#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 2985
#define LARGE_STATE_COUNT 617
#define SYMBOL_COUNT 299
#define ALIAS_COUNT 8
#define TOKEN_COUNT 141
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_QMARK_QMARK = 86,
  anon_sym_instanceof = 87,
  anon_sym_BANG = 88,
  anon_sym_TILDE = 89,
  anon_sym_void = 90,
  anon_sym_delete = 91,
  anon_sym_PLUS_PLUS = 92,
  anon_sym_DASH_DASH = 93,
  anon_sym_DQUOTE = 94,
  aux_sym_string_token1 = 95,
  anon_sym_SQUOTE = 96,
  aux_sym_string_token2 = 97,
  sym_escape_sequence = 98,
  sym_comment = 99,
  anon_sym_BQUOTE = 100,
  anon_sym_DOLLAR_LBRACE = 101,
  anon_sym_SLASH2 = 102,
  sym_regex_pattern = 103,
  sym_regex_flags = 104,
  sym_number = 105,
  anon_sym_target = 106,
  sym_this = 107,
  sym_super = 108,
  sym_true = 109,
  sym_false = 110,
  sym_null = 111,
  sym_undefined = 112,
  anon_sym_AT = 113,
  anon_sym_static = 114,
  anon_sym_abstract = 115,
  anon_sym_get = 116,
  anon_sym_set = 117,
  anon_sym_declare = 118,
  anon_sym_public = 119,
  anon_sym_private = 120,
  anon_sym_protected = 121,
  anon_sym_module = 122,
  anon_sym_any = 123,
  anon_sym_number = 124,
  anon_sym_boolean = 125,
  anon_sym_string = 126,
  anon_sym_symbol = 127,
  anon_sym_require = 128,
  anon_sym_implements = 129,
  anon_sym_global = 130,
  anon_sym_interface = 131,
  anon_sym_extends = 132,
  anon_sym_enum = 133,
  sym_readonly = 134,
  anon_sym_is = 135,
  anon_sym_keyof = 136,
  anon_sym_LBRACE_PIPE = 137,
  anon_sym_PIPE_RBRACE = 138,
  sym__automatic_semicolon = 139,
  sym__template_chars = 140,
  sym_program = 141,
  sym_export_statement = 142,
  sym_export_clause = 143,
  sym__import_export_specifier = 144,
  sym__declaration = 145,
  sym_import = 146,
  sym_import_statement = 147,
  sym_import_clause = 148,
  sym__from_clause = 149,
  sym_namespace_import = 150,
  sym_named_imports = 151,
  sym_expression_statement = 152,
  sym_variable_declaration = 153,
  sym_lexical_declaration = 154,
  sym_variable_declarator = 155,
  sym_statement_block = 156,
  sym_if_statement = 157,
  sym_switch_statement = 158,
  sym_for_statement = 159,
  sym_for_in_statement = 160,
  sym__for_header = 161,
  sym_while_statement = 162,
  sym_do_statement = 163,
  sym_try_statement = 164,
  sym_with_statement = 165,
  sym_break_statement = 166,
  sym_continue_statement = 167,
  sym_debugger_statement = 168,
  sym_return_statement = 169,
  sym_throw_statement = 170,
  sym_empty_statement = 171,
  sym_labeled_statement = 172,
  sym_switch_body = 173,
  sym_switch_case = 174,
  sym_switch_default = 175,
  sym_catch_clause = 176,
  sym_finally_clause = 177,
  sym_parenthesized_expression = 178,
  sym__expression = 179,
  sym_yield_expression = 180,
  sym_object = 181,
  sym_assignment_pattern = 182,
  sym_array = 183,
  sym_nested_identifier = 184,
  sym_class = 185,
  sym_class_declaration = 186,
  sym_class_heritage = 187,
  sym_function = 188,
  sym_function_declaration = 189,
  sym_generator_function = 190,
  sym_generator_function_declaration = 191,
  sym_arrow_function = 192,
  sym__call_signature = 193,
  sym_call_expression = 194,
  sym_new_expression = 195,
  sym_await_expression = 196,
  sym_member_expression = 197,
  sym_subscript_expression = 198,
  sym_assignment_expression = 199,
  sym_augmented_assignment_expression = 200,
  sym__initializer = 201,
  sym_spread_element = 202,
  sym_ternary_expression = 203,
  sym_binary_expression = 204,
  sym_unary_expression = 205,
  sym_update_expression = 206,
  sym_sequence_expression = 207,
  sym_string = 208,
  sym_template_string = 209,
  sym_template_substitution = 210,
  sym_regex = 211,
  sym_meta_property = 212,
  sym_arguments = 213,
  sym_decorator = 214,
  sym_decorator_member_expression = 215,
  sym_decorator_call_expression = 216,
  sym_class_body = 217,
  sym_public_field_definition = 218,
  sym_formal_parameters = 219,
  sym_rest_parameter = 220,
  sym_method_definition = 221,
  sym_pair = 222,
  sym__property_name = 223,
  sym_computed_property_name = 224,
  sym_non_null_expression = 225,
  sym_method_signature = 226,
  sym_abstract_method_signature = 227,
  sym_function_signature = 228,
  sym_type_assertion = 229,
  sym_as_expression = 230,
  sym_import_require_clause = 231,
  sym_implements_clause = 232,
  sym_ambient_declaration = 233,
  sym_abstract_class_declaration = 234,
  sym_module = 235,
  sym_internal_module = 236,
  sym__module = 237,
  sym_import_alias = 238,
  sym_nested_type_identifier = 239,
  sym_interface_declaration = 240,
  sym_extends_clause = 241,
  sym_enum_declaration = 242,
  sym_enum_body = 243,
  sym_enum_assignment = 244,
  sym_type_alias_declaration = 245,
  sym_accessibility_modifier = 246,
  sym_required_parameter = 247,
  sym_optional_parameter = 248,
  sym__parameter_name = 249,
  sym_type_annotation = 250,
  sym__type = 251,
  sym_constructor_type = 252,
  sym__primary_type = 253,
  sym_generic_type = 254,
  sym_type_predicate = 255,
  sym_type_query = 256,
  sym_index_type_query = 257,
  sym_lookup_type = 258,
  sym_mapped_type_clause = 259,
  sym_literal_type = 260,
  sym__number = 261,
  sym_existential_type = 262,
  sym_flow_maybe_type = 263,
  sym_parenthesized_type = 264,
  sym_predefined_type = 265,
  sym_type_arguments = 266,
  sym_object_type = 267,
  sym_call_signature = 268,
  sym_property_signature = 269,
  sym_type_parameters = 270,
  sym_type_parameter = 271,
  sym_default_type = 272,
  sym_constraint = 273,
  sym_construct_signature = 274,
  sym_index_signature = 275,
  sym_array_type = 276,
  sym_tuple_type = 277,
  sym_union_type = 278,
  sym_intersection_type = 279,
  sym_function_type = 280,
  aux_sym_program_repeat1 = 281,
  aux_sym_export_statement_repeat1 = 282,
  aux_sym_export_clause_repeat1 = 283,
  aux_sym_named_imports_repeat1 = 284,
  aux_sym_variable_declaration_repeat1 = 285,
  aux_sym_switch_body_repeat1 = 286,
  aux_sym_object_repeat1 = 287,
  aux_sym_array_repeat1 = 288,
  aux_sym_string_repeat1 = 289,
  aux_sym_string_repeat2 = 290,
  aux_sym_template_string_repeat1 = 291,
  aux_sym_class_body_repeat1 = 292,
  aux_sym_formal_parameters_repeat1 = 293,
  aux_sym_implements_clause_repeat1 = 294,
  aux_sym_extends_clause_repeat1 = 295,
  aux_sym_enum_body_repeat1 = 296,
  aux_sym_object_type_repeat1 = 297,
  aux_sym_type_parameters_repeat1 = 298,
  alias_sym_array_pattern = 299,
  alias_sym_export_specifier = 300,
  alias_sym_import_specifier = 301,
  alias_sym_object_pattern = 302,
  alias_sym_property_identifier = 303,
  alias_sym_shorthand_property_identifier = 304,
  alias_sym_statement_identifier = 305,
  alias_sym_type_identifier = 306,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "??",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH2,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type] = sym__type,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_source = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_value = 35,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[183] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 2},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 29, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 29, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 3},
  [40] = {.index = 40, .length = 1},
  [41] = {.index = 41, .length = 2},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 1},
  [46] = {.index = 50, .length = 3},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 2},
  [50] = {.index = 56, .length = 1},
  [51] = {.index = 57, .length = 2},
  [52] = {.index = 59, .length = 4},
  [53] = {.index = 63, .length = 2},
  [54] = {.index = 63, .length = 2},
  [55] = {.index = 20, .length = 2},
  [56] = {.index = 23, .length = 2},
  [57] = {.index = 25, .length = 2},
  [58] = {.index = 65, .length = 3},
  [59] = {.index = 10, .length = 2},
  [60] = {.index = 54, .length = 2},
  [61] = {.index = 68, .length = 3},
  [62] = {.index = 20, .length = 2},
  [63] = {.index = 20, .length = 2},
  [64] = {.index = 71, .length = 4},
  [65] = {.index = 75, .length = 3},
  [66] = {.index = 78, .length = 2},
  [67] = {.index = 80, .length = 1},
  [68] = {.index = 81, .length = 1},
  [69] = {.index = 82, .length = 1},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 2},
  [72] = {.index = 20, .length = 2},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 88, .length = 5},
  [75] = {.index = 84, .length = 2},
  [76] = {.index = 93, .length = 1},
  [77] = {.index = 94, .length = 3},
  [78] = {.index = 94, .length = 3},
  [79] = {.index = 94, .length = 3},
  [80] = {.index = 97, .length = 2},
  [81] = {.index = 99, .length = 3},
  [85] = {.index = 102, .length = 1},
  [86] = {.index = 103, .length = 3},
  [87] = {.index = 106, .length = 4},
  [88] = {.index = 110, .length = 2},
  [89] = {.index = 112, .length = 2},
  [90] = {.index = 114, .length = 2},
  [91] = {.index = 116, .length = 3},
  [92] = {.index = 119, .length = 2},
  [93] = {.index = 121, .length = 2},
  [94] = {.index = 123, .length = 4},
  [95] = {.index = 121, .length = 2},
  [96] = {.index = 127, .length = 4},
  [97] = {.index = 131, .length = 4},
  [98] = {.index = 135, .length = 5},
  [99] = {.index = 140, .length = 2},
  [100] = {.index = 97, .length = 2},
  [101] = {.index = 142, .length = 3},
  [102] = {.index = 145, .length = 2},
  [103] = {.index = 147, .length = 3},
  [104] = {.index = 150, .length = 2},
  [105] = {.index = 152, .length = 5},
  [106] = {.index = 157, .length = 2},
  [107] = {.index = 159, .length = 1},
  [108] = {.index = 160, .length = 3},
  [109] = {.index = 163, .length = 1},
  [110] = {.index = 164, .length = 1},
  [111] = {.index = 165, .length = 1},
  [112] = {.index = 166, .length = 2},
  [113] = {.index = 168, .length = 1},
  [114] = {.index = 169, .length = 2},
  [115] = {.index = 171, .length = 4},
  [116] = {.index = 175, .length = 2},
  [117] = {.index = 177, .length = 2},
  [118] = {.index = 179, .length = 2},
  [119] = {.index = 181, .length = 3},
  [120] = {.index = 184, .length = 4},
  [121] = {.index = 188, .length = 4},
  [122] = {.index = 192, .length = 5},
  [123] = {.index = 197, .length = 2},
  [124] = {.index = 199, .length = 3},
  [125] = {.index = 202, .length = 3},
  [126] = {.index = 205, .length = 2},
  [127] = {.index = 207, .length = 3},
  [128] = {.index = 210, .length = 4},
  [129] = {.index = 214, .length = 3},
  [130] = {.index = 217, .length = 2},
  [131] = {.index = 219, .length = 5},
  [132] = {.index = 224, .length = 3},
  [133] = {.index = 227, .length = 2},
  [134] = {.index = 227, .length = 2},
  [135] = {.index = 229, .length = 3},
  [136] = {.index = 227, .length = 2},
  [137] = {.index = 227, .length = 2},
  [138] = {.index = 232, .length = 2},
  [139] = {.index = 234, .length = 4},
  [140] = {.index = 238, .length = 2},
  [141] = {.index = 240, .length = 2},
  [142] = {.index = 242, .length = 1},
  [143] = {.index = 243, .length = 2},
  [144] = {.index = 245, .length = 2},
  [145] = {.index = 247, .length = 3},
  [146] = {.index = 250, .length = 3},
  [147] = {.index = 253, .length = 5},
  [148] = {.index = 258, .length = 3},
  [150] = {.index = 261, .length = 4},
  [151] = {.index = 265, .length = 5},
  [152] = {.index = 270, .length = 2},
  [153] = {.index = 270, .length = 2},
  [154] = {.index = 270, .length = 2},
  [155] = {.index = 270, .length = 2},
  [156] = {.index = 272, .length = 4},
  [157] = {.index = 276, .length = 2},
  [158] = {.index = 276, .length = 2},
  [159] = {.index = 276, .length = 2},
  [160] = {.index = 278, .length = 4},
  [161] = {.index = 282, .length = 4},
  [162] = {.index = 286, .length = 2},
  [163] = {.index = 288, .length = 2},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 292, .length = 3},
  [166] = {.index = 295, .length = 3},
  [167] = {.index = 298, .length = 2},
  [168] = {.index = 300, .length = 5},
  [169] = {.index = 305, .length = 5},
  [170] = {.index = 310, .length = 4},
  [171] = {.index = 314, .length = 4},
  [172] = {.index = 318, .length = 2},
  [173] = {.index = 320, .length = 3},
  [174] = {.index = 323, .length = 2},
  [175] = {.index = 325, .length = 3},
  [176] = {.index = 328, .length = 5},
  [177] = {.index = 333, .length = 5},
  [178] = {.index = 338, .length = 4},
  [179] = {.index = 342, .length = 4},
  [180] = {.index = 346, .length = 3},
  [181] = {.index = 349, .length = 5},
  [182] = {.index = 354, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_label, 0},
  [23] =
    {field_object, 0},
    {field_property, 2},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_body, 1},
    {field_name, 0},
  [29] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [31] =
    {field_name, 0},
    {field_type, 1},
  [33] =
    {field_condition, 1},
    {field_consequence, 2},
  [35] =
    {field_body, 2},
    {field_value, 1},
  [37] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [40] =
    {field_value, 1, .inherited = true},
  [41] =
    {field_body, 2},
    {field_condition, 1},
  [43] =
    {field_body, 1},
    {field_handler, 2},
  [45] =
    {field_body, 1},
    {field_finalizer, 2},
  [47] =
    {field_body, 2},
    {field_object, 1},
  [49] =
    {field_label, 1},
  [50] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_body, 2},
    {field_name, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [68] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [71] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [75] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [78] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [80] =
    {field_source, 1},
  [81] =
    {field_source, 2, .inherited = true},
  [82] =
    {field_value, 2},
  [83] =
    {field_name, 1},
  [84] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [86] =
    {field_key, 0},
    {field_value, 2},
  [88] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_value, 1},
  [94] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [97] =
    {field_body, 3},
    {field_name, 2},
  [99] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [102] =
    {field_value, 2, .inherited = true},
  [103] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [106] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [110] =
    {field_module, 0},
    {field_name, 2},
  [112] =
    {field_flags, 3},
    {field_pattern, 1},
  [114] =
    {field_body, 3},
    {field_name, 1},
  [116] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [119] =
    {field_body, 3},
    {field_type_parameters, 1},
  [121] =
    {field_body, 3},
    {field_parameter, 1},
  [123] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [127] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [131] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [135] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [140] =
    {field_index, 2},
    {field_object, 0},
  [142] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [145] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [147] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [150] =
    {field_alias, 2},
    {field_name, 0},
  [152] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [157] =
    {field_name, 1},
    {field_value, 3},
  [159] =
    {field_source, 3, .inherited = true},
  [160] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [163] =
    {field_decorator, 1, .inherited = true},
  [164] =
    {field_decorator, 2, .inherited = true},
  [165] =
    {field_value, 3, .inherited = true},
  [166] =
    {field_body, 1},
    {field_condition, 3},
  [168] =
    {field_name, 2},
  [169] =
    {field_name, 1},
    {field_type, 2},
  [171] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [175] =
    {field_name, 0},
    {field_type, 2},
  [177] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [179] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [181] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [184] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [188] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [192] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [197] =
    {field_body, 4},
    {field_name, 2},
  [199] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [202] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [205] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [207] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [210] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [217] =
    {field_alias, 3},
    {field_name, 1},
  [219] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [224] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [227] =
    {field_left, 1},
    {field_right, 3},
  [229] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [232] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [234] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 2},
    {field_type, 3},
  [240] =
    {field_name, 1},
    {field_type, 3},
  [242] =
    {field_name, 3},
  [243] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [245] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [247] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [250] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [253] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [258] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [261] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [265] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [270] =
    {field_left, 2},
    {field_right, 4},
  [272] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [276] =
    {field_body, 4},
    {field_parameter, 2},
  [278] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [282] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [286] =
    {field_name, 2},
    {field_type, 4},
  [288] =
    {field_name, 3},
    {field_type, 4},
  [290] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [292] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [295] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [298] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [300] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [305] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [310] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [314] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [318] =
    {field_name, 3},
    {field_type, 5},
  [320] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [323] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [325] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [328] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [333] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [338] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [342] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [346] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [349] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [354] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[183][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [0] = alias_sym_object_pattern,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_array_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [1] = alias_sym_object_pattern,
  },
  [39] = {
    [1] = alias_sym_array_pattern,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [56] = {
    [2] = alias_sym_property_identifier,
  },
  [59] = {
    [0] = sym_identifier,
  },
  [62] = {
    [0] = alias_sym_object_pattern,
  },
  [63] = {
    [0] = alias_sym_array_pattern,
  },
  [71] = {
    [1] = alias_sym_export_specifier,
  },
  [72] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [75] = {
    [1] = alias_sym_import_specifier,
  },
  [78] = {
    [0] = alias_sym_object_pattern,
  },
  [79] = {
    [0] = alias_sym_array_pattern,
  },
  [82] = {
    [2] = sym_identifier,
  },
  [83] = {
    [2] = alias_sym_object_pattern,
  },
  [84] = {
    [2] = alias_sym_array_pattern,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [90] = {
    [1] = alias_sym_type_identifier,
  },
  [91] = {
    [1] = alias_sym_type_identifier,
  },
  [93] = {
    [1] = sym_identifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [119] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [2] = alias_sym_type_identifier,
  },
  [124] = {
    [2] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [2] = alias_sym_type_identifier,
  },
  [132] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [1] = sym_identifier,
  },
  [136] = {
    [1] = alias_sym_object_pattern,
  },
  [137] = {
    [1] = alias_sym_array_pattern,
  },
  [148] = {
    [2] = alias_sym_type_identifier,
  },
  [149] = {
    [3] = alias_sym_property_identifier,
  },
  [150] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = sym_identifier,
  },
  [154] = {
    [2] = alias_sym_object_pattern,
  },
  [155] = {
    [2] = alias_sym_array_pattern,
  },
  [158] = {
    [2] = alias_sym_object_pattern,
  },
  [159] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0) ADVANCE(155);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(150);
      if (lookahead == '\r') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(20)
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(157);
      if (lookahead == '\r') ADVANCE(165);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(26)
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(174);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(188);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(65);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(24);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(24);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0) ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead != 0) ADVANCE(23);
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 26:
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(26)
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(172);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '}') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == '}') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 39:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 40:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(188);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(175);
      END_STATE();
    case 61:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 62:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(188);
      END_STATE();
    case 63:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(126);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(63)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(188);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(190);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(143);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(150);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(157);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(163);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(167);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(30);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '0') ADVANCE(183);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(48);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(177);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '{') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 63},
  [2] = {.lex_state = 63},
  [3] = {.lex_state = 63},
  [4] = {.lex_state = 63},
  [5] = {.lex_state = 63},
  [6] = {.lex_state = 63},
  [7] = {.lex_state = 63},
  [8] = {.lex_state = 63},
  [9] = {.lex_state = 63},
  [10] = {.lex_state = 63},
  [11] = {.lex_state = 63},
  [12] = {.lex_state = 63},
  [13] = {.lex_state = 63},
  [14] = {.lex_state = 63},
  [15] = {.lex_state = 63},
  [16] = {.lex_state = 63},
  [17] = {.lex_state = 63},
  [18] = {.lex_state = 63},
  [19] = {.lex_state = 63},
  [20] = {.lex_state = 63},
  [21] = {.lex_state = 63},
  [22] = {.lex_state = 63},
  [23] = {.lex_state = 63},
  [24] = {.lex_state = 63},
  [25] = {.lex_state = 63},
  [26] = {.lex_state = 63},
  [27] = {.lex_state = 63},
  [28] = {.lex_state = 63},
  [29] = {.lex_state = 63},
  [30] = {.lex_state = 63},
  [31] = {.lex_state = 63},
  [32] = {.lex_state = 63},
  [33] = {.lex_state = 63},
  [34] = {.lex_state = 63},
  [35] = {.lex_state = 63},
  [36] = {.lex_state = 63},
  [37] = {.lex_state = 63},
  [38] = {.lex_state = 63},
  [39] = {.lex_state = 63},
  [40] = {.lex_state = 63},
  [41] = {.lex_state = 63},
  [42] = {.lex_state = 63},
  [43] = {.lex_state = 63},
  [44] = {.lex_state = 63},
  [45] = {.lex_state = 63},
  [46] = {.lex_state = 63},
  [47] = {.lex_state = 63},
  [48] = {.lex_state = 6, .external_lex_state = 2},
  [49] = {.lex_state = 6, .external_lex_state = 2},
  [50] = {.lex_state = 6, .external_lex_state = 3},
  [51] = {.lex_state = 6, .external_lex_state = 2},
  [52] = {.lex_state = 6, .external_lex_state = 3},
  [53] = {.lex_state = 6, .external_lex_state = 2},
  [54] = {.lex_state = 6, .external_lex_state = 2},
  [55] = {.lex_state = 6, .external_lex_state = 3},
  [56] = {.lex_state = 6, .external_lex_state = 2},
  [57] = {.lex_state = 6, .external_lex_state = 2},
  [58] = {.lex_state = 6, .external_lex_state = 2},
  [59] = {.lex_state = 6, .external_lex_state = 2},
  [60] = {.lex_state = 6, .external_lex_state = 2},
  [61] = {.lex_state = 6, .external_lex_state = 3},
  [62] = {.lex_state = 6, .external_lex_state = 3},
  [63] = {.lex_state = 6, .external_lex_state = 3},
  [64] = {.lex_state = 6, .external_lex_state = 2},
  [65] = {.lex_state = 6, .external_lex_state = 3},
  [66] = {.lex_state = 6, .external_lex_state = 3},
  [67] = {.lex_state = 7, .external_lex_state = 3},
  [68] = {.lex_state = 6, .external_lex_state = 3},
  [69] = {.lex_state = 6, .external_lex_state = 3},
  [70] = {.lex_state = 6, .external_lex_state = 2},
  [71] = {.lex_state = 7, .external_lex_state = 3},
  [72] = {.lex_state = 6, .external_lex_state = 3},
  [73] = {.lex_state = 6, .external_lex_state = 3},
  [74] = {.lex_state = 6, .external_lex_state = 3},
  [75] = {.lex_state = 7, .external_lex_state = 3},
  [76] = {.lex_state = 6, .external_lex_state = 3},
  [77] = {.lex_state = 6, .external_lex_state = 2},
  [78] = {.lex_state = 6, .external_lex_state = 3},
  [79] = {.lex_state = 6, .external_lex_state = 3},
  [80] = {.lex_state = 6, .external_lex_state = 3},
  [81] = {.lex_state = 14},
  [82] = {.lex_state = 14},
  [83] = {.lex_state = 14},
  [84] = {.lex_state = 14},
  [85] = {.lex_state = 14},
  [86] = {.lex_state = 14},
  [87] = {.lex_state = 14},
  [88] = {.lex_state = 14},
  [89] = {.lex_state = 14},
  [90] = {.lex_state = 62, .external_lex_state = 3},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 62, .external_lex_state = 2},
  [96] = {.lex_state = 14},
  [97] = {.lex_state = 14},
  [98] = {.lex_state = 14},
  [99] = {.lex_state = 62, .external_lex_state = 3},
  [100] = {.lex_state = 62, .external_lex_state = 3},
  [101] = {.lex_state = 8, .external_lex_state = 3},
  [102] = {.lex_state = 62, .external_lex_state = 2},
  [103] = {.lex_state = 62, .external_lex_state = 2},
  [104] = {.lex_state = 62, .external_lex_state = 2},
  [105] = {.lex_state = 62, .external_lex_state = 2},
  [106] = {.lex_state = 62, .external_lex_state = 2},
  [107] = {.lex_state = 62, .external_lex_state = 2},
  [108] = {.lex_state = 62, .external_lex_state = 2},
  [109] = {.lex_state = 62, .external_lex_state = 2},
  [110] = {.lex_state = 62, .external_lex_state = 2},
  [111] = {.lex_state = 62, .external_lex_state = 2},
  [112] = {.lex_state = 62, .external_lex_state = 2},
  [113] = {.lex_state = 62, .external_lex_state = 2},
  [114] = {.lex_state = 62, .external_lex_state = 2},
  [115] = {.lex_state = 62, .external_lex_state = 2},
  [116] = {.lex_state = 62, .external_lex_state = 2},
  [117] = {.lex_state = 62, .external_lex_state = 2},
  [118] = {.lex_state = 62, .external_lex_state = 2},
  [119] = {.lex_state = 62, .external_lex_state = 2},
  [120] = {.lex_state = 62, .external_lex_state = 2},
  [121] = {.lex_state = 62, .external_lex_state = 2},
  [122] = {.lex_state = 62, .external_lex_state = 2},
  [123] = {.lex_state = 62, .external_lex_state = 2},
  [124] = {.lex_state = 62, .external_lex_state = 2},
  [125] = {.lex_state = 62, .external_lex_state = 2},
  [126] = {.lex_state = 62, .external_lex_state = 2},
  [127] = {.lex_state = 62, .external_lex_state = 2},
  [128] = {.lex_state = 62, .external_lex_state = 2},
  [129] = {.lex_state = 62, .external_lex_state = 2},
  [130] = {.lex_state = 63},
  [131] = {.lex_state = 63},
  [132] = {.lex_state = 63},
  [133] = {.lex_state = 63},
  [134] = {.lex_state = 63},
  [135] = {.lex_state = 63},
  [136] = {.lex_state = 63},
  [137] = {.lex_state = 63},
  [138] = {.lex_state = 63},
  [139] = {.lex_state = 63},
  [140] = {.lex_state = 63},
  [141] = {.lex_state = 63},
  [142] = {.lex_state = 63},
  [143] = {.lex_state = 63},
  [144] = {.lex_state = 63},
  [145] = {.lex_state = 63},
  [146] = {.lex_state = 63},
  [147] = {.lex_state = 63},
  [148] = {.lex_state = 63},
  [149] = {.lex_state = 6, .external_lex_state = 2},
  [150] = {.lex_state = 6, .external_lex_state = 2},
  [151] = {.lex_state = 63},
  [152] = {.lex_state = 63},
  [153] = {.lex_state = 6, .external_lex_state = 2},
  [154] = {.lex_state = 63},
  [155] = {.lex_state = 63},
  [156] = {.lex_state = 63, .external_lex_state = 4},
  [157] = {.lex_state = 63},
  [158] = {.lex_state = 63},
  [159] = {.lex_state = 63},
  [160] = {.lex_state = 63},
  [161] = {.lex_state = 6, .external_lex_state = 2},
  [162] = {.lex_state = 6, .external_lex_state = 2},
  [163] = {.lex_state = 6, .external_lex_state = 2},
  [164] = {.lex_state = 6, .external_lex_state = 2},
  [165] = {.lex_state = 63},
  [166] = {.lex_state = 6, .external_lex_state = 2},
  [167] = {.lex_state = 63},
  [168] = {.lex_state = 63},
  [169] = {.lex_state = 63},
  [170] = {.lex_state = 63},
  [171] = {.lex_state = 63},
  [172] = {.lex_state = 63},
  [173] = {.lex_state = 63},
  [174] = {.lex_state = 63},
  [175] = {.lex_state = 63},
  [176] = {.lex_state = 63},
  [177] = {.lex_state = 63},
  [178] = {.lex_state = 63},
  [179] = {.lex_state = 63},
  [180] = {.lex_state = 63},
  [181] = {.lex_state = 63},
  [182] = {.lex_state = 63},
  [183] = {.lex_state = 63},
  [184] = {.lex_state = 63},
  [185] = {.lex_state = 63},
  [186] = {.lex_state = 63},
  [187] = {.lex_state = 63},
  [188] = {.lex_state = 63},
  [189] = {.lex_state = 63},
  [190] = {.lex_state = 63},
  [191] = {.lex_state = 63},
  [192] = {.lex_state = 63},
  [193] = {.lex_state = 63},
  [194] = {.lex_state = 63},
  [195] = {.lex_state = 63},
  [196] = {.lex_state = 63},
  [197] = {.lex_state = 63},
  [198] = {.lex_state = 63},
  [199] = {.lex_state = 63},
  [200] = {.lex_state = 63},
  [201] = {.lex_state = 63},
  [202] = {.lex_state = 63},
  [203] = {.lex_state = 63},
  [204] = {.lex_state = 63},
  [205] = {.lex_state = 63},
  [206] = {.lex_state = 63},
  [207] = {.lex_state = 63},
  [208] = {.lex_state = 63},
  [209] = {.lex_state = 63},
  [210] = {.lex_state = 63},
  [211] = {.lex_state = 63},
  [212] = {.lex_state = 63},
  [213] = {.lex_state = 63},
  [214] = {.lex_state = 63},
  [215] = {.lex_state = 63},
  [216] = {.lex_state = 63},
  [217] = {.lex_state = 63},
  [218] = {.lex_state = 63},
  [219] = {.lex_state = 63},
  [220] = {.lex_state = 63},
  [221] = {.lex_state = 63},
  [222] = {.lex_state = 63},
  [223] = {.lex_state = 63},
  [224] = {.lex_state = 63},
  [225] = {.lex_state = 63},
  [226] = {.lex_state = 63},
  [227] = {.lex_state = 63},
  [228] = {.lex_state = 63},
  [229] = {.lex_state = 63},
  [230] = {.lex_state = 63},
  [231] = {.lex_state = 63},
  [232] = {.lex_state = 63},
  [233] = {.lex_state = 63},
  [234] = {.lex_state = 63},
  [235] = {.lex_state = 63},
  [236] = {.lex_state = 63},
  [237] = {.lex_state = 63},
  [238] = {.lex_state = 63},
  [239] = {.lex_state = 63},
  [240] = {.lex_state = 63},
  [241] = {.lex_state = 63},
  [242] = {.lex_state = 63},
  [243] = {.lex_state = 63},
  [244] = {.lex_state = 63},
  [245] = {.lex_state = 63},
  [246] = {.lex_state = 63},
  [247] = {.lex_state = 63},
  [248] = {.lex_state = 63},
  [249] = {.lex_state = 63},
  [250] = {.lex_state = 63},
  [251] = {.lex_state = 63},
  [252] = {.lex_state = 63},
  [253] = {.lex_state = 63},
  [254] = {.lex_state = 63},
  [255] = {.lex_state = 63},
  [256] = {.lex_state = 63},
  [257] = {.lex_state = 6, .external_lex_state = 2},
  [258] = {.lex_state = 63},
  [259] = {.lex_state = 63},
  [260] = {.lex_state = 63},
  [261] = {.lex_state = 63},
  [262] = {.lex_state = 63},
  [263] = {.lex_state = 63},
  [264] = {.lex_state = 63},
  [265] = {.lex_state = 63},
  [266] = {.lex_state = 63},
  [267] = {.lex_state = 63},
  [268] = {.lex_state = 63},
  [269] = {.lex_state = 63},
  [270] = {.lex_state = 63},
  [271] = {.lex_state = 63},
  [272] = {.lex_state = 63},
  [273] = {.lex_state = 63},
  [274] = {.lex_state = 63},
  [275] = {.lex_state = 63},
  [276] = {.lex_state = 63},
  [277] = {.lex_state = 63},
  [278] = {.lex_state = 63},
  [279] = {.lex_state = 63},
  [280] = {.lex_state = 63},
  [281] = {.lex_state = 63},
  [282] = {.lex_state = 63},
  [283] = {.lex_state = 63},
  [284] = {.lex_state = 63},
  [285] = {.lex_state = 63},
  [286] = {.lex_state = 63},
  [287] = {.lex_state = 63},
  [288] = {.lex_state = 63},
  [289] = {.lex_state = 63},
  [290] = {.lex_state = 63},
  [291] = {.lex_state = 63},
  [292] = {.lex_state = 63},
  [293] = {.lex_state = 63},
  [294] = {.lex_state = 63},
  [295] = {.lex_state = 63},
  [296] = {.lex_state = 63},
  [297] = {.lex_state = 63},
  [298] = {.lex_state = 63},
  [299] = {.lex_state = 63},
  [300] = {.lex_state = 63},
  [301] = {.lex_state = 63},
  [302] = {.lex_state = 63},
  [303] = {.lex_state = 63},
  [304] = {.lex_state = 63},
  [305] = {.lex_state = 63},
  [306] = {.lex_state = 63},
  [307] = {.lex_state = 63},
  [308] = {.lex_state = 63},
  [309] = {.lex_state = 63},
  [310] = {.lex_state = 63},
  [311] = {.lex_state = 63},
  [312] = {.lex_state = 63},
  [313] = {.lex_state = 63},
  [314] = {.lex_state = 63},
  [315] = {.lex_state = 63},
  [316] = {.lex_state = 63},
  [317] = {.lex_state = 63},
  [318] = {.lex_state = 63},
  [319] = {.lex_state = 63},
  [320] = {.lex_state = 63},
  [321] = {.lex_state = 63},
  [322] = {.lex_state = 63},
  [323] = {.lex_state = 63},
  [324] = {.lex_state = 63},
  [325] = {.lex_state = 63},
  [326] = {.lex_state = 63},
  [327] = {.lex_state = 63},
  [328] = {.lex_state = 63},
  [329] = {.lex_state = 63},
  [330] = {.lex_state = 63},
  [331] = {.lex_state = 63},
  [332] = {.lex_state = 63},
  [333] = {.lex_state = 63},
  [334] = {.lex_state = 63},
  [335] = {.lex_state = 63},
  [336] = {.lex_state = 63},
  [337] = {.lex_state = 63},
  [338] = {.lex_state = 63},
  [339] = {.lex_state = 63},
  [340] = {.lex_state = 6, .external_lex_state = 2},
  [341] = {.lex_state = 63},
  [342] = {.lex_state = 63},
  [343] = {.lex_state = 63},
  [344] = {.lex_state = 63},
  [345] = {.lex_state = 63},
  [346] = {.lex_state = 63},
  [347] = {.lex_state = 63},
  [348] = {.lex_state = 63},
  [349] = {.lex_state = 63},
  [350] = {.lex_state = 63},
  [351] = {.lex_state = 63},
  [352] = {.lex_state = 63},
  [353] = {.lex_state = 63},
  [354] = {.lex_state = 63},
  [355] = {.lex_state = 63},
  [356] = {.lex_state = 63},
  [357] = {.lex_state = 63},
  [358] = {.lex_state = 63},
  [359] = {.lex_state = 63},
  [360] = {.lex_state = 63},
  [361] = {.lex_state = 63},
  [362] = {.lex_state = 63},
  [363] = {.lex_state = 63},
  [364] = {.lex_state = 63},
  [365] = {.lex_state = 63},
  [366] = {.lex_state = 63},
  [367] = {.lex_state = 63},
  [368] = {.lex_state = 63},
  [369] = {.lex_state = 63},
  [370] = {.lex_state = 63},
  [371] = {.lex_state = 63},
  [372] = {.lex_state = 63},
  [373] = {.lex_state = 63},
  [374] = {.lex_state = 63},
  [375] = {.lex_state = 63},
  [376] = {.lex_state = 63},
  [377] = {.lex_state = 63},
  [378] = {.lex_state = 63},
  [379] = {.lex_state = 63},
  [380] = {.lex_state = 63},
  [381] = {.lex_state = 63},
  [382] = {.lex_state = 63},
  [383] = {.lex_state = 63},
  [384] = {.lex_state = 63},
  [385] = {.lex_state = 63},
  [386] = {.lex_state = 63},
  [387] = {.lex_state = 63},
  [388] = {.lex_state = 63},
  [389] = {.lex_state = 63},
  [390] = {.lex_state = 63},
  [391] = {.lex_state = 63},
  [392] = {.lex_state = 63},
  [393] = {.lex_state = 63},
  [394] = {.lex_state = 63},
  [395] = {.lex_state = 63},
  [396] = {.lex_state = 63},
  [397] = {.lex_state = 63},
  [398] = {.lex_state = 63},
  [399] = {.lex_state = 63},
  [400] = {.lex_state = 63},
  [401] = {.lex_state = 63},
  [402] = {.lex_state = 63},
  [403] = {.lex_state = 63},
  [404] = {.lex_state = 63},
  [405] = {.lex_state = 63},
  [406] = {.lex_state = 63},
  [407] = {.lex_state = 63},
  [408] = {.lex_state = 63},
  [409] = {.lex_state = 63},
  [410] = {.lex_state = 63},
  [411] = {.lex_state = 63},
  [412] = {.lex_state = 63},
  [413] = {.lex_state = 63},
  [414] = {.lex_state = 6, .external_lex_state = 2},
  [415] = {.lex_state = 63},
  [416] = {.lex_state = 63},
  [417] = {.lex_state = 6, .external_lex_state = 2},
  [418] = {.lex_state = 6, .external_lex_state = 2},
  [419] = {.lex_state = 63},
  [420] = {.lex_state = 63},
  [421] = {.lex_state = 63},
  [422] = {.lex_state = 63},
  [423] = {.lex_state = 63},
  [424] = {.lex_state = 63},
  [425] = {.lex_state = 63},
  [426] = {.lex_state = 63},
  [427] = {.lex_state = 63},
  [428] = {.lex_state = 63},
  [429] = {.lex_state = 63},
  [430] = {.lex_state = 63},
  [431] = {.lex_state = 63},
  [432] = {.lex_state = 63},
  [433] = {.lex_state = 63},
  [434] = {.lex_state = 63},
  [435] = {.lex_state = 63},
  [436] = {.lex_state = 63},
  [437] = {.lex_state = 63},
  [438] = {.lex_state = 63},
  [439] = {.lex_state = 63},
  [440] = {.lex_state = 63},
  [441] = {.lex_state = 63},
  [442] = {.lex_state = 63},
  [443] = {.lex_state = 63},
  [444] = {.lex_state = 63},
  [445] = {.lex_state = 63},
  [446] = {.lex_state = 63},
  [447] = {.lex_state = 63},
  [448] = {.lex_state = 63},
  [449] = {.lex_state = 6, .external_lex_state = 2},
  [450] = {.lex_state = 6, .external_lex_state = 2},
  [451] = {.lex_state = 6, .external_lex_state = 2},
  [452] = {.lex_state = 6, .external_lex_state = 2},
  [453] = {.lex_state = 6, .external_lex_state = 2},
  [454] = {.lex_state = 6, .external_lex_state = 2},
  [455] = {.lex_state = 6, .external_lex_state = 2},
  [456] = {.lex_state = 6, .external_lex_state = 2},
  [457] = {.lex_state = 6, .external_lex_state = 2},
  [458] = {.lex_state = 63},
  [459] = {.lex_state = 63},
  [460] = {.lex_state = 63, .external_lex_state = 4},
  [461] = {.lex_state = 6, .external_lex_state = 3},
  [462] = {.lex_state = 63, .external_lex_state = 4},
  [463] = {.lex_state = 6, .external_lex_state = 2},
  [464] = {.lex_state = 15},
  [465] = {.lex_state = 63, .external_lex_state = 4},
  [466] = {.lex_state = 15},
  [467] = {.lex_state = 63},
  [468] = {.lex_state = 63, .external_lex_state = 4},
  [469] = {.lex_state = 15},
  [470] = {.lex_state = 15},
  [471] = {.lex_state = 6, .external_lex_state = 2},
  [472] = {.lex_state = 6, .external_lex_state = 2},
  [473] = {.lex_state = 63, .external_lex_state = 4},
  [474] = {.lex_state = 63},
  [475] = {.lex_state = 15},
  [476] = {.lex_state = 6, .external_lex_state = 3},
  [477] = {.lex_state = 63, .external_lex_state = 4},
  [478] = {.lex_state = 63},
  [479] = {.lex_state = 63, .external_lex_state = 4},
  [480] = {.lex_state = 63, .external_lex_state = 4},
  [481] = {.lex_state = 6, .external_lex_state = 2},
  [482] = {.lex_state = 6, .external_lex_state = 2},
  [483] = {.lex_state = 63},
  [484] = {.lex_state = 63},
  [485] = {.lex_state = 63},
  [486] = {.lex_state = 63},
  [487] = {.lex_state = 63},
  [488] = {.lex_state = 63},
  [489] = {.lex_state = 7, .external_lex_state = 3},
  [490] = {.lex_state = 6, .external_lex_state = 2},
  [491] = {.lex_state = 63},
  [492] = {.lex_state = 6, .external_lex_state = 2},
  [493] = {.lex_state = 6, .external_lex_state = 3},
  [494] = {.lex_state = 63},
  [495] = {.lex_state = 6, .external_lex_state = 2},
  [496] = {.lex_state = 63, .external_lex_state = 4},
  [497] = {.lex_state = 63, .external_lex_state = 4},
  [498] = {.lex_state = 6, .external_lex_state = 3},
  [499] = {.lex_state = 63, .external_lex_state = 4},
  [500] = {.lex_state = 63, .external_lex_state = 4},
  [501] = {.lex_state = 63, .external_lex_state = 4},
  [502] = {.lex_state = 63},
  [503] = {.lex_state = 63, .external_lex_state = 4},
  [504] = {.lex_state = 63, .external_lex_state = 4},
  [505] = {.lex_state = 63},
  [506] = {.lex_state = 63, .external_lex_state = 4},
  [507] = {.lex_state = 63},
  [508] = {.lex_state = 63},
  [509] = {.lex_state = 6, .external_lex_state = 3},
  [510] = {.lex_state = 63},
  [511] = {.lex_state = 6, .external_lex_state = 3},
  [512] = {.lex_state = 63, .external_lex_state = 4},
  [513] = {.lex_state = 6, .external_lex_state = 3},
  [514] = {.lex_state = 63, .external_lex_state = 4},
  [515] = {.lex_state = 6, .external_lex_state = 2},
  [516] = {.lex_state = 63, .external_lex_state = 4},
  [517] = {.lex_state = 63},
  [518] = {.lex_state = 7, .external_lex_state = 3},
  [519] = {.lex_state = 63, .external_lex_state = 4},
  [520] = {.lex_state = 6, .external_lex_state = 3},
  [521] = {.lex_state = 63},
  [522] = {.lex_state = 6, .external_lex_state = 3},
  [523] = {.lex_state = 6, .external_lex_state = 3},
  [524] = {.lex_state = 63},
  [525] = {.lex_state = 63},
  [526] = {.lex_state = 63},
  [527] = {.lex_state = 63},
  [528] = {.lex_state = 63},
  [529] = {.lex_state = 63},
  [530] = {.lex_state = 63},
  [531] = {.lex_state = 63},
  [532] = {.lex_state = 63},
  [533] = {.lex_state = 63},
  [534] = {.lex_state = 6, .external_lex_state = 3},
  [535] = {.lex_state = 63},
  [536] = {.lex_state = 63},
  [537] = {.lex_state = 63},
  [538] = {.lex_state = 63},
  [539] = {.lex_state = 63},
  [540] = {.lex_state = 63},
  [541] = {.lex_state = 63},
  [542] = {.lex_state = 63},
  [543] = {.lex_state = 63},
  [544] = {.lex_state = 63},
  [545] = {.lex_state = 63},
  [546] = {.lex_state = 63},
  [547] = {.lex_state = 63},
  [548] = {.lex_state = 63},
  [549] = {.lex_state = 63},
  [550] = {.lex_state = 63},
  [551] = {.lex_state = 63},
  [552] = {.lex_state = 63},
  [553] = {.lex_state = 6, .external_lex_state = 2},
  [554] = {.lex_state = 63},
  [555] = {.lex_state = 63},
  [556] = {.lex_state = 63},
  [557] = {.lex_state = 63},
  [558] = {.lex_state = 63},
  [559] = {.lex_state = 63},
  [560] = {.lex_state = 63},
  [561] = {.lex_state = 63},
  [562] = {.lex_state = 63},
  [563] = {.lex_state = 63},
  [564] = {.lex_state = 63},
  [565] = {.lex_state = 63},
  [566] = {.lex_state = 63},
  [567] = {.lex_state = 63},
  [568] = {.lex_state = 63},
  [569] = {.lex_state = 63},
  [570] = {.lex_state = 63},
  [571] = {.lex_state = 63},
  [572] = {.lex_state = 63},
  [573] = {.lex_state = 63},
  [574] = {.lex_state = 63},
  [575] = {.lex_state = 63},
  [576] = {.lex_state = 63},
  [577] = {.lex_state = 6, .external_lex_state = 3},
  [578] = {.lex_state = 63},
  [579] = {.lex_state = 63},
  [580] = {.lex_state = 63},
  [581] = {.lex_state = 63},
  [582] = {.lex_state = 63},
  [583] = {.lex_state = 63},
  [584] = {.lex_state = 63},
  [585] = {.lex_state = 63},
  [586] = {.lex_state = 63},
  [587] = {.lex_state = 63},
  [588] = {.lex_state = 63},
  [589] = {.lex_state = 63},
  [590] = {.lex_state = 63},
  [591] = {.lex_state = 63},
  [592] = {.lex_state = 63},
  [593] = {.lex_state = 63},
  [594] = {.lex_state = 63},
  [595] = {.lex_state = 63},
  [596] = {.lex_state = 63},
  [597] = {.lex_state = 63},
  [598] = {.lex_state = 63},
  [599] = {.lex_state = 63},
  [600] = {.lex_state = 63},
  [601] = {.lex_state = 63},
  [602] = {.lex_state = 63},
  [603] = {.lex_state = 6, .external_lex_state = 3},
  [604] = {.lex_state = 6, .external_lex_state = 3},
  [605] = {.lex_state = 6, .external_lex_state = 3},
  [606] = {.lex_state = 6, .external_lex_state = 3},
  [607] = {.lex_state = 63},
  [608] = {.lex_state = 63},
  [609] = {.lex_state = 63},
  [610] = {.lex_state = 63},
  [611] = {.lex_state = 63},
  [612] = {.lex_state = 63},
  [613] = {.lex_state = 63},
  [614] = {.lex_state = 63},
  [615] = {.lex_state = 63},
  [616] = {.lex_state = 63},
  [617] = {.lex_state = 6, .external_lex_state = 2},
  [618] = {.lex_state = 6, .external_lex_state = 2},
  [619] = {.lex_state = 6, .external_lex_state = 2},
  [620] = {.lex_state = 6, .external_lex_state = 2},
  [621] = {.lex_state = 6, .external_lex_state = 2},
  [622] = {.lex_state = 6, .external_lex_state = 3},
  [623] = {.lex_state = 6, .external_lex_state = 2},
  [624] = {.lex_state = 6, .external_lex_state = 2},
  [625] = {.lex_state = 6, .external_lex_state = 3},
  [626] = {.lex_state = 6, .external_lex_state = 3},
  [627] = {.lex_state = 6, .external_lex_state = 2},
  [628] = {.lex_state = 7, .external_lex_state = 3},
  [629] = {.lex_state = 6, .external_lex_state = 2},
  [630] = {.lex_state = 6, .external_lex_state = 2},
  [631] = {.lex_state = 6, .external_lex_state = 2},
  [632] = {.lex_state = 6, .external_lex_state = 2},
  [633] = {.lex_state = 6, .external_lex_state = 2},
  [634] = {.lex_state = 6, .external_lex_state = 3},
  [635] = {.lex_state = 6, .external_lex_state = 2},
  [636] = {.lex_state = 63},
  [637] = {.lex_state = 63},
  [638] = {.lex_state = 63},
  [639] = {.lex_state = 6, .external_lex_state = 3},
  [640] = {.lex_state = 63},
  [641] = {.lex_state = 7, .external_lex_state = 3},
  [642] = {.lex_state = 63},
  [643] = {.lex_state = 6, .external_lex_state = 3},
  [644] = {.lex_state = 6, .external_lex_state = 3},
  [645] = {.lex_state = 6, .external_lex_state = 3},
  [646] = {.lex_state = 63},
  [647] = {.lex_state = 63},
  [648] = {.lex_state = 6, .external_lex_state = 2},
  [649] = {.lex_state = 6, .external_lex_state = 3},
  [650] = {.lex_state = 6, .external_lex_state = 3},
  [651] = {.lex_state = 6, .external_lex_state = 3},
  [652] = {.lex_state = 6, .external_lex_state = 3},
  [653] = {.lex_state = 6, .external_lex_state = 3},
  [654] = {.lex_state = 6, .external_lex_state = 3},
  [655] = {.lex_state = 6, .external_lex_state = 3},
  [656] = {.lex_state = 6, .external_lex_state = 2},
  [657] = {.lex_state = 6, .external_lex_state = 2},
  [658] = {.lex_state = 6, .external_lex_state = 2},
  [659] = {.lex_state = 6, .external_lex_state = 2},
  [660] = {.lex_state = 6, .external_lex_state = 3},
  [661] = {.lex_state = 6, .external_lex_state = 3},
  [662] = {.lex_state = 6, .external_lex_state = 2},
  [663] = {.lex_state = 6, .external_lex_state = 3},
  [664] = {.lex_state = 6, .external_lex_state = 3},
  [665] = {.lex_state = 6, .external_lex_state = 2},
  [666] = {.lex_state = 63},
  [667] = {.lex_state = 6, .external_lex_state = 2},
  [668] = {.lex_state = 6, .external_lex_state = 2},
  [669] = {.lex_state = 15},
  [670] = {.lex_state = 6, .external_lex_state = 3},
  [671] = {.lex_state = 6, .external_lex_state = 3},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 6, .external_lex_state = 3},
  [674] = {.lex_state = 6, .external_lex_state = 2},
  [675] = {.lex_state = 15},
  [676] = {.lex_state = 63},
  [677] = {.lex_state = 6, .external_lex_state = 2},
  [678] = {.lex_state = 6, .external_lex_state = 3},
  [679] = {.lex_state = 15},
  [680] = {.lex_state = 6, .external_lex_state = 3},
  [681] = {.lex_state = 6, .external_lex_state = 2},
  [682] = {.lex_state = 15},
  [683] = {.lex_state = 6, .external_lex_state = 3},
  [684] = {.lex_state = 6, .external_lex_state = 3},
  [685] = {.lex_state = 6, .external_lex_state = 3},
  [686] = {.lex_state = 15},
  [687] = {.lex_state = 15},
  [688] = {.lex_state = 6, .external_lex_state = 2},
  [689] = {.lex_state = 15},
  [690] = {.lex_state = 15},
  [691] = {.lex_state = 15},
  [692] = {.lex_state = 15},
  [693] = {.lex_state = 7, .external_lex_state = 3},
  [694] = {.lex_state = 6, .external_lex_state = 2},
  [695] = {.lex_state = 15},
  [696] = {.lex_state = 15},
  [697] = {.lex_state = 6, .external_lex_state = 3},
  [698] = {.lex_state = 15},
  [699] = {.lex_state = 15},
  [700] = {.lex_state = 6, .external_lex_state = 3},
  [701] = {.lex_state = 6, .external_lex_state = 2},
  [702] = {.lex_state = 6, .external_lex_state = 2},
  [703] = {.lex_state = 15},
  [704] = {.lex_state = 15},
  [705] = {.lex_state = 7, .external_lex_state = 3},
  [706] = {.lex_state = 15},
  [707] = {.lex_state = 15},
  [708] = {.lex_state = 15},
  [709] = {.lex_state = 6, .external_lex_state = 2},
  [710] = {.lex_state = 6, .external_lex_state = 2},
  [711] = {.lex_state = 6, .external_lex_state = 3},
  [712] = {.lex_state = 6, .external_lex_state = 3},
  [713] = {.lex_state = 6, .external_lex_state = 2},
  [714] = {.lex_state = 6, .external_lex_state = 3},
  [715] = {.lex_state = 15},
  [716] = {.lex_state = 15},
  [717] = {.lex_state = 15},
  [718] = {.lex_state = 15},
  [719] = {.lex_state = 15},
  [720] = {.lex_state = 6, .external_lex_state = 2},
  [721] = {.lex_state = 15},
  [722] = {.lex_state = 15},
  [723] = {.lex_state = 15},
  [724] = {.lex_state = 15},
  [725] = {.lex_state = 15},
  [726] = {.lex_state = 15},
  [727] = {.lex_state = 7, .external_lex_state = 3},
  [728] = {.lex_state = 15},
  [729] = {.lex_state = 15},
  [730] = {.lex_state = 15},
  [731] = {.lex_state = 15},
  [732] = {.lex_state = 15},
  [733] = {.lex_state = 15},
  [734] = {.lex_state = 15},
  [735] = {.lex_state = 7, .external_lex_state = 3},
  [736] = {.lex_state = 6, .external_lex_state = 2},
  [737] = {.lex_state = 15},
  [738] = {.lex_state = 15},
  [739] = {.lex_state = 15},
  [740] = {.lex_state = 6, .external_lex_state = 2},
  [741] = {.lex_state = 6, .external_lex_state = 2},
  [742] = {.lex_state = 7, .external_lex_state = 3},
  [743] = {.lex_state = 15},
  [744] = {.lex_state = 6, .external_lex_state = 3},
  [745] = {.lex_state = 15},
  [746] = {.lex_state = 15},
  [747] = {.lex_state = 15},
  [748] = {.lex_state = 15},
  [749] = {.lex_state = 15},
  [750] = {.lex_state = 15},
  [751] = {.lex_state = 15},
  [752] = {.lex_state = 15},
  [753] = {.lex_state = 15},
  [754] = {.lex_state = 6, .external_lex_state = 2},
  [755] = {.lex_state = 15},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 15},
  [759] = {.lex_state = 15},
  [760] = {.lex_state = 6, .external_lex_state = 2},
  [761] = {.lex_state = 6, .external_lex_state = 2},
  [762] = {.lex_state = 6, .external_lex_state = 2},
  [763] = {.lex_state = 15},
  [764] = {.lex_state = 15},
  [765] = {.lex_state = 15},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 15},
  [768] = {.lex_state = 15},
  [769] = {.lex_state = 15},
  [770] = {.lex_state = 15},
  [771] = {.lex_state = 15},
  [772] = {.lex_state = 15},
  [773] = {.lex_state = 15},
  [774] = {.lex_state = 15},
  [775] = {.lex_state = 15},
  [776] = {.lex_state = 15},
  [777] = {.lex_state = 15},
  [778] = {.lex_state = 15},
  [779] = {.lex_state = 15},
  [780] = {.lex_state = 6, .external_lex_state = 3},
  [781] = {.lex_state = 15},
  [782] = {.lex_state = 15},
  [783] = {.lex_state = 15},
  [784] = {.lex_state = 15},
  [785] = {.lex_state = 6, .external_lex_state = 2},
  [786] = {.lex_state = 15},
  [787] = {.lex_state = 15},
  [788] = {.lex_state = 6, .external_lex_state = 2},
  [789] = {.lex_state = 6, .external_lex_state = 3},
  [790] = {.lex_state = 6, .external_lex_state = 2},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 6, .external_lex_state = 2},
  [793] = {.lex_state = 6, .external_lex_state = 2},
  [794] = {.lex_state = 15},
  [795] = {.lex_state = 15},
  [796] = {.lex_state = 6, .external_lex_state = 2},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 15},
  [803] = {.lex_state = 15},
  [804] = {.lex_state = 15},
  [805] = {.lex_state = 15},
  [806] = {.lex_state = 15},
  [807] = {.lex_state = 6, .external_lex_state = 3},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 6, .external_lex_state = 2},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 6, .external_lex_state = 3},
  [813] = {.lex_state = 15},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 6, .external_lex_state = 2},
  [817] = {.lex_state = 15},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 6, .external_lex_state = 2},
  [820] = {.lex_state = 6, .external_lex_state = 2},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 6, .external_lex_state = 2},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 15},
  [825] = {.lex_state = 6, .external_lex_state = 3},
  [826] = {.lex_state = 6, .external_lex_state = 2},
  [827] = {.lex_state = 15},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 15},
  [830] = {.lex_state = 6, .external_lex_state = 3},
  [831] = {.lex_state = 7, .external_lex_state = 3},
  [832] = {.lex_state = 7, .external_lex_state = 3},
  [833] = {.lex_state = 6, .external_lex_state = 2},
  [834] = {.lex_state = 6, .external_lex_state = 3},
  [835] = {.lex_state = 6, .external_lex_state = 2},
  [836] = {.lex_state = 6, .external_lex_state = 2},
  [837] = {.lex_state = 6, .external_lex_state = 3},
  [838] = {.lex_state = 7, .external_lex_state = 3},
  [839] = {.lex_state = 6, .external_lex_state = 3},
  [840] = {.lex_state = 6, .external_lex_state = 3},
  [841] = {.lex_state = 7, .external_lex_state = 3},
  [842] = {.lex_state = 6, .external_lex_state = 3},
  [843] = {.lex_state = 6, .external_lex_state = 3},
  [844] = {.lex_state = 6, .external_lex_state = 3},
  [845] = {.lex_state = 6, .external_lex_state = 2},
  [846] = {.lex_state = 6, .external_lex_state = 2},
  [847] = {.lex_state = 6, .external_lex_state = 2},
  [848] = {.lex_state = 6, .external_lex_state = 3},
  [849] = {.lex_state = 6, .external_lex_state = 3},
  [850] = {.lex_state = 6, .external_lex_state = 2},
  [851] = {.lex_state = 6, .external_lex_state = 2},
  [852] = {.lex_state = 6, .external_lex_state = 3},
  [853] = {.lex_state = 6, .external_lex_state = 3},
  [854] = {.lex_state = 6, .external_lex_state = 3},
  [855] = {.lex_state = 7, .external_lex_state = 3},
  [856] = {.lex_state = 6, .external_lex_state = 3},
  [857] = {.lex_state = 6, .external_lex_state = 2},
  [858] = {.lex_state = 6, .external_lex_state = 3},
  [859] = {.lex_state = 6, .external_lex_state = 3},
  [860] = {.lex_state = 7, .external_lex_state = 3},
  [861] = {.lex_state = 6, .external_lex_state = 3},
  [862] = {.lex_state = 6, .external_lex_state = 3},
  [863] = {.lex_state = 6, .external_lex_state = 3},
  [864] = {.lex_state = 6, .external_lex_state = 3},
  [865] = {.lex_state = 7, .external_lex_state = 3},
  [866] = {.lex_state = 7, .external_lex_state = 3},
  [867] = {.lex_state = 6, .external_lex_state = 2},
  [868] = {.lex_state = 7, .external_lex_state = 3},
  [869] = {.lex_state = 6, .external_lex_state = 3},
  [870] = {.lex_state = 6, .external_lex_state = 3},
  [871] = {.lex_state = 7, .external_lex_state = 3},
  [872] = {.lex_state = 7, .external_lex_state = 3},
  [873] = {.lex_state = 6, .external_lex_state = 3},
  [874] = {.lex_state = 6, .external_lex_state = 2},
  [875] = {.lex_state = 6, .external_lex_state = 2},
  [876] = {.lex_state = 7, .external_lex_state = 3},
  [877] = {.lex_state = 6, .external_lex_state = 3},
  [878] = {.lex_state = 6, .external_lex_state = 3},
  [879] = {.lex_state = 7, .external_lex_state = 3},
  [880] = {.lex_state = 6, .external_lex_state = 2},
  [881] = {.lex_state = 6, .external_lex_state = 3},
  [882] = {.lex_state = 6, .external_lex_state = 3},
  [883] = {.lex_state = 7, .external_lex_state = 3},
  [884] = {.lex_state = 6, .external_lex_state = 3},
  [885] = {.lex_state = 7, .external_lex_state = 3},
  [886] = {.lex_state = 6, .external_lex_state = 3},
  [887] = {.lex_state = 6, .external_lex_state = 3},
  [888] = {.lex_state = 6, .external_lex_state = 3},
  [889] = {.lex_state = 6, .external_lex_state = 3},
  [890] = {.lex_state = 6, .external_lex_state = 2},
  [891] = {.lex_state = 6, .external_lex_state = 3},
  [892] = {.lex_state = 6, .external_lex_state = 3},
  [893] = {.lex_state = 6, .external_lex_state = 3},
  [894] = {.lex_state = 63},
  [895] = {.lex_state = 6, .external_lex_state = 3},
  [896] = {.lex_state = 63},
  [897] = {.lex_state = 63},
  [898] = {.lex_state = 63, .external_lex_state = 4},
  [899] = {.lex_state = 63},
  [900] = {.lex_state = 63, .external_lex_state = 4},
  [901] = {.lex_state = 63, .external_lex_state = 4},
  [902] = {.lex_state = 63, .external_lex_state = 4},
  [903] = {.lex_state = 62, .external_lex_state = 2},
  [904] = {.lex_state = 63},
  [905] = {.lex_state = 6, .external_lex_state = 3},
  [906] = {.lex_state = 63, .external_lex_state = 4},
  [907] = {.lex_state = 63, .external_lex_state = 4},
  [908] = {.lex_state = 63},
  [909] = {.lex_state = 63},
  [910] = {.lex_state = 63},
  [911] = {.lex_state = 63},
  [912] = {.lex_state = 63},
  [913] = {.lex_state = 63},
  [914] = {.lex_state = 63},
  [915] = {.lex_state = 63},
  [916] = {.lex_state = 63},
  [917] = {.lex_state = 63},
  [918] = {.lex_state = 63},
  [919] = {.lex_state = 63},
  [920] = {.lex_state = 63},
  [921] = {.lex_state = 63},
  [922] = {.lex_state = 63},
  [923] = {.lex_state = 63},
  [924] = {.lex_state = 63},
  [925] = {.lex_state = 63},
  [926] = {.lex_state = 62, .external_lex_state = 3},
  [927] = {.lex_state = 63},
  [928] = {.lex_state = 62, .external_lex_state = 3},
  [929] = {.lex_state = 62, .external_lex_state = 3},
  [930] = {.lex_state = 62, .external_lex_state = 3},
  [931] = {.lex_state = 63},
  [932] = {.lex_state = 63},
  [933] = {.lex_state = 62, .external_lex_state = 3},
  [934] = {.lex_state = 62, .external_lex_state = 3},
  [935] = {.lex_state = 62, .external_lex_state = 3},
  [936] = {.lex_state = 62, .external_lex_state = 3},
  [937] = {.lex_state = 62, .external_lex_state = 2},
  [938] = {.lex_state = 62, .external_lex_state = 3},
  [939] = {.lex_state = 62, .external_lex_state = 3},
  [940] = {.lex_state = 62, .external_lex_state = 3},
  [941] = {.lex_state = 62, .external_lex_state = 2},
  [942] = {.lex_state = 62, .external_lex_state = 3},
  [943] = {.lex_state = 62, .external_lex_state = 3},
  [944] = {.lex_state = 62, .external_lex_state = 2},
  [945] = {.lex_state = 62, .external_lex_state = 3},
  [946] = {.lex_state = 62, .external_lex_state = 3},
  [947] = {.lex_state = 62, .external_lex_state = 3},
  [948] = {.lex_state = 62, .external_lex_state = 3},
  [949] = {.lex_state = 62, .external_lex_state = 3},
  [950] = {.lex_state = 62, .external_lex_state = 3},
  [951] = {.lex_state = 62, .external_lex_state = 3},
  [952] = {.lex_state = 62, .external_lex_state = 3},
  [953] = {.lex_state = 62, .external_lex_state = 3},
  [954] = {.lex_state = 62, .external_lex_state = 3},
  [955] = {.lex_state = 62, .external_lex_state = 3},
  [956] = {.lex_state = 62, .external_lex_state = 3},
  [957] = {.lex_state = 62, .external_lex_state = 3},
  [958] = {.lex_state = 62, .external_lex_state = 3},
  [959] = {.lex_state = 62, .external_lex_state = 3},
  [960] = {.lex_state = 62, .external_lex_state = 3},
  [961] = {.lex_state = 62, .external_lex_state = 3},
  [962] = {.lex_state = 62, .external_lex_state = 3},
  [963] = {.lex_state = 62, .external_lex_state = 2},
  [964] = {.lex_state = 62, .external_lex_state = 2},
  [965] = {.lex_state = 62, .external_lex_state = 3},
  [966] = {.lex_state = 62, .external_lex_state = 3},
  [967] = {.lex_state = 62, .external_lex_state = 2},
  [968] = {.lex_state = 62, .external_lex_state = 3},
  [969] = {.lex_state = 62, .external_lex_state = 3},
  [970] = {.lex_state = 62, .external_lex_state = 3},
  [971] = {.lex_state = 62, .external_lex_state = 3},
  [972] = {.lex_state = 62, .external_lex_state = 3},
  [973] = {.lex_state = 62, .external_lex_state = 3},
  [974] = {.lex_state = 62, .external_lex_state = 2},
  [975] = {.lex_state = 62, .external_lex_state = 3},
  [976] = {.lex_state = 62, .external_lex_state = 3},
  [977] = {.lex_state = 62, .external_lex_state = 3},
  [978] = {.lex_state = 62, .external_lex_state = 3},
  [979] = {.lex_state = 62, .external_lex_state = 2},
  [980] = {.lex_state = 62, .external_lex_state = 2},
  [981] = {.lex_state = 62, .external_lex_state = 3},
  [982] = {.lex_state = 62, .external_lex_state = 3},
  [983] = {.lex_state = 62, .external_lex_state = 3},
  [984] = {.lex_state = 62, .external_lex_state = 3},
  [985] = {.lex_state = 62, .external_lex_state = 3},
  [986] = {.lex_state = 62, .external_lex_state = 3},
  [987] = {.lex_state = 62, .external_lex_state = 3},
  [988] = {.lex_state = 62, .external_lex_state = 3},
  [989] = {.lex_state = 62, .external_lex_state = 3},
  [990] = {.lex_state = 62, .external_lex_state = 3},
  [991] = {.lex_state = 62, .external_lex_state = 3},
  [992] = {.lex_state = 62, .external_lex_state = 2},
  [993] = {.lex_state = 62, .external_lex_state = 3},
  [994] = {.lex_state = 62, .external_lex_state = 3},
  [995] = {.lex_state = 15},
  [996] = {.lex_state = 62, .external_lex_state = 3},
  [997] = {.lex_state = 62, .external_lex_state = 3},
  [998] = {.lex_state = 62, .external_lex_state = 3},
  [999] = {.lex_state = 62, .external_lex_state = 3},
  [1000] = {.lex_state = 62, .external_lex_state = 3},
  [1001] = {.lex_state = 62, .external_lex_state = 3},
  [1002] = {.lex_state = 62, .external_lex_state = 3},
  [1003] = {.lex_state = 62, .external_lex_state = 3},
  [1004] = {.lex_state = 62, .external_lex_state = 3},
  [1005] = {.lex_state = 62, .external_lex_state = 3},
  [1006] = {.lex_state = 62, .external_lex_state = 3},
  [1007] = {.lex_state = 62, .external_lex_state = 3},
  [1008] = {.lex_state = 62, .external_lex_state = 3},
  [1009] = {.lex_state = 62, .external_lex_state = 3},
  [1010] = {.lex_state = 62, .external_lex_state = 3},
  [1011] = {.lex_state = 62, .external_lex_state = 3},
  [1012] = {.lex_state = 62, .external_lex_state = 3},
  [1013] = {.lex_state = 62, .external_lex_state = 2},
  [1014] = {.lex_state = 62, .external_lex_state = 3},
  [1015] = {.lex_state = 62, .external_lex_state = 2},
  [1016] = {.lex_state = 62, .external_lex_state = 3},
  [1017] = {.lex_state = 62, .external_lex_state = 3},
  [1018] = {.lex_state = 62, .external_lex_state = 3},
  [1019] = {.lex_state = 62, .external_lex_state = 3},
  [1020] = {.lex_state = 62, .external_lex_state = 3},
  [1021] = {.lex_state = 62, .external_lex_state = 3},
  [1022] = {.lex_state = 62, .external_lex_state = 3},
  [1023] = {.lex_state = 62, .external_lex_state = 3},
  [1024] = {.lex_state = 62, .external_lex_state = 2},
  [1025] = {.lex_state = 62, .external_lex_state = 3},
  [1026] = {.lex_state = 62, .external_lex_state = 3},
  [1027] = {.lex_state = 62, .external_lex_state = 3},
  [1028] = {.lex_state = 62, .external_lex_state = 3},
  [1029] = {.lex_state = 62, .external_lex_state = 3},
  [1030] = {.lex_state = 62, .external_lex_state = 2},
  [1031] = {.lex_state = 62, .external_lex_state = 3},
  [1032] = {.lex_state = 62, .external_lex_state = 3},
  [1033] = {.lex_state = 62, .external_lex_state = 3},
  [1034] = {.lex_state = 62, .external_lex_state = 3},
  [1035] = {.lex_state = 62, .external_lex_state = 3},
  [1036] = {.lex_state = 62, .external_lex_state = 3},
  [1037] = {.lex_state = 62, .external_lex_state = 3},
  [1038] = {.lex_state = 62, .external_lex_state = 3},
  [1039] = {.lex_state = 15},
  [1040] = {.lex_state = 62, .external_lex_state = 3},
  [1041] = {.lex_state = 62, .external_lex_state = 3},
  [1042] = {.lex_state = 62, .external_lex_state = 2},
  [1043] = {.lex_state = 62, .external_lex_state = 2},
  [1044] = {.lex_state = 62, .external_lex_state = 2},
  [1045] = {.lex_state = 62, .external_lex_state = 2},
  [1046] = {.lex_state = 62, .external_lex_state = 2},
  [1047] = {.lex_state = 62, .external_lex_state = 3},
  [1048] = {.lex_state = 62, .external_lex_state = 2},
  [1049] = {.lex_state = 62, .external_lex_state = 3},
  [1050] = {.lex_state = 62, .external_lex_state = 2},
  [1051] = {.lex_state = 62, .external_lex_state = 3},
  [1052] = {.lex_state = 62, .external_lex_state = 2},
  [1053] = {.lex_state = 62, .external_lex_state = 2},
  [1054] = {.lex_state = 62, .external_lex_state = 3},
  [1055] = {.lex_state = 62, .external_lex_state = 3},
  [1056] = {.lex_state = 62, .external_lex_state = 3},
  [1057] = {.lex_state = 62, .external_lex_state = 3},
  [1058] = {.lex_state = 62, .external_lex_state = 2},
  [1059] = {.lex_state = 15},
  [1060] = {.lex_state = 62, .external_lex_state = 3},
  [1061] = {.lex_state = 62, .external_lex_state = 2},
  [1062] = {.lex_state = 15},
  [1063] = {.lex_state = 62, .external_lex_state = 3},
  [1064] = {.lex_state = 62, .external_lex_state = 3},
  [1065] = {.lex_state = 62, .external_lex_state = 2},
  [1066] = {.lex_state = 62, .external_lex_state = 3},
  [1067] = {.lex_state = 62, .external_lex_state = 3},
  [1068] = {.lex_state = 62, .external_lex_state = 3},
  [1069] = {.lex_state = 62, .external_lex_state = 3},
  [1070] = {.lex_state = 62, .external_lex_state = 3},
  [1071] = {.lex_state = 62, .external_lex_state = 3},
  [1072] = {.lex_state = 62, .external_lex_state = 3},
  [1073] = {.lex_state = 62, .external_lex_state = 2},
  [1074] = {.lex_state = 62, .external_lex_state = 2},
  [1075] = {.lex_state = 62, .external_lex_state = 2},
  [1076] = {.lex_state = 62, .external_lex_state = 3},
  [1077] = {.lex_state = 62, .external_lex_state = 2},
  [1078] = {.lex_state = 62, .external_lex_state = 2},
  [1079] = {.lex_state = 62, .external_lex_state = 3},
  [1080] = {.lex_state = 62, .external_lex_state = 3},
  [1081] = {.lex_state = 62, .external_lex_state = 2},
  [1082] = {.lex_state = 62, .external_lex_state = 3},
  [1083] = {.lex_state = 62, .external_lex_state = 3},
  [1084] = {.lex_state = 62, .external_lex_state = 3},
  [1085] = {.lex_state = 62, .external_lex_state = 3},
  [1086] = {.lex_state = 62, .external_lex_state = 3},
  [1087] = {.lex_state = 62, .external_lex_state = 3},
  [1088] = {.lex_state = 62, .external_lex_state = 3},
  [1089] = {.lex_state = 62, .external_lex_state = 3},
  [1090] = {.lex_state = 62, .external_lex_state = 3},
  [1091] = {.lex_state = 62, .external_lex_state = 3},
  [1092] = {.lex_state = 62, .external_lex_state = 3},
  [1093] = {.lex_state = 62, .external_lex_state = 3},
  [1094] = {.lex_state = 62, .external_lex_state = 3},
  [1095] = {.lex_state = 62, .external_lex_state = 3},
  [1096] = {.lex_state = 62, .external_lex_state = 3},
  [1097] = {.lex_state = 62, .external_lex_state = 2},
  [1098] = {.lex_state = 62, .external_lex_state = 2},
  [1099] = {.lex_state = 62, .external_lex_state = 2},
  [1100] = {.lex_state = 62, .external_lex_state = 3},
  [1101] = {.lex_state = 62, .external_lex_state = 3},
  [1102] = {.lex_state = 62, .external_lex_state = 3},
  [1103] = {.lex_state = 62, .external_lex_state = 3},
  [1104] = {.lex_state = 62, .external_lex_state = 2},
  [1105] = {.lex_state = 62, .external_lex_state = 3},
  [1106] = {.lex_state = 62, .external_lex_state = 3},
  [1107] = {.lex_state = 62, .external_lex_state = 3},
  [1108] = {.lex_state = 62, .external_lex_state = 3},
  [1109] = {.lex_state = 62, .external_lex_state = 2},
  [1110] = {.lex_state = 62, .external_lex_state = 2},
  [1111] = {.lex_state = 62, .external_lex_state = 3},
  [1112] = {.lex_state = 62, .external_lex_state = 3},
  [1113] = {.lex_state = 62, .external_lex_state = 3},
  [1114] = {.lex_state = 8, .external_lex_state = 3},
  [1115] = {.lex_state = 62, .external_lex_state = 3},
  [1116] = {.lex_state = 62, .external_lex_state = 3},
  [1117] = {.lex_state = 15},
  [1118] = {.lex_state = 62, .external_lex_state = 2},
  [1119] = {.lex_state = 62, .external_lex_state = 2},
  [1120] = {.lex_state = 62, .external_lex_state = 2},
  [1121] = {.lex_state = 62, .external_lex_state = 3},
  [1122] = {.lex_state = 62, .external_lex_state = 2},
  [1123] = {.lex_state = 62, .external_lex_state = 3},
  [1124] = {.lex_state = 62, .external_lex_state = 2},
  [1125] = {.lex_state = 62, .external_lex_state = 2},
  [1126] = {.lex_state = 62, .external_lex_state = 2},
  [1127] = {.lex_state = 62, .external_lex_state = 2},
  [1128] = {.lex_state = 62, .external_lex_state = 2},
  [1129] = {.lex_state = 62, .external_lex_state = 2},
  [1130] = {.lex_state = 62, .external_lex_state = 2},
  [1131] = {.lex_state = 62, .external_lex_state = 3},
  [1132] = {.lex_state = 62, .external_lex_state = 3},
  [1133] = {.lex_state = 62, .external_lex_state = 2},
  [1134] = {.lex_state = 15},
  [1135] = {.lex_state = 62, .external_lex_state = 3},
  [1136] = {.lex_state = 62, .external_lex_state = 2},
  [1137] = {.lex_state = 62, .external_lex_state = 3},
  [1138] = {.lex_state = 62, .external_lex_state = 2},
  [1139] = {.lex_state = 62, .external_lex_state = 2},
  [1140] = {.lex_state = 63},
  [1141] = {.lex_state = 62, .external_lex_state = 2},
  [1142] = {.lex_state = 63},
  [1143] = {.lex_state = 62, .external_lex_state = 2},
  [1144] = {.lex_state = 62, .external_lex_state = 3},
  [1145] = {.lex_state = 8, .external_lex_state = 3},
  [1146] = {.lex_state = 8, .external_lex_state = 3},
  [1147] = {.lex_state = 62, .external_lex_state = 3},
  [1148] = {.lex_state = 8, .external_lex_state = 3},
  [1149] = {.lex_state = 62, .external_lex_state = 3},
  [1150] = {.lex_state = 8, .external_lex_state = 3},
  [1151] = {.lex_state = 8, .external_lex_state = 3},
  [1152] = {.lex_state = 8, .external_lex_state = 3},
  [1153] = {.lex_state = 8, .external_lex_state = 3},
  [1154] = {.lex_state = 8, .external_lex_state = 3},
  [1155] = {.lex_state = 8, .external_lex_state = 3},
  [1156] = {.lex_state = 62, .external_lex_state = 3},
  [1157] = {.lex_state = 62, .external_lex_state = 3},
  [1158] = {.lex_state = 62, .external_lex_state = 3},
  [1159] = {.lex_state = 8, .external_lex_state = 3},
  [1160] = {.lex_state = 8, .external_lex_state = 3},
  [1161] = {.lex_state = 62, .external_lex_state = 3},
  [1162] = {.lex_state = 62, .external_lex_state = 3},
  [1163] = {.lex_state = 8, .external_lex_state = 3},
  [1164] = {.lex_state = 62, .external_lex_state = 3},
  [1165] = {.lex_state = 8, .external_lex_state = 3},
  [1166] = {.lex_state = 8, .external_lex_state = 3},
  [1167] = {.lex_state = 62, .external_lex_state = 2},
  [1168] = {.lex_state = 63},
  [1169] = {.lex_state = 8, .external_lex_state = 3},
  [1170] = {.lex_state = 62, .external_lex_state = 3},
  [1171] = {.lex_state = 62, .external_lex_state = 3},
  [1172] = {.lex_state = 8, .external_lex_state = 3},
  [1173] = {.lex_state = 62, .external_lex_state = 3},
  [1174] = {.lex_state = 62, .external_lex_state = 2},
  [1175] = {.lex_state = 8, .external_lex_state = 3},
  [1176] = {.lex_state = 63},
  [1177] = {.lex_state = 9, .external_lex_state = 3},
  [1178] = {.lex_state = 62, .external_lex_state = 3},
  [1179] = {.lex_state = 62, .external_lex_state = 2},
  [1180] = {.lex_state = 62, .external_lex_state = 2},
  [1181] = {.lex_state = 62, .external_lex_state = 3},
  [1182] = {.lex_state = 62, .external_lex_state = 3},
  [1183] = {.lex_state = 62, .external_lex_state = 3},
  [1184] = {.lex_state = 62, .external_lex_state = 3},
  [1185] = {.lex_state = 62, .external_lex_state = 2},
  [1186] = {.lex_state = 62, .external_lex_state = 2},
  [1187] = {.lex_state = 62, .external_lex_state = 2},
  [1188] = {.lex_state = 62, .external_lex_state = 3},
  [1189] = {.lex_state = 8, .external_lex_state = 3},
  [1190] = {.lex_state = 8, .external_lex_state = 3},
  [1191] = {.lex_state = 62, .external_lex_state = 2},
  [1192] = {.lex_state = 8, .external_lex_state = 3},
  [1193] = {.lex_state = 62, .external_lex_state = 2},
  [1194] = {.lex_state = 8, .external_lex_state = 3},
  [1195] = {.lex_state = 62, .external_lex_state = 2},
  [1196] = {.lex_state = 62, .external_lex_state = 3},
  [1197] = {.lex_state = 62, .external_lex_state = 3},
  [1198] = {.lex_state = 62, .external_lex_state = 3},
  [1199] = {.lex_state = 62, .external_lex_state = 3},
  [1200] = {.lex_state = 62, .external_lex_state = 3},
  [1201] = {.lex_state = 62, .external_lex_state = 3},
  [1202] = {.lex_state = 62, .external_lex_state = 3},
  [1203] = {.lex_state = 62, .external_lex_state = 3},
  [1204] = {.lex_state = 62, .external_lex_state = 3},
  [1205] = {.lex_state = 62, .external_lex_state = 2},
  [1206] = {.lex_state = 62, .external_lex_state = 3},
  [1207] = {.lex_state = 62, .external_lex_state = 2},
  [1208] = {.lex_state = 62, .external_lex_state = 3},
  [1209] = {.lex_state = 62, .external_lex_state = 3},
  [1210] = {.lex_state = 8, .external_lex_state = 3},
  [1211] = {.lex_state = 62, .external_lex_state = 3},
  [1212] = {.lex_state = 8, .external_lex_state = 3},
  [1213] = {.lex_state = 62, .external_lex_state = 2},
  [1214] = {.lex_state = 62, .external_lex_state = 3},
  [1215] = {.lex_state = 8, .external_lex_state = 3},
  [1216] = {.lex_state = 8, .external_lex_state = 3},
  [1217] = {.lex_state = 62, .external_lex_state = 3},
  [1218] = {.lex_state = 8, .external_lex_state = 3},
  [1219] = {.lex_state = 62, .external_lex_state = 3},
  [1220] = {.lex_state = 8, .external_lex_state = 3},
  [1221] = {.lex_state = 8, .external_lex_state = 3},
  [1222] = {.lex_state = 62, .external_lex_state = 2},
  [1223] = {.lex_state = 62, .external_lex_state = 2},
  [1224] = {.lex_state = 62, .external_lex_state = 2},
  [1225] = {.lex_state = 8, .external_lex_state = 3},
  [1226] = {.lex_state = 8, .external_lex_state = 3},
  [1227] = {.lex_state = 62, .external_lex_state = 3},
  [1228] = {.lex_state = 62, .external_lex_state = 3},
  [1229] = {.lex_state = 62, .external_lex_state = 3},
  [1230] = {.lex_state = 8, .external_lex_state = 3},
  [1231] = {.lex_state = 62, .external_lex_state = 3},
  [1232] = {.lex_state = 62, .external_lex_state = 3},
  [1233] = {.lex_state = 62, .external_lex_state = 2},
  [1234] = {.lex_state = 62, .external_lex_state = 2},
  [1235] = {.lex_state = 63},
  [1236] = {.lex_state = 62, .external_lex_state = 3},
  [1237] = {.lex_state = 62, .external_lex_state = 3},
  [1238] = {.lex_state = 62, .external_lex_state = 3},
  [1239] = {.lex_state = 8, .external_lex_state = 3},
  [1240] = {.lex_state = 62, .external_lex_state = 2},
  [1241] = {.lex_state = 62, .external_lex_state = 2},
  [1242] = {.lex_state = 62, .external_lex_state = 3},
  [1243] = {.lex_state = 62, .external_lex_state = 2},
  [1244] = {.lex_state = 63, .external_lex_state = 4},
  [1245] = {.lex_state = 62, .external_lex_state = 3},
  [1246] = {.lex_state = 62, .external_lex_state = 3},
  [1247] = {.lex_state = 62, .external_lex_state = 3},
  [1248] = {.lex_state = 62, .external_lex_state = 2},
  [1249] = {.lex_state = 62, .external_lex_state = 3},
  [1250] = {.lex_state = 62, .external_lex_state = 3},
  [1251] = {.lex_state = 62, .external_lex_state = 2},
  [1252] = {.lex_state = 62, .external_lex_state = 3},
  [1253] = {.lex_state = 62, .external_lex_state = 3},
  [1254] = {.lex_state = 62, .external_lex_state = 2},
  [1255] = {.lex_state = 62, .external_lex_state = 2},
  [1256] = {.lex_state = 62, .external_lex_state = 3},
  [1257] = {.lex_state = 62, .external_lex_state = 3},
  [1258] = {.lex_state = 62, .external_lex_state = 2},
  [1259] = {.lex_state = 62, .external_lex_state = 3},
  [1260] = {.lex_state = 62, .external_lex_state = 3},
  [1261] = {.lex_state = 62, .external_lex_state = 3},
  [1262] = {.lex_state = 62, .external_lex_state = 3},
  [1263] = {.lex_state = 62, .external_lex_state = 3},
  [1264] = {.lex_state = 62, .external_lex_state = 2},
  [1265] = {.lex_state = 62, .external_lex_state = 3},
  [1266] = {.lex_state = 62, .external_lex_state = 3},
  [1267] = {.lex_state = 62, .external_lex_state = 3},
  [1268] = {.lex_state = 62, .external_lex_state = 3},
  [1269] = {.lex_state = 62, .external_lex_state = 3},
  [1270] = {.lex_state = 62, .external_lex_state = 3},
  [1271] = {.lex_state = 8, .external_lex_state = 3},
  [1272] = {.lex_state = 8, .external_lex_state = 3},
  [1273] = {.lex_state = 63},
  [1274] = {.lex_state = 62, .external_lex_state = 3},
  [1275] = {.lex_state = 62, .external_lex_state = 2},
  [1276] = {.lex_state = 62, .external_lex_state = 3},
  [1277] = {.lex_state = 62, .external_lex_state = 2},
  [1278] = {.lex_state = 62, .external_lex_state = 2},
  [1279] = {.lex_state = 62, .external_lex_state = 3},
  [1280] = {.lex_state = 62, .external_lex_state = 2},
  [1281] = {.lex_state = 62, .external_lex_state = 3},
  [1282] = {.lex_state = 62, .external_lex_state = 3},
  [1283] = {.lex_state = 62, .external_lex_state = 2},
  [1284] = {.lex_state = 62, .external_lex_state = 3},
  [1285] = {.lex_state = 62, .external_lex_state = 2},
  [1286] = {.lex_state = 62, .external_lex_state = 3},
  [1287] = {.lex_state = 62, .external_lex_state = 3},
  [1288] = {.lex_state = 62, .external_lex_state = 2},
  [1289] = {.lex_state = 63},
  [1290] = {.lex_state = 63, .external_lex_state = 4},
  [1291] = {.lex_state = 62, .external_lex_state = 2},
  [1292] = {.lex_state = 62, .external_lex_state = 3},
  [1293] = {.lex_state = 62, .external_lex_state = 2},
  [1294] = {.lex_state = 62, .external_lex_state = 2},
  [1295] = {.lex_state = 8, .external_lex_state = 3},
  [1296] = {.lex_state = 63},
  [1297] = {.lex_state = 63, .external_lex_state = 4},
  [1298] = {.lex_state = 62, .external_lex_state = 2},
  [1299] = {.lex_state = 62, .external_lex_state = 2},
  [1300] = {.lex_state = 62, .external_lex_state = 2},
  [1301] = {.lex_state = 62, .external_lex_state = 2},
  [1302] = {.lex_state = 63, .external_lex_state = 4},
  [1303] = {.lex_state = 62, .external_lex_state = 2},
  [1304] = {.lex_state = 62, .external_lex_state = 2},
  [1305] = {.lex_state = 62, .external_lex_state = 2},
  [1306] = {.lex_state = 8, .external_lex_state = 2},
  [1307] = {.lex_state = 63, .external_lex_state = 4},
  [1308] = {.lex_state = 62, .external_lex_state = 3},
  [1309] = {.lex_state = 63, .external_lex_state = 4},
  [1310] = {.lex_state = 63, .external_lex_state = 4},
  [1311] = {.lex_state = 62, .external_lex_state = 3},
  [1312] = {.lex_state = 63},
  [1313] = {.lex_state = 62, .external_lex_state = 2},
  [1314] = {.lex_state = 62, .external_lex_state = 2},
  [1315] = {.lex_state = 62, .external_lex_state = 3},
  [1316] = {.lex_state = 62, .external_lex_state = 2},
  [1317] = {.lex_state = 62, .external_lex_state = 2},
  [1318] = {.lex_state = 63},
  [1319] = {.lex_state = 63},
  [1320] = {.lex_state = 62, .external_lex_state = 2},
  [1321] = {.lex_state = 63},
  [1322] = {.lex_state = 63, .external_lex_state = 4},
  [1323] = {.lex_state = 63, .external_lex_state = 4},
  [1324] = {.lex_state = 63, .external_lex_state = 4},
  [1325] = {.lex_state = 62, .external_lex_state = 2},
  [1326] = {.lex_state = 63},
  [1327] = {.lex_state = 62, .external_lex_state = 2},
  [1328] = {.lex_state = 62, .external_lex_state = 2},
  [1329] = {.lex_state = 62, .external_lex_state = 2},
  [1330] = {.lex_state = 63},
  [1331] = {.lex_state = 62, .external_lex_state = 3},
  [1332] = {.lex_state = 62, .external_lex_state = 3},
  [1333] = {.lex_state = 62, .external_lex_state = 3},
  [1334] = {.lex_state = 62, .external_lex_state = 2},
  [1335] = {.lex_state = 62, .external_lex_state = 3},
  [1336] = {.lex_state = 63},
  [1337] = {.lex_state = 62, .external_lex_state = 2},
  [1338] = {.lex_state = 62, .external_lex_state = 2},
  [1339] = {.lex_state = 62, .external_lex_state = 3},
  [1340] = {.lex_state = 62, .external_lex_state = 3},
  [1341] = {.lex_state = 62, .external_lex_state = 2},
  [1342] = {.lex_state = 62, .external_lex_state = 3},
  [1343] = {.lex_state = 62, .external_lex_state = 2},
  [1344] = {.lex_state = 62, .external_lex_state = 2},
  [1345] = {.lex_state = 62, .external_lex_state = 2},
  [1346] = {.lex_state = 63},
  [1347] = {.lex_state = 62, .external_lex_state = 3},
  [1348] = {.lex_state = 62, .external_lex_state = 2},
  [1349] = {.lex_state = 62, .external_lex_state = 2},
  [1350] = {.lex_state = 62, .external_lex_state = 3},
  [1351] = {.lex_state = 62, .external_lex_state = 2},
  [1352] = {.lex_state = 62, .external_lex_state = 3},
  [1353] = {.lex_state = 62, .external_lex_state = 3},
  [1354] = {.lex_state = 62, .external_lex_state = 2},
  [1355] = {.lex_state = 62, .external_lex_state = 2},
  [1356] = {.lex_state = 62, .external_lex_state = 2},
  [1357] = {.lex_state = 62, .external_lex_state = 2},
  [1358] = {.lex_state = 62, .external_lex_state = 2},
  [1359] = {.lex_state = 62, .external_lex_state = 3},
  [1360] = {.lex_state = 62, .external_lex_state = 3},
  [1361] = {.lex_state = 62, .external_lex_state = 2},
  [1362] = {.lex_state = 62, .external_lex_state = 2},
  [1363] = {.lex_state = 63},
  [1364] = {.lex_state = 8, .external_lex_state = 3},
  [1365] = {.lex_state = 62, .external_lex_state = 2},
  [1366] = {.lex_state = 9, .external_lex_state = 2},
  [1367] = {.lex_state = 63, .external_lex_state = 4},
  [1368] = {.lex_state = 62, .external_lex_state = 2},
  [1369] = {.lex_state = 62, .external_lex_state = 2},
  [1370] = {.lex_state = 62, .external_lex_state = 2},
  [1371] = {.lex_state = 63, .external_lex_state = 4},
  [1372] = {.lex_state = 62, .external_lex_state = 2},
  [1373] = {.lex_state = 62, .external_lex_state = 3},
  [1374] = {.lex_state = 63},
  [1375] = {.lex_state = 63},
  [1376] = {.lex_state = 8, .external_lex_state = 2},
  [1377] = {.lex_state = 8, .external_lex_state = 3},
  [1378] = {.lex_state = 62, .external_lex_state = 2},
  [1379] = {.lex_state = 9, .external_lex_state = 3},
  [1380] = {.lex_state = 62, .external_lex_state = 2},
  [1381] = {.lex_state = 62, .external_lex_state = 2},
  [1382] = {.lex_state = 62, .external_lex_state = 2},
  [1383] = {.lex_state = 62, .external_lex_state = 2},
  [1384] = {.lex_state = 62, .external_lex_state = 2},
  [1385] = {.lex_state = 62, .external_lex_state = 2},
  [1386] = {.lex_state = 62, .external_lex_state = 2},
  [1387] = {.lex_state = 62, .external_lex_state = 2},
  [1388] = {.lex_state = 62, .external_lex_state = 2},
  [1389] = {.lex_state = 62, .external_lex_state = 2},
  [1390] = {.lex_state = 62, .external_lex_state = 2},
  [1391] = {.lex_state = 62, .external_lex_state = 2},
  [1392] = {.lex_state = 62, .external_lex_state = 2},
  [1393] = {.lex_state = 62, .external_lex_state = 2},
  [1394] = {.lex_state = 62, .external_lex_state = 2},
  [1395] = {.lex_state = 62, .external_lex_state = 2},
  [1396] = {.lex_state = 62, .external_lex_state = 2},
  [1397] = {.lex_state = 62, .external_lex_state = 2},
  [1398] = {.lex_state = 63, .external_lex_state = 4},
  [1399] = {.lex_state = 62, .external_lex_state = 2},
  [1400] = {.lex_state = 62, .external_lex_state = 2},
  [1401] = {.lex_state = 8, .external_lex_state = 3},
  [1402] = {.lex_state = 62, .external_lex_state = 2},
  [1403] = {.lex_state = 62, .external_lex_state = 2},
  [1404] = {.lex_state = 62, .external_lex_state = 2},
  [1405] = {.lex_state = 62, .external_lex_state = 2},
  [1406] = {.lex_state = 8, .external_lex_state = 3},
  [1407] = {.lex_state = 62, .external_lex_state = 2},
  [1408] = {.lex_state = 62, .external_lex_state = 2},
  [1409] = {.lex_state = 62, .external_lex_state = 3},
  [1410] = {.lex_state = 62, .external_lex_state = 3},
  [1411] = {.lex_state = 62, .external_lex_state = 2},
  [1412] = {.lex_state = 8, .external_lex_state = 3},
  [1413] = {.lex_state = 62, .external_lex_state = 3},
  [1414] = {.lex_state = 62, .external_lex_state = 2},
  [1415] = {.lex_state = 8, .external_lex_state = 3},
  [1416] = {.lex_state = 62, .external_lex_state = 2},
  [1417] = {.lex_state = 62, .external_lex_state = 3},
  [1418] = {.lex_state = 8, .external_lex_state = 3},
  [1419] = {.lex_state = 62, .external_lex_state = 3},
  [1420] = {.lex_state = 8, .external_lex_state = 3},
  [1421] = {.lex_state = 62, .external_lex_state = 3},
  [1422] = {.lex_state = 62, .external_lex_state = 3},
  [1423] = {.lex_state = 62, .external_lex_state = 3},
  [1424] = {.lex_state = 63, .external_lex_state = 4},
  [1425] = {.lex_state = 63, .external_lex_state = 4},
  [1426] = {.lex_state = 8, .external_lex_state = 3},
  [1427] = {.lex_state = 62, .external_lex_state = 2},
  [1428] = {.lex_state = 8, .external_lex_state = 3},
  [1429] = {.lex_state = 63, .external_lex_state = 4},
  [1430] = {.lex_state = 62, .external_lex_state = 2},
  [1431] = {.lex_state = 8, .external_lex_state = 3},
  [1432] = {.lex_state = 62, .external_lex_state = 2},
  [1433] = {.lex_state = 62, .external_lex_state = 3},
  [1434] = {.lex_state = 8, .external_lex_state = 3},
  [1435] = {.lex_state = 62, .external_lex_state = 2},
  [1436] = {.lex_state = 62, .external_lex_state = 2},
  [1437] = {.lex_state = 62, .external_lex_state = 2},
  [1438] = {.lex_state = 62, .external_lex_state = 2},
  [1439] = {.lex_state = 62, .external_lex_state = 2},
  [1440] = {.lex_state = 62, .external_lex_state = 2},
  [1441] = {.lex_state = 62, .external_lex_state = 2},
  [1442] = {.lex_state = 62, .external_lex_state = 2},
  [1443] = {.lex_state = 8, .external_lex_state = 3},
  [1444] = {.lex_state = 62, .external_lex_state = 2},
  [1445] = {.lex_state = 62, .external_lex_state = 2},
  [1446] = {.lex_state = 62, .external_lex_state = 2},
  [1447] = {.lex_state = 8, .external_lex_state = 3},
  [1448] = {.lex_state = 11, .external_lex_state = 3},
  [1449] = {.lex_state = 8, .external_lex_state = 3},
  [1450] = {.lex_state = 62, .external_lex_state = 2},
  [1451] = {.lex_state = 62, .external_lex_state = 2},
  [1452] = {.lex_state = 62, .external_lex_state = 2},
  [1453] = {.lex_state = 63, .external_lex_state = 4},
  [1454] = {.lex_state = 62, .external_lex_state = 2},
  [1455] = {.lex_state = 62, .external_lex_state = 3},
  [1456] = {.lex_state = 62, .external_lex_state = 2},
  [1457] = {.lex_state = 62, .external_lex_state = 2},
  [1458] = {.lex_state = 62, .external_lex_state = 2},
  [1459] = {.lex_state = 62, .external_lex_state = 2},
  [1460] = {.lex_state = 62, .external_lex_state = 2},
  [1461] = {.lex_state = 62, .external_lex_state = 2},
  [1462] = {.lex_state = 63, .external_lex_state = 4},
  [1463] = {.lex_state = 8, .external_lex_state = 3},
  [1464] = {.lex_state = 62, .external_lex_state = 3},
  [1465] = {.lex_state = 62, .external_lex_state = 2},
  [1466] = {.lex_state = 62, .external_lex_state = 2},
  [1467] = {.lex_state = 62, .external_lex_state = 3},
  [1468] = {.lex_state = 62, .external_lex_state = 2},
  [1469] = {.lex_state = 62, .external_lex_state = 3},
  [1470] = {.lex_state = 62, .external_lex_state = 2},
  [1471] = {.lex_state = 63, .external_lex_state = 4},
  [1472] = {.lex_state = 62, .external_lex_state = 2},
  [1473] = {.lex_state = 62, .external_lex_state = 2},
  [1474] = {.lex_state = 62, .external_lex_state = 2},
  [1475] = {.lex_state = 62, .external_lex_state = 2},
  [1476] = {.lex_state = 62, .external_lex_state = 2},
  [1477] = {.lex_state = 62, .external_lex_state = 2},
  [1478] = {.lex_state = 62, .external_lex_state = 2},
  [1479] = {.lex_state = 62, .external_lex_state = 2},
  [1480] = {.lex_state = 62, .external_lex_state = 2},
  [1481] = {.lex_state = 62, .external_lex_state = 2},
  [1482] = {.lex_state = 62, .external_lex_state = 2},
  [1483] = {.lex_state = 62, .external_lex_state = 2},
  [1484] = {.lex_state = 62, .external_lex_state = 2},
  [1485] = {.lex_state = 62, .external_lex_state = 2},
  [1486] = {.lex_state = 62, .external_lex_state = 2},
  [1487] = {.lex_state = 62, .external_lex_state = 3},
  [1488] = {.lex_state = 63, .external_lex_state = 4},
  [1489] = {.lex_state = 62, .external_lex_state = 2},
  [1490] = {.lex_state = 62, .external_lex_state = 2},
  [1491] = {.lex_state = 62, .external_lex_state = 2},
  [1492] = {.lex_state = 62, .external_lex_state = 3},
  [1493] = {.lex_state = 62, .external_lex_state = 2},
  [1494] = {.lex_state = 63, .external_lex_state = 4},
  [1495] = {.lex_state = 62, .external_lex_state = 2},
  [1496] = {.lex_state = 62, .external_lex_state = 2},
  [1497] = {.lex_state = 62, .external_lex_state = 2},
  [1498] = {.lex_state = 62, .external_lex_state = 2},
  [1499] = {.lex_state = 62, .external_lex_state = 2},
  [1500] = {.lex_state = 62, .external_lex_state = 2},
  [1501] = {.lex_state = 62, .external_lex_state = 3},
  [1502] = {.lex_state = 62, .external_lex_state = 3},
  [1503] = {.lex_state = 62, .external_lex_state = 2},
  [1504] = {.lex_state = 62, .external_lex_state = 3},
  [1505] = {.lex_state = 8, .external_lex_state = 2},
  [1506] = {.lex_state = 62, .external_lex_state = 2},
  [1507] = {.lex_state = 62, .external_lex_state = 3},
  [1508] = {.lex_state = 62, .external_lex_state = 2},
  [1509] = {.lex_state = 8, .external_lex_state = 3},
  [1510] = {.lex_state = 63, .external_lex_state = 4},
  [1511] = {.lex_state = 8, .external_lex_state = 3},
  [1512] = {.lex_state = 8, .external_lex_state = 3},
  [1513] = {.lex_state = 8, .external_lex_state = 3},
  [1514] = {.lex_state = 8, .external_lex_state = 3},
  [1515] = {.lex_state = 8, .external_lex_state = 3},
  [1516] = {.lex_state = 8, .external_lex_state = 3},
  [1517] = {.lex_state = 62, .external_lex_state = 3},
  [1518] = {.lex_state = 8, .external_lex_state = 3},
  [1519] = {.lex_state = 63, .external_lex_state = 4},
  [1520] = {.lex_state = 63, .external_lex_state = 4},
  [1521] = {.lex_state = 8, .external_lex_state = 3},
  [1522] = {.lex_state = 8, .external_lex_state = 3},
  [1523] = {.lex_state = 8, .external_lex_state = 3},
  [1524] = {.lex_state = 8, .external_lex_state = 3},
  [1525] = {.lex_state = 62, .external_lex_state = 3},
  [1526] = {.lex_state = 8, .external_lex_state = 3},
  [1527] = {.lex_state = 62, .external_lex_state = 3},
  [1528] = {.lex_state = 8, .external_lex_state = 3},
  [1529] = {.lex_state = 8, .external_lex_state = 3},
  [1530] = {.lex_state = 8, .external_lex_state = 3},
  [1531] = {.lex_state = 8, .external_lex_state = 3},
  [1532] = {.lex_state = 8, .external_lex_state = 3},
  [1533] = {.lex_state = 63, .external_lex_state = 4},
  [1534] = {.lex_state = 8, .external_lex_state = 3},
  [1535] = {.lex_state = 8, .external_lex_state = 3},
  [1536] = {.lex_state = 63, .external_lex_state = 4},
  [1537] = {.lex_state = 8, .external_lex_state = 3},
  [1538] = {.lex_state = 8, .external_lex_state = 3},
  [1539] = {.lex_state = 63, .external_lex_state = 4},
  [1540] = {.lex_state = 8, .external_lex_state = 3},
  [1541] = {.lex_state = 8, .external_lex_state = 3},
  [1542] = {.lex_state = 8, .external_lex_state = 3},
  [1543] = {.lex_state = 8, .external_lex_state = 3},
  [1544] = {.lex_state = 8, .external_lex_state = 3},
  [1545] = {.lex_state = 8, .external_lex_state = 3},
  [1546] = {.lex_state = 62, .external_lex_state = 3},
  [1547] = {.lex_state = 8, .external_lex_state = 3},
  [1548] = {.lex_state = 8, .external_lex_state = 3},
  [1549] = {.lex_state = 8, .external_lex_state = 3},
  [1550] = {.lex_state = 62, .external_lex_state = 3},
  [1551] = {.lex_state = 8, .external_lex_state = 3},
  [1552] = {.lex_state = 8, .external_lex_state = 3},
  [1553] = {.lex_state = 8, .external_lex_state = 3},
  [1554] = {.lex_state = 8, .external_lex_state = 3},
  [1555] = {.lex_state = 8, .external_lex_state = 3},
  [1556] = {.lex_state = 8, .external_lex_state = 3},
  [1557] = {.lex_state = 63, .external_lex_state = 4},
  [1558] = {.lex_state = 8, .external_lex_state = 3},
  [1559] = {.lex_state = 8, .external_lex_state = 3},
  [1560] = {.lex_state = 62, .external_lex_state = 3},
  [1561] = {.lex_state = 62, .external_lex_state = 2},
  [1562] = {.lex_state = 8, .external_lex_state = 3},
  [1563] = {.lex_state = 62, .external_lex_state = 2},
  [1564] = {.lex_state = 62, .external_lex_state = 3},
  [1565] = {.lex_state = 8, .external_lex_state = 3},
  [1566] = {.lex_state = 63, .external_lex_state = 4},
  [1567] = {.lex_state = 8, .external_lex_state = 3},
  [1568] = {.lex_state = 8, .external_lex_state = 3},
  [1569] = {.lex_state = 8, .external_lex_state = 3},
  [1570] = {.lex_state = 63, .external_lex_state = 4},
  [1571] = {.lex_state = 8, .external_lex_state = 3},
  [1572] = {.lex_state = 8, .external_lex_state = 3},
  [1573] = {.lex_state = 8, .external_lex_state = 3},
  [1574] = {.lex_state = 8, .external_lex_state = 3},
  [1575] = {.lex_state = 8, .external_lex_state = 3},
  [1576] = {.lex_state = 8, .external_lex_state = 3},
  [1577] = {.lex_state = 8, .external_lex_state = 3},
  [1578] = {.lex_state = 63, .external_lex_state = 4},
  [1579] = {.lex_state = 63, .external_lex_state = 4},
  [1580] = {.lex_state = 8, .external_lex_state = 3},
  [1581] = {.lex_state = 62, .external_lex_state = 2},
  [1582] = {.lex_state = 8, .external_lex_state = 3},
  [1583] = {.lex_state = 62, .external_lex_state = 3},
  [1584] = {.lex_state = 63, .external_lex_state = 4},
  [1585] = {.lex_state = 8, .external_lex_state = 3},
  [1586] = {.lex_state = 62, .external_lex_state = 2},
  [1587] = {.lex_state = 8, .external_lex_state = 3},
  [1588] = {.lex_state = 8, .external_lex_state = 3},
  [1589] = {.lex_state = 8, .external_lex_state = 3},
  [1590] = {.lex_state = 8, .external_lex_state = 3},
  [1591] = {.lex_state = 62, .external_lex_state = 3},
  [1592] = {.lex_state = 8, .external_lex_state = 3},
  [1593] = {.lex_state = 8, .external_lex_state = 3},
  [1594] = {.lex_state = 63, .external_lex_state = 4},
  [1595] = {.lex_state = 8, .external_lex_state = 3},
  [1596] = {.lex_state = 8, .external_lex_state = 3},
  [1597] = {.lex_state = 8, .external_lex_state = 3},
  [1598] = {.lex_state = 8, .external_lex_state = 3},
  [1599] = {.lex_state = 8, .external_lex_state = 3},
  [1600] = {.lex_state = 8, .external_lex_state = 3},
  [1601] = {.lex_state = 63, .external_lex_state = 4},
  [1602] = {.lex_state = 8, .external_lex_state = 3},
  [1603] = {.lex_state = 63, .external_lex_state = 4},
  [1604] = {.lex_state = 8, .external_lex_state = 3},
  [1605] = {.lex_state = 8, .external_lex_state = 3},
  [1606] = {.lex_state = 63, .external_lex_state = 4},
  [1607] = {.lex_state = 8, .external_lex_state = 3},
  [1608] = {.lex_state = 63, .external_lex_state = 4},
  [1609] = {.lex_state = 8, .external_lex_state = 3},
  [1610] = {.lex_state = 62, .external_lex_state = 3},
  [1611] = {.lex_state = 63, .external_lex_state = 4},
  [1612] = {.lex_state = 63, .external_lex_state = 4},
  [1613] = {.lex_state = 63, .external_lex_state = 4},
  [1614] = {.lex_state = 8, .external_lex_state = 3},
  [1615] = {.lex_state = 62, .external_lex_state = 3},
  [1616] = {.lex_state = 8, .external_lex_state = 3},
  [1617] = {.lex_state = 8, .external_lex_state = 3},
  [1618] = {.lex_state = 63, .external_lex_state = 4},
  [1619] = {.lex_state = 62, .external_lex_state = 3},
  [1620] = {.lex_state = 8, .external_lex_state = 3},
  [1621] = {.lex_state = 8, .external_lex_state = 3},
  [1622] = {.lex_state = 8, .external_lex_state = 3},
  [1623] = {.lex_state = 8, .external_lex_state = 3},
  [1624] = {.lex_state = 8, .external_lex_state = 3},
  [1625] = {.lex_state = 8, .external_lex_state = 3},
  [1626] = {.lex_state = 63, .external_lex_state = 4},
  [1627] = {.lex_state = 8, .external_lex_state = 3},
  [1628] = {.lex_state = 8, .external_lex_state = 3},
  [1629] = {.lex_state = 8, .external_lex_state = 3},
  [1630] = {.lex_state = 8, .external_lex_state = 3},
  [1631] = {.lex_state = 8, .external_lex_state = 3},
  [1632] = {.lex_state = 8, .external_lex_state = 3},
  [1633] = {.lex_state = 8, .external_lex_state = 3},
  [1634] = {.lex_state = 8, .external_lex_state = 3},
  [1635] = {.lex_state = 63, .external_lex_state = 4},
  [1636] = {.lex_state = 8, .external_lex_state = 3},
  [1637] = {.lex_state = 8, .external_lex_state = 3},
  [1638] = {.lex_state = 8, .external_lex_state = 3},
  [1639] = {.lex_state = 8, .external_lex_state = 3},
  [1640] = {.lex_state = 63, .external_lex_state = 4},
  [1641] = {.lex_state = 63, .external_lex_state = 4},
  [1642] = {.lex_state = 63, .external_lex_state = 4},
  [1643] = {.lex_state = 62, .external_lex_state = 3},
  [1644] = {.lex_state = 63, .external_lex_state = 4},
  [1645] = {.lex_state = 62, .external_lex_state = 3},
  [1646] = {.lex_state = 63, .external_lex_state = 4},
  [1647] = {.lex_state = 63},
  [1648] = {.lex_state = 62, .external_lex_state = 3},
  [1649] = {.lex_state = 63},
  [1650] = {.lex_state = 63, .external_lex_state = 4},
  [1651] = {.lex_state = 63, .external_lex_state = 4},
  [1652] = {.lex_state = 63, .external_lex_state = 4},
  [1653] = {.lex_state = 63},
  [1654] = {.lex_state = 63, .external_lex_state = 4},
  [1655] = {.lex_state = 63},
  [1656] = {.lex_state = 62, .external_lex_state = 3},
  [1657] = {.lex_state = 62, .external_lex_state = 3},
  [1658] = {.lex_state = 63, .external_lex_state = 4},
  [1659] = {.lex_state = 63, .external_lex_state = 4},
  [1660] = {.lex_state = 62, .external_lex_state = 3},
  [1661] = {.lex_state = 63},
  [1662] = {.lex_state = 63, .external_lex_state = 4},
  [1663] = {.lex_state = 63},
  [1664] = {.lex_state = 63},
  [1665] = {.lex_state = 63},
  [1666] = {.lex_state = 63},
  [1667] = {.lex_state = 63, .external_lex_state = 4},
  [1668] = {.lex_state = 63, .external_lex_state = 4},
  [1669] = {.lex_state = 63},
  [1670] = {.lex_state = 63, .external_lex_state = 4},
  [1671] = {.lex_state = 63},
  [1672] = {.lex_state = 63},
  [1673] = {.lex_state = 63, .external_lex_state = 4},
  [1674] = {.lex_state = 63},
  [1675] = {.lex_state = 63},
  [1676] = {.lex_state = 63, .external_lex_state = 4},
  [1677] = {.lex_state = 62, .external_lex_state = 3},
  [1678] = {.lex_state = 63},
  [1679] = {.lex_state = 63, .external_lex_state = 4},
  [1680] = {.lex_state = 63, .external_lex_state = 4},
  [1681] = {.lex_state = 63, .external_lex_state = 4},
  [1682] = {.lex_state = 63, .external_lex_state = 4},
  [1683] = {.lex_state = 63},
  [1684] = {.lex_state = 63},
  [1685] = {.lex_state = 63},
  [1686] = {.lex_state = 63, .external_lex_state = 4},
  [1687] = {.lex_state = 63},
  [1688] = {.lex_state = 63},
  [1689] = {.lex_state = 63},
  [1690] = {.lex_state = 63},
  [1691] = {.lex_state = 63},
  [1692] = {.lex_state = 63},
  [1693] = {.lex_state = 63},
  [1694] = {.lex_state = 63},
  [1695] = {.lex_state = 63},
  [1696] = {.lex_state = 63},
  [1697] = {.lex_state = 63},
  [1698] = {.lex_state = 63},
  [1699] = {.lex_state = 63},
  [1700] = {.lex_state = 63},
  [1701] = {.lex_state = 63},
  [1702] = {.lex_state = 63},
  [1703] = {.lex_state = 63},
  [1704] = {.lex_state = 63},
  [1705] = {.lex_state = 63},
  [1706] = {.lex_state = 63},
  [1707] = {.lex_state = 63},
  [1708] = {.lex_state = 63},
  [1709] = {.lex_state = 63},
  [1710] = {.lex_state = 63},
  [1711] = {.lex_state = 63},
  [1712] = {.lex_state = 63},
  [1713] = {.lex_state = 63},
  [1714] = {.lex_state = 63},
  [1715] = {.lex_state = 63},
  [1716] = {.lex_state = 63},
  [1717] = {.lex_state = 63},
  [1718] = {.lex_state = 63},
  [1719] = {.lex_state = 63},
  [1720] = {.lex_state = 63},
  [1721] = {.lex_state = 63},
  [1722] = {.lex_state = 63},
  [1723] = {.lex_state = 63},
  [1724] = {.lex_state = 63},
  [1725] = {.lex_state = 63},
  [1726] = {.lex_state = 63},
  [1727] = {.lex_state = 63},
  [1728] = {.lex_state = 63},
  [1729] = {.lex_state = 63},
  [1730] = {.lex_state = 63},
  [1731] = {.lex_state = 63},
  [1732] = {.lex_state = 63},
  [1733] = {.lex_state = 63},
  [1734] = {.lex_state = 63},
  [1735] = {.lex_state = 63},
  [1736] = {.lex_state = 63, .external_lex_state = 4},
  [1737] = {.lex_state = 63},
  [1738] = {.lex_state = 63},
  [1739] = {.lex_state = 63},
  [1740] = {.lex_state = 63, .external_lex_state = 4},
  [1741] = {.lex_state = 63},
  [1742] = {.lex_state = 63},
  [1743] = {.lex_state = 63, .external_lex_state = 4},
  [1744] = {.lex_state = 63},
  [1745] = {.lex_state = 63},
  [1746] = {.lex_state = 63, .external_lex_state = 4},
  [1747] = {.lex_state = 63},
  [1748] = {.lex_state = 63},
  [1749] = {.lex_state = 63},
  [1750] = {.lex_state = 63},
  [1751] = {.lex_state = 63},
  [1752] = {.lex_state = 63},
  [1753] = {.lex_state = 63, .external_lex_state = 4},
  [1754] = {.lex_state = 63, .external_lex_state = 4},
  [1755] = {.lex_state = 63, .external_lex_state = 4},
  [1756] = {.lex_state = 63},
  [1757] = {.lex_state = 63, .external_lex_state = 4},
  [1758] = {.lex_state = 63, .external_lex_state = 4},
  [1759] = {.lex_state = 63},
  [1760] = {.lex_state = 63, .external_lex_state = 4},
  [1761] = {.lex_state = 63, .external_lex_state = 4},
  [1762] = {.lex_state = 63, .external_lex_state = 4},
  [1763] = {.lex_state = 63, .external_lex_state = 4},
  [1764] = {.lex_state = 63, .external_lex_state = 4},
  [1765] = {.lex_state = 63, .external_lex_state = 4},
  [1766] = {.lex_state = 63, .external_lex_state = 4},
  [1767] = {.lex_state = 63},
  [1768] = {.lex_state = 63},
  [1769] = {.lex_state = 63, .external_lex_state = 4},
  [1770] = {.lex_state = 63},
  [1771] = {.lex_state = 63},
  [1772] = {.lex_state = 63},
  [1773] = {.lex_state = 63},
  [1774] = {.lex_state = 63},
  [1775] = {.lex_state = 63},
  [1776] = {.lex_state = 63},
  [1777] = {.lex_state = 63},
  [1778] = {.lex_state = 63},
  [1779] = {.lex_state = 63},
  [1780] = {.lex_state = 63},
  [1781] = {.lex_state = 63},
  [1782] = {.lex_state = 63},
  [1783] = {.lex_state = 63},
  [1784] = {.lex_state = 63},
  [1785] = {.lex_state = 63},
  [1786] = {.lex_state = 63},
  [1787] = {.lex_state = 63},
  [1788] = {.lex_state = 63},
  [1789] = {.lex_state = 63},
  [1790] = {.lex_state = 63},
  [1791] = {.lex_state = 63},
  [1792] = {.lex_state = 63},
  [1793] = {.lex_state = 63},
  [1794] = {.lex_state = 63},
  [1795] = {.lex_state = 63},
  [1796] = {.lex_state = 63},
  [1797] = {.lex_state = 63},
  [1798] = {.lex_state = 63},
  [1799] = {.lex_state = 63},
  [1800] = {.lex_state = 63},
  [1801] = {.lex_state = 63},
  [1802] = {.lex_state = 63},
  [1803] = {.lex_state = 63},
  [1804] = {.lex_state = 63},
  [1805] = {.lex_state = 63},
  [1806] = {.lex_state = 63},
  [1807] = {.lex_state = 63},
  [1808] = {.lex_state = 63},
  [1809] = {.lex_state = 63},
  [1810] = {.lex_state = 63},
  [1811] = {.lex_state = 63},
  [1812] = {.lex_state = 63},
  [1813] = {.lex_state = 63},
  [1814] = {.lex_state = 63, .external_lex_state = 4},
  [1815] = {.lex_state = 63, .external_lex_state = 4},
  [1816] = {.lex_state = 63},
  [1817] = {.lex_state = 63, .external_lex_state = 4},
  [1818] = {.lex_state = 63, .external_lex_state = 4},
  [1819] = {.lex_state = 63, .external_lex_state = 4},
  [1820] = {.lex_state = 63, .external_lex_state = 4},
  [1821] = {.lex_state = 63, .external_lex_state = 4},
  [1822] = {.lex_state = 63, .external_lex_state = 4},
  [1823] = {.lex_state = 63},
  [1824] = {.lex_state = 63, .external_lex_state = 4},
  [1825] = {.lex_state = 63, .external_lex_state = 4},
  [1826] = {.lex_state = 63, .external_lex_state = 4},
  [1827] = {.lex_state = 63, .external_lex_state = 4},
  [1828] = {.lex_state = 63, .external_lex_state = 4},
  [1829] = {.lex_state = 63, .external_lex_state = 4},
  [1830] = {.lex_state = 63, .external_lex_state = 4},
  [1831] = {.lex_state = 63, .external_lex_state = 4},
  [1832] = {.lex_state = 63, .external_lex_state = 4},
  [1833] = {.lex_state = 63},
  [1834] = {.lex_state = 63, .external_lex_state = 4},
  [1835] = {.lex_state = 63, .external_lex_state = 4},
  [1836] = {.lex_state = 63, .external_lex_state = 4},
  [1837] = {.lex_state = 63, .external_lex_state = 4},
  [1838] = {.lex_state = 63, .external_lex_state = 4},
  [1839] = {.lex_state = 63, .external_lex_state = 4},
  [1840] = {.lex_state = 63},
  [1841] = {.lex_state = 63, .external_lex_state = 4},
  [1842] = {.lex_state = 63, .external_lex_state = 4},
  [1843] = {.lex_state = 63, .external_lex_state = 4},
  [1844] = {.lex_state = 63, .external_lex_state = 4},
  [1845] = {.lex_state = 63},
  [1846] = {.lex_state = 63, .external_lex_state = 4},
  [1847] = {.lex_state = 63, .external_lex_state = 4},
  [1848] = {.lex_state = 63},
  [1849] = {.lex_state = 63, .external_lex_state = 4},
  [1850] = {.lex_state = 63},
  [1851] = {.lex_state = 63, .external_lex_state = 4},
  [1852] = {.lex_state = 63},
  [1853] = {.lex_state = 63, .external_lex_state = 4},
  [1854] = {.lex_state = 63, .external_lex_state = 4},
  [1855] = {.lex_state = 63, .external_lex_state = 4},
  [1856] = {.lex_state = 63, .external_lex_state = 4},
  [1857] = {.lex_state = 63, .external_lex_state = 4},
  [1858] = {.lex_state = 63, .external_lex_state = 4},
  [1859] = {.lex_state = 63, .external_lex_state = 4},
  [1860] = {.lex_state = 63, .external_lex_state = 4},
  [1861] = {.lex_state = 63, .external_lex_state = 4},
  [1862] = {.lex_state = 63, .external_lex_state = 4},
  [1863] = {.lex_state = 63, .external_lex_state = 4},
  [1864] = {.lex_state = 63, .external_lex_state = 4},
  [1865] = {.lex_state = 63},
  [1866] = {.lex_state = 63},
  [1867] = {.lex_state = 63},
  [1868] = {.lex_state = 63, .external_lex_state = 4},
  [1869] = {.lex_state = 63, .external_lex_state = 4},
  [1870] = {.lex_state = 63, .external_lex_state = 4},
  [1871] = {.lex_state = 63, .external_lex_state = 4},
  [1872] = {.lex_state = 63},
  [1873] = {.lex_state = 63},
  [1874] = {.lex_state = 63, .external_lex_state = 4},
  [1875] = {.lex_state = 63, .external_lex_state = 4},
  [1876] = {.lex_state = 63},
  [1877] = {.lex_state = 63},
  [1878] = {.lex_state = 63, .external_lex_state = 4},
  [1879] = {.lex_state = 63, .external_lex_state = 4},
  [1880] = {.lex_state = 63},
  [1881] = {.lex_state = 63, .external_lex_state = 4},
  [1882] = {.lex_state = 63, .external_lex_state = 4},
  [1883] = {.lex_state = 63, .external_lex_state = 4},
  [1884] = {.lex_state = 63},
  [1885] = {.lex_state = 63, .external_lex_state = 4},
  [1886] = {.lex_state = 63, .external_lex_state = 4},
  [1887] = {.lex_state = 63},
  [1888] = {.lex_state = 63, .external_lex_state = 4},
  [1889] = {.lex_state = 63, .external_lex_state = 4},
  [1890] = {.lex_state = 63, .external_lex_state = 4},
  [1891] = {.lex_state = 63},
  [1892] = {.lex_state = 63, .external_lex_state = 4},
  [1893] = {.lex_state = 63, .external_lex_state = 4},
  [1894] = {.lex_state = 63, .external_lex_state = 4},
  [1895] = {.lex_state = 63, .external_lex_state = 4},
  [1896] = {.lex_state = 63, .external_lex_state = 4},
  [1897] = {.lex_state = 63, .external_lex_state = 4},
  [1898] = {.lex_state = 63, .external_lex_state = 4},
  [1899] = {.lex_state = 63, .external_lex_state = 4},
  [1900] = {.lex_state = 63, .external_lex_state = 4},
  [1901] = {.lex_state = 63, .external_lex_state = 4},
  [1902] = {.lex_state = 63, .external_lex_state = 4},
  [1903] = {.lex_state = 63, .external_lex_state = 4},
  [1904] = {.lex_state = 63, .external_lex_state = 4},
  [1905] = {.lex_state = 63, .external_lex_state = 4},
  [1906] = {.lex_state = 63, .external_lex_state = 4},
  [1907] = {.lex_state = 63, .external_lex_state = 4},
  [1908] = {.lex_state = 63},
  [1909] = {.lex_state = 63, .external_lex_state = 4},
  [1910] = {.lex_state = 63},
  [1911] = {.lex_state = 63},
  [1912] = {.lex_state = 63},
  [1913] = {.lex_state = 63},
  [1914] = {.lex_state = 63},
  [1915] = {.lex_state = 63},
  [1916] = {.lex_state = 63},
  [1917] = {.lex_state = 63, .external_lex_state = 4},
  [1918] = {.lex_state = 63},
  [1919] = {.lex_state = 63},
  [1920] = {.lex_state = 63},
  [1921] = {.lex_state = 63, .external_lex_state = 4},
  [1922] = {.lex_state = 63},
  [1923] = {.lex_state = 63},
  [1924] = {.lex_state = 63},
  [1925] = {.lex_state = 63},
  [1926] = {.lex_state = 63},
  [1927] = {.lex_state = 63},
  [1928] = {.lex_state = 63},
  [1929] = {.lex_state = 63},
  [1930] = {.lex_state = 63},
  [1931] = {.lex_state = 63},
  [1932] = {.lex_state = 63, .external_lex_state = 4},
  [1933] = {.lex_state = 63},
  [1934] = {.lex_state = 63},
  [1935] = {.lex_state = 63, .external_lex_state = 4},
  [1936] = {.lex_state = 63, .external_lex_state = 4},
  [1937] = {.lex_state = 63},
  [1938] = {.lex_state = 63},
  [1939] = {.lex_state = 63},
  [1940] = {.lex_state = 63},
  [1941] = {.lex_state = 63},
  [1942] = {.lex_state = 63, .external_lex_state = 4},
  [1943] = {.lex_state = 0, .external_lex_state = 4},
  [1944] = {.lex_state = 0, .external_lex_state = 4},
  [1945] = {.lex_state = 63},
  [1946] = {.lex_state = 63},
  [1947] = {.lex_state = 63},
  [1948] = {.lex_state = 63},
  [1949] = {.lex_state = 63},
  [1950] = {.lex_state = 63},
  [1951] = {.lex_state = 63},
  [1952] = {.lex_state = 63},
  [1953] = {.lex_state = 63, .external_lex_state = 4},
  [1954] = {.lex_state = 63},
  [1955] = {.lex_state = 0, .external_lex_state = 4},
  [1956] = {.lex_state = 63},
  [1957] = {.lex_state = 63},
  [1958] = {.lex_state = 63},
  [1959] = {.lex_state = 63},
  [1960] = {.lex_state = 63},
  [1961] = {.lex_state = 63},
  [1962] = {.lex_state = 14},
  [1963] = {.lex_state = 63},
  [1964] = {.lex_state = 63},
  [1965] = {.lex_state = 63},
  [1966] = {.lex_state = 63, .external_lex_state = 4},
  [1967] = {.lex_state = 63},
  [1968] = {.lex_state = 0, .external_lex_state = 4},
  [1969] = {.lex_state = 63, .external_lex_state = 4},
  [1970] = {.lex_state = 63},
  [1971] = {.lex_state = 63, .external_lex_state = 4},
  [1972] = {.lex_state = 63},
  [1973] = {.lex_state = 63},
  [1974] = {.lex_state = 63},
  [1975] = {.lex_state = 63},
  [1976] = {.lex_state = 63},
  [1977] = {.lex_state = 63},
  [1978] = {.lex_state = 63},
  [1979] = {.lex_state = 63},
  [1980] = {.lex_state = 0, .external_lex_state = 4},
  [1981] = {.lex_state = 0, .external_lex_state = 4},
  [1982] = {.lex_state = 0, .external_lex_state = 4},
  [1983] = {.lex_state = 63, .external_lex_state = 4},
  [1984] = {.lex_state = 63, .external_lex_state = 4},
  [1985] = {.lex_state = 63, .external_lex_state = 4},
  [1986] = {.lex_state = 63},
  [1987] = {.lex_state = 63, .external_lex_state = 4},
  [1988] = {.lex_state = 63},
  [1989] = {.lex_state = 63, .external_lex_state = 4},
  [1990] = {.lex_state = 63, .external_lex_state = 4},
  [1991] = {.lex_state = 63},
  [1992] = {.lex_state = 0, .external_lex_state = 4},
  [1993] = {.lex_state = 63},
  [1994] = {.lex_state = 63, .external_lex_state = 4},
  [1995] = {.lex_state = 63},
  [1996] = {.lex_state = 63},
  [1997] = {.lex_state = 63},
  [1998] = {.lex_state = 63, .external_lex_state = 4},
  [1999] = {.lex_state = 63, .external_lex_state = 4},
  [2000] = {.lex_state = 63, .external_lex_state = 4},
  [2001] = {.lex_state = 63},
  [2002] = {.lex_state = 14},
  [2003] = {.lex_state = 63},
  [2004] = {.lex_state = 63},
  [2005] = {.lex_state = 63, .external_lex_state = 4},
  [2006] = {.lex_state = 63},
  [2007] = {.lex_state = 63, .external_lex_state = 4},
  [2008] = {.lex_state = 0, .external_lex_state = 4},
  [2009] = {.lex_state = 63, .external_lex_state = 4},
  [2010] = {.lex_state = 63, .external_lex_state = 4},
  [2011] = {.lex_state = 63},
  [2012] = {.lex_state = 18, .external_lex_state = 5},
  [2013] = {.lex_state = 63},
  [2014] = {.lex_state = 63},
  [2015] = {.lex_state = 63},
  [2016] = {.lex_state = 63},
  [2017] = {.lex_state = 0, .external_lex_state = 4},
  [2018] = {.lex_state = 63},
  [2019] = {.lex_state = 63},
  [2020] = {.lex_state = 63},
  [2021] = {.lex_state = 63},
  [2022] = {.lex_state = 63},
  [2023] = {.lex_state = 63},
  [2024] = {.lex_state = 63},
  [2025] = {.lex_state = 0, .external_lex_state = 4},
  [2026] = {.lex_state = 0, .external_lex_state = 4},
  [2027] = {.lex_state = 18, .external_lex_state = 5},
  [2028] = {.lex_state = 0, .external_lex_state = 4},
  [2029] = {.lex_state = 63},
  [2030] = {.lex_state = 63},
  [2031] = {.lex_state = 18, .external_lex_state = 5},
  [2032] = {.lex_state = 63},
  [2033] = {.lex_state = 63, .external_lex_state = 4},
  [2034] = {.lex_state = 63},
  [2035] = {.lex_state = 63},
  [2036] = {.lex_state = 0, .external_lex_state = 4},
  [2037] = {.lex_state = 63},
  [2038] = {.lex_state = 63},
  [2039] = {.lex_state = 63},
  [2040] = {.lex_state = 63},
  [2041] = {.lex_state = 63},
  [2042] = {.lex_state = 18, .external_lex_state = 5},
  [2043] = {.lex_state = 63},
  [2044] = {.lex_state = 63},
  [2045] = {.lex_state = 0, .external_lex_state = 4},
  [2046] = {.lex_state = 63},
  [2047] = {.lex_state = 63},
  [2048] = {.lex_state = 0, .external_lex_state = 4},
  [2049] = {.lex_state = 63},
  [2050] = {.lex_state = 14},
  [2051] = {.lex_state = 0, .external_lex_state = 4},
  [2052] = {.lex_state = 63},
  [2053] = {.lex_state = 63},
  [2054] = {.lex_state = 63},
  [2055] = {.lex_state = 63},
  [2056] = {.lex_state = 63},
  [2057] = {.lex_state = 0, .external_lex_state = 4},
  [2058] = {.lex_state = 0, .external_lex_state = 4},
  [2059] = {.lex_state = 63},
  [2060] = {.lex_state = 0, .external_lex_state = 4},
  [2061] = {.lex_state = 63},
  [2062] = {.lex_state = 63},
  [2063] = {.lex_state = 63},
  [2064] = {.lex_state = 63},
  [2065] = {.lex_state = 0, .external_lex_state = 4},
  [2066] = {.lex_state = 63},
  [2067] = {.lex_state = 63},
  [2068] = {.lex_state = 0, .external_lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 4},
  [2070] = {.lex_state = 63},
  [2071] = {.lex_state = 0, .external_lex_state = 4},
  [2072] = {.lex_state = 63},
  [2073] = {.lex_state = 18, .external_lex_state = 5},
  [2074] = {.lex_state = 63},
  [2075] = {.lex_state = 18, .external_lex_state = 5},
  [2076] = {.lex_state = 63},
  [2077] = {.lex_state = 18, .external_lex_state = 5},
  [2078] = {.lex_state = 0, .external_lex_state = 4},
  [2079] = {.lex_state = 63},
  [2080] = {.lex_state = 63},
  [2081] = {.lex_state = 63},
  [2082] = {.lex_state = 63, .external_lex_state = 4},
  [2083] = {.lex_state = 0, .external_lex_state = 4},
  [2084] = {.lex_state = 0, .external_lex_state = 4},
  [2085] = {.lex_state = 63},
  [2086] = {.lex_state = 0},
  [2087] = {.lex_state = 63},
  [2088] = {.lex_state = 63},
  [2089] = {.lex_state = 0, .external_lex_state = 4},
  [2090] = {.lex_state = 63},
  [2091] = {.lex_state = 0, .external_lex_state = 4},
  [2092] = {.lex_state = 0, .external_lex_state = 4},
  [2093] = {.lex_state = 63},
  [2094] = {.lex_state = 63},
  [2095] = {.lex_state = 0, .external_lex_state = 4},
  [2096] = {.lex_state = 63, .external_lex_state = 4},
  [2097] = {.lex_state = 0, .external_lex_state = 4},
  [2098] = {.lex_state = 63},
  [2099] = {.lex_state = 63},
  [2100] = {.lex_state = 63},
  [2101] = {.lex_state = 63},
  [2102] = {.lex_state = 0, .external_lex_state = 4},
  [2103] = {.lex_state = 0, .external_lex_state = 4},
  [2104] = {.lex_state = 63},
  [2105] = {.lex_state = 0, .external_lex_state = 4},
  [2106] = {.lex_state = 63},
  [2107] = {.lex_state = 0, .external_lex_state = 4},
  [2108] = {.lex_state = 63},
  [2109] = {.lex_state = 0, .external_lex_state = 4},
  [2110] = {.lex_state = 0, .external_lex_state = 4},
  [2111] = {.lex_state = 63},
  [2112] = {.lex_state = 63},
  [2113] = {.lex_state = 63},
  [2114] = {.lex_state = 63},
  [2115] = {.lex_state = 63},
  [2116] = {.lex_state = 0, .external_lex_state = 4},
  [2117] = {.lex_state = 63},
  [2118] = {.lex_state = 63},
  [2119] = {.lex_state = 0, .external_lex_state = 4},
  [2120] = {.lex_state = 63},
  [2121] = {.lex_state = 0, .external_lex_state = 4},
  [2122] = {.lex_state = 0, .external_lex_state = 4},
  [2123] = {.lex_state = 63},
  [2124] = {.lex_state = 14},
  [2125] = {.lex_state = 0, .external_lex_state = 4},
  [2126] = {.lex_state = 63},
  [2127] = {.lex_state = 0, .external_lex_state = 4},
  [2128] = {.lex_state = 63},
  [2129] = {.lex_state = 0, .external_lex_state = 4},
  [2130] = {.lex_state = 0, .external_lex_state = 4},
  [2131] = {.lex_state = 63},
  [2132] = {.lex_state = 0, .external_lex_state = 4},
  [2133] = {.lex_state = 0, .external_lex_state = 4},
  [2134] = {.lex_state = 63},
  [2135] = {.lex_state = 7},
  [2136] = {.lex_state = 63},
  [2137] = {.lex_state = 63},
  [2138] = {.lex_state = 63},
  [2139] = {.lex_state = 63},
  [2140] = {.lex_state = 63},
  [2141] = {.lex_state = 63},
  [2142] = {.lex_state = 63},
  [2143] = {.lex_state = 63},
  [2144] = {.lex_state = 63},
  [2145] = {.lex_state = 63},
  [2146] = {.lex_state = 63},
  [2147] = {.lex_state = 0, .external_lex_state = 4},
  [2148] = {.lex_state = 0, .external_lex_state = 4},
  [2149] = {.lex_state = 63},
  [2150] = {.lex_state = 0, .external_lex_state = 4},
  [2151] = {.lex_state = 0, .external_lex_state = 4},
  [2152] = {.lex_state = 63},
  [2153] = {.lex_state = 63},
  [2154] = {.lex_state = 0, .external_lex_state = 4},
  [2155] = {.lex_state = 0, .external_lex_state = 4},
  [2156] = {.lex_state = 0, .external_lex_state = 4},
  [2157] = {.lex_state = 0, .external_lex_state = 4},
  [2158] = {.lex_state = 0, .external_lex_state = 4},
  [2159] = {.lex_state = 0, .external_lex_state = 4},
  [2160] = {.lex_state = 63},
  [2161] = {.lex_state = 63},
  [2162] = {.lex_state = 0, .external_lex_state = 4},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 63},
  [2165] = {.lex_state = 0, .external_lex_state = 4},
  [2166] = {.lex_state = 0, .external_lex_state = 4},
  [2167] = {.lex_state = 63},
  [2168] = {.lex_state = 0, .external_lex_state = 4},
  [2169] = {.lex_state = 0, .external_lex_state = 4},
  [2170] = {.lex_state = 0, .external_lex_state = 4},
  [2171] = {.lex_state = 0, .external_lex_state = 4},
  [2172] = {.lex_state = 0, .external_lex_state = 4},
  [2173] = {.lex_state = 0, .external_lex_state = 4},
  [2174] = {.lex_state = 0, .external_lex_state = 4},
  [2175] = {.lex_state = 0, .external_lex_state = 4},
  [2176] = {.lex_state = 0, .external_lex_state = 4},
  [2177] = {.lex_state = 63},
  [2178] = {.lex_state = 63},
  [2179] = {.lex_state = 0, .external_lex_state = 4},
  [2180] = {.lex_state = 63},
  [2181] = {.lex_state = 0, .external_lex_state = 4},
  [2182] = {.lex_state = 63, .external_lex_state = 4},
  [2183] = {.lex_state = 63},
  [2184] = {.lex_state = 63},
  [2185] = {.lex_state = 63},
  [2186] = {.lex_state = 63},
  [2187] = {.lex_state = 63, .external_lex_state = 4},
  [2188] = {.lex_state = 0, .external_lex_state = 4},
  [2189] = {.lex_state = 63},
  [2190] = {.lex_state = 63},
  [2191] = {.lex_state = 14},
  [2192] = {.lex_state = 63},
  [2193] = {.lex_state = 0, .external_lex_state = 4},
  [2194] = {.lex_state = 0, .external_lex_state = 4},
  [2195] = {.lex_state = 0, .external_lex_state = 4},
  [2196] = {.lex_state = 0, .external_lex_state = 4},
  [2197] = {.lex_state = 0, .external_lex_state = 4},
  [2198] = {.lex_state = 63},
  [2199] = {.lex_state = 63},
  [2200] = {.lex_state = 0, .external_lex_state = 4},
  [2201] = {.lex_state = 0, .external_lex_state = 4},
  [2202] = {.lex_state = 0, .external_lex_state = 4},
  [2203] = {.lex_state = 63},
  [2204] = {.lex_state = 7},
  [2205] = {.lex_state = 63},
  [2206] = {.lex_state = 0, .external_lex_state = 4},
  [2207] = {.lex_state = 63},
  [2208] = {.lex_state = 63},
  [2209] = {.lex_state = 0, .external_lex_state = 4},
  [2210] = {.lex_state = 0, .external_lex_state = 4},
  [2211] = {.lex_state = 0, .external_lex_state = 4},
  [2212] = {.lex_state = 63},
  [2213] = {.lex_state = 63},
  [2214] = {.lex_state = 0, .external_lex_state = 4},
  [2215] = {.lex_state = 0, .external_lex_state = 4},
  [2216] = {.lex_state = 0, .external_lex_state = 4},
  [2217] = {.lex_state = 0, .external_lex_state = 4},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 0},
  [2220] = {.lex_state = 63},
  [2221] = {.lex_state = 63},
  [2222] = {.lex_state = 63},
  [2223] = {.lex_state = 0, .external_lex_state = 4},
  [2224] = {.lex_state = 63},
  [2225] = {.lex_state = 0, .external_lex_state = 4},
  [2226] = {.lex_state = 0, .external_lex_state = 4},
  [2227] = {.lex_state = 63},
  [2228] = {.lex_state = 0, .external_lex_state = 4},
  [2229] = {.lex_state = 0, .external_lex_state = 4},
  [2230] = {.lex_state = 0, .external_lex_state = 4},
  [2231] = {.lex_state = 63},
  [2232] = {.lex_state = 0, .external_lex_state = 4},
  [2233] = {.lex_state = 0, .external_lex_state = 4},
  [2234] = {.lex_state = 63},
  [2235] = {.lex_state = 63},
  [2236] = {.lex_state = 63},
  [2237] = {.lex_state = 0, .external_lex_state = 4},
  [2238] = {.lex_state = 0, .external_lex_state = 4},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 63},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 63, .external_lex_state = 4},
  [2243] = {.lex_state = 63},
  [2244] = {.lex_state = 63, .external_lex_state = 4},
  [2245] = {.lex_state = 63, .external_lex_state = 4},
  [2246] = {.lex_state = 63},
  [2247] = {.lex_state = 0, .external_lex_state = 4},
  [2248] = {.lex_state = 0, .external_lex_state = 4},
  [2249] = {.lex_state = 63},
  [2250] = {.lex_state = 63},
  [2251] = {.lex_state = 63},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 63},
  [2254] = {.lex_state = 0, .external_lex_state = 4},
  [2255] = {.lex_state = 63},
  [2256] = {.lex_state = 63, .external_lex_state = 4},
  [2257] = {.lex_state = 0, .external_lex_state = 4},
  [2258] = {.lex_state = 63, .external_lex_state = 4},
  [2259] = {.lex_state = 63},
  [2260] = {.lex_state = 63, .external_lex_state = 4},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 63},
  [2263] = {.lex_state = 0, .external_lex_state = 4},
  [2264] = {.lex_state = 63},
  [2265] = {.lex_state = 0, .external_lex_state = 4},
  [2266] = {.lex_state = 63},
  [2267] = {.lex_state = 0},
  [2268] = {.lex_state = 63},
  [2269] = {.lex_state = 0, .external_lex_state = 4},
  [2270] = {.lex_state = 0, .external_lex_state = 4},
  [2271] = {.lex_state = 63},
  [2272] = {.lex_state = 0, .external_lex_state = 4},
  [2273] = {.lex_state = 0, .external_lex_state = 4},
  [2274] = {.lex_state = 63},
  [2275] = {.lex_state = 63, .external_lex_state = 4},
  [2276] = {.lex_state = 63},
  [2277] = {.lex_state = 63, .external_lex_state = 4},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 63},
  [2280] = {.lex_state = 63},
  [2281] = {.lex_state = 0, .external_lex_state = 4},
  [2282] = {.lex_state = 63},
  [2283] = {.lex_state = 0, .external_lex_state = 4},
  [2284] = {.lex_state = 0, .external_lex_state = 4},
  [2285] = {.lex_state = 0, .external_lex_state = 4},
  [2286] = {.lex_state = 63},
  [2287] = {.lex_state = 63},
  [2288] = {.lex_state = 63},
  [2289] = {.lex_state = 0, .external_lex_state = 4},
  [2290] = {.lex_state = 0, .external_lex_state = 4},
  [2291] = {.lex_state = 63},
  [2292] = {.lex_state = 0, .external_lex_state = 4},
  [2293] = {.lex_state = 63, .external_lex_state = 4},
  [2294] = {.lex_state = 63},
  [2295] = {.lex_state = 0, .external_lex_state = 4},
  [2296] = {.lex_state = 63},
  [2297] = {.lex_state = 63},
  [2298] = {.lex_state = 0, .external_lex_state = 4},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 63},
  [2301] = {.lex_state = 63},
  [2302] = {.lex_state = 63},
  [2303] = {.lex_state = 0, .external_lex_state = 4},
  [2304] = {.lex_state = 63},
  [2305] = {.lex_state = 0, .external_lex_state = 4},
  [2306] = {.lex_state = 1},
  [2307] = {.lex_state = 63, .external_lex_state = 4},
  [2308] = {.lex_state = 1},
  [2309] = {.lex_state = 3},
  [2310] = {.lex_state = 0},
  [2311] = {.lex_state = 63},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 63},
  [2314] = {.lex_state = 63},
  [2315] = {.lex_state = 63},
  [2316] = {.lex_state = 63},
  [2317] = {.lex_state = 63, .external_lex_state = 4},
  [2318] = {.lex_state = 63, .external_lex_state = 4},
  [2319] = {.lex_state = 63},
  [2320] = {.lex_state = 0},
  [2321] = {.lex_state = 63},
  [2322] = {.lex_state = 63},
  [2323] = {.lex_state = 63, .external_lex_state = 4},
  [2324] = {.lex_state = 63},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 0},
  [2327] = {.lex_state = 0},
  [2328] = {.lex_state = 63},
  [2329] = {.lex_state = 63},
  [2330] = {.lex_state = 63},
  [2331] = {.lex_state = 0},
  [2332] = {.lex_state = 63},
  [2333] = {.lex_state = 63},
  [2334] = {.lex_state = 63, .external_lex_state = 4},
  [2335] = {.lex_state = 63, .external_lex_state = 4},
  [2336] = {.lex_state = 1},
  [2337] = {.lex_state = 3},
  [2338] = {.lex_state = 1},
  [2339] = {.lex_state = 0},
  [2340] = {.lex_state = 63, .external_lex_state = 4},
  [2341] = {.lex_state = 0, .external_lex_state = 4},
  [2342] = {.lex_state = 18, .external_lex_state = 5},
  [2343] = {.lex_state = 63, .external_lex_state = 4},
  [2344] = {.lex_state = 3},
  [2345] = {.lex_state = 63},
  [2346] = {.lex_state = 63},
  [2347] = {.lex_state = 63},
  [2348] = {.lex_state = 63},
  [2349] = {.lex_state = 63},
  [2350] = {.lex_state = 63},
  [2351] = {.lex_state = 1},
  [2352] = {.lex_state = 3},
  [2353] = {.lex_state = 0},
  [2354] = {.lex_state = 63, .external_lex_state = 4},
  [2355] = {.lex_state = 63},
  [2356] = {.lex_state = 63},
  [2357] = {.lex_state = 63},
  [2358] = {.lex_state = 63, .external_lex_state = 4},
  [2359] = {.lex_state = 0, .external_lex_state = 4},
  [2360] = {.lex_state = 63, .external_lex_state = 4},
  [2361] = {.lex_state = 3},
  [2362] = {.lex_state = 1},
  [2363] = {.lex_state = 3},
  [2364] = {.lex_state = 1},
  [2365] = {.lex_state = 63, .external_lex_state = 4},
  [2366] = {.lex_state = 1},
  [2367] = {.lex_state = 3},
  [2368] = {.lex_state = 63, .external_lex_state = 4},
  [2369] = {.lex_state = 3},
  [2370] = {.lex_state = 1},
  [2371] = {.lex_state = 63},
  [2372] = {.lex_state = 3},
  [2373] = {.lex_state = 1},
  [2374] = {.lex_state = 0, .external_lex_state = 4},
  [2375] = {.lex_state = 0, .external_lex_state = 4},
  [2376] = {.lex_state = 63},
  [2377] = {.lex_state = 0},
  [2378] = {.lex_state = 0, .external_lex_state = 4},
  [2379] = {.lex_state = 3},
  [2380] = {.lex_state = 1},
  [2381] = {.lex_state = 3},
  [2382] = {.lex_state = 1},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 63, .external_lex_state = 4},
  [2386] = {.lex_state = 1},
  [2387] = {.lex_state = 3},
  [2388] = {.lex_state = 63},
  [2389] = {.lex_state = 0},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 0, .external_lex_state = 4},
  [2392] = {.lex_state = 3},
  [2393] = {.lex_state = 0},
  [2394] = {.lex_state = 63},
  [2395] = {.lex_state = 0, .external_lex_state = 4},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 0, .external_lex_state = 4},
  [2399] = {.lex_state = 63},
  [2400] = {.lex_state = 0, .external_lex_state = 4},
  [2401] = {.lex_state = 0, .external_lex_state = 4},
  [2402] = {.lex_state = 63, .external_lex_state = 4},
  [2403] = {.lex_state = 63, .external_lex_state = 4},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 0},
  [2406] = {.lex_state = 63},
  [2407] = {.lex_state = 0},
  [2408] = {.lex_state = 63},
  [2409] = {.lex_state = 0, .external_lex_state = 4},
  [2410] = {.lex_state = 0, .external_lex_state = 4},
  [2411] = {.lex_state = 0},
  [2412] = {.lex_state = 0},
  [2413] = {.lex_state = 63},
  [2414] = {.lex_state = 0},
  [2415] = {.lex_state = 63},
  [2416] = {.lex_state = 0, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 63},
  [2419] = {.lex_state = 0},
  [2420] = {.lex_state = 0, .external_lex_state = 4},
  [2421] = {.lex_state = 63},
  [2422] = {.lex_state = 63},
  [2423] = {.lex_state = 0, .external_lex_state = 4},
  [2424] = {.lex_state = 0, .external_lex_state = 4},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 63},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 0},
  [2429] = {.lex_state = 0},
  [2430] = {.lex_state = 0},
  [2431] = {.lex_state = 0},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 0},
  [2434] = {.lex_state = 0, .external_lex_state = 4},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 63},
  [2437] = {.lex_state = 63},
  [2438] = {.lex_state = 0},
  [2439] = {.lex_state = 0},
  [2440] = {.lex_state = 0},
  [2441] = {.lex_state = 0},
  [2442] = {.lex_state = 0},
  [2443] = {.lex_state = 0},
  [2444] = {.lex_state = 63},
  [2445] = {.lex_state = 7},
  [2446] = {.lex_state = 63},
  [2447] = {.lex_state = 63},
  [2448] = {.lex_state = 63, .external_lex_state = 4},
  [2449] = {.lex_state = 0},
  [2450] = {.lex_state = 0},
  [2451] = {.lex_state = 63},
  [2452] = {.lex_state = 7},
  [2453] = {.lex_state = 0},
  [2454] = {.lex_state = 63},
  [2455] = {.lex_state = 0},
  [2456] = {.lex_state = 0},
  [2457] = {.lex_state = 0},
  [2458] = {.lex_state = 0},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 0, .external_lex_state = 4},
  [2461] = {.lex_state = 0, .external_lex_state = 4},
  [2462] = {.lex_state = 7},
  [2463] = {.lex_state = 0},
  [2464] = {.lex_state = 0, .external_lex_state = 4},
  [2465] = {.lex_state = 0},
  [2466] = {.lex_state = 0},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 63},
  [2470] = {.lex_state = 0},
  [2471] = {.lex_state = 63},
  [2472] = {.lex_state = 63},
  [2473] = {.lex_state = 0},
  [2474] = {.lex_state = 0},
  [2475] = {.lex_state = 63},
  [2476] = {.lex_state = 63},
  [2477] = {.lex_state = 63},
  [2478] = {.lex_state = 0},
  [2479] = {.lex_state = 0},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 0},
  [2482] = {.lex_state = 63, .external_lex_state = 4},
  [2483] = {.lex_state = 0},
  [2484] = {.lex_state = 0},
  [2485] = {.lex_state = 63},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 63},
  [2488] = {.lex_state = 0},
  [2489] = {.lex_state = 63},
  [2490] = {.lex_state = 63},
  [2491] = {.lex_state = 63},
  [2492] = {.lex_state = 0},
  [2493] = {.lex_state = 0},
  [2494] = {.lex_state = 0},
  [2495] = {.lex_state = 0},
  [2496] = {.lex_state = 0},
  [2497] = {.lex_state = 63},
  [2498] = {.lex_state = 63},
  [2499] = {.lex_state = 0, .external_lex_state = 4},
  [2500] = {.lex_state = 63},
  [2501] = {.lex_state = 0},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 63},
  [2505] = {.lex_state = 0},
  [2506] = {.lex_state = 63},
  [2507] = {.lex_state = 63, .external_lex_state = 4},
  [2508] = {.lex_state = 0},
  [2509] = {.lex_state = 63},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 0},
  [2512] = {.lex_state = 0},
  [2513] = {.lex_state = 0},
  [2514] = {.lex_state = 0},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 0},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 0, .external_lex_state = 4},
  [2519] = {.lex_state = 0},
  [2520] = {.lex_state = 0},
  [2521] = {.lex_state = 0},
  [2522] = {.lex_state = 0},
  [2523] = {.lex_state = 63},
  [2524] = {.lex_state = 0},
  [2525] = {.lex_state = 0},
  [2526] = {.lex_state = 0},
  [2527] = {.lex_state = 0},
  [2528] = {.lex_state = 0},
  [2529] = {.lex_state = 63},
  [2530] = {.lex_state = 0},
  [2531] = {.lex_state = 63},
  [2532] = {.lex_state = 0, .external_lex_state = 4},
  [2533] = {.lex_state = 0, .external_lex_state = 4},
  [2534] = {.lex_state = 0},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 0, .external_lex_state = 4},
  [2538] = {.lex_state = 0},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 63},
  [2541] = {.lex_state = 63, .external_lex_state = 4},
  [2542] = {.lex_state = 63},
  [2543] = {.lex_state = 0, .external_lex_state = 4},
  [2544] = {.lex_state = 0},
  [2545] = {.lex_state = 0, .external_lex_state = 4},
  [2546] = {.lex_state = 63},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 0, .external_lex_state = 4},
  [2550] = {.lex_state = 0, .external_lex_state = 4},
  [2551] = {.lex_state = 63, .external_lex_state = 4},
  [2552] = {.lex_state = 0, .external_lex_state = 4},
  [2553] = {.lex_state = 63},
  [2554] = {.lex_state = 0},
  [2555] = {.lex_state = 0},
  [2556] = {.lex_state = 0, .external_lex_state = 4},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 63},
  [2559] = {.lex_state = 63},
  [2560] = {.lex_state = 0},
  [2561] = {.lex_state = 0},
  [2562] = {.lex_state = 0},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 63},
  [2566] = {.lex_state = 63},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 63},
  [2569] = {.lex_state = 63},
  [2570] = {.lex_state = 0},
  [2571] = {.lex_state = 63},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 63},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 63},
  [2576] = {.lex_state = 0},
  [2577] = {.lex_state = 0},
  [2578] = {.lex_state = 0},
  [2579] = {.lex_state = 0},
  [2580] = {.lex_state = 63},
  [2581] = {.lex_state = 0},
  [2582] = {.lex_state = 63},
  [2583] = {.lex_state = 0},
  [2584] = {.lex_state = 63},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 0},
  [2587] = {.lex_state = 63},
  [2588] = {.lex_state = 63},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 0},
  [2591] = {.lex_state = 63},
  [2592] = {.lex_state = 63},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 63},
  [2596] = {.lex_state = 0, .external_lex_state = 4},
  [2597] = {.lex_state = 63},
  [2598] = {.lex_state = 63},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 63},
  [2601] = {.lex_state = 0},
  [2602] = {.lex_state = 63},
  [2603] = {.lex_state = 0, .external_lex_state = 4},
  [2604] = {.lex_state = 0},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 63},
  [2607] = {.lex_state = 63},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 63},
  [2612] = {.lex_state = 0, .external_lex_state = 4},
  [2613] = {.lex_state = 0},
  [2614] = {.lex_state = 0, .external_lex_state = 4},
  [2615] = {.lex_state = 63},
  [2616] = {.lex_state = 63},
  [2617] = {.lex_state = 63},
  [2618] = {.lex_state = 63},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 63},
  [2621] = {.lex_state = 0, .external_lex_state = 4},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 63},
  [2624] = {.lex_state = 63},
  [2625] = {.lex_state = 63},
  [2626] = {.lex_state = 63},
  [2627] = {.lex_state = 63},
  [2628] = {.lex_state = 63},
  [2629] = {.lex_state = 63},
  [2630] = {.lex_state = 63},
  [2631] = {.lex_state = 0, .external_lex_state = 4},
  [2632] = {.lex_state = 63},
  [2633] = {.lex_state = 63},
  [2634] = {.lex_state = 0},
  [2635] = {.lex_state = 63},
  [2636] = {.lex_state = 0},
  [2637] = {.lex_state = 0},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 63},
  [2640] = {.lex_state = 63},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 0},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 63},
  [2645] = {.lex_state = 63},
  [2646] = {.lex_state = 0, .external_lex_state = 4},
  [2647] = {.lex_state = 63},
  [2648] = {.lex_state = 0, .external_lex_state = 4},
  [2649] = {.lex_state = 63},
  [2650] = {.lex_state = 0},
  [2651] = {.lex_state = 63},
  [2652] = {.lex_state = 63},
  [2653] = {.lex_state = 63},
  [2654] = {.lex_state = 63},
  [2655] = {.lex_state = 63},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 63},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 63},
  [2662] = {.lex_state = 0},
  [2663] = {.lex_state = 63},
  [2664] = {.lex_state = 63},
  [2665] = {.lex_state = 63},
  [2666] = {.lex_state = 63},
  [2667] = {.lex_state = 63},
  [2668] = {.lex_state = 63},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 63},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 63},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 63},
  [2675] = {.lex_state = 63},
  [2676] = {.lex_state = 63},
  [2677] = {.lex_state = 63},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 0, .external_lex_state = 4},
  [2680] = {.lex_state = 63},
  [2681] = {.lex_state = 63},
  [2682] = {.lex_state = 63},
  [2683] = {.lex_state = 0},
  [2684] = {.lex_state = 63},
  [2685] = {.lex_state = 0},
  [2686] = {.lex_state = 0},
  [2687] = {.lex_state = 63},
  [2688] = {.lex_state = 63},
  [2689] = {.lex_state = 63},
  [2690] = {.lex_state = 63},
  [2691] = {.lex_state = 63},
  [2692] = {.lex_state = 63},
  [2693] = {.lex_state = 0, .external_lex_state = 4},
  [2694] = {.lex_state = 63},
  [2695] = {.lex_state = 63},
  [2696] = {.lex_state = 63},
  [2697] = {.lex_state = 63},
  [2698] = {.lex_state = 63},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 0, .external_lex_state = 4},
  [2701] = {.lex_state = 0, .external_lex_state = 4},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 63},
  [2704] = {.lex_state = 63},
  [2705] = {.lex_state = 63},
  [2706] = {.lex_state = 63},
  [2707] = {.lex_state = 63},
  [2708] = {.lex_state = 0, .external_lex_state = 4},
  [2709] = {.lex_state = 0, .external_lex_state = 4},
  [2710] = {.lex_state = 63},
  [2711] = {.lex_state = 63},
  [2712] = {.lex_state = 63},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 63},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 63},
  [2718] = {.lex_state = 63},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 63},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 63},
  [2723] = {.lex_state = 63},
  [2724] = {.lex_state = 63},
  [2725] = {.lex_state = 63},
  [2726] = {.lex_state = 63},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 63},
  [2729] = {.lex_state = 63},
  [2730] = {.lex_state = 0},
  [2731] = {.lex_state = 63},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 63},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 63},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 63},
  [2738] = {.lex_state = 63},
  [2739] = {.lex_state = 63},
  [2740] = {.lex_state = 63},
  [2741] = {.lex_state = 63},
  [2742] = {.lex_state = 63},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 63},
  [2745] = {.lex_state = 0},
  [2746] = {.lex_state = 63},
  [2747] = {.lex_state = 63},
  [2748] = {.lex_state = 63},
  [2749] = {.lex_state = 63},
  [2750] = {.lex_state = 63},
  [2751] = {.lex_state = 63},
  [2752] = {.lex_state = 63},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 63},
  [2755] = {.lex_state = 63},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 63},
  [2759] = {.lex_state = 63},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 0},
  [2762] = {.lex_state = 63},
  [2763] = {.lex_state = 63},
  [2764] = {.lex_state = 63},
  [2765] = {.lex_state = 63},
  [2766] = {.lex_state = 63},
  [2767] = {.lex_state = 63},
  [2768] = {.lex_state = 63},
  [2769] = {.lex_state = 0, .external_lex_state = 4},
  [2770] = {.lex_state = 63},
  [2771] = {.lex_state = 0, .external_lex_state = 4},
  [2772] = {.lex_state = 0, .external_lex_state = 4},
  [2773] = {.lex_state = 0, .external_lex_state = 4},
  [2774] = {.lex_state = 63},
  [2775] = {.lex_state = 63},
  [2776] = {.lex_state = 63},
  [2777] = {.lex_state = 63},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 63},
  [2780] = {.lex_state = 0, .external_lex_state = 4},
  [2781] = {.lex_state = 63},
  [2782] = {.lex_state = 63},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 63},
  [2785] = {.lex_state = 15},
  [2786] = {.lex_state = 15},
  [2787] = {.lex_state = 15},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 0},
  [2793] = {.lex_state = 63},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 0},
  [2797] = {.lex_state = 63},
  [2798] = {.lex_state = 63},
  [2799] = {.lex_state = 63},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 0},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 63},
  [2804] = {.lex_state = 63},
  [2805] = {.lex_state = 63},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 0},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 0},
  [2814] = {.lex_state = 63},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 63},
  [2817] = {.lex_state = 5},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 0},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 63},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 0},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 0},
  [2827] = {.lex_state = 0},
  [2828] = {.lex_state = 63},
  [2829] = {.lex_state = 63},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 63},
  [2833] = {.lex_state = 63},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 63},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 63},
  [2840] = {.lex_state = 63},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 63},
  [2843] = {.lex_state = 63},
  [2844] = {.lex_state = 63},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 63},
  [2848] = {.lex_state = 63},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 0},
  [2851] = {.lex_state = 63},
  [2852] = {.lex_state = 15},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 63},
  [2855] = {.lex_state = 63},
  [2856] = {.lex_state = 63},
  [2857] = {.lex_state = 63},
  [2858] = {.lex_state = 63},
  [2859] = {.lex_state = 63},
  [2860] = {.lex_state = 63},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 63},
  [2864] = {.lex_state = 63},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 63},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 0},
  [2871] = {.lex_state = 63},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 0},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 63},
  [2876] = {.lex_state = 63},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 0},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 0},
  [2882] = {.lex_state = 63},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 0},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 63},
  [2888] = {.lex_state = 5},
  [2889] = {.lex_state = 63},
  [2890] = {.lex_state = 63},
  [2891] = {.lex_state = 63},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 63},
  [2895] = {.lex_state = 63},
  [2896] = {.lex_state = 0},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 63},
  [2899] = {.lex_state = 63},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 63},
  [2902] = {.lex_state = 63},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 5},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 63},
  [2909] = {.lex_state = 63},
  [2910] = {.lex_state = 63},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 63},
  [2914] = {.lex_state = 63},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 63},
  [2918] = {.lex_state = 63},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 63},
  [2921] = {.lex_state = 0},
  [2922] = {.lex_state = 0},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 63},
  [2925] = {.lex_state = 63},
  [2926] = {.lex_state = 63},
  [2927] = {.lex_state = 63},
  [2928] = {.lex_state = 63},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 63},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 63},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 63},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 63},
  [2942] = {.lex_state = 63},
  [2943] = {.lex_state = 63},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 63},
  [2948] = {.lex_state = 63},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 63},
  [2951] = {.lex_state = 63},
  [2952] = {.lex_state = 63},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 63},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 0},
  [2957] = {.lex_state = 63},
  [2958] = {.lex_state = 63},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 0},
  [2961] = {.lex_state = 63},
  [2962] = {.lex_state = 5},
  [2963] = {.lex_state = 63},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 63},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 0},
  [2970] = {.lex_state = 0},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 63},
  [2973] = {.lex_state = 63},
  [2974] = {.lex_state = 63},
  [2975] = {.lex_state = 63},
  [2976] = {.lex_state = 63},
  [2977] = {.lex_state = 63},
  [2978] = {.lex_state = 63},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 0},
  [2981] = {.lex_state = 63},
  [2982] = {.lex_state = 63},
  [2983] = {.lex_state = 63},
  [2984] = {.lex_state = 63},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2922),
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(28),
    [sym_lexical_declaration] = STATE(28),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(28),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(28),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(28),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(28),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(28),
    [sym_abstract_class_declaration] = STATE(28),
    [sym_module] = STATE(28),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(28),
    [sym_interface_declaration] = STATE(28),
    [sym_enum_declaration] = STATE(28),
    [sym_type_alias_declaration] = STATE(28),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1436),
    [sym_assignment_pattern] = STATE(2578),
    [sym_array] = STATE(1437),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2578),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_method_definition] = STATE(2578),
    [sym_pair] = STATE(2578),
    [sym__property_name] = STATE(1964),
    [sym_computed_property_name] = STATE(1964),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(14),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_accessibility_modifier] = STATE(1784),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [aux_sym_object_repeat1] = STATE(2440),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(27),
    [sym_lexical_declaration] = STATE(27),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1436),
    [sym_assignment_pattern] = STATE(2555),
    [sym_array] = STATE(1437),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(27),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(27),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(27),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2555),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_method_definition] = STATE(2555),
    [sym_pair] = STATE(2555),
    [sym__property_name] = STATE(1964),
    [sym_computed_property_name] = STATE(1964),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(27),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(27),
    [sym_abstract_class_declaration] = STATE(27),
    [sym_module] = STATE(27),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(27),
    [sym_interface_declaration] = STATE(27),
    [sym_enum_declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(27),
    [sym_accessibility_modifier] = STATE(1784),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [aux_sym_object_repeat1] = STATE(2557),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [4] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1436),
    [sym_assignment_pattern] = STATE(2438),
    [sym_array] = STATE(1437),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2438),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_method_definition] = STATE(2438),
    [sym_pair] = STATE(2438),
    [sym__property_name] = STATE(1964),
    [sym_computed_property_name] = STATE(1964),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_accessibility_modifier] = STATE(1784),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [aux_sym_object_repeat1] = STATE(2441),
    [sym_identifier] = ACTIONS(175),
    [anon_sym_export] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(181),
    [anon_sym_type] = ACTIONS(183),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(187),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(189),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(191),
    [anon_sym_set] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(193),
    [anon_sym_public] = ACTIONS(195),
    [anon_sym_private] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(195),
    [anon_sym_module] = ACTIONS(197),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(201),
  },
  [5] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1436),
    [sym_assignment_pattern] = STATE(2438),
    [sym_array] = STATE(1437),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2438),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_method_definition] = STATE(2438),
    [sym_pair] = STATE(2438),
    [sym__property_name] = STATE(1964),
    [sym_computed_property_name] = STATE(1964),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_accessibility_modifier] = STATE(1784),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [aux_sym_object_repeat1] = STATE(2441),
    [sym_identifier] = ACTIONS(175),
    [anon_sym_export] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(203),
    [anon_sym_type] = ACTIONS(183),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(187),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(189),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(191),
    [anon_sym_set] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(193),
    [anon_sym_public] = ACTIONS(195),
    [anon_sym_private] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(195),
    [anon_sym_module] = ACTIONS(197),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(201),
  },
  [6] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1436),
    [sym_assignment_pattern] = STATE(2438),
    [sym_array] = STATE(1437),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_spread_element] = STATE(2438),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_method_definition] = STATE(2438),
    [sym_pair] = STATE(2438),
    [sym__property_name] = STATE(1964),
    [sym_computed_property_name] = STATE(1964),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(24),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_accessibility_modifier] = STATE(1784),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [aux_sym_object_repeat1] = STATE(2441),
    [sym_identifier] = ACTIONS(175),
    [anon_sym_export] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(205),
    [anon_sym_type] = ACTIONS(183),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(187),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(189),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(191),
    [anon_sym_set] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(193),
    [anon_sym_public] = ACTIONS(195),
    [anon_sym_private] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(195),
    [anon_sym_module] = ACTIONS(197),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(201),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(11),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(11),
    [sym_abstract_class_declaration] = STATE(11),
    [sym_module] = STATE(11),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(11),
    [sym_interface_declaration] = STATE(11),
    [sym_enum_declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(11),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(8),
    [sym__declaration] = STATE(8),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym_variable_declaration] = STATE(8),
    [sym_lexical_declaration] = STATE(8),
    [sym_statement_block] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_switch_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_for_in_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_with_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_debugger_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym_labeled_statement] = STATE(8),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(8),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(8),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(8),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(8),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(8),
    [sym_abstract_class_declaration] = STATE(8),
    [sym_module] = STATE(8),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(8),
    [sym_interface_declaration] = STATE(8),
    [sym_enum_declaration] = STATE(8),
    [sym_type_alias_declaration] = STATE(8),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(24),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(14),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(25),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(27),
    [sym_lexical_declaration] = STATE(27),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(27),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(27),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(27),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(27),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(27),
    [sym_abstract_class_declaration] = STATE(27),
    [sym_module] = STATE(27),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(27),
    [sym_interface_declaration] = STATE(27),
    [sym_enum_declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(27),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(399),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(19),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(19),
    [sym_abstract_class_declaration] = STATE(19),
    [sym_module] = STATE(19),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(19),
    [sym_interface_declaration] = STATE(19),
    [sym_enum_declaration] = STATE(19),
    [sym_type_alias_declaration] = STATE(19),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(538),
    [sym__declaration] = STATE(538),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(538),
    [sym_expression_statement] = STATE(538),
    [sym_variable_declaration] = STATE(538),
    [sym_lexical_declaration] = STATE(538),
    [sym_statement_block] = STATE(538),
    [sym_if_statement] = STATE(538),
    [sym_switch_statement] = STATE(538),
    [sym_for_statement] = STATE(538),
    [sym_for_in_statement] = STATE(538),
    [sym_while_statement] = STATE(538),
    [sym_do_statement] = STATE(538),
    [sym_try_statement] = STATE(538),
    [sym_with_statement] = STATE(538),
    [sym_break_statement] = STATE(538),
    [sym_continue_statement] = STATE(538),
    [sym_debugger_statement] = STATE(538),
    [sym_return_statement] = STATE(538),
    [sym_throw_statement] = STATE(538),
    [sym_empty_statement] = STATE(538),
    [sym_labeled_statement] = STATE(538),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(538),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(538),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(538),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(538),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(538),
    [sym_abstract_class_declaration] = STATE(538),
    [sym_module] = STATE(538),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(538),
    [sym_interface_declaration] = STATE(538),
    [sym_enum_declaration] = STATE(538),
    [sym_type_alias_declaration] = STATE(538),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [30] = {
    [sym_export_statement] = STATE(538),
    [sym__declaration] = STATE(538),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(538),
    [sym_expression_statement] = STATE(538),
    [sym_variable_declaration] = STATE(538),
    [sym_lexical_declaration] = STATE(538),
    [sym_statement_block] = STATE(538),
    [sym_if_statement] = STATE(538),
    [sym_switch_statement] = STATE(538),
    [sym_for_statement] = STATE(538),
    [sym_for_in_statement] = STATE(538),
    [sym_while_statement] = STATE(538),
    [sym_do_statement] = STATE(538),
    [sym_try_statement] = STATE(538),
    [sym_with_statement] = STATE(538),
    [sym_break_statement] = STATE(538),
    [sym_continue_statement] = STATE(538),
    [sym_debugger_statement] = STATE(538),
    [sym_return_statement] = STATE(538),
    [sym_throw_statement] = STATE(538),
    [sym_empty_statement] = STATE(538),
    [sym_labeled_statement] = STATE(538),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(538),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(538),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(538),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(538),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(538),
    [sym_abstract_class_declaration] = STATE(538),
    [sym_module] = STATE(538),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(538),
    [sym_interface_declaration] = STATE(538),
    [sym_enum_declaration] = STATE(538),
    [sym_type_alias_declaration] = STATE(538),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [31] = {
    [sym_export_statement] = STATE(2814),
    [sym__declaration] = STATE(2814),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(2814),
    [sym_expression_statement] = STATE(2814),
    [sym_variable_declaration] = STATE(2814),
    [sym_lexical_declaration] = STATE(2814),
    [sym_statement_block] = STATE(2814),
    [sym_if_statement] = STATE(2814),
    [sym_switch_statement] = STATE(2814),
    [sym_for_statement] = STATE(2814),
    [sym_for_in_statement] = STATE(2814),
    [sym_while_statement] = STATE(2814),
    [sym_do_statement] = STATE(2814),
    [sym_try_statement] = STATE(2814),
    [sym_with_statement] = STATE(2814),
    [sym_break_statement] = STATE(2814),
    [sym_continue_statement] = STATE(2814),
    [sym_debugger_statement] = STATE(2814),
    [sym_return_statement] = STATE(2814),
    [sym_throw_statement] = STATE(2814),
    [sym_empty_statement] = STATE(2814),
    [sym_labeled_statement] = STATE(2814),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(2814),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(2814),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(2814),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(2814),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(2814),
    [sym_abstract_class_declaration] = STATE(2814),
    [sym_module] = STATE(2814),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(2814),
    [sym_interface_declaration] = STATE(2814),
    [sym_enum_declaration] = STATE(2814),
    [sym_type_alias_declaration] = STATE(2814),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [32] = {
    [sym_export_statement] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(597),
    [sym_expression_statement] = STATE(597),
    [sym_variable_declaration] = STATE(597),
    [sym_lexical_declaration] = STATE(597),
    [sym_statement_block] = STATE(597),
    [sym_if_statement] = STATE(597),
    [sym_switch_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_for_in_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_do_statement] = STATE(597),
    [sym_try_statement] = STATE(597),
    [sym_with_statement] = STATE(597),
    [sym_break_statement] = STATE(597),
    [sym_continue_statement] = STATE(597),
    [sym_debugger_statement] = STATE(597),
    [sym_return_statement] = STATE(597),
    [sym_throw_statement] = STATE(597),
    [sym_empty_statement] = STATE(597),
    [sym_labeled_statement] = STATE(597),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(597),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(597),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(597),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(597),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(597),
    [sym_abstract_class_declaration] = STATE(597),
    [sym_module] = STATE(597),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(597),
    [sym_interface_declaration] = STATE(597),
    [sym_enum_declaration] = STATE(597),
    [sym_type_alias_declaration] = STATE(597),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [33] = {
    [sym_export_statement] = STATE(591),
    [sym__declaration] = STATE(591),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(591),
    [sym_expression_statement] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_statement_block] = STATE(591),
    [sym_if_statement] = STATE(591),
    [sym_switch_statement] = STATE(591),
    [sym_for_statement] = STATE(591),
    [sym_for_in_statement] = STATE(591),
    [sym_while_statement] = STATE(591),
    [sym_do_statement] = STATE(591),
    [sym_try_statement] = STATE(591),
    [sym_with_statement] = STATE(591),
    [sym_break_statement] = STATE(591),
    [sym_continue_statement] = STATE(591),
    [sym_debugger_statement] = STATE(591),
    [sym_return_statement] = STATE(591),
    [sym_throw_statement] = STATE(591),
    [sym_empty_statement] = STATE(591),
    [sym_labeled_statement] = STATE(591),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(591),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(591),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(591),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [34] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(560),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [35] = {
    [sym_export_statement] = STATE(590),
    [sym__declaration] = STATE(590),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(590),
    [sym_expression_statement] = STATE(590),
    [sym_variable_declaration] = STATE(590),
    [sym_lexical_declaration] = STATE(590),
    [sym_statement_block] = STATE(590),
    [sym_if_statement] = STATE(590),
    [sym_switch_statement] = STATE(590),
    [sym_for_statement] = STATE(590),
    [sym_for_in_statement] = STATE(590),
    [sym_while_statement] = STATE(590),
    [sym_do_statement] = STATE(590),
    [sym_try_statement] = STATE(590),
    [sym_with_statement] = STATE(590),
    [sym_break_statement] = STATE(590),
    [sym_continue_statement] = STATE(590),
    [sym_debugger_statement] = STATE(590),
    [sym_return_statement] = STATE(590),
    [sym_throw_statement] = STATE(590),
    [sym_empty_statement] = STATE(590),
    [sym_labeled_statement] = STATE(590),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(590),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(590),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(590),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(590),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(590),
    [sym_abstract_class_declaration] = STATE(590),
    [sym_module] = STATE(590),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(590),
    [sym_interface_declaration] = STATE(590),
    [sym_enum_declaration] = STATE(590),
    [sym_type_alias_declaration] = STATE(590),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [36] = {
    [sym_export_statement] = STATE(558),
    [sym__declaration] = STATE(558),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(558),
    [sym_expression_statement] = STATE(558),
    [sym_variable_declaration] = STATE(558),
    [sym_lexical_declaration] = STATE(558),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_switch_statement] = STATE(558),
    [sym_for_statement] = STATE(558),
    [sym_for_in_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_do_statement] = STATE(558),
    [sym_try_statement] = STATE(558),
    [sym_with_statement] = STATE(558),
    [sym_break_statement] = STATE(558),
    [sym_continue_statement] = STATE(558),
    [sym_debugger_statement] = STATE(558),
    [sym_return_statement] = STATE(558),
    [sym_throw_statement] = STATE(558),
    [sym_empty_statement] = STATE(558),
    [sym_labeled_statement] = STATE(558),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(558),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(558),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(558),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(558),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(558),
    [sym_abstract_class_declaration] = STATE(558),
    [sym_module] = STATE(558),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(558),
    [sym_interface_declaration] = STATE(558),
    [sym_enum_declaration] = STATE(558),
    [sym_type_alias_declaration] = STATE(558),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [37] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(542),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [38] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(542),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [39] = {
    [sym_export_statement] = STATE(573),
    [sym__declaration] = STATE(573),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(573),
    [sym_expression_statement] = STATE(573),
    [sym_variable_declaration] = STATE(573),
    [sym_lexical_declaration] = STATE(573),
    [sym_statement_block] = STATE(573),
    [sym_if_statement] = STATE(573),
    [sym_switch_statement] = STATE(573),
    [sym_for_statement] = STATE(573),
    [sym_for_in_statement] = STATE(573),
    [sym_while_statement] = STATE(573),
    [sym_do_statement] = STATE(573),
    [sym_try_statement] = STATE(573),
    [sym_with_statement] = STATE(573),
    [sym_break_statement] = STATE(573),
    [sym_continue_statement] = STATE(573),
    [sym_debugger_statement] = STATE(573),
    [sym_return_statement] = STATE(573),
    [sym_throw_statement] = STATE(573),
    [sym_empty_statement] = STATE(573),
    [sym_labeled_statement] = STATE(573),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(573),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(573),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(573),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(573),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(573),
    [sym_abstract_class_declaration] = STATE(573),
    [sym_module] = STATE(573),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(573),
    [sym_interface_declaration] = STATE(573),
    [sym_enum_declaration] = STATE(573),
    [sym_type_alias_declaration] = STATE(573),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [40] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(560),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [41] = {
    [sym_export_statement] = STATE(530),
    [sym__declaration] = STATE(530),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(530),
    [sym_expression_statement] = STATE(530),
    [sym_variable_declaration] = STATE(530),
    [sym_lexical_declaration] = STATE(530),
    [sym_statement_block] = STATE(530),
    [sym_if_statement] = STATE(530),
    [sym_switch_statement] = STATE(530),
    [sym_for_statement] = STATE(530),
    [sym_for_in_statement] = STATE(530),
    [sym_while_statement] = STATE(530),
    [sym_do_statement] = STATE(530),
    [sym_try_statement] = STATE(530),
    [sym_with_statement] = STATE(530),
    [sym_break_statement] = STATE(530),
    [sym_continue_statement] = STATE(530),
    [sym_debugger_statement] = STATE(530),
    [sym_return_statement] = STATE(530),
    [sym_throw_statement] = STATE(530),
    [sym_empty_statement] = STATE(530),
    [sym_labeled_statement] = STATE(530),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(530),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(530),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(530),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(530),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(530),
    [sym_abstract_class_declaration] = STATE(530),
    [sym_module] = STATE(530),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(530),
    [sym_interface_declaration] = STATE(530),
    [sym_enum_declaration] = STATE(530),
    [sym_type_alias_declaration] = STATE(530),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [42] = {
    [sym_export_statement] = STATE(590),
    [sym__declaration] = STATE(590),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(590),
    [sym_expression_statement] = STATE(590),
    [sym_variable_declaration] = STATE(590),
    [sym_lexical_declaration] = STATE(590),
    [sym_statement_block] = STATE(590),
    [sym_if_statement] = STATE(590),
    [sym_switch_statement] = STATE(590),
    [sym_for_statement] = STATE(590),
    [sym_for_in_statement] = STATE(590),
    [sym_while_statement] = STATE(590),
    [sym_do_statement] = STATE(590),
    [sym_try_statement] = STATE(590),
    [sym_with_statement] = STATE(590),
    [sym_break_statement] = STATE(590),
    [sym_continue_statement] = STATE(590),
    [sym_debugger_statement] = STATE(590),
    [sym_return_statement] = STATE(590),
    [sym_throw_statement] = STATE(590),
    [sym_empty_statement] = STATE(590),
    [sym_labeled_statement] = STATE(590),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(590),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(590),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(590),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(590),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(590),
    [sym_abstract_class_declaration] = STATE(590),
    [sym_module] = STATE(590),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(590),
    [sym_interface_declaration] = STATE(590),
    [sym_enum_declaration] = STATE(590),
    [sym_type_alias_declaration] = STATE(590),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [43] = {
    [sym_export_statement] = STATE(2712),
    [sym__declaration] = STATE(2712),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(2712),
    [sym_expression_statement] = STATE(2712),
    [sym_variable_declaration] = STATE(2712),
    [sym_lexical_declaration] = STATE(2712),
    [sym_statement_block] = STATE(2712),
    [sym_if_statement] = STATE(2712),
    [sym_switch_statement] = STATE(2712),
    [sym_for_statement] = STATE(2712),
    [sym_for_in_statement] = STATE(2712),
    [sym_while_statement] = STATE(2712),
    [sym_do_statement] = STATE(2712),
    [sym_try_statement] = STATE(2712),
    [sym_with_statement] = STATE(2712),
    [sym_break_statement] = STATE(2712),
    [sym_continue_statement] = STATE(2712),
    [sym_debugger_statement] = STATE(2712),
    [sym_return_statement] = STATE(2712),
    [sym_throw_statement] = STATE(2712),
    [sym_empty_statement] = STATE(2712),
    [sym_labeled_statement] = STATE(2712),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(2712),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(2712),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(2712),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(2712),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(2712),
    [sym_abstract_class_declaration] = STATE(2712),
    [sym_module] = STATE(2712),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(2712),
    [sym_interface_declaration] = STATE(2712),
    [sym_enum_declaration] = STATE(2712),
    [sym_type_alias_declaration] = STATE(2712),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [44] = {
    [sym_export_statement] = STATE(558),
    [sym__declaration] = STATE(558),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(558),
    [sym_expression_statement] = STATE(558),
    [sym_variable_declaration] = STATE(558),
    [sym_lexical_declaration] = STATE(558),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_switch_statement] = STATE(558),
    [sym_for_statement] = STATE(558),
    [sym_for_in_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_do_statement] = STATE(558),
    [sym_try_statement] = STATE(558),
    [sym_with_statement] = STATE(558),
    [sym_break_statement] = STATE(558),
    [sym_continue_statement] = STATE(558),
    [sym_debugger_statement] = STATE(558),
    [sym_return_statement] = STATE(558),
    [sym_throw_statement] = STATE(558),
    [sym_empty_statement] = STATE(558),
    [sym_labeled_statement] = STATE(558),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(558),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(558),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(558),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(558),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(558),
    [sym_abstract_class_declaration] = STATE(558),
    [sym_module] = STATE(558),
    [sym_internal_module] = STATE(1285),
    [sym_import_alias] = STATE(558),
    [sym_interface_declaration] = STATE(558),
    [sym_enum_declaration] = STATE(558),
    [sym_type_alias_declaration] = STATE(558),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [45] = {
    [sym_export_statement] = STATE(591),
    [sym__declaration] = STATE(591),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(591),
    [sym_expression_statement] = STATE(591),
    [sym_variable_declaration] = STATE(591),
    [sym_lexical_declaration] = STATE(591),
    [sym_statement_block] = STATE(591),
    [sym_if_statement] = STATE(591),
    [sym_switch_statement] = STATE(591),
    [sym_for_statement] = STATE(591),
    [sym_for_in_statement] = STATE(591),
    [sym_while_statement] = STATE(591),
    [sym_do_statement] = STATE(591),
    [sym_try_statement] = STATE(591),
    [sym_with_statement] = STATE(591),
    [sym_break_statement] = STATE(591),
    [sym_continue_statement] = STATE(591),
    [sym_debugger_statement] = STATE(591),
    [sym_return_statement] = STATE(591),
    [sym_throw_statement] = STATE(591),
    [sym_empty_statement] = STATE(591),
    [sym_labeled_statement] = STATE(591),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(591),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(591),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(591),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(591),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(591),
    [sym_abstract_class_declaration] = STATE(591),
    [sym_module] = STATE(591),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(591),
    [sym_interface_declaration] = STATE(591),
    [sym_enum_declaration] = STATE(591),
    [sym_type_alias_declaration] = STATE(591),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [46] = {
    [sym_export_statement] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(597),
    [sym_expression_statement] = STATE(597),
    [sym_variable_declaration] = STATE(597),
    [sym_lexical_declaration] = STATE(597),
    [sym_statement_block] = STATE(597),
    [sym_if_statement] = STATE(597),
    [sym_switch_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_for_in_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_do_statement] = STATE(597),
    [sym_try_statement] = STATE(597),
    [sym_with_statement] = STATE(597),
    [sym_break_statement] = STATE(597),
    [sym_continue_statement] = STATE(597),
    [sym_debugger_statement] = STATE(597),
    [sym_return_statement] = STATE(597),
    [sym_throw_statement] = STATE(597),
    [sym_empty_statement] = STATE(597),
    [sym_labeled_statement] = STATE(597),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(597),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(597),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(597),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(597),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(597),
    [sym_abstract_class_declaration] = STATE(597),
    [sym_module] = STATE(597),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(597),
    [sym_interface_declaration] = STATE(597),
    [sym_enum_declaration] = STATE(597),
    [sym_type_alias_declaration] = STATE(597),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [47] = {
    [sym_export_statement] = STATE(530),
    [sym__declaration] = STATE(530),
    [sym_import] = STATE(1224),
    [sym_import_statement] = STATE(530),
    [sym_expression_statement] = STATE(530),
    [sym_variable_declaration] = STATE(530),
    [sym_lexical_declaration] = STATE(530),
    [sym_statement_block] = STATE(530),
    [sym_if_statement] = STATE(530),
    [sym_switch_statement] = STATE(530),
    [sym_for_statement] = STATE(530),
    [sym_for_in_statement] = STATE(530),
    [sym_while_statement] = STATE(530),
    [sym_do_statement] = STATE(530),
    [sym_try_statement] = STATE(530),
    [sym_with_statement] = STATE(530),
    [sym_break_statement] = STATE(530),
    [sym_continue_statement] = STATE(530),
    [sym_debugger_statement] = STATE(530),
    [sym_return_statement] = STATE(530),
    [sym_throw_statement] = STATE(530),
    [sym_empty_statement] = STATE(530),
    [sym_labeled_statement] = STATE(530),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_class_declaration] = STATE(530),
    [sym_function] = STATE(1058),
    [sym_function_declaration] = STATE(530),
    [sym_generator_function] = STATE(1224),
    [sym_generator_function_declaration] = STATE(530),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_function_signature] = STATE(530),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_ambient_declaration] = STATE(530),
    [sym_abstract_class_declaration] = STATE(530),
    [sym_module] = STATE(530),
    [sym_internal_module] = STATE(108),
    [sym_import_alias] = STATE(530),
    [sym_interface_declaration] = STATE(530),
    [sym_enum_declaration] = STATE(530),
    [sym_type_alias_declaration] = STATE(530),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2094),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [48] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [49] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [50] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1107),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [51] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [52] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [53] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1402),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [54] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [55] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [56] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [57] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [58] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [59] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(595),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [60] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(597),
    [anon_sym_of] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [61] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [62] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(611),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [63] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1107),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(613),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [anon_sym_implements] = ACTIONS(493),
    [sym_readonly] = ACTIONS(491),
  },
  [64] = {
    [sym_import] = STATE(1254),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1254),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1254),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1254),
    [sym_arrow_function] = STATE(1254),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1254),
    [sym_new_expression] = STATE(1254),
    [sym_await_expression] = STATE(1254),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1254),
    [sym_augmented_assignment_expression] = STATE(1254),
    [sym_ternary_expression] = STATE(1254),
    [sym_binary_expression] = STATE(1254),
    [sym_unary_expression] = STATE(1254),
    [sym_update_expression] = STATE(1254),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1254),
    [sym_regex] = STATE(1254),
    [sym_meta_property] = STATE(1254),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1254),
    [sym_type_assertion] = STATE(1254),
    [sym_as_expression] = STATE(1254),
    [sym_internal_module] = STATE(1254),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(631),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(635),
    [anon_sym_DASH_EQ] = ACTIONS(635),
    [anon_sym_STAR_EQ] = ACTIONS(635),
    [anon_sym_SLASH_EQ] = ACTIONS(635),
    [anon_sym_PERCENT_EQ] = ACTIONS(635),
    [anon_sym_CARET_EQ] = ACTIONS(635),
    [anon_sym_AMP_EQ] = ACTIONS(635),
    [anon_sym_PIPE_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_LT_LT_EQ] = ACTIONS(635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(647),
    [sym_this] = ACTIONS(649),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_undefined] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [65] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [66] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [67] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1528),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(661),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [68] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1107),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [69] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(665),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [70] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_arguments] = STATE(1402),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(631),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [71] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT] = ACTIONS(661),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS_EQ] = ACTIONS(701),
    [anon_sym_DASH_EQ] = ACTIONS(701),
    [anon_sym_STAR_EQ] = ACTIONS(701),
    [anon_sym_SLASH_EQ] = ACTIONS(701),
    [anon_sym_PERCENT_EQ] = ACTIONS(701),
    [anon_sym_CARET_EQ] = ACTIONS(701),
    [anon_sym_AMP_EQ] = ACTIONS(701),
    [anon_sym_PIPE_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_LT_LT_EQ] = ACTIONS(701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(719),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [72] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [73] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(613),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(757),
    [sym_this] = ACTIONS(759),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(759),
    [sym_false] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [sym_undefined] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(727),
  },
  [74] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(613),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(757),
    [sym_this] = ACTIONS(759),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(759),
    [sym_false] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [sym_undefined] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(727),
  },
  [75] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT] = ACTIONS(661),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS_EQ] = ACTIONS(701),
    [anon_sym_DASH_EQ] = ACTIONS(701),
    [anon_sym_STAR_EQ] = ACTIONS(701),
    [anon_sym_SLASH_EQ] = ACTIONS(701),
    [anon_sym_PERCENT_EQ] = ACTIONS(701),
    [anon_sym_CARET_EQ] = ACTIONS(701),
    [anon_sym_AMP_EQ] = ACTIONS(701),
    [anon_sym_PIPE_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_LT_LT_EQ] = ACTIONS(701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(719),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [76] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [77] = {
    [sym_import] = STATE(1254),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1254),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1254),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1254),
    [sym_arrow_function] = STATE(1254),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1254),
    [sym_new_expression] = STATE(1254),
    [sym_await_expression] = STATE(1254),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1254),
    [sym_augmented_assignment_expression] = STATE(1254),
    [sym_ternary_expression] = STATE(1254),
    [sym_binary_expression] = STATE(1254),
    [sym_unary_expression] = STATE(1254),
    [sym_update_expression] = STATE(1254),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1254),
    [sym_regex] = STATE(1254),
    [sym_meta_property] = STATE(1254),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1254),
    [sym_type_assertion] = STATE(1254),
    [sym_as_expression] = STATE(1254),
    [sym_internal_module] = STATE(1254),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(631),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS_EQ] = ACTIONS(635),
    [anon_sym_DASH_EQ] = ACTIONS(635),
    [anon_sym_STAR_EQ] = ACTIONS(635),
    [anon_sym_SLASH_EQ] = ACTIONS(635),
    [anon_sym_PERCENT_EQ] = ACTIONS(635),
    [anon_sym_CARET_EQ] = ACTIONS(635),
    [anon_sym_AMP_EQ] = ACTIONS(635),
    [anon_sym_PIPE_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_LT_LT_EQ] = ACTIONS(635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(647),
    [sym_this] = ACTIONS(649),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_undefined] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [78] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [79] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(597),
    [anon_sym_of] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [80] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(761),
    [anon_sym_of] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [81] = {
    [sym_import] = STATE(1025),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1025),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1025),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1025),
    [sym_arrow_function] = STATE(1025),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1025),
    [sym_new_expression] = STATE(1025),
    [sym_await_expression] = STATE(1025),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(1025),
    [sym_ternary_expression] = STATE(1025),
    [sym_binary_expression] = STATE(1025),
    [sym_unary_expression] = STATE(1025),
    [sym_update_expression] = STATE(1025),
    [sym_sequence_expression] = STATE(2827),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1025),
    [sym_regex] = STATE(1025),
    [sym_meta_property] = STATE(1025),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1025),
    [sym_type_assertion] = STATE(1025),
    [sym_as_expression] = STATE(1025),
    [sym_internal_module] = STATE(1025),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2418),
    [sym_constructor_type] = STATE(2418),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2418),
    [sym_intersection_type] = STATE(2418),
    [sym_function_type] = STATE(2418),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(776),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(804),
    [sym_false] = ACTIONS(804),
    [sym_null] = ACTIONS(806),
    [sym_undefined] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [sym_readonly] = ACTIONS(812),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [82] = {
    [sym_import] = STATE(1029),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1029),
    [sym_yield_expression] = STATE(1029),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1029),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1029),
    [sym_arrow_function] = STATE(1029),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1029),
    [sym_new_expression] = STATE(1029),
    [sym_await_expression] = STATE(1029),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1029),
    [sym_augmented_assignment_expression] = STATE(1029),
    [sym_ternary_expression] = STATE(1029),
    [sym_binary_expression] = STATE(1029),
    [sym_unary_expression] = STATE(1029),
    [sym_update_expression] = STATE(1029),
    [sym_sequence_expression] = STATE(2904),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1029),
    [sym_regex] = STATE(1029),
    [sym_meta_property] = STATE(1029),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1029),
    [sym_type_assertion] = STATE(1029),
    [sym_as_expression] = STATE(1029),
    [sym_internal_module] = STATE(1029),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2418),
    [sym_constructor_type] = STATE(2418),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2418),
    [sym_intersection_type] = STATE(2418),
    [sym_function_type] = STATE(2418),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(776),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(804),
    [sym_false] = ACTIONS(804),
    [sym_null] = ACTIONS(818),
    [sym_undefined] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [sym_readonly] = ACTIONS(812),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [83] = {
    [sym_import] = STATE(1115),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1115),
    [sym_yield_expression] = STATE(1115),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1115),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1115),
    [sym_arrow_function] = STATE(1115),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1115),
    [sym_new_expression] = STATE(1115),
    [sym_await_expression] = STATE(1115),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1115),
    [sym_augmented_assignment_expression] = STATE(1115),
    [sym_ternary_expression] = STATE(1115),
    [sym_binary_expression] = STATE(1115),
    [sym_unary_expression] = STATE(1115),
    [sym_update_expression] = STATE(1115),
    [sym_sequence_expression] = STATE(2960),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1115),
    [sym_regex] = STATE(1115),
    [sym_meta_property] = STATE(1115),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1115),
    [sym_type_assertion] = STATE(1115),
    [sym_as_expression] = STATE(1115),
    [sym_internal_module] = STATE(1115),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2418),
    [sym_constructor_type] = STATE(2418),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2418),
    [sym_intersection_type] = STATE(2418),
    [sym_function_type] = STATE(2418),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(776),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(804),
    [sym_false] = ACTIONS(804),
    [sym_null] = ACTIONS(820),
    [sym_undefined] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [sym_readonly] = ACTIONS(812),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [84] = {
    [sym_import] = STATE(1029),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1029),
    [sym_yield_expression] = STATE(1029),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1029),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1029),
    [sym_arrow_function] = STATE(1029),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1029),
    [sym_new_expression] = STATE(1029),
    [sym_await_expression] = STATE(1029),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1029),
    [sym_augmented_assignment_expression] = STATE(1029),
    [sym_ternary_expression] = STATE(1029),
    [sym_binary_expression] = STATE(1029),
    [sym_unary_expression] = STATE(1029),
    [sym_update_expression] = STATE(1029),
    [sym_sequence_expression] = STATE(2904),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1029),
    [sym_regex] = STATE(1029),
    [sym_meta_property] = STATE(1029),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1029),
    [sym_type_assertion] = STATE(1029),
    [sym_as_expression] = STATE(1029),
    [sym_internal_module] = STATE(1029),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2415),
    [sym_constructor_type] = STATE(2415),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2415),
    [sym_intersection_type] = STATE(2415),
    [sym_function_type] = STATE(2415),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(776),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(804),
    [sym_false] = ACTIONS(804),
    [sym_null] = ACTIONS(818),
    [sym_undefined] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [sym_readonly] = ACTIONS(812),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [85] = {
    [sym_import] = STATE(1171),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1171),
    [sym_yield_expression] = STATE(1171),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1171),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1171),
    [sym_arrow_function] = STATE(1171),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1171),
    [sym_new_expression] = STATE(1171),
    [sym_await_expression] = STATE(1171),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1171),
    [sym_augmented_assignment_expression] = STATE(1171),
    [sym_spread_element] = STATE(2563),
    [sym_ternary_expression] = STATE(1171),
    [sym_binary_expression] = STATE(1171),
    [sym_unary_expression] = STATE(1171),
    [sym_update_expression] = STATE(1171),
    [sym_string] = STATE(1645),
    [sym_template_string] = STATE(1171),
    [sym_regex] = STATE(1171),
    [sym_meta_property] = STATE(1171),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1171),
    [sym_as_expression] = STATE(1171),
    [sym_internal_module] = STATE(1171),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2185),
    [sym_constructor_type] = STATE(2185),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2185),
    [sym_intersection_type] = STATE(2185),
    [sym_function_type] = STATE(2185),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2564),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(834),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(836),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(842),
    [sym_undefined] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [86] = {
    [sym_import] = STATE(1149),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1149),
    [sym_yield_expression] = STATE(1149),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1149),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1149),
    [sym_arrow_function] = STATE(1149),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1149),
    [sym_augmented_assignment_expression] = STATE(1149),
    [sym_spread_element] = STATE(2501),
    [sym_ternary_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_update_expression] = STATE(1149),
    [sym_string] = STATE(1645),
    [sym_template_string] = STATE(1149),
    [sym_regex] = STATE(1149),
    [sym_meta_property] = STATE(1149),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1149),
    [sym_type_assertion] = STATE(1149),
    [sym_as_expression] = STATE(1149),
    [sym_internal_module] = STATE(1149),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2185),
    [sym_constructor_type] = STATE(2185),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2185),
    [sym_intersection_type] = STATE(2185),
    [sym_function_type] = STATE(2185),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2502),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(834),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(836),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(848),
    [sym_undefined] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [87] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2522),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1645),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1219),
    [sym_type_assertion] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2178),
    [sym_constructor_type] = STATE(2178),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2178),
    [sym_intersection_type] = STATE(2178),
    [sym_function_type] = STATE(2178),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(850),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(834),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(836),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [88] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2522),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1645),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1219),
    [sym_type_assertion] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2185),
    [sym_constructor_type] = STATE(2185),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2185),
    [sym_intersection_type] = STATE(2185),
    [sym_function_type] = STATE(2185),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(850),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(834),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(836),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [89] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_spread_element] = STATE(2468),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1645),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1178),
    [sym_type_assertion] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2185),
    [sym_constructor_type] = STATE(2185),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2185),
    [sym_intersection_type] = STATE(2185),
    [sym_function_type] = STATE(2185),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2470),
    [sym_identifier] = ACTIONS(822),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(854),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(834),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(836),
    [sym_this] = ACTIONS(838),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(856),
    [sym_undefined] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_symbol] = ACTIONS(844),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [90] = {
    [sym_import] = STATE(986),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(986),
    [sym_yield_expression] = STATE(986),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(986),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(986),
    [sym_arrow_function] = STATE(986),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(986),
    [sym_new_expression] = STATE(986),
    [sym_await_expression] = STATE(986),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(986),
    [sym_augmented_assignment_expression] = STATE(986),
    [sym_ternary_expression] = STATE(986),
    [sym_binary_expression] = STATE(986),
    [sym_unary_expression] = STATE(986),
    [sym_update_expression] = STATE(986),
    [sym_string] = STATE(986),
    [sym_template_string] = STATE(986),
    [sym_regex] = STATE(986),
    [sym_meta_property] = STATE(986),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(986),
    [sym_type_assertion] = STATE(986),
    [sym_as_expression] = STATE(986),
    [sym_internal_module] = STATE(986),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(858),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_RBRACE] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(862),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(862),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(864),
    [sym_this] = ACTIONS(866),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(866),
    [sym_false] = ACTIONS(866),
    [sym_null] = ACTIONS(866),
    [sym_undefined] = ACTIONS(866),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [91] = {
    [sym_import] = STATE(1354),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1563),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(320),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(870),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(872),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(876),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(878),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(880),
    [anon_sym_DASH] = ACTIONS(880),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(882),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(884),
    [sym_this] = ACTIONS(886),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(888),
    [sym_false] = ACTIONS(888),
    [sym_null] = ACTIONS(890),
    [sym_undefined] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [sym_readonly] = ACTIONS(617),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [92] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1072),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1182),
    [sym_type_assertion] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(251),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(898),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(904),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(906),
    [sym_this] = ACTIONS(908),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(912),
    [sym_undefined] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(914),
    [anon_sym_number] = ACTIONS(914),
    [anon_sym_boolean] = ACTIONS(914),
    [anon_sym_string] = ACTIONS(914),
    [anon_sym_symbol] = ACTIONS(914),
    [sym_readonly] = ACTIONS(727),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [93] = {
    [sym_import] = STATE(1268),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1268),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1268),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1268),
    [sym_arrow_function] = STATE(1268),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1268),
    [sym_new_expression] = STATE(1268),
    [sym_await_expression] = STATE(1268),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1268),
    [sym_augmented_assignment_expression] = STATE(1268),
    [sym_ternary_expression] = STATE(1268),
    [sym_binary_expression] = STATE(1268),
    [sym_unary_expression] = STATE(1268),
    [sym_update_expression] = STATE(1268),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1268),
    [sym_regex] = STATE(1268),
    [sym_meta_property] = STATE(1268),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1268),
    [sym_type_assertion] = STATE(1268),
    [sym_as_expression] = STATE(1268),
    [sym_internal_module] = STATE(1268),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(402),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(916),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(918),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(926),
    [sym_this] = ACTIONS(928),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_null] = ACTIONS(932),
    [sym_undefined] = ACTIONS(932),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [sym_readonly] = ACTIONS(491),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [94] = {
    [sym_import] = STATE(1154),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1154),
    [sym_yield_expression] = STATE(1154),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1154),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1154),
    [sym_arrow_function] = STATE(1154),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1154),
    [sym_new_expression] = STATE(1154),
    [sym_await_expression] = STATE(1154),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1154),
    [sym_augmented_assignment_expression] = STATE(1154),
    [sym_ternary_expression] = STATE(1154),
    [sym_binary_expression] = STATE(1154),
    [sym_unary_expression] = STATE(1154),
    [sym_update_expression] = STATE(1154),
    [sym_string] = STATE(1565),
    [sym_template_string] = STATE(1154),
    [sym_regex] = STATE(1154),
    [sym_meta_property] = STATE(1154),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1154),
    [sym_type_assertion] = STATE(1154),
    [sym_as_expression] = STATE(1154),
    [sym_internal_module] = STATE(1154),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(382),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(936),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(950),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(952),
    [sym_this] = ACTIONS(954),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(956),
    [sym_false] = ACTIONS(956),
    [sym_null] = ACTIONS(958),
    [sym_undefined] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [95] = {
    [sym_import] = STATE(1074),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1074),
    [sym_yield_expression] = STATE(1074),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1074),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1074),
    [sym_arrow_function] = STATE(1074),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1074),
    [sym_new_expression] = STATE(1074),
    [sym_await_expression] = STATE(1074),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1074),
    [sym_augmented_assignment_expression] = STATE(1074),
    [sym_ternary_expression] = STATE(1074),
    [sym_binary_expression] = STATE(1074),
    [sym_unary_expression] = STATE(1074),
    [sym_update_expression] = STATE(1074),
    [sym_string] = STATE(1074),
    [sym_template_string] = STATE(1074),
    [sym_regex] = STATE(1074),
    [sym_meta_property] = STATE(1074),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1074),
    [sym_type_assertion] = STATE(1074),
    [sym_as_expression] = STATE(1074),
    [sym_internal_module] = STATE(1074),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_RBRACE] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(964),
    [sym_this] = ACTIONS(966),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_null] = ACTIONS(966),
    [sym_undefined] = ACTIONS(966),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(862),
  },
  [96] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2823),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1313),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2439),
    [sym_non_null_expression] = STATE(1315),
    [sym_type_assertion] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1909),
    [sym_constructor_type] = STATE(1909),
    [sym__primary_type] = STATE(1881),
    [sym_generic_type] = STATE(1881),
    [sym_type_predicate] = STATE(1881),
    [sym_type_query] = STATE(1881),
    [sym_index_type_query] = STATE(1881),
    [sym_lookup_type] = STATE(1881),
    [sym_literal_type] = STATE(1881),
    [sym__number] = STATE(1879),
    [sym_existential_type] = STATE(1881),
    [sym_flow_maybe_type] = STATE(1881),
    [sym_parenthesized_type] = STATE(1881),
    [sym_predefined_type] = STATE(1881),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(1881),
    [sym_type_parameters] = STATE(2605),
    [sym_array_type] = STATE(1881),
    [sym_tuple_type] = STATE(1881),
    [sym_union_type] = STATE(1909),
    [sym_intersection_type] = STATE(1909),
    [sym_function_type] = STATE(1909),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(980),
    [anon_sym_QMARK] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_PIPE] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(990),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(992),
    [sym_this] = ACTIONS(994),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(1000),
    [anon_sym_number] = ACTIONS(1000),
    [anon_sym_boolean] = ACTIONS(1000),
    [anon_sym_string] = ACTIONS(1000),
    [anon_sym_symbol] = ACTIONS(1000),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(1002),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1004),
  },
  [97] = {
    [sym_import] = STATE(1065),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1065),
    [sym_yield_expression] = STATE(1065),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1065),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1065),
    [sym_arrow_function] = STATE(1065),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1065),
    [sym_new_expression] = STATE(1065),
    [sym_await_expression] = STATE(1065),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1065),
    [sym_augmented_assignment_expression] = STATE(1065),
    [sym_ternary_expression] = STATE(1065),
    [sym_binary_expression] = STATE(1065),
    [sym_unary_expression] = STATE(1065),
    [sym_update_expression] = STATE(1065),
    [sym_string] = STATE(1465),
    [sym_template_string] = STATE(1065),
    [sym_regex] = STATE(1065),
    [sym_meta_property] = STATE(1065),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(1065),
    [sym_type_assertion] = STATE(1065),
    [sym_as_expression] = STATE(1065),
    [sym_internal_module] = STATE(1065),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(393),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(870),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(1008),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(876),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1014),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1016),
    [sym_this] = ACTIONS(1018),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1022),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(1024),
    [anon_sym_number] = ACTIONS(1024),
    [anon_sym_boolean] = ACTIONS(1024),
    [anon_sym_string] = ACTIONS(1024),
    [anon_sym_symbol] = ACTIONS(1024),
    [sym_readonly] = ACTIONS(443),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [98] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(957),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(1072),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2510),
    [sym_non_null_expression] = STATE(957),
    [sym_type_assertion] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_nested_type_identifier] = STATE(1816),
    [sym__type] = STATE(2136),
    [sym_constructor_type] = STATE(2136),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_type_arguments] = STATE(268),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2686),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2136),
    [sym_intersection_type] = STATE(2136),
    [sym_function_type] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(1028),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1032),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(906),
    [sym_this] = ACTIONS(908),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(1034),
    [sym_undefined] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(1036),
    [anon_sym_number] = ACTIONS(1036),
    [anon_sym_boolean] = ACTIONS(1036),
    [anon_sym_string] = ACTIONS(1036),
    [anon_sym_symbol] = ACTIONS(1036),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [99] = {
    [sym_import] = STATE(1261),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1261),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1261),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1261),
    [sym_arrow_function] = STATE(1261),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1261),
    [sym_new_expression] = STATE(1261),
    [sym_await_expression] = STATE(1261),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1261),
    [sym_ternary_expression] = STATE(1261),
    [sym_binary_expression] = STATE(1261),
    [sym_unary_expression] = STATE(1261),
    [sym_update_expression] = STATE(1261),
    [sym_string] = STATE(1261),
    [sym_template_string] = STATE(1261),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1261),
    [sym_type_assertion] = STATE(1261),
    [sym_as_expression] = STATE(1261),
    [sym_internal_module] = STATE(1261),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(862),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(655),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1040),
    [sym_this] = ACTIONS(1042),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [sym_undefined] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [100] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1201),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1201),
    [sym_type_assertion] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(1044),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1046),
    [sym_this] = ACTIONS(1048),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_undefined] = ACTIONS(1048),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [anon_sym_implements] = ACTIONS(860),
    [sym_readonly] = ACTIONS(727),
  },
  [101] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1218),
    [sym_type_assertion] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1052),
    [sym_this] = ACTIONS(1054),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_null] = ACTIONS(1054),
    [sym_undefined] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
    [anon_sym_LBRACE_PIPE] = ACTIONS(862),
  },
  [102] = {
    [sym_import] = STATE(1275),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1275),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1275),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1275),
    [sym_arrow_function] = STATE(1275),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1275),
    [sym_new_expression] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_ternary_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_update_expression] = STATE(1275),
    [sym_string] = STATE(1275),
    [sym_template_string] = STATE(1275),
    [sym_regex] = STATE(1275),
    [sym_meta_property] = STATE(1275),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1275),
    [sym_type_assertion] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_internal_module] = STATE(1275),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_STAR] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(862),
    [anon_sym_PIPE_PIPE] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(862),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_STAR_STAR] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(862),
    [anon_sym_GT_EQ] = ACTIONS(862),
    [anon_sym_QMARK_QMARK] = ACTIONS(862),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_BANG] = ACTIONS(639),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1058),
    [sym_this] = ACTIONS(1060),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_undefined] = ACTIONS(1060),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(862),
  },
  [103] = {
    [sym_statement_block] = STATE(115),
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_as] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_in] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_GT] = ACTIONS(1064),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_QMARK] = ACTIONS(1064),
    [anon_sym_AMP_AMP] = ACTIONS(1062),
    [anon_sym_PIPE_PIPE] = ACTIONS(1062),
    [anon_sym_GT_GT] = ACTIONS(1064),
    [anon_sym_GT_GT_GT] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1064),
    [anon_sym_CARET] = ACTIONS(1062),
    [anon_sym_PIPE] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PERCENT] = ACTIONS(1062),
    [anon_sym_STAR_STAR] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1062),
    [anon_sym_EQ_EQ] = ACTIONS(1064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1062),
    [anon_sym_BANG_EQ] = ACTIONS(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1062),
    [anon_sym_QMARK_QMARK] = ACTIONS(1062),
    [anon_sym_instanceof] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_number] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_undefined] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
    [sym__automatic_semicolon] = ACTIONS(1062),
  },
  [104] = {
    [sym_statement_block] = STATE(115),
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_as] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_in] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_GT] = ACTIONS(1064),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_DOT] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_QMARK] = ACTIONS(1064),
    [anon_sym_AMP_AMP] = ACTIONS(1062),
    [anon_sym_PIPE_PIPE] = ACTIONS(1062),
    [anon_sym_GT_GT] = ACTIONS(1064),
    [anon_sym_GT_GT_GT] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1064),
    [anon_sym_CARET] = ACTIONS(1062),
    [anon_sym_PIPE] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PERCENT] = ACTIONS(1062),
    [anon_sym_STAR_STAR] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1062),
    [anon_sym_EQ_EQ] = ACTIONS(1064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1062),
    [anon_sym_BANG_EQ] = ACTIONS(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1062),
    [anon_sym_QMARK_QMARK] = ACTIONS(1062),
    [anon_sym_instanceof] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_number] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_undefined] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
    [sym__automatic_semicolon] = ACTIONS(1062),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_EQ] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_var] = ACTIONS(1072),
    [anon_sym_let] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1072),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_debugger] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_throw] = ACTIONS(1072),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_function] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1076),
    [anon_sym_PIPE_PIPE] = ACTIONS(1076),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_GT_GT_GT] = ACTIONS(1076),
    [anon_sym_LT_LT] = ACTIONS(1076),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_CARET] = ACTIONS(1076),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1076),
    [anon_sym_STAR_STAR] = ACTIONS(1076),
    [anon_sym_LT_EQ] = ACTIONS(1076),
    [anon_sym_EQ_EQ] = ACTIONS(1074),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1076),
    [anon_sym_BANG_EQ] = ACTIONS(1074),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1076),
    [anon_sym_GT_EQ] = ACTIONS(1076),
    [anon_sym_QMARK_QMARK] = ACTIONS(1076),
    [anon_sym_instanceof] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_void] = ACTIONS(1072),
    [anon_sym_delete] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [sym_number] = ACTIONS(1070),
    [sym_this] = ACTIONS(1072),
    [sym_super] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_undefined] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_abstract] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_interface] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [sym_readonly] = ACTIONS(1072),
    [sym__automatic_semicolon] = ACTIONS(1078),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_export] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_default] = ACTIONS(1082),
    [anon_sym_as] = ACTIONS(1082),
    [anon_sym_namespace] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1080),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1082),
    [anon_sym_typeof] = ACTIONS(1082),
    [anon_sym_import] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_const] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_in] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_do] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_debugger] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_throw] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1082),
    [anon_sym_GT] = ACTIONS(1082),
    [anon_sym_SLASH] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_function] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_QMARK] = ACTIONS(1082),
    [anon_sym_AMP_AMP] = ACTIONS(1080),
    [anon_sym_PIPE_PIPE] = ACTIONS(1080),
    [anon_sym_GT_GT] = ACTIONS(1082),
    [anon_sym_GT_GT_GT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_CARET] = ACTIONS(1080),
    [anon_sym_PIPE] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1082),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_STAR_STAR] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1080),
    [anon_sym_EQ_EQ] = ACTIONS(1082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ] = ACTIONS(1082),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1080),
    [anon_sym_GT_EQ] = ACTIONS(1080),
    [anon_sym_QMARK_QMARK] = ACTIONS(1080),
    [anon_sym_instanceof] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1082),
    [anon_sym_delete] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1080),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_SQUOTE] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1080),
    [sym_number] = ACTIONS(1080),
    [sym_this] = ACTIONS(1082),
    [sym_super] = ACTIONS(1082),
    [sym_true] = ACTIONS(1082),
    [sym_false] = ACTIONS(1082),
    [sym_null] = ACTIONS(1082),
    [sym_undefined] = ACTIONS(1082),
    [anon_sym_AT] = ACTIONS(1080),
    [anon_sym_static] = ACTIONS(1082),
    [anon_sym_abstract] = ACTIONS(1082),
    [anon_sym_get] = ACTIONS(1082),
    [anon_sym_set] = ACTIONS(1082),
    [anon_sym_declare] = ACTIONS(1082),
    [anon_sym_public] = ACTIONS(1082),
    [anon_sym_private] = ACTIONS(1082),
    [anon_sym_protected] = ACTIONS(1082),
    [anon_sym_module] = ACTIONS(1082),
    [anon_sym_any] = ACTIONS(1082),
    [anon_sym_number] = ACTIONS(1082),
    [anon_sym_boolean] = ACTIONS(1082),
    [anon_sym_string] = ACTIONS(1082),
    [anon_sym_symbol] = ACTIONS(1082),
    [anon_sym_interface] = ACTIONS(1082),
    [anon_sym_enum] = ACTIONS(1082),
    [sym_readonly] = ACTIONS(1082),
    [sym__automatic_semicolon] = ACTIONS(1080),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_export] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1086),
    [anon_sym_as] = ACTIONS(1088),
    [anon_sym_namespace] = ACTIONS(1086),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_typeof] = ACTIONS(1086),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [anon_sym_let] = ACTIONS(1086),
    [anon_sym_const] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1086),
    [anon_sym_switch] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [anon_sym_in] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_do] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_debugger] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_throw] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1086),
    [anon_sym_GT] = ACTIONS(1088),
    [anon_sym_SLASH] = ACTIONS(1086),
    [anon_sym_DOT] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(1086),
    [anon_sym_new] = ACTIONS(1086),
    [anon_sym_QMARK] = ACTIONS(1088),
    [anon_sym_AMP_AMP] = ACTIONS(1090),
    [anon_sym_PIPE_PIPE] = ACTIONS(1090),
    [anon_sym_GT_GT] = ACTIONS(1088),
    [anon_sym_GT_GT_GT] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(1090),
    [anon_sym_PIPE] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_PERCENT] = ACTIONS(1090),
    [anon_sym_STAR_STAR] = ACTIONS(1090),
    [anon_sym_LT_EQ] = ACTIONS(1090),
    [anon_sym_EQ_EQ] = ACTIONS(1088),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1090),
    [anon_sym_BANG_EQ] = ACTIONS(1088),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1090),
    [anon_sym_GT_EQ] = ACTIONS(1090),
    [anon_sym_QMARK_QMARK] = ACTIONS(1090),
    [anon_sym_instanceof] = ACTIONS(1088),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1086),
    [anon_sym_delete] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1084),
    [sym_number] = ACTIONS(1084),
    [sym_this] = ACTIONS(1086),
    [sym_super] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_null] = ACTIONS(1086),
    [sym_undefined] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_static] = ACTIONS(1086),
    [anon_sym_abstract] = ACTIONS(1086),
    [anon_sym_get] = ACTIONS(1086),
    [anon_sym_set] = ACTIONS(1086),
    [anon_sym_declare] = ACTIONS(1086),
    [anon_sym_public] = ACTIONS(1086),
    [anon_sym_private] = ACTIONS(1086),
    [anon_sym_protected] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [anon_sym_any] = ACTIONS(1086),
    [anon_sym_number] = ACTIONS(1086),
    [anon_sym_boolean] = ACTIONS(1086),
    [anon_sym_string] = ACTIONS(1086),
    [anon_sym_symbol] = ACTIONS(1086),
    [anon_sym_interface] = ACTIONS(1086),
    [anon_sym_enum] = ACTIONS(1086),
    [sym_readonly] = ACTIONS(1086),
    [sym__automatic_semicolon] = ACTIONS(1092),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_export] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_as] = ACTIONS(1098),
    [anon_sym_namespace] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_COMMA] = ACTIONS(1100),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [anon_sym_type] = ACTIONS(1096),
    [anon_sym_typeof] = ACTIONS(1096),
    [anon_sym_import] = ACTIONS(1096),
    [anon_sym_var] = ACTIONS(1096),
    [anon_sym_let] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_else] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_await] = ACTIONS(1096),
    [anon_sym_in] = ACTIONS(1098),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_try] = ACTIONS(1096),
    [anon_sym_with] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_debugger] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_throw] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_yield] = ACTIONS(1096),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1096),
    [anon_sym_DOT] = ACTIONS(1098),
    [anon_sym_class] = ACTIONS(1096),
    [anon_sym_async] = ACTIONS(1096),
    [anon_sym_function] = ACTIONS(1096),
    [anon_sym_new] = ACTIONS(1096),
    [anon_sym_QMARK] = ACTIONS(1098),
    [anon_sym_AMP_AMP] = ACTIONS(1100),
    [anon_sym_PIPE_PIPE] = ACTIONS(1100),
    [anon_sym_GT_GT] = ACTIONS(1098),
    [anon_sym_GT_GT_GT] = ACTIONS(1100),
    [anon_sym_LT_LT] = ACTIONS(1100),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_CARET] = ACTIONS(1100),
    [anon_sym_PIPE] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PERCENT] = ACTIONS(1100),
    [anon_sym_STAR_STAR] = ACTIONS(1100),
    [anon_sym_LT_EQ] = ACTIONS(1100),
    [anon_sym_EQ_EQ] = ACTIONS(1098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1100),
    [anon_sym_BANG_EQ] = ACTIONS(1098),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1100),
    [anon_sym_GT_EQ] = ACTIONS(1100),
    [anon_sym_QMARK_QMARK] = ACTIONS(1100),
    [anon_sym_instanceof] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_void] = ACTIONS(1096),
    [anon_sym_delete] = ACTIONS(1096),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1094),
    [sym_number] = ACTIONS(1094),
    [sym_this] = ACTIONS(1096),
    [sym_super] = ACTIONS(1096),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_undefined] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_abstract] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(1096),
    [anon_sym_set] = ACTIONS(1096),
    [anon_sym_declare] = ACTIONS(1096),
    [anon_sym_public] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym_protected] = ACTIONS(1096),
    [anon_sym_module] = ACTIONS(1096),
    [anon_sym_any] = ACTIONS(1096),
    [anon_sym_number] = ACTIONS(1096),
    [anon_sym_boolean] = ACTIONS(1096),
    [anon_sym_string] = ACTIONS(1096),
    [anon_sym_symbol] = ACTIONS(1096),
    [anon_sym_interface] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [sym_readonly] = ACTIONS(1096),
    [sym__automatic_semicolon] = ACTIONS(1100),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_as] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_in] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_QMARK] = ACTIONS(1104),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_GT_GT_GT] = ACTIONS(1102),
    [anon_sym_LT_LT] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1104),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PERCENT] = ACTIONS(1102),
    [anon_sym_STAR_STAR] = ACTIONS(1102),
    [anon_sym_LT_EQ] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1102),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1102),
    [anon_sym_GT_EQ] = ACTIONS(1102),
    [anon_sym_QMARK_QMARK] = ACTIONS(1102),
    [anon_sym_instanceof] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
    [sym__automatic_semicolon] = ACTIONS(1106),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_identifier] = ACTIONS(1110),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_default] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_typeof] = ACTIONS(1110),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_const] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_await] = ACTIONS(1110),
    [anon_sym_in] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_debugger] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_throw] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_async] = ACTIONS(1110),
    [anon_sym_function] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1110),
    [anon_sym_QMARK] = ACTIONS(1110),
    [anon_sym_AMP_AMP] = ACTIONS(1108),
    [anon_sym_PIPE_PIPE] = ACTIONS(1108),
    [anon_sym_GT_GT] = ACTIONS(1110),
    [anon_sym_GT_GT_GT] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1108),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_CARET] = ACTIONS(1108),
    [anon_sym_PIPE] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_PERCENT] = ACTIONS(1108),
    [anon_sym_STAR_STAR] = ACTIONS(1108),
    [anon_sym_LT_EQ] = ACTIONS(1108),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1108),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1108),
    [anon_sym_QMARK_QMARK] = ACTIONS(1108),
    [anon_sym_instanceof] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1110),
    [anon_sym_delete] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [sym_number] = ACTIONS(1108),
    [sym_this] = ACTIONS(1110),
    [sym_super] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_null] = ACTIONS(1110),
    [sym_undefined] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_abstract] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_interface] = ACTIONS(1110),
    [anon_sym_enum] = ACTIONS(1110),
    [sym_readonly] = ACTIONS(1110),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_as] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_in] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_QMARK] = ACTIONS(1104),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_GT_GT_GT] = ACTIONS(1102),
    [anon_sym_LT_LT] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1104),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PERCENT] = ACTIONS(1102),
    [anon_sym_STAR_STAR] = ACTIONS(1102),
    [anon_sym_LT_EQ] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1102),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1102),
    [anon_sym_GT_EQ] = ACTIONS(1102),
    [anon_sym_QMARK_QMARK] = ACTIONS(1102),
    [anon_sym_instanceof] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
    [sym__automatic_semicolon] = ACTIONS(1102),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_as] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_var] = ACTIONS(1072),
    [anon_sym_let] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1072),
    [anon_sym_in] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_debugger] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_throw] = ACTIONS(1072),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_function] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_GT_GT_GT] = ACTIONS(1070),
    [anon_sym_LT_LT] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1070),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1070),
    [anon_sym_STAR_STAR] = ACTIONS(1070),
    [anon_sym_LT_EQ] = ACTIONS(1070),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1070),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1070),
    [anon_sym_GT_EQ] = ACTIONS(1070),
    [anon_sym_QMARK_QMARK] = ACTIONS(1070),
    [anon_sym_instanceof] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_void] = ACTIONS(1072),
    [anon_sym_delete] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [sym_number] = ACTIONS(1070),
    [sym_this] = ACTIONS(1072),
    [sym_super] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_undefined] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_abstract] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_interface] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [sym_readonly] = ACTIONS(1072),
    [sym__automatic_semicolon] = ACTIONS(1112),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_as] = ACTIONS(1118),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_in] = ACTIONS(1118),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_GT] = ACTIONS(1118),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_DOT] = ACTIONS(1118),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_QMARK] = ACTIONS(1118),
    [anon_sym_AMP_AMP] = ACTIONS(1120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1120),
    [anon_sym_GT_GT] = ACTIONS(1118),
    [anon_sym_GT_GT_GT] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1120),
    [anon_sym_PIPE] = ACTIONS(1118),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1120),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK_QMARK] = ACTIONS(1120),
    [anon_sym_instanceof] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_number] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_undefined] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1122),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(1124),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1126),
    [anon_sym_STAR] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(1128),
    [anon_sym_namespace] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1124),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1126),
    [anon_sym_typeof] = ACTIONS(1126),
    [anon_sym_import] = ACTIONS(1126),
    [anon_sym_var] = ACTIONS(1126),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_const] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1126),
    [anon_sym_switch] = ACTIONS(1126),
    [anon_sym_for] = ACTIONS(1126),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_await] = ACTIONS(1126),
    [anon_sym_in] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1126),
    [anon_sym_do] = ACTIONS(1126),
    [anon_sym_try] = ACTIONS(1126),
    [anon_sym_with] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_debugger] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_throw] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1126),
    [anon_sym_yield] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1126),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_SLASH] = ACTIONS(1126),
    [anon_sym_DOT] = ACTIONS(1128),
    [anon_sym_class] = ACTIONS(1126),
    [anon_sym_async] = ACTIONS(1126),
    [anon_sym_function] = ACTIONS(1126),
    [anon_sym_new] = ACTIONS(1126),
    [anon_sym_QMARK] = ACTIONS(1128),
    [anon_sym_AMP_AMP] = ACTIONS(1130),
    [anon_sym_PIPE_PIPE] = ACTIONS(1130),
    [anon_sym_GT_GT] = ACTIONS(1128),
    [anon_sym_GT_GT_GT] = ACTIONS(1130),
    [anon_sym_LT_LT] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1128),
    [anon_sym_CARET] = ACTIONS(1130),
    [anon_sym_PIPE] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1126),
    [anon_sym_PERCENT] = ACTIONS(1130),
    [anon_sym_STAR_STAR] = ACTIONS(1130),
    [anon_sym_LT_EQ] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(1128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1130),
    [anon_sym_GT_EQ] = ACTIONS(1130),
    [anon_sym_QMARK_QMARK] = ACTIONS(1130),
    [anon_sym_instanceof] = ACTIONS(1128),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1126),
    [anon_sym_delete] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_SQUOTE] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1124),
    [sym_number] = ACTIONS(1124),
    [sym_this] = ACTIONS(1126),
    [sym_super] = ACTIONS(1126),
    [sym_true] = ACTIONS(1126),
    [sym_false] = ACTIONS(1126),
    [sym_null] = ACTIONS(1126),
    [sym_undefined] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1124),
    [anon_sym_static] = ACTIONS(1126),
    [anon_sym_abstract] = ACTIONS(1126),
    [anon_sym_get] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1126),
    [anon_sym_declare] = ACTIONS(1126),
    [anon_sym_public] = ACTIONS(1126),
    [anon_sym_private] = ACTIONS(1126),
    [anon_sym_protected] = ACTIONS(1126),
    [anon_sym_module] = ACTIONS(1126),
    [anon_sym_any] = ACTIONS(1126),
    [anon_sym_number] = ACTIONS(1126),
    [anon_sym_boolean] = ACTIONS(1126),
    [anon_sym_string] = ACTIONS(1126),
    [anon_sym_symbol] = ACTIONS(1126),
    [anon_sym_interface] = ACTIONS(1126),
    [anon_sym_enum] = ACTIONS(1126),
    [sym_readonly] = ACTIONS(1126),
    [sym__automatic_semicolon] = ACTIONS(1132),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1134),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_as] = ACTIONS(1136),
    [anon_sym_namespace] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_COMMA] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1136),
    [anon_sym_typeof] = ACTIONS(1136),
    [anon_sym_import] = ACTIONS(1136),
    [anon_sym_var] = ACTIONS(1136),
    [anon_sym_let] = ACTIONS(1136),
    [anon_sym_const] = ACTIONS(1136),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(1136),
    [anon_sym_for] = ACTIONS(1136),
    [anon_sym_LPAREN] = ACTIONS(1134),
    [anon_sym_await] = ACTIONS(1136),
    [anon_sym_in] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(1136),
    [anon_sym_do] = ACTIONS(1136),
    [anon_sym_try] = ACTIONS(1136),
    [anon_sym_with] = ACTIONS(1136),
    [anon_sym_break] = ACTIONS(1136),
    [anon_sym_continue] = ACTIONS(1136),
    [anon_sym_debugger] = ACTIONS(1136),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_throw] = ACTIONS(1136),
    [anon_sym_SEMI] = ACTIONS(1134),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_yield] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_DOT] = ACTIONS(1136),
    [anon_sym_class] = ACTIONS(1136),
    [anon_sym_async] = ACTIONS(1136),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_new] = ACTIONS(1136),
    [anon_sym_QMARK] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1134),
    [anon_sym_PIPE_PIPE] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_GT_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(1134),
    [anon_sym_AMP] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1134),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_PERCENT] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(1134),
    [anon_sym_LT_EQ] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(1136),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1134),
    [anon_sym_GT_EQ] = ACTIONS(1134),
    [anon_sym_QMARK_QMARK] = ACTIONS(1134),
    [anon_sym_instanceof] = ACTIONS(1136),
    [anon_sym_BANG] = ACTIONS(1136),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_void] = ACTIONS(1136),
    [anon_sym_delete] = ACTIONS(1136),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1134),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1134),
    [sym_number] = ACTIONS(1134),
    [sym_this] = ACTIONS(1136),
    [sym_super] = ACTIONS(1136),
    [sym_true] = ACTIONS(1136),
    [sym_false] = ACTIONS(1136),
    [sym_null] = ACTIONS(1136),
    [sym_undefined] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1134),
    [anon_sym_static] = ACTIONS(1136),
    [anon_sym_abstract] = ACTIONS(1136),
    [anon_sym_get] = ACTIONS(1136),
    [anon_sym_set] = ACTIONS(1136),
    [anon_sym_declare] = ACTIONS(1136),
    [anon_sym_public] = ACTIONS(1136),
    [anon_sym_private] = ACTIONS(1136),
    [anon_sym_protected] = ACTIONS(1136),
    [anon_sym_module] = ACTIONS(1136),
    [anon_sym_any] = ACTIONS(1136),
    [anon_sym_number] = ACTIONS(1136),
    [anon_sym_boolean] = ACTIONS(1136),
    [anon_sym_string] = ACTIONS(1136),
    [anon_sym_symbol] = ACTIONS(1136),
    [anon_sym_interface] = ACTIONS(1136),
    [anon_sym_enum] = ACTIONS(1136),
    [sym_readonly] = ACTIONS(1136),
    [sym__automatic_semicolon] = ACTIONS(1134),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_as] = ACTIONS(1142),
    [anon_sym_namespace] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_await] = ACTIONS(1140),
    [anon_sym_in] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_debugger] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_yield] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_DOT] = ACTIONS(1142),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_async] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_QMARK] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1144),
    [anon_sym_PIPE_PIPE] = ACTIONS(1144),
    [anon_sym_GT_GT] = ACTIONS(1142),
    [anon_sym_GT_GT_GT] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1144),
    [anon_sym_AMP] = ACTIONS(1142),
    [anon_sym_CARET] = ACTIONS(1144),
    [anon_sym_PIPE] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_PERCENT] = ACTIONS(1144),
    [anon_sym_STAR_STAR] = ACTIONS(1144),
    [anon_sym_LT_EQ] = ACTIONS(1144),
    [anon_sym_EQ_EQ] = ACTIONS(1142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(1142),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1144),
    [anon_sym_QMARK_QMARK] = ACTIONS(1144),
    [anon_sym_instanceof] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1140),
    [anon_sym_delete] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_number] = ACTIONS(1138),
    [sym_this] = ACTIONS(1140),
    [sym_super] = ACTIONS(1140),
    [sym_true] = ACTIONS(1140),
    [sym_false] = ACTIONS(1140),
    [sym_null] = ACTIONS(1140),
    [sym_undefined] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1140),
    [anon_sym_set] = ACTIONS(1140),
    [anon_sym_declare] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_protected] = ACTIONS(1140),
    [anon_sym_module] = ACTIONS(1140),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1140),
    [sym__automatic_semicolon] = ACTIONS(1146),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_export] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1152),
    [anon_sym_default] = ACTIONS(1150),
    [anon_sym_as] = ACTIONS(1152),
    [anon_sym_namespace] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_COMMA] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(1150),
    [anon_sym_import] = ACTIONS(1150),
    [anon_sym_var] = ACTIONS(1150),
    [anon_sym_let] = ACTIONS(1150),
    [anon_sym_const] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(1150),
    [anon_sym_else] = ACTIONS(1150),
    [anon_sym_switch] = ACTIONS(1150),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_await] = ACTIONS(1150),
    [anon_sym_in] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_do] = ACTIONS(1150),
    [anon_sym_try] = ACTIONS(1150),
    [anon_sym_with] = ACTIONS(1150),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_continue] = ACTIONS(1150),
    [anon_sym_debugger] = ACTIONS(1150),
    [anon_sym_return] = ACTIONS(1150),
    [anon_sym_throw] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_case] = ACTIONS(1150),
    [anon_sym_yield] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_DOT] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(1150),
    [anon_sym_async] = ACTIONS(1150),
    [anon_sym_function] = ACTIONS(1150),
    [anon_sym_new] = ACTIONS(1150),
    [anon_sym_QMARK] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1154),
    [anon_sym_PIPE_PIPE] = ACTIONS(1154),
    [anon_sym_GT_GT] = ACTIONS(1152),
    [anon_sym_GT_GT_GT] = ACTIONS(1154),
    [anon_sym_LT_LT] = ACTIONS(1154),
    [anon_sym_AMP] = ACTIONS(1152),
    [anon_sym_CARET] = ACTIONS(1154),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_PERCENT] = ACTIONS(1154),
    [anon_sym_STAR_STAR] = ACTIONS(1154),
    [anon_sym_LT_EQ] = ACTIONS(1154),
    [anon_sym_EQ_EQ] = ACTIONS(1152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1152),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1154),
    [anon_sym_GT_EQ] = ACTIONS(1154),
    [anon_sym_QMARK_QMARK] = ACTIONS(1154),
    [anon_sym_instanceof] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_void] = ACTIONS(1150),
    [anon_sym_delete] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [sym_number] = ACTIONS(1148),
    [sym_this] = ACTIONS(1150),
    [sym_super] = ACTIONS(1150),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_null] = ACTIONS(1150),
    [sym_undefined] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1150),
    [anon_sym_abstract] = ACTIONS(1150),
    [anon_sym_get] = ACTIONS(1150),
    [anon_sym_set] = ACTIONS(1150),
    [anon_sym_declare] = ACTIONS(1150),
    [anon_sym_public] = ACTIONS(1150),
    [anon_sym_private] = ACTIONS(1150),
    [anon_sym_protected] = ACTIONS(1150),
    [anon_sym_module] = ACTIONS(1150),
    [anon_sym_any] = ACTIONS(1150),
    [anon_sym_number] = ACTIONS(1150),
    [anon_sym_boolean] = ACTIONS(1150),
    [anon_sym_string] = ACTIONS(1150),
    [anon_sym_symbol] = ACTIONS(1150),
    [anon_sym_interface] = ACTIONS(1150),
    [anon_sym_enum] = ACTIONS(1150),
    [sym_readonly] = ACTIONS(1150),
    [sym__automatic_semicolon] = ACTIONS(1156),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_export] = ACTIONS(1160),
    [anon_sym_STAR] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_as] = ACTIONS(1160),
    [anon_sym_namespace] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1160),
    [anon_sym_typeof] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [anon_sym_let] = ACTIONS(1160),
    [anon_sym_const] = ACTIONS(1160),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_await] = ACTIONS(1160),
    [anon_sym_in] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_with] = ACTIONS(1160),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_debugger] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1160),
    [anon_sym_GT] = ACTIONS(1160),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_DOT] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_async] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_QMARK] = ACTIONS(1160),
    [anon_sym_AMP_AMP] = ACTIONS(1158),
    [anon_sym_PIPE_PIPE] = ACTIONS(1158),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_GT_GT_GT] = ACTIONS(1158),
    [anon_sym_LT_LT] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(1160),
    [anon_sym_CARET] = ACTIONS(1158),
    [anon_sym_PIPE] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_PERCENT] = ACTIONS(1158),
    [anon_sym_STAR_STAR] = ACTIONS(1158),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_EQ_EQ] = ACTIONS(1160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1158),
    [anon_sym_BANG_EQ] = ACTIONS(1160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1158),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_QMARK_QMARK] = ACTIONS(1158),
    [anon_sym_instanceof] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1160),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1160),
    [anon_sym_delete] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1158),
    [sym_this] = ACTIONS(1160),
    [sym_super] = ACTIONS(1160),
    [sym_true] = ACTIONS(1160),
    [sym_false] = ACTIONS(1160),
    [sym_null] = ACTIONS(1160),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_get] = ACTIONS(1160),
    [anon_sym_set] = ACTIONS(1160),
    [anon_sym_declare] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_protected] = ACTIONS(1160),
    [anon_sym_module] = ACTIONS(1160),
    [anon_sym_any] = ACTIONS(1160),
    [anon_sym_number] = ACTIONS(1160),
    [anon_sym_boolean] = ACTIONS(1160),
    [anon_sym_string] = ACTIONS(1160),
    [anon_sym_symbol] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [sym_readonly] = ACTIONS(1160),
    [sym__automatic_semicolon] = ACTIONS(1158),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_default] = ACTIONS(1164),
    [anon_sym_as] = ACTIONS(1164),
    [anon_sym_namespace] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1164),
    [anon_sym_typeof] = ACTIONS(1164),
    [anon_sym_import] = ACTIONS(1164),
    [anon_sym_var] = ACTIONS(1164),
    [anon_sym_let] = ACTIONS(1164),
    [anon_sym_const] = ACTIONS(1164),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_else] = ACTIONS(1164),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_await] = ACTIONS(1164),
    [anon_sym_in] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1164),
    [anon_sym_do] = ACTIONS(1164),
    [anon_sym_try] = ACTIONS(1164),
    [anon_sym_with] = ACTIONS(1164),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [anon_sym_debugger] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_throw] = ACTIONS(1164),
    [anon_sym_SEMI] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1164),
    [anon_sym_yield] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_LT] = ACTIONS(1164),
    [anon_sym_GT] = ACTIONS(1164),
    [anon_sym_SLASH] = ACTIONS(1164),
    [anon_sym_DOT] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(1164),
    [anon_sym_async] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_new] = ACTIONS(1164),
    [anon_sym_QMARK] = ACTIONS(1164),
    [anon_sym_AMP_AMP] = ACTIONS(1162),
    [anon_sym_PIPE_PIPE] = ACTIONS(1162),
    [anon_sym_GT_GT] = ACTIONS(1164),
    [anon_sym_GT_GT_GT] = ACTIONS(1162),
    [anon_sym_LT_LT] = ACTIONS(1162),
    [anon_sym_AMP] = ACTIONS(1164),
    [anon_sym_CARET] = ACTIONS(1162),
    [anon_sym_PIPE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_PERCENT] = ACTIONS(1162),
    [anon_sym_STAR_STAR] = ACTIONS(1162),
    [anon_sym_LT_EQ] = ACTIONS(1162),
    [anon_sym_EQ_EQ] = ACTIONS(1164),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1162),
    [anon_sym_BANG_EQ] = ACTIONS(1164),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1162),
    [anon_sym_GT_EQ] = ACTIONS(1162),
    [anon_sym_QMARK_QMARK] = ACTIONS(1162),
    [anon_sym_instanceof] = ACTIONS(1164),
    [anon_sym_BANG] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_void] = ACTIONS(1164),
    [anon_sym_delete] = ACTIONS(1164),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [sym_number] = ACTIONS(1162),
    [sym_this] = ACTIONS(1164),
    [sym_super] = ACTIONS(1164),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1162),
    [anon_sym_static] = ACTIONS(1164),
    [anon_sym_abstract] = ACTIONS(1164),
    [anon_sym_get] = ACTIONS(1164),
    [anon_sym_set] = ACTIONS(1164),
    [anon_sym_declare] = ACTIONS(1164),
    [anon_sym_public] = ACTIONS(1164),
    [anon_sym_private] = ACTIONS(1164),
    [anon_sym_protected] = ACTIONS(1164),
    [anon_sym_module] = ACTIONS(1164),
    [anon_sym_any] = ACTIONS(1164),
    [anon_sym_number] = ACTIONS(1164),
    [anon_sym_boolean] = ACTIONS(1164),
    [anon_sym_string] = ACTIONS(1164),
    [anon_sym_symbol] = ACTIONS(1164),
    [anon_sym_interface] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(1164),
    [sym_readonly] = ACTIONS(1164),
    [sym__automatic_semicolon] = ACTIONS(1162),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_export] = ACTIONS(1168),
    [anon_sym_STAR] = ACTIONS(1168),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_as] = ACTIONS(1168),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_COMMA] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_const] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_await] = ACTIONS(1168),
    [anon_sym_in] = ACTIONS(1168),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_debugger] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_yield] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_DOT] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_async] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_QMARK] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [anon_sym_GT_GT_GT] = ACTIONS(1166),
    [anon_sym_LT_LT] = ACTIONS(1166),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_CARET] = ACTIONS(1166),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_PERCENT] = ACTIONS(1166),
    [anon_sym_STAR_STAR] = ACTIONS(1166),
    [anon_sym_LT_EQ] = ACTIONS(1166),
    [anon_sym_EQ_EQ] = ACTIONS(1168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1166),
    [anon_sym_BANG_EQ] = ACTIONS(1168),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1166),
    [anon_sym_GT_EQ] = ACTIONS(1166),
    [anon_sym_QMARK_QMARK] = ACTIONS(1166),
    [anon_sym_instanceof] = ACTIONS(1168),
    [anon_sym_BANG] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_void] = ACTIONS(1168),
    [anon_sym_delete] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [sym_number] = ACTIONS(1166),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(1168),
    [sym_true] = ACTIONS(1168),
    [sym_false] = ACTIONS(1168),
    [sym_null] = ACTIONS(1168),
    [sym_undefined] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1166),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_get] = ACTIONS(1168),
    [anon_sym_set] = ACTIONS(1168),
    [anon_sym_declare] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_protected] = ACTIONS(1168),
    [anon_sym_module] = ACTIONS(1168),
    [anon_sym_any] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_boolean] = ACTIONS(1168),
    [anon_sym_string] = ACTIONS(1168),
    [anon_sym_symbol] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [sym_readonly] = ACTIONS(1168),
    [sym__automatic_semicolon] = ACTIONS(1166),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_export] = ACTIONS(1172),
    [anon_sym_STAR] = ACTIONS(1174),
    [anon_sym_default] = ACTIONS(1172),
    [anon_sym_as] = ACTIONS(1174),
    [anon_sym_namespace] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_COMMA] = ACTIONS(1176),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_type] = ACTIONS(1172),
    [anon_sym_typeof] = ACTIONS(1172),
    [anon_sym_import] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_const] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1172),
    [anon_sym_switch] = ACTIONS(1172),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [anon_sym_await] = ACTIONS(1172),
    [anon_sym_in] = ACTIONS(1174),
    [anon_sym_while] = ACTIONS(1172),
    [anon_sym_do] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_with] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_debugger] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_throw] = ACTIONS(1172),
    [anon_sym_SEMI] = ACTIONS(1170),
    [anon_sym_case] = ACTIONS(1172),
    [anon_sym_yield] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LT] = ACTIONS(1172),
    [anon_sym_GT] = ACTIONS(1174),
    [anon_sym_SLASH] = ACTIONS(1172),
    [anon_sym_DOT] = ACTIONS(1174),
    [anon_sym_class] = ACTIONS(1172),
    [anon_sym_async] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(1172),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_QMARK] = ACTIONS(1174),
    [anon_sym_AMP_AMP] = ACTIONS(1176),
    [anon_sym_PIPE_PIPE] = ACTIONS(1176),
    [anon_sym_GT_GT] = ACTIONS(1174),
    [anon_sym_GT_GT_GT] = ACTIONS(1176),
    [anon_sym_LT_LT] = ACTIONS(1176),
    [anon_sym_AMP] = ACTIONS(1174),
    [anon_sym_CARET] = ACTIONS(1176),
    [anon_sym_PIPE] = ACTIONS(1174),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_PERCENT] = ACTIONS(1176),
    [anon_sym_STAR_STAR] = ACTIONS(1176),
    [anon_sym_LT_EQ] = ACTIONS(1176),
    [anon_sym_EQ_EQ] = ACTIONS(1174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1176),
    [anon_sym_BANG_EQ] = ACTIONS(1174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1176),
    [anon_sym_GT_EQ] = ACTIONS(1176),
    [anon_sym_QMARK_QMARK] = ACTIONS(1176),
    [anon_sym_instanceof] = ACTIONS(1174),
    [anon_sym_BANG] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_void] = ACTIONS(1172),
    [anon_sym_delete] = ACTIONS(1172),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [sym_number] = ACTIONS(1170),
    [sym_this] = ACTIONS(1172),
    [sym_super] = ACTIONS(1172),
    [sym_true] = ACTIONS(1172),
    [sym_false] = ACTIONS(1172),
    [sym_null] = ACTIONS(1172),
    [sym_undefined] = ACTIONS(1172),
    [anon_sym_AT] = ACTIONS(1170),
    [anon_sym_static] = ACTIONS(1172),
    [anon_sym_abstract] = ACTIONS(1172),
    [anon_sym_get] = ACTIONS(1172),
    [anon_sym_set] = ACTIONS(1172),
    [anon_sym_declare] = ACTIONS(1172),
    [anon_sym_public] = ACTIONS(1172),
    [anon_sym_private] = ACTIONS(1172),
    [anon_sym_protected] = ACTIONS(1172),
    [anon_sym_module] = ACTIONS(1172),
    [anon_sym_any] = ACTIONS(1172),
    [anon_sym_number] = ACTIONS(1172),
    [anon_sym_boolean] = ACTIONS(1172),
    [anon_sym_string] = ACTIONS(1172),
    [anon_sym_symbol] = ACTIONS(1172),
    [anon_sym_interface] = ACTIONS(1172),
    [anon_sym_enum] = ACTIONS(1172),
    [sym_readonly] = ACTIONS(1172),
    [sym__automatic_semicolon] = ACTIONS(1178),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1180),
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1184),
    [anon_sym_default] = ACTIONS(1182),
    [anon_sym_as] = ACTIONS(1184),
    [anon_sym_namespace] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_typeof] = ACTIONS(1182),
    [anon_sym_import] = ACTIONS(1182),
    [anon_sym_var] = ACTIONS(1182),
    [anon_sym_let] = ACTIONS(1182),
    [anon_sym_const] = ACTIONS(1182),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_else] = ACTIONS(1182),
    [anon_sym_switch] = ACTIONS(1182),
    [anon_sym_for] = ACTIONS(1182),
    [anon_sym_LPAREN] = ACTIONS(1180),
    [anon_sym_await] = ACTIONS(1182),
    [anon_sym_in] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1182),
    [anon_sym_do] = ACTIONS(1182),
    [anon_sym_try] = ACTIONS(1182),
    [anon_sym_with] = ACTIONS(1182),
    [anon_sym_break] = ACTIONS(1182),
    [anon_sym_continue] = ACTIONS(1182),
    [anon_sym_debugger] = ACTIONS(1182),
    [anon_sym_return] = ACTIONS(1182),
    [anon_sym_throw] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1180),
    [anon_sym_case] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1182),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_LT] = ACTIONS(1182),
    [anon_sym_GT] = ACTIONS(1184),
    [anon_sym_SLASH] = ACTIONS(1182),
    [anon_sym_DOT] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(1182),
    [anon_sym_async] = ACTIONS(1182),
    [anon_sym_function] = ACTIONS(1182),
    [anon_sym_new] = ACTIONS(1182),
    [anon_sym_QMARK] = ACTIONS(1184),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_PIPE_PIPE] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1184),
    [anon_sym_GT_GT_GT] = ACTIONS(1186),
    [anon_sym_LT_LT] = ACTIONS(1186),
    [anon_sym_AMP] = ACTIONS(1184),
    [anon_sym_CARET] = ACTIONS(1186),
    [anon_sym_PIPE] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_DASH] = ACTIONS(1182),
    [anon_sym_PERCENT] = ACTIONS(1186),
    [anon_sym_STAR_STAR] = ACTIONS(1186),
    [anon_sym_LT_EQ] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1186),
    [anon_sym_BANG_EQ] = ACTIONS(1184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1186),
    [anon_sym_GT_EQ] = ACTIONS(1186),
    [anon_sym_QMARK_QMARK] = ACTIONS(1186),
    [anon_sym_instanceof] = ACTIONS(1184),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_TILDE] = ACTIONS(1180),
    [anon_sym_void] = ACTIONS(1182),
    [anon_sym_delete] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1180),
    [anon_sym_DASH_DASH] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1180),
    [sym_number] = ACTIONS(1180),
    [sym_this] = ACTIONS(1182),
    [sym_super] = ACTIONS(1182),
    [sym_true] = ACTIONS(1182),
    [sym_false] = ACTIONS(1182),
    [sym_null] = ACTIONS(1182),
    [sym_undefined] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_abstract] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_interface] = ACTIONS(1182),
    [anon_sym_enum] = ACTIONS(1182),
    [sym_readonly] = ACTIONS(1182),
    [sym__automatic_semicolon] = ACTIONS(1188),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_export] = ACTIONS(1192),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_default] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_typeof] = ACTIONS(1192),
    [anon_sym_import] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_const] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_switch] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_await] = ACTIONS(1192),
    [anon_sym_in] = ACTIONS(1194),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_do] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_debugger] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_throw] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1190),
    [anon_sym_case] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1192),
    [anon_sym_DOT] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1192),
    [anon_sym_function] = ACTIONS(1192),
    [anon_sym_new] = ACTIONS(1192),
    [anon_sym_QMARK] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_PIPE_PIPE] = ACTIONS(1196),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_GT_GT_GT] = ACTIONS(1196),
    [anon_sym_LT_LT] = ACTIONS(1196),
    [anon_sym_AMP] = ACTIONS(1194),
    [anon_sym_CARET] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_PERCENT] = ACTIONS(1196),
    [anon_sym_STAR_STAR] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1196),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1196),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1196),
    [anon_sym_QMARK_QMARK] = ACTIONS(1196),
    [anon_sym_instanceof] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_void] = ACTIONS(1192),
    [anon_sym_delete] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [sym_number] = ACTIONS(1190),
    [sym_this] = ACTIONS(1192),
    [sym_super] = ACTIONS(1192),
    [sym_true] = ACTIONS(1192),
    [sym_false] = ACTIONS(1192),
    [sym_null] = ACTIONS(1192),
    [sym_undefined] = ACTIONS(1192),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_abstract] = ACTIONS(1192),
    [anon_sym_get] = ACTIONS(1192),
    [anon_sym_set] = ACTIONS(1192),
    [anon_sym_declare] = ACTIONS(1192),
    [anon_sym_public] = ACTIONS(1192),
    [anon_sym_private] = ACTIONS(1192),
    [anon_sym_protected] = ACTIONS(1192),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1192),
    [anon_sym_number] = ACTIONS(1192),
    [anon_sym_boolean] = ACTIONS(1192),
    [anon_sym_string] = ACTIONS(1192),
    [anon_sym_symbol] = ACTIONS(1192),
    [anon_sym_interface] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [sym_readonly] = ACTIONS(1192),
    [sym__automatic_semicolon] = ACTIONS(1198),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1200),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_export] = ACTIONS(1202),
    [anon_sym_STAR] = ACTIONS(1202),
    [anon_sym_default] = ACTIONS(1202),
    [anon_sym_as] = ACTIONS(1202),
    [anon_sym_namespace] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1200),
    [anon_sym_COMMA] = ACTIONS(1200),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1202),
    [anon_sym_var] = ACTIONS(1202),
    [anon_sym_let] = ACTIONS(1202),
    [anon_sym_const] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_else] = ACTIONS(1202),
    [anon_sym_switch] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1202),
    [anon_sym_LPAREN] = ACTIONS(1200),
    [anon_sym_await] = ACTIONS(1202),
    [anon_sym_in] = ACTIONS(1202),
    [anon_sym_while] = ACTIONS(1202),
    [anon_sym_do] = ACTIONS(1202),
    [anon_sym_try] = ACTIONS(1202),
    [anon_sym_with] = ACTIONS(1202),
    [anon_sym_break] = ACTIONS(1202),
    [anon_sym_continue] = ACTIONS(1202),
    [anon_sym_debugger] = ACTIONS(1202),
    [anon_sym_return] = ACTIONS(1202),
    [anon_sym_throw] = ACTIONS(1202),
    [anon_sym_SEMI] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(1202),
    [anon_sym_DOT] = ACTIONS(1202),
    [anon_sym_class] = ACTIONS(1202),
    [anon_sym_async] = ACTIONS(1202),
    [anon_sym_function] = ACTIONS(1202),
    [anon_sym_new] = ACTIONS(1202),
    [anon_sym_QMARK] = ACTIONS(1202),
    [anon_sym_AMP_AMP] = ACTIONS(1200),
    [anon_sym_PIPE_PIPE] = ACTIONS(1200),
    [anon_sym_GT_GT] = ACTIONS(1202),
    [anon_sym_GT_GT_GT] = ACTIONS(1200),
    [anon_sym_LT_LT] = ACTIONS(1200),
    [anon_sym_AMP] = ACTIONS(1202),
    [anon_sym_CARET] = ACTIONS(1200),
    [anon_sym_PIPE] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(1202),
    [anon_sym_DASH] = ACTIONS(1202),
    [anon_sym_PERCENT] = ACTIONS(1200),
    [anon_sym_STAR_STAR] = ACTIONS(1200),
    [anon_sym_LT_EQ] = ACTIONS(1200),
    [anon_sym_EQ_EQ] = ACTIONS(1202),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1200),
    [anon_sym_BANG_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1200),
    [anon_sym_GT_EQ] = ACTIONS(1200),
    [anon_sym_QMARK_QMARK] = ACTIONS(1200),
    [anon_sym_instanceof] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(1200),
    [anon_sym_void] = ACTIONS(1202),
    [anon_sym_delete] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1200),
    [anon_sym_DASH_DASH] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1200),
    [anon_sym_SQUOTE] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1200),
    [sym_number] = ACTIONS(1200),
    [sym_this] = ACTIONS(1202),
    [sym_super] = ACTIONS(1202),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_null] = ACTIONS(1202),
    [sym_undefined] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_static] = ACTIONS(1202),
    [anon_sym_abstract] = ACTIONS(1202),
    [anon_sym_get] = ACTIONS(1202),
    [anon_sym_set] = ACTIONS(1202),
    [anon_sym_declare] = ACTIONS(1202),
    [anon_sym_public] = ACTIONS(1202),
    [anon_sym_private] = ACTIONS(1202),
    [anon_sym_protected] = ACTIONS(1202),
    [anon_sym_module] = ACTIONS(1202),
    [anon_sym_any] = ACTIONS(1202),
    [anon_sym_number] = ACTIONS(1202),
    [anon_sym_boolean] = ACTIONS(1202),
    [anon_sym_string] = ACTIONS(1202),
    [anon_sym_symbol] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1202),
    [anon_sym_enum] = ACTIONS(1202),
    [sym_readonly] = ACTIONS(1202),
    [sym__automatic_semicolon] = ACTIONS(1200),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1204),
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_export] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1206),
    [anon_sym_as] = ACTIONS(1208),
    [anon_sym_namespace] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_COMMA] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1204),
    [anon_sym_type] = ACTIONS(1206),
    [anon_sym_typeof] = ACTIONS(1206),
    [anon_sym_import] = ACTIONS(1206),
    [anon_sym_var] = ACTIONS(1206),
    [anon_sym_let] = ACTIONS(1206),
    [anon_sym_const] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_else] = ACTIONS(1206),
    [anon_sym_switch] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1204),
    [anon_sym_await] = ACTIONS(1206),
    [anon_sym_in] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1206),
    [anon_sym_do] = ACTIONS(1206),
    [anon_sym_try] = ACTIONS(1206),
    [anon_sym_with] = ACTIONS(1206),
    [anon_sym_break] = ACTIONS(1206),
    [anon_sym_continue] = ACTIONS(1206),
    [anon_sym_debugger] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1206),
    [anon_sym_throw] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_case] = ACTIONS(1206),
    [anon_sym_yield] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_SLASH] = ACTIONS(1206),
    [anon_sym_DOT] = ACTIONS(1208),
    [anon_sym_class] = ACTIONS(1206),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1206),
    [anon_sym_new] = ACTIONS(1206),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_AMP_AMP] = ACTIONS(1210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1210),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_GT_GT_GT] = ACTIONS(1210),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1210),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1206),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1210),
    [anon_sym_LT_EQ] = ACTIONS(1210),
    [anon_sym_EQ_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ] = ACTIONS(1208),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1210),
    [anon_sym_GT_EQ] = ACTIONS(1210),
    [anon_sym_QMARK_QMARK] = ACTIONS(1210),
    [anon_sym_instanceof] = ACTIONS(1208),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_void] = ACTIONS(1206),
    [anon_sym_delete] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_SQUOTE] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [sym_number] = ACTIONS(1204),
    [sym_this] = ACTIONS(1206),
    [sym_super] = ACTIONS(1206),
    [sym_true] = ACTIONS(1206),
    [sym_false] = ACTIONS(1206),
    [sym_null] = ACTIONS(1206),
    [sym_undefined] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_static] = ACTIONS(1206),
    [anon_sym_abstract] = ACTIONS(1206),
    [anon_sym_get] = ACTIONS(1206),
    [anon_sym_set] = ACTIONS(1206),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_public] = ACTIONS(1206),
    [anon_sym_private] = ACTIONS(1206),
    [anon_sym_protected] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1206),
    [anon_sym_any] = ACTIONS(1206),
    [anon_sym_number] = ACTIONS(1206),
    [anon_sym_boolean] = ACTIONS(1206),
    [anon_sym_string] = ACTIONS(1206),
    [anon_sym_symbol] = ACTIONS(1206),
    [anon_sym_interface] = ACTIONS(1206),
    [anon_sym_enum] = ACTIONS(1206),
    [sym_readonly] = ACTIONS(1206),
    [sym__automatic_semicolon] = ACTIONS(1212),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1216),
    [anon_sym_export] = ACTIONS(1216),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_default] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1220),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1216),
    [anon_sym_typeof] = ACTIONS(1216),
    [anon_sym_import] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1216),
    [anon_sym_switch] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_await] = ACTIONS(1216),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1216),
    [anon_sym_do] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_with] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_debugger] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_throw] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_case] = ACTIONS(1216),
    [anon_sym_yield] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1216),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1216),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1216),
    [anon_sym_async] = ACTIONS(1216),
    [anon_sym_function] = ACTIONS(1216),
    [anon_sym_new] = ACTIONS(1216),
    [anon_sym_QMARK] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1220),
    [anon_sym_PIPE_PIPE] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(1220),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_PERCENT] = ACTIONS(1220),
    [anon_sym_STAR_STAR] = ACTIONS(1220),
    [anon_sym_LT_EQ] = ACTIONS(1220),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1220),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1220),
    [anon_sym_GT_EQ] = ACTIONS(1220),
    [anon_sym_QMARK_QMARK] = ACTIONS(1220),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1216),
    [anon_sym_delete] = ACTIONS(1216),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [sym_number] = ACTIONS(1214),
    [sym_this] = ACTIONS(1216),
    [sym_super] = ACTIONS(1216),
    [sym_true] = ACTIONS(1216),
    [sym_false] = ACTIONS(1216),
    [sym_null] = ACTIONS(1216),
    [sym_undefined] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_static] = ACTIONS(1216),
    [anon_sym_abstract] = ACTIONS(1216),
    [anon_sym_get] = ACTIONS(1216),
    [anon_sym_set] = ACTIONS(1216),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1216),
    [anon_sym_private] = ACTIONS(1216),
    [anon_sym_protected] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1216),
    [anon_sym_any] = ACTIONS(1216),
    [anon_sym_number] = ACTIONS(1216),
    [anon_sym_boolean] = ACTIONS(1216),
    [anon_sym_string] = ACTIONS(1216),
    [anon_sym_symbol] = ACTIONS(1216),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_enum] = ACTIONS(1216),
    [sym_readonly] = ACTIONS(1216),
    [sym__automatic_semicolon] = ACTIONS(1222),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_export] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(1226),
    [anon_sym_default] = ACTIONS(1226),
    [anon_sym_as] = ACTIONS(1226),
    [anon_sym_namespace] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1224),
    [anon_sym_COMMA] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1226),
    [anon_sym_import] = ACTIONS(1226),
    [anon_sym_var] = ACTIONS(1226),
    [anon_sym_let] = ACTIONS(1226),
    [anon_sym_const] = ACTIONS(1226),
    [anon_sym_if] = ACTIONS(1226),
    [anon_sym_else] = ACTIONS(1226),
    [anon_sym_switch] = ACTIONS(1226),
    [anon_sym_for] = ACTIONS(1226),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1226),
    [anon_sym_in] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1226),
    [anon_sym_do] = ACTIONS(1226),
    [anon_sym_try] = ACTIONS(1226),
    [anon_sym_with] = ACTIONS(1226),
    [anon_sym_break] = ACTIONS(1226),
    [anon_sym_continue] = ACTIONS(1226),
    [anon_sym_debugger] = ACTIONS(1226),
    [anon_sym_return] = ACTIONS(1226),
    [anon_sym_throw] = ACTIONS(1226),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_case] = ACTIONS(1226),
    [anon_sym_yield] = ACTIONS(1226),
    [anon_sym_LBRACK] = ACTIONS(1224),
    [anon_sym_LT] = ACTIONS(1226),
    [anon_sym_GT] = ACTIONS(1226),
    [anon_sym_SLASH] = ACTIONS(1226),
    [anon_sym_DOT] = ACTIONS(1226),
    [anon_sym_class] = ACTIONS(1226),
    [anon_sym_async] = ACTIONS(1226),
    [anon_sym_function] = ACTIONS(1226),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_QMARK] = ACTIONS(1226),
    [anon_sym_AMP_AMP] = ACTIONS(1224),
    [anon_sym_PIPE_PIPE] = ACTIONS(1224),
    [anon_sym_GT_GT] = ACTIONS(1226),
    [anon_sym_GT_GT_GT] = ACTIONS(1224),
    [anon_sym_LT_LT] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1226),
    [anon_sym_CARET] = ACTIONS(1224),
    [anon_sym_PIPE] = ACTIONS(1226),
    [anon_sym_PLUS] = ACTIONS(1226),
    [anon_sym_DASH] = ACTIONS(1226),
    [anon_sym_PERCENT] = ACTIONS(1224),
    [anon_sym_STAR_STAR] = ACTIONS(1224),
    [anon_sym_LT_EQ] = ACTIONS(1224),
    [anon_sym_EQ_EQ] = ACTIONS(1226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1224),
    [anon_sym_BANG_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1224),
    [anon_sym_GT_EQ] = ACTIONS(1224),
    [anon_sym_QMARK_QMARK] = ACTIONS(1224),
    [anon_sym_instanceof] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1226),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(1226),
    [anon_sym_delete] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1224),
    [anon_sym_DASH_DASH] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(1224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1224),
    [sym_number] = ACTIONS(1224),
    [sym_this] = ACTIONS(1226),
    [sym_super] = ACTIONS(1226),
    [sym_true] = ACTIONS(1226),
    [sym_false] = ACTIONS(1226),
    [sym_null] = ACTIONS(1226),
    [sym_undefined] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_static] = ACTIONS(1226),
    [anon_sym_abstract] = ACTIONS(1226),
    [anon_sym_get] = ACTIONS(1226),
    [anon_sym_set] = ACTIONS(1226),
    [anon_sym_declare] = ACTIONS(1226),
    [anon_sym_public] = ACTIONS(1226),
    [anon_sym_private] = ACTIONS(1226),
    [anon_sym_protected] = ACTIONS(1226),
    [anon_sym_module] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(1226),
    [anon_sym_number] = ACTIONS(1226),
    [anon_sym_boolean] = ACTIONS(1226),
    [anon_sym_string] = ACTIONS(1226),
    [anon_sym_symbol] = ACTIONS(1226),
    [anon_sym_interface] = ACTIONS(1226),
    [anon_sym_enum] = ACTIONS(1226),
    [sym_readonly] = ACTIONS(1226),
    [sym__automatic_semicolon] = ACTIONS(1224),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1228),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_default] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(1232),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_COMMA] = ACTIONS(1234),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_var] = ACTIONS(1230),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_const] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_else] = ACTIONS(1230),
    [anon_sym_switch] = ACTIONS(1230),
    [anon_sym_for] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1228),
    [anon_sym_await] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1230),
    [anon_sym_do] = ACTIONS(1230),
    [anon_sym_try] = ACTIONS(1230),
    [anon_sym_with] = ACTIONS(1230),
    [anon_sym_break] = ACTIONS(1230),
    [anon_sym_continue] = ACTIONS(1230),
    [anon_sym_debugger] = ACTIONS(1230),
    [anon_sym_return] = ACTIONS(1230),
    [anon_sym_throw] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_case] = ACTIONS(1230),
    [anon_sym_yield] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1232),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_DOT] = ACTIONS(1232),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_function] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1232),
    [anon_sym_GT_GT_GT] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_CARET] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1234),
    [anon_sym_STAR_STAR] = ACTIONS(1234),
    [anon_sym_LT_EQ] = ACTIONS(1234),
    [anon_sym_EQ_EQ] = ACTIONS(1232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1234),
    [anon_sym_BANG_EQ] = ACTIONS(1232),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1234),
    [anon_sym_GT_EQ] = ACTIONS(1234),
    [anon_sym_QMARK_QMARK] = ACTIONS(1234),
    [anon_sym_instanceof] = ACTIONS(1232),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_TILDE] = ACTIONS(1228),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_delete] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1228),
    [sym_number] = ACTIONS(1228),
    [sym_this] = ACTIONS(1230),
    [sym_super] = ACTIONS(1230),
    [sym_true] = ACTIONS(1230),
    [sym_false] = ACTIONS(1230),
    [sym_null] = ACTIONS(1230),
    [sym_undefined] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_abstract] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_interface] = ACTIONS(1230),
    [anon_sym_enum] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(1230),
    [sym__automatic_semicolon] = ACTIONS(1236),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1240),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_default] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1240),
    [anon_sym_typeof] = ACTIONS(1240),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [anon_sym_let] = ACTIONS(1240),
    [anon_sym_const] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1240),
    [anon_sym_switch] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_await] = ACTIONS(1240),
    [anon_sym_in] = ACTIONS(1242),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_do] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_debugger] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_throw] = ACTIONS(1240),
    [anon_sym_SEMI] = ACTIONS(1238),
    [anon_sym_case] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1240),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_async] = ACTIONS(1240),
    [anon_sym_function] = ACTIONS(1240),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_QMARK] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_GT_GT_GT] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_PERCENT] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1244),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_QMARK_QMARK] = ACTIONS(1244),
    [anon_sym_instanceof] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1240),
    [anon_sym_delete] = ACTIONS(1240),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1238),
    [sym_number] = ACTIONS(1238),
    [sym_this] = ACTIONS(1240),
    [sym_super] = ACTIONS(1240),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_null] = ACTIONS(1240),
    [sym_undefined] = ACTIONS(1240),
    [anon_sym_AT] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_abstract] = ACTIONS(1240),
    [anon_sym_get] = ACTIONS(1240),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_declare] = ACTIONS(1240),
    [anon_sym_public] = ACTIONS(1240),
    [anon_sym_private] = ACTIONS(1240),
    [anon_sym_protected] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_any] = ACTIONS(1240),
    [anon_sym_number] = ACTIONS(1240),
    [anon_sym_boolean] = ACTIONS(1240),
    [anon_sym_string] = ACTIONS(1240),
    [anon_sym_symbol] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1240),
    [anon_sym_enum] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1240),
    [sym__automatic_semicolon] = ACTIONS(1246),
  },
  [130] = {
    [sym_import] = STATE(1224),
    [sym_expression_statement] = STATE(152),
    [sym_variable_declaration] = STATE(152),
    [sym_lexical_declaration] = STATE(152),
    [sym_empty_statement] = STATE(152),
    [sym_parenthesized_expression] = STATE(845),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1328),
    [sym_array] = STATE(1329),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(845),
    [sym_subscript_expression] = STATE(845),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1256),
    [anon_sym_const] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1260),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_declare] = ACTIONS(1250),
    [anon_sym_public] = ACTIONS(1250),
    [anon_sym_private] = ACTIONS(1250),
    [anon_sym_protected] = ACTIONS(1250),
    [anon_sym_module] = ACTIONS(1250),
    [anon_sym_any] = ACTIONS(1250),
    [anon_sym_number] = ACTIONS(1250),
    [anon_sym_boolean] = ACTIONS(1250),
    [anon_sym_string] = ACTIONS(1250),
    [anon_sym_symbol] = ACTIONS(1250),
    [sym_readonly] = ACTIONS(1250),
  },
  [131] = {
    [sym_import] = STATE(1224),
    [sym_expression_statement] = STATE(151),
    [sym_variable_declaration] = STATE(151),
    [sym_lexical_declaration] = STATE(151),
    [sym_empty_statement] = STATE(151),
    [sym_parenthesized_expression] = STATE(845),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1328),
    [sym_array] = STATE(1329),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(845),
    [sym_subscript_expression] = STATE(845),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1256),
    [anon_sym_const] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1260),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_declare] = ACTIONS(1250),
    [anon_sym_public] = ACTIONS(1250),
    [anon_sym_private] = ACTIONS(1250),
    [anon_sym_protected] = ACTIONS(1250),
    [anon_sym_module] = ACTIONS(1250),
    [anon_sym_any] = ACTIONS(1250),
    [anon_sym_number] = ACTIONS(1250),
    [anon_sym_boolean] = ACTIONS(1250),
    [anon_sym_string] = ACTIONS(1250),
    [anon_sym_symbol] = ACTIONS(1250),
    [sym_readonly] = ACTIONS(1250),
  },
  [132] = {
    [sym_import] = STATE(1029),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1029),
    [sym_yield_expression] = STATE(1029),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_class] = STATE(1029),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1029),
    [sym_arrow_function] = STATE(1029),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1029),
    [sym_new_expression] = STATE(1029),
    [sym_await_expression] = STATE(1029),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1029),
    [sym_augmented_assignment_expression] = STATE(1029),
    [sym_ternary_expression] = STATE(1029),
    [sym_binary_expression] = STATE(1029),
    [sym_unary_expression] = STATE(1029),
    [sym_update_expression] = STATE(1029),
    [sym_sequence_expression] = STATE(2904),
    [sym_string] = STATE(1029),
    [sym_template_string] = STATE(1029),
    [sym_regex] = STATE(1029),
    [sym_meta_property] = STATE(1029),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1029),
    [sym_type_assertion] = STATE(1029),
    [sym_as_expression] = STATE(1029),
    [sym_internal_module] = STATE(1029),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1266),
    [sym_this] = ACTIONS(1268),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_null] = ACTIONS(818),
    [sym_undefined] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(812),
  },
  [133] = {
    [sym_import] = STATE(1115),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1115),
    [sym_yield_expression] = STATE(1115),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_class] = STATE(1115),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1115),
    [sym_arrow_function] = STATE(1115),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1115),
    [sym_new_expression] = STATE(1115),
    [sym_await_expression] = STATE(1115),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1115),
    [sym_augmented_assignment_expression] = STATE(1115),
    [sym_ternary_expression] = STATE(1115),
    [sym_binary_expression] = STATE(1115),
    [sym_unary_expression] = STATE(1115),
    [sym_update_expression] = STATE(1115),
    [sym_sequence_expression] = STATE(2960),
    [sym_string] = STATE(1115),
    [sym_template_string] = STATE(1115),
    [sym_regex] = STATE(1115),
    [sym_meta_property] = STATE(1115),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1115),
    [sym_type_assertion] = STATE(1115),
    [sym_as_expression] = STATE(1115),
    [sym_internal_module] = STATE(1115),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1270),
    [sym_this] = ACTIONS(1268),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(820),
    [sym_false] = ACTIONS(820),
    [sym_null] = ACTIONS(820),
    [sym_undefined] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(812),
  },
  [134] = {
    [sym_import] = STATE(1025),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1025),
    [sym_object] = STATE(1492),
    [sym_array] = STATE(1501),
    [sym_class] = STATE(1025),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1025),
    [sym_arrow_function] = STATE(1025),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1025),
    [sym_new_expression] = STATE(1025),
    [sym_await_expression] = STATE(1025),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(1025),
    [sym_ternary_expression] = STATE(1025),
    [sym_binary_expression] = STATE(1025),
    [sym_unary_expression] = STATE(1025),
    [sym_update_expression] = STATE(1025),
    [sym_sequence_expression] = STATE(2827),
    [sym_string] = STATE(1025),
    [sym_template_string] = STATE(1025),
    [sym_regex] = STATE(1025),
    [sym_meta_property] = STATE(1025),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_rest_parameter] = STATE(2458),
    [sym_non_null_expression] = STATE(1025),
    [sym_type_assertion] = STATE(1025),
    [sym_as_expression] = STATE(1025),
    [sym_internal_module] = STATE(1025),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1272),
    [sym_this] = ACTIONS(1268),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_null] = ACTIONS(806),
    [sym_undefined] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(808),
    [anon_sym_private] = ACTIONS(808),
    [anon_sym_protected] = ACTIONS(808),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(812),
  },
  [135] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_spread_element] = STATE(2501),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1211),
    [sym_type_assertion] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_mapped_type_clause] = STATE(2862),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2502),
    [sym_identifier] = ACTIONS(1274),
    [anon_sym_export] = ACTIONS(1276),
    [anon_sym_namespace] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(1276),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1280),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1282),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1276),
    [anon_sym_get] = ACTIONS(1276),
    [anon_sym_set] = ACTIONS(1276),
    [anon_sym_declare] = ACTIONS(1276),
    [anon_sym_public] = ACTIONS(1276),
    [anon_sym_private] = ACTIONS(1276),
    [anon_sym_protected] = ACTIONS(1276),
    [anon_sym_module] = ACTIONS(1276),
    [anon_sym_any] = ACTIONS(1276),
    [anon_sym_number] = ACTIONS(1276),
    [anon_sym_boolean] = ACTIONS(1276),
    [anon_sym_string] = ACTIONS(1276),
    [anon_sym_symbol] = ACTIONS(1276),
    [sym_readonly] = ACTIONS(1276),
  },
  [136] = {
    [sym_import] = STATE(1200),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1200),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1200),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1200),
    [sym_arrow_function] = STATE(1200),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1200),
    [sym_new_expression] = STATE(1200),
    [sym_await_expression] = STATE(1200),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1200),
    [sym_augmented_assignment_expression] = STATE(1200),
    [sym_spread_element] = STATE(2468),
    [sym_ternary_expression] = STATE(1200),
    [sym_binary_expression] = STATE(1200),
    [sym_unary_expression] = STATE(1200),
    [sym_update_expression] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_template_string] = STATE(1200),
    [sym_regex] = STATE(1200),
    [sym_meta_property] = STATE(1200),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1200),
    [sym_type_assertion] = STATE(1200),
    [sym_as_expression] = STATE(1200),
    [sym_internal_module] = STATE(1200),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2470),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(854),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1288),
    [sym_this] = ACTIONS(1290),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1290),
    [sym_false] = ACTIONS(1290),
    [sym_null] = ACTIONS(1290),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [137] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_spread_element] = STATE(2474),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(2320),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1340),
    [sym_type_assertion] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1294),
    [sym_this] = ACTIONS(1296),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_null] = ACTIONS(1296),
    [sym_undefined] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [138] = {
    [sym_import] = STATE(1206),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1206),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1206),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1206),
    [sym_arrow_function] = STATE(1206),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1206),
    [sym_new_expression] = STATE(1206),
    [sym_await_expression] = STATE(1206),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1206),
    [sym_augmented_assignment_expression] = STATE(1206),
    [sym_spread_element] = STATE(2501),
    [sym_ternary_expression] = STATE(1206),
    [sym_binary_expression] = STATE(1206),
    [sym_unary_expression] = STATE(1206),
    [sym_update_expression] = STATE(1206),
    [sym_string] = STATE(1206),
    [sym_template_string] = STATE(1206),
    [sym_regex] = STATE(1206),
    [sym_meta_property] = STATE(1206),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1206),
    [sym_type_assertion] = STATE(1206),
    [sym_as_expression] = STATE(1206),
    [sym_internal_module] = STATE(1206),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2502),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1298),
    [sym_this] = ACTIONS(1300),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1300),
    [sym_false] = ACTIONS(1300),
    [sym_null] = ACTIONS(1300),
    [sym_undefined] = ACTIONS(1300),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [139] = {
    [sym_import] = STATE(1181),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_spread_element] = STATE(2474),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1181),
    [sym_type_assertion] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1302),
    [sym_this] = ACTIONS(1304),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1304),
    [sym_false] = ACTIONS(1304),
    [sym_null] = ACTIONS(1304),
    [sym_undefined] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [140] = {
    [sym_import] = STATE(1217),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1217),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1217),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1217),
    [sym_arrow_function] = STATE(1217),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1217),
    [sym_new_expression] = STATE(1217),
    [sym_await_expression] = STATE(1217),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1217),
    [sym_augmented_assignment_expression] = STATE(1217),
    [sym_spread_element] = STATE(2554),
    [sym_ternary_expression] = STATE(1217),
    [sym_binary_expression] = STATE(1217),
    [sym_unary_expression] = STATE(1217),
    [sym_update_expression] = STATE(1217),
    [sym_string] = STATE(1217),
    [sym_template_string] = STATE(1217),
    [sym_regex] = STATE(1217),
    [sym_meta_property] = STATE(1217),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1217),
    [sym_type_assertion] = STATE(1217),
    [sym_as_expression] = STATE(1217),
    [sym_internal_module] = STATE(1217),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1306),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1308),
    [sym_this] = ACTIONS(1310),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [sym_null] = ACTIONS(1310),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [141] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_spread_element] = STATE(2468),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1178),
    [sym_type_assertion] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2470),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(854),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1312),
    [sym_this] = ACTIONS(856),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(856),
    [sym_false] = ACTIONS(856),
    [sym_null] = ACTIONS(856),
    [sym_undefined] = ACTIONS(856),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [142] = {
    [sym_import] = STATE(1204),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_spread_element] = STATE(2508),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1204),
    [sym_type_assertion] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2503),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1316),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_null] = ACTIONS(1318),
    [sym_undefined] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [143] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_spread_element] = STATE(2429),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1208),
    [sym_type_assertion] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2430),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1320),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1322),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1324),
    [sym_false] = ACTIONS(1324),
    [sym_null] = ACTIONS(1324),
    [sym_undefined] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [144] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_spread_element] = STATE(2412),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1209),
    [sym_type_assertion] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2414),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1326),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1328),
    [sym_this] = ACTIONS(1330),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [sym_null] = ACTIONS(1330),
    [sym_undefined] = ACTIONS(1330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [145] = {
    [sym_import] = STATE(1149),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1149),
    [sym_yield_expression] = STATE(1149),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1149),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1149),
    [sym_arrow_function] = STATE(1149),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1149),
    [sym_augmented_assignment_expression] = STATE(1149),
    [sym_spread_element] = STATE(2501),
    [sym_ternary_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_update_expression] = STATE(1149),
    [sym_string] = STATE(1149),
    [sym_template_string] = STATE(1149),
    [sym_regex] = STATE(1149),
    [sym_meta_property] = STATE(1149),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1149),
    [sym_type_assertion] = STATE(1149),
    [sym_as_expression] = STATE(1149),
    [sym_internal_module] = STATE(1149),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2502),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1332),
    [sym_this] = ACTIONS(848),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(848),
    [sym_false] = ACTIONS(848),
    [sym_null] = ACTIONS(848),
    [sym_undefined] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [146] = {
    [sym_import] = STATE(1171),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1171),
    [sym_yield_expression] = STATE(1171),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1171),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1171),
    [sym_arrow_function] = STATE(1171),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1171),
    [sym_new_expression] = STATE(1171),
    [sym_await_expression] = STATE(1171),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1171),
    [sym_augmented_assignment_expression] = STATE(1171),
    [sym_spread_element] = STATE(2563),
    [sym_ternary_expression] = STATE(1171),
    [sym_binary_expression] = STATE(1171),
    [sym_unary_expression] = STATE(1171),
    [sym_update_expression] = STATE(1171),
    [sym_string] = STATE(1171),
    [sym_template_string] = STATE(1171),
    [sym_regex] = STATE(1171),
    [sym_meta_property] = STATE(1171),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1171),
    [sym_as_expression] = STATE(1171),
    [sym_internal_module] = STATE(1171),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2564),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1334),
    [sym_this] = ACTIONS(842),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_null] = ACTIONS(842),
    [sym_undefined] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [147] = {
    [sym_import] = STATE(1164),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1164),
    [sym_yield_expression] = STATE(1164),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1164),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1164),
    [sym_arrow_function] = STATE(1164),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1164),
    [sym_new_expression] = STATE(1164),
    [sym_await_expression] = STATE(1164),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1164),
    [sym_augmented_assignment_expression] = STATE(1164),
    [sym_spread_element] = STATE(2534),
    [sym_ternary_expression] = STATE(1164),
    [sym_binary_expression] = STATE(1164),
    [sym_unary_expression] = STATE(1164),
    [sym_update_expression] = STATE(1164),
    [sym_string] = STATE(1164),
    [sym_template_string] = STATE(1164),
    [sym_regex] = STATE(1164),
    [sym_meta_property] = STATE(1164),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1164),
    [sym_type_assertion] = STATE(1164),
    [sym_as_expression] = STATE(1164),
    [sym_internal_module] = STATE(1164),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2535),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1338),
    [sym_this] = ACTIONS(1340),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1340),
    [sym_false] = ACTIONS(1340),
    [sym_null] = ACTIONS(1340),
    [sym_undefined] = ACTIONS(1340),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [148] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2522),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1219),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1219),
    [sym_type_assertion] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [aux_sym_array_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(850),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1342),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_null] = ACTIONS(852),
    [sym_undefined] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [149] = {
    [sym_export_clause] = STATE(2318),
    [sym__declaration] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_class_declaration] = STATE(602),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function_declaration] = STATE(602),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(602),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(602),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2405),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [150] = {
    [sym_export_clause] = STATE(2318),
    [sym__declaration] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_class_declaration] = STATE(602),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function_declaration] = STATE(602),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(602),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(602),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [151] = {
    [sym_import] = STATE(1224),
    [sym_expression_statement] = STATE(160),
    [sym_empty_statement] = STATE(160),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [152] = {
    [sym_import] = STATE(1224),
    [sym_expression_statement] = STATE(165),
    [sym_empty_statement] = STATE(165),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_sequence_expression] = STATE(2631),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [153] = {
    [sym_export_clause] = STATE(2318),
    [sym__declaration] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_class_declaration] = STATE(602),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function_declaration] = STATE(602),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(602),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(602),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2576),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [154] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_nested_identifier] = STATE(2900),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1239),
    [sym_type_assertion] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_nested_type_identifier] = STATE(2191),
    [sym_generic_type] = STATE(2463),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(1387),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1391),
    [sym_this] = ACTIONS(1393),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [sym_null] = ACTIONS(1393),
    [sym_undefined] = ACTIONS(1393),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [155] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_nested_identifier] = STATE(2900),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1114),
    [sym_type_assertion] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_nested_type_identifier] = STATE(2050),
    [sym_generic_type] = STATE(2312),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1397),
    [sym_this] = ACTIONS(1399),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1399),
    [sym_false] = ACTIONS(1399),
    [sym_null] = ACTIONS(1399),
    [sym_undefined] = ACTIONS(1399),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [156] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_sequence_expression] = STATE(2771),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1401),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1403),
    [sym_this] = ACTIONS(1405),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [sym_null] = ACTIONS(1405),
    [sym_undefined] = ACTIONS(1405),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(1401),
  },
  [157] = {
    [sym_import] = STATE(1010),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1010),
    [sym_yield_expression] = STATE(1010),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1010),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1010),
    [sym_arrow_function] = STATE(1010),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1010),
    [sym_new_expression] = STATE(1010),
    [sym_await_expression] = STATE(1010),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1010),
    [sym_augmented_assignment_expression] = STATE(1010),
    [sym_ternary_expression] = STATE(1010),
    [sym_binary_expression] = STATE(1010),
    [sym_unary_expression] = STATE(1010),
    [sym_update_expression] = STATE(1010),
    [sym_string] = STATE(1010),
    [sym_template_string] = STATE(1010),
    [sym_regex] = STATE(1010),
    [sym_meta_property] = STATE(1010),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1010),
    [sym_type_assertion] = STATE(1010),
    [sym_as_expression] = STATE(1010),
    [sym_internal_module] = STATE(1010),
    [sym_nested_type_identifier] = STATE(2021),
    [sym_generic_type] = STATE(2350),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1407),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1409),
    [sym_this] = ACTIONS(1411),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [158] = {
    [sym_import] = STATE(1527),
    [sym_parenthesized_expression] = STATE(905),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(1677),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1527),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1527),
    [sym_arrow_function] = STATE(1527),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(905),
    [sym_subscript_expression] = STATE(905),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(1527),
    [sym_template_string] = STATE(1527),
    [sym_regex] = STATE(1527),
    [sym_meta_property] = STATE(1527),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_var] = ACTIONS(1419),
    [anon_sym_let] = ACTIONS(1419),
    [anon_sym_const] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1423),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1425),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [sym_readonly] = ACTIONS(1415),
  },
  [159] = {
    [sym_import] = STATE(1232),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1232),
    [sym_yield_expression] = STATE(1232),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_nested_identifier] = STATE(2792),
    [sym_class] = STATE(1232),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1232),
    [sym_arrow_function] = STATE(1232),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1232),
    [sym_new_expression] = STATE(1232),
    [sym_await_expression] = STATE(1232),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1232),
    [sym_augmented_assignment_expression] = STATE(1232),
    [sym_ternary_expression] = STATE(1232),
    [sym_binary_expression] = STATE(1232),
    [sym_unary_expression] = STATE(1232),
    [sym_update_expression] = STATE(1232),
    [sym_string] = STATE(1232),
    [sym_template_string] = STATE(1232),
    [sym_regex] = STATE(1232),
    [sym_meta_property] = STATE(1232),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1232),
    [sym_type_assertion] = STATE(1232),
    [sym_as_expression] = STATE(1232),
    [sym_internal_module] = STATE(1232),
    [sym_nested_type_identifier] = STATE(2153),
    [sym_generic_type] = STATE(2469),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1431),
    [sym_this] = ACTIONS(1433),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [sym_null] = ACTIONS(1433),
    [sym_undefined] = ACTIONS(1433),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [160] = {
    [sym_import] = STATE(1281),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1281),
    [sym_yield_expression] = STATE(1281),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1281),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1281),
    [sym_arrow_function] = STATE(1281),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1281),
    [sym_new_expression] = STATE(1281),
    [sym_await_expression] = STATE(1281),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1281),
    [sym_augmented_assignment_expression] = STATE(1281),
    [sym_ternary_expression] = STATE(1281),
    [sym_binary_expression] = STATE(1281),
    [sym_unary_expression] = STATE(1281),
    [sym_update_expression] = STATE(1281),
    [sym_sequence_expression] = STATE(2800),
    [sym_string] = STATE(1281),
    [sym_template_string] = STATE(1281),
    [sym_regex] = STATE(1281),
    [sym_meta_property] = STATE(1281),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1281),
    [sym_type_assertion] = STATE(1281),
    [sym_as_expression] = STATE(1281),
    [sym_internal_module] = STATE(1281),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1435),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1437),
    [sym_this] = ACTIONS(1439),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1439),
    [sym_false] = ACTIONS(1439),
    [sym_null] = ACTIONS(1439),
    [sym_undefined] = ACTIONS(1439),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [161] = {
    [sym__declaration] = STATE(536),
    [sym_variable_declaration] = STATE(536),
    [sym_lexical_declaration] = STATE(536),
    [sym_class_declaration] = STATE(536),
    [sym_function_declaration] = STATE(536),
    [sym_generator_function_declaration] = STATE(536),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(536),
    [sym_ambient_declaration] = STATE(536),
    [sym_abstract_class_declaration] = STATE(536),
    [sym_module] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_import_alias] = STATE(536),
    [sym_interface_declaration] = STATE(536),
    [sym_enum_declaration] = STATE(536),
    [sym_type_alias_declaration] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2405),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1441),
    [anon_sym_global] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [162] = {
    [sym_export_clause] = STATE(2318),
    [sym__declaration] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_class_declaration] = STATE(602),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function_declaration] = STATE(602),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(602),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(602),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1445),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [163] = {
    [sym__declaration] = STATE(536),
    [sym_variable_declaration] = STATE(536),
    [sym_lexical_declaration] = STATE(536),
    [sym_class_declaration] = STATE(536),
    [sym_function_declaration] = STATE(536),
    [sym_generator_function_declaration] = STATE(536),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(536),
    [sym_ambient_declaration] = STATE(536),
    [sym_abstract_class_declaration] = STATE(536),
    [sym_module] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_import_alias] = STATE(536),
    [sym_interface_declaration] = STATE(536),
    [sym_enum_declaration] = STATE(536),
    [sym_type_alias_declaration] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2576),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1441),
    [anon_sym_global] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [164] = {
    [sym__declaration] = STATE(536),
    [sym_variable_declaration] = STATE(536),
    [sym_lexical_declaration] = STATE(536),
    [sym_class_declaration] = STATE(536),
    [sym_function_declaration] = STATE(536),
    [sym_generator_function_declaration] = STATE(536),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(536),
    [sym_ambient_declaration] = STATE(536),
    [sym_abstract_class_declaration] = STATE(536),
    [sym_module] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_import_alias] = STATE(536),
    [sym_interface_declaration] = STATE(536),
    [sym_enum_declaration] = STATE(536),
    [sym_type_alias_declaration] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [aux_sym_object_repeat1] = STATE(2515),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1441),
    [anon_sym_global] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [165] = {
    [sym_import] = STATE(1263),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1263),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1263),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1263),
    [sym_arrow_function] = STATE(1263),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1263),
    [sym_new_expression] = STATE(1263),
    [sym_await_expression] = STATE(1263),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1263),
    [sym_augmented_assignment_expression] = STATE(1263),
    [sym_ternary_expression] = STATE(1263),
    [sym_binary_expression] = STATE(1263),
    [sym_unary_expression] = STATE(1263),
    [sym_update_expression] = STATE(1263),
    [sym_sequence_expression] = STATE(2820),
    [sym_string] = STATE(1263),
    [sym_template_string] = STATE(1263),
    [sym_regex] = STATE(1263),
    [sym_meta_property] = STATE(1263),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1263),
    [sym_as_expression] = STATE(1263),
    [sym_internal_module] = STATE(1263),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1451),
    [sym_this] = ACTIONS(1453),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [sym_null] = ACTIONS(1453),
    [sym_undefined] = ACTIONS(1453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [166] = {
    [sym_export_clause] = STATE(2318),
    [sym__declaration] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_class_declaration] = STATE(602),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function_declaration] = STATE(602),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(602),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(602),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1445),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1381),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [167] = {
    [sym_import] = STATE(1155),
    [sym_statement_block] = STATE(1605),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1155),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1155),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1155),
    [sym_arrow_function] = STATE(1155),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1155),
    [sym_new_expression] = STATE(1155),
    [sym_await_expression] = STATE(1155),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(1155),
    [sym_ternary_expression] = STATE(1155),
    [sym_binary_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1155),
    [sym_update_expression] = STATE(1155),
    [sym_string] = STATE(1155),
    [sym_template_string] = STATE(1155),
    [sym_regex] = STATE(1155),
    [sym_meta_property] = STATE(1155),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1155),
    [sym_type_assertion] = STATE(1155),
    [sym_as_expression] = STATE(1155),
    [sym_internal_module] = STATE(1155),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1457),
    [sym_this] = ACTIONS(1459),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1459),
    [sym_false] = ACTIONS(1459),
    [sym_null] = ACTIONS(1459),
    [sym_undefined] = ACTIONS(1459),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [168] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(1859),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [169] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_sequence_expression] = STATE(2923),
    [sym_string] = STATE(1359),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1359),
    [sym_type_assertion] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [170] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2456),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2713),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1469),
    [anon_sym_namespace] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1469),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1469),
    [anon_sym_set] = ACTIONS(1469),
    [anon_sym_declare] = ACTIONS(1469),
    [anon_sym_public] = ACTIONS(1469),
    [anon_sym_private] = ACTIONS(1469),
    [anon_sym_protected] = ACTIONS(1469),
    [anon_sym_module] = ACTIONS(1469),
    [anon_sym_any] = ACTIONS(1469),
    [anon_sym_number] = ACTIONS(1469),
    [anon_sym_boolean] = ACTIONS(1469),
    [anon_sym_string] = ACTIONS(1469),
    [anon_sym_symbol] = ACTIONS(1469),
    [sym_readonly] = ACTIONS(1469),
  },
  [171] = {
    [sym_import] = STATE(1339),
    [sym_statement_block] = STATE(1092),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1339),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1339),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1339),
    [sym_arrow_function] = STATE(1339),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1339),
    [sym_new_expression] = STATE(1339),
    [sym_await_expression] = STATE(1339),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1339),
    [sym_augmented_assignment_expression] = STATE(1339),
    [sym_ternary_expression] = STATE(1339),
    [sym_binary_expression] = STATE(1339),
    [sym_unary_expression] = STATE(1339),
    [sym_update_expression] = STATE(1339),
    [sym_string] = STATE(1339),
    [sym_template_string] = STATE(1339),
    [sym_regex] = STATE(1339),
    [sym_meta_property] = STATE(1339),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1339),
    [sym_type_assertion] = STATE(1339),
    [sym_as_expression] = STATE(1339),
    [sym_internal_module] = STATE(1339),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [172] = {
    [sym_import] = STATE(1373),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_sequence_expression] = STATE(2933),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [173] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1469),
    [anon_sym_namespace] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1469),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1469),
    [anon_sym_set] = ACTIONS(1469),
    [anon_sym_declare] = ACTIONS(1469),
    [anon_sym_public] = ACTIONS(1469),
    [anon_sym_private] = ACTIONS(1469),
    [anon_sym_protected] = ACTIONS(1469),
    [anon_sym_module] = ACTIONS(1469),
    [anon_sym_any] = ACTIONS(1469),
    [anon_sym_number] = ACTIONS(1469),
    [anon_sym_boolean] = ACTIONS(1469),
    [anon_sym_string] = ACTIONS(1469),
    [anon_sym_symbol] = ACTIONS(1469),
    [sym_readonly] = ACTIONS(1469),
  },
  [174] = {
    [sym_import] = STATE(1259),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_sequence_expression] = STATE(2807),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1259),
    [sym_type_assertion] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1493),
    [sym_this] = ACTIONS(1495),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1495),
    [sym_false] = ACTIONS(1495),
    [sym_null] = ACTIONS(1495),
    [sym_undefined] = ACTIONS(1495),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [175] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1497),
    [anon_sym_export] = ACTIONS(1499),
    [anon_sym_namespace] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1499),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1505),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
    [anon_sym_declare] = ACTIONS(1499),
    [anon_sym_public] = ACTIONS(1499),
    [anon_sym_private] = ACTIONS(1499),
    [anon_sym_protected] = ACTIONS(1499),
    [anon_sym_module] = ACTIONS(1499),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [sym_readonly] = ACTIONS(1499),
  },
  [176] = {
    [sym_import] = STATE(1260),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1260),
    [sym_yield_expression] = STATE(1260),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1260),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1260),
    [sym_arrow_function] = STATE(1260),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1260),
    [sym_new_expression] = STATE(1260),
    [sym_await_expression] = STATE(1260),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1260),
    [sym_augmented_assignment_expression] = STATE(1260),
    [sym_ternary_expression] = STATE(1260),
    [sym_binary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1260),
    [sym_update_expression] = STATE(1260),
    [sym_sequence_expression] = STATE(2815),
    [sym_string] = STATE(1260),
    [sym_template_string] = STATE(1260),
    [sym_regex] = STATE(1260),
    [sym_meta_property] = STATE(1260),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1260),
    [sym_type_assertion] = STATE(1260),
    [sym_as_expression] = STATE(1260),
    [sym_internal_module] = STATE(1260),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1507),
    [sym_this] = ACTIONS(1509),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [sym_null] = ACTIONS(1509),
    [sym_undefined] = ACTIONS(1509),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [177] = {
    [sym_import] = STATE(1262),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1262),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1262),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1262),
    [sym_arrow_function] = STATE(1262),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1262),
    [sym_new_expression] = STATE(1262),
    [sym_await_expression] = STATE(1262),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1262),
    [sym_augmented_assignment_expression] = STATE(1262),
    [sym_ternary_expression] = STATE(1262),
    [sym_binary_expression] = STATE(1262),
    [sym_unary_expression] = STATE(1262),
    [sym_update_expression] = STATE(1262),
    [sym_sequence_expression] = STATE(2818),
    [sym_string] = STATE(1262),
    [sym_template_string] = STATE(1262),
    [sym_regex] = STATE(1262),
    [sym_meta_property] = STATE(1262),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1262),
    [sym_type_assertion] = STATE(1262),
    [sym_as_expression] = STATE(1262),
    [sym_internal_module] = STATE(1262),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1511),
    [sym_this] = ACTIONS(1513),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_undefined] = ACTIONS(1513),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [178] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1523),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [179] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1265),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1265),
    [sym_await_expression] = STATE(1265),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1265),
    [sym_augmented_assignment_expression] = STATE(1265),
    [sym_ternary_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_update_expression] = STATE(1265),
    [sym_sequence_expression] = STATE(2822),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1265),
    [sym_type_assertion] = STATE(1265),
    [sym_as_expression] = STATE(1265),
    [sym_internal_module] = STATE(1265),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1525),
    [sym_this] = ACTIONS(1527),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_undefined] = ACTIONS(1527),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [180] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_sequence_expression] = STATE(2825),
    [sym_string] = STATE(1269),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1269),
    [sym_type_assertion] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1529),
    [sym_this] = ACTIONS(1531),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [sym_null] = ACTIONS(1531),
    [sym_undefined] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [181] = {
    [sym_import] = STATE(1335),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1335),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1335),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1335),
    [sym_arrow_function] = STATE(1335),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_await_expression] = STATE(1335),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1335),
    [sym_augmented_assignment_expression] = STATE(1335),
    [sym_ternary_expression] = STATE(1335),
    [sym_binary_expression] = STATE(1335),
    [sym_unary_expression] = STATE(1335),
    [sym_update_expression] = STATE(1335),
    [sym_string] = STATE(1335),
    [sym_template_string] = STATE(1335),
    [sym_regex] = STATE(1335),
    [sym_meta_property] = STATE(1335),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1335),
    [sym_type_assertion] = STATE(1335),
    [sym_as_expression] = STATE(1335),
    [sym_internal_module] = STATE(1335),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1533),
    [sym_this] = ACTIONS(1535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [182] = {
    [sym_import] = STATE(1415),
    [sym_parenthesized_expression] = STATE(838),
    [sym__expression] = STATE(1517),
    [sym_yield_expression] = STATE(1517),
    [sym_object] = STATE(1272),
    [sym_array] = STATE(1271),
    [sym_class] = STATE(1415),
    [sym_function] = STATE(1216),
    [sym_generator_function] = STATE(1415),
    [sym_arrow_function] = STATE(1415),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1517),
    [sym_new_expression] = STATE(1415),
    [sym_await_expression] = STATE(1517),
    [sym_member_expression] = STATE(838),
    [sym_subscript_expression] = STATE(838),
    [sym_assignment_expression] = STATE(1517),
    [sym_augmented_assignment_expression] = STATE(1517),
    [sym_ternary_expression] = STATE(1517),
    [sym_binary_expression] = STATE(1517),
    [sym_unary_expression] = STATE(1517),
    [sym_update_expression] = STATE(1517),
    [sym_string] = STATE(1415),
    [sym_template_string] = STATE(1415),
    [sym_regex] = STATE(1415),
    [sym_meta_property] = STATE(1415),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1517),
    [sym_type_assertion] = STATE(1517),
    [sym_as_expression] = STATE(1517),
    [sym_internal_module] = STATE(1517),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [183] = {
    [sym_import] = STATE(1333),
    [sym_statement_block] = STATE(1033),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1333),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1333),
    [sym_arrow_function] = STATE(1333),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_ternary_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_update_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_regex] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1333),
    [sym_type_assertion] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_internal_module] = STATE(1333),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1555),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [184] = {
    [sym_import] = STATE(1332),
    [sym_statement_block] = STATE(1022),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1332),
    [sym_arrow_function] = STATE(1332),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1559),
    [sym_this] = ACTIONS(1561),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [185] = {
    [sym_import] = STATE(1487),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1487),
    [sym_yield_expression] = STATE(1487),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1487),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1487),
    [sym_arrow_function] = STATE(1487),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1487),
    [sym_new_expression] = STATE(1487),
    [sym_await_expression] = STATE(1487),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1487),
    [sym_augmented_assignment_expression] = STATE(1487),
    [sym_ternary_expression] = STATE(1487),
    [sym_binary_expression] = STATE(1487),
    [sym_unary_expression] = STATE(1487),
    [sym_update_expression] = STATE(1487),
    [sym_string] = STATE(1487),
    [sym_template_string] = STATE(1487),
    [sym_regex] = STATE(1487),
    [sym_meta_property] = STATE(1487),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(1487),
    [sym_as_expression] = STATE(1487),
    [sym_internal_module] = STATE(1487),
    [sym_mapped_type_clause] = STATE(2862),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_export] = ACTIONS(1565),
    [anon_sym_namespace] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1565),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1569),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1571),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_get] = ACTIONS(1565),
    [anon_sym_set] = ACTIONS(1565),
    [anon_sym_declare] = ACTIONS(1565),
    [anon_sym_public] = ACTIONS(1565),
    [anon_sym_private] = ACTIONS(1565),
    [anon_sym_protected] = ACTIONS(1565),
    [anon_sym_module] = ACTIONS(1565),
    [anon_sym_any] = ACTIONS(1565),
    [anon_sym_number] = ACTIONS(1565),
    [anon_sym_boolean] = ACTIONS(1565),
    [anon_sym_string] = ACTIONS(1565),
    [anon_sym_symbol] = ACTIONS(1565),
    [sym_readonly] = ACTIONS(1565),
  },
  [186] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1577),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [187] = {
    [sym_import] = STATE(1331),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1331),
    [sym_type_assertion] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1579),
    [sym_this] = ACTIONS(1581),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1581),
    [sym_false] = ACTIONS(1581),
    [sym_null] = ACTIONS(1581),
    [sym_undefined] = ACTIONS(1581),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [188] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1583),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(757),
    [sym_this] = ACTIONS(759),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(759),
    [sym_false] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [sym_undefined] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [189] = {
    [sym_import] = STATE(1415),
    [sym_parenthesized_expression] = STATE(838),
    [sym__expression] = STATE(1517),
    [sym_yield_expression] = STATE(1517),
    [sym_object] = STATE(1272),
    [sym_array] = STATE(1271),
    [sym_class] = STATE(1415),
    [sym_function] = STATE(1216),
    [sym_generator_function] = STATE(1415),
    [sym_arrow_function] = STATE(1415),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1517),
    [sym_new_expression] = STATE(1415),
    [sym_await_expression] = STATE(1517),
    [sym_member_expression] = STATE(838),
    [sym_subscript_expression] = STATE(838),
    [sym_assignment_expression] = STATE(1517),
    [sym_augmented_assignment_expression] = STATE(1517),
    [sym_ternary_expression] = STATE(1517),
    [sym_binary_expression] = STATE(1517),
    [sym_unary_expression] = STATE(1517),
    [sym_update_expression] = STATE(1517),
    [sym_string] = STATE(1415),
    [sym_template_string] = STATE(1415),
    [sym_regex] = STATE(1415),
    [sym_meta_property] = STATE(1415),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1517),
    [sym_type_assertion] = STATE(1517),
    [sym_as_expression] = STATE(1517),
    [sym_internal_module] = STATE(1517),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [190] = {
    [sym_import] = STATE(1050),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1050),
    [sym_yield_expression] = STATE(1050),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1050),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1050),
    [sym_arrow_function] = STATE(1050),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1050),
    [sym_new_expression] = STATE(1050),
    [sym_await_expression] = STATE(1050),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1050),
    [sym_augmented_assignment_expression] = STATE(1050),
    [sym_ternary_expression] = STATE(1050),
    [sym_binary_expression] = STATE(1050),
    [sym_unary_expression] = STATE(1050),
    [sym_update_expression] = STATE(1050),
    [sym_string] = STATE(1050),
    [sym_template_string] = STATE(1050),
    [sym_regex] = STATE(1050),
    [sym_meta_property] = STATE(1050),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1050),
    [sym_type_assertion] = STATE(1050),
    [sym_as_expression] = STATE(1050),
    [sym_internal_module] = STATE(1050),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1589),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [191] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1523),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [192] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(719),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [193] = {
    [sym_import] = STATE(1166),
    [sym_statement_block] = STATE(1538),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1166),
    [sym_yield_expression] = STATE(1166),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1166),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1166),
    [sym_arrow_function] = STATE(1166),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1166),
    [sym_new_expression] = STATE(1166),
    [sym_await_expression] = STATE(1166),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1166),
    [sym_augmented_assignment_expression] = STATE(1166),
    [sym_ternary_expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_update_expression] = STATE(1166),
    [sym_string] = STATE(1166),
    [sym_template_string] = STATE(1166),
    [sym_regex] = STATE(1166),
    [sym_meta_property] = STATE(1166),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1166),
    [sym_type_assertion] = STATE(1166),
    [sym_as_expression] = STATE(1166),
    [sym_internal_module] = STATE(1166),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1593),
    [sym_this] = ACTIONS(1595),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1595),
    [sym_false] = ACTIONS(1595),
    [sym_null] = ACTIONS(1595),
    [sym_undefined] = ACTIONS(1595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [194] = {
    [sym_import] = STATE(1165),
    [sym_statement_block] = STATE(1526),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1165),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1165),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1165),
    [sym_arrow_function] = STATE(1165),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1165),
    [sym_new_expression] = STATE(1165),
    [sym_await_expression] = STATE(1165),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1165),
    [sym_augmented_assignment_expression] = STATE(1165),
    [sym_ternary_expression] = STATE(1165),
    [sym_binary_expression] = STATE(1165),
    [sym_unary_expression] = STATE(1165),
    [sym_update_expression] = STATE(1165),
    [sym_string] = STATE(1165),
    [sym_template_string] = STATE(1165),
    [sym_regex] = STATE(1165),
    [sym_meta_property] = STATE(1165),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1165),
    [sym_as_expression] = STATE(1165),
    [sym_internal_module] = STATE(1165),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1597),
    [sym_this] = ACTIONS(1599),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_undefined] = ACTIONS(1599),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [195] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1497),
    [anon_sym_export] = ACTIONS(1499),
    [anon_sym_namespace] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1499),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1505),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
    [anon_sym_declare] = ACTIONS(1499),
    [anon_sym_public] = ACTIONS(1499),
    [anon_sym_private] = ACTIONS(1499),
    [anon_sym_protected] = ACTIONS(1499),
    [anon_sym_module] = ACTIONS(1499),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [sym_readonly] = ACTIONS(1499),
  },
  [196] = {
    [sym_import] = STATE(1163),
    [sym_statement_block] = STATE(1511),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1163),
    [sym_yield_expression] = STATE(1163),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1163),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1163),
    [sym_arrow_function] = STATE(1163),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1163),
    [sym_new_expression] = STATE(1163),
    [sym_await_expression] = STATE(1163),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(1163),
    [sym_ternary_expression] = STATE(1163),
    [sym_binary_expression] = STATE(1163),
    [sym_unary_expression] = STATE(1163),
    [sym_update_expression] = STATE(1163),
    [sym_string] = STATE(1163),
    [sym_template_string] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_meta_property] = STATE(1163),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1163),
    [sym_type_assertion] = STATE(1163),
    [sym_as_expression] = STATE(1163),
    [sym_internal_module] = STATE(1163),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1601),
    [sym_this] = ACTIONS(1603),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1603),
    [sym_false] = ACTIONS(1603),
    [sym_null] = ACTIONS(1603),
    [sym_undefined] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [197] = {
    [sym_import] = STATE(1342),
    [sym_statement_block] = STATE(1137),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1342),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1342),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1342),
    [sym_arrow_function] = STATE(1342),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_await_expression] = STATE(1342),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1342),
    [sym_augmented_assignment_expression] = STATE(1342),
    [sym_ternary_expression] = STATE(1342),
    [sym_binary_expression] = STATE(1342),
    [sym_unary_expression] = STATE(1342),
    [sym_update_expression] = STATE(1342),
    [sym_string] = STATE(1342),
    [sym_template_string] = STATE(1342),
    [sym_regex] = STATE(1342),
    [sym_meta_property] = STATE(1342),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1342),
    [sym_type_assertion] = STATE(1342),
    [sym_as_expression] = STATE(1342),
    [sym_internal_module] = STATE(1342),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1605),
    [sym_this] = ACTIONS(1607),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1607),
    [sym_false] = ACTIONS(1607),
    [sym_null] = ACTIONS(1607),
    [sym_undefined] = ACTIONS(1607),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [198] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [199] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [200] = {
    [sym_import] = STATE(1527),
    [sym_variable_declarator] = STATE(2325),
    [sym_parenthesized_expression] = STATE(895),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(979),
    [sym_array] = STATE(967),
    [sym_class] = STATE(1527),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1527),
    [sym_arrow_function] = STATE(1527),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(895),
    [sym_subscript_expression] = STATE(895),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(1527),
    [sym_template_string] = STATE(1527),
    [sym_regex] = STATE(1527),
    [sym_meta_property] = STATE(1527),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1615),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1621),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1425),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_get] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1615),
    [anon_sym_declare] = ACTIONS(1615),
    [anon_sym_public] = ACTIONS(1615),
    [anon_sym_private] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1615),
    [anon_sym_any] = ACTIONS(1615),
    [anon_sym_number] = ACTIONS(1615),
    [anon_sym_boolean] = ACTIONS(1615),
    [anon_sym_string] = ACTIONS(1615),
    [anon_sym_symbol] = ACTIONS(1615),
    [sym_readonly] = ACTIONS(1615),
  },
  [201] = {
    [sym_import] = STATE(1527),
    [sym_variable_declarator] = STATE(2341),
    [sym_parenthesized_expression] = STATE(895),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(979),
    [sym_array] = STATE(967),
    [sym_class] = STATE(1527),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1527),
    [sym_arrow_function] = STATE(1527),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(895),
    [sym_subscript_expression] = STATE(895),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(1527),
    [sym_template_string] = STATE(1527),
    [sym_regex] = STATE(1527),
    [sym_meta_property] = STATE(1527),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1615),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1621),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1425),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_get] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1615),
    [anon_sym_declare] = ACTIONS(1615),
    [anon_sym_public] = ACTIONS(1615),
    [anon_sym_private] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1615),
    [anon_sym_any] = ACTIONS(1615),
    [anon_sym_number] = ACTIONS(1615),
    [anon_sym_boolean] = ACTIONS(1615),
    [anon_sym_string] = ACTIONS(1615),
    [anon_sym_symbol] = ACTIONS(1615),
    [sym_readonly] = ACTIONS(1615),
  },
  [202] = {
    [sym_import] = STATE(1237),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1237),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1237),
    [sym_arrow_function] = STATE(1237),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1237),
    [sym_new_expression] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_string] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_meta_property] = STATE(1237),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1237),
    [sym_type_assertion] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1623),
    [sym_this] = ACTIONS(1625),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1625),
    [sym_false] = ACTIONS(1625),
    [sym_null] = ACTIONS(1625),
    [sym_undefined] = ACTIONS(1625),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [203] = {
    [sym_import] = STATE(1238),
    [sym_statement_block] = STATE(1022),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1238),
    [sym_type_assertion] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1627),
    [sym_this] = ACTIONS(1629),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1629),
    [sym_false] = ACTIONS(1629),
    [sym_null] = ACTIONS(1629),
    [sym_undefined] = ACTIONS(1629),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [204] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1033),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1144),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1144),
    [sym_await_expression] = STATE(1144),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1144),
    [sym_augmented_assignment_expression] = STATE(1144),
    [sym_ternary_expression] = STATE(1144),
    [sym_binary_expression] = STATE(1144),
    [sym_unary_expression] = STATE(1144),
    [sym_update_expression] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1144),
    [sym_as_expression] = STATE(1144),
    [sym_internal_module] = STATE(1144),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1631),
    [sym_this] = ACTIONS(1633),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [sym_null] = ACTIONS(1633),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [205] = {
    [sym_import] = STATE(1242),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1635),
    [sym_this] = ACTIONS(1637),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1637),
    [sym_false] = ACTIONS(1637),
    [sym_null] = ACTIONS(1637),
    [sym_undefined] = ACTIONS(1637),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [206] = {
    [sym_import] = STATE(1122),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1122),
    [sym_type_assertion] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1639),
    [sym_this] = ACTIONS(1641),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1641),
    [sym_false] = ACTIONS(1641),
    [sym_null] = ACTIONS(1641),
    [sym_undefined] = ACTIONS(1641),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [207] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_sequence_expression] = STATE(2877),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1347),
    [sym_type_assertion] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1643),
    [sym_this] = ACTIONS(1645),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1645),
    [sym_false] = ACTIONS(1645),
    [sym_null] = ACTIONS(1645),
    [sym_undefined] = ACTIONS(1645),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [208] = {
    [sym_import] = STATE(1350),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_sequence_expression] = STATE(2878),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1350),
    [sym_type_assertion] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1647),
    [sym_this] = ACTIONS(1649),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1649),
    [sym_false] = ACTIONS(1649),
    [sym_null] = ACTIONS(1649),
    [sym_undefined] = ACTIONS(1649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [209] = {
    [sym_import] = STATE(1352),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_sequence_expression] = STATE(2879),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1352),
    [sym_type_assertion] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1651),
    [sym_this] = ACTIONS(1653),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1653),
    [sym_false] = ACTIONS(1653),
    [sym_null] = ACTIONS(1653),
    [sym_undefined] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [210] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_sequence_expression] = STATE(2880),
    [sym_string] = STATE(1353),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1655),
    [sym_this] = ACTIONS(1657),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1657),
    [sym_false] = ACTIONS(1657),
    [sym_null] = ACTIONS(1657),
    [sym_undefined] = ACTIONS(1657),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [211] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(740),
    [sym__expression] = STATE(1583),
    [sym_yield_expression] = STATE(1583),
    [sym_object] = STATE(1233),
    [sym_array] = STATE(1234),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1015),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1583),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1583),
    [sym_member_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_assignment_expression] = STATE(1583),
    [sym_augmented_assignment_expression] = STATE(1583),
    [sym_ternary_expression] = STATE(1583),
    [sym_binary_expression] = STATE(1583),
    [sym_unary_expression] = STATE(1583),
    [sym_update_expression] = STATE(1583),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1583),
    [sym_type_assertion] = STATE(1583),
    [sym_as_expression] = STATE(1583),
    [sym_internal_module] = STATE(1583),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_namespace] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1665),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1671),
    [sym_this] = ACTIONS(1673),
    [sym_super] = ACTIONS(1675),
    [sym_true] = ACTIONS(1673),
    [sym_false] = ACTIONS(1673),
    [sym_null] = ACTIONS(1673),
    [sym_undefined] = ACTIONS(1673),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1661),
    [anon_sym_get] = ACTIONS(1661),
    [anon_sym_set] = ACTIONS(1661),
    [anon_sym_declare] = ACTIONS(1661),
    [anon_sym_public] = ACTIONS(1661),
    [anon_sym_private] = ACTIONS(1661),
    [anon_sym_protected] = ACTIONS(1661),
    [anon_sym_module] = ACTIONS(1661),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1661),
  },
  [212] = {
    [sym_import] = STATE(1169),
    [sym_statement_block] = STATE(1514),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_string] = STATE(1169),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1169),
    [sym_type_assertion] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1677),
    [sym_this] = ACTIONS(1679),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_undefined] = ACTIONS(1679),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [213] = {
    [sym_import] = STATE(1190),
    [sym_statement_block] = STATE(1585),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1190),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1190),
    [sym_type_assertion] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1681),
    [sym_this] = ACTIONS(1683),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [214] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [215] = {
    [sym_import] = STATE(1124),
    [sym_statement_block] = STATE(1476),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1687),
    [sym_this] = ACTIONS(1689),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1689),
    [sym_false] = ACTIONS(1689),
    [sym_null] = ACTIONS(1689),
    [sym_undefined] = ACTIONS(1689),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [216] = {
    [sym_import] = STATE(1125),
    [sym_statement_block] = STATE(1456),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1125),
    [sym_yield_expression] = STATE(1125),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1125),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1125),
    [sym_arrow_function] = STATE(1125),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1125),
    [sym_new_expression] = STATE(1125),
    [sym_await_expression] = STATE(1125),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1125),
    [sym_augmented_assignment_expression] = STATE(1125),
    [sym_ternary_expression] = STATE(1125),
    [sym_binary_expression] = STATE(1125),
    [sym_unary_expression] = STATE(1125),
    [sym_update_expression] = STATE(1125),
    [sym_string] = STATE(1125),
    [sym_template_string] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_meta_property] = STATE(1125),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1125),
    [sym_type_assertion] = STATE(1125),
    [sym_as_expression] = STATE(1125),
    [sym_internal_module] = STATE(1125),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1691),
    [sym_this] = ACTIONS(1693),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1693),
    [sym_false] = ACTIONS(1693),
    [sym_null] = ACTIONS(1693),
    [sym_undefined] = ACTIONS(1693),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [217] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(653),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(938),
    [sym_array] = STATE(939),
    [sym_class] = STATE(984),
    [sym_function] = STATE(928),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(653),
    [sym_subscript_expression] = STATE(653),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1467),
    [anon_sym_export] = ACTIONS(1469),
    [anon_sym_namespace] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1469),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1477),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1481),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [sym_null] = ACTIONS(1481),
    [sym_undefined] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1469),
    [anon_sym_set] = ACTIONS(1469),
    [anon_sym_declare] = ACTIONS(1469),
    [anon_sym_public] = ACTIONS(1469),
    [anon_sym_private] = ACTIONS(1469),
    [anon_sym_protected] = ACTIONS(1469),
    [anon_sym_module] = ACTIONS(1469),
    [anon_sym_any] = ACTIONS(1469),
    [anon_sym_number] = ACTIONS(1469),
    [anon_sym_boolean] = ACTIONS(1469),
    [anon_sym_string] = ACTIONS(1469),
    [anon_sym_symbol] = ACTIONS(1469),
    [sym_readonly] = ACTIONS(1469),
  },
  [218] = {
    [sym_import] = STATE(1357),
    [sym_statement_block] = STATE(1491),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1357),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1357),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1357),
    [sym_arrow_function] = STATE(1357),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1357),
    [sym_new_expression] = STATE(1357),
    [sym_await_expression] = STATE(1357),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1357),
    [sym_augmented_assignment_expression] = STATE(1357),
    [sym_ternary_expression] = STATE(1357),
    [sym_binary_expression] = STATE(1357),
    [sym_unary_expression] = STATE(1357),
    [sym_update_expression] = STATE(1357),
    [sym_string] = STATE(1357),
    [sym_template_string] = STATE(1357),
    [sym_regex] = STATE(1357),
    [sym_meta_property] = STATE(1357),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1357),
    [sym_type_assertion] = STATE(1357),
    [sym_as_expression] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1695),
    [sym_this] = ACTIONS(1697),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1697),
    [sym_false] = ACTIONS(1697),
    [sym_null] = ACTIONS(1697),
    [sym_undefined] = ACTIONS(1697),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [219] = {
    [sym_import] = STATE(1231),
    [sym_statement_block] = STATE(1092),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1231),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1231),
    [sym_type_assertion] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1699),
    [sym_this] = ACTIONS(1701),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1701),
    [sym_false] = ACTIONS(1701),
    [sym_null] = ACTIONS(1701),
    [sym_undefined] = ACTIONS(1701),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [220] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [221] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(740),
    [sym__expression] = STATE(1583),
    [sym_yield_expression] = STATE(1583),
    [sym_object] = STATE(1233),
    [sym_array] = STATE(1234),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1015),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1583),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1583),
    [sym_member_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_assignment_expression] = STATE(1583),
    [sym_augmented_assignment_expression] = STATE(1583),
    [sym_ternary_expression] = STATE(1583),
    [sym_binary_expression] = STATE(1583),
    [sym_unary_expression] = STATE(1583),
    [sym_update_expression] = STATE(1583),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1583),
    [sym_type_assertion] = STATE(1583),
    [sym_as_expression] = STATE(1583),
    [sym_internal_module] = STATE(1583),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1705),
    [anon_sym_export] = ACTIONS(1707),
    [anon_sym_namespace] = ACTIONS(1709),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1707),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1665),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1711),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1713),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1671),
    [sym_this] = ACTIONS(1673),
    [sym_super] = ACTIONS(1675),
    [sym_true] = ACTIONS(1673),
    [sym_false] = ACTIONS(1673),
    [sym_null] = ACTIONS(1673),
    [sym_undefined] = ACTIONS(1673),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1707),
    [anon_sym_get] = ACTIONS(1707),
    [anon_sym_set] = ACTIONS(1707),
    [anon_sym_declare] = ACTIONS(1707),
    [anon_sym_public] = ACTIONS(1707),
    [anon_sym_private] = ACTIONS(1707),
    [anon_sym_protected] = ACTIONS(1707),
    [anon_sym_module] = ACTIONS(1707),
    [anon_sym_any] = ACTIONS(1707),
    [anon_sym_number] = ACTIONS(1707),
    [anon_sym_boolean] = ACTIONS(1707),
    [anon_sym_string] = ACTIONS(1707),
    [anon_sym_symbol] = ACTIONS(1707),
    [sym_readonly] = ACTIONS(1707),
  },
  [222] = {
    [sym_import] = STATE(983),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(983),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(983),
    [sym_type_assertion] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1715),
    [sym_this] = ACTIONS(1717),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1717),
    [sym_false] = ACTIONS(1717),
    [sym_null] = ACTIONS(1717),
    [sym_undefined] = ACTIONS(1717),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [223] = {
    [sym_import] = STATE(1135),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1135),
    [sym_yield_expression] = STATE(1135),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1135),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1135),
    [sym_arrow_function] = STATE(1135),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1135),
    [sym_new_expression] = STATE(1135),
    [sym_await_expression] = STATE(1135),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1135),
    [sym_augmented_assignment_expression] = STATE(1135),
    [sym_ternary_expression] = STATE(1135),
    [sym_binary_expression] = STATE(1135),
    [sym_unary_expression] = STATE(1135),
    [sym_update_expression] = STATE(1135),
    [sym_sequence_expression] = STATE(2830),
    [sym_string] = STATE(1135),
    [sym_template_string] = STATE(1135),
    [sym_regex] = STATE(1135),
    [sym_meta_property] = STATE(1135),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1135),
    [sym_type_assertion] = STATE(1135),
    [sym_as_expression] = STATE(1135),
    [sym_internal_module] = STATE(1135),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1719),
    [sym_this] = ACTIONS(1721),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1721),
    [sym_false] = ACTIONS(1721),
    [sym_null] = ACTIONS(1721),
    [sym_undefined] = ACTIONS(1721),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [224] = {
    [sym_import] = STATE(975),
    [sym_statement_block] = STATE(1022),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(975),
    [sym_yield_expression] = STATE(975),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(975),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(975),
    [sym_arrow_function] = STATE(975),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(975),
    [sym_new_expression] = STATE(975),
    [sym_await_expression] = STATE(975),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(975),
    [sym_augmented_assignment_expression] = STATE(975),
    [sym_ternary_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_update_expression] = STATE(975),
    [sym_string] = STATE(975),
    [sym_template_string] = STATE(975),
    [sym_regex] = STATE(975),
    [sym_meta_property] = STATE(975),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(975),
    [sym_as_expression] = STATE(975),
    [sym_internal_module] = STATE(975),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1723),
    [sym_this] = ACTIONS(1725),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1725),
    [sym_false] = ACTIONS(1725),
    [sym_null] = ACTIONS(1725),
    [sym_undefined] = ACTIONS(1725),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [225] = {
    [sym_import] = STATE(959),
    [sym_statement_block] = STATE(1033),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(959),
    [sym_yield_expression] = STATE(959),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(959),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(959),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(959),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(959),
    [sym_augmented_assignment_expression] = STATE(959),
    [sym_ternary_expression] = STATE(959),
    [sym_binary_expression] = STATE(959),
    [sym_unary_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(959),
    [sym_type_assertion] = STATE(959),
    [sym_as_expression] = STATE(959),
    [sym_internal_module] = STATE(959),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1727),
    [sym_this] = ACTIONS(1729),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1729),
    [sym_false] = ACTIONS(1729),
    [sym_null] = ACTIONS(1729),
    [sym_undefined] = ACTIONS(1729),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [226] = {
    [sym_import] = STATE(1185),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_sequence_expression] = STATE(2769),
    [sym_string] = STATE(1185),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1185),
    [sym_type_assertion] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1731),
    [sym_this] = ACTIONS(1733),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1733),
    [sym_false] = ACTIONS(1733),
    [sym_null] = ACTIONS(1733),
    [sym_undefined] = ACTIONS(1733),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [227] = {
    [sym_import] = STATE(1370),
    [sym_statement_block] = STATE(1427),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1370),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1370),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1370),
    [sym_arrow_function] = STATE(1370),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1370),
    [sym_new_expression] = STATE(1370),
    [sym_await_expression] = STATE(1370),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1370),
    [sym_augmented_assignment_expression] = STATE(1370),
    [sym_ternary_expression] = STATE(1370),
    [sym_binary_expression] = STATE(1370),
    [sym_unary_expression] = STATE(1370),
    [sym_update_expression] = STATE(1370),
    [sym_string] = STATE(1370),
    [sym_template_string] = STATE(1370),
    [sym_regex] = STATE(1370),
    [sym_meta_property] = STATE(1370),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(1370),
    [sym_as_expression] = STATE(1370),
    [sym_internal_module] = STATE(1370),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1735),
    [sym_this] = ACTIONS(1737),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1737),
    [sym_false] = ACTIONS(1737),
    [sym_null] = ACTIONS(1737),
    [sym_undefined] = ACTIONS(1737),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [228] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_sequence_expression] = STATE(2968),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1360),
    [sym_type_assertion] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1739),
    [sym_this] = ACTIONS(1741),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1741),
    [sym_false] = ACTIONS(1741),
    [sym_null] = ACTIONS(1741),
    [sym_undefined] = ACTIONS(1741),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [229] = {
    [sym_import] = STATE(1334),
    [sym_statement_block] = STATE(1470),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1334),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1334),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1334),
    [sym_arrow_function] = STATE(1334),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1334),
    [sym_new_expression] = STATE(1334),
    [sym_await_expression] = STATE(1334),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1334),
    [sym_augmented_assignment_expression] = STATE(1334),
    [sym_ternary_expression] = STATE(1334),
    [sym_binary_expression] = STATE(1334),
    [sym_unary_expression] = STATE(1334),
    [sym_update_expression] = STATE(1334),
    [sym_string] = STATE(1334),
    [sym_template_string] = STATE(1334),
    [sym_regex] = STATE(1334),
    [sym_meta_property] = STATE(1334),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1334),
    [sym_type_assertion] = STATE(1334),
    [sym_as_expression] = STATE(1334),
    [sym_internal_module] = STATE(1334),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1743),
    [sym_this] = ACTIONS(1745),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1745),
    [sym_false] = ACTIONS(1745),
    [sym_null] = ACTIONS(1745),
    [sym_undefined] = ACTIONS(1745),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [230] = {
    [sym_import] = STATE(1069),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1069),
    [sym_yield_expression] = STATE(1069),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1069),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1069),
    [sym_arrow_function] = STATE(1069),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1069),
    [sym_new_expression] = STATE(1069),
    [sym_await_expression] = STATE(1069),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1069),
    [sym_augmented_assignment_expression] = STATE(1069),
    [sym_ternary_expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_update_expression] = STATE(1069),
    [sym_sequence_expression] = STATE(2872),
    [sym_string] = STATE(1069),
    [sym_template_string] = STATE(1069),
    [sym_regex] = STATE(1069),
    [sym_meta_property] = STATE(1069),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1069),
    [sym_type_assertion] = STATE(1069),
    [sym_as_expression] = STATE(1069),
    [sym_internal_module] = STATE(1069),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1747),
    [sym_this] = ACTIONS(1749),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1749),
    [sym_false] = ACTIONS(1749),
    [sym_null] = ACTIONS(1749),
    [sym_undefined] = ACTIONS(1749),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [231] = {
    [sym_import] = STATE(1283),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1283),
    [sym_type_assertion] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1751),
    [sym_this] = ACTIONS(1753),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1753),
    [sym_false] = ACTIONS(1753),
    [sym_null] = ACTIONS(1753),
    [sym_undefined] = ACTIONS(1753),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [232] = {
    [sym_import] = STATE(1120),
    [sym_statement_block] = STATE(1470),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1120),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1120),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1120),
    [sym_arrow_function] = STATE(1120),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1120),
    [sym_new_expression] = STATE(1120),
    [sym_await_expression] = STATE(1120),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1120),
    [sym_augmented_assignment_expression] = STATE(1120),
    [sym_ternary_expression] = STATE(1120),
    [sym_binary_expression] = STATE(1120),
    [sym_unary_expression] = STATE(1120),
    [sym_update_expression] = STATE(1120),
    [sym_string] = STATE(1120),
    [sym_template_string] = STATE(1120),
    [sym_regex] = STATE(1120),
    [sym_meta_property] = STATE(1120),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1120),
    [sym_type_assertion] = STATE(1120),
    [sym_as_expression] = STATE(1120),
    [sym_internal_module] = STATE(1120),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1755),
    [sym_this] = ACTIONS(1757),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1757),
    [sym_false] = ACTIONS(1757),
    [sym_null] = ACTIONS(1757),
    [sym_undefined] = ACTIONS(1757),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [233] = {
    [sym_import] = STATE(956),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(956),
    [sym_yield_expression] = STATE(956),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(956),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(956),
    [sym_arrow_function] = STATE(956),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(956),
    [sym_new_expression] = STATE(956),
    [sym_await_expression] = STATE(956),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(956),
    [sym_augmented_assignment_expression] = STATE(956),
    [sym_ternary_expression] = STATE(956),
    [sym_binary_expression] = STATE(956),
    [sym_unary_expression] = STATE(956),
    [sym_update_expression] = STATE(956),
    [sym_string] = STATE(956),
    [sym_template_string] = STATE(956),
    [sym_regex] = STATE(956),
    [sym_meta_property] = STATE(956),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(956),
    [sym_type_assertion] = STATE(956),
    [sym_as_expression] = STATE(956),
    [sym_internal_module] = STATE(956),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1759),
    [sym_this] = ACTIONS(1761),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1761),
    [sym_false] = ACTIONS(1761),
    [sym_null] = ACTIONS(1761),
    [sym_undefined] = ACTIONS(1761),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [234] = {
    [sym_import] = STATE(1278),
    [sym_statement_block] = STATE(1476),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1278),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1278),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1278),
    [sym_arrow_function] = STATE(1278),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1278),
    [sym_new_expression] = STATE(1278),
    [sym_await_expression] = STATE(1278),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1278),
    [sym_augmented_assignment_expression] = STATE(1278),
    [sym_ternary_expression] = STATE(1278),
    [sym_binary_expression] = STATE(1278),
    [sym_unary_expression] = STATE(1278),
    [sym_update_expression] = STATE(1278),
    [sym_string] = STATE(1278),
    [sym_template_string] = STATE(1278),
    [sym_regex] = STATE(1278),
    [sym_meta_property] = STATE(1278),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1278),
    [sym_type_assertion] = STATE(1278),
    [sym_as_expression] = STATE(1278),
    [sym_internal_module] = STATE(1278),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1763),
    [sym_this] = ACTIONS(1765),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1765),
    [sym_false] = ACTIONS(1765),
    [sym_null] = ACTIONS(1765),
    [sym_undefined] = ACTIONS(1765),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [235] = {
    [sym_import] = STATE(1277),
    [sym_statement_block] = STATE(1456),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1277),
    [sym_type_assertion] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1767),
    [sym_this] = ACTIONS(1769),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1769),
    [sym_false] = ACTIONS(1769),
    [sym_null] = ACTIONS(1769),
    [sym_undefined] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [236] = {
    [sym_import] = STATE(955),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(955),
    [sym_yield_expression] = STATE(955),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(955),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(955),
    [sym_arrow_function] = STATE(955),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(955),
    [sym_new_expression] = STATE(955),
    [sym_await_expression] = STATE(955),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(955),
    [sym_augmented_assignment_expression] = STATE(955),
    [sym_ternary_expression] = STATE(955),
    [sym_binary_expression] = STATE(955),
    [sym_unary_expression] = STATE(955),
    [sym_update_expression] = STATE(955),
    [sym_sequence_expression] = STATE(2320),
    [sym_string] = STATE(955),
    [sym_template_string] = STATE(955),
    [sym_regex] = STATE(955),
    [sym_meta_property] = STATE(955),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(955),
    [sym_type_assertion] = STATE(955),
    [sym_as_expression] = STATE(955),
    [sym_internal_module] = STATE(955),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1771),
    [sym_this] = ACTIONS(1773),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1773),
    [sym_false] = ACTIONS(1773),
    [sym_null] = ACTIONS(1773),
    [sym_undefined] = ACTIONS(1773),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [237] = {
    [sym_import] = STATE(1205),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_sequence_expression] = STATE(2708),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1205),
    [sym_type_assertion] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [sym_undefined] = ACTIONS(1777),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [238] = {
    [sym_import] = STATE(1254),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1254),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_nested_identifier] = STATE(425),
    [sym_class] = STATE(1254),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1254),
    [sym_arrow_function] = STATE(1254),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1254),
    [sym_new_expression] = STATE(1254),
    [sym_await_expression] = STATE(1254),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1254),
    [sym_augmented_assignment_expression] = STATE(1254),
    [sym_ternary_expression] = STATE(1254),
    [sym_binary_expression] = STATE(1254),
    [sym_unary_expression] = STATE(1254),
    [sym_update_expression] = STATE(1254),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1254),
    [sym_regex] = STATE(1254),
    [sym_meta_property] = STATE(1254),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1254),
    [sym_type_assertion] = STATE(1254),
    [sym_as_expression] = STATE(1254),
    [sym_internal_module] = STATE(1254),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(647),
    [sym_this] = ACTIONS(649),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_undefined] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [239] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(740),
    [sym__expression] = STATE(1583),
    [sym_yield_expression] = STATE(1583),
    [sym_object] = STATE(1233),
    [sym_array] = STATE(1234),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1015),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1583),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1583),
    [sym_member_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_assignment_expression] = STATE(1583),
    [sym_augmented_assignment_expression] = STATE(1583),
    [sym_ternary_expression] = STATE(1583),
    [sym_binary_expression] = STATE(1583),
    [sym_unary_expression] = STATE(1583),
    [sym_update_expression] = STATE(1583),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1583),
    [sym_type_assertion] = STATE(1583),
    [sym_as_expression] = STATE(1583),
    [sym_internal_module] = STATE(1583),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_namespace] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1665),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1671),
    [sym_this] = ACTIONS(1673),
    [sym_super] = ACTIONS(1675),
    [sym_true] = ACTIONS(1673),
    [sym_false] = ACTIONS(1673),
    [sym_null] = ACTIONS(1673),
    [sym_undefined] = ACTIONS(1673),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1661),
    [anon_sym_get] = ACTIONS(1661),
    [anon_sym_set] = ACTIONS(1661),
    [anon_sym_declare] = ACTIONS(1661),
    [anon_sym_public] = ACTIONS(1661),
    [anon_sym_private] = ACTIONS(1661),
    [anon_sym_protected] = ACTIONS(1661),
    [anon_sym_module] = ACTIONS(1661),
    [anon_sym_any] = ACTIONS(1661),
    [anon_sym_number] = ACTIONS(1661),
    [anon_sym_boolean] = ACTIONS(1661),
    [anon_sym_string] = ACTIONS(1661),
    [anon_sym_symbol] = ACTIONS(1661),
    [sym_readonly] = ACTIONS(1661),
  },
  [240] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(740),
    [sym__expression] = STATE(1583),
    [sym_yield_expression] = STATE(1583),
    [sym_object] = STATE(1233),
    [sym_array] = STATE(1234),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1015),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1583),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1583),
    [sym_member_expression] = STATE(740),
    [sym_subscript_expression] = STATE(740),
    [sym_assignment_expression] = STATE(1583),
    [sym_augmented_assignment_expression] = STATE(1583),
    [sym_ternary_expression] = STATE(1583),
    [sym_binary_expression] = STATE(1583),
    [sym_unary_expression] = STATE(1583),
    [sym_update_expression] = STATE(1583),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2484),
    [sym_non_null_expression] = STATE(1583),
    [sym_type_assertion] = STATE(1583),
    [sym_as_expression] = STATE(1583),
    [sym_internal_module] = STATE(1583),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2730),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(1705),
    [anon_sym_export] = ACTIONS(1707),
    [anon_sym_namespace] = ACTIONS(1709),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1707),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1665),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1711),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1713),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1671),
    [sym_this] = ACTIONS(1673),
    [sym_super] = ACTIONS(1675),
    [sym_true] = ACTIONS(1673),
    [sym_false] = ACTIONS(1673),
    [sym_null] = ACTIONS(1673),
    [sym_undefined] = ACTIONS(1673),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1707),
    [anon_sym_get] = ACTIONS(1707),
    [anon_sym_set] = ACTIONS(1707),
    [anon_sym_declare] = ACTIONS(1707),
    [anon_sym_public] = ACTIONS(1707),
    [anon_sym_private] = ACTIONS(1707),
    [anon_sym_protected] = ACTIONS(1707),
    [anon_sym_module] = ACTIONS(1707),
    [anon_sym_any] = ACTIONS(1707),
    [anon_sym_number] = ACTIONS(1707),
    [anon_sym_boolean] = ACTIONS(1707),
    [anon_sym_string] = ACTIONS(1707),
    [anon_sym_symbol] = ACTIONS(1707),
    [sym_readonly] = ACTIONS(1707),
  },
  [241] = {
    [sym_import] = STATE(1045),
    [sym_statement_block] = STATE(1427),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1045),
    [sym_yield_expression] = STATE(1045),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1045),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1045),
    [sym_arrow_function] = STATE(1045),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1045),
    [sym_new_expression] = STATE(1045),
    [sym_await_expression] = STATE(1045),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1045),
    [sym_augmented_assignment_expression] = STATE(1045),
    [sym_ternary_expression] = STATE(1045),
    [sym_binary_expression] = STATE(1045),
    [sym_unary_expression] = STATE(1045),
    [sym_update_expression] = STATE(1045),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(1045),
    [sym_regex] = STATE(1045),
    [sym_meta_property] = STATE(1045),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1045),
    [sym_type_assertion] = STATE(1045),
    [sym_as_expression] = STATE(1045),
    [sym_internal_module] = STATE(1045),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1781),
    [sym_this] = ACTIONS(1783),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [sym_null] = ACTIONS(1783),
    [sym_undefined] = ACTIONS(1783),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [242] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_sequence_expression] = STATE(2836),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1785),
    [sym_this] = ACTIONS(1787),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1787),
    [sym_false] = ACTIONS(1787),
    [sym_null] = ACTIONS(1787),
    [sym_undefined] = ACTIONS(1787),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [243] = {
    [sym_import] = STATE(951),
    [sym_statement_block] = STATE(1092),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(951),
    [sym_yield_expression] = STATE(951),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(951),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(951),
    [sym_arrow_function] = STATE(951),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(951),
    [sym_new_expression] = STATE(951),
    [sym_await_expression] = STATE(951),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(951),
    [sym_augmented_assignment_expression] = STATE(951),
    [sym_ternary_expression] = STATE(951),
    [sym_binary_expression] = STATE(951),
    [sym_unary_expression] = STATE(951),
    [sym_update_expression] = STATE(951),
    [sym_string] = STATE(951),
    [sym_template_string] = STATE(951),
    [sym_regex] = STATE(951),
    [sym_meta_property] = STATE(951),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(951),
    [sym_type_assertion] = STATE(951),
    [sym_as_expression] = STATE(951),
    [sym_internal_module] = STATE(951),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1789),
    [sym_this] = ACTIONS(1791),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1791),
    [sym_false] = ACTIONS(1791),
    [sym_null] = ACTIONS(1791),
    [sym_undefined] = ACTIONS(1791),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [244] = {
    [sym_import] = STATE(958),
    [sym_statement_block] = STATE(1137),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(958),
    [sym_yield_expression] = STATE(958),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(958),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(958),
    [sym_arrow_function] = STATE(958),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(958),
    [sym_new_expression] = STATE(958),
    [sym_await_expression] = STATE(958),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(958),
    [sym_augmented_assignment_expression] = STATE(958),
    [sym_ternary_expression] = STATE(958),
    [sym_binary_expression] = STATE(958),
    [sym_unary_expression] = STATE(958),
    [sym_update_expression] = STATE(958),
    [sym_string] = STATE(958),
    [sym_template_string] = STATE(958),
    [sym_regex] = STATE(958),
    [sym_meta_property] = STATE(958),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(958),
    [sym_type_assertion] = STATE(958),
    [sym_as_expression] = STATE(958),
    [sym_internal_module] = STATE(958),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1793),
    [sym_this] = ACTIONS(1795),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1795),
    [sym_false] = ACTIONS(1795),
    [sym_null] = ACTIONS(1795),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [245] = {
    [sym_import] = STATE(1227),
    [sym_statement_block] = STATE(1137),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1227),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1227),
    [sym_arrow_function] = STATE(1227),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_string] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1227),
    [sym_type_assertion] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1797),
    [sym_this] = ACTIONS(1799),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1799),
    [sym_false] = ACTIONS(1799),
    [sym_null] = ACTIONS(1799),
    [sym_undefined] = ACTIONS(1799),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [246] = {
    [sym_import] = STATE(1368),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1368),
    [sym_arrow_function] = STATE(1368),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1368),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1368),
    [sym_type_assertion] = STATE(1368),
    [sym_as_expression] = STATE(1368),
    [sym_internal_module] = STATE(1368),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1801),
    [sym_this] = ACTIONS(1803),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1803),
    [sym_false] = ACTIONS(1803),
    [sym_null] = ACTIONS(1803),
    [sym_undefined] = ACTIONS(1803),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [247] = {
    [sym_import] = STATE(1175),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1175),
    [sym_yield_expression] = STATE(1175),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1175),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1175),
    [sym_arrow_function] = STATE(1175),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1175),
    [sym_new_expression] = STATE(1175),
    [sym_await_expression] = STATE(1175),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(1175),
    [sym_ternary_expression] = STATE(1175),
    [sym_binary_expression] = STATE(1175),
    [sym_unary_expression] = STATE(1175),
    [sym_update_expression] = STATE(1175),
    [sym_string] = STATE(1175),
    [sym_template_string] = STATE(1175),
    [sym_regex] = STATE(1175),
    [sym_meta_property] = STATE(1175),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1175),
    [sym_as_expression] = STATE(1175),
    [sym_internal_module] = STATE(1175),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1805),
    [sym_this] = ACTIONS(1807),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1807),
    [sym_false] = ACTIONS(1807),
    [sym_null] = ACTIONS(1807),
    [sym_undefined] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [248] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1809),
    [sym_this] = ACTIONS(1811),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1811),
    [sym_false] = ACTIONS(1811),
    [sym_null] = ACTIONS(1811),
    [sym_undefined] = ACTIONS(1811),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [249] = {
    [sym_import] = STATE(1109),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1109),
    [sym_yield_expression] = STATE(1109),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1109),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1109),
    [sym_arrow_function] = STATE(1109),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1109),
    [sym_new_expression] = STATE(1109),
    [sym_await_expression] = STATE(1109),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1109),
    [sym_augmented_assignment_expression] = STATE(1109),
    [sym_ternary_expression] = STATE(1109),
    [sym_binary_expression] = STATE(1109),
    [sym_unary_expression] = STATE(1109),
    [sym_update_expression] = STATE(1109),
    [sym_string] = STATE(1109),
    [sym_template_string] = STATE(1109),
    [sym_regex] = STATE(1109),
    [sym_meta_property] = STATE(1109),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1109),
    [sym_type_assertion] = STATE(1109),
    [sym_as_expression] = STATE(1109),
    [sym_internal_module] = STATE(1109),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1813),
    [sym_this] = ACTIONS(1815),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1815),
    [sym_false] = ACTIONS(1815),
    [sym_null] = ACTIONS(1815),
    [sym_undefined] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [250] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(978),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1817),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [251] = {
    [sym_import] = STATE(929),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(929),
    [sym_yield_expression] = STATE(929),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(929),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(929),
    [sym_arrow_function] = STATE(929),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(929),
    [sym_new_expression] = STATE(929),
    [sym_await_expression] = STATE(929),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(929),
    [sym_augmented_assignment_expression] = STATE(929),
    [sym_ternary_expression] = STATE(929),
    [sym_binary_expression] = STATE(929),
    [sym_unary_expression] = STATE(929),
    [sym_update_expression] = STATE(929),
    [sym_string] = STATE(929),
    [sym_template_string] = STATE(929),
    [sym_regex] = STATE(929),
    [sym_meta_property] = STATE(929),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(929),
    [sym_type_assertion] = STATE(929),
    [sym_as_expression] = STATE(929),
    [sym_internal_module] = STATE(929),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [sym_undefined] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [252] = {
    [sym_import] = STATE(933),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(933),
    [sym_yield_expression] = STATE(933),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(933),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(933),
    [sym_arrow_function] = STATE(933),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(933),
    [sym_new_expression] = STATE(933),
    [sym_await_expression] = STATE(933),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(933),
    [sym_augmented_assignment_expression] = STATE(933),
    [sym_ternary_expression] = STATE(933),
    [sym_binary_expression] = STATE(933),
    [sym_unary_expression] = STATE(933),
    [sym_update_expression] = STATE(933),
    [sym_string] = STATE(933),
    [sym_template_string] = STATE(933),
    [sym_regex] = STATE(933),
    [sym_meta_property] = STATE(933),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(933),
    [sym_type_assertion] = STATE(933),
    [sym_as_expression] = STATE(933),
    [sym_internal_module] = STATE(933),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1825),
    [sym_this] = ACTIONS(1827),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1827),
    [sym_false] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [253] = {
    [sym_import] = STATE(1147),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1147),
    [sym_yield_expression] = STATE(1147),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1147),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1147),
    [sym_arrow_function] = STATE(1147),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1147),
    [sym_new_expression] = STATE(1147),
    [sym_await_expression] = STATE(1147),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1147),
    [sym_augmented_assignment_expression] = STATE(1147),
    [sym_ternary_expression] = STATE(1147),
    [sym_binary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym_update_expression] = STATE(1147),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(1147),
    [sym_regex] = STATE(1147),
    [sym_meta_property] = STATE(1147),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1147),
    [sym_type_assertion] = STATE(1147),
    [sym_as_expression] = STATE(1147),
    [sym_internal_module] = STATE(1147),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1829),
    [sym_this] = ACTIONS(1831),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1831),
    [sym_false] = ACTIONS(1831),
    [sym_null] = ACTIONS(1831),
    [sym_undefined] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [254] = {
    [sym_import] = STATE(1042),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1042),
    [sym_yield_expression] = STATE(1042),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1042),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1042),
    [sym_arrow_function] = STATE(1042),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1042),
    [sym_new_expression] = STATE(1042),
    [sym_await_expression] = STATE(1042),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1042),
    [sym_augmented_assignment_expression] = STATE(1042),
    [sym_ternary_expression] = STATE(1042),
    [sym_binary_expression] = STATE(1042),
    [sym_unary_expression] = STATE(1042),
    [sym_update_expression] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym_template_string] = STATE(1042),
    [sym_regex] = STATE(1042),
    [sym_meta_property] = STATE(1042),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1042),
    [sym_type_assertion] = STATE(1042),
    [sym_as_expression] = STATE(1042),
    [sym_internal_module] = STATE(1042),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1833),
    [sym_this] = ACTIONS(1835),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1835),
    [sym_false] = ACTIONS(1835),
    [sym_null] = ACTIONS(1835),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [255] = {
    [sym_import] = STATE(1199),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1199),
    [sym_type_assertion] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1837),
    [sym_this] = ACTIONS(1839),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1839),
    [sym_false] = ACTIONS(1839),
    [sym_null] = ACTIONS(1839),
    [sym_undefined] = ACTIONS(1839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [256] = {
    [sym_import] = STATE(1046),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1046),
    [sym_yield_expression] = STATE(1046),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1046),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1046),
    [sym_arrow_function] = STATE(1046),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1046),
    [sym_new_expression] = STATE(1046),
    [sym_await_expression] = STATE(1046),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1046),
    [sym_augmented_assignment_expression] = STATE(1046),
    [sym_ternary_expression] = STATE(1046),
    [sym_binary_expression] = STATE(1046),
    [sym_unary_expression] = STATE(1046),
    [sym_update_expression] = STATE(1046),
    [sym_string] = STATE(1046),
    [sym_template_string] = STATE(1046),
    [sym_regex] = STATE(1046),
    [sym_meta_property] = STATE(1046),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1046),
    [sym_type_assertion] = STATE(1046),
    [sym_as_expression] = STATE(1046),
    [sym_internal_module] = STATE(1046),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1841),
    [sym_this] = ACTIONS(1843),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1843),
    [sym_false] = ACTIONS(1843),
    [sym_null] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [257] = {
    [sym__declaration] = STATE(536),
    [sym_variable_declaration] = STATE(536),
    [sym_lexical_declaration] = STATE(536),
    [sym_class_declaration] = STATE(536),
    [sym_function_declaration] = STATE(536),
    [sym_generator_function_declaration] = STATE(536),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(536),
    [sym_ambient_declaration] = STATE(536),
    [sym_abstract_class_declaration] = STATE(536),
    [sym_module] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_import_alias] = STATE(536),
    [sym_interface_declaration] = STATE(536),
    [sym_enum_declaration] = STATE(536),
    [sym_type_alias_declaration] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1441),
    [anon_sym_global] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [258] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1258),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1258),
    [sym_type_assertion] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1845),
    [sym_this] = ACTIONS(1847),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1847),
    [sym_false] = ACTIONS(1847),
    [sym_null] = ACTIONS(1847),
    [sym_undefined] = ACTIONS(1847),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [259] = {
    [sym_import] = STATE(953),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(953),
    [sym_yield_expression] = STATE(953),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(953),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(953),
    [sym_arrow_function] = STATE(953),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(953),
    [sym_new_expression] = STATE(953),
    [sym_await_expression] = STATE(953),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(953),
    [sym_augmented_assignment_expression] = STATE(953),
    [sym_ternary_expression] = STATE(953),
    [sym_binary_expression] = STATE(953),
    [sym_unary_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_string] = STATE(953),
    [sym_template_string] = STATE(953),
    [sym_regex] = STATE(953),
    [sym_meta_property] = STATE(953),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(953),
    [sym_type_assertion] = STATE(953),
    [sym_as_expression] = STATE(953),
    [sym_internal_module] = STATE(953),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1849),
    [sym_this] = ACTIONS(1851),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1851),
    [sym_false] = ACTIONS(1851),
    [sym_null] = ACTIONS(1851),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [260] = {
    [sym_import] = STATE(992),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(992),
    [sym_yield_expression] = STATE(992),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(992),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(992),
    [sym_arrow_function] = STATE(992),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(992),
    [sym_new_expression] = STATE(992),
    [sym_await_expression] = STATE(992),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(992),
    [sym_augmented_assignment_expression] = STATE(992),
    [sym_ternary_expression] = STATE(992),
    [sym_binary_expression] = STATE(992),
    [sym_unary_expression] = STATE(992),
    [sym_update_expression] = STATE(992),
    [sym_string] = STATE(992),
    [sym_template_string] = STATE(992),
    [sym_regex] = STATE(992),
    [sym_meta_property] = STATE(992),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(992),
    [sym_type_assertion] = STATE(992),
    [sym_as_expression] = STATE(992),
    [sym_internal_module] = STATE(992),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1853),
    [sym_this] = ACTIONS(1855),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_undefined] = ACTIONS(1855),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [261] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1308),
    [sym_type_assertion] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1857),
    [sym_this] = ACTIONS(1859),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1859),
    [sym_false] = ACTIONS(1859),
    [sym_null] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [262] = {
    [sym_import] = STATE(948),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(948),
    [sym_yield_expression] = STATE(948),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(948),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(948),
    [sym_arrow_function] = STATE(948),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(948),
    [sym_new_expression] = STATE(948),
    [sym_await_expression] = STATE(948),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(948),
    [sym_augmented_assignment_expression] = STATE(948),
    [sym_ternary_expression] = STATE(948),
    [sym_binary_expression] = STATE(948),
    [sym_unary_expression] = STATE(948),
    [sym_update_expression] = STATE(948),
    [sym_string] = STATE(948),
    [sym_template_string] = STATE(948),
    [sym_regex] = STATE(948),
    [sym_meta_property] = STATE(948),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(948),
    [sym_type_assertion] = STATE(948),
    [sym_as_expression] = STATE(948),
    [sym_internal_module] = STATE(948),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1861),
    [sym_this] = ACTIONS(1863),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1863),
    [sym_false] = ACTIONS(1863),
    [sym_null] = ACTIONS(1863),
    [sym_undefined] = ACTIONS(1863),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [263] = {
    [sym_import] = STATE(1264),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1264),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1264),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1264),
    [sym_arrow_function] = STATE(1264),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1264),
    [sym_new_expression] = STATE(1264),
    [sym_await_expression] = STATE(1264),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1264),
    [sym_augmented_assignment_expression] = STATE(1264),
    [sym_ternary_expression] = STATE(1264),
    [sym_binary_expression] = STATE(1264),
    [sym_unary_expression] = STATE(1264),
    [sym_update_expression] = STATE(1264),
    [sym_string] = STATE(1264),
    [sym_template_string] = STATE(1264),
    [sym_regex] = STATE(1264),
    [sym_meta_property] = STATE(1264),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1264),
    [sym_type_assertion] = STATE(1264),
    [sym_as_expression] = STATE(1264),
    [sym_internal_module] = STATE(1264),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1865),
    [sym_this] = ACTIONS(1867),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1867),
    [sym_false] = ACTIONS(1867),
    [sym_null] = ACTIONS(1867),
    [sym_undefined] = ACTIONS(1867),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [264] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1869),
    [sym_this] = ACTIONS(1871),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_undefined] = ACTIONS(1871),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [265] = {
    [sym_import] = STATE(1126),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1126),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1126),
    [sym_arrow_function] = STATE(1126),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1126),
    [sym_new_expression] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_string] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1126),
    [sym_type_assertion] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1873),
    [sym_this] = ACTIONS(1875),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1875),
    [sym_false] = ACTIONS(1875),
    [sym_null] = ACTIONS(1875),
    [sym_undefined] = ACTIONS(1875),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [266] = {
    [sym_import] = STATE(1024),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1024),
    [sym_yield_expression] = STATE(1024),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1024),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1024),
    [sym_arrow_function] = STATE(1024),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1024),
    [sym_new_expression] = STATE(1024),
    [sym_await_expression] = STATE(1024),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1024),
    [sym_augmented_assignment_expression] = STATE(1024),
    [sym_ternary_expression] = STATE(1024),
    [sym_binary_expression] = STATE(1024),
    [sym_unary_expression] = STATE(1024),
    [sym_update_expression] = STATE(1024),
    [sym_string] = STATE(1024),
    [sym_template_string] = STATE(1024),
    [sym_regex] = STATE(1024),
    [sym_meta_property] = STATE(1024),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1024),
    [sym_type_assertion] = STATE(1024),
    [sym_as_expression] = STATE(1024),
    [sym_internal_module] = STATE(1024),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1877),
    [sym_this] = ACTIONS(1879),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1879),
    [sym_false] = ACTIONS(1879),
    [sym_null] = ACTIONS(1879),
    [sym_undefined] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [267] = {
    [sym_import] = STATE(1527),
    [sym_parenthesized_expression] = STATE(895),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1527),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1527),
    [sym_arrow_function] = STATE(1527),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(895),
    [sym_subscript_expression] = STATE(895),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(1527),
    [sym_template_string] = STATE(1527),
    [sym_regex] = STATE(1527),
    [sym_meta_property] = STATE(1527),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(1881),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(1615),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(1621),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1425),
    [sym_this] = ACTIONS(1427),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1427),
    [sym_false] = ACTIONS(1427),
    [sym_null] = ACTIONS(1427),
    [sym_undefined] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_get] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1615),
    [anon_sym_declare] = ACTIONS(1615),
    [anon_sym_public] = ACTIONS(1615),
    [anon_sym_private] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1615),
    [anon_sym_any] = ACTIONS(1615),
    [anon_sym_number] = ACTIONS(1615),
    [anon_sym_boolean] = ACTIONS(1615),
    [anon_sym_string] = ACTIONS(1615),
    [anon_sym_symbol] = ACTIONS(1615),
    [sym_readonly] = ACTIONS(1615),
  },
  [268] = {
    [sym_import] = STATE(929),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(929),
    [sym_yield_expression] = STATE(929),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(929),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(929),
    [sym_arrow_function] = STATE(929),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(929),
    [sym_new_expression] = STATE(929),
    [sym_await_expression] = STATE(929),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(929),
    [sym_augmented_assignment_expression] = STATE(929),
    [sym_ternary_expression] = STATE(929),
    [sym_binary_expression] = STATE(929),
    [sym_unary_expression] = STATE(929),
    [sym_update_expression] = STATE(929),
    [sym_string] = STATE(929),
    [sym_template_string] = STATE(929),
    [sym_regex] = STATE(929),
    [sym_meta_property] = STATE(929),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(929),
    [sym_type_assertion] = STATE(929),
    [sym_as_expression] = STATE(929),
    [sym_internal_module] = STATE(929),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [sym_undefined] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [269] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(533),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_null] = ACTIONS(535),
    [sym_undefined] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [270] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1061),
    [sym_type_assertion] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1883),
    [sym_this] = ACTIONS(1885),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1885),
    [sym_false] = ACTIONS(1885),
    [sym_null] = ACTIONS(1885),
    [sym_undefined] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [271] = {
    [sym_import] = STATE(1157),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1157),
    [sym_yield_expression] = STATE(1157),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1157),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1157),
    [sym_arrow_function] = STATE(1157),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1157),
    [sym_new_expression] = STATE(1157),
    [sym_await_expression] = STATE(1157),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1157),
    [sym_augmented_assignment_expression] = STATE(1157),
    [sym_ternary_expression] = STATE(1157),
    [sym_binary_expression] = STATE(1157),
    [sym_unary_expression] = STATE(1157),
    [sym_update_expression] = STATE(1157),
    [sym_string] = STATE(1157),
    [sym_template_string] = STATE(1157),
    [sym_regex] = STATE(1157),
    [sym_meta_property] = STATE(1157),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1157),
    [sym_type_assertion] = STATE(1157),
    [sym_as_expression] = STATE(1157),
    [sym_internal_module] = STATE(1157),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1887),
    [sym_this] = ACTIONS(1889),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1889),
    [sym_false] = ACTIONS(1889),
    [sym_null] = ACTIONS(1889),
    [sym_undefined] = ACTIONS(1889),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [272] = {
    [sym_import] = STATE(1138),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1138),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1138),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1138),
    [sym_arrow_function] = STATE(1138),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1138),
    [sym_new_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1138),
    [sym_augmented_assignment_expression] = STATE(1138),
    [sym_ternary_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_update_expression] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_template_string] = STATE(1138),
    [sym_regex] = STATE(1138),
    [sym_meta_property] = STATE(1138),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1138),
    [sym_type_assertion] = STATE(1138),
    [sym_as_expression] = STATE(1138),
    [sym_internal_module] = STATE(1138),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [273] = {
    [sym_import] = STATE(1065),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1065),
    [sym_yield_expression] = STATE(1065),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1065),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1065),
    [sym_arrow_function] = STATE(1065),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1065),
    [sym_new_expression] = STATE(1065),
    [sym_await_expression] = STATE(1065),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1065),
    [sym_augmented_assignment_expression] = STATE(1065),
    [sym_ternary_expression] = STATE(1065),
    [sym_binary_expression] = STATE(1065),
    [sym_unary_expression] = STATE(1065),
    [sym_update_expression] = STATE(1065),
    [sym_string] = STATE(1065),
    [sym_template_string] = STATE(1065),
    [sym_regex] = STATE(1065),
    [sym_meta_property] = STATE(1065),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1065),
    [sym_type_assertion] = STATE(1065),
    [sym_as_expression] = STATE(1065),
    [sym_internal_module] = STATE(1065),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1891),
    [sym_this] = ACTIONS(1022),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1022),
    [sym_false] = ACTIONS(1022),
    [sym_null] = ACTIONS(1022),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [274] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1250),
    [sym_type_assertion] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1893),
    [sym_this] = ACTIONS(1895),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1895),
    [sym_false] = ACTIONS(1895),
    [sym_null] = ACTIONS(1895),
    [sym_undefined] = ACTIONS(1895),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [275] = {
    [sym_import] = STATE(1469),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1469),
    [sym_yield_expression] = STATE(1469),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1469),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1469),
    [sym_arrow_function] = STATE(1469),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1469),
    [sym_new_expression] = STATE(1469),
    [sym_await_expression] = STATE(1469),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1469),
    [sym_augmented_assignment_expression] = STATE(1469),
    [sym_ternary_expression] = STATE(1469),
    [sym_binary_expression] = STATE(1469),
    [sym_unary_expression] = STATE(1469),
    [sym_update_expression] = STATE(1469),
    [sym_string] = STATE(1469),
    [sym_template_string] = STATE(1469),
    [sym_regex] = STATE(1469),
    [sym_meta_property] = STATE(1469),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1469),
    [sym_type_assertion] = STATE(1469),
    [sym_as_expression] = STATE(1469),
    [sym_internal_module] = STATE(1469),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1897),
    [sym_this] = ACTIONS(1899),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1899),
    [sym_false] = ACTIONS(1899),
    [sym_null] = ACTIONS(1899),
    [sym_undefined] = ACTIONS(1899),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [276] = {
    [sym_import] = STATE(1073),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1073),
    [sym_yield_expression] = STATE(1073),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1073),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1073),
    [sym_arrow_function] = STATE(1073),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1073),
    [sym_new_expression] = STATE(1073),
    [sym_await_expression] = STATE(1073),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1073),
    [sym_augmented_assignment_expression] = STATE(1073),
    [sym_ternary_expression] = STATE(1073),
    [sym_binary_expression] = STATE(1073),
    [sym_unary_expression] = STATE(1073),
    [sym_update_expression] = STATE(1073),
    [sym_string] = STATE(1073),
    [sym_template_string] = STATE(1073),
    [sym_regex] = STATE(1073),
    [sym_meta_property] = STATE(1073),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1073),
    [sym_type_assertion] = STATE(1073),
    [sym_as_expression] = STATE(1073),
    [sym_internal_module] = STATE(1073),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1901),
    [sym_this] = ACTIONS(1903),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [sym_null] = ACTIONS(1903),
    [sym_undefined] = ACTIONS(1903),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [277] = {
    [sym_import] = STATE(1075),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1075),
    [sym_yield_expression] = STATE(1075),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1075),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1075),
    [sym_arrow_function] = STATE(1075),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1075),
    [sym_new_expression] = STATE(1075),
    [sym_await_expression] = STATE(1075),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1075),
    [sym_augmented_assignment_expression] = STATE(1075),
    [sym_ternary_expression] = STATE(1075),
    [sym_binary_expression] = STATE(1075),
    [sym_unary_expression] = STATE(1075),
    [sym_update_expression] = STATE(1075),
    [sym_string] = STATE(1075),
    [sym_template_string] = STATE(1075),
    [sym_regex] = STATE(1075),
    [sym_meta_property] = STATE(1075),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1075),
    [sym_type_assertion] = STATE(1075),
    [sym_as_expression] = STATE(1075),
    [sym_internal_module] = STATE(1075),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1905),
    [sym_this] = ACTIONS(1907),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1907),
    [sym_false] = ACTIONS(1907),
    [sym_null] = ACTIONS(1907),
    [sym_undefined] = ACTIONS(1907),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [278] = {
    [sym_import] = STATE(1077),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1077),
    [sym_arrow_function] = STATE(1077),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1077),
    [sym_type_assertion] = STATE(1077),
    [sym_as_expression] = STATE(1077),
    [sym_internal_module] = STATE(1077),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1909),
    [sym_this] = ACTIONS(1911),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1911),
    [sym_false] = ACTIONS(1911),
    [sym_null] = ACTIONS(1911),
    [sym_undefined] = ACTIONS(1911),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [279] = {
    [sym_import] = STATE(1078),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1078),
    [sym_yield_expression] = STATE(1078),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1078),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1078),
    [sym_arrow_function] = STATE(1078),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1078),
    [sym_new_expression] = STATE(1078),
    [sym_await_expression] = STATE(1078),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1078),
    [sym_augmented_assignment_expression] = STATE(1078),
    [sym_ternary_expression] = STATE(1078),
    [sym_binary_expression] = STATE(1078),
    [sym_unary_expression] = STATE(1078),
    [sym_update_expression] = STATE(1078),
    [sym_string] = STATE(1078),
    [sym_template_string] = STATE(1078),
    [sym_regex] = STATE(1078),
    [sym_meta_property] = STATE(1078),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1078),
    [sym_type_assertion] = STATE(1078),
    [sym_as_expression] = STATE(1078),
    [sym_internal_module] = STATE(1078),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1913),
    [sym_this] = ACTIONS(1915),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1915),
    [sym_false] = ACTIONS(1915),
    [sym_null] = ACTIONS(1915),
    [sym_undefined] = ACTIONS(1915),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [280] = {
    [sym_import] = STATE(1099),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1099),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1099),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1099),
    [sym_arrow_function] = STATE(1099),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1099),
    [sym_new_expression] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1099),
    [sym_augmented_assignment_expression] = STATE(1099),
    [sym_ternary_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_update_expression] = STATE(1099),
    [sym_string] = STATE(1099),
    [sym_template_string] = STATE(1099),
    [sym_regex] = STATE(1099),
    [sym_meta_property] = STATE(1099),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1099),
    [sym_as_expression] = STATE(1099),
    [sym_internal_module] = STATE(1099),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1917),
    [sym_this] = ACTIONS(1919),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [sym_null] = ACTIONS(1919),
    [sym_undefined] = ACTIONS(1919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [281] = {
    [sym_import] = STATE(933),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(933),
    [sym_yield_expression] = STATE(933),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(933),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(933),
    [sym_arrow_function] = STATE(933),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(933),
    [sym_new_expression] = STATE(933),
    [sym_await_expression] = STATE(933),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(933),
    [sym_augmented_assignment_expression] = STATE(933),
    [sym_ternary_expression] = STATE(933),
    [sym_binary_expression] = STATE(933),
    [sym_unary_expression] = STATE(933),
    [sym_update_expression] = STATE(933),
    [sym_string] = STATE(933),
    [sym_template_string] = STATE(933),
    [sym_regex] = STATE(933),
    [sym_meta_property] = STATE(933),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(933),
    [sym_type_assertion] = STATE(933),
    [sym_as_expression] = STATE(933),
    [sym_internal_module] = STATE(933),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1825),
    [sym_this] = ACTIONS(1827),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1827),
    [sym_false] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [282] = {
    [sym_import] = STATE(1158),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1158),
    [sym_yield_expression] = STATE(1158),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1158),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1158),
    [sym_arrow_function] = STATE(1158),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1158),
    [sym_new_expression] = STATE(1158),
    [sym_await_expression] = STATE(1158),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(1158),
    [sym_ternary_expression] = STATE(1158),
    [sym_binary_expression] = STATE(1158),
    [sym_unary_expression] = STATE(1158),
    [sym_update_expression] = STATE(1158),
    [sym_string] = STATE(1158),
    [sym_template_string] = STATE(1158),
    [sym_regex] = STATE(1158),
    [sym_meta_property] = STATE(1158),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1158),
    [sym_type_assertion] = STATE(1158),
    [sym_as_expression] = STATE(1158),
    [sym_internal_module] = STATE(1158),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [283] = {
    [sym_import] = STATE(1104),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1104),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1104),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1104),
    [sym_arrow_function] = STATE(1104),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1104),
    [sym_new_expression] = STATE(1104),
    [sym_await_expression] = STATE(1104),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1104),
    [sym_augmented_assignment_expression] = STATE(1104),
    [sym_ternary_expression] = STATE(1104),
    [sym_binary_expression] = STATE(1104),
    [sym_unary_expression] = STATE(1104),
    [sym_update_expression] = STATE(1104),
    [sym_string] = STATE(1104),
    [sym_template_string] = STATE(1104),
    [sym_regex] = STATE(1104),
    [sym_meta_property] = STATE(1104),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1104),
    [sym_type_assertion] = STATE(1104),
    [sym_as_expression] = STATE(1104),
    [sym_internal_module] = STATE(1104),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1925),
    [sym_this] = ACTIONS(1927),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [sym_null] = ACTIONS(1927),
    [sym_undefined] = ACTIONS(1927),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [284] = {
    [sym_import] = STATE(1119),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1119),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_ternary_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_update_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_template_string] = STATE(1119),
    [sym_regex] = STATE(1119),
    [sym_meta_property] = STATE(1119),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1119),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1929),
    [sym_this] = ACTIONS(1931),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1931),
    [sym_false] = ACTIONS(1931),
    [sym_null] = ACTIONS(1931),
    [sym_undefined] = ACTIONS(1931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [285] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1252),
    [sym_type_assertion] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1933),
    [sym_this] = ACTIONS(1935),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1935),
    [sym_false] = ACTIONS(1935),
    [sym_null] = ACTIONS(1935),
    [sym_undefined] = ACTIONS(1935),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [286] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(976),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(976),
    [sym_type_assertion] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1937),
    [sym_this] = ACTIONS(1939),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1939),
    [sym_false] = ACTIONS(1939),
    [sym_null] = ACTIONS(1939),
    [sym_undefined] = ACTIONS(1939),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [287] = {
    [sym_import] = STATE(1257),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1257),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1257),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1257),
    [sym_arrow_function] = STATE(1257),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1257),
    [sym_new_expression] = STATE(1257),
    [sym_await_expression] = STATE(1257),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1257),
    [sym_augmented_assignment_expression] = STATE(1257),
    [sym_ternary_expression] = STATE(1257),
    [sym_binary_expression] = STATE(1257),
    [sym_unary_expression] = STATE(1257),
    [sym_update_expression] = STATE(1257),
    [sym_string] = STATE(1257),
    [sym_template_string] = STATE(1257),
    [sym_regex] = STATE(1257),
    [sym_meta_property] = STATE(1257),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1257),
    [sym_type_assertion] = STATE(1257),
    [sym_as_expression] = STATE(1257),
    [sym_internal_module] = STATE(1257),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1941),
    [sym_this] = ACTIONS(1943),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1943),
    [sym_false] = ACTIONS(1943),
    [sym_null] = ACTIONS(1943),
    [sym_undefined] = ACTIONS(1943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [288] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(978),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [289] = {
    [sym_import] = STATE(1161),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1161),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1161),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1161),
    [sym_arrow_function] = STATE(1161),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1161),
    [sym_new_expression] = STATE(1161),
    [sym_await_expression] = STATE(1161),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1161),
    [sym_augmented_assignment_expression] = STATE(1161),
    [sym_ternary_expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_unary_expression] = STATE(1161),
    [sym_update_expression] = STATE(1161),
    [sym_string] = STATE(1161),
    [sym_template_string] = STATE(1161),
    [sym_regex] = STATE(1161),
    [sym_meta_property] = STATE(1161),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1161),
    [sym_type_assertion] = STATE(1161),
    [sym_as_expression] = STATE(1161),
    [sym_internal_module] = STATE(1161),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1947),
    [sym_this] = ACTIONS(1949),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1949),
    [sym_false] = ACTIONS(1949),
    [sym_null] = ACTIONS(1949),
    [sym_undefined] = ACTIONS(1949),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [290] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1220),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(1951),
    [sym_this] = ACTIONS(1953),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [sym_null] = ACTIONS(1953),
    [sym_undefined] = ACTIONS(1953),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [291] = {
    [sym_import] = STATE(1162),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1162),
    [sym_yield_expression] = STATE(1162),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1162),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1162),
    [sym_arrow_function] = STATE(1162),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1162),
    [sym_new_expression] = STATE(1162),
    [sym_await_expression] = STATE(1162),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1162),
    [sym_augmented_assignment_expression] = STATE(1162),
    [sym_ternary_expression] = STATE(1162),
    [sym_binary_expression] = STATE(1162),
    [sym_unary_expression] = STATE(1162),
    [sym_update_expression] = STATE(1162),
    [sym_string] = STATE(1162),
    [sym_template_string] = STATE(1162),
    [sym_regex] = STATE(1162),
    [sym_meta_property] = STATE(1162),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1162),
    [sym_type_assertion] = STATE(1162),
    [sym_as_expression] = STATE(1162),
    [sym_internal_module] = STATE(1162),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1955),
    [sym_this] = ACTIONS(1957),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [sym_null] = ACTIONS(1957),
    [sym_undefined] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [292] = {
    [sym_import] = STATE(1487),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1487),
    [sym_yield_expression] = STATE(1487),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1487),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1487),
    [sym_arrow_function] = STATE(1487),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1487),
    [sym_new_expression] = STATE(1487),
    [sym_await_expression] = STATE(1487),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1487),
    [sym_augmented_assignment_expression] = STATE(1487),
    [sym_ternary_expression] = STATE(1487),
    [sym_binary_expression] = STATE(1487),
    [sym_unary_expression] = STATE(1487),
    [sym_update_expression] = STATE(1487),
    [sym_string] = STATE(1487),
    [sym_template_string] = STATE(1487),
    [sym_regex] = STATE(1487),
    [sym_meta_property] = STATE(1487),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(1487),
    [sym_as_expression] = STATE(1487),
    [sym_internal_module] = STATE(1487),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [293] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(719),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [294] = {
    [sym_import] = STATE(1338),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1959),
    [sym_this] = ACTIONS(1961),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [sym_null] = ACTIONS(1961),
    [sym_undefined] = ACTIONS(1961),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [295] = {
    [sym_import] = STATE(1341),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1341),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1341),
    [sym_arrow_function] = STATE(1341),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1341),
    [sym_new_expression] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_string] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1341),
    [sym_type_assertion] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1963),
    [sym_this] = ACTIONS(1965),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1965),
    [sym_false] = ACTIONS(1965),
    [sym_null] = ACTIONS(1965),
    [sym_undefined] = ACTIONS(1965),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [296] = {
    [sym_import] = STATE(1343),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1343),
    [sym_type_assertion] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1967),
    [sym_this] = ACTIONS(1969),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1969),
    [sym_false] = ACTIONS(1969),
    [sym_null] = ACTIONS(1969),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [297] = {
    [sym_import] = STATE(1170),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1170),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1170),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1170),
    [sym_arrow_function] = STATE(1170),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1170),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1170),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1170),
    [sym_template_string] = STATE(1170),
    [sym_regex] = STATE(1170),
    [sym_meta_property] = STATE(1170),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1170),
    [sym_type_assertion] = STATE(1170),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1971),
    [sym_this] = ACTIONS(1973),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1973),
    [sym_false] = ACTIONS(1973),
    [sym_null] = ACTIONS(1973),
    [sym_undefined] = ACTIONS(1973),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [298] = {
    [sym_import] = STATE(985),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(985),
    [sym_yield_expression] = STATE(985),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(985),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(985),
    [sym_arrow_function] = STATE(985),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(985),
    [sym_new_expression] = STATE(985),
    [sym_await_expression] = STATE(985),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(985),
    [sym_augmented_assignment_expression] = STATE(985),
    [sym_ternary_expression] = STATE(985),
    [sym_binary_expression] = STATE(985),
    [sym_unary_expression] = STATE(985),
    [sym_update_expression] = STATE(985),
    [sym_string] = STATE(985),
    [sym_template_string] = STATE(985),
    [sym_regex] = STATE(985),
    [sym_meta_property] = STATE(985),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(985),
    [sym_type_assertion] = STATE(985),
    [sym_as_expression] = STATE(985),
    [sym_internal_module] = STATE(985),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1975),
    [sym_this] = ACTIONS(1977),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [299] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1344),
    [sym_type_assertion] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1979),
    [sym_this] = ACTIONS(1981),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1981),
    [sym_false] = ACTIONS(1981),
    [sym_null] = ACTIONS(1981),
    [sym_undefined] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [300] = {
    [sym_import] = STATE(1345),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1345),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1345),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1345),
    [sym_arrow_function] = STATE(1345),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1345),
    [sym_new_expression] = STATE(1345),
    [sym_await_expression] = STATE(1345),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1345),
    [sym_augmented_assignment_expression] = STATE(1345),
    [sym_ternary_expression] = STATE(1345),
    [sym_binary_expression] = STATE(1345),
    [sym_unary_expression] = STATE(1345),
    [sym_update_expression] = STATE(1345),
    [sym_string] = STATE(1345),
    [sym_template_string] = STATE(1345),
    [sym_regex] = STATE(1345),
    [sym_meta_property] = STATE(1345),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(1345),
    [sym_as_expression] = STATE(1345),
    [sym_internal_module] = STATE(1345),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1983),
    [sym_this] = ACTIONS(1985),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1985),
    [sym_false] = ACTIONS(1985),
    [sym_null] = ACTIONS(1985),
    [sym_undefined] = ACTIONS(1985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [301] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1348),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_ternary_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_update_expression] = STATE(1348),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_internal_module] = STATE(1348),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1987),
    [sym_this] = ACTIONS(1989),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1989),
    [sym_false] = ACTIONS(1989),
    [sym_null] = ACTIONS(1989),
    [sym_undefined] = ACTIONS(1989),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [302] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1991),
    [sym_this] = ACTIONS(1993),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1993),
    [sym_false] = ACTIONS(1993),
    [sym_null] = ACTIONS(1993),
    [sym_undefined] = ACTIONS(1993),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [303] = {
    [sym_import] = STATE(1433),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1433),
    [sym_yield_expression] = STATE(1433),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1433),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1433),
    [sym_arrow_function] = STATE(1433),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1433),
    [sym_new_expression] = STATE(1433),
    [sym_await_expression] = STATE(1433),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1433),
    [sym_augmented_assignment_expression] = STATE(1433),
    [sym_ternary_expression] = STATE(1433),
    [sym_binary_expression] = STATE(1433),
    [sym_unary_expression] = STATE(1433),
    [sym_update_expression] = STATE(1433),
    [sym_string] = STATE(1433),
    [sym_template_string] = STATE(1433),
    [sym_regex] = STATE(1433),
    [sym_meta_property] = STATE(1433),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(1433),
    [sym_as_expression] = STATE(1433),
    [sym_internal_module] = STATE(1433),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1995),
    [sym_this] = ACTIONS(1997),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [sym_null] = ACTIONS(1997),
    [sym_undefined] = ACTIONS(1997),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [304] = {
    [sym_import] = STATE(1354),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1999),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_null] = ACTIONS(890),
    [sym_undefined] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [305] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2003),
    [sym_false] = ACTIONS(2003),
    [sym_null] = ACTIONS(2003),
    [sym_undefined] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [306] = {
    [sym_import] = STATE(1173),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1173),
    [sym_yield_expression] = STATE(1173),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1173),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1173),
    [sym_arrow_function] = STATE(1173),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1173),
    [sym_new_expression] = STATE(1173),
    [sym_await_expression] = STATE(1173),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1173),
    [sym_augmented_assignment_expression] = STATE(1173),
    [sym_ternary_expression] = STATE(1173),
    [sym_binary_expression] = STATE(1173),
    [sym_unary_expression] = STATE(1173),
    [sym_update_expression] = STATE(1173),
    [sym_string] = STATE(1173),
    [sym_template_string] = STATE(1173),
    [sym_regex] = STATE(1173),
    [sym_meta_property] = STATE(1173),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1173),
    [sym_type_assertion] = STATE(1173),
    [sym_as_expression] = STATE(1173),
    [sym_internal_module] = STATE(1173),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2005),
    [sym_this] = ACTIONS(2007),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2007),
    [sym_false] = ACTIONS(2007),
    [sym_null] = ACTIONS(2007),
    [sym_undefined] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [307] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(978),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2009),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [308] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(978),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2011),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [309] = {
    [sym_import] = STATE(1079),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1079),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1079),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1079),
    [sym_arrow_function] = STATE(1079),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1079),
    [sym_new_expression] = STATE(1079),
    [sym_await_expression] = STATE(1079),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1079),
    [sym_augmented_assignment_expression] = STATE(1079),
    [sym_ternary_expression] = STATE(1079),
    [sym_binary_expression] = STATE(1079),
    [sym_unary_expression] = STATE(1079),
    [sym_update_expression] = STATE(1079),
    [sym_string] = STATE(1079),
    [sym_template_string] = STATE(1079),
    [sym_regex] = STATE(1079),
    [sym_meta_property] = STATE(1079),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1079),
    [sym_type_assertion] = STATE(1079),
    [sym_as_expression] = STATE(1079),
    [sym_internal_module] = STATE(1079),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2013),
    [sym_this] = ACTIONS(2015),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2015),
    [sym_false] = ACTIONS(2015),
    [sym_null] = ACTIONS(2015),
    [sym_undefined] = ACTIONS(2015),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [310] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1464),
    [sym_yield_expression] = STATE(1464),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1464),
    [sym_await_expression] = STATE(1464),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1464),
    [sym_augmented_assignment_expression] = STATE(1464),
    [sym_ternary_expression] = STATE(1464),
    [sym_binary_expression] = STATE(1464),
    [sym_unary_expression] = STATE(1464),
    [sym_update_expression] = STATE(1464),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(1464),
    [sym_as_expression] = STATE(1464),
    [sym_internal_module] = STATE(1464),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2017),
    [sym_this] = ACTIONS(2019),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2019),
    [sym_false] = ACTIONS(2019),
    [sym_null] = ACTIONS(2019),
    [sym_undefined] = ACTIONS(2019),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [311] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1372),
    [sym_type_assertion] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2021),
    [sym_this] = ACTIONS(2023),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2023),
    [sym_false] = ACTIONS(2023),
    [sym_null] = ACTIONS(2023),
    [sym_undefined] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [312] = {
    [sym_import] = STATE(1236),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1236),
    [sym_type_assertion] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2025),
    [sym_this] = ACTIONS(2027),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [sym_null] = ACTIONS(2027),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [313] = {
    [sym_import] = STATE(1044),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1044),
    [sym_yield_expression] = STATE(1044),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1044),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1044),
    [sym_arrow_function] = STATE(1044),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1044),
    [sym_new_expression] = STATE(1044),
    [sym_await_expression] = STATE(1044),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1044),
    [sym_augmented_assignment_expression] = STATE(1044),
    [sym_ternary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_update_expression] = STATE(1044),
    [sym_string] = STATE(1044),
    [sym_template_string] = STATE(1044),
    [sym_regex] = STATE(1044),
    [sym_meta_property] = STATE(1044),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1044),
    [sym_type_assertion] = STATE(1044),
    [sym_as_expression] = STATE(1044),
    [sym_internal_module] = STATE(1044),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [314] = {
    [sym_import] = STATE(1455),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1455),
    [sym_yield_expression] = STATE(1455),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1455),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1455),
    [sym_arrow_function] = STATE(1455),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1455),
    [sym_new_expression] = STATE(1455),
    [sym_await_expression] = STATE(1455),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1455),
    [sym_augmented_assignment_expression] = STATE(1455),
    [sym_ternary_expression] = STATE(1455),
    [sym_binary_expression] = STATE(1455),
    [sym_unary_expression] = STATE(1455),
    [sym_update_expression] = STATE(1455),
    [sym_string] = STATE(1455),
    [sym_template_string] = STATE(1455),
    [sym_regex] = STATE(1455),
    [sym_meta_property] = STATE(1455),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1455),
    [sym_type_assertion] = STATE(1455),
    [sym_as_expression] = STATE(1455),
    [sym_internal_module] = STATE(1455),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2033),
    [sym_this] = ACTIONS(2035),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2035),
    [sym_false] = ACTIONS(2035),
    [sym_null] = ACTIONS(2035),
    [sym_undefined] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [315] = {
    [sym_import] = STATE(1079),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1079),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1079),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1079),
    [sym_arrow_function] = STATE(1079),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1079),
    [sym_new_expression] = STATE(1079),
    [sym_await_expression] = STATE(1079),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1079),
    [sym_augmented_assignment_expression] = STATE(1079),
    [sym_ternary_expression] = STATE(1079),
    [sym_binary_expression] = STATE(1079),
    [sym_unary_expression] = STATE(1079),
    [sym_update_expression] = STATE(1079),
    [sym_string] = STATE(1079),
    [sym_template_string] = STATE(1079),
    [sym_regex] = STATE(1079),
    [sym_meta_property] = STATE(1079),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1079),
    [sym_type_assertion] = STATE(1079),
    [sym_as_expression] = STATE(1079),
    [sym_internal_module] = STATE(1079),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2013),
    [sym_this] = ACTIONS(2015),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2015),
    [sym_false] = ACTIONS(2015),
    [sym_null] = ACTIONS(2015),
    [sym_undefined] = ACTIONS(2015),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [316] = {
    [sym_import] = STATE(1172),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1172),
    [sym_yield_expression] = STATE(1172),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1172),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1172),
    [sym_arrow_function] = STATE(1172),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1172),
    [sym_new_expression] = STATE(1172),
    [sym_await_expression] = STATE(1172),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1172),
    [sym_augmented_assignment_expression] = STATE(1172),
    [sym_ternary_expression] = STATE(1172),
    [sym_binary_expression] = STATE(1172),
    [sym_unary_expression] = STATE(1172),
    [sym_update_expression] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_template_string] = STATE(1172),
    [sym_regex] = STATE(1172),
    [sym_meta_property] = STATE(1172),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1172),
    [sym_type_assertion] = STATE(1172),
    [sym_as_expression] = STATE(1172),
    [sym_internal_module] = STATE(1172),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2039),
    [sym_this] = ACTIONS(2041),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2041),
    [sym_false] = ACTIONS(2041),
    [sym_null] = ACTIONS(2041),
    [sym_undefined] = ACTIONS(2041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [317] = {
    [sym_import] = STATE(1199),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1199),
    [sym_type_assertion] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1817),
    [sym_this] = ACTIONS(1839),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1839),
    [sym_false] = ACTIONS(1839),
    [sym_null] = ACTIONS(1839),
    [sym_undefined] = ACTIONS(1839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [318] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1249),
    [sym_type_assertion] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2043),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [319] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1139),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2049),
    [sym_this] = ACTIONS(2051),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [sym_undefined] = ACTIONS(2051),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [320] = {
    [sym_import] = STATE(1030),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1030),
    [sym_yield_expression] = STATE(1030),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1030),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1030),
    [sym_arrow_function] = STATE(1030),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1030),
    [sym_new_expression] = STATE(1030),
    [sym_await_expression] = STATE(1030),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1030),
    [sym_augmented_assignment_expression] = STATE(1030),
    [sym_ternary_expression] = STATE(1030),
    [sym_binary_expression] = STATE(1030),
    [sym_unary_expression] = STATE(1030),
    [sym_update_expression] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_template_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [sym_meta_property] = STATE(1030),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1030),
    [sym_type_assertion] = STATE(1030),
    [sym_as_expression] = STATE(1030),
    [sym_internal_module] = STATE(1030),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2053),
    [sym_this] = ACTIONS(2055),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [sym_undefined] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [321] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(966),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2057),
    [sym_this] = ACTIONS(2059),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [sym_undefined] = ACTIONS(2059),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [322] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_string] = STATE(1043),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2061),
    [sym_this] = ACTIONS(2063),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [sym_undefined] = ACTIONS(2063),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [323] = {
    [sym_import] = STATE(1502),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1502),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1502),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1502),
    [sym_arrow_function] = STATE(1502),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1502),
    [sym_new_expression] = STATE(1502),
    [sym_await_expression] = STATE(1502),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1502),
    [sym_augmented_assignment_expression] = STATE(1502),
    [sym_ternary_expression] = STATE(1502),
    [sym_binary_expression] = STATE(1502),
    [sym_unary_expression] = STATE(1502),
    [sym_update_expression] = STATE(1502),
    [sym_string] = STATE(1502),
    [sym_template_string] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_meta_property] = STATE(1502),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1502),
    [sym_type_assertion] = STATE(1502),
    [sym_as_expression] = STATE(1502),
    [sym_internal_module] = STATE(1502),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2065),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [324] = {
    [sym_import] = STATE(1052),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1052),
    [sym_yield_expression] = STATE(1052),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1052),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1052),
    [sym_arrow_function] = STATE(1052),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1052),
    [sym_new_expression] = STATE(1052),
    [sym_await_expression] = STATE(1052),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1052),
    [sym_augmented_assignment_expression] = STATE(1052),
    [sym_ternary_expression] = STATE(1052),
    [sym_binary_expression] = STATE(1052),
    [sym_unary_expression] = STATE(1052),
    [sym_update_expression] = STATE(1052),
    [sym_string] = STATE(1052),
    [sym_template_string] = STATE(1052),
    [sym_regex] = STATE(1052),
    [sym_meta_property] = STATE(1052),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1052),
    [sym_as_expression] = STATE(1052),
    [sym_internal_module] = STATE(1052),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2069),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [325] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1139),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2049),
    [sym_this] = ACTIONS(2051),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [sym_undefined] = ACTIONS(2051),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [326] = {
    [sym_import] = STATE(1361),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1361),
    [sym_arrow_function] = STATE(1361),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1361),
    [sym_type_assertion] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2073),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_undefined] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [327] = {
    [sym_import] = STATE(1247),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1247),
    [sym_type_assertion] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2077),
    [sym_this] = ACTIONS(2079),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_undefined] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [328] = {
    [sym_import] = STATE(1246),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1246),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1246),
    [sym_arrow_function] = STATE(1246),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1246),
    [sym_new_expression] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_string] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1246),
    [sym_type_assertion] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2081),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [329] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [330] = {
    [sym_import] = STATE(1156),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1156),
    [sym_yield_expression] = STATE(1156),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1156),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1156),
    [sym_arrow_function] = STATE(1156),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1156),
    [sym_new_expression] = STATE(1156),
    [sym_await_expression] = STATE(1156),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1156),
    [sym_augmented_assignment_expression] = STATE(1156),
    [sym_ternary_expression] = STATE(1156),
    [sym_binary_expression] = STATE(1156),
    [sym_unary_expression] = STATE(1156),
    [sym_update_expression] = STATE(1156),
    [sym_string] = STATE(1156),
    [sym_template_string] = STATE(1156),
    [sym_regex] = STATE(1156),
    [sym_meta_property] = STATE(1156),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1156),
    [sym_type_assertion] = STATE(1156),
    [sym_as_expression] = STATE(1156),
    [sym_internal_module] = STATE(1156),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2089),
    [sym_this] = ACTIONS(2091),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2091),
    [sym_false] = ACTIONS(2091),
    [sym_null] = ACTIONS(2091),
    [sym_undefined] = ACTIONS(2091),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [331] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1267),
    [sym_type_assertion] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2093),
    [sym_this] = ACTIONS(2095),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [332] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1215),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_await_expression] = STATE(1215),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(1215),
    [sym_ternary_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_update_expression] = STATE(1215),
    [sym_string] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1215),
    [sym_type_assertion] = STATE(1215),
    [sym_as_expression] = STATE(1215),
    [sym_internal_module] = STATE(1215),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2097),
    [sym_this] = ACTIONS(2099),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_undefined] = ACTIONS(2099),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [333] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1355),
    [sym_type_assertion] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2101),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [334] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1358),
    [sym_type_assertion] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2105),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [335] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(988),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [336] = {
    [sym_import] = STATE(987),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(987),
    [sym_yield_expression] = STATE(987),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(987),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(987),
    [sym_arrow_function] = STATE(987),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(987),
    [sym_new_expression] = STATE(987),
    [sym_await_expression] = STATE(987),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(987),
    [sym_augmented_assignment_expression] = STATE(987),
    [sym_ternary_expression] = STATE(987),
    [sym_binary_expression] = STATE(987),
    [sym_unary_expression] = STATE(987),
    [sym_update_expression] = STATE(987),
    [sym_string] = STATE(987),
    [sym_template_string] = STATE(987),
    [sym_regex] = STATE(987),
    [sym_meta_property] = STATE(987),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(987),
    [sym_type_assertion] = STATE(987),
    [sym_as_expression] = STATE(987),
    [sym_internal_module] = STATE(987),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2109),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [337] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2113),
    [sym_this] = ACTIONS(2115),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [sym_undefined] = ACTIONS(2115),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [338] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2117),
    [sym_this] = ACTIONS(2119),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2119),
    [sym_false] = ACTIONS(2119),
    [sym_null] = ACTIONS(2119),
    [sym_undefined] = ACTIONS(2119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [339] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1182),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1182),
    [sym_type_assertion] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2121),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_null] = ACTIONS(912),
    [sym_undefined] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [340] = {
    [sym__declaration] = STATE(536),
    [sym_variable_declaration] = STATE(536),
    [sym_lexical_declaration] = STATE(536),
    [sym_class_declaration] = STATE(536),
    [sym_function_declaration] = STATE(536),
    [sym_generator_function_declaration] = STATE(536),
    [sym_decorator] = STATE(1810),
    [sym_function_signature] = STATE(536),
    [sym_ambient_declaration] = STATE(536),
    [sym_abstract_class_declaration] = STATE(536),
    [sym_module] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_import_alias] = STATE(536),
    [sym_interface_declaration] = STATE(536),
    [sym_enum_declaration] = STATE(536),
    [sym_type_alias_declaration] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(2319),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1377),
    [anon_sym_declare] = ACTIONS(1447),
    [anon_sym_module] = ACTIONS(2123),
    [anon_sym_global] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1385),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [341] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1183),
    [sym_type_assertion] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2125),
    [sym_this] = ACTIONS(2127),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [sym_null] = ACTIONS(2127),
    [sym_undefined] = ACTIONS(2127),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [342] = {
    [sym_import] = STATE(1118),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1118),
    [sym_yield_expression] = STATE(1118),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1118),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1118),
    [sym_arrow_function] = STATE(1118),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1118),
    [sym_new_expression] = STATE(1118),
    [sym_await_expression] = STATE(1118),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1118),
    [sym_augmented_assignment_expression] = STATE(1118),
    [sym_ternary_expression] = STATE(1118),
    [sym_binary_expression] = STATE(1118),
    [sym_unary_expression] = STATE(1118),
    [sym_update_expression] = STATE(1118),
    [sym_string] = STATE(1118),
    [sym_template_string] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_meta_property] = STATE(1118),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1118),
    [sym_type_assertion] = STATE(1118),
    [sym_as_expression] = STATE(1118),
    [sym_internal_module] = STATE(1118),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2129),
    [sym_this] = ACTIONS(2131),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_undefined] = ACTIONS(2131),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [343] = {
    [sym_import] = STATE(960),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(960),
    [sym_yield_expression] = STATE(960),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(960),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(960),
    [sym_arrow_function] = STATE(960),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(960),
    [sym_new_expression] = STATE(960),
    [sym_await_expression] = STATE(960),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(960),
    [sym_augmented_assignment_expression] = STATE(960),
    [sym_ternary_expression] = STATE(960),
    [sym_binary_expression] = STATE(960),
    [sym_unary_expression] = STATE(960),
    [sym_update_expression] = STATE(960),
    [sym_string] = STATE(960),
    [sym_template_string] = STATE(960),
    [sym_regex] = STATE(960),
    [sym_meta_property] = STATE(960),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(960),
    [sym_type_assertion] = STATE(960),
    [sym_as_expression] = STATE(960),
    [sym_internal_module] = STATE(960),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2133),
    [sym_this] = ACTIONS(2135),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2135),
    [sym_false] = ACTIONS(2135),
    [sym_null] = ACTIONS(2135),
    [sym_undefined] = ACTIONS(2135),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [344] = {
    [sym_import] = STATE(952),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(952),
    [sym_yield_expression] = STATE(952),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(952),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(952),
    [sym_arrow_function] = STATE(952),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(952),
    [sym_new_expression] = STATE(952),
    [sym_await_expression] = STATE(952),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(952),
    [sym_augmented_assignment_expression] = STATE(952),
    [sym_ternary_expression] = STATE(952),
    [sym_binary_expression] = STATE(952),
    [sym_unary_expression] = STATE(952),
    [sym_update_expression] = STATE(952),
    [sym_string] = STATE(952),
    [sym_template_string] = STATE(952),
    [sym_regex] = STATE(952),
    [sym_meta_property] = STATE(952),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(952),
    [sym_as_expression] = STATE(952),
    [sym_internal_module] = STATE(952),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2137),
    [sym_this] = ACTIONS(2139),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [sym_undefined] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [345] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1215),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_await_expression] = STATE(1215),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(1215),
    [sym_ternary_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_update_expression] = STATE(1215),
    [sym_string] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1215),
    [sym_type_assertion] = STATE(1215),
    [sym_as_expression] = STATE(1215),
    [sym_internal_module] = STATE(1215),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2141),
    [sym_this] = ACTIONS(2099),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_undefined] = ACTIONS(2099),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [346] = {
    [sym_import] = STATE(1129),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1129),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1129),
    [sym_arrow_function] = STATE(1129),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1129),
    [sym_new_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_string] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_meta_property] = STATE(1129),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1129),
    [sym_type_assertion] = STATE(1129),
    [sym_as_expression] = STATE(1129),
    [sym_internal_module] = STATE(1129),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2143),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [347] = {
    [sym_import] = STATE(1184),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1184),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1184),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1184),
    [sym_arrow_function] = STATE(1184),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1184),
    [sym_new_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1184),
    [sym_augmented_assignment_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_update_expression] = STATE(1184),
    [sym_string] = STATE(1184),
    [sym_template_string] = STATE(1184),
    [sym_regex] = STATE(1184),
    [sym_meta_property] = STATE(1184),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1184),
    [sym_type_assertion] = STATE(1184),
    [sym_as_expression] = STATE(1184),
    [sym_internal_module] = STATE(1184),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2147),
    [sym_this] = ACTIONS(2149),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2149),
    [sym_false] = ACTIONS(2149),
    [sym_null] = ACTIONS(2149),
    [sym_undefined] = ACTIONS(2149),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [348] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(757),
    [sym_this] = ACTIONS(759),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(759),
    [sym_false] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [sym_undefined] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [349] = {
    [sym_import] = STATE(1127),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1127),
    [sym_arrow_function] = STATE(1127),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2151),
    [sym_this] = ACTIONS(2153),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2153),
    [sym_false] = ACTIONS(2153),
    [sym_null] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [350] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1315),
    [sym_type_assertion] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2155),
    [sym_this] = ACTIONS(998),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [351] = {
    [sym_import] = STATE(1266),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1266),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1266),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1266),
    [sym_arrow_function] = STATE(1266),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1266),
    [sym_new_expression] = STATE(1266),
    [sym_await_expression] = STATE(1266),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1266),
    [sym_augmented_assignment_expression] = STATE(1266),
    [sym_ternary_expression] = STATE(1266),
    [sym_binary_expression] = STATE(1266),
    [sym_unary_expression] = STATE(1266),
    [sym_update_expression] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_template_string] = STATE(1266),
    [sym_regex] = STATE(1266),
    [sym_meta_property] = STATE(1266),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1266),
    [sym_type_assertion] = STATE(1266),
    [sym_as_expression] = STATE(1266),
    [sym_internal_module] = STATE(1266),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2157),
    [sym_this] = ACTIONS(2159),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_undefined] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [352] = {
    [sym_import] = STATE(1270),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1270),
    [sym_type_assertion] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2161),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [353] = {
    [sym_import] = STATE(1268),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1268),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1268),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1268),
    [sym_arrow_function] = STATE(1268),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1268),
    [sym_new_expression] = STATE(1268),
    [sym_await_expression] = STATE(1268),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1268),
    [sym_augmented_assignment_expression] = STATE(1268),
    [sym_ternary_expression] = STATE(1268),
    [sym_binary_expression] = STATE(1268),
    [sym_unary_expression] = STATE(1268),
    [sym_update_expression] = STATE(1268),
    [sym_string] = STATE(1268),
    [sym_template_string] = STATE(1268),
    [sym_regex] = STATE(1268),
    [sym_meta_property] = STATE(1268),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1268),
    [sym_type_assertion] = STATE(1268),
    [sym_as_expression] = STATE(1268),
    [sym_internal_module] = STATE(1268),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2165),
    [sym_this] = ACTIONS(932),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(932),
    [sym_false] = ACTIONS(932),
    [sym_null] = ACTIONS(932),
    [sym_undefined] = ACTIONS(932),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [354] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1212),
    [sym_yield_expression] = STATE(1212),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1212),
    [sym_await_expression] = STATE(1212),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1212),
    [sym_augmented_assignment_expression] = STATE(1212),
    [sym_ternary_expression] = STATE(1212),
    [sym_binary_expression] = STATE(1212),
    [sym_unary_expression] = STATE(1212),
    [sym_update_expression] = STATE(1212),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1212),
    [sym_type_assertion] = STATE(1212),
    [sym_as_expression] = STATE(1212),
    [sym_internal_module] = STATE(1212),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2167),
    [sym_this] = ACTIONS(2169),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2169),
    [sym_false] = ACTIONS(2169),
    [sym_null] = ACTIONS(2169),
    [sym_undefined] = ACTIONS(2169),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [355] = {
    [sym_import] = STATE(1210),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1210),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1210),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1210),
    [sym_arrow_function] = STATE(1210),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1210),
    [sym_new_expression] = STATE(1210),
    [sym_await_expression] = STATE(1210),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1210),
    [sym_augmented_assignment_expression] = STATE(1210),
    [sym_ternary_expression] = STATE(1210),
    [sym_binary_expression] = STATE(1210),
    [sym_unary_expression] = STATE(1210),
    [sym_update_expression] = STATE(1210),
    [sym_string] = STATE(1210),
    [sym_template_string] = STATE(1210),
    [sym_regex] = STATE(1210),
    [sym_meta_property] = STATE(1210),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1210),
    [sym_type_assertion] = STATE(1210),
    [sym_as_expression] = STATE(1210),
    [sym_internal_module] = STATE(1210),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2171),
    [sym_this] = ACTIONS(2173),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2173),
    [sym_false] = ACTIONS(2173),
    [sym_null] = ACTIONS(2173),
    [sym_undefined] = ACTIONS(2173),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [356] = {
    [sym_import] = STATE(1253),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1253),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1253),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1253),
    [sym_arrow_function] = STATE(1253),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1253),
    [sym_new_expression] = STATE(1253),
    [sym_await_expression] = STATE(1253),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1253),
    [sym_augmented_assignment_expression] = STATE(1253),
    [sym_ternary_expression] = STATE(1253),
    [sym_binary_expression] = STATE(1253),
    [sym_unary_expression] = STATE(1253),
    [sym_update_expression] = STATE(1253),
    [sym_string] = STATE(1253),
    [sym_template_string] = STATE(1253),
    [sym_regex] = STATE(1253),
    [sym_meta_property] = STATE(1253),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1253),
    [sym_type_assertion] = STATE(1253),
    [sym_as_expression] = STATE(1253),
    [sym_internal_module] = STATE(1253),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [357] = {
    [sym_import] = STATE(1188),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1188),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1188),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1188),
    [sym_arrow_function] = STATE(1188),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1188),
    [sym_augmented_assignment_expression] = STATE(1188),
    [sym_ternary_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_update_expression] = STATE(1188),
    [sym_string] = STATE(1188),
    [sym_template_string] = STATE(1188),
    [sym_regex] = STATE(1188),
    [sym_meta_property] = STATE(1188),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1188),
    [sym_type_assertion] = STATE(1188),
    [sym_as_expression] = STATE(1188),
    [sym_internal_module] = STATE(1188),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2177),
    [sym_this] = ACTIONS(2179),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_null] = ACTIONS(2179),
    [sym_undefined] = ACTIONS(2179),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [358] = {
    [sym_import] = STATE(1214),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1214),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(1214),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1214),
    [sym_arrow_function] = STATE(1214),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(1214),
    [sym_new_expression] = STATE(1214),
    [sym_await_expression] = STATE(1214),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(1214),
    [sym_augmented_assignment_expression] = STATE(1214),
    [sym_ternary_expression] = STATE(1214),
    [sym_binary_expression] = STATE(1214),
    [sym_unary_expression] = STATE(1214),
    [sym_update_expression] = STATE(1214),
    [sym_string] = STATE(1214),
    [sym_template_string] = STATE(1214),
    [sym_regex] = STATE(1214),
    [sym_meta_property] = STATE(1214),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1214),
    [sym_type_assertion] = STATE(1214),
    [sym_as_expression] = STATE(1214),
    [sym_internal_module] = STATE(1214),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2181),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [359] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1291),
    [sym_type_assertion] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2185),
    [sym_this] = ACTIONS(2187),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_null] = ACTIONS(2187),
    [sym_undefined] = ACTIONS(2187),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [360] = {
    [sym_import] = STATE(1202),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1202),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1202),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1202),
    [sym_arrow_function] = STATE(1202),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1202),
    [sym_new_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1202),
    [sym_augmented_assignment_expression] = STATE(1202),
    [sym_ternary_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_update_expression] = STATE(1202),
    [sym_string] = STATE(1202),
    [sym_template_string] = STATE(1202),
    [sym_regex] = STATE(1202),
    [sym_meta_property] = STATE(1202),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1202),
    [sym_type_assertion] = STATE(1202),
    [sym_as_expression] = STATE(1202),
    [sym_internal_module] = STATE(1202),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2189),
    [sym_this] = ACTIONS(2191),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [sym_null] = ACTIONS(2191),
    [sym_undefined] = ACTIONS(2191),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [361] = {
    [sym_import] = STATE(1421),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1421),
    [sym_yield_expression] = STATE(1421),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1421),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1421),
    [sym_arrow_function] = STATE(1421),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1421),
    [sym_new_expression] = STATE(1421),
    [sym_await_expression] = STATE(1421),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1421),
    [sym_augmented_assignment_expression] = STATE(1421),
    [sym_ternary_expression] = STATE(1421),
    [sym_binary_expression] = STATE(1421),
    [sym_unary_expression] = STATE(1421),
    [sym_update_expression] = STATE(1421),
    [sym_string] = STATE(1421),
    [sym_template_string] = STATE(1421),
    [sym_regex] = STATE(1421),
    [sym_meta_property] = STATE(1421),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1421),
    [sym_as_expression] = STATE(1421),
    [sym_internal_module] = STATE(1421),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2193),
    [sym_this] = ACTIONS(2195),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [sym_null] = ACTIONS(2195),
    [sym_undefined] = ACTIONS(2195),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [362] = {
    [sym_import] = STATE(1274),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1274),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1274),
    [sym_arrow_function] = STATE(1274),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_string] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_meta_property] = STATE(1274),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1274),
    [sym_type_assertion] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2197),
    [sym_this] = ACTIONS(2199),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [sym_null] = ACTIONS(2199),
    [sym_undefined] = ACTIONS(2199),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [363] = {
    [sym_import] = STATE(1276),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1276),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1276),
    [sym_arrow_function] = STATE(1276),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1276),
    [sym_new_expression] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_string] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_meta_property] = STATE(1276),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1276),
    [sym_type_assertion] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2201),
    [sym_this] = ACTIONS(2203),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [sym_null] = ACTIONS(2203),
    [sym_undefined] = ACTIONS(2203),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [364] = {
    [sym_import] = STATE(1044),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1044),
    [sym_yield_expression] = STATE(1044),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1044),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1044),
    [sym_arrow_function] = STATE(1044),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1044),
    [sym_new_expression] = STATE(1044),
    [sym_await_expression] = STATE(1044),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1044),
    [sym_augmented_assignment_expression] = STATE(1044),
    [sym_ternary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_update_expression] = STATE(1044),
    [sym_string] = STATE(1044),
    [sym_template_string] = STATE(1044),
    [sym_regex] = STATE(1044),
    [sym_meta_property] = STATE(1044),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1044),
    [sym_type_assertion] = STATE(1044),
    [sym_as_expression] = STATE(1044),
    [sym_internal_module] = STATE(1044),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [365] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1248),
    [sym_type_assertion] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2205),
    [sym_this] = ACTIONS(2207),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2207),
    [sym_false] = ACTIONS(2207),
    [sym_null] = ACTIONS(2207),
    [sym_undefined] = ACTIONS(2207),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [366] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2209),
    [sym_this] = ACTIONS(2211),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [sym_null] = ACTIONS(2211),
    [sym_undefined] = ACTIONS(2211),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [367] = {
    [sym_import] = STATE(1152),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1152),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1152),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1152),
    [sym_arrow_function] = STATE(1152),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1152),
    [sym_new_expression] = STATE(1152),
    [sym_await_expression] = STATE(1152),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1152),
    [sym_augmented_assignment_expression] = STATE(1152),
    [sym_ternary_expression] = STATE(1152),
    [sym_binary_expression] = STATE(1152),
    [sym_unary_expression] = STATE(1152),
    [sym_update_expression] = STATE(1152),
    [sym_string] = STATE(1152),
    [sym_template_string] = STATE(1152),
    [sym_regex] = STATE(1152),
    [sym_meta_property] = STATE(1152),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1152),
    [sym_type_assertion] = STATE(1152),
    [sym_as_expression] = STATE(1152),
    [sym_internal_module] = STATE(1152),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2213),
    [sym_this] = ACTIONS(2215),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [sym_null] = ACTIONS(2215),
    [sym_undefined] = ACTIONS(2215),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [368] = {
    [sym_import] = STATE(1196),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1196),
    [sym_yield_expression] = STATE(1196),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1196),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1196),
    [sym_arrow_function] = STATE(1196),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1196),
    [sym_augmented_assignment_expression] = STATE(1196),
    [sym_ternary_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_update_expression] = STATE(1196),
    [sym_string] = STATE(1196),
    [sym_template_string] = STATE(1196),
    [sym_regex] = STATE(1196),
    [sym_meta_property] = STATE(1196),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1196),
    [sym_type_assertion] = STATE(1196),
    [sym_as_expression] = STATE(1196),
    [sym_internal_module] = STATE(1196),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2217),
    [sym_this] = ACTIONS(2219),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2219),
    [sym_false] = ACTIONS(2219),
    [sym_null] = ACTIONS(2219),
    [sym_undefined] = ACTIONS(2219),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [369] = {
    [sym_import] = STATE(1024),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1024),
    [sym_yield_expression] = STATE(1024),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1024),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1024),
    [sym_arrow_function] = STATE(1024),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1024),
    [sym_new_expression] = STATE(1024),
    [sym_await_expression] = STATE(1024),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1024),
    [sym_augmented_assignment_expression] = STATE(1024),
    [sym_ternary_expression] = STATE(1024),
    [sym_binary_expression] = STATE(1024),
    [sym_unary_expression] = STATE(1024),
    [sym_update_expression] = STATE(1024),
    [sym_string] = STATE(1024),
    [sym_template_string] = STATE(1024),
    [sym_regex] = STATE(1024),
    [sym_meta_property] = STATE(1024),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1024),
    [sym_type_assertion] = STATE(1024),
    [sym_as_expression] = STATE(1024),
    [sym_internal_module] = STATE(1024),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1869),
    [sym_this] = ACTIONS(1879),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1879),
    [sym_false] = ACTIONS(1879),
    [sym_null] = ACTIONS(1879),
    [sym_undefined] = ACTIONS(1879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [370] = {
    [sym_import] = STATE(954),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(954),
    [sym_yield_expression] = STATE(954),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(954),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(954),
    [sym_arrow_function] = STATE(954),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(954),
    [sym_new_expression] = STATE(954),
    [sym_await_expression] = STATE(954),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(954),
    [sym_augmented_assignment_expression] = STATE(954),
    [sym_ternary_expression] = STATE(954),
    [sym_binary_expression] = STATE(954),
    [sym_unary_expression] = STATE(954),
    [sym_update_expression] = STATE(954),
    [sym_string] = STATE(954),
    [sym_template_string] = STATE(954),
    [sym_regex] = STATE(954),
    [sym_meta_property] = STATE(954),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(954),
    [sym_type_assertion] = STATE(954),
    [sym_as_expression] = STATE(954),
    [sym_internal_module] = STATE(954),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2221),
    [sym_this] = ACTIONS(2223),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [sym_null] = ACTIONS(2223),
    [sym_undefined] = ACTIONS(2223),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [371] = {
    [sym_import] = STATE(1151),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1151),
    [sym_yield_expression] = STATE(1151),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1151),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1151),
    [sym_arrow_function] = STATE(1151),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1151),
    [sym_new_expression] = STATE(1151),
    [sym_await_expression] = STATE(1151),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1151),
    [sym_augmented_assignment_expression] = STATE(1151),
    [sym_ternary_expression] = STATE(1151),
    [sym_binary_expression] = STATE(1151),
    [sym_unary_expression] = STATE(1151),
    [sym_update_expression] = STATE(1151),
    [sym_string] = STATE(1151),
    [sym_template_string] = STATE(1151),
    [sym_regex] = STATE(1151),
    [sym_meta_property] = STATE(1151),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1151),
    [sym_type_assertion] = STATE(1151),
    [sym_as_expression] = STATE(1151),
    [sym_internal_module] = STATE(1151),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2225),
    [sym_this] = ACTIONS(2227),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [sym_null] = ACTIONS(2227),
    [sym_undefined] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [372] = {
    [sym_import] = STATE(1013),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1013),
    [sym_yield_expression] = STATE(1013),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1013),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1013),
    [sym_arrow_function] = STATE(1013),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1013),
    [sym_new_expression] = STATE(1013),
    [sym_await_expression] = STATE(1013),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1013),
    [sym_augmented_assignment_expression] = STATE(1013),
    [sym_ternary_expression] = STATE(1013),
    [sym_binary_expression] = STATE(1013),
    [sym_unary_expression] = STATE(1013),
    [sym_update_expression] = STATE(1013),
    [sym_string] = STATE(1013),
    [sym_template_string] = STATE(1013),
    [sym_regex] = STATE(1013),
    [sym_meta_property] = STATE(1013),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1013),
    [sym_as_expression] = STATE(1013),
    [sym_internal_module] = STATE(1013),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2229),
    [sym_this] = ACTIONS(2231),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [sym_null] = ACTIONS(2231),
    [sym_undefined] = ACTIONS(2231),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [373] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(957),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(957),
    [sym_type_assertion] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2233),
    [sym_this] = ACTIONS(1034),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1034),
    [sym_false] = ACTIONS(1034),
    [sym_null] = ACTIONS(1034),
    [sym_undefined] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [374] = {
    [sym_import] = STATE(989),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(989),
    [sym_yield_expression] = STATE(989),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(989),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(989),
    [sym_arrow_function] = STATE(989),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(989),
    [sym_new_expression] = STATE(989),
    [sym_await_expression] = STATE(989),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(989),
    [sym_augmented_assignment_expression] = STATE(989),
    [sym_ternary_expression] = STATE(989),
    [sym_binary_expression] = STATE(989),
    [sym_unary_expression] = STATE(989),
    [sym_update_expression] = STATE(989),
    [sym_string] = STATE(989),
    [sym_template_string] = STATE(989),
    [sym_regex] = STATE(989),
    [sym_meta_property] = STATE(989),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(989),
    [sym_type_assertion] = STATE(989),
    [sym_as_expression] = STATE(989),
    [sym_internal_module] = STATE(989),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2235),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [375] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2239),
    [sym_this] = ACTIONS(2241),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2241),
    [sym_false] = ACTIONS(2241),
    [sym_null] = ACTIONS(2241),
    [sym_undefined] = ACTIONS(2241),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [376] = {
    [sym_import] = STATE(982),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(982),
    [sym_yield_expression] = STATE(982),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(982),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(982),
    [sym_arrow_function] = STATE(982),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(982),
    [sym_new_expression] = STATE(982),
    [sym_await_expression] = STATE(982),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(982),
    [sym_augmented_assignment_expression] = STATE(982),
    [sym_ternary_expression] = STATE(982),
    [sym_binary_expression] = STATE(982),
    [sym_unary_expression] = STATE(982),
    [sym_update_expression] = STATE(982),
    [sym_string] = STATE(982),
    [sym_template_string] = STATE(982),
    [sym_regex] = STATE(982),
    [sym_meta_property] = STATE(982),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(982),
    [sym_type_assertion] = STATE(982),
    [sym_as_expression] = STATE(982),
    [sym_internal_module] = STATE(982),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2243),
    [sym_this] = ACTIONS(2245),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2245),
    [sym_false] = ACTIONS(2245),
    [sym_null] = ACTIONS(2245),
    [sym_undefined] = ACTIONS(2245),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [377] = {
    [sym_import] = STATE(981),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(981),
    [sym_yield_expression] = STATE(981),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(981),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(981),
    [sym_arrow_function] = STATE(981),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(981),
    [sym_new_expression] = STATE(981),
    [sym_await_expression] = STATE(981),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(981),
    [sym_augmented_assignment_expression] = STATE(981),
    [sym_ternary_expression] = STATE(981),
    [sym_binary_expression] = STATE(981),
    [sym_unary_expression] = STATE(981),
    [sym_update_expression] = STATE(981),
    [sym_string] = STATE(981),
    [sym_template_string] = STATE(981),
    [sym_regex] = STATE(981),
    [sym_meta_property] = STATE(981),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(981),
    [sym_type_assertion] = STATE(981),
    [sym_as_expression] = STATE(981),
    [sym_internal_module] = STATE(981),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2247),
    [sym_this] = ACTIONS(2249),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2249),
    [sym_false] = ACTIONS(2249),
    [sym_null] = ACTIONS(2249),
    [sym_undefined] = ACTIONS(2249),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [378] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1282),
    [sym_type_assertion] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2251),
    [sym_this] = ACTIONS(2253),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2253),
    [sym_false] = ACTIONS(2253),
    [sym_null] = ACTIONS(2253),
    [sym_undefined] = ACTIONS(2253),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [379] = {
    [sym_import] = STATE(1150),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1150),
    [sym_yield_expression] = STATE(1150),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1150),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1150),
    [sym_arrow_function] = STATE(1150),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1150),
    [sym_new_expression] = STATE(1150),
    [sym_await_expression] = STATE(1150),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1150),
    [sym_augmented_assignment_expression] = STATE(1150),
    [sym_ternary_expression] = STATE(1150),
    [sym_binary_expression] = STATE(1150),
    [sym_unary_expression] = STATE(1150),
    [sym_update_expression] = STATE(1150),
    [sym_string] = STATE(1150),
    [sym_template_string] = STATE(1150),
    [sym_regex] = STATE(1150),
    [sym_meta_property] = STATE(1150),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1150),
    [sym_type_assertion] = STATE(1150),
    [sym_as_expression] = STATE(1150),
    [sym_internal_module] = STATE(1150),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2255),
    [sym_this] = ACTIONS(2257),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2257),
    [sym_false] = ACTIONS(2257),
    [sym_null] = ACTIONS(2257),
    [sym_undefined] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [380] = {
    [sym_import] = STATE(1207),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1207),
    [sym_type_assertion] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2259),
    [sym_this] = ACTIONS(2261),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2261),
    [sym_false] = ACTIONS(2261),
    [sym_null] = ACTIONS(2261),
    [sym_undefined] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [381] = {
    [sym_import] = STATE(1284),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1284),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1284),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1284),
    [sym_arrow_function] = STATE(1284),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1284),
    [sym_new_expression] = STATE(1284),
    [sym_await_expression] = STATE(1284),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1284),
    [sym_augmented_assignment_expression] = STATE(1284),
    [sym_ternary_expression] = STATE(1284),
    [sym_binary_expression] = STATE(1284),
    [sym_unary_expression] = STATE(1284),
    [sym_update_expression] = STATE(1284),
    [sym_string] = STATE(1284),
    [sym_template_string] = STATE(1284),
    [sym_regex] = STATE(1284),
    [sym_meta_property] = STATE(1284),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1284),
    [sym_type_assertion] = STATE(1284),
    [sym_as_expression] = STATE(1284),
    [sym_internal_module] = STATE(1284),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2263),
    [sym_this] = ACTIONS(2265),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2265),
    [sym_false] = ACTIONS(2265),
    [sym_null] = ACTIONS(2265),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [382] = {
    [sym_import] = STATE(1194),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1194),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1194),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1194),
    [sym_arrow_function] = STATE(1194),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1194),
    [sym_new_expression] = STATE(1194),
    [sym_await_expression] = STATE(1194),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1194),
    [sym_augmented_assignment_expression] = STATE(1194),
    [sym_ternary_expression] = STATE(1194),
    [sym_binary_expression] = STATE(1194),
    [sym_unary_expression] = STATE(1194),
    [sym_update_expression] = STATE(1194),
    [sym_string] = STATE(1194),
    [sym_template_string] = STATE(1194),
    [sym_regex] = STATE(1194),
    [sym_meta_property] = STATE(1194),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1194),
    [sym_type_assertion] = STATE(1194),
    [sym_as_expression] = STATE(1194),
    [sym_internal_module] = STATE(1194),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2267),
    [sym_this] = ACTIONS(2269),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_null] = ACTIONS(2269),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [383] = {
    [sym_import] = STATE(1148),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2271),
    [sym_this] = ACTIONS(2273),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2273),
    [sym_false] = ACTIONS(2273),
    [sym_null] = ACTIONS(2273),
    [sym_undefined] = ACTIONS(2273),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [384] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(978),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(978),
    [sym_type_assertion] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2275),
    [sym_this] = ACTIONS(1819),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1819),
    [sym_false] = ACTIONS(1819),
    [sym_null] = ACTIONS(1819),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [385] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1286),
    [sym_type_assertion] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2277),
    [sym_this] = ACTIONS(2279),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2279),
    [sym_false] = ACTIONS(2279),
    [sym_null] = ACTIONS(2279),
    [sym_undefined] = ACTIONS(2279),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [386] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(977),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2281),
    [sym_this] = ACTIONS(2283),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2283),
    [sym_false] = ACTIONS(2283),
    [sym_null] = ACTIONS(2283),
    [sym_undefined] = ACTIONS(2283),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [387] = {
    [sym_import] = STATE(972),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(972),
    [sym_yield_expression] = STATE(972),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(972),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(972),
    [sym_arrow_function] = STATE(972),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(972),
    [sym_new_expression] = STATE(972),
    [sym_await_expression] = STATE(972),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(972),
    [sym_augmented_assignment_expression] = STATE(972),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_update_expression] = STATE(972),
    [sym_string] = STATE(972),
    [sym_template_string] = STATE(972),
    [sym_regex] = STATE(972),
    [sym_meta_property] = STATE(972),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(972),
    [sym_type_assertion] = STATE(972),
    [sym_as_expression] = STATE(972),
    [sym_internal_module] = STATE(972),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2285),
    [sym_this] = ACTIONS(2287),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2287),
    [sym_false] = ACTIONS(2287),
    [sym_null] = ACTIONS(2287),
    [sym_undefined] = ACTIONS(2287),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [388] = {
    [sym_import] = STATE(1413),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1413),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1413),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1413),
    [sym_arrow_function] = STATE(1413),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1413),
    [sym_new_expression] = STATE(1413),
    [sym_await_expression] = STATE(1413),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1413),
    [sym_augmented_assignment_expression] = STATE(1413),
    [sym_ternary_expression] = STATE(1413),
    [sym_binary_expression] = STATE(1413),
    [sym_unary_expression] = STATE(1413),
    [sym_update_expression] = STATE(1413),
    [sym_string] = STATE(1413),
    [sym_template_string] = STATE(1413),
    [sym_regex] = STATE(1413),
    [sym_meta_property] = STATE(1413),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1413),
    [sym_type_assertion] = STATE(1413),
    [sym_as_expression] = STATE(1413),
    [sym_internal_module] = STATE(1413),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2289),
    [sym_this] = ACTIONS(2291),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2291),
    [sym_false] = ACTIONS(2291),
    [sym_null] = ACTIONS(2291),
    [sym_undefined] = ACTIONS(2291),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [389] = {
    [sym_import] = STATE(1195),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1195),
    [sym_type_assertion] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2293),
    [sym_this] = ACTIONS(2295),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2295),
    [sym_false] = ACTIONS(2295),
    [sym_null] = ACTIONS(2295),
    [sym_undefined] = ACTIONS(2295),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [390] = {
    [sym_import] = STATE(1193),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1193),
    [sym_type_assertion] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2297),
    [sym_this] = ACTIONS(2299),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2299),
    [sym_false] = ACTIONS(2299),
    [sym_null] = ACTIONS(2299),
    [sym_undefined] = ACTIONS(2299),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [391] = {
    [sym_import] = STATE(1254),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1254),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1254),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1254),
    [sym_arrow_function] = STATE(1254),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1254),
    [sym_new_expression] = STATE(1254),
    [sym_await_expression] = STATE(1254),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1254),
    [sym_augmented_assignment_expression] = STATE(1254),
    [sym_ternary_expression] = STATE(1254),
    [sym_binary_expression] = STATE(1254),
    [sym_unary_expression] = STATE(1254),
    [sym_update_expression] = STATE(1254),
    [sym_string] = STATE(1254),
    [sym_template_string] = STATE(1254),
    [sym_regex] = STATE(1254),
    [sym_meta_property] = STATE(1254),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1254),
    [sym_type_assertion] = STATE(1254),
    [sym_as_expression] = STATE(1254),
    [sym_internal_module] = STATE(1254),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(647),
    [sym_this] = ACTIONS(649),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(649),
    [sym_false] = ACTIONS(649),
    [sym_null] = ACTIONS(649),
    [sym_undefined] = ACTIONS(649),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [392] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1191),
    [sym_type_assertion] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2301),
    [sym_this] = ACTIONS(2303),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2303),
    [sym_false] = ACTIONS(2303),
    [sym_null] = ACTIONS(2303),
    [sym_undefined] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [393] = {
    [sym_import] = STATE(1030),
    [sym_parenthesized_expression] = STATE(857),
    [sym__expression] = STATE(1030),
    [sym_yield_expression] = STATE(1030),
    [sym_object] = STATE(1369),
    [sym_array] = STATE(1362),
    [sym_class] = STATE(1030),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1030),
    [sym_arrow_function] = STATE(1030),
    [sym__call_signature] = STATE(2915),
    [sym_call_expression] = STATE(1030),
    [sym_new_expression] = STATE(1030),
    [sym_await_expression] = STATE(1030),
    [sym_member_expression] = STATE(857),
    [sym_subscript_expression] = STATE(857),
    [sym_assignment_expression] = STATE(1030),
    [sym_augmented_assignment_expression] = STATE(1030),
    [sym_ternary_expression] = STATE(1030),
    [sym_binary_expression] = STATE(1030),
    [sym_unary_expression] = STATE(1030),
    [sym_update_expression] = STATE(1030),
    [sym_string] = STATE(1030),
    [sym_template_string] = STATE(1030),
    [sym_regex] = STATE(1030),
    [sym_meta_property] = STATE(1030),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1030),
    [sym_type_assertion] = STATE(1030),
    [sym_as_expression] = STATE(1030),
    [sym_internal_module] = STATE(1030),
    [sym_type_arguments] = STATE(393),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2053),
    [sym_this] = ACTIONS(2055),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [sym_undefined] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [394] = {
    [sym_import] = STATE(1146),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1146),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1146),
    [sym_arrow_function] = STATE(1146),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1146),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1146),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1146),
    [sym_template_string] = STATE(1146),
    [sym_regex] = STATE(1146),
    [sym_meta_property] = STATE(1146),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1146),
    [sym_type_assertion] = STATE(1146),
    [sym_as_expression] = STATE(1146),
    [sym_internal_module] = STATE(1146),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2305),
    [sym_this] = ACTIONS(2307),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_undefined] = ACTIONS(2307),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [395] = {
    [sym_import] = STATE(1145),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1145),
    [sym_yield_expression] = STATE(1145),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1145),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1145),
    [sym_arrow_function] = STATE(1145),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1145),
    [sym_new_expression] = STATE(1145),
    [sym_await_expression] = STATE(1145),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1145),
    [sym_augmented_assignment_expression] = STATE(1145),
    [sym_ternary_expression] = STATE(1145),
    [sym_binary_expression] = STATE(1145),
    [sym_unary_expression] = STATE(1145),
    [sym_update_expression] = STATE(1145),
    [sym_string] = STATE(1145),
    [sym_template_string] = STATE(1145),
    [sym_regex] = STATE(1145),
    [sym_meta_property] = STATE(1145),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1145),
    [sym_type_assertion] = STATE(1145),
    [sym_as_expression] = STATE(1145),
    [sym_internal_module] = STATE(1145),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2309),
    [sym_this] = ACTIONS(2311),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2311),
    [sym_false] = ACTIONS(2311),
    [sym_null] = ACTIONS(2311),
    [sym_undefined] = ACTIONS(2311),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [396] = {
    [sym_import] = STATE(1251),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1251),
    [sym_type_assertion] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2313),
    [sym_this] = ACTIONS(2315),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_undefined] = ACTIONS(2315),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [397] = {
    [sym_import] = STATE(1198),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1198),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1198),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1198),
    [sym_arrow_function] = STATE(1198),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1198),
    [sym_augmented_assignment_expression] = STATE(1198),
    [sym_ternary_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_update_expression] = STATE(1198),
    [sym_string] = STATE(1198),
    [sym_template_string] = STATE(1198),
    [sym_regex] = STATE(1198),
    [sym_meta_property] = STATE(1198),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1198),
    [sym_type_assertion] = STATE(1198),
    [sym_as_expression] = STATE(1198),
    [sym_internal_module] = STATE(1198),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2317),
    [sym_this] = ACTIONS(2319),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2319),
    [sym_false] = ACTIONS(2319),
    [sym_null] = ACTIONS(2319),
    [sym_undefined] = ACTIONS(2319),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [398] = {
    [sym_import] = STATE(1287),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1287),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1287),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1287),
    [sym_arrow_function] = STATE(1287),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1287),
    [sym_new_expression] = STATE(1287),
    [sym_await_expression] = STATE(1287),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1287),
    [sym_augmented_assignment_expression] = STATE(1287),
    [sym_ternary_expression] = STATE(1287),
    [sym_binary_expression] = STATE(1287),
    [sym_unary_expression] = STATE(1287),
    [sym_update_expression] = STATE(1287),
    [sym_string] = STATE(1287),
    [sym_template_string] = STATE(1287),
    [sym_regex] = STATE(1287),
    [sym_meta_property] = STATE(1287),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1287),
    [sym_type_assertion] = STATE(1287),
    [sym_as_expression] = STATE(1287),
    [sym_internal_module] = STATE(1287),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2321),
    [sym_this] = ACTIONS(2323),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2323),
    [sym_false] = ACTIONS(2323),
    [sym_null] = ACTIONS(2323),
    [sym_undefined] = ACTIONS(2323),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [399] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1189),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1189),
    [sym_type_assertion] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2325),
    [sym_this] = ACTIONS(2327),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2327),
    [sym_false] = ACTIONS(2327),
    [sym_null] = ACTIONS(2327),
    [sym_undefined] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [400] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2329),
    [sym_this] = ACTIONS(1871),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1871),
    [sym_false] = ACTIONS(1871),
    [sym_null] = ACTIONS(1871),
    [sym_undefined] = ACTIONS(1871),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [401] = {
    [sym_import] = STATE(1192),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1192),
    [sym_yield_expression] = STATE(1192),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1192),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1192),
    [sym_arrow_function] = STATE(1192),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1192),
    [sym_new_expression] = STATE(1192),
    [sym_await_expression] = STATE(1192),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1192),
    [sym_augmented_assignment_expression] = STATE(1192),
    [sym_ternary_expression] = STATE(1192),
    [sym_binary_expression] = STATE(1192),
    [sym_unary_expression] = STATE(1192),
    [sym_update_expression] = STATE(1192),
    [sym_string] = STATE(1192),
    [sym_template_string] = STATE(1192),
    [sym_regex] = STATE(1192),
    [sym_meta_property] = STATE(1192),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1192),
    [sym_type_assertion] = STATE(1192),
    [sym_as_expression] = STATE(1192),
    [sym_internal_module] = STATE(1192),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2333),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_null] = ACTIONS(2333),
    [sym_undefined] = ACTIONS(2333),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [402] = {
    [sym_import] = STATE(929),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(929),
    [sym_yield_expression] = STATE(929),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(929),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(929),
    [sym_arrow_function] = STATE(929),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(929),
    [sym_new_expression] = STATE(929),
    [sym_await_expression] = STATE(929),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(929),
    [sym_augmented_assignment_expression] = STATE(929),
    [sym_ternary_expression] = STATE(929),
    [sym_binary_expression] = STATE(929),
    [sym_unary_expression] = STATE(929),
    [sym_update_expression] = STATE(929),
    [sym_string] = STATE(929),
    [sym_template_string] = STATE(929),
    [sym_regex] = STATE(929),
    [sym_meta_property] = STATE(929),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(929),
    [sym_type_assertion] = STATE(929),
    [sym_as_expression] = STATE(929),
    [sym_internal_module] = STATE(929),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1821),
    [sym_this] = ACTIONS(1823),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1823),
    [sym_false] = ACTIONS(1823),
    [sym_null] = ACTIONS(1823),
    [sym_undefined] = ACTIONS(1823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [403] = {
    [sym_import] = STATE(1154),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1154),
    [sym_yield_expression] = STATE(1154),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1154),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1154),
    [sym_arrow_function] = STATE(1154),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1154),
    [sym_new_expression] = STATE(1154),
    [sym_await_expression] = STATE(1154),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1154),
    [sym_augmented_assignment_expression] = STATE(1154),
    [sym_ternary_expression] = STATE(1154),
    [sym_binary_expression] = STATE(1154),
    [sym_unary_expression] = STATE(1154),
    [sym_update_expression] = STATE(1154),
    [sym_string] = STATE(1154),
    [sym_template_string] = STATE(1154),
    [sym_regex] = STATE(1154),
    [sym_meta_property] = STATE(1154),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1154),
    [sym_type_assertion] = STATE(1154),
    [sym_as_expression] = STATE(1154),
    [sym_internal_module] = STATE(1154),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2335),
    [sym_this] = ACTIONS(958),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_undefined] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [404] = {
    [sym_import] = STATE(969),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(969),
    [sym_yield_expression] = STATE(969),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(969),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(969),
    [sym_arrow_function] = STATE(969),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(969),
    [sym_new_expression] = STATE(969),
    [sym_await_expression] = STATE(969),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(969),
    [sym_augmented_assignment_expression] = STATE(969),
    [sym_ternary_expression] = STATE(969),
    [sym_binary_expression] = STATE(969),
    [sym_unary_expression] = STATE(969),
    [sym_update_expression] = STATE(969),
    [sym_string] = STATE(969),
    [sym_template_string] = STATE(969),
    [sym_regex] = STATE(969),
    [sym_meta_property] = STATE(969),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(969),
    [sym_type_assertion] = STATE(969),
    [sym_as_expression] = STATE(969),
    [sym_internal_module] = STATE(969),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2337),
    [sym_this] = ACTIONS(2339),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2339),
    [sym_false] = ACTIONS(2339),
    [sym_null] = ACTIONS(2339),
    [sym_undefined] = ACTIONS(2339),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [405] = {
    [sym_import] = STATE(950),
    [sym_parenthesized_expression] = STATE(744),
    [sym__expression] = STATE(950),
    [sym_yield_expression] = STATE(950),
    [sym_object] = STATE(1228),
    [sym_array] = STATE(1229),
    [sym_class] = STATE(950),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(950),
    [sym_arrow_function] = STATE(950),
    [sym__call_signature] = STATE(2970),
    [sym_call_expression] = STATE(950),
    [sym_new_expression] = STATE(950),
    [sym_await_expression] = STATE(950),
    [sym_member_expression] = STATE(744),
    [sym_subscript_expression] = STATE(744),
    [sym_assignment_expression] = STATE(950),
    [sym_augmented_assignment_expression] = STATE(950),
    [sym_ternary_expression] = STATE(950),
    [sym_binary_expression] = STATE(950),
    [sym_unary_expression] = STATE(950),
    [sym_update_expression] = STATE(950),
    [sym_string] = STATE(950),
    [sym_template_string] = STATE(950),
    [sym_regex] = STATE(950),
    [sym_meta_property] = STATE(950),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(950),
    [sym_type_assertion] = STATE(950),
    [sym_as_expression] = STATE(950),
    [sym_internal_module] = STATE(950),
    [sym_type_arguments] = STATE(268),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2341),
    [sym_this] = ACTIONS(2343),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2343),
    [sym_false] = ACTIONS(2343),
    [sym_null] = ACTIONS(2343),
    [sym_undefined] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [406] = {
    [sym_import] = STATE(1159),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1159),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1159),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1159),
    [sym_arrow_function] = STATE(1159),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1159),
    [sym_new_expression] = STATE(1159),
    [sym_await_expression] = STATE(1159),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1159),
    [sym_augmented_assignment_expression] = STATE(1159),
    [sym_ternary_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym_update_expression] = STATE(1159),
    [sym_string] = STATE(1159),
    [sym_template_string] = STATE(1159),
    [sym_regex] = STATE(1159),
    [sym_meta_property] = STATE(1159),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1159),
    [sym_type_assertion] = STATE(1159),
    [sym_as_expression] = STATE(1159),
    [sym_internal_module] = STATE(1159),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2345),
    [sym_this] = ACTIONS(2347),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2347),
    [sym_false] = ACTIONS(2347),
    [sym_null] = ACTIONS(2347),
    [sym_undefined] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [407] = {
    [sym_import] = STATE(1160),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1160),
    [sym_yield_expression] = STATE(1160),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1160),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1160),
    [sym_arrow_function] = STATE(1160),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1160),
    [sym_new_expression] = STATE(1160),
    [sym_await_expression] = STATE(1160),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1160),
    [sym_augmented_assignment_expression] = STATE(1160),
    [sym_ternary_expression] = STATE(1160),
    [sym_binary_expression] = STATE(1160),
    [sym_unary_expression] = STATE(1160),
    [sym_update_expression] = STATE(1160),
    [sym_string] = STATE(1160),
    [sym_template_string] = STATE(1160),
    [sym_regex] = STATE(1160),
    [sym_meta_property] = STATE(1160),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1160),
    [sym_type_assertion] = STATE(1160),
    [sym_as_expression] = STATE(1160),
    [sym_internal_module] = STATE(1160),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2349),
    [sym_this] = ACTIONS(2351),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2351),
    [sym_false] = ACTIONS(2351),
    [sym_null] = ACTIONS(2351),
    [sym_undefined] = ACTIONS(2351),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [408] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1267),
    [sym_type_assertion] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1817),
    [sym_this] = ACTIONS(2095),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [409] = {
    [sym_import] = STATE(992),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(992),
    [sym_yield_expression] = STATE(992),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(992),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(992),
    [sym_arrow_function] = STATE(992),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(992),
    [sym_new_expression] = STATE(992),
    [sym_await_expression] = STATE(992),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(992),
    [sym_augmented_assignment_expression] = STATE(992),
    [sym_ternary_expression] = STATE(992),
    [sym_binary_expression] = STATE(992),
    [sym_unary_expression] = STATE(992),
    [sym_update_expression] = STATE(992),
    [sym_string] = STATE(992),
    [sym_template_string] = STATE(992),
    [sym_regex] = STATE(992),
    [sym_meta_property] = STATE(992),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(992),
    [sym_type_assertion] = STATE(992),
    [sym_as_expression] = STATE(992),
    [sym_internal_module] = STATE(992),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1853),
    [sym_this] = ACTIONS(1855),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1855),
    [sym_false] = ACTIONS(1855),
    [sym_null] = ACTIONS(1855),
    [sym_undefined] = ACTIONS(1855),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [410] = {
    [sym_import] = STATE(1327),
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1581),
    [sym_array] = STATE(1586),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(2921),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(890),
    [sym_subscript_expression] = STATE(890),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1327),
    [sym_type_assertion] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_arguments] = STATE(320),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2322),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_export] = ACTIONS(617),
    [anon_sym_namespace] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(617),
    [anon_sym_typeof] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(625),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_delete] = ACTIONS(623),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2353),
    [sym_this] = ACTIONS(2355),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2355),
    [sym_false] = ACTIONS(2355),
    [sym_null] = ACTIONS(2355),
    [sym_undefined] = ACTIONS(2355),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(617),
    [anon_sym_get] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(617),
    [anon_sym_declare] = ACTIONS(617),
    [anon_sym_public] = ACTIONS(617),
    [anon_sym_private] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(617),
  },
  [411] = {
    [sym_import] = STATE(1197),
    [sym_parenthesized_expression] = STATE(864),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1410),
    [sym_array] = STATE(1409),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(2810),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(864),
    [sym_subscript_expression] = STATE(864),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1197),
    [sym_type_assertion] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_arguments] = STATE(251),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_export] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(739),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(747),
    [anon_sym_DASH] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2357),
    [sym_this] = ACTIONS(2359),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(2359),
    [sym_false] = ACTIONS(2359),
    [sym_null] = ACTIONS(2359),
    [sym_undefined] = ACTIONS(2359),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_get] = ACTIONS(727),
    [anon_sym_set] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(727),
    [anon_sym_number] = ACTIONS(727),
    [anon_sym_boolean] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_symbol] = ACTIONS(727),
    [sym_readonly] = ACTIONS(727),
  },
  [412] = {
    [sym_import] = STATE(933),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(933),
    [sym_yield_expression] = STATE(933),
    [sym_object] = STATE(1615),
    [sym_array] = STATE(1546),
    [sym_class] = STATE(933),
    [sym_function] = STATE(926),
    [sym_generator_function] = STATE(933),
    [sym_arrow_function] = STATE(933),
    [sym__call_signature] = STATE(2883),
    [sym_call_expression] = STATE(933),
    [sym_new_expression] = STATE(933),
    [sym_await_expression] = STATE(933),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(933),
    [sym_augmented_assignment_expression] = STATE(933),
    [sym_ternary_expression] = STATE(933),
    [sym_binary_expression] = STATE(933),
    [sym_unary_expression] = STATE(933),
    [sym_update_expression] = STATE(933),
    [sym_string] = STATE(933),
    [sym_template_string] = STATE(933),
    [sym_regex] = STATE(933),
    [sym_meta_property] = STATE(933),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(933),
    [sym_type_assertion] = STATE(933),
    [sym_as_expression] = STATE(933),
    [sym_internal_module] = STATE(933),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2355),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(515),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1825),
    [sym_this] = ACTIONS(1827),
    [sym_super] = ACTIONS(537),
    [sym_true] = ACTIONS(1827),
    [sym_false] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
    [anon_sym_declare] = ACTIONS(491),
    [anon_sym_public] = ACTIONS(491),
    [anon_sym_private] = ACTIONS(491),
    [anon_sym_protected] = ACTIONS(491),
    [anon_sym_module] = ACTIONS(491),
    [anon_sym_any] = ACTIONS(491),
    [anon_sym_number] = ACTIONS(491),
    [anon_sym_boolean] = ACTIONS(491),
    [anon_sym_string] = ACTIONS(491),
    [anon_sym_symbol] = ACTIONS(491),
    [sym_readonly] = ACTIONS(491),
  },
  [413] = {
    [sym_import] = STATE(1230),
    [sym_parenthesized_expression] = STATE(860),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1428),
    [sym_array] = STATE(1426),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(1225),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(2874),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(860),
    [sym_subscript_expression] = STATE(860),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2313),
    [sym_non_null_expression] = STATE(1230),
    [sym_type_assertion] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_export_statement_repeat1] = STATE(2330),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_await] = ACTIONS(685),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(697),
    [anon_sym_new] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(679),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_DQUOTE] = ACTIONS(713),
    [anon_sym_SQUOTE] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_number] = ACTIONS(2361),
    [sym_this] = ACTIONS(2363),
    [sym_super] = ACTIONS(723),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_undefined] = ACTIONS(2363),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_get] = ACTIONS(671),
    [anon_sym_set] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [sym_readonly] = ACTIONS(671),
  },
  [414] = {
    [sym__call_signature] = STATE(2808),
    [sym_string] = STATE(2039),
    [sym_formal_parameters] = STATE(2313),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2391),
    [anon_sym_set] = ACTIONS(2391),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
    [sym_readonly] = ACTIONS(2367),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_export] = ACTIONS(1226),
    [anon_sym_default] = ACTIONS(1226),
    [anon_sym_EQ] = ACTIONS(1226),
    [anon_sym_namespace] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1224),
    [anon_sym_COMMA] = ACTIONS(1224),
    [anon_sym_RBRACE] = ACTIONS(1224),
    [anon_sym_type] = ACTIONS(1226),
    [anon_sym_typeof] = ACTIONS(1226),
    [anon_sym_import] = ACTIONS(1226),
    [anon_sym_var] = ACTIONS(1226),
    [anon_sym_let] = ACTIONS(1226),
    [anon_sym_const] = ACTIONS(1226),
    [anon_sym_if] = ACTIONS(1226),
    [anon_sym_else] = ACTIONS(1226),
    [anon_sym_switch] = ACTIONS(1226),
    [anon_sym_for] = ACTIONS(1226),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1226),
    [anon_sym_while] = ACTIONS(1226),
    [anon_sym_do] = ACTIONS(1226),
    [anon_sym_try] = ACTIONS(1226),
    [anon_sym_with] = ACTIONS(1226),
    [anon_sym_break] = ACTIONS(1226),
    [anon_sym_continue] = ACTIONS(1226),
    [anon_sym_debugger] = ACTIONS(1226),
    [anon_sym_return] = ACTIONS(1226),
    [anon_sym_throw] = ACTIONS(1226),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_COLON] = ACTIONS(1224),
    [anon_sym_case] = ACTIONS(1226),
    [anon_sym_yield] = ACTIONS(1226),
    [anon_sym_LBRACK] = ACTIONS(1224),
    [anon_sym_RBRACK] = ACTIONS(1224),
    [anon_sym_LT] = ACTIONS(1224),
    [anon_sym_GT] = ACTIONS(1224),
    [anon_sym_SLASH] = ACTIONS(1226),
    [anon_sym_class] = ACTIONS(1226),
    [anon_sym_async] = ACTIONS(1226),
    [anon_sym_function] = ACTIONS(1226),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_QMARK] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_PIPE] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1226),
    [anon_sym_DASH] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(1226),
    [anon_sym_delete] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1224),
    [anon_sym_DASH_DASH] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(1224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1224),
    [sym_number] = ACTIONS(1224),
    [sym_this] = ACTIONS(1226),
    [sym_super] = ACTIONS(1226),
    [sym_true] = ACTIONS(1226),
    [sym_false] = ACTIONS(1226),
    [sym_null] = ACTIONS(1226),
    [sym_undefined] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_static] = ACTIONS(1226),
    [anon_sym_abstract] = ACTIONS(1226),
    [anon_sym_get] = ACTIONS(1226),
    [anon_sym_set] = ACTIONS(1226),
    [anon_sym_declare] = ACTIONS(1226),
    [anon_sym_public] = ACTIONS(1226),
    [anon_sym_private] = ACTIONS(1226),
    [anon_sym_protected] = ACTIONS(1226),
    [anon_sym_module] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(1226),
    [anon_sym_number] = ACTIONS(1226),
    [anon_sym_boolean] = ACTIONS(1226),
    [anon_sym_string] = ACTIONS(1226),
    [anon_sym_symbol] = ACTIONS(1226),
    [anon_sym_interface] = ACTIONS(1226),
    [anon_sym_enum] = ACTIONS(1226),
    [sym_readonly] = ACTIONS(1226),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_export] = ACTIONS(1082),
    [anon_sym_default] = ACTIONS(1082),
    [anon_sym_EQ] = ACTIONS(1082),
    [anon_sym_namespace] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1080),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1082),
    [anon_sym_typeof] = ACTIONS(1082),
    [anon_sym_import] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_const] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_RPAREN] = ACTIONS(1080),
    [anon_sym_await] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_do] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_debugger] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_throw] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1080),
    [anon_sym_COLON] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_RBRACK] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_function] = ACTIONS(1082),
    [anon_sym_EQ_GT] = ACTIONS(1080),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_PIPE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1082),
    [anon_sym_delete] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1080),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_SQUOTE] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1080),
    [sym_number] = ACTIONS(1080),
    [sym_this] = ACTIONS(1082),
    [sym_super] = ACTIONS(1082),
    [sym_true] = ACTIONS(1082),
    [sym_false] = ACTIONS(1082),
    [sym_null] = ACTIONS(1082),
    [sym_undefined] = ACTIONS(1082),
    [anon_sym_AT] = ACTIONS(1080),
    [anon_sym_static] = ACTIONS(1082),
    [anon_sym_abstract] = ACTIONS(1082),
    [anon_sym_get] = ACTIONS(1082),
    [anon_sym_set] = ACTIONS(1082),
    [anon_sym_declare] = ACTIONS(1082),
    [anon_sym_public] = ACTIONS(1082),
    [anon_sym_private] = ACTIONS(1082),
    [anon_sym_protected] = ACTIONS(1082),
    [anon_sym_module] = ACTIONS(1082),
    [anon_sym_any] = ACTIONS(1082),
    [anon_sym_number] = ACTIONS(1082),
    [anon_sym_boolean] = ACTIONS(1082),
    [anon_sym_string] = ACTIONS(1082),
    [anon_sym_symbol] = ACTIONS(1082),
    [anon_sym_interface] = ACTIONS(1082),
    [anon_sym_enum] = ACTIONS(1082),
    [sym_readonly] = ACTIONS(1082),
  },
  [417] = {
    [sym__call_signature] = STATE(2808),
    [sym_string] = STATE(2039),
    [sym_formal_parameters] = STATE(2313),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2391),
    [anon_sym_set] = ACTIONS(2391),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
    [sym_readonly] = ACTIONS(2367),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [418] = {
    [sym__call_signature] = STATE(2808),
    [sym_string] = STATE(2039),
    [sym_formal_parameters] = STATE(2313),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [sym_type_parameters] = STATE(2634),
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2379),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2391),
    [anon_sym_set] = ACTIONS(2391),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
    [sym_readonly] = ACTIONS(2367),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(2393),
    [sym_identifier] = ACTIONS(2395),
    [anon_sym_export] = ACTIONS(2395),
    [anon_sym_default] = ACTIONS(2395),
    [anon_sym_EQ] = ACTIONS(2395),
    [anon_sym_namespace] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2393),
    [anon_sym_RBRACE] = ACTIONS(2393),
    [anon_sym_type] = ACTIONS(2395),
    [anon_sym_typeof] = ACTIONS(2395),
    [anon_sym_import] = ACTIONS(2395),
    [anon_sym_var] = ACTIONS(2395),
    [anon_sym_let] = ACTIONS(2395),
    [anon_sym_const] = ACTIONS(2395),
    [anon_sym_if] = ACTIONS(2395),
    [anon_sym_else] = ACTIONS(2395),
    [anon_sym_switch] = ACTIONS(2395),
    [anon_sym_for] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2393),
    [anon_sym_RPAREN] = ACTIONS(2393),
    [anon_sym_await] = ACTIONS(2395),
    [anon_sym_while] = ACTIONS(2395),
    [anon_sym_do] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2395),
    [anon_sym_with] = ACTIONS(2395),
    [anon_sym_break] = ACTIONS(2395),
    [anon_sym_continue] = ACTIONS(2395),
    [anon_sym_debugger] = ACTIONS(2395),
    [anon_sym_return] = ACTIONS(2395),
    [anon_sym_throw] = ACTIONS(2395),
    [anon_sym_SEMI] = ACTIONS(2393),
    [anon_sym_case] = ACTIONS(2395),
    [anon_sym_yield] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2393),
    [anon_sym_RBRACK] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2395),
    [anon_sym_DOT] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(2395),
    [anon_sym_async] = ACTIONS(2395),
    [anon_sym_function] = ACTIONS(2395),
    [anon_sym_EQ_GT] = ACTIONS(2393),
    [anon_sym_new] = ACTIONS(2395),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2395),
    [anon_sym_DASH] = ACTIONS(2395),
    [anon_sym_BANG] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2393),
    [anon_sym_void] = ACTIONS(2395),
    [anon_sym_delete] = ACTIONS(2395),
    [anon_sym_PLUS_PLUS] = ACTIONS(2393),
    [anon_sym_DASH_DASH] = ACTIONS(2393),
    [anon_sym_DQUOTE] = ACTIONS(2393),
    [anon_sym_SQUOTE] = ACTIONS(2393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2393),
    [sym_number] = ACTIONS(2393),
    [sym_this] = ACTIONS(2395),
    [sym_super] = ACTIONS(2395),
    [sym_true] = ACTIONS(2395),
    [sym_false] = ACTIONS(2395),
    [sym_null] = ACTIONS(2395),
    [sym_undefined] = ACTIONS(2395),
    [anon_sym_AT] = ACTIONS(2393),
    [anon_sym_static] = ACTIONS(2395),
    [anon_sym_abstract] = ACTIONS(2395),
    [anon_sym_get] = ACTIONS(2395),
    [anon_sym_set] = ACTIONS(2395),
    [anon_sym_declare] = ACTIONS(2395),
    [anon_sym_public] = ACTIONS(2395),
    [anon_sym_private] = ACTIONS(2395),
    [anon_sym_protected] = ACTIONS(2395),
    [anon_sym_module] = ACTIONS(2395),
    [anon_sym_any] = ACTIONS(2395),
    [anon_sym_number] = ACTIONS(2395),
    [anon_sym_boolean] = ACTIONS(2395),
    [anon_sym_string] = ACTIONS(2395),
    [anon_sym_symbol] = ACTIONS(2395),
    [anon_sym_implements] = ACTIONS(2395),
    [anon_sym_interface] = ACTIONS(2395),
    [anon_sym_enum] = ACTIONS(2395),
    [sym_readonly] = ACTIONS(2395),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_export] = ACTIONS(2399),
    [anon_sym_default] = ACTIONS(2399),
    [anon_sym_EQ] = ACTIONS(2399),
    [anon_sym_namespace] = ACTIONS(2399),
    [anon_sym_LBRACE] = ACTIONS(2397),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_type] = ACTIONS(2399),
    [anon_sym_typeof] = ACTIONS(2399),
    [anon_sym_import] = ACTIONS(2399),
    [anon_sym_var] = ACTIONS(2399),
    [anon_sym_let] = ACTIONS(2399),
    [anon_sym_const] = ACTIONS(2399),
    [anon_sym_if] = ACTIONS(2399),
    [anon_sym_else] = ACTIONS(2399),
    [anon_sym_switch] = ACTIONS(2399),
    [anon_sym_for] = ACTIONS(2399),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_await] = ACTIONS(2399),
    [anon_sym_while] = ACTIONS(2399),
    [anon_sym_do] = ACTIONS(2399),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_with] = ACTIONS(2399),
    [anon_sym_break] = ACTIONS(2399),
    [anon_sym_continue] = ACTIONS(2399),
    [anon_sym_debugger] = ACTIONS(2399),
    [anon_sym_return] = ACTIONS(2399),
    [anon_sym_throw] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2397),
    [anon_sym_case] = ACTIONS(2399),
    [anon_sym_yield] = ACTIONS(2399),
    [anon_sym_LBRACK] = ACTIONS(2397),
    [anon_sym_RBRACK] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(2397),
    [anon_sym_GT] = ACTIONS(2397),
    [anon_sym_SLASH] = ACTIONS(2399),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_class] = ACTIONS(2399),
    [anon_sym_async] = ACTIONS(2399),
    [anon_sym_function] = ACTIONS(2399),
    [anon_sym_EQ_GT] = ACTIONS(2397),
    [anon_sym_new] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_BANG] = ACTIONS(2397),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_void] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2399),
    [anon_sym_PLUS_PLUS] = ACTIONS(2397),
    [anon_sym_DASH_DASH] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [sym_number] = ACTIONS(2397),
    [sym_this] = ACTIONS(2399),
    [sym_super] = ACTIONS(2399),
    [sym_true] = ACTIONS(2399),
    [sym_false] = ACTIONS(2399),
    [sym_null] = ACTIONS(2399),
    [sym_undefined] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(2397),
    [anon_sym_static] = ACTIONS(2399),
    [anon_sym_abstract] = ACTIONS(2399),
    [anon_sym_get] = ACTIONS(2399),
    [anon_sym_set] = ACTIONS(2399),
    [anon_sym_declare] = ACTIONS(2399),
    [anon_sym_public] = ACTIONS(2399),
    [anon_sym_private] = ACTIONS(2399),
    [anon_sym_protected] = ACTIONS(2399),
    [anon_sym_module] = ACTIONS(2399),
    [anon_sym_any] = ACTIONS(2399),
    [anon_sym_number] = ACTIONS(2399),
    [anon_sym_boolean] = ACTIONS(2399),
    [anon_sym_string] = ACTIONS(2399),
    [anon_sym_symbol] = ACTIONS(2399),
    [anon_sym_interface] = ACTIONS(2399),
    [anon_sym_enum] = ACTIONS(2399),
    [sym_readonly] = ACTIONS(2399),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_export] = ACTIONS(2405),
    [anon_sym_default] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(2405),
    [anon_sym_namespace] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2405),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_import] = ACTIONS(2405),
    [anon_sym_var] = ACTIONS(2405),
    [anon_sym_let] = ACTIONS(2405),
    [anon_sym_const] = ACTIONS(2405),
    [anon_sym_if] = ACTIONS(2405),
    [anon_sym_else] = ACTIONS(2405),
    [anon_sym_switch] = ACTIONS(2405),
    [anon_sym_for] = ACTIONS(2405),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_await] = ACTIONS(2405),
    [anon_sym_while] = ACTIONS(2405),
    [anon_sym_do] = ACTIONS(2405),
    [anon_sym_try] = ACTIONS(2405),
    [anon_sym_with] = ACTIONS(2405),
    [anon_sym_break] = ACTIONS(2405),
    [anon_sym_continue] = ACTIONS(2405),
    [anon_sym_debugger] = ACTIONS(2405),
    [anon_sym_return] = ACTIONS(2405),
    [anon_sym_throw] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_case] = ACTIONS(2405),
    [anon_sym_yield] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_RBRACK] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(2403),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_class] = ACTIONS(2405),
    [anon_sym_async] = ACTIONS(2405),
    [anon_sym_function] = ACTIONS(2405),
    [anon_sym_EQ_GT] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2403),
    [anon_sym_TILDE] = ACTIONS(2403),
    [anon_sym_void] = ACTIONS(2405),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [anon_sym_SQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_number] = ACTIONS(2403),
    [sym_this] = ACTIONS(2405),
    [sym_super] = ACTIONS(2405),
    [sym_true] = ACTIONS(2405),
    [sym_false] = ACTIONS(2405),
    [sym_null] = ACTIONS(2405),
    [sym_undefined] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_static] = ACTIONS(2405),
    [anon_sym_abstract] = ACTIONS(2405),
    [anon_sym_get] = ACTIONS(2405),
    [anon_sym_set] = ACTIONS(2405),
    [anon_sym_declare] = ACTIONS(2405),
    [anon_sym_public] = ACTIONS(2405),
    [anon_sym_private] = ACTIONS(2405),
    [anon_sym_protected] = ACTIONS(2405),
    [anon_sym_module] = ACTIONS(2405),
    [anon_sym_any] = ACTIONS(2405),
    [anon_sym_number] = ACTIONS(2405),
    [anon_sym_boolean] = ACTIONS(2405),
    [anon_sym_string] = ACTIONS(2405),
    [anon_sym_symbol] = ACTIONS(2405),
    [anon_sym_implements] = ACTIONS(2405),
    [anon_sym_interface] = ACTIONS(2405),
    [anon_sym_enum] = ACTIONS(2405),
    [sym_readonly] = ACTIONS(2405),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2407),
    [sym_identifier] = ACTIONS(2409),
    [anon_sym_export] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2407),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_type] = ACTIONS(2409),
    [anon_sym_typeof] = ACTIONS(2409),
    [anon_sym_import] = ACTIONS(2409),
    [anon_sym_var] = ACTIONS(2409),
    [anon_sym_let] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_else] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_RPAREN] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_with] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_debugger] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2407),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_RBRACK] = ACTIONS(2407),
    [anon_sym_LT] = ACTIONS(2407),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_SLASH] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_async] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2409),
    [anon_sym_EQ_GT] = ACTIONS(2407),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_PIPE] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_BANG] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2407),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_PLUS_PLUS] = ACTIONS(2407),
    [anon_sym_DASH_DASH] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_SQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_number] = ACTIONS(2407),
    [sym_this] = ACTIONS(2409),
    [sym_super] = ACTIONS(2409),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [sym_null] = ACTIONS(2409),
    [sym_undefined] = ACTIONS(2409),
    [anon_sym_AT] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_abstract] = ACTIONS(2409),
    [anon_sym_get] = ACTIONS(2409),
    [anon_sym_set] = ACTIONS(2409),
    [anon_sym_declare] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_module] = ACTIONS(2409),
    [anon_sym_any] = ACTIONS(2409),
    [anon_sym_number] = ACTIONS(2409),
    [anon_sym_boolean] = ACTIONS(2409),
    [anon_sym_string] = ACTIONS(2409),
    [anon_sym_symbol] = ACTIONS(2409),
    [anon_sym_implements] = ACTIONS(2409),
    [anon_sym_interface] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [sym_readonly] = ACTIONS(2409),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2411),
    [sym_identifier] = ACTIONS(2413),
    [anon_sym_export] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2413),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_namespace] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_type] = ACTIONS(2413),
    [anon_sym_typeof] = ACTIONS(2413),
    [anon_sym_import] = ACTIONS(2413),
    [anon_sym_var] = ACTIONS(2413),
    [anon_sym_let] = ACTIONS(2413),
    [anon_sym_const] = ACTIONS(2413),
    [anon_sym_if] = ACTIONS(2413),
    [anon_sym_else] = ACTIONS(2413),
    [anon_sym_switch] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_await] = ACTIONS(2413),
    [anon_sym_while] = ACTIONS(2413),
    [anon_sym_do] = ACTIONS(2413),
    [anon_sym_try] = ACTIONS(2413),
    [anon_sym_with] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2413),
    [anon_sym_continue] = ACTIONS(2413),
    [anon_sym_debugger] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2413),
    [anon_sym_throw] = ACTIONS(2413),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_case] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_class] = ACTIONS(2413),
    [anon_sym_async] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2413),
    [anon_sym_EQ_GT] = ACTIONS(2411),
    [anon_sym_new] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_void] = ACTIONS(2413),
    [anon_sym_delete] = ACTIONS(2413),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [sym_number] = ACTIONS(2411),
    [sym_this] = ACTIONS(2413),
    [sym_super] = ACTIONS(2413),
    [sym_true] = ACTIONS(2413),
    [sym_false] = ACTIONS(2413),
    [sym_null] = ACTIONS(2413),
    [sym_undefined] = ACTIONS(2413),
    [anon_sym_AT] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2413),
    [anon_sym_abstract] = ACTIONS(2413),
    [anon_sym_get] = ACTIONS(2413),
    [anon_sym_set] = ACTIONS(2413),
    [anon_sym_declare] = ACTIONS(2413),
    [anon_sym_public] = ACTIONS(2413),
    [anon_sym_private] = ACTIONS(2413),
    [anon_sym_protected] = ACTIONS(2413),
    [anon_sym_module] = ACTIONS(2413),
    [anon_sym_any] = ACTIONS(2413),
    [anon_sym_number] = ACTIONS(2413),
    [anon_sym_boolean] = ACTIONS(2413),
    [anon_sym_string] = ACTIONS(2413),
    [anon_sym_symbol] = ACTIONS(2413),
    [anon_sym_implements] = ACTIONS(2413),
    [anon_sym_interface] = ACTIONS(2413),
    [anon_sym_enum] = ACTIONS(2413),
    [sym_readonly] = ACTIONS(2413),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(1164),
    [anon_sym_default] = ACTIONS(1164),
    [anon_sym_EQ] = ACTIONS(1164),
    [anon_sym_namespace] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_COMMA] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1164),
    [anon_sym_typeof] = ACTIONS(1164),
    [anon_sym_import] = ACTIONS(1164),
    [anon_sym_var] = ACTIONS(1164),
    [anon_sym_let] = ACTIONS(1164),
    [anon_sym_const] = ACTIONS(1164),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_else] = ACTIONS(1164),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_RPAREN] = ACTIONS(1162),
    [anon_sym_await] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1164),
    [anon_sym_do] = ACTIONS(1164),
    [anon_sym_try] = ACTIONS(1164),
    [anon_sym_with] = ACTIONS(1164),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [anon_sym_debugger] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_throw] = ACTIONS(1164),
    [anon_sym_SEMI] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1164),
    [anon_sym_yield] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_RBRACK] = ACTIONS(1162),
    [anon_sym_LT] = ACTIONS(1162),
    [anon_sym_GT] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1164),
    [anon_sym_DOT] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(1164),
    [anon_sym_async] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_EQ_GT] = ACTIONS(1162),
    [anon_sym_new] = ACTIONS(1164),
    [anon_sym_AMP] = ACTIONS(1162),
    [anon_sym_PIPE] = ACTIONS(1162),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_void] = ACTIONS(1164),
    [anon_sym_delete] = ACTIONS(1164),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [sym_number] = ACTIONS(1162),
    [sym_this] = ACTIONS(1164),
    [sym_super] = ACTIONS(1164),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1162),
    [anon_sym_static] = ACTIONS(1164),
    [anon_sym_abstract] = ACTIONS(1164),
    [anon_sym_get] = ACTIONS(1164),
    [anon_sym_set] = ACTIONS(1164),
    [anon_sym_declare] = ACTIONS(1164),
    [anon_sym_public] = ACTIONS(1164),
    [anon_sym_private] = ACTIONS(1164),
    [anon_sym_protected] = ACTIONS(1164),
    [anon_sym_module] = ACTIONS(1164),
    [anon_sym_any] = ACTIONS(1164),
    [anon_sym_number] = ACTIONS(1164),
    [anon_sym_boolean] = ACTIONS(1164),
    [anon_sym_string] = ACTIONS(1164),
    [anon_sym_symbol] = ACTIONS(1164),
    [anon_sym_interface] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(1164),
    [sym_readonly] = ACTIONS(1164),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2415),
    [sym_identifier] = ACTIONS(2417),
    [anon_sym_export] = ACTIONS(2417),
    [anon_sym_default] = ACTIONS(2417),
    [anon_sym_EQ] = ACTIONS(2417),
    [anon_sym_namespace] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(2415),
    [anon_sym_COMMA] = ACTIONS(2415),
    [anon_sym_RBRACE] = ACTIONS(2415),
    [anon_sym_type] = ACTIONS(2417),
    [anon_sym_typeof] = ACTIONS(2417),
    [anon_sym_import] = ACTIONS(2417),
    [anon_sym_var] = ACTIONS(2417),
    [anon_sym_let] = ACTIONS(2417),
    [anon_sym_const] = ACTIONS(2417),
    [anon_sym_if] = ACTIONS(2417),
    [anon_sym_else] = ACTIONS(2417),
    [anon_sym_switch] = ACTIONS(2417),
    [anon_sym_for] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_RPAREN] = ACTIONS(2415),
    [anon_sym_await] = ACTIONS(2417),
    [anon_sym_while] = ACTIONS(2417),
    [anon_sym_do] = ACTIONS(2417),
    [anon_sym_try] = ACTIONS(2417),
    [anon_sym_with] = ACTIONS(2417),
    [anon_sym_break] = ACTIONS(2417),
    [anon_sym_continue] = ACTIONS(2417),
    [anon_sym_debugger] = ACTIONS(2417),
    [anon_sym_return] = ACTIONS(2417),
    [anon_sym_throw] = ACTIONS(2417),
    [anon_sym_SEMI] = ACTIONS(2415),
    [anon_sym_case] = ACTIONS(2417),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2415),
    [anon_sym_RBRACK] = ACTIONS(2415),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_SLASH] = ACTIONS(2417),
    [anon_sym_DOT] = ACTIONS(2419),
    [anon_sym_class] = ACTIONS(2417),
    [anon_sym_async] = ACTIONS(2417),
    [anon_sym_function] = ACTIONS(2417),
    [anon_sym_EQ_GT] = ACTIONS(2415),
    [anon_sym_new] = ACTIONS(2417),
    [anon_sym_AMP] = ACTIONS(2415),
    [anon_sym_PIPE] = ACTIONS(2415),
    [anon_sym_PLUS] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(2417),
    [anon_sym_BANG] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2415),
    [anon_sym_void] = ACTIONS(2417),
    [anon_sym_delete] = ACTIONS(2417),
    [anon_sym_PLUS_PLUS] = ACTIONS(2415),
    [anon_sym_DASH_DASH] = ACTIONS(2415),
    [anon_sym_DQUOTE] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(2415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2415),
    [sym_number] = ACTIONS(2415),
    [sym_this] = ACTIONS(2417),
    [sym_super] = ACTIONS(2417),
    [sym_true] = ACTIONS(2417),
    [sym_false] = ACTIONS(2417),
    [sym_null] = ACTIONS(2417),
    [sym_undefined] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2415),
    [anon_sym_static] = ACTIONS(2417),
    [anon_sym_abstract] = ACTIONS(2417),
    [anon_sym_get] = ACTIONS(2417),
    [anon_sym_set] = ACTIONS(2417),
    [anon_sym_declare] = ACTIONS(2417),
    [anon_sym_public] = ACTIONS(2417),
    [anon_sym_private] = ACTIONS(2417),
    [anon_sym_protected] = ACTIONS(2417),
    [anon_sym_module] = ACTIONS(2417),
    [anon_sym_any] = ACTIONS(2417),
    [anon_sym_number] = ACTIONS(2417),
    [anon_sym_boolean] = ACTIONS(2417),
    [anon_sym_string] = ACTIONS(2417),
    [anon_sym_symbol] = ACTIONS(2417),
    [anon_sym_interface] = ACTIONS(2417),
    [anon_sym_enum] = ACTIONS(2417),
    [sym_readonly] = ACTIONS(2417),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(2421),
    [sym_identifier] = ACTIONS(2423),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_default] = ACTIONS(2423),
    [anon_sym_EQ] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2423),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_COMMA] = ACTIONS(2421),
    [anon_sym_RBRACE] = ACTIONS(2421),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(2423),
    [anon_sym_import] = ACTIONS(2423),
    [anon_sym_var] = ACTIONS(2423),
    [anon_sym_let] = ACTIONS(2423),
    [anon_sym_const] = ACTIONS(2423),
    [anon_sym_if] = ACTIONS(2423),
    [anon_sym_else] = ACTIONS(2423),
    [anon_sym_switch] = ACTIONS(2423),
    [anon_sym_for] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_RPAREN] = ACTIONS(2421),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(2423),
    [anon_sym_do] = ACTIONS(2423),
    [anon_sym_try] = ACTIONS(2423),
    [anon_sym_with] = ACTIONS(2423),
    [anon_sym_break] = ACTIONS(2423),
    [anon_sym_continue] = ACTIONS(2423),
    [anon_sym_debugger] = ACTIONS(2423),
    [anon_sym_return] = ACTIONS(2423),
    [anon_sym_throw] = ACTIONS(2423),
    [anon_sym_SEMI] = ACTIONS(2421),
    [anon_sym_case] = ACTIONS(2423),
    [anon_sym_yield] = ACTIONS(2423),
    [anon_sym_LBRACK] = ACTIONS(2421),
    [anon_sym_RBRACK] = ACTIONS(2421),
    [anon_sym_LT] = ACTIONS(2421),
    [anon_sym_GT] = ACTIONS(2421),
    [anon_sym_SLASH] = ACTIONS(2423),
    [anon_sym_class] = ACTIONS(2423),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_function] = ACTIONS(2423),
    [anon_sym_EQ_GT] = ACTIONS(2421),
    [anon_sym_new] = ACTIONS(2423),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_PIPE] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_TILDE] = ACTIONS(2421),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_delete] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(2421),
    [anon_sym_DASH_DASH] = ACTIONS(2421),
    [anon_sym_DQUOTE] = ACTIONS(2421),
    [anon_sym_SQUOTE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2421),
    [sym_number] = ACTIONS(2421),
    [sym_this] = ACTIONS(2423),
    [sym_super] = ACTIONS(2423),
    [sym_true] = ACTIONS(2423),
    [sym_false] = ACTIONS(2423),
    [sym_null] = ACTIONS(2423),
    [sym_undefined] = ACTIONS(2423),
    [anon_sym_AT] = ACTIONS(2421),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_abstract] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [anon_sym_implements] = ACTIONS(2423),
    [anon_sym_interface] = ACTIONS(2423),
    [anon_sym_enum] = ACTIONS(2423),
    [sym_readonly] = ACTIONS(2423),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(2425),
    [sym_identifier] = ACTIONS(2427),
    [anon_sym_export] = ACTIONS(2427),
    [anon_sym_default] = ACTIONS(2427),
    [anon_sym_EQ] = ACTIONS(2427),
    [anon_sym_namespace] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2425),
    [anon_sym_COMMA] = ACTIONS(2425),
    [anon_sym_RBRACE] = ACTIONS(2425),
    [anon_sym_type] = ACTIONS(2427),
    [anon_sym_typeof] = ACTIONS(2427),
    [anon_sym_import] = ACTIONS(2427),
    [anon_sym_var] = ACTIONS(2427),
    [anon_sym_let] = ACTIONS(2427),
    [anon_sym_const] = ACTIONS(2427),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2427),
    [anon_sym_switch] = ACTIONS(2427),
    [anon_sym_for] = ACTIONS(2427),
    [anon_sym_LPAREN] = ACTIONS(2425),
    [anon_sym_RPAREN] = ACTIONS(2425),
    [anon_sym_await] = ACTIONS(2427),
    [anon_sym_while] = ACTIONS(2427),
    [anon_sym_do] = ACTIONS(2427),
    [anon_sym_try] = ACTIONS(2427),
    [anon_sym_with] = ACTIONS(2427),
    [anon_sym_break] = ACTIONS(2427),
    [anon_sym_continue] = ACTIONS(2427),
    [anon_sym_debugger] = ACTIONS(2427),
    [anon_sym_return] = ACTIONS(2427),
    [anon_sym_throw] = ACTIONS(2427),
    [anon_sym_SEMI] = ACTIONS(2425),
    [anon_sym_case] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(2427),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_RBRACK] = ACTIONS(2425),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_SLASH] = ACTIONS(2427),
    [anon_sym_class] = ACTIONS(2427),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2427),
    [anon_sym_EQ_GT] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_PIPE] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2425),
    [anon_sym_void] = ACTIONS(2427),
    [anon_sym_delete] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2425),
    [anon_sym_DQUOTE] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2425),
    [sym_number] = ACTIONS(2425),
    [sym_this] = ACTIONS(2427),
    [sym_super] = ACTIONS(2427),
    [sym_true] = ACTIONS(2427),
    [sym_false] = ACTIONS(2427),
    [sym_null] = ACTIONS(2427),
    [sym_undefined] = ACTIONS(2427),
    [anon_sym_AT] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2427),
    [anon_sym_abstract] = ACTIONS(2427),
    [anon_sym_get] = ACTIONS(2427),
    [anon_sym_set] = ACTIONS(2427),
    [anon_sym_declare] = ACTIONS(2427),
    [anon_sym_public] = ACTIONS(2427),
    [anon_sym_private] = ACTIONS(2427),
    [anon_sym_protected] = ACTIONS(2427),
    [anon_sym_module] = ACTIONS(2427),
    [anon_sym_any] = ACTIONS(2427),
    [anon_sym_number] = ACTIONS(2427),
    [anon_sym_boolean] = ACTIONS(2427),
    [anon_sym_string] = ACTIONS(2427),
    [anon_sym_symbol] = ACTIONS(2427),
    [anon_sym_implements] = ACTIONS(2427),
    [anon_sym_interface] = ACTIONS(2427),
    [anon_sym_enum] = ACTIONS(2427),
    [sym_readonly] = ACTIONS(2427),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2431),
    [anon_sym_export] = ACTIONS(2431),
    [anon_sym_default] = ACTIONS(2431),
    [anon_sym_EQ] = ACTIONS(2431),
    [anon_sym_namespace] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_type] = ACTIONS(2431),
    [anon_sym_typeof] = ACTIONS(2431),
    [anon_sym_import] = ACTIONS(2431),
    [anon_sym_var] = ACTIONS(2431),
    [anon_sym_let] = ACTIONS(2431),
    [anon_sym_const] = ACTIONS(2431),
    [anon_sym_if] = ACTIONS(2431),
    [anon_sym_else] = ACTIONS(2431),
    [anon_sym_switch] = ACTIONS(2431),
    [anon_sym_for] = ACTIONS(2431),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_RPAREN] = ACTIONS(2429),
    [anon_sym_await] = ACTIONS(2431),
    [anon_sym_while] = ACTIONS(2431),
    [anon_sym_do] = ACTIONS(2431),
    [anon_sym_try] = ACTIONS(2431),
    [anon_sym_with] = ACTIONS(2431),
    [anon_sym_break] = ACTIONS(2431),
    [anon_sym_continue] = ACTIONS(2431),
    [anon_sym_debugger] = ACTIONS(2431),
    [anon_sym_return] = ACTIONS(2431),
    [anon_sym_throw] = ACTIONS(2431),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_case] = ACTIONS(2431),
    [anon_sym_yield] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_RBRACK] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2429),
    [anon_sym_SLASH] = ACTIONS(2431),
    [anon_sym_class] = ACTIONS(2431),
    [anon_sym_async] = ACTIONS(2431),
    [anon_sym_function] = ACTIONS(2431),
    [anon_sym_EQ_GT] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2429),
    [anon_sym_void] = ACTIONS(2431),
    [anon_sym_delete] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_DQUOTE] = ACTIONS(2429),
    [anon_sym_SQUOTE] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2429),
    [sym_number] = ACTIONS(2429),
    [sym_this] = ACTIONS(2431),
    [sym_super] = ACTIONS(2431),
    [sym_true] = ACTIONS(2431),
    [sym_false] = ACTIONS(2431),
    [sym_null] = ACTIONS(2431),
    [sym_undefined] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2431),
    [anon_sym_abstract] = ACTIONS(2431),
    [anon_sym_get] = ACTIONS(2431),
    [anon_sym_set] = ACTIONS(2431),
    [anon_sym_declare] = ACTIONS(2431),
    [anon_sym_public] = ACTIONS(2431),
    [anon_sym_private] = ACTIONS(2431),
    [anon_sym_protected] = ACTIONS(2431),
    [anon_sym_module] = ACTIONS(2431),
    [anon_sym_any] = ACTIONS(2431),
    [anon_sym_number] = ACTIONS(2431),
    [anon_sym_boolean] = ACTIONS(2431),
    [anon_sym_string] = ACTIONS(2431),
    [anon_sym_symbol] = ACTIONS(2431),
    [anon_sym_interface] = ACTIONS(2431),
    [anon_sym_enum] = ACTIONS(2431),
    [sym_readonly] = ACTIONS(2431),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_export] = ACTIONS(2435),
    [anon_sym_default] = ACTIONS(2435),
    [anon_sym_EQ] = ACTIONS(2435),
    [anon_sym_namespace] = ACTIONS(2435),
    [anon_sym_LBRACE] = ACTIONS(2433),
    [anon_sym_COMMA] = ACTIONS(2433),
    [anon_sym_RBRACE] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2435),
    [anon_sym_typeof] = ACTIONS(2435),
    [anon_sym_import] = ACTIONS(2435),
    [anon_sym_var] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(2435),
    [anon_sym_const] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2435),
    [anon_sym_else] = ACTIONS(2435),
    [anon_sym_switch] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2435),
    [anon_sym_LPAREN] = ACTIONS(2433),
    [anon_sym_RPAREN] = ACTIONS(2433),
    [anon_sym_await] = ACTIONS(2435),
    [anon_sym_while] = ACTIONS(2435),
    [anon_sym_do] = ACTIONS(2435),
    [anon_sym_try] = ACTIONS(2435),
    [anon_sym_with] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2435),
    [anon_sym_continue] = ACTIONS(2435),
    [anon_sym_debugger] = ACTIONS(2435),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_throw] = ACTIONS(2435),
    [anon_sym_SEMI] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2435),
    [anon_sym_yield] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_RBRACK] = ACTIONS(2433),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_class] = ACTIONS(2435),
    [anon_sym_async] = ACTIONS(2435),
    [anon_sym_function] = ACTIONS(2435),
    [anon_sym_EQ_GT] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_PIPE] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2433),
    [anon_sym_TILDE] = ACTIONS(2433),
    [anon_sym_void] = ACTIONS(2435),
    [anon_sym_delete] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2433),
    [anon_sym_DQUOTE] = ACTIONS(2433),
    [anon_sym_SQUOTE] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2433),
    [sym_number] = ACTIONS(2433),
    [sym_this] = ACTIONS(2435),
    [sym_super] = ACTIONS(2435),
    [sym_true] = ACTIONS(2435),
    [sym_false] = ACTIONS(2435),
    [sym_null] = ACTIONS(2435),
    [sym_undefined] = ACTIONS(2435),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2435),
    [anon_sym_abstract] = ACTIONS(2435),
    [anon_sym_get] = ACTIONS(2435),
    [anon_sym_set] = ACTIONS(2435),
    [anon_sym_declare] = ACTIONS(2435),
    [anon_sym_public] = ACTIONS(2435),
    [anon_sym_private] = ACTIONS(2435),
    [anon_sym_protected] = ACTIONS(2435),
    [anon_sym_module] = ACTIONS(2435),
    [anon_sym_any] = ACTIONS(2435),
    [anon_sym_number] = ACTIONS(2435),
    [anon_sym_boolean] = ACTIONS(2435),
    [anon_sym_string] = ACTIONS(2435),
    [anon_sym_symbol] = ACTIONS(2435),
    [anon_sym_interface] = ACTIONS(2435),
    [anon_sym_enum] = ACTIONS(2435),
    [sym_readonly] = ACTIONS(2435),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2437),
    [sym_identifier] = ACTIONS(2439),
    [anon_sym_export] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_EQ] = ACTIONS(2439),
    [anon_sym_namespace] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2437),
    [anon_sym_COMMA] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_type] = ACTIONS(2439),
    [anon_sym_typeof] = ACTIONS(2439),
    [anon_sym_import] = ACTIONS(2439),
    [anon_sym_var] = ACTIONS(2439),
    [anon_sym_let] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2437),
    [anon_sym_RPAREN] = ACTIONS(2437),
    [anon_sym_await] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_with] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_debugger] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_yield] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_RBRACK] = ACTIONS(2437),
    [anon_sym_LT] = ACTIONS(2437),
    [anon_sym_GT] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_async] = ACTIONS(2439),
    [anon_sym_function] = ACTIONS(2439),
    [anon_sym_EQ_GT] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_PIPE] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2437),
    [anon_sym_void] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_PLUS_PLUS] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(2437),
    [anon_sym_SQUOTE] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2437),
    [sym_number] = ACTIONS(2437),
    [sym_this] = ACTIONS(2439),
    [sym_super] = ACTIONS(2439),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [sym_null] = ACTIONS(2439),
    [sym_undefined] = ACTIONS(2439),
    [anon_sym_AT] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_abstract] = ACTIONS(2439),
    [anon_sym_get] = ACTIONS(2439),
    [anon_sym_set] = ACTIONS(2439),
    [anon_sym_declare] = ACTIONS(2439),
    [anon_sym_public] = ACTIONS(2439),
    [anon_sym_private] = ACTIONS(2439),
    [anon_sym_protected] = ACTIONS(2439),
    [anon_sym_module] = ACTIONS(2439),
    [anon_sym_any] = ACTIONS(2439),
    [anon_sym_number] = ACTIONS(2439),
    [anon_sym_boolean] = ACTIONS(2439),
    [anon_sym_string] = ACTIONS(2439),
    [anon_sym_symbol] = ACTIONS(2439),
    [anon_sym_interface] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [sym_readonly] = ACTIONS(2439),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_export] = ACTIONS(2443),
    [anon_sym_default] = ACTIONS(2443),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_namespace] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_COMMA] = ACTIONS(2441),
    [anon_sym_RBRACE] = ACTIONS(2441),
    [anon_sym_type] = ACTIONS(2443),
    [anon_sym_typeof] = ACTIONS(2443),
    [anon_sym_import] = ACTIONS(2443),
    [anon_sym_var] = ACTIONS(2443),
    [anon_sym_let] = ACTIONS(2443),
    [anon_sym_const] = ACTIONS(2443),
    [anon_sym_if] = ACTIONS(2443),
    [anon_sym_else] = ACTIONS(2443),
    [anon_sym_switch] = ACTIONS(2443),
    [anon_sym_for] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_RPAREN] = ACTIONS(2441),
    [anon_sym_await] = ACTIONS(2443),
    [anon_sym_while] = ACTIONS(2443),
    [anon_sym_do] = ACTIONS(2443),
    [anon_sym_try] = ACTIONS(2443),
    [anon_sym_with] = ACTIONS(2443),
    [anon_sym_break] = ACTIONS(2443),
    [anon_sym_continue] = ACTIONS(2443),
    [anon_sym_debugger] = ACTIONS(2443),
    [anon_sym_return] = ACTIONS(2443),
    [anon_sym_throw] = ACTIONS(2443),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym_case] = ACTIONS(2443),
    [anon_sym_yield] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_RBRACK] = ACTIONS(2441),
    [anon_sym_LT] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2441),
    [anon_sym_SLASH] = ACTIONS(2443),
    [anon_sym_class] = ACTIONS(2443),
    [anon_sym_async] = ACTIONS(2443),
    [anon_sym_function] = ACTIONS(2443),
    [anon_sym_EQ_GT] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2443),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_PIPE] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_void] = ACTIONS(2443),
    [anon_sym_delete] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2441),
    [sym_number] = ACTIONS(2441),
    [sym_this] = ACTIONS(2443),
    [sym_super] = ACTIONS(2443),
    [sym_true] = ACTIONS(2443),
    [sym_false] = ACTIONS(2443),
    [sym_null] = ACTIONS(2443),
    [sym_undefined] = ACTIONS(2443),
    [anon_sym_AT] = ACTIONS(2441),
    [anon_sym_static] = ACTIONS(2443),
    [anon_sym_abstract] = ACTIONS(2443),
    [anon_sym_get] = ACTIONS(2443),
    [anon_sym_set] = ACTIONS(2443),
    [anon_sym_declare] = ACTIONS(2443),
    [anon_sym_public] = ACTIONS(2443),
    [anon_sym_private] = ACTIONS(2443),
    [anon_sym_protected] = ACTIONS(2443),
    [anon_sym_module] = ACTIONS(2443),
    [anon_sym_any] = ACTIONS(2443),
    [anon_sym_number] = ACTIONS(2443),
    [anon_sym_boolean] = ACTIONS(2443),
    [anon_sym_string] = ACTIONS(2443),
    [anon_sym_symbol] = ACTIONS(2443),
    [anon_sym_interface] = ACTIONS(2443),
    [anon_sym_enum] = ACTIONS(2443),
    [sym_readonly] = ACTIONS(2443),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2447),
    [sym_identifier] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_EQ] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_COMMA] = ACTIONS(2447),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [anon_sym_type] = ACTIONS(2449),
    [anon_sym_typeof] = ACTIONS(2449),
    [anon_sym_import] = ACTIONS(2449),
    [anon_sym_var] = ACTIONS(2449),
    [anon_sym_let] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_else] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [anon_sym_RPAREN] = ACTIONS(2447),
    [anon_sym_await] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_with] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_debugger] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_yield] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2447),
    [anon_sym_RBRACK] = ACTIONS(2447),
    [anon_sym_LT] = ACTIONS(2447),
    [anon_sym_GT] = ACTIONS(2447),
    [anon_sym_SLASH] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_async] = ACTIONS(2449),
    [anon_sym_function] = ACTIONS(2449),
    [anon_sym_EQ_GT] = ACTIONS(2447),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_AMP] = ACTIONS(2447),
    [anon_sym_PIPE] = ACTIONS(2447),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_void] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2447),
    [sym_number] = ACTIONS(2447),
    [sym_this] = ACTIONS(2449),
    [sym_super] = ACTIONS(2449),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [sym_null] = ACTIONS(2449),
    [sym_undefined] = ACTIONS(2449),
    [anon_sym_AT] = ACTIONS(2447),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_abstract] = ACTIONS(2449),
    [anon_sym_get] = ACTIONS(2449),
    [anon_sym_set] = ACTIONS(2449),
    [anon_sym_declare] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_any] = ACTIONS(2449),
    [anon_sym_number] = ACTIONS(2449),
    [anon_sym_boolean] = ACTIONS(2449),
    [anon_sym_string] = ACTIONS(2449),
    [anon_sym_symbol] = ACTIONS(2449),
    [anon_sym_interface] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [sym_readonly] = ACTIONS(2449),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_EQ] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_COMMA] = ACTIONS(2451),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_type] = ACTIONS(2453),
    [anon_sym_typeof] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_var] = ACTIONS(2453),
    [anon_sym_let] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_else] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2451),
    [anon_sym_RPAREN] = ACTIONS(2451),
    [anon_sym_await] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_with] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_debugger] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_yield] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2451),
    [anon_sym_RBRACK] = ACTIONS(2451),
    [anon_sym_LT] = ACTIONS(2451),
    [anon_sym_GT] = ACTIONS(2451),
    [anon_sym_SLASH] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_async] = ACTIONS(2453),
    [anon_sym_function] = ACTIONS(2453),
    [anon_sym_EQ_GT] = ACTIONS(2451),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_AMP] = ACTIONS(2451),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_void] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2451),
    [sym_number] = ACTIONS(2451),
    [sym_this] = ACTIONS(2453),
    [sym_super] = ACTIONS(2453),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [sym_null] = ACTIONS(2453),
    [sym_undefined] = ACTIONS(2453),
    [anon_sym_AT] = ACTIONS(2451),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_abstract] = ACTIONS(2453),
    [anon_sym_get] = ACTIONS(2453),
    [anon_sym_set] = ACTIONS(2453),
    [anon_sym_declare] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_any] = ACTIONS(2453),
    [anon_sym_number] = ACTIONS(2453),
    [anon_sym_boolean] = ACTIONS(2453),
    [anon_sym_string] = ACTIONS(2453),
    [anon_sym_symbol] = ACTIONS(2453),
    [anon_sym_interface] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [sym_readonly] = ACTIONS(2453),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_EQ] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_COMMA] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2457),
    [anon_sym_typeof] = ACTIONS(2457),
    [anon_sym_import] = ACTIONS(2457),
    [anon_sym_var] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_RPAREN] = ACTIONS(2455),
    [anon_sym_await] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2455),
    [anon_sym_RBRACK] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2455),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_SLASH] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_async] = ACTIONS(2457),
    [anon_sym_function] = ACTIONS(2457),
    [anon_sym_EQ_GT] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_AMP] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [sym_number] = ACTIONS(2455),
    [sym_this] = ACTIONS(2457),
    [sym_super] = ACTIONS(2457),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [sym_null] = ACTIONS(2457),
    [sym_undefined] = ACTIONS(2457),
    [anon_sym_AT] = ACTIONS(2455),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_abstract] = ACTIONS(2457),
    [anon_sym_get] = ACTIONS(2457),
    [anon_sym_set] = ACTIONS(2457),
    [anon_sym_declare] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2457),
    [anon_sym_any] = ACTIONS(2457),
    [anon_sym_number] = ACTIONS(2457),
    [anon_sym_boolean] = ACTIONS(2457),
    [anon_sym_string] = ACTIONS(2457),
    [anon_sym_symbol] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [sym_readonly] = ACTIONS(2457),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2459),
    [sym_identifier] = ACTIONS(2461),
    [anon_sym_export] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_EQ] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2459),
    [anon_sym_RBRACE] = ACTIONS(2459),
    [anon_sym_type] = ACTIONS(2461),
    [anon_sym_typeof] = ACTIONS(2461),
    [anon_sym_import] = ACTIONS(2461),
    [anon_sym_var] = ACTIONS(2461),
    [anon_sym_let] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_else] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_LPAREN] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(2459),
    [anon_sym_await] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_with] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_debugger] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_yield] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2459),
    [anon_sym_RBRACK] = ACTIONS(2459),
    [anon_sym_LT] = ACTIONS(2459),
    [anon_sym_GT] = ACTIONS(2459),
    [anon_sym_SLASH] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_async] = ACTIONS(2461),
    [anon_sym_function] = ACTIONS(2461),
    [anon_sym_EQ_GT] = ACTIONS(2459),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_AMP] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_void] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2459),
    [sym_number] = ACTIONS(2459),
    [sym_this] = ACTIONS(2461),
    [sym_super] = ACTIONS(2461),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [sym_null] = ACTIONS(2461),
    [sym_undefined] = ACTIONS(2461),
    [anon_sym_AT] = ACTIONS(2459),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_abstract] = ACTIONS(2461),
    [anon_sym_get] = ACTIONS(2461),
    [anon_sym_set] = ACTIONS(2461),
    [anon_sym_declare] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_module] = ACTIONS(2461),
    [anon_sym_any] = ACTIONS(2461),
    [anon_sym_number] = ACTIONS(2461),
    [anon_sym_boolean] = ACTIONS(2461),
    [anon_sym_string] = ACTIONS(2461),
    [anon_sym_symbol] = ACTIONS(2461),
    [anon_sym_interface] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [sym_readonly] = ACTIONS(2461),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_export] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_EQ] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_COMMA] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_type] = ACTIONS(2465),
    [anon_sym_typeof] = ACTIONS(2465),
    [anon_sym_import] = ACTIONS(2465),
    [anon_sym_var] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_else] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_LPAREN] = ACTIONS(2463),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_await] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_debugger] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_yield] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2463),
    [anon_sym_RBRACK] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2463),
    [anon_sym_GT] = ACTIONS(2463),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_async] = ACTIONS(2465),
    [anon_sym_function] = ACTIONS(2465),
    [anon_sym_EQ_GT] = ACTIONS(2463),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_AMP] = ACTIONS(2463),
    [anon_sym_PIPE] = ACTIONS(2463),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_void] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2463),
    [sym_number] = ACTIONS(2463),
    [sym_this] = ACTIONS(2465),
    [sym_super] = ACTIONS(2465),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [sym_null] = ACTIONS(2465),
    [sym_undefined] = ACTIONS(2465),
    [anon_sym_AT] = ACTIONS(2463),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_abstract] = ACTIONS(2465),
    [anon_sym_get] = ACTIONS(2465),
    [anon_sym_set] = ACTIONS(2465),
    [anon_sym_declare] = ACTIONS(2465),
    [anon_sym_public] = ACTIONS(2465),
    [anon_sym_private] = ACTIONS(2465),
    [anon_sym_protected] = ACTIONS(2465),
    [anon_sym_module] = ACTIONS(2465),
    [anon_sym_any] = ACTIONS(2465),
    [anon_sym_number] = ACTIONS(2465),
    [anon_sym_boolean] = ACTIONS(2465),
    [anon_sym_string] = ACTIONS(2465),
    [anon_sym_symbol] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [sym_readonly] = ACTIONS(2465),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2469),
    [anon_sym_export] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_EQ] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_COMMA] = ACTIONS(2467),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_type] = ACTIONS(2469),
    [anon_sym_typeof] = ACTIONS(2469),
    [anon_sym_import] = ACTIONS(2469),
    [anon_sym_var] = ACTIONS(2469),
    [anon_sym_let] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_else] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_LPAREN] = ACTIONS(2467),
    [anon_sym_RPAREN] = ACTIONS(2467),
    [anon_sym_await] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_with] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_debugger] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_yield] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2467),
    [anon_sym_RBRACK] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_SLASH] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_async] = ACTIONS(2469),
    [anon_sym_function] = ACTIONS(2469),
    [anon_sym_EQ_GT] = ACTIONS(2467),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_void] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [sym_number] = ACTIONS(2467),
    [sym_this] = ACTIONS(2469),
    [sym_super] = ACTIONS(2469),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [sym_null] = ACTIONS(2469),
    [sym_undefined] = ACTIONS(2469),
    [anon_sym_AT] = ACTIONS(2467),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_abstract] = ACTIONS(2469),
    [anon_sym_get] = ACTIONS(2469),
    [anon_sym_set] = ACTIONS(2469),
    [anon_sym_declare] = ACTIONS(2469),
    [anon_sym_public] = ACTIONS(2469),
    [anon_sym_private] = ACTIONS(2469),
    [anon_sym_protected] = ACTIONS(2469),
    [anon_sym_module] = ACTIONS(2469),
    [anon_sym_any] = ACTIONS(2469),
    [anon_sym_number] = ACTIONS(2469),
    [anon_sym_boolean] = ACTIONS(2469),
    [anon_sym_string] = ACTIONS(2469),
    [anon_sym_symbol] = ACTIONS(2469),
    [anon_sym_interface] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [sym_readonly] = ACTIONS(2469),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_export] = ACTIONS(2471),
    [anon_sym_default] = ACTIONS(2471),
    [anon_sym_EQ] = ACTIONS(2471),
    [anon_sym_namespace] = ACTIONS(2471),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(2471),
    [anon_sym_typeof] = ACTIONS(2471),
    [anon_sym_import] = ACTIONS(2471),
    [anon_sym_var] = ACTIONS(2471),
    [anon_sym_let] = ACTIONS(2471),
    [anon_sym_const] = ACTIONS(2471),
    [anon_sym_if] = ACTIONS(2471),
    [anon_sym_else] = ACTIONS(2471),
    [anon_sym_switch] = ACTIONS(2471),
    [anon_sym_for] = ACTIONS(2471),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_await] = ACTIONS(2471),
    [anon_sym_while] = ACTIONS(2471),
    [anon_sym_do] = ACTIONS(2471),
    [anon_sym_try] = ACTIONS(2471),
    [anon_sym_with] = ACTIONS(2471),
    [anon_sym_break] = ACTIONS(2471),
    [anon_sym_continue] = ACTIONS(2471),
    [anon_sym_debugger] = ACTIONS(2471),
    [anon_sym_return] = ACTIONS(2471),
    [anon_sym_throw] = ACTIONS(2471),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(2471),
    [anon_sym_yield] = ACTIONS(2471),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(2471),
    [anon_sym_class] = ACTIONS(2471),
    [anon_sym_async] = ACTIONS(2471),
    [anon_sym_function] = ACTIONS(2471),
    [anon_sym_EQ_GT] = ACTIONS(589),
    [anon_sym_new] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_void] = ACTIONS(2471),
    [anon_sym_delete] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(2471),
    [sym_super] = ACTIONS(2471),
    [sym_true] = ACTIONS(2471),
    [sym_false] = ACTIONS(2471),
    [sym_null] = ACTIONS(2471),
    [sym_undefined] = ACTIONS(2471),
    [anon_sym_AT] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(2471),
    [anon_sym_abstract] = ACTIONS(2471),
    [anon_sym_get] = ACTIONS(2471),
    [anon_sym_set] = ACTIONS(2471),
    [anon_sym_declare] = ACTIONS(2471),
    [anon_sym_public] = ACTIONS(2471),
    [anon_sym_private] = ACTIONS(2471),
    [anon_sym_protected] = ACTIONS(2471),
    [anon_sym_module] = ACTIONS(2471),
    [anon_sym_any] = ACTIONS(2471),
    [anon_sym_number] = ACTIONS(2471),
    [anon_sym_boolean] = ACTIONS(2471),
    [anon_sym_string] = ACTIONS(2471),
    [anon_sym_symbol] = ACTIONS(2471),
    [anon_sym_interface] = ACTIONS(2471),
    [anon_sym_enum] = ACTIONS(2471),
    [sym_readonly] = ACTIONS(2471),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2473),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_export] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2475),
    [anon_sym_EQ] = ACTIONS(2475),
    [anon_sym_namespace] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_COMMA] = ACTIONS(2473),
    [anon_sym_RBRACE] = ACTIONS(2473),
    [anon_sym_type] = ACTIONS(2475),
    [anon_sym_typeof] = ACTIONS(2475),
    [anon_sym_import] = ACTIONS(2475),
    [anon_sym_var] = ACTIONS(2475),
    [anon_sym_let] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_RPAREN] = ACTIONS(2473),
    [anon_sym_await] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_with] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_debugger] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_yield] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_RBRACK] = ACTIONS(2473),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_GT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_async] = ACTIONS(2475),
    [anon_sym_function] = ACTIONS(2475),
    [anon_sym_EQ_GT] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_PIPE] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [anon_sym_void] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2473),
    [anon_sym_DQUOTE] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2473),
    [sym_number] = ACTIONS(2473),
    [sym_this] = ACTIONS(2475),
    [sym_super] = ACTIONS(2475),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [sym_null] = ACTIONS(2475),
    [sym_undefined] = ACTIONS(2475),
    [anon_sym_AT] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_abstract] = ACTIONS(2475),
    [anon_sym_get] = ACTIONS(2475),
    [anon_sym_set] = ACTIONS(2475),
    [anon_sym_declare] = ACTIONS(2475),
    [anon_sym_public] = ACTIONS(2475),
    [anon_sym_private] = ACTIONS(2475),
    [anon_sym_protected] = ACTIONS(2475),
    [anon_sym_module] = ACTIONS(2475),
    [anon_sym_any] = ACTIONS(2475),
    [anon_sym_number] = ACTIONS(2475),
    [anon_sym_boolean] = ACTIONS(2475),
    [anon_sym_string] = ACTIONS(2475),
    [anon_sym_symbol] = ACTIONS(2475),
    [anon_sym_interface] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [sym_readonly] = ACTIONS(2475),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_export] = ACTIONS(2479),
    [anon_sym_default] = ACTIONS(2479),
    [anon_sym_EQ] = ACTIONS(2479),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_COMMA] = ACTIONS(2477),
    [anon_sym_RBRACE] = ACTIONS(2477),
    [anon_sym_type] = ACTIONS(2479),
    [anon_sym_typeof] = ACTIONS(2479),
    [anon_sym_import] = ACTIONS(2479),
    [anon_sym_var] = ACTIONS(2479),
    [anon_sym_let] = ACTIONS(2479),
    [anon_sym_const] = ACTIONS(2479),
    [anon_sym_if] = ACTIONS(2479),
    [anon_sym_else] = ACTIONS(2479),
    [anon_sym_switch] = ACTIONS(2479),
    [anon_sym_for] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(2477),
    [anon_sym_RPAREN] = ACTIONS(2477),
    [anon_sym_await] = ACTIONS(2479),
    [anon_sym_while] = ACTIONS(2479),
    [anon_sym_do] = ACTIONS(2479),
    [anon_sym_try] = ACTIONS(2479),
    [anon_sym_with] = ACTIONS(2479),
    [anon_sym_break] = ACTIONS(2479),
    [anon_sym_continue] = ACTIONS(2479),
    [anon_sym_debugger] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(2479),
    [anon_sym_throw] = ACTIONS(2479),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2479),
    [anon_sym_yield] = ACTIONS(2479),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_RBRACK] = ACTIONS(2477),
    [anon_sym_LT] = ACTIONS(2477),
    [anon_sym_GT] = ACTIONS(2477),
    [anon_sym_SLASH] = ACTIONS(2479),
    [anon_sym_class] = ACTIONS(2479),
    [anon_sym_async] = ACTIONS(2479),
    [anon_sym_function] = ACTIONS(2479),
    [anon_sym_EQ_GT] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_PIPE] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2479),
    [anon_sym_DASH] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_void] = ACTIONS(2479),
    [anon_sym_delete] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2477),
    [sym_number] = ACTIONS(2477),
    [sym_this] = ACTIONS(2479),
    [sym_super] = ACTIONS(2479),
    [sym_true] = ACTIONS(2479),
    [sym_false] = ACTIONS(2479),
    [sym_null] = ACTIONS(2479),
    [sym_undefined] = ACTIONS(2479),
    [anon_sym_AT] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2479),
    [anon_sym_abstract] = ACTIONS(2479),
    [anon_sym_get] = ACTIONS(2479),
    [anon_sym_set] = ACTIONS(2479),
    [anon_sym_declare] = ACTIONS(2479),
    [anon_sym_public] = ACTIONS(2479),
    [anon_sym_private] = ACTIONS(2479),
    [anon_sym_protected] = ACTIONS(2479),
    [anon_sym_module] = ACTIONS(2479),
    [anon_sym_any] = ACTIONS(2479),
    [anon_sym_number] = ACTIONS(2479),
    [anon_sym_boolean] = ACTIONS(2479),
    [anon_sym_string] = ACTIONS(2479),
    [anon_sym_symbol] = ACTIONS(2479),
    [anon_sym_interface] = ACTIONS(2479),
    [anon_sym_enum] = ACTIONS(2479),
    [sym_readonly] = ACTIONS(2479),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2481),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_export] = ACTIONS(2483),
    [anon_sym_default] = ACTIONS(2483),
    [anon_sym_EQ] = ACTIONS(2483),
    [anon_sym_namespace] = ACTIONS(2483),
    [anon_sym_LBRACE] = ACTIONS(2481),
    [anon_sym_COMMA] = ACTIONS(2481),
    [anon_sym_RBRACE] = ACTIONS(2481),
    [anon_sym_type] = ACTIONS(2483),
    [anon_sym_typeof] = ACTIONS(2483),
    [anon_sym_import] = ACTIONS(2483),
    [anon_sym_var] = ACTIONS(2483),
    [anon_sym_let] = ACTIONS(2483),
    [anon_sym_const] = ACTIONS(2483),
    [anon_sym_if] = ACTIONS(2483),
    [anon_sym_else] = ACTIONS(2483),
    [anon_sym_switch] = ACTIONS(2483),
    [anon_sym_for] = ACTIONS(2483),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_RPAREN] = ACTIONS(2481),
    [anon_sym_await] = ACTIONS(2483),
    [anon_sym_while] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2483),
    [anon_sym_try] = ACTIONS(2483),
    [anon_sym_with] = ACTIONS(2483),
    [anon_sym_break] = ACTIONS(2483),
    [anon_sym_continue] = ACTIONS(2483),
    [anon_sym_debugger] = ACTIONS(2483),
    [anon_sym_return] = ACTIONS(2483),
    [anon_sym_throw] = ACTIONS(2483),
    [anon_sym_SEMI] = ACTIONS(2481),
    [anon_sym_case] = ACTIONS(2483),
    [anon_sym_yield] = ACTIONS(2483),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [anon_sym_RBRACK] = ACTIONS(2481),
    [anon_sym_LT] = ACTIONS(2481),
    [anon_sym_GT] = ACTIONS(2481),
    [anon_sym_SLASH] = ACTIONS(2483),
    [anon_sym_class] = ACTIONS(2483),
    [anon_sym_async] = ACTIONS(2483),
    [anon_sym_function] = ACTIONS(2483),
    [anon_sym_EQ_GT] = ACTIONS(2481),
    [anon_sym_new] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(2481),
    [anon_sym_PIPE] = ACTIONS(2481),
    [anon_sym_PLUS] = ACTIONS(2483),
    [anon_sym_DASH] = ACTIONS(2483),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_TILDE] = ACTIONS(2481),
    [anon_sym_void] = ACTIONS(2483),
    [anon_sym_delete] = ACTIONS(2483),
    [anon_sym_PLUS_PLUS] = ACTIONS(2481),
    [anon_sym_DASH_DASH] = ACTIONS(2481),
    [anon_sym_DQUOTE] = ACTIONS(2481),
    [anon_sym_SQUOTE] = ACTIONS(2481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2481),
    [sym_number] = ACTIONS(2481),
    [sym_this] = ACTIONS(2483),
    [sym_super] = ACTIONS(2483),
    [sym_true] = ACTIONS(2483),
    [sym_false] = ACTIONS(2483),
    [sym_null] = ACTIONS(2483),
    [sym_undefined] = ACTIONS(2483),
    [anon_sym_AT] = ACTIONS(2481),
    [anon_sym_static] = ACTIONS(2483),
    [anon_sym_abstract] = ACTIONS(2483),
    [anon_sym_get] = ACTIONS(2483),
    [anon_sym_set] = ACTIONS(2483),
    [anon_sym_declare] = ACTIONS(2483),
    [anon_sym_public] = ACTIONS(2483),
    [anon_sym_private] = ACTIONS(2483),
    [anon_sym_protected] = ACTIONS(2483),
    [anon_sym_module] = ACTIONS(2483),
    [anon_sym_any] = ACTIONS(2483),
    [anon_sym_number] = ACTIONS(2483),
    [anon_sym_boolean] = ACTIONS(2483),
    [anon_sym_string] = ACTIONS(2483),
    [anon_sym_symbol] = ACTIONS(2483),
    [anon_sym_interface] = ACTIONS(2483),
    [anon_sym_enum] = ACTIONS(2483),
    [sym_readonly] = ACTIONS(2483),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2485),
    [sym_identifier] = ACTIONS(2487),
    [anon_sym_export] = ACTIONS(2487),
    [anon_sym_default] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_namespace] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2485),
    [anon_sym_type] = ACTIONS(2487),
    [anon_sym_typeof] = ACTIONS(2487),
    [anon_sym_import] = ACTIONS(2487),
    [anon_sym_var] = ACTIONS(2487),
    [anon_sym_let] = ACTIONS(2487),
    [anon_sym_const] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2487),
    [anon_sym_else] = ACTIONS(2487),
    [anon_sym_switch] = ACTIONS(2487),
    [anon_sym_for] = ACTIONS(2487),
    [anon_sym_LPAREN] = ACTIONS(2485),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_await] = ACTIONS(2487),
    [anon_sym_while] = ACTIONS(2487),
    [anon_sym_do] = ACTIONS(2487),
    [anon_sym_try] = ACTIONS(2487),
    [anon_sym_with] = ACTIONS(2487),
    [anon_sym_break] = ACTIONS(2487),
    [anon_sym_continue] = ACTIONS(2487),
    [anon_sym_debugger] = ACTIONS(2487),
    [anon_sym_return] = ACTIONS(2487),
    [anon_sym_throw] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2485),
    [anon_sym_case] = ACTIONS(2487),
    [anon_sym_yield] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2485),
    [anon_sym_LT] = ACTIONS(2485),
    [anon_sym_GT] = ACTIONS(2485),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_class] = ACTIONS(2487),
    [anon_sym_async] = ACTIONS(2487),
    [anon_sym_function] = ACTIONS(2487),
    [anon_sym_EQ_GT] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2485),
    [anon_sym_PIPE] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(2487),
    [anon_sym_delete] = ACTIONS(2487),
    [anon_sym_PLUS_PLUS] = ACTIONS(2485),
    [anon_sym_DASH_DASH] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2485),
    [sym_number] = ACTIONS(2485),
    [sym_this] = ACTIONS(2487),
    [sym_super] = ACTIONS(2487),
    [sym_true] = ACTIONS(2487),
    [sym_false] = ACTIONS(2487),
    [sym_null] = ACTIONS(2487),
    [sym_undefined] = ACTIONS(2487),
    [anon_sym_AT] = ACTIONS(2485),
    [anon_sym_static] = ACTIONS(2487),
    [anon_sym_abstract] = ACTIONS(2487),
    [anon_sym_get] = ACTIONS(2487),
    [anon_sym_set] = ACTIONS(2487),
    [anon_sym_declare] = ACTIONS(2487),
    [anon_sym_public] = ACTIONS(2487),
    [anon_sym_private] = ACTIONS(2487),
    [anon_sym_protected] = ACTIONS(2487),
    [anon_sym_module] = ACTIONS(2487),
    [anon_sym_any] = ACTIONS(2487),
    [anon_sym_number] = ACTIONS(2487),
    [anon_sym_boolean] = ACTIONS(2487),
    [anon_sym_string] = ACTIONS(2487),
    [anon_sym_symbol] = ACTIONS(2487),
    [anon_sym_interface] = ACTIONS(2487),
    [anon_sym_enum] = ACTIONS(2487),
    [sym_readonly] = ACTIONS(2487),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(2489),
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_export] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_type] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(2491),
    [anon_sym_import] = ACTIONS(2491),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_await] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_with] = ACTIONS(2491),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_debugger] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_yield] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_async] = ACTIONS(2491),
    [anon_sym_function] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2489),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_void] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2489),
    [sym_number] = ACTIONS(2489),
    [sym_this] = ACTIONS(2491),
    [sym_super] = ACTIONS(2491),
    [sym_true] = ACTIONS(2491),
    [sym_false] = ACTIONS(2491),
    [sym_null] = ACTIONS(2491),
    [sym_undefined] = ACTIONS(2491),
    [anon_sym_AT] = ACTIONS(2489),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_abstract] = ACTIONS(2491),
    [anon_sym_get] = ACTIONS(2491),
    [anon_sym_set] = ACTIONS(2491),
    [anon_sym_declare] = ACTIONS(2491),
    [anon_sym_public] = ACTIONS(2491),
    [anon_sym_private] = ACTIONS(2491),
    [anon_sym_protected] = ACTIONS(2491),
    [anon_sym_module] = ACTIONS(2491),
    [anon_sym_any] = ACTIONS(2491),
    [anon_sym_number] = ACTIONS(2491),
    [anon_sym_boolean] = ACTIONS(2491),
    [anon_sym_string] = ACTIONS(2491),
    [anon_sym_symbol] = ACTIONS(2491),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [sym_readonly] = ACTIONS(2491),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_default] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_LBRACE] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2493),
    [anon_sym_RBRACE] = ACTIONS(2493),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_typeof] = ACTIONS(2495),
    [anon_sym_import] = ACTIONS(2495),
    [anon_sym_var] = ACTIONS(2495),
    [anon_sym_let] = ACTIONS(2495),
    [anon_sym_const] = ACTIONS(2495),
    [anon_sym_if] = ACTIONS(2495),
    [anon_sym_else] = ACTIONS(2495),
    [anon_sym_switch] = ACTIONS(2495),
    [anon_sym_for] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2493),
    [anon_sym_RPAREN] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [anon_sym_while] = ACTIONS(2495),
    [anon_sym_do] = ACTIONS(2495),
    [anon_sym_try] = ACTIONS(2495),
    [anon_sym_with] = ACTIONS(2495),
    [anon_sym_break] = ACTIONS(2495),
    [anon_sym_continue] = ACTIONS(2495),
    [anon_sym_debugger] = ACTIONS(2495),
    [anon_sym_return] = ACTIONS(2495),
    [anon_sym_throw] = ACTIONS(2495),
    [anon_sym_SEMI] = ACTIONS(2493),
    [anon_sym_case] = ACTIONS(2495),
    [anon_sym_yield] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(2493),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2495),
    [anon_sym_class] = ACTIONS(2495),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_function] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(2493),
    [anon_sym_new] = ACTIONS(2495),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2495),
    [anon_sym_DASH] = ACTIONS(2495),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_delete] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(2493),
    [anon_sym_DASH_DASH] = ACTIONS(2493),
    [anon_sym_DQUOTE] = ACTIONS(2493),
    [anon_sym_SQUOTE] = ACTIONS(2493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2493),
    [sym_number] = ACTIONS(2493),
    [sym_this] = ACTIONS(2495),
    [sym_super] = ACTIONS(2495),
    [sym_true] = ACTIONS(2495),
    [sym_false] = ACTIONS(2495),
    [sym_null] = ACTIONS(2495),
    [sym_undefined] = ACTIONS(2495),
    [anon_sym_AT] = ACTIONS(2493),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_abstract] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [anon_sym_interface] = ACTIONS(2495),
    [anon_sym_enum] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(2497),
    [sym_identifier] = ACTIONS(2499),
    [anon_sym_export] = ACTIONS(2499),
    [anon_sym_default] = ACTIONS(2499),
    [anon_sym_EQ] = ACTIONS(2499),
    [anon_sym_namespace] = ACTIONS(2499),
    [anon_sym_LBRACE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2497),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_type] = ACTIONS(2499),
    [anon_sym_typeof] = ACTIONS(2499),
    [anon_sym_import] = ACTIONS(2499),
    [anon_sym_var] = ACTIONS(2499),
    [anon_sym_let] = ACTIONS(2499),
    [anon_sym_const] = ACTIONS(2499),
    [anon_sym_if] = ACTIONS(2499),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_switch] = ACTIONS(2499),
    [anon_sym_for] = ACTIONS(2499),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_RPAREN] = ACTIONS(2497),
    [anon_sym_await] = ACTIONS(2499),
    [anon_sym_while] = ACTIONS(2499),
    [anon_sym_do] = ACTIONS(2499),
    [anon_sym_try] = ACTIONS(2499),
    [anon_sym_with] = ACTIONS(2499),
    [anon_sym_break] = ACTIONS(2499),
    [anon_sym_continue] = ACTIONS(2499),
    [anon_sym_debugger] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(2499),
    [anon_sym_throw] = ACTIONS(2499),
    [anon_sym_SEMI] = ACTIONS(2497),
    [anon_sym_case] = ACTIONS(2499),
    [anon_sym_yield] = ACTIONS(2499),
    [anon_sym_LBRACK] = ACTIONS(2497),
    [anon_sym_RBRACK] = ACTIONS(2497),
    [anon_sym_LT] = ACTIONS(2497),
    [anon_sym_GT] = ACTIONS(2497),
    [anon_sym_SLASH] = ACTIONS(2499),
    [anon_sym_class] = ACTIONS(2499),
    [anon_sym_async] = ACTIONS(2499),
    [anon_sym_function] = ACTIONS(2499),
    [anon_sym_EQ_GT] = ACTIONS(2497),
    [anon_sym_new] = ACTIONS(2499),
    [anon_sym_AMP] = ACTIONS(2497),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_PLUS] = ACTIONS(2499),
    [anon_sym_DASH] = ACTIONS(2499),
    [anon_sym_BANG] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2497),
    [anon_sym_void] = ACTIONS(2499),
    [anon_sym_delete] = ACTIONS(2499),
    [anon_sym_PLUS_PLUS] = ACTIONS(2497),
    [anon_sym_DASH_DASH] = ACTIONS(2497),
    [anon_sym_DQUOTE] = ACTIONS(2497),
    [anon_sym_SQUOTE] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2497),
    [sym_number] = ACTIONS(2497),
    [sym_this] = ACTIONS(2499),
    [sym_super] = ACTIONS(2499),
    [sym_true] = ACTIONS(2499),
    [sym_false] = ACTIONS(2499),
    [sym_null] = ACTIONS(2499),
    [sym_undefined] = ACTIONS(2499),
    [anon_sym_AT] = ACTIONS(2497),
    [anon_sym_static] = ACTIONS(2499),
    [anon_sym_abstract] = ACTIONS(2499),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2499),
    [anon_sym_public] = ACTIONS(2499),
    [anon_sym_private] = ACTIONS(2499),
    [anon_sym_protected] = ACTIONS(2499),
    [anon_sym_module] = ACTIONS(2499),
    [anon_sym_any] = ACTIONS(2499),
    [anon_sym_number] = ACTIONS(2499),
    [anon_sym_boolean] = ACTIONS(2499),
    [anon_sym_string] = ACTIONS(2499),
    [anon_sym_symbol] = ACTIONS(2499),
    [anon_sym_interface] = ACTIONS(2499),
    [anon_sym_enum] = ACTIONS(2499),
    [sym_readonly] = ACTIONS(2499),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(2501),
    [sym_identifier] = ACTIONS(2503),
    [anon_sym_export] = ACTIONS(2503),
    [anon_sym_default] = ACTIONS(2503),
    [anon_sym_EQ] = ACTIONS(2503),
    [anon_sym_namespace] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2501),
    [anon_sym_COMMA] = ACTIONS(2501),
    [anon_sym_RBRACE] = ACTIONS(2501),
    [anon_sym_type] = ACTIONS(2503),
    [anon_sym_typeof] = ACTIONS(2503),
    [anon_sym_import] = ACTIONS(2503),
    [anon_sym_var] = ACTIONS(2503),
    [anon_sym_let] = ACTIONS(2503),
    [anon_sym_const] = ACTIONS(2503),
    [anon_sym_if] = ACTIONS(2503),
    [anon_sym_else] = ACTIONS(2503),
    [anon_sym_switch] = ACTIONS(2503),
    [anon_sym_for] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2501),
    [anon_sym_RPAREN] = ACTIONS(2501),
    [anon_sym_await] = ACTIONS(2503),
    [anon_sym_while] = ACTIONS(2503),
    [anon_sym_do] = ACTIONS(2503),
    [anon_sym_try] = ACTIONS(2503),
    [anon_sym_with] = ACTIONS(2503),
    [anon_sym_break] = ACTIONS(2503),
    [anon_sym_continue] = ACTIONS(2503),
    [anon_sym_debugger] = ACTIONS(2503),
    [anon_sym_return] = ACTIONS(2503),
    [anon_sym_throw] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2501),
    [anon_sym_case] = ACTIONS(2503),
    [anon_sym_yield] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2501),
    [anon_sym_RBRACK] = ACTIONS(2501),
    [anon_sym_LT] = ACTIONS(2501),
    [anon_sym_GT] = ACTIONS(2501),
    [anon_sym_SLASH] = ACTIONS(2503),
    [anon_sym_class] = ACTIONS(2503),
    [anon_sym_async] = ACTIONS(2503),
    [anon_sym_function] = ACTIONS(2503),
    [anon_sym_EQ_GT] = ACTIONS(2501),
    [anon_sym_new] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2501),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_PLUS] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2501),
    [anon_sym_TILDE] = ACTIONS(2501),
    [anon_sym_void] = ACTIONS(2503),
    [anon_sym_delete] = ACTIONS(2503),
    [anon_sym_PLUS_PLUS] = ACTIONS(2501),
    [anon_sym_DASH_DASH] = ACTIONS(2501),
    [anon_sym_DQUOTE] = ACTIONS(2501),
    [anon_sym_SQUOTE] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2501),
    [sym_number] = ACTIONS(2501),
    [sym_this] = ACTIONS(2503),
    [sym_super] = ACTIONS(2503),
    [sym_true] = ACTIONS(2503),
    [sym_false] = ACTIONS(2503),
    [sym_null] = ACTIONS(2503),
    [sym_undefined] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2501),
    [anon_sym_static] = ACTIONS(2503),
    [anon_sym_abstract] = ACTIONS(2503),
    [anon_sym_get] = ACTIONS(2503),
    [anon_sym_set] = ACTIONS(2503),
    [anon_sym_declare] = ACTIONS(2503),
    [anon_sym_public] = ACTIONS(2503),
    [anon_sym_private] = ACTIONS(2503),
    [anon_sym_protected] = ACTIONS(2503),
    [anon_sym_module] = ACTIONS(2503),
    [anon_sym_any] = ACTIONS(2503),
    [anon_sym_number] = ACTIONS(2503),
    [anon_sym_boolean] = ACTIONS(2503),
    [anon_sym_string] = ACTIONS(2503),
    [anon_sym_symbol] = ACTIONS(2503),
    [anon_sym_interface] = ACTIONS(2503),
    [anon_sym_enum] = ACTIONS(2503),
    [sym_readonly] = ACTIONS(2503),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2505),
    [anon_sym_COMMA] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2507),
    [anon_sym_import] = ACTIONS(2507),
    [anon_sym_var] = ACTIONS(2507),
    [anon_sym_let] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_await] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_with] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_debugger] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2505),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2505),
    [anon_sym_RBRACK] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_GT] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_function] = ACTIONS(2507),
    [anon_sym_EQ_GT] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2505),
    [anon_sym_PIPE] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_BANG] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2505),
    [anon_sym_void] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_PLUS_PLUS] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2505),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [sym_number] = ACTIONS(2505),
    [sym_this] = ACTIONS(2507),
    [sym_super] = ACTIONS(2507),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [sym_null] = ACTIONS(2507),
    [sym_undefined] = ACTIONS(2507),
    [anon_sym_AT] = ACTIONS(2505),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_abstract] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2507),
    [anon_sym_private] = ACTIONS(2507),
    [anon_sym_protected] = ACTIONS(2507),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [anon_sym_interface] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(2507),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2509),
    [sym_identifier] = ACTIONS(2511),
    [anon_sym_export] = ACTIONS(2511),
    [anon_sym_default] = ACTIONS(2511),
    [anon_sym_EQ] = ACTIONS(2511),
    [anon_sym_namespace] = ACTIONS(2511),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_RBRACE] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2511),
    [anon_sym_typeof] = ACTIONS(2511),
    [anon_sym_import] = ACTIONS(2511),
    [anon_sym_var] = ACTIONS(2511),
    [anon_sym_let] = ACTIONS(2511),
    [anon_sym_const] = ACTIONS(2511),
    [anon_sym_if] = ACTIONS(2511),
    [anon_sym_else] = ACTIONS(2511),
    [anon_sym_switch] = ACTIONS(2511),
    [anon_sym_for] = ACTIONS(2511),
    [anon_sym_LPAREN] = ACTIONS(2509),
    [anon_sym_RPAREN] = ACTIONS(2509),
    [anon_sym_await] = ACTIONS(2511),
    [anon_sym_while] = ACTIONS(2511),
    [anon_sym_do] = ACTIONS(2511),
    [anon_sym_try] = ACTIONS(2511),
    [anon_sym_with] = ACTIONS(2511),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_continue] = ACTIONS(2511),
    [anon_sym_debugger] = ACTIONS(2511),
    [anon_sym_return] = ACTIONS(2511),
    [anon_sym_throw] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(2509),
    [anon_sym_case] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2511),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(2509),
    [anon_sym_GT] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2511),
    [anon_sym_class] = ACTIONS(2511),
    [anon_sym_async] = ACTIONS(2511),
    [anon_sym_function] = ACTIONS(2511),
    [anon_sym_EQ_GT] = ACTIONS(2509),
    [anon_sym_new] = ACTIONS(2511),
    [anon_sym_AMP] = ACTIONS(2509),
    [anon_sym_PIPE] = ACTIONS(2509),
    [anon_sym_PLUS] = ACTIONS(2511),
    [anon_sym_DASH] = ACTIONS(2511),
    [anon_sym_BANG] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_void] = ACTIONS(2511),
    [anon_sym_delete] = ACTIONS(2511),
    [anon_sym_PLUS_PLUS] = ACTIONS(2509),
    [anon_sym_DASH_DASH] = ACTIONS(2509),
    [anon_sym_DQUOTE] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2509),
    [sym_number] = ACTIONS(2509),
    [sym_this] = ACTIONS(2511),
    [sym_super] = ACTIONS(2511),
    [sym_true] = ACTIONS(2511),
    [sym_false] = ACTIONS(2511),
    [sym_null] = ACTIONS(2511),
    [sym_undefined] = ACTIONS(2511),
    [anon_sym_AT] = ACTIONS(2509),
    [anon_sym_static] = ACTIONS(2511),
    [anon_sym_abstract] = ACTIONS(2511),
    [anon_sym_get] = ACTIONS(2511),
    [anon_sym_set] = ACTIONS(2511),
    [anon_sym_declare] = ACTIONS(2511),
    [anon_sym_public] = ACTIONS(2511),
    [anon_sym_private] = ACTIONS(2511),
    [anon_sym_protected] = ACTIONS(2511),
    [anon_sym_module] = ACTIONS(2511),
    [anon_sym_any] = ACTIONS(2511),
    [anon_sym_number] = ACTIONS(2511),
    [anon_sym_boolean] = ACTIONS(2511),
    [anon_sym_string] = ACTIONS(2511),
    [anon_sym_symbol] = ACTIONS(2511),
    [anon_sym_interface] = ACTIONS(2511),
    [anon_sym_enum] = ACTIONS(2511),
    [sym_readonly] = ACTIONS(2511),
  },
  [449] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2519),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [450] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [451] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [452] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [453] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [454] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2519),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [455] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [456] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2517),
    [anon_sym_set] = ACTIONS(2517),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2519),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [457] = {
    [sym_string] = STATE(2039),
    [sym__property_name] = STATE(2039),
    [sym_computed_property_name] = STATE(2039),
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2513),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2513),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2389),
    [anon_sym_static] = ACTIONS(2513),
    [anon_sym_get] = ACTIONS(2513),
    [anon_sym_set] = ACTIONS(2513),
    [anon_sym_declare] = ACTIONS(2513),
    [anon_sym_public] = ACTIONS(2513),
    [anon_sym_private] = ACTIONS(2513),
    [anon_sym_protected] = ACTIONS(2513),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_any] = ACTIONS(2513),
    [anon_sym_number] = ACTIONS(2513),
    [anon_sym_boolean] = ACTIONS(2513),
    [anon_sym_string] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2513),
    [sym_readonly] = ACTIONS(2513),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [458] = {
    [sym_type_arguments] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(2521),
    [sym_identifier] = ACTIONS(2523),
    [anon_sym_export] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2521),
    [anon_sym_RBRACE] = ACTIONS(2521),
    [anon_sym_type] = ACTIONS(2523),
    [anon_sym_typeof] = ACTIONS(2523),
    [anon_sym_import] = ACTIONS(2523),
    [anon_sym_var] = ACTIONS(2523),
    [anon_sym_let] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(2523),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_await] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_with] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_debugger] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2521),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_yield] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2521),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_SLASH] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(2401),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_async] = ACTIONS(2523),
    [anon_sym_function] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2521),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [anon_sym_void] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_PLUS_PLUS] = ACTIONS(2521),
    [anon_sym_DASH_DASH] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2521),
    [anon_sym_SQUOTE] = ACTIONS(2521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2521),
    [sym_number] = ACTIONS(2521),
    [sym_this] = ACTIONS(2523),
    [sym_super] = ACTIONS(2523),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [sym_null] = ACTIONS(2523),
    [sym_undefined] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2521),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_abstract] = ACTIONS(2523),
    [anon_sym_get] = ACTIONS(2523),
    [anon_sym_set] = ACTIONS(2523),
    [anon_sym_declare] = ACTIONS(2523),
    [anon_sym_public] = ACTIONS(2523),
    [anon_sym_private] = ACTIONS(2523),
    [anon_sym_protected] = ACTIONS(2523),
    [anon_sym_module] = ACTIONS(2523),
    [anon_sym_any] = ACTIONS(2523),
    [anon_sym_number] = ACTIONS(2523),
    [anon_sym_boolean] = ACTIONS(2523),
    [anon_sym_string] = ACTIONS(2523),
    [anon_sym_symbol] = ACTIONS(2523),
    [anon_sym_interface] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [sym_readonly] = ACTIONS(2523),
    [anon_sym_is] = ACTIONS(2528),
  },
  [459] = {
    [sym_catch_clause] = STATE(488),
    [sym_finally_clause] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(2530),
    [sym_identifier] = ACTIONS(2532),
    [anon_sym_export] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_import] = ACTIONS(2532),
    [anon_sym_var] = ACTIONS(2532),
    [anon_sym_let] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_else] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_await] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_with] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_debugger] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_catch] = ACTIONS(2534),
    [anon_sym_finally] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [anon_sym_LT] = ACTIONS(2530),
    [anon_sym_SLASH] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_async] = ACTIONS(2532),
    [anon_sym_function] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_void] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2530),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2532),
    [sym_super] = ACTIONS(2532),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [sym_null] = ACTIONS(2532),
    [sym_undefined] = ACTIONS(2532),
    [anon_sym_AT] = ACTIONS(2530),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_abstract] = ACTIONS(2532),
    [anon_sym_get] = ACTIONS(2532),
    [anon_sym_set] = ACTIONS(2532),
    [anon_sym_declare] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_module] = ACTIONS(2532),
    [anon_sym_any] = ACTIONS(2532),
    [anon_sym_number] = ACTIONS(2532),
    [anon_sym_boolean] = ACTIONS(2532),
    [anon_sym_string] = ACTIONS(2532),
    [anon_sym_symbol] = ACTIONS(2532),
    [anon_sym_interface] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [sym_readonly] = ACTIONS(2532),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_var] = ACTIONS(1072),
    [anon_sym_let] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_debugger] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_throw] = ACTIONS(1072),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_catch] = ACTIONS(1072),
    [anon_sym_finally] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_function] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_void] = ACTIONS(1072),
    [anon_sym_delete] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [sym_number] = ACTIONS(1070),
    [sym_this] = ACTIONS(1072),
    [sym_super] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_undefined] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_abstract] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_interface] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [sym_readonly] = ACTIONS(1072),
    [sym__automatic_semicolon] = ACTIONS(1078),
  },
  [461] = {
    [sym__call_signature] = STATE(2802),
    [sym_arguments] = STATE(1107),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [sym_readonly] = ACTIONS(2540),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_catch] = ACTIONS(1104),
    [anon_sym_finally] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
    [sym__automatic_semicolon] = ACTIONS(2546),
  },
  [463] = {
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [sym_readonly] = ACTIONS(2548),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [464] = {
    [sym_object] = STATE(2137),
    [sym_array] = STATE(2138),
    [sym_nested_identifier] = STATE(2792),
    [sym_string] = STATE(444),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2791),
    [sym_rest_parameter] = STATE(2458),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2523),
    [sym_constructor_type] = STATE(2523),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2761),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2523),
    [sym_intersection_type] = STATE(2523),
    [sym_function_type] = STATE(2523),
    [aux_sym_export_statement_repeat1] = STATE(1709),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2574),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(2582),
  },
  [466] = {
    [sym_object] = STATE(2137),
    [sym_array] = STATE(2138),
    [sym_nested_identifier] = STATE(2792),
    [sym_string] = STATE(444),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2791),
    [sym_rest_parameter] = STATE(2458),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2418),
    [sym_constructor_type] = STATE(2418),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2761),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2418),
    [sym_intersection_type] = STATE(2418),
    [sym_function_type] = STATE(2418),
    [aux_sym_export_statement_repeat1] = STATE(1709),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2574),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [467] = {
    [sym_type_arguments] = STATE(422),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_default] = ACTIONS(2586),
    [anon_sym_namespace] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_type] = ACTIONS(2586),
    [anon_sym_typeof] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_var] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_switch] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_await] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_with] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_continue] = ACTIONS(2586),
    [anon_sym_debugger] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_throw] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_async] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2584),
    [anon_sym_void] = ACTIONS(2586),
    [anon_sym_delete] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2584),
    [sym_this] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_null] = ACTIONS(2586),
    [sym_undefined] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_get] = ACTIONS(2586),
    [anon_sym_set] = ACTIONS(2586),
    [anon_sym_declare] = ACTIONS(2586),
    [anon_sym_public] = ACTIONS(2586),
    [anon_sym_private] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_any] = ACTIONS(2586),
    [anon_sym_number] = ACTIONS(2586),
    [anon_sym_boolean] = ACTIONS(2586),
    [anon_sym_string] = ACTIONS(2586),
    [anon_sym_symbol] = ACTIONS(2586),
    [anon_sym_interface] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2586),
    [sym_readonly] = ACTIONS(2586),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1102),
  },
  [469] = {
    [sym_object] = STATE(2137),
    [sym_array] = STATE(2138),
    [sym_nested_identifier] = STATE(2792),
    [sym_string] = STATE(444),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2791),
    [sym_rest_parameter] = STATE(2458),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2415),
    [sym_constructor_type] = STATE(2415),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2761),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2415),
    [sym_intersection_type] = STATE(2415),
    [sym_function_type] = STATE(2415),
    [aux_sym_export_statement_repeat1] = STATE(1709),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2574),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [470] = {
    [sym_object] = STATE(2137),
    [sym_array] = STATE(2138),
    [sym_nested_identifier] = STATE(2792),
    [sym_string] = STATE(444),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2791),
    [sym_rest_parameter] = STATE(2458),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2575),
    [sym_constructor_type] = STATE(2575),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2761),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2575),
    [sym_intersection_type] = STATE(2575),
    [sym_function_type] = STATE(2575),
    [aux_sym_export_statement_repeat1] = STATE(1709),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2574),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [471] = {
    [aux_sym_object_repeat1] = STATE(2405),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [sym_readonly] = ACTIONS(2548),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [472] = {
    [aux_sym_object_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [sym_readonly] = ACTIONS(2548),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_export] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_namespace] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_var] = ACTIONS(1072),
    [anon_sym_let] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_debugger] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_throw] = ACTIONS(1072),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_SLASH] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_function] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_void] = ACTIONS(1072),
    [anon_sym_delete] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [sym_number] = ACTIONS(1070),
    [sym_this] = ACTIONS(1072),
    [sym_super] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_undefined] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_abstract] = ACTIONS(1072),
    [anon_sym_get] = ACTIONS(1072),
    [anon_sym_set] = ACTIONS(1072),
    [anon_sym_declare] = ACTIONS(1072),
    [anon_sym_public] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym_protected] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_interface] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [sym_readonly] = ACTIONS(1072),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1070),
    [sym__automatic_semicolon] = ACTIONS(2591),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_export] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1104),
    [anon_sym_typeof] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [anon_sym_let] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_with] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_debugger] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_catch] = ACTIONS(1104),
    [anon_sym_finally] = ACTIONS(1104),
    [anon_sym_yield] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_void] = ACTIONS(1104),
    [anon_sym_delete] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [sym_number] = ACTIONS(1102),
    [sym_this] = ACTIONS(1104),
    [sym_super] = ACTIONS(1104),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_undefined] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1104),
    [anon_sym_set] = ACTIONS(1104),
    [anon_sym_declare] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_protected] = ACTIONS(1104),
    [anon_sym_module] = ACTIONS(1104),
    [anon_sym_any] = ACTIONS(1104),
    [anon_sym_number] = ACTIONS(1104),
    [anon_sym_boolean] = ACTIONS(1104),
    [anon_sym_string] = ACTIONS(1104),
    [anon_sym_symbol] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [sym_readonly] = ACTIONS(1104),
  },
  [475] = {
    [sym_object] = STATE(2137),
    [sym_array] = STATE(2138),
    [sym_nested_identifier] = STATE(2792),
    [sym_string] = STATE(444),
    [sym_decorator] = STATE(1810),
    [sym_formal_parameters] = STATE(2791),
    [sym_rest_parameter] = STATE(2458),
    [sym_nested_type_identifier] = STATE(1816),
    [sym_accessibility_modifier] = STATE(1811),
    [sym_required_parameter] = STATE(2458),
    [sym_optional_parameter] = STATE(2458),
    [sym__parameter_name] = STATE(2003),
    [sym__type] = STATE(2422),
    [sym_constructor_type] = STATE(2422),
    [sym__primary_type] = STATE(431),
    [sym_generic_type] = STATE(431),
    [sym_type_predicate] = STATE(431),
    [sym_type_query] = STATE(431),
    [sym_index_type_query] = STATE(431),
    [sym_lookup_type] = STATE(431),
    [sym_literal_type] = STATE(431),
    [sym__number] = STATE(444),
    [sym_existential_type] = STATE(431),
    [sym_flow_maybe_type] = STATE(431),
    [sym_parenthesized_type] = STATE(431),
    [sym_predefined_type] = STATE(431),
    [sym_object_type] = STATE(431),
    [sym_type_parameters] = STATE(2761),
    [sym_array_type] = STATE(431),
    [sym_tuple_type] = STATE(431),
    [sym_union_type] = STATE(2422),
    [sym_intersection_type] = STATE(2422),
    [sym_function_type] = STATE(2422),
    [aux_sym_export_statement_repeat1] = STATE(1709),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2385),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2574),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [sym_readonly] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(816),
  },
  [476] = {
    [sym__call_signature] = STATE(2802),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [sym_readonly] = ACTIONS(2540),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_export] = ACTIONS(1168),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_COMMA] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_const] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_await] = ACTIONS(1168),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_debugger] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_yield] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_async] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_void] = ACTIONS(1168),
    [anon_sym_delete] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [sym_number] = ACTIONS(1166),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(1168),
    [sym_true] = ACTIONS(1168),
    [sym_false] = ACTIONS(1168),
    [sym_null] = ACTIONS(1168),
    [sym_undefined] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1166),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_get] = ACTIONS(1168),
    [anon_sym_set] = ACTIONS(1168),
    [anon_sym_declare] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_protected] = ACTIONS(1168),
    [anon_sym_module] = ACTIONS(1168),
    [anon_sym_any] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_boolean] = ACTIONS(1168),
    [anon_sym_string] = ACTIONS(1168),
    [anon_sym_symbol] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [sym_readonly] = ACTIONS(1168),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1166),
    [sym__automatic_semicolon] = ACTIONS(1166),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_export] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_namespace] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1160),
    [anon_sym_typeof] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [anon_sym_let] = ACTIONS(1160),
    [anon_sym_const] = ACTIONS(1160),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_await] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_with] = ACTIONS(1160),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_debugger] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_catch] = ACTIONS(1160),
    [anon_sym_finally] = ACTIONS(1160),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1158),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_async] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1160),
    [anon_sym_delete] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1158),
    [sym_this] = ACTIONS(1160),
    [sym_super] = ACTIONS(1160),
    [sym_true] = ACTIONS(1160),
    [sym_false] = ACTIONS(1160),
    [sym_null] = ACTIONS(1160),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_get] = ACTIONS(1160),
    [anon_sym_set] = ACTIONS(1160),
    [anon_sym_declare] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_protected] = ACTIONS(1160),
    [anon_sym_module] = ACTIONS(1160),
    [anon_sym_any] = ACTIONS(1160),
    [anon_sym_number] = ACTIONS(1160),
    [anon_sym_boolean] = ACTIONS(1160),
    [anon_sym_string] = ACTIONS(1160),
    [anon_sym_symbol] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [sym_readonly] = ACTIONS(1160),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_export] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_namespace] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_COMMA] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1160),
    [anon_sym_typeof] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [anon_sym_let] = ACTIONS(1160),
    [anon_sym_const] = ACTIONS(1160),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_await] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_with] = ACTIONS(1160),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_debugger] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_yield] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1158),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_async] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1160),
    [anon_sym_delete] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1158),
    [sym_this] = ACTIONS(1160),
    [sym_super] = ACTIONS(1160),
    [sym_true] = ACTIONS(1160),
    [sym_false] = ACTIONS(1160),
    [sym_null] = ACTIONS(1160),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_get] = ACTIONS(1160),
    [anon_sym_set] = ACTIONS(1160),
    [anon_sym_declare] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_protected] = ACTIONS(1160),
    [anon_sym_module] = ACTIONS(1160),
    [anon_sym_any] = ACTIONS(1160),
    [anon_sym_number] = ACTIONS(1160),
    [anon_sym_boolean] = ACTIONS(1160),
    [anon_sym_string] = ACTIONS(1160),
    [anon_sym_symbol] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [sym_readonly] = ACTIONS(1160),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1158),
    [sym__automatic_semicolon] = ACTIONS(1158),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_identifier] = ACTIONS(1110),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_default] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_COMMA] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_typeof] = ACTIONS(1110),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_const] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_await] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_debugger] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_throw] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_async] = ACTIONS(1110),
    [anon_sym_function] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1110),
    [anon_sym_delete] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [sym_number] = ACTIONS(1108),
    [sym_this] = ACTIONS(1110),
    [sym_super] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_null] = ACTIONS(1110),
    [sym_undefined] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_abstract] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_interface] = ACTIONS(1110),
    [anon_sym_enum] = ACTIONS(1110),
    [sym_readonly] = ACTIONS(1110),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1108),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [481] = {
    [sym__call_signature] = STATE(2808),
    [sym_arguments] = STATE(1402),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2599),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2603),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [sym_readonly] = ACTIONS(2601),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [482] = {
    [sym__call_signature] = STATE(2808),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2599),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2603),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [sym_readonly] = ACTIONS(2601),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(2605),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2607),
    [anon_sym_default] = ACTIONS(2607),
    [anon_sym_namespace] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2607),
    [anon_sym_import] = ACTIONS(2607),
    [anon_sym_var] = ACTIONS(2607),
    [anon_sym_let] = ACTIONS(2607),
    [anon_sym_const] = ACTIONS(2607),
    [anon_sym_if] = ACTIONS(2607),
    [anon_sym_else] = ACTIONS(2607),
    [anon_sym_switch] = ACTIONS(2607),
    [anon_sym_for] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_await] = ACTIONS(2607),
    [anon_sym_while] = ACTIONS(2607),
    [anon_sym_do] = ACTIONS(2607),
    [anon_sym_try] = ACTIONS(2607),
    [anon_sym_with] = ACTIONS(2607),
    [anon_sym_break] = ACTIONS(2607),
    [anon_sym_continue] = ACTIONS(2607),
    [anon_sym_debugger] = ACTIONS(2607),
    [anon_sym_return] = ACTIONS(2607),
    [anon_sym_throw] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2607),
    [anon_sym_yield] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_class] = ACTIONS(2607),
    [anon_sym_async] = ACTIONS(2607),
    [anon_sym_function] = ACTIONS(2607),
    [anon_sym_new] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2605),
    [anon_sym_TILDE] = ACTIONS(2605),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_delete] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(2605),
    [anon_sym_SQUOTE] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [sym_number] = ACTIONS(2605),
    [sym_this] = ACTIONS(2607),
    [sym_super] = ACTIONS(2607),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_AT] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2607),
    [anon_sym_get] = ACTIONS(2607),
    [anon_sym_set] = ACTIONS(2607),
    [anon_sym_declare] = ACTIONS(2607),
    [anon_sym_public] = ACTIONS(2607),
    [anon_sym_private] = ACTIONS(2607),
    [anon_sym_protected] = ACTIONS(2607),
    [anon_sym_module] = ACTIONS(2607),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_interface] = ACTIONS(2607),
    [anon_sym_enum] = ACTIONS(2607),
    [sym_readonly] = ACTIONS(2607),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(2613),
    [sym_identifier] = ACTIONS(2615),
    [anon_sym_export] = ACTIONS(2615),
    [anon_sym_default] = ACTIONS(2615),
    [anon_sym_namespace] = ACTIONS(2615),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_type] = ACTIONS(2615),
    [anon_sym_typeof] = ACTIONS(2615),
    [anon_sym_import] = ACTIONS(2615),
    [anon_sym_var] = ACTIONS(2615),
    [anon_sym_let] = ACTIONS(2615),
    [anon_sym_const] = ACTIONS(2615),
    [anon_sym_if] = ACTIONS(2615),
    [anon_sym_else] = ACTIONS(2615),
    [anon_sym_switch] = ACTIONS(2615),
    [anon_sym_for] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(2613),
    [anon_sym_await] = ACTIONS(2615),
    [anon_sym_while] = ACTIONS(2615),
    [anon_sym_do] = ACTIONS(2615),
    [anon_sym_try] = ACTIONS(2615),
    [anon_sym_with] = ACTIONS(2615),
    [anon_sym_break] = ACTIONS(2615),
    [anon_sym_continue] = ACTIONS(2615),
    [anon_sym_debugger] = ACTIONS(2615),
    [anon_sym_return] = ACTIONS(2615),
    [anon_sym_throw] = ACTIONS(2615),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_class] = ACTIONS(2615),
    [anon_sym_async] = ACTIONS(2615),
    [anon_sym_function] = ACTIONS(2615),
    [anon_sym_new] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_void] = ACTIONS(2615),
    [anon_sym_delete] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2613),
    [anon_sym_DQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2613),
    [sym_number] = ACTIONS(2613),
    [sym_this] = ACTIONS(2615),
    [sym_super] = ACTIONS(2615),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_AT] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2615),
    [anon_sym_abstract] = ACTIONS(2615),
    [anon_sym_get] = ACTIONS(2615),
    [anon_sym_set] = ACTIONS(2615),
    [anon_sym_declare] = ACTIONS(2615),
    [anon_sym_public] = ACTIONS(2615),
    [anon_sym_private] = ACTIONS(2615),
    [anon_sym_protected] = ACTIONS(2615),
    [anon_sym_module] = ACTIONS(2615),
    [anon_sym_any] = ACTIONS(2615),
    [anon_sym_number] = ACTIONS(2615),
    [anon_sym_boolean] = ACTIONS(2615),
    [anon_sym_string] = ACTIONS(2615),
    [anon_sym_symbol] = ACTIONS(2615),
    [anon_sym_interface] = ACTIONS(2615),
    [anon_sym_enum] = ACTIONS(2615),
    [sym_readonly] = ACTIONS(2615),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2617),
    [anon_sym_RBRACE] = ACTIONS(2617),
    [anon_sym_type] = ACTIONS(2619),
    [anon_sym_typeof] = ACTIONS(2619),
    [anon_sym_import] = ACTIONS(2619),
    [anon_sym_var] = ACTIONS(2619),
    [anon_sym_let] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2617),
    [anon_sym_await] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_with] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_debugger] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_yield] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_SLASH] = ACTIONS(2619),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_async] = ACTIONS(2619),
    [anon_sym_function] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2617),
    [anon_sym_TILDE] = ACTIONS(2617),
    [anon_sym_void] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2617),
    [anon_sym_DQUOTE] = ACTIONS(2617),
    [anon_sym_SQUOTE] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2617),
    [sym_number] = ACTIONS(2617),
    [sym_this] = ACTIONS(2619),
    [sym_super] = ACTIONS(2619),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [sym_null] = ACTIONS(2619),
    [sym_undefined] = ACTIONS(2619),
    [anon_sym_AT] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_abstract] = ACTIONS(2619),
    [anon_sym_get] = ACTIONS(2619),
    [anon_sym_set] = ACTIONS(2619),
    [anon_sym_declare] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_module] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2619),
    [anon_sym_number] = ACTIONS(2619),
    [anon_sym_boolean] = ACTIONS(2619),
    [anon_sym_string] = ACTIONS(2619),
    [anon_sym_symbol] = ACTIONS(2619),
    [anon_sym_interface] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [sym_readonly] = ACTIONS(2619),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2621),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_export] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_type] = ACTIONS(2623),
    [anon_sym_typeof] = ACTIONS(2623),
    [anon_sym_import] = ACTIONS(2623),
    [anon_sym_var] = ACTIONS(2623),
    [anon_sym_let] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(2623),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_with] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_debugger] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_yield] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_LT] = ACTIONS(2621),
    [anon_sym_SLASH] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_async] = ACTIONS(2623),
    [anon_sym_function] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_void] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2621),
    [sym_number] = ACTIONS(2621),
    [sym_this] = ACTIONS(2623),
    [sym_super] = ACTIONS(2623),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [sym_null] = ACTIONS(2623),
    [sym_undefined] = ACTIONS(2623),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_abstract] = ACTIONS(2623),
    [anon_sym_get] = ACTIONS(2623),
    [anon_sym_set] = ACTIONS(2623),
    [anon_sym_declare] = ACTIONS(2623),
    [anon_sym_public] = ACTIONS(2623),
    [anon_sym_private] = ACTIONS(2623),
    [anon_sym_protected] = ACTIONS(2623),
    [anon_sym_module] = ACTIONS(2623),
    [anon_sym_any] = ACTIONS(2623),
    [anon_sym_number] = ACTIONS(2623),
    [anon_sym_boolean] = ACTIONS(2623),
    [anon_sym_string] = ACTIONS(2623),
    [anon_sym_symbol] = ACTIONS(2623),
    [anon_sym_interface] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [sym_readonly] = ACTIONS(2623),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(2625),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_export] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_namespace] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_type] = ACTIONS(2627),
    [anon_sym_typeof] = ACTIONS(2627),
    [anon_sym_import] = ACTIONS(2627),
    [anon_sym_var] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_await] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_with] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_debugger] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_LT] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2627),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_async] = ACTIONS(2627),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_void] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2625),
    [sym_number] = ACTIONS(2625),
    [sym_this] = ACTIONS(2627),
    [sym_super] = ACTIONS(2627),
    [sym_true] = ACTIONS(2627),
    [sym_false] = ACTIONS(2627),
    [sym_null] = ACTIONS(2627),
    [sym_undefined] = ACTIONS(2627),
    [anon_sym_AT] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_abstract] = ACTIONS(2627),
    [anon_sym_get] = ACTIONS(2627),
    [anon_sym_set] = ACTIONS(2627),
    [anon_sym_declare] = ACTIONS(2627),
    [anon_sym_public] = ACTIONS(2627),
    [anon_sym_private] = ACTIONS(2627),
    [anon_sym_protected] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2627),
    [anon_sym_any] = ACTIONS(2627),
    [anon_sym_number] = ACTIONS(2627),
    [anon_sym_boolean] = ACTIONS(2627),
    [anon_sym_string] = ACTIONS(2627),
    [anon_sym_symbol] = ACTIONS(2627),
    [anon_sym_interface] = ACTIONS(2627),
    [anon_sym_enum] = ACTIONS(2627),
    [sym_readonly] = ACTIONS(2627),
  },
  [488] = {
    [sym_finally_clause] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(2629),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_export] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_type] = ACTIONS(2631),
    [anon_sym_typeof] = ACTIONS(2631),
    [anon_sym_import] = ACTIONS(2631),
    [anon_sym_var] = ACTIONS(2631),
    [anon_sym_let] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_await] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_with] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_debugger] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_finally] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_async] = ACTIONS(2631),
    [anon_sym_function] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_void] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2629),
    [sym_number] = ACTIONS(2629),
    [sym_this] = ACTIONS(2631),
    [sym_super] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_null] = ACTIONS(2631),
    [sym_undefined] = ACTIONS(2631),
    [anon_sym_AT] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_abstract] = ACTIONS(2631),
    [anon_sym_get] = ACTIONS(2631),
    [anon_sym_set] = ACTIONS(2631),
    [anon_sym_declare] = ACTIONS(2631),
    [anon_sym_public] = ACTIONS(2631),
    [anon_sym_private] = ACTIONS(2631),
    [anon_sym_protected] = ACTIONS(2631),
    [anon_sym_module] = ACTIONS(2631),
    [anon_sym_any] = ACTIONS(2631),
    [anon_sym_number] = ACTIONS(2631),
    [anon_sym_boolean] = ACTIONS(2631),
    [anon_sym_string] = ACTIONS(2631),
    [anon_sym_symbol] = ACTIONS(2631),
    [anon_sym_interface] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [sym_readonly] = ACTIONS(2631),
  },
  [489] = {
    [sym__call_signature] = STATE(2838),
    [sym_arguments] = STATE(1528),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_export] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2637),
    [anon_sym_async] = ACTIONS(2635),
    [anon_sym_function] = ACTIONS(2639),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_get] = ACTIONS(2635),
    [anon_sym_set] = ACTIONS(2635),
    [anon_sym_declare] = ACTIONS(2635),
    [anon_sym_public] = ACTIONS(2635),
    [anon_sym_private] = ACTIONS(2635),
    [anon_sym_protected] = ACTIONS(2635),
    [anon_sym_module] = ACTIONS(2635),
    [anon_sym_any] = ACTIONS(2635),
    [anon_sym_number] = ACTIONS(2635),
    [anon_sym_boolean] = ACTIONS(2635),
    [anon_sym_string] = ACTIONS(2635),
    [anon_sym_symbol] = ACTIONS(2635),
    [sym_readonly] = ACTIONS(2635),
    [anon_sym_LBRACE_PIPE] = ACTIONS(501),
  },
  [490] = {
    [sym__call_signature] = STATE(2808),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2599),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(597),
    [anon_sym_of] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2603),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [sym_readonly] = ACTIONS(2601),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(2641),
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_export] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_type] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2643),
    [anon_sym_import] = ACTIONS(2643),
    [anon_sym_var] = ACTIONS(2643),
    [anon_sym_let] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_LPAREN] = ACTIONS(2641),
    [anon_sym_await] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_with] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_debugger] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_SLASH] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_async] = ACTIONS(2643),
    [anon_sym_function] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_void] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2641),
    [sym_number] = ACTIONS(2641),
    [sym_this] = ACTIONS(2643),
    [sym_super] = ACTIONS(2643),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [sym_null] = ACTIONS(2643),
    [sym_undefined] = ACTIONS(2643),
    [anon_sym_AT] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_abstract] = ACTIONS(2643),
    [anon_sym_get] = ACTIONS(2643),
    [anon_sym_set] = ACTIONS(2643),
    [anon_sym_declare] = ACTIONS(2643),
    [anon_sym_public] = ACTIONS(2643),
    [anon_sym_private] = ACTIONS(2643),
    [anon_sym_protected] = ACTIONS(2643),
    [anon_sym_module] = ACTIONS(2643),
    [anon_sym_any] = ACTIONS(2643),
    [anon_sym_number] = ACTIONS(2643),
    [anon_sym_boolean] = ACTIONS(2643),
    [anon_sym_string] = ACTIONS(2643),
    [anon_sym_symbol] = ACTIONS(2643),
    [anon_sym_interface] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [sym_readonly] = ACTIONS(2643),
  },
  [492] = {
    [sym__call_signature] = STATE(2808),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2599),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [sym_readonly] = ACTIONS(2601),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [493] = {
    [sym__call_signature] = STATE(2813),
    [sym_arguments] = STATE(1107),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_export] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(613),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_get] = ACTIONS(2647),
    [anon_sym_set] = ACTIONS(2647),
    [anon_sym_declare] = ACTIONS(2647),
    [anon_sym_public] = ACTIONS(2647),
    [anon_sym_private] = ACTIONS(2647),
    [anon_sym_protected] = ACTIONS(2647),
    [anon_sym_module] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_implements] = ACTIONS(493),
    [sym_readonly] = ACTIONS(2647),
  },
  [494] = {
    [sym_statement_block] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_DOT] = ACTIONS(2419),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_number] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_undefined] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
  },
  [495] = {
    [sym__call_signature] = STATE(2808),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2599),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2651),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [sym_readonly] = ACTIONS(2601),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1204),
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_export] = ACTIONS(1206),
    [anon_sym_default] = ACTIONS(1206),
    [anon_sym_namespace] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_RBRACE] = ACTIONS(1204),
    [anon_sym_type] = ACTIONS(1206),
    [anon_sym_typeof] = ACTIONS(1206),
    [anon_sym_import] = ACTIONS(1206),
    [anon_sym_var] = ACTIONS(1206),
    [anon_sym_let] = ACTIONS(1206),
    [anon_sym_const] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_else] = ACTIONS(1206),
    [anon_sym_switch] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1204),
    [anon_sym_await] = ACTIONS(1206),
    [anon_sym_while] = ACTIONS(1206),
    [anon_sym_do] = ACTIONS(1206),
    [anon_sym_try] = ACTIONS(1206),
    [anon_sym_with] = ACTIONS(1206),
    [anon_sym_break] = ACTIONS(1206),
    [anon_sym_continue] = ACTIONS(1206),
    [anon_sym_debugger] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1206),
    [anon_sym_throw] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_case] = ACTIONS(1206),
    [anon_sym_yield] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_SLASH] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(1206),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_function] = ACTIONS(1206),
    [anon_sym_new] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1206),
    [anon_sym_DASH] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_void] = ACTIONS(1206),
    [anon_sym_delete] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_SQUOTE] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [sym_number] = ACTIONS(1204),
    [sym_this] = ACTIONS(1206),
    [sym_super] = ACTIONS(1206),
    [sym_true] = ACTIONS(1206),
    [sym_false] = ACTIONS(1206),
    [sym_null] = ACTIONS(1206),
    [sym_undefined] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_static] = ACTIONS(1206),
    [anon_sym_abstract] = ACTIONS(1206),
    [anon_sym_get] = ACTIONS(1206),
    [anon_sym_set] = ACTIONS(1206),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_public] = ACTIONS(1206),
    [anon_sym_private] = ACTIONS(1206),
    [anon_sym_protected] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1206),
    [anon_sym_any] = ACTIONS(1206),
    [anon_sym_number] = ACTIONS(1206),
    [anon_sym_boolean] = ACTIONS(1206),
    [anon_sym_string] = ACTIONS(1206),
    [anon_sym_symbol] = ACTIONS(1206),
    [anon_sym_interface] = ACTIONS(1206),
    [anon_sym_enum] = ACTIONS(1206),
    [sym_readonly] = ACTIONS(1206),
    [sym__automatic_semicolon] = ACTIONS(1212),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1124),
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_export] = ACTIONS(1126),
    [anon_sym_default] = ACTIONS(1126),
    [anon_sym_namespace] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1124),
    [anon_sym_RBRACE] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1126),
    [anon_sym_typeof] = ACTIONS(1126),
    [anon_sym_import] = ACTIONS(1126),
    [anon_sym_var] = ACTIONS(1126),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_const] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1126),
    [anon_sym_else] = ACTIONS(1126),
    [anon_sym_switch] = ACTIONS(1126),
    [anon_sym_for] = ACTIONS(1126),
    [anon_sym_LPAREN] = ACTIONS(1124),
    [anon_sym_await] = ACTIONS(1126),
    [anon_sym_while] = ACTIONS(1126),
    [anon_sym_do] = ACTIONS(1126),
    [anon_sym_try] = ACTIONS(1126),
    [anon_sym_with] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_debugger] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_throw] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1126),
    [anon_sym_yield] = ACTIONS(1126),
    [anon_sym_LBRACK] = ACTIONS(1124),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_SLASH] = ACTIONS(1126),
    [anon_sym_class] = ACTIONS(1126),
    [anon_sym_async] = ACTIONS(1126),
    [anon_sym_function] = ACTIONS(1126),
    [anon_sym_new] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1124),
    [anon_sym_TILDE] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1126),
    [anon_sym_delete] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_SQUOTE] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1124),
    [sym_number] = ACTIONS(1124),
    [sym_this] = ACTIONS(1126),
    [sym_super] = ACTIONS(1126),
    [sym_true] = ACTIONS(1126),
    [sym_false] = ACTIONS(1126),
    [sym_null] = ACTIONS(1126),
    [sym_undefined] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1124),
    [anon_sym_static] = ACTIONS(1126),
    [anon_sym_abstract] = ACTIONS(1126),
    [anon_sym_get] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1126),
    [anon_sym_declare] = ACTIONS(1126),
    [anon_sym_public] = ACTIONS(1126),
    [anon_sym_private] = ACTIONS(1126),
    [anon_sym_protected] = ACTIONS(1126),
    [anon_sym_module] = ACTIONS(1126),
    [anon_sym_any] = ACTIONS(1126),
    [anon_sym_number] = ACTIONS(1126),
    [anon_sym_boolean] = ACTIONS(1126),
    [anon_sym_string] = ACTIONS(1126),
    [anon_sym_symbol] = ACTIONS(1126),
    [anon_sym_interface] = ACTIONS(1126),
    [anon_sym_enum] = ACTIONS(1126),
    [sym_readonly] = ACTIONS(1126),
    [sym__automatic_semicolon] = ACTIONS(1132),
  },
  [498] = {
    [sym_object] = STATE(2118),
    [sym_array] = STATE(2123),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2655),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_get] = ACTIONS(2655),
    [anon_sym_set] = ACTIONS(2655),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2655),
    [anon_sym_private] = ACTIONS(2655),
    [anon_sym_protected] = ACTIONS(2655),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [sym_readonly] = ACTIONS(2655),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1228),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_default] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_typeof] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_var] = ACTIONS(1230),
    [anon_sym_let] = ACTIONS(1230),
    [anon_sym_const] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(1230),
    [anon_sym_else] = ACTIONS(1230),
    [anon_sym_switch] = ACTIONS(1230),
    [anon_sym_for] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1228),
    [anon_sym_await] = ACTIONS(1230),
    [anon_sym_while] = ACTIONS(1230),
    [anon_sym_do] = ACTIONS(1230),
    [anon_sym_try] = ACTIONS(1230),
    [anon_sym_with] = ACTIONS(1230),
    [anon_sym_break] = ACTIONS(1230),
    [anon_sym_continue] = ACTIONS(1230),
    [anon_sym_debugger] = ACTIONS(1230),
    [anon_sym_return] = ACTIONS(1230),
    [anon_sym_throw] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1228),
    [anon_sym_case] = ACTIONS(1230),
    [anon_sym_yield] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_SLASH] = ACTIONS(1230),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_function] = ACTIONS(1230),
    [anon_sym_new] = ACTIONS(1230),
    [anon_sym_PLUS] = ACTIONS(1230),
    [anon_sym_DASH] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1228),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_delete] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1228),
    [anon_sym_DQUOTE] = ACTIONS(1228),
    [anon_sym_SQUOTE] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1228),
    [sym_number] = ACTIONS(1228),
    [sym_this] = ACTIONS(1230),
    [sym_super] = ACTIONS(1230),
    [sym_true] = ACTIONS(1230),
    [sym_false] = ACTIONS(1230),
    [sym_null] = ACTIONS(1230),
    [sym_undefined] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_static] = ACTIONS(1230),
    [anon_sym_abstract] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_interface] = ACTIONS(1230),
    [anon_sym_enum] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(1230),
    [sym__automatic_semicolon] = ACTIONS(1236),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1240),
    [anon_sym_default] = ACTIONS(1240),
    [anon_sym_namespace] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_type] = ACTIONS(1240),
    [anon_sym_typeof] = ACTIONS(1240),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [anon_sym_let] = ACTIONS(1240),
    [anon_sym_const] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1240),
    [anon_sym_switch] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_await] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_do] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_debugger] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_throw] = ACTIONS(1240),
    [anon_sym_SEMI] = ACTIONS(1238),
    [anon_sym_case] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1240),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_async] = ACTIONS(1240),
    [anon_sym_function] = ACTIONS(1240),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1240),
    [anon_sym_delete] = ACTIONS(1240),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1238),
    [sym_number] = ACTIONS(1238),
    [sym_this] = ACTIONS(1240),
    [sym_super] = ACTIONS(1240),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_null] = ACTIONS(1240),
    [sym_undefined] = ACTIONS(1240),
    [anon_sym_AT] = ACTIONS(1238),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_abstract] = ACTIONS(1240),
    [anon_sym_get] = ACTIONS(1240),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_declare] = ACTIONS(1240),
    [anon_sym_public] = ACTIONS(1240),
    [anon_sym_private] = ACTIONS(1240),
    [anon_sym_protected] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_any] = ACTIONS(1240),
    [anon_sym_number] = ACTIONS(1240),
    [anon_sym_boolean] = ACTIONS(1240),
    [anon_sym_string] = ACTIONS(1240),
    [anon_sym_symbol] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1240),
    [anon_sym_enum] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1240),
    [sym__automatic_semicolon] = ACTIONS(1246),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1216),
    [anon_sym_export] = ACTIONS(1216),
    [anon_sym_default] = ACTIONS(1216),
    [anon_sym_namespace] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1216),
    [anon_sym_typeof] = ACTIONS(1216),
    [anon_sym_import] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_const] = ACTIONS(1216),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1216),
    [anon_sym_switch] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_await] = ACTIONS(1216),
    [anon_sym_while] = ACTIONS(1216),
    [anon_sym_do] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_with] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_debugger] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_throw] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_case] = ACTIONS(1216),
    [anon_sym_yield] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1216),
    [anon_sym_class] = ACTIONS(1216),
    [anon_sym_async] = ACTIONS(1216),
    [anon_sym_function] = ACTIONS(1216),
    [anon_sym_new] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_BANG] = ACTIONS(1214),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1216),
    [anon_sym_delete] = ACTIONS(1216),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [sym_number] = ACTIONS(1214),
    [sym_this] = ACTIONS(1216),
    [sym_super] = ACTIONS(1216),
    [sym_true] = ACTIONS(1216),
    [sym_false] = ACTIONS(1216),
    [sym_null] = ACTIONS(1216),
    [sym_undefined] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_static] = ACTIONS(1216),
    [anon_sym_abstract] = ACTIONS(1216),
    [anon_sym_get] = ACTIONS(1216),
    [anon_sym_set] = ACTIONS(1216),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1216),
    [anon_sym_private] = ACTIONS(1216),
    [anon_sym_protected] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1216),
    [anon_sym_any] = ACTIONS(1216),
    [anon_sym_number] = ACTIONS(1216),
    [anon_sym_boolean] = ACTIONS(1216),
    [anon_sym_string] = ACTIONS(1216),
    [anon_sym_symbol] = ACTIONS(1216),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_enum] = ACTIONS(1216),
    [sym_readonly] = ACTIONS(1216),
    [sym__automatic_semicolon] = ACTIONS(1222),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(2662),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_typeof] = ACTIONS(2664),
    [anon_sym_import] = ACTIONS(2664),
    [anon_sym_var] = ACTIONS(2664),
    [anon_sym_let] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_else] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_await] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_with] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_debugger] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_finally] = ACTIONS(2664),
    [anon_sym_yield] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2662),
    [anon_sym_LT] = ACTIONS(2662),
    [anon_sym_SLASH] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [sym_number] = ACTIONS(2662),
    [sym_this] = ACTIONS(2664),
    [sym_super] = ACTIONS(2664),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [sym_null] = ACTIONS(2664),
    [sym_undefined] = ACTIONS(2664),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_abstract] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_interface] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_export] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_namespace] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_type] = ACTIONS(1140),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [anon_sym_let] = ACTIONS(1140),
    [anon_sym_const] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_await] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_debugger] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_yield] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_async] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1140),
    [anon_sym_delete] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_number] = ACTIONS(1138),
    [sym_this] = ACTIONS(1140),
    [sym_super] = ACTIONS(1140),
    [sym_true] = ACTIONS(1140),
    [sym_false] = ACTIONS(1140),
    [sym_null] = ACTIONS(1140),
    [sym_undefined] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1140),
    [anon_sym_set] = ACTIONS(1140),
    [anon_sym_declare] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_protected] = ACTIONS(1140),
    [anon_sym_module] = ACTIONS(1140),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [sym_readonly] = ACTIONS(1140),
    [sym__automatic_semicolon] = ACTIONS(1146),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_number] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_undefined] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1122),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(2666),
    [sym_identifier] = ACTIONS(2668),
    [anon_sym_export] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_type] = ACTIONS(2668),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_import] = ACTIONS(2668),
    [anon_sym_var] = ACTIONS(2668),
    [anon_sym_let] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_else] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_await] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_with] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_debugger] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_finally] = ACTIONS(2668),
    [anon_sym_yield] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2666),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_SLASH] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_async] = ACTIONS(2668),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2666),
    [sym_number] = ACTIONS(2666),
    [sym_this] = ACTIONS(2668),
    [sym_super] = ACTIONS(2668),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [sym_null] = ACTIONS(2668),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(2666),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_abstract] = ACTIONS(2668),
    [anon_sym_get] = ACTIONS(2668),
    [anon_sym_set] = ACTIONS(2668),
    [anon_sym_declare] = ACTIONS(2668),
    [anon_sym_public] = ACTIONS(2668),
    [anon_sym_private] = ACTIONS(2668),
    [anon_sym_protected] = ACTIONS(2668),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_any] = ACTIONS(2668),
    [anon_sym_number] = ACTIONS(2668),
    [anon_sym_boolean] = ACTIONS(2668),
    [anon_sym_string] = ACTIONS(2668),
    [anon_sym_symbol] = ACTIONS(2668),
    [anon_sym_interface] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [sym_readonly] = ACTIONS(2668),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_export] = ACTIONS(1192),
    [anon_sym_default] = ACTIONS(1192),
    [anon_sym_namespace] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_typeof] = ACTIONS(1192),
    [anon_sym_import] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_const] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_switch] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_await] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_do] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_debugger] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_throw] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1190),
    [anon_sym_case] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1192),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1192),
    [anon_sym_function] = ACTIONS(1192),
    [anon_sym_new] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_void] = ACTIONS(1192),
    [anon_sym_delete] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [sym_number] = ACTIONS(1190),
    [sym_this] = ACTIONS(1192),
    [sym_super] = ACTIONS(1192),
    [sym_true] = ACTIONS(1192),
    [sym_false] = ACTIONS(1192),
    [sym_null] = ACTIONS(1192),
    [sym_undefined] = ACTIONS(1192),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_abstract] = ACTIONS(1192),
    [anon_sym_get] = ACTIONS(1192),
    [anon_sym_set] = ACTIONS(1192),
    [anon_sym_declare] = ACTIONS(1192),
    [anon_sym_public] = ACTIONS(1192),
    [anon_sym_private] = ACTIONS(1192),
    [anon_sym_protected] = ACTIONS(1192),
    [anon_sym_module] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1192),
    [anon_sym_number] = ACTIONS(1192),
    [anon_sym_boolean] = ACTIONS(1192),
    [anon_sym_string] = ACTIONS(1192),
    [anon_sym_symbol] = ACTIONS(1192),
    [anon_sym_interface] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [sym_readonly] = ACTIONS(1192),
    [sym__automatic_semicolon] = ACTIONS(1198),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_typeof] = ACTIONS(2672),
    [anon_sym_import] = ACTIONS(2672),
    [anon_sym_var] = ACTIONS(2672),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_await] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_with] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_debugger] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_finally] = ACTIONS(2672),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_function] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_void] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2672),
    [sym_super] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(2670),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_abstract] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2672),
    [anon_sym_public] = ACTIONS(2672),
    [anon_sym_private] = ACTIONS(2672),
    [anon_sym_protected] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_interface] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [sym_readonly] = ACTIONS(2672),
  },
  [508] = {
    [sym_statement_block] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_export] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_namespace] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_var] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_debugger] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_throw] = ACTIONS(1064),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_SLASH] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_new] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_number] = ACTIONS(1062),
    [sym_this] = ACTIONS(1064),
    [sym_super] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_undefined] = ACTIONS(1064),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_abstract] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1064),
    [anon_sym_set] = ACTIONS(1064),
    [anon_sym_declare] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym_protected] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [anon_sym_any] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_boolean] = ACTIONS(1064),
    [anon_sym_string] = ACTIONS(1064),
    [anon_sym_symbol] = ACTIONS(1064),
    [anon_sym_interface] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [sym_readonly] = ACTIONS(1064),
  },
  [509] = {
    [sym__call_signature] = STATE(2802),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [sym_readonly] = ACTIONS(2540),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_var] = ACTIONS(2676),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_RPAREN] = ACTIONS(2674),
    [anon_sym_await] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_with] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_debugger] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_yield] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_void] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2674),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_null] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2674),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_abstract] = ACTIONS(2676),
    [anon_sym_get] = ACTIONS(2676),
    [anon_sym_set] = ACTIONS(2676),
    [anon_sym_declare] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_any] = ACTIONS(2676),
    [anon_sym_number] = ACTIONS(2676),
    [anon_sym_boolean] = ACTIONS(2676),
    [anon_sym_string] = ACTIONS(2676),
    [anon_sym_symbol] = ACTIONS(2676),
    [anon_sym_interface] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [sym_readonly] = ACTIONS(2676),
  },
  [511] = {
    [sym__call_signature] = STATE(2886),
    [sym_arguments] = STATE(1107),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_COLON] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_export] = ACTIONS(1172),
    [anon_sym_default] = ACTIONS(1172),
    [anon_sym_namespace] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_type] = ACTIONS(1172),
    [anon_sym_typeof] = ACTIONS(1172),
    [anon_sym_import] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_const] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1172),
    [anon_sym_switch] = ACTIONS(1172),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [anon_sym_await] = ACTIONS(1172),
    [anon_sym_while] = ACTIONS(1172),
    [anon_sym_do] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_with] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_debugger] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_throw] = ACTIONS(1172),
    [anon_sym_SEMI] = ACTIONS(1170),
    [anon_sym_case] = ACTIONS(1172),
    [anon_sym_yield] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_LT] = ACTIONS(1170),
    [anon_sym_SLASH] = ACTIONS(1172),
    [anon_sym_class] = ACTIONS(1172),
    [anon_sym_async] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(1172),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_BANG] = ACTIONS(1170),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_void] = ACTIONS(1172),
    [anon_sym_delete] = ACTIONS(1172),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [sym_number] = ACTIONS(1170),
    [sym_this] = ACTIONS(1172),
    [sym_super] = ACTIONS(1172),
    [sym_true] = ACTIONS(1172),
    [sym_false] = ACTIONS(1172),
    [sym_null] = ACTIONS(1172),
    [sym_undefined] = ACTIONS(1172),
    [anon_sym_AT] = ACTIONS(1170),
    [anon_sym_static] = ACTIONS(1172),
    [anon_sym_abstract] = ACTIONS(1172),
    [anon_sym_get] = ACTIONS(1172),
    [anon_sym_set] = ACTIONS(1172),
    [anon_sym_declare] = ACTIONS(1172),
    [anon_sym_public] = ACTIONS(1172),
    [anon_sym_private] = ACTIONS(1172),
    [anon_sym_protected] = ACTIONS(1172),
    [anon_sym_module] = ACTIONS(1172),
    [anon_sym_any] = ACTIONS(1172),
    [anon_sym_number] = ACTIONS(1172),
    [anon_sym_boolean] = ACTIONS(1172),
    [anon_sym_string] = ACTIONS(1172),
    [anon_sym_symbol] = ACTIONS(1172),
    [anon_sym_interface] = ACTIONS(1172),
    [anon_sym_enum] = ACTIONS(1172),
    [sym_readonly] = ACTIONS(1172),
    [sym__automatic_semicolon] = ACTIONS(1178),
  },
  [513] = {
    [sym__call_signature] = STATE(2802),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [sym_readonly] = ACTIONS(2540),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_export] = ACTIONS(1086),
    [anon_sym_default] = ACTIONS(1086),
    [anon_sym_namespace] = ACTIONS(1086),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_typeof] = ACTIONS(1086),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [anon_sym_let] = ACTIONS(1086),
    [anon_sym_const] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1086),
    [anon_sym_switch] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_do] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_debugger] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_throw] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_SLASH] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(1086),
    [anon_sym_new] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1084),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1086),
    [anon_sym_delete] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1084),
    [sym_number] = ACTIONS(1084),
    [sym_this] = ACTIONS(1086),
    [sym_super] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_null] = ACTIONS(1086),
    [sym_undefined] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_static] = ACTIONS(1086),
    [anon_sym_abstract] = ACTIONS(1086),
    [anon_sym_get] = ACTIONS(1086),
    [anon_sym_set] = ACTIONS(1086),
    [anon_sym_declare] = ACTIONS(1086),
    [anon_sym_public] = ACTIONS(1086),
    [anon_sym_private] = ACTIONS(1086),
    [anon_sym_protected] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [anon_sym_any] = ACTIONS(1086),
    [anon_sym_number] = ACTIONS(1086),
    [anon_sym_boolean] = ACTIONS(1086),
    [anon_sym_string] = ACTIONS(1086),
    [anon_sym_symbol] = ACTIONS(1086),
    [anon_sym_interface] = ACTIONS(1086),
    [anon_sym_enum] = ACTIONS(1086),
    [sym_readonly] = ACTIONS(1086),
    [sym__automatic_semicolon] = ACTIONS(1092),
  },
  [515] = {
    [sym__call_signature] = STATE(2932),
    [sym_arguments] = STATE(1402),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2603),
    [anon_sym_EQ_GT] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(493),
    [anon_sym_GT_GT_GT] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_CARET] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(493),
    [anon_sym_STAR_STAR] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [sym_readonly] = ACTIONS(2684),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_export] = ACTIONS(1150),
    [anon_sym_default] = ACTIONS(1150),
    [anon_sym_namespace] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1150),
    [anon_sym_typeof] = ACTIONS(1150),
    [anon_sym_import] = ACTIONS(1150),
    [anon_sym_var] = ACTIONS(1150),
    [anon_sym_let] = ACTIONS(1150),
    [anon_sym_const] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(1150),
    [anon_sym_else] = ACTIONS(1150),
    [anon_sym_switch] = ACTIONS(1150),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [anon_sym_await] = ACTIONS(1150),
    [anon_sym_while] = ACTIONS(1150),
    [anon_sym_do] = ACTIONS(1150),
    [anon_sym_try] = ACTIONS(1150),
    [anon_sym_with] = ACTIONS(1150),
    [anon_sym_break] = ACTIONS(1150),
    [anon_sym_continue] = ACTIONS(1150),
    [anon_sym_debugger] = ACTIONS(1150),
    [anon_sym_return] = ACTIONS(1150),
    [anon_sym_throw] = ACTIONS(1150),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_case] = ACTIONS(1150),
    [anon_sym_yield] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_class] = ACTIONS(1150),
    [anon_sym_async] = ACTIONS(1150),
    [anon_sym_function] = ACTIONS(1150),
    [anon_sym_new] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_BANG] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_void] = ACTIONS(1150),
    [anon_sym_delete] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [sym_number] = ACTIONS(1148),
    [sym_this] = ACTIONS(1150),
    [sym_super] = ACTIONS(1150),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_null] = ACTIONS(1150),
    [sym_undefined] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1150),
    [anon_sym_abstract] = ACTIONS(1150),
    [anon_sym_get] = ACTIONS(1150),
    [anon_sym_set] = ACTIONS(1150),
    [anon_sym_declare] = ACTIONS(1150),
    [anon_sym_public] = ACTIONS(1150),
    [anon_sym_private] = ACTIONS(1150),
    [anon_sym_protected] = ACTIONS(1150),
    [anon_sym_module] = ACTIONS(1150),
    [anon_sym_any] = ACTIONS(1150),
    [anon_sym_number] = ACTIONS(1150),
    [anon_sym_boolean] = ACTIONS(1150),
    [anon_sym_string] = ACTIONS(1150),
    [anon_sym_symbol] = ACTIONS(1150),
    [anon_sym_interface] = ACTIONS(1150),
    [anon_sym_enum] = ACTIONS(1150),
    [sym_readonly] = ACTIONS(1150),
    [sym__automatic_semicolon] = ACTIONS(1156),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2686),
    [sym_identifier] = ACTIONS(2688),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_typeof] = ACTIONS(2688),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_var] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_else] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_RPAREN] = ACTIONS(2686),
    [anon_sym_await] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_with] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_debugger] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_yield] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2686),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [sym_number] = ACTIONS(2686),
    [sym_this] = ACTIONS(2688),
    [sym_super] = ACTIONS(2688),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [sym_null] = ACTIONS(2688),
    [sym_undefined] = ACTIONS(2688),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_abstract] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [anon_sym_interface] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [518] = {
    [sym__call_signature] = STATE(2838),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_export] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(673),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2637),
    [anon_sym_async] = ACTIONS(2635),
    [anon_sym_function] = ACTIONS(2639),
    [anon_sym_EQ_GT] = ACTIONS(663),
    [anon_sym_PLUS_EQ] = ACTIONS(701),
    [anon_sym_DASH_EQ] = ACTIONS(701),
    [anon_sym_STAR_EQ] = ACTIONS(701),
    [anon_sym_SLASH_EQ] = ACTIONS(701),
    [anon_sym_PERCENT_EQ] = ACTIONS(701),
    [anon_sym_CARET_EQ] = ACTIONS(701),
    [anon_sym_AMP_EQ] = ACTIONS(701),
    [anon_sym_PIPE_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(701),
    [anon_sym_LT_LT_EQ] = ACTIONS(701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2635),
    [anon_sym_get] = ACTIONS(2635),
    [anon_sym_set] = ACTIONS(2635),
    [anon_sym_declare] = ACTIONS(2635),
    [anon_sym_public] = ACTIONS(2635),
    [anon_sym_private] = ACTIONS(2635),
    [anon_sym_protected] = ACTIONS(2635),
    [anon_sym_module] = ACTIONS(2635),
    [anon_sym_any] = ACTIONS(2635),
    [anon_sym_number] = ACTIONS(2635),
    [anon_sym_boolean] = ACTIONS(2635),
    [anon_sym_string] = ACTIONS(2635),
    [anon_sym_symbol] = ACTIONS(2635),
    [sym_readonly] = ACTIONS(2635),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1180),
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_default] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_typeof] = ACTIONS(1182),
    [anon_sym_import] = ACTIONS(1182),
    [anon_sym_var] = ACTIONS(1182),
    [anon_sym_let] = ACTIONS(1182),
    [anon_sym_const] = ACTIONS(1182),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_else] = ACTIONS(1182),
    [anon_sym_switch] = ACTIONS(1182),
    [anon_sym_for] = ACTIONS(1182),
    [anon_sym_LPAREN] = ACTIONS(1180),
    [anon_sym_await] = ACTIONS(1182),
    [anon_sym_while] = ACTIONS(1182),
    [anon_sym_do] = ACTIONS(1182),
    [anon_sym_try] = ACTIONS(1182),
    [anon_sym_with] = ACTIONS(1182),
    [anon_sym_break] = ACTIONS(1182),
    [anon_sym_continue] = ACTIONS(1182),
    [anon_sym_debugger] = ACTIONS(1182),
    [anon_sym_return] = ACTIONS(1182),
    [anon_sym_throw] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1180),
    [anon_sym_case] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1182),
    [anon_sym_LBRACK] = ACTIONS(1180),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_SLASH] = ACTIONS(1182),
    [anon_sym_class] = ACTIONS(1182),
    [anon_sym_async] = ACTIONS(1182),
    [anon_sym_function] = ACTIONS(1182),
    [anon_sym_new] = ACTIONS(1182),
    [anon_sym_PLUS] = ACTIONS(1182),
    [anon_sym_DASH] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1180),
    [anon_sym_void] = ACTIONS(1182),
    [anon_sym_delete] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1180),
    [anon_sym_DASH_DASH] = ACTIONS(1180),
    [anon_sym_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1180),
    [sym_number] = ACTIONS(1180),
    [sym_this] = ACTIONS(1182),
    [sym_super] = ACTIONS(1182),
    [sym_true] = ACTIONS(1182),
    [sym_false] = ACTIONS(1182),
    [sym_null] = ACTIONS(1182),
    [sym_undefined] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_abstract] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_interface] = ACTIONS(1182),
    [anon_sym_enum] = ACTIONS(1182),
    [sym_readonly] = ACTIONS(1182),
    [sym__automatic_semicolon] = ACTIONS(1188),
  },
  [520] = {
    [sym__call_signature] = STATE(2813),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_export] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(613),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2647),
    [anon_sym_get] = ACTIONS(2647),
    [anon_sym_set] = ACTIONS(2647),
    [anon_sym_declare] = ACTIONS(2647),
    [anon_sym_public] = ACTIONS(2647),
    [anon_sym_private] = ACTIONS(2647),
    [anon_sym_protected] = ACTIONS(2647),
    [anon_sym_module] = ACTIONS(2647),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(2647),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_export] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_typeof] = ACTIONS(2692),
    [anon_sym_import] = ACTIONS(2692),
    [anon_sym_var] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_await] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_with] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_debugger] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_finally] = ACTIONS(2692),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_void] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_number] = ACTIONS(2690),
    [sym_this] = ACTIONS(2692),
    [sym_super] = ACTIONS(2692),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [sym_null] = ACTIONS(2692),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(2690),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_get] = ACTIONS(2692),
    [anon_sym_set] = ACTIONS(2692),
    [anon_sym_declare] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_any] = ACTIONS(2692),
    [anon_sym_number] = ACTIONS(2692),
    [anon_sym_boolean] = ACTIONS(2692),
    [anon_sym_string] = ACTIONS(2692),
    [anon_sym_symbol] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [sym_readonly] = ACTIONS(2692),
  },
  [522] = {
    [sym__call_signature] = STATE(2802),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [sym_readonly] = ACTIONS(2540),
  },
  [523] = {
    [sym_object] = STATE(2118),
    [sym_array] = STATE(2123),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(2655),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2655),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2655),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2655),
    [anon_sym_get] = ACTIONS(2655),
    [anon_sym_set] = ACTIONS(2655),
    [anon_sym_declare] = ACTIONS(2655),
    [anon_sym_public] = ACTIONS(2655),
    [anon_sym_private] = ACTIONS(2655),
    [anon_sym_protected] = ACTIONS(2655),
    [anon_sym_module] = ACTIONS(2655),
    [anon_sym_any] = ACTIONS(2655),
    [anon_sym_number] = ACTIONS(2655),
    [anon_sym_boolean] = ACTIONS(2655),
    [anon_sym_string] = ACTIONS(2655),
    [anon_sym_symbol] = ACTIONS(2655),
    [sym_readonly] = ACTIONS(2655),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2694),
    [sym_identifier] = ACTIONS(2696),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_default] = ACTIONS(2696),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_import] = ACTIONS(2696),
    [anon_sym_var] = ACTIONS(2696),
    [anon_sym_let] = ACTIONS(2696),
    [anon_sym_const] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(2696),
    [anon_sym_else] = ACTIONS(2696),
    [anon_sym_switch] = ACTIONS(2696),
    [anon_sym_for] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2694),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_while] = ACTIONS(2696),
    [anon_sym_do] = ACTIONS(2696),
    [anon_sym_try] = ACTIONS(2696),
    [anon_sym_with] = ACTIONS(2696),
    [anon_sym_break] = ACTIONS(2696),
    [anon_sym_continue] = ACTIONS(2696),
    [anon_sym_debugger] = ACTIONS(2696),
    [anon_sym_return] = ACTIONS(2696),
    [anon_sym_throw] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_case] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(2696),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_delete] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [sym_number] = ACTIONS(2694),
    [sym_this] = ACTIONS(2696),
    [sym_super] = ACTIONS(2696),
    [sym_true] = ACTIONS(2696),
    [sym_false] = ACTIONS(2696),
    [sym_null] = ACTIONS(2696),
    [sym_undefined] = ACTIONS(2696),
    [anon_sym_AT] = ACTIONS(2694),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_abstract] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [anon_sym_interface] = ACTIONS(2696),
    [anon_sym_enum] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2698),
    [sym_identifier] = ACTIONS(2700),
    [anon_sym_export] = ACTIONS(2700),
    [anon_sym_default] = ACTIONS(2700),
    [anon_sym_namespace] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_type] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2700),
    [anon_sym_import] = ACTIONS(2700),
    [anon_sym_var] = ACTIONS(2700),
    [anon_sym_let] = ACTIONS(2700),
    [anon_sym_const] = ACTIONS(2700),
    [anon_sym_if] = ACTIONS(2700),
    [anon_sym_else] = ACTIONS(2700),
    [anon_sym_switch] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_await] = ACTIONS(2700),
    [anon_sym_while] = ACTIONS(2700),
    [anon_sym_do] = ACTIONS(2700),
    [anon_sym_try] = ACTIONS(2700),
    [anon_sym_with] = ACTIONS(2700),
    [anon_sym_break] = ACTIONS(2700),
    [anon_sym_continue] = ACTIONS(2700),
    [anon_sym_debugger] = ACTIONS(2700),
    [anon_sym_return] = ACTIONS(2700),
    [anon_sym_throw] = ACTIONS(2700),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_case] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_class] = ACTIONS(2700),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2700),
    [anon_sym_delete] = ACTIONS(2700),
    [anon_sym_PLUS_PLUS] = ACTIONS(2698),
    [anon_sym_DASH_DASH] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_SQUOTE] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2698),
    [sym_number] = ACTIONS(2698),
    [sym_this] = ACTIONS(2700),
    [sym_super] = ACTIONS(2700),
    [sym_true] = ACTIONS(2700),
    [sym_false] = ACTIONS(2700),
    [sym_null] = ACTIONS(2700),
    [sym_undefined] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2700),
    [anon_sym_abstract] = ACTIONS(2700),
    [anon_sym_get] = ACTIONS(2700),
    [anon_sym_set] = ACTIONS(2700),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_public] = ACTIONS(2700),
    [anon_sym_private] = ACTIONS(2700),
    [anon_sym_protected] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2700),
    [anon_sym_any] = ACTIONS(2700),
    [anon_sym_number] = ACTIONS(2700),
    [anon_sym_boolean] = ACTIONS(2700),
    [anon_sym_string] = ACTIONS(2700),
    [anon_sym_symbol] = ACTIONS(2700),
    [anon_sym_interface] = ACTIONS(2700),
    [anon_sym_enum] = ACTIONS(2700),
    [sym_readonly] = ACTIONS(2700),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2702),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_export] = ACTIONS(2704),
    [anon_sym_default] = ACTIONS(2704),
    [anon_sym_namespace] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_type] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2704),
    [anon_sym_import] = ACTIONS(2704),
    [anon_sym_var] = ACTIONS(2704),
    [anon_sym_let] = ACTIONS(2704),
    [anon_sym_const] = ACTIONS(2704),
    [anon_sym_if] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2704),
    [anon_sym_switch] = ACTIONS(2704),
    [anon_sym_for] = ACTIONS(2704),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_await] = ACTIONS(2704),
    [anon_sym_while] = ACTIONS(2704),
    [anon_sym_do] = ACTIONS(2704),
    [anon_sym_try] = ACTIONS(2704),
    [anon_sym_with] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2704),
    [anon_sym_continue] = ACTIONS(2704),
    [anon_sym_debugger] = ACTIONS(2704),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_throw] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_case] = ACTIONS(2704),
    [anon_sym_yield] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2704),
    [anon_sym_class] = ACTIONS(2704),
    [anon_sym_async] = ACTIONS(2704),
    [anon_sym_function] = ACTIONS(2704),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2702),
    [anon_sym_void] = ACTIONS(2704),
    [anon_sym_delete] = ACTIONS(2704),
    [anon_sym_PLUS_PLUS] = ACTIONS(2702),
    [anon_sym_DASH_DASH] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_super] = ACTIONS(2704),
    [sym_true] = ACTIONS(2704),
    [sym_false] = ACTIONS(2704),
    [sym_null] = ACTIONS(2704),
    [sym_undefined] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(2702),
    [anon_sym_static] = ACTIONS(2704),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_get] = ACTIONS(2704),
    [anon_sym_set] = ACTIONS(2704),
    [anon_sym_declare] = ACTIONS(2704),
    [anon_sym_public] = ACTIONS(2704),
    [anon_sym_private] = ACTIONS(2704),
    [anon_sym_protected] = ACTIONS(2704),
    [anon_sym_module] = ACTIONS(2704),
    [anon_sym_any] = ACTIONS(2704),
    [anon_sym_number] = ACTIONS(2704),
    [anon_sym_boolean] = ACTIONS(2704),
    [anon_sym_string] = ACTIONS(2704),
    [anon_sym_symbol] = ACTIONS(2704),
    [anon_sym_interface] = ACTIONS(2704),
    [anon_sym_enum] = ACTIONS(2704),
    [sym_readonly] = ACTIONS(2704),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_export] = ACTIONS(2708),
    [anon_sym_default] = ACTIONS(2708),
    [anon_sym_namespace] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2708),
    [anon_sym_import] = ACTIONS(2708),
    [anon_sym_var] = ACTIONS(2708),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_const] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2708),
    [anon_sym_switch] = ACTIONS(2708),
    [anon_sym_for] = ACTIONS(2708),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_await] = ACTIONS(2708),
    [anon_sym_while] = ACTIONS(2708),
    [anon_sym_do] = ACTIONS(2708),
    [anon_sym_try] = ACTIONS(2708),
    [anon_sym_with] = ACTIONS(2708),
    [anon_sym_break] = ACTIONS(2708),
    [anon_sym_continue] = ACTIONS(2708),
    [anon_sym_debugger] = ACTIONS(2708),
    [anon_sym_return] = ACTIONS(2708),
    [anon_sym_throw] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_case] = ACTIONS(2708),
    [anon_sym_yield] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_class] = ACTIONS(2708),
    [anon_sym_async] = ACTIONS(2708),
    [anon_sym_function] = ACTIONS(2708),
    [anon_sym_new] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2708),
    [anon_sym_delete] = ACTIONS(2708),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(2706),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2706),
    [sym_number] = ACTIONS(2706),
    [sym_this] = ACTIONS(2708),
    [sym_super] = ACTIONS(2708),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_null] = ACTIONS(2708),
    [sym_undefined] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2706),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_abstract] = ACTIONS(2708),
    [anon_sym_get] = ACTIONS(2708),
    [anon_sym_set] = ACTIONS(2708),
    [anon_sym_declare] = ACTIONS(2708),
    [anon_sym_public] = ACTIONS(2708),
    [anon_sym_private] = ACTIONS(2708),
    [anon_sym_protected] = ACTIONS(2708),
    [anon_sym_module] = ACTIONS(2708),
    [anon_sym_any] = ACTIONS(2708),
    [anon_sym_number] = ACTIONS(2708),
    [anon_sym_boolean] = ACTIONS(2708),
    [anon_sym_string] = ACTIONS(2708),
    [anon_sym_symbol] = ACTIONS(2708),
    [anon_sym_interface] = ACTIONS(2708),
    [anon_sym_enum] = ACTIONS(2708),
    [sym_readonly] = ACTIONS(2708),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_namespace] = ACTIONS(2712),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_type] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_var] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_switch] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [anon_sym_do] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_with] = ACTIONS(2712),
    [anon_sym_break] = ACTIONS(2712),
    [anon_sym_continue] = ACTIONS(2712),
    [anon_sym_debugger] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_throw] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2710),
    [anon_sym_case] = ACTIONS(2712),
    [anon_sym_yield] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_class] = ACTIONS(2712),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_new] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_TILDE] = ACTIONS(2710),
    [anon_sym_void] = ACTIONS(2712),
    [anon_sym_delete] = ACTIONS(2712),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_SQUOTE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [sym_number] = ACTIONS(2710),
    [sym_this] = ACTIONS(2712),
    [sym_super] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_null] = ACTIONS(2712),
    [sym_undefined] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2710),
    [anon_sym_static] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_get] = ACTIONS(2712),
    [anon_sym_set] = ACTIONS(2712),
    [anon_sym_declare] = ACTIONS(2712),
    [anon_sym_public] = ACTIONS(2712),
    [anon_sym_private] = ACTIONS(2712),
    [anon_sym_protected] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(2712),
    [anon_sym_number] = ACTIONS(2712),
    [anon_sym_boolean] = ACTIONS(2712),
    [anon_sym_string] = ACTIONS(2712),
    [anon_sym_symbol] = ACTIONS(2712),
    [anon_sym_interface] = ACTIONS(2712),
    [anon_sym_enum] = ACTIONS(2712),
    [sym_readonly] = ACTIONS(2712),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_with] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [sym_readonly] = ACTIONS(2716),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_default] = ACTIONS(2720),
    [anon_sym_namespace] = ACTIONS(2720),
    [anon_sym_LBRACE] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_typeof] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_var] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_switch] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [anon_sym_do] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_with] = ACTIONS(2720),
    [anon_sym_break] = ACTIONS(2720),
    [anon_sym_continue] = ACTIONS(2720),
    [anon_sym_debugger] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_throw] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_case] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_class] = ACTIONS(2720),
    [anon_sym_async] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_new] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [anon_sym_BANG] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(2720),
    [anon_sym_delete] = ACTIONS(2720),
    [anon_sym_PLUS_PLUS] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2718),
    [anon_sym_DQUOTE] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_number] = ACTIONS(2718),
    [sym_this] = ACTIONS(2720),
    [sym_super] = ACTIONS(2720),
    [sym_true] = ACTIONS(2720),
    [sym_false] = ACTIONS(2720),
    [sym_null] = ACTIONS(2720),
    [sym_undefined] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_get] = ACTIONS(2720),
    [anon_sym_set] = ACTIONS(2720),
    [anon_sym_declare] = ACTIONS(2720),
    [anon_sym_public] = ACTIONS(2720),
    [anon_sym_private] = ACTIONS(2720),
    [anon_sym_protected] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_any] = ACTIONS(2720),
    [anon_sym_number] = ACTIONS(2720),
    [anon_sym_boolean] = ACTIONS(2720),
    [anon_sym_string] = ACTIONS(2720),
    [anon_sym_symbol] = ACTIONS(2720),
    [anon_sym_interface] = ACTIONS(2720),
    [anon_sym_enum] = ACTIONS(2720),
    [sym_readonly] = ACTIONS(2720),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_export] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_namespace] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2724),
    [anon_sym_import] = ACTIONS(2724),
    [anon_sym_var] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2724),
    [anon_sym_switch] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_await] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_do] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [anon_sym_with] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_debugger] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_throw] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_case] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_class] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(2724),
    [anon_sym_new] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_void] = ACTIONS(2724),
    [anon_sym_delete] = ACTIONS(2724),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_DQUOTE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [sym_number] = ACTIONS(2722),
    [sym_this] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_true] = ACTIONS(2724),
    [sym_false] = ACTIONS(2724),
    [sym_null] = ACTIONS(2724),
    [sym_undefined] = ACTIONS(2724),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_abstract] = ACTIONS(2724),
    [anon_sym_get] = ACTIONS(2724),
    [anon_sym_set] = ACTIONS(2724),
    [anon_sym_declare] = ACTIONS(2724),
    [anon_sym_public] = ACTIONS(2724),
    [anon_sym_private] = ACTIONS(2724),
    [anon_sym_protected] = ACTIONS(2724),
    [anon_sym_module] = ACTIONS(2724),
    [anon_sym_any] = ACTIONS(2724),
    [anon_sym_number] = ACTIONS(2724),
    [anon_sym_boolean] = ACTIONS(2724),
    [anon_sym_string] = ACTIONS(2724),
    [anon_sym_symbol] = ACTIONS(2724),
    [anon_sym_interface] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [sym_readonly] = ACTIONS(2724),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1200),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_export] = ACTIONS(1202),
    [anon_sym_default] = ACTIONS(1202),
    [anon_sym_namespace] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1200),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_typeof] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1202),
    [anon_sym_var] = ACTIONS(1202),
    [anon_sym_let] = ACTIONS(1202),
    [anon_sym_const] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_else] = ACTIONS(1202),
    [anon_sym_switch] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1202),
    [anon_sym_LPAREN] = ACTIONS(1200),
    [anon_sym_await] = ACTIONS(1202),
    [anon_sym_while] = ACTIONS(1202),
    [anon_sym_do] = ACTIONS(1202),
    [anon_sym_try] = ACTIONS(1202),
    [anon_sym_with] = ACTIONS(1202),
    [anon_sym_break] = ACTIONS(1202),
    [anon_sym_continue] = ACTIONS(1202),
    [anon_sym_debugger] = ACTIONS(1202),
    [anon_sym_return] = ACTIONS(1202),
    [anon_sym_throw] = ACTIONS(1202),
    [anon_sym_SEMI] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1200),
    [anon_sym_LT] = ACTIONS(1200),
    [anon_sym_SLASH] = ACTIONS(1202),
    [anon_sym_class] = ACTIONS(1202),
    [anon_sym_async] = ACTIONS(1202),
    [anon_sym_function] = ACTIONS(1202),
    [anon_sym_new] = ACTIONS(1202),
    [anon_sym_PLUS] = ACTIONS(1202),
    [anon_sym_DASH] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1200),
    [anon_sym_void] = ACTIONS(1202),
    [anon_sym_delete] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1200),
    [anon_sym_DASH_DASH] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1200),
    [anon_sym_SQUOTE] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1200),
    [sym_number] = ACTIONS(1200),
    [sym_this] = ACTIONS(1202),
    [sym_super] = ACTIONS(1202),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_null] = ACTIONS(1202),
    [sym_undefined] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_static] = ACTIONS(1202),
    [anon_sym_abstract] = ACTIONS(1202),
    [anon_sym_get] = ACTIONS(1202),
    [anon_sym_set] = ACTIONS(1202),
    [anon_sym_declare] = ACTIONS(1202),
    [anon_sym_public] = ACTIONS(1202),
    [anon_sym_private] = ACTIONS(1202),
    [anon_sym_protected] = ACTIONS(1202),
    [anon_sym_module] = ACTIONS(1202),
    [anon_sym_any] = ACTIONS(1202),
    [anon_sym_number] = ACTIONS(1202),
    [anon_sym_boolean] = ACTIONS(1202),
    [anon_sym_string] = ACTIONS(1202),
    [anon_sym_symbol] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1202),
    [anon_sym_enum] = ACTIONS(1202),
    [sym_readonly] = ACTIONS(1202),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_var] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_switch] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_await] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_do] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_with] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_debugger] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_throw] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_case] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_delete] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_number] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_true] = ACTIONS(2728),
    [sym_false] = ACTIONS(2728),
    [sym_null] = ACTIONS(2728),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
  },
  [534] = {
    [sym__call_signature] = STATE(2886),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2730),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2732),
    [anon_sym_import] = ACTIONS(2732),
    [anon_sym_var] = ACTIONS(2732),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2732),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_switch] = ACTIONS(2732),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_await] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_do] = ACTIONS(2732),
    [anon_sym_try] = ACTIONS(2732),
    [anon_sym_with] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_debugger] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_throw] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2730),
    [anon_sym_case] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2732),
    [anon_sym_class] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2732),
    [anon_sym_new] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_delete] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2730),
    [anon_sym_DASH_DASH] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [anon_sym_SQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_number] = ACTIONS(2730),
    [sym_this] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_true] = ACTIONS(2732),
    [sym_false] = ACTIONS(2732),
    [sym_null] = ACTIONS(2732),
    [sym_undefined] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2730),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_abstract] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_interface] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_await] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [sym_this] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [sym_readonly] = ACTIONS(2736),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_identifier] = ACTIONS(1110),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_default] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_typeof] = ACTIONS(1110),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_var] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_const] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1110),
    [anon_sym_for] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_await] = ACTIONS(1110),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1110),
    [anon_sym_try] = ACTIONS(1110),
    [anon_sym_with] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [anon_sym_debugger] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_throw] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_SLASH] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1110),
    [anon_sym_async] = ACTIONS(1110),
    [anon_sym_function] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1110),
    [anon_sym_delete] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [sym_number] = ACTIONS(1108),
    [sym_this] = ACTIONS(1110),
    [sym_super] = ACTIONS(1110),
    [sym_true] = ACTIONS(1110),
    [sym_false] = ACTIONS(1110),
    [sym_null] = ACTIONS(1110),
    [sym_undefined] = ACTIONS(1110),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_abstract] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_interface] = ACTIONS(1110),
    [anon_sym_enum] = ACTIONS(1110),
    [sym_readonly] = ACTIONS(1110),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [sym_readonly] = ACTIONS(2740),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [sym_readonly] = ACTIONS(2744),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [sym_readonly] = ACTIONS(2748),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [sym_readonly] = ACTIONS(2752),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [sym_readonly] = ACTIONS(2756),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1134),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_export] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_namespace] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1136),
    [anon_sym_typeof] = ACTIONS(1136),
    [anon_sym_import] = ACTIONS(1136),
    [anon_sym_var] = ACTIONS(1136),
    [anon_sym_let] = ACTIONS(1136),
    [anon_sym_const] = ACTIONS(1136),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(1136),
    [anon_sym_for] = ACTIONS(1136),
    [anon_sym_LPAREN] = ACTIONS(1134),
    [anon_sym_await] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(1136),
    [anon_sym_do] = ACTIONS(1136),
    [anon_sym_try] = ACTIONS(1136),
    [anon_sym_with] = ACTIONS(1136),
    [anon_sym_break] = ACTIONS(1136),
    [anon_sym_continue] = ACTIONS(1136),
    [anon_sym_debugger] = ACTIONS(1136),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_throw] = ACTIONS(1136),
    [anon_sym_SEMI] = ACTIONS(1134),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_yield] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_LT] = ACTIONS(1134),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_class] = ACTIONS(1136),
    [anon_sym_async] = ACTIONS(1136),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_new] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_BANG] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_void] = ACTIONS(1136),
    [anon_sym_delete] = ACTIONS(1136),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1134),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1134),
    [sym_number] = ACTIONS(1134),
    [sym_this] = ACTIONS(1136),
    [sym_super] = ACTIONS(1136),
    [sym_true] = ACTIONS(1136),
    [sym_false] = ACTIONS(1136),
    [sym_null] = ACTIONS(1136),
    [sym_undefined] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1134),
    [anon_sym_static] = ACTIONS(1136),
    [anon_sym_abstract] = ACTIONS(1136),
    [anon_sym_get] = ACTIONS(1136),
    [anon_sym_set] = ACTIONS(1136),
    [anon_sym_declare] = ACTIONS(1136),
    [anon_sym_public] = ACTIONS(1136),
    [anon_sym_private] = ACTIONS(1136),
    [anon_sym_protected] = ACTIONS(1136),
    [anon_sym_module] = ACTIONS(1136),
    [anon_sym_any] = ACTIONS(1136),
    [anon_sym_number] = ACTIONS(1136),
    [anon_sym_boolean] = ACTIONS(1136),
    [anon_sym_string] = ACTIONS(1136),
    [anon_sym_symbol] = ACTIONS(1136),
    [anon_sym_interface] = ACTIONS(1136),
    [anon_sym_enum] = ACTIONS(1136),
    [sym_readonly] = ACTIONS(1136),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [sym_readonly] = ACTIONS(2760),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [sym_readonly] = ACTIONS(2764),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [sym_readonly] = ACTIONS(2772),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [sym_readonly] = ACTIONS(2776),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [sym_readonly] = ACTIONS(2780),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [553] = {
    [sym__call_signature] = STATE(2932),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(619),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2603),
    [anon_sym_EQ_GT] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(635),
    [anon_sym_DASH_EQ] = ACTIONS(635),
    [anon_sym_STAR_EQ] = ACTIONS(635),
    [anon_sym_SLASH_EQ] = ACTIONS(635),
    [anon_sym_PERCENT_EQ] = ACTIONS(635),
    [anon_sym_CARET_EQ] = ACTIONS(635),
    [anon_sym_AMP_EQ] = ACTIONS(635),
    [anon_sym_PIPE_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(635),
    [anon_sym_LT_LT_EQ] = ACTIONS(635),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(635),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [sym_readonly] = ACTIONS(2684),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [sym_readonly] = ACTIONS(2796),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [sym_readonly] = ACTIONS(2800),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [sym_readonly] = ACTIONS(2804),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_import] = ACTIONS(2808),
    [anon_sym_var] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_else] = ACTIONS(2808),
    [anon_sym_switch] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_await] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_do] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [anon_sym_with] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_debugger] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_throw] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2808),
    [anon_sym_new] = ACTIONS(2808),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_BANG] = ACTIONS(2806),
    [anon_sym_TILDE] = ACTIONS(2806),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2806),
    [anon_sym_DASH_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [sym_number] = ACTIONS(2806),
    [sym_this] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_true] = ACTIONS(2808),
    [sym_false] = ACTIONS(2808),
    [sym_null] = ACTIONS(2808),
    [sym_undefined] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2806),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_abstract] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [anon_sym_interface] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [sym_readonly] = ACTIONS(2812),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [sym_readonly] = ACTIONS(2816),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [sym_readonly] = ACTIONS(2824),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [sym_readonly] = ACTIONS(2828),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [sym_readonly] = ACTIONS(2832),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [sym_readonly] = ACTIONS(2840),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [sym_readonly] = ACTIONS(2844),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_await] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [sym_this] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [sym_readonly] = ACTIONS(2848),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [sym_readonly] = ACTIONS(2852),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [sym_readonly] = ACTIONS(2856),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_export] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2860),
    [anon_sym_var] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_function] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [sym_readonly] = ACTIONS(2860),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_export] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_namespace] = ACTIONS(2864),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_typeof] = ACTIONS(2864),
    [anon_sym_import] = ACTIONS(2864),
    [anon_sym_var] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_else] = ACTIONS(2864),
    [anon_sym_switch] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_do] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [anon_sym_with] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_debugger] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_throw] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_case] = ACTIONS(2864),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_SLASH] = ACTIONS(2864),
    [anon_sym_class] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_function] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_void] = ACTIONS(2864),
    [anon_sym_delete] = ACTIONS(2864),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_undefined] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_get] = ACTIONS(2864),
    [anon_sym_set] = ACTIONS(2864),
    [anon_sym_declare] = ACTIONS(2864),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2864),
    [anon_sym_any] = ACTIONS(2864),
    [anon_sym_number] = ACTIONS(2864),
    [anon_sym_boolean] = ACTIONS(2864),
    [anon_sym_string] = ACTIONS(2864),
    [anon_sym_symbol] = ACTIONS(2864),
    [anon_sym_interface] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
    [sym_readonly] = ACTIONS(2864),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_export] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_namespace] = ACTIONS(2868),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_typeof] = ACTIONS(2868),
    [anon_sym_import] = ACTIONS(2868),
    [anon_sym_var] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_await] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_debugger] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_throw] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_case] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_class] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_function] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2866),
    [anon_sym_void] = ACTIONS(2868),
    [anon_sym_delete] = ACTIONS(2868),
    [anon_sym_PLUS_PLUS] = ACTIONS(2866),
    [anon_sym_DASH_DASH] = ACTIONS(2866),
    [anon_sym_DQUOTE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_number] = ACTIONS(2866),
    [sym_this] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_AT] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_abstract] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(2868),
    [anon_sym_declare] = ACTIONS(2868),
    [anon_sym_public] = ACTIONS(2868),
    [anon_sym_private] = ACTIONS(2868),
    [anon_sym_protected] = ACTIONS(2868),
    [anon_sym_module] = ACTIONS(2868),
    [anon_sym_any] = ACTIONS(2868),
    [anon_sym_number] = ACTIONS(2868),
    [anon_sym_boolean] = ACTIONS(2868),
    [anon_sym_string] = ACTIONS(2868),
    [anon_sym_symbol] = ACTIONS(2868),
    [anon_sym_interface] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
    [sym_readonly] = ACTIONS(2868),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2874),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [sym_readonly] = ACTIONS(2872),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2878),
    [anon_sym_default] = ACTIONS(2878),
    [anon_sym_namespace] = ACTIONS(2878),
    [anon_sym_LBRACE] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2876),
    [anon_sym_type] = ACTIONS(2878),
    [anon_sym_typeof] = ACTIONS(2878),
    [anon_sym_import] = ACTIONS(2878),
    [anon_sym_var] = ACTIONS(2878),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_const] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2878),
    [anon_sym_else] = ACTIONS(2878),
    [anon_sym_switch] = ACTIONS(2878),
    [anon_sym_for] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2876),
    [anon_sym_await] = ACTIONS(2878),
    [anon_sym_while] = ACTIONS(2878),
    [anon_sym_do] = ACTIONS(2878),
    [anon_sym_try] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2878),
    [anon_sym_break] = ACTIONS(2878),
    [anon_sym_continue] = ACTIONS(2878),
    [anon_sym_debugger] = ACTIONS(2878),
    [anon_sym_return] = ACTIONS(2878),
    [anon_sym_throw] = ACTIONS(2878),
    [anon_sym_SEMI] = ACTIONS(2876),
    [anon_sym_case] = ACTIONS(2878),
    [anon_sym_yield] = ACTIONS(2878),
    [anon_sym_LBRACK] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2878),
    [anon_sym_class] = ACTIONS(2878),
    [anon_sym_async] = ACTIONS(2878),
    [anon_sym_function] = ACTIONS(2878),
    [anon_sym_new] = ACTIONS(2878),
    [anon_sym_PLUS] = ACTIONS(2878),
    [anon_sym_DASH] = ACTIONS(2878),
    [anon_sym_BANG] = ACTIONS(2876),
    [anon_sym_TILDE] = ACTIONS(2876),
    [anon_sym_void] = ACTIONS(2878),
    [anon_sym_delete] = ACTIONS(2878),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_SQUOTE] = ACTIONS(2876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [sym_number] = ACTIONS(2876),
    [sym_this] = ACTIONS(2878),
    [sym_super] = ACTIONS(2878),
    [sym_true] = ACTIONS(2878),
    [sym_false] = ACTIONS(2878),
    [sym_null] = ACTIONS(2878),
    [sym_undefined] = ACTIONS(2878),
    [anon_sym_AT] = ACTIONS(2876),
    [anon_sym_static] = ACTIONS(2878),
    [anon_sym_abstract] = ACTIONS(2878),
    [anon_sym_get] = ACTIONS(2878),
    [anon_sym_set] = ACTIONS(2878),
    [anon_sym_declare] = ACTIONS(2878),
    [anon_sym_public] = ACTIONS(2878),
    [anon_sym_private] = ACTIONS(2878),
    [anon_sym_protected] = ACTIONS(2878),
    [anon_sym_module] = ACTIONS(2878),
    [anon_sym_any] = ACTIONS(2878),
    [anon_sym_number] = ACTIONS(2878),
    [anon_sym_boolean] = ACTIONS(2878),
    [anon_sym_string] = ACTIONS(2878),
    [anon_sym_symbol] = ACTIONS(2878),
    [anon_sym_interface] = ACTIONS(2878),
    [anon_sym_enum] = ACTIONS(2878),
    [sym_readonly] = ACTIONS(2878),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2880),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_default] = ACTIONS(2882),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(2880),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_typeof] = ACTIONS(2882),
    [anon_sym_import] = ACTIONS(2882),
    [anon_sym_var] = ACTIONS(2882),
    [anon_sym_let] = ACTIONS(2882),
    [anon_sym_const] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2882),
    [anon_sym_switch] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2880),
    [anon_sym_await] = ACTIONS(2882),
    [anon_sym_while] = ACTIONS(2882),
    [anon_sym_do] = ACTIONS(2882),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2882),
    [anon_sym_break] = ACTIONS(2882),
    [anon_sym_continue] = ACTIONS(2882),
    [anon_sym_debugger] = ACTIONS(2882),
    [anon_sym_return] = ACTIONS(2882),
    [anon_sym_throw] = ACTIONS(2882),
    [anon_sym_SEMI] = ACTIONS(2880),
    [anon_sym_case] = ACTIONS(2882),
    [anon_sym_yield] = ACTIONS(2882),
    [anon_sym_LBRACK] = ACTIONS(2880),
    [anon_sym_LT] = ACTIONS(2880),
    [anon_sym_SLASH] = ACTIONS(2882),
    [anon_sym_class] = ACTIONS(2882),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_function] = ACTIONS(2882),
    [anon_sym_new] = ACTIONS(2882),
    [anon_sym_PLUS] = ACTIONS(2882),
    [anon_sym_DASH] = ACTIONS(2882),
    [anon_sym_BANG] = ACTIONS(2880),
    [anon_sym_TILDE] = ACTIONS(2880),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_delete] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_DQUOTE] = ACTIONS(2880),
    [anon_sym_SQUOTE] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2880),
    [sym_number] = ACTIONS(2880),
    [sym_this] = ACTIONS(2882),
    [sym_super] = ACTIONS(2882),
    [sym_true] = ACTIONS(2882),
    [sym_false] = ACTIONS(2882),
    [sym_null] = ACTIONS(2882),
    [sym_undefined] = ACTIONS(2882),
    [anon_sym_AT] = ACTIONS(2880),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_abstract] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [anon_sym_interface] = ACTIONS(2882),
    [anon_sym_enum] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_export] = ACTIONS(1168),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1168),
    [anon_sym_typeof] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_const] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_await] = ACTIONS(1168),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_debugger] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_SEMI] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_yield] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1166),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_async] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_void] = ACTIONS(1168),
    [anon_sym_delete] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [sym_number] = ACTIONS(1166),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(1168),
    [sym_true] = ACTIONS(1168),
    [sym_false] = ACTIONS(1168),
    [sym_null] = ACTIONS(1168),
    [sym_undefined] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1166),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_get] = ACTIONS(1168),
    [anon_sym_set] = ACTIONS(1168),
    [anon_sym_declare] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_protected] = ACTIONS(1168),
    [anon_sym_module] = ACTIONS(1168),
    [anon_sym_any] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_boolean] = ACTIONS(1168),
    [anon_sym_string] = ACTIONS(1168),
    [anon_sym_symbol] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [sym_readonly] = ACTIONS(1168),
  },
  [577] = {
    [sym__call_signature] = STATE(2886),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2884),
    [sym_identifier] = ACTIONS(2886),
    [anon_sym_export] = ACTIONS(2886),
    [anon_sym_default] = ACTIONS(2886),
    [anon_sym_namespace] = ACTIONS(2886),
    [anon_sym_LBRACE] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_type] = ACTIONS(2886),
    [anon_sym_typeof] = ACTIONS(2886),
    [anon_sym_import] = ACTIONS(2886),
    [anon_sym_var] = ACTIONS(2886),
    [anon_sym_let] = ACTIONS(2886),
    [anon_sym_const] = ACTIONS(2886),
    [anon_sym_if] = ACTIONS(2886),
    [anon_sym_else] = ACTIONS(2886),
    [anon_sym_switch] = ACTIONS(2886),
    [anon_sym_for] = ACTIONS(2886),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_await] = ACTIONS(2886),
    [anon_sym_while] = ACTIONS(2886),
    [anon_sym_do] = ACTIONS(2886),
    [anon_sym_try] = ACTIONS(2886),
    [anon_sym_with] = ACTIONS(2886),
    [anon_sym_break] = ACTIONS(2886),
    [anon_sym_continue] = ACTIONS(2886),
    [anon_sym_debugger] = ACTIONS(2886),
    [anon_sym_return] = ACTIONS(2886),
    [anon_sym_throw] = ACTIONS(2886),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_case] = ACTIONS(2886),
    [anon_sym_yield] = ACTIONS(2886),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(2886),
    [anon_sym_class] = ACTIONS(2886),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_function] = ACTIONS(2886),
    [anon_sym_new] = ACTIONS(2886),
    [anon_sym_PLUS] = ACTIONS(2886),
    [anon_sym_DASH] = ACTIONS(2886),
    [anon_sym_BANG] = ACTIONS(2884),
    [anon_sym_TILDE] = ACTIONS(2884),
    [anon_sym_void] = ACTIONS(2886),
    [anon_sym_delete] = ACTIONS(2886),
    [anon_sym_PLUS_PLUS] = ACTIONS(2884),
    [anon_sym_DASH_DASH] = ACTIONS(2884),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [anon_sym_SQUOTE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [sym_number] = ACTIONS(2884),
    [sym_this] = ACTIONS(2886),
    [sym_super] = ACTIONS(2886),
    [sym_true] = ACTIONS(2886),
    [sym_false] = ACTIONS(2886),
    [sym_null] = ACTIONS(2886),
    [sym_undefined] = ACTIONS(2886),
    [anon_sym_AT] = ACTIONS(2884),
    [anon_sym_static] = ACTIONS(2886),
    [anon_sym_abstract] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2886),
    [anon_sym_public] = ACTIONS(2886),
    [anon_sym_private] = ACTIONS(2886),
    [anon_sym_protected] = ACTIONS(2886),
    [anon_sym_module] = ACTIONS(2886),
    [anon_sym_any] = ACTIONS(2886),
    [anon_sym_number] = ACTIONS(2886),
    [anon_sym_boolean] = ACTIONS(2886),
    [anon_sym_string] = ACTIONS(2886),
    [anon_sym_symbol] = ACTIONS(2886),
    [anon_sym_interface] = ACTIONS(2886),
    [anon_sym_enum] = ACTIONS(2886),
    [sym_readonly] = ACTIONS(2886),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(2888),
    [sym_identifier] = ACTIONS(2890),
    [anon_sym_export] = ACTIONS(2890),
    [anon_sym_default] = ACTIONS(2890),
    [anon_sym_namespace] = ACTIONS(2890),
    [anon_sym_LBRACE] = ACTIONS(2888),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_type] = ACTIONS(2890),
    [anon_sym_typeof] = ACTIONS(2890),
    [anon_sym_import] = ACTIONS(2890),
    [anon_sym_var] = ACTIONS(2890),
    [anon_sym_let] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2890),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_else] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2890),
    [anon_sym_for] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2888),
    [anon_sym_await] = ACTIONS(2890),
    [anon_sym_while] = ACTIONS(2890),
    [anon_sym_do] = ACTIONS(2890),
    [anon_sym_try] = ACTIONS(2890),
    [anon_sym_with] = ACTIONS(2890),
    [anon_sym_break] = ACTIONS(2890),
    [anon_sym_continue] = ACTIONS(2890),
    [anon_sym_debugger] = ACTIONS(2890),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_throw] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_case] = ACTIONS(2890),
    [anon_sym_yield] = ACTIONS(2890),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [anon_sym_LT] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2890),
    [anon_sym_class] = ACTIONS(2890),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_function] = ACTIONS(2890),
    [anon_sym_new] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2890),
    [anon_sym_DASH] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(2888),
    [anon_sym_TILDE] = ACTIONS(2888),
    [anon_sym_void] = ACTIONS(2890),
    [anon_sym_delete] = ACTIONS(2890),
    [anon_sym_PLUS_PLUS] = ACTIONS(2888),
    [anon_sym_DASH_DASH] = ACTIONS(2888),
    [anon_sym_DQUOTE] = ACTIONS(2888),
    [anon_sym_SQUOTE] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2888),
    [sym_number] = ACTIONS(2888),
    [sym_this] = ACTIONS(2890),
    [sym_super] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [sym_false] = ACTIONS(2890),
    [sym_null] = ACTIONS(2890),
    [sym_undefined] = ACTIONS(2890),
    [anon_sym_AT] = ACTIONS(2888),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_abstract] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_interface] = ACTIONS(2890),
    [anon_sym_enum] = ACTIONS(2890),
    [sym_readonly] = ACTIONS(2890),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2892),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2892),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_typeof] = ACTIONS(2894),
    [anon_sym_import] = ACTIONS(2894),
    [anon_sym_var] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_const] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_else] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_for] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2892),
    [anon_sym_await] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2894),
    [anon_sym_do] = ACTIONS(2894),
    [anon_sym_try] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2894),
    [anon_sym_continue] = ACTIONS(2894),
    [anon_sym_debugger] = ACTIONS(2894),
    [anon_sym_return] = ACTIONS(2894),
    [anon_sym_throw] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_yield] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2894),
    [anon_sym_class] = ACTIONS(2894),
    [anon_sym_async] = ACTIONS(2894),
    [anon_sym_function] = ACTIONS(2894),
    [anon_sym_new] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_TILDE] = ACTIONS(2892),
    [anon_sym_void] = ACTIONS(2894),
    [anon_sym_delete] = ACTIONS(2894),
    [anon_sym_PLUS_PLUS] = ACTIONS(2892),
    [anon_sym_DASH_DASH] = ACTIONS(2892),
    [anon_sym_DQUOTE] = ACTIONS(2892),
    [anon_sym_SQUOTE] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2892),
    [sym_number] = ACTIONS(2892),
    [sym_this] = ACTIONS(2894),
    [sym_super] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_null] = ACTIONS(2894),
    [sym_undefined] = ACTIONS(2894),
    [anon_sym_AT] = ACTIONS(2892),
    [anon_sym_static] = ACTIONS(2894),
    [anon_sym_abstract] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2894),
    [anon_sym_set] = ACTIONS(2894),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2894),
    [anon_sym_private] = ACTIONS(2894),
    [anon_sym_protected] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_interface] = ACTIONS(2894),
    [anon_sym_enum] = ACTIONS(2894),
    [sym_readonly] = ACTIONS(2894),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2896),
    [sym_identifier] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2898),
    [anon_sym_default] = ACTIONS(2898),
    [anon_sym_namespace] = ACTIONS(2898),
    [anon_sym_LBRACE] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2896),
    [anon_sym_type] = ACTIONS(2898),
    [anon_sym_typeof] = ACTIONS(2898),
    [anon_sym_import] = ACTIONS(2898),
    [anon_sym_var] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2898),
    [anon_sym_const] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2898),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_await] = ACTIONS(2898),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_do] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2898),
    [anon_sym_with] = ACTIONS(2898),
    [anon_sym_break] = ACTIONS(2898),
    [anon_sym_continue] = ACTIONS(2898),
    [anon_sym_debugger] = ACTIONS(2898),
    [anon_sym_return] = ACTIONS(2898),
    [anon_sym_throw] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_case] = ACTIONS(2898),
    [anon_sym_yield] = ACTIONS(2898),
    [anon_sym_LBRACK] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_SLASH] = ACTIONS(2898),
    [anon_sym_class] = ACTIONS(2898),
    [anon_sym_async] = ACTIONS(2898),
    [anon_sym_function] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2898),
    [anon_sym_DASH] = ACTIONS(2898),
    [anon_sym_BANG] = ACTIONS(2896),
    [anon_sym_TILDE] = ACTIONS(2896),
    [anon_sym_void] = ACTIONS(2898),
    [anon_sym_delete] = ACTIONS(2898),
    [anon_sym_PLUS_PLUS] = ACTIONS(2896),
    [anon_sym_DASH_DASH] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [sym_number] = ACTIONS(2896),
    [sym_this] = ACTIONS(2898),
    [sym_super] = ACTIONS(2898),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [sym_null] = ACTIONS(2898),
    [sym_undefined] = ACTIONS(2898),
    [anon_sym_AT] = ACTIONS(2896),
    [anon_sym_static] = ACTIONS(2898),
    [anon_sym_abstract] = ACTIONS(2898),
    [anon_sym_get] = ACTIONS(2898),
    [anon_sym_set] = ACTIONS(2898),
    [anon_sym_declare] = ACTIONS(2898),
    [anon_sym_public] = ACTIONS(2898),
    [anon_sym_private] = ACTIONS(2898),
    [anon_sym_protected] = ACTIONS(2898),
    [anon_sym_module] = ACTIONS(2898),
    [anon_sym_any] = ACTIONS(2898),
    [anon_sym_number] = ACTIONS(2898),
    [anon_sym_boolean] = ACTIONS(2898),
    [anon_sym_string] = ACTIONS(2898),
    [anon_sym_symbol] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2898),
    [anon_sym_enum] = ACTIONS(2898),
    [sym_readonly] = ACTIONS(2898),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(2900),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_export] = ACTIONS(2902),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_namespace] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_type] = ACTIONS(2902),
    [anon_sym_typeof] = ACTIONS(2902),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_var] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_const] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2902),
    [anon_sym_switch] = ACTIONS(2902),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_await] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_break] = ACTIONS(2902),
    [anon_sym_continue] = ACTIONS(2902),
    [anon_sym_debugger] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_throw] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_case] = ACTIONS(2902),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(2902),
    [anon_sym_class] = ACTIONS(2902),
    [anon_sym_async] = ACTIONS(2902),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2900),
    [anon_sym_void] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2902),
    [anon_sym_PLUS_PLUS] = ACTIONS(2900),
    [anon_sym_DASH_DASH] = ACTIONS(2900),
    [anon_sym_DQUOTE] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2900),
    [sym_number] = ACTIONS(2900),
    [sym_this] = ACTIONS(2902),
    [sym_super] = ACTIONS(2902),
    [sym_true] = ACTIONS(2902),
    [sym_false] = ACTIONS(2902),
    [sym_null] = ACTIONS(2902),
    [sym_undefined] = ACTIONS(2902),
    [anon_sym_AT] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_abstract] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2902),
    [anon_sym_set] = ACTIONS(2902),
    [anon_sym_declare] = ACTIONS(2902),
    [anon_sym_public] = ACTIONS(2902),
    [anon_sym_private] = ACTIONS(2902),
    [anon_sym_protected] = ACTIONS(2902),
    [anon_sym_module] = ACTIONS(2902),
    [anon_sym_any] = ACTIONS(2902),
    [anon_sym_number] = ACTIONS(2902),
    [anon_sym_boolean] = ACTIONS(2902),
    [anon_sym_string] = ACTIONS(2902),
    [anon_sym_symbol] = ACTIONS(2902),
    [anon_sym_interface] = ACTIONS(2902),
    [anon_sym_enum] = ACTIONS(2902),
    [sym_readonly] = ACTIONS(2902),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(2904),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_export] = ACTIONS(2906),
    [anon_sym_default] = ACTIONS(2906),
    [anon_sym_namespace] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_type] = ACTIONS(2906),
    [anon_sym_typeof] = ACTIONS(2906),
    [anon_sym_import] = ACTIONS(2906),
    [anon_sym_var] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_const] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_else] = ACTIONS(2906),
    [anon_sym_switch] = ACTIONS(2906),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2904),
    [anon_sym_await] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_break] = ACTIONS(2906),
    [anon_sym_continue] = ACTIONS(2906),
    [anon_sym_debugger] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_throw] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym_case] = ACTIONS(2906),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_SLASH] = ACTIONS(2906),
    [anon_sym_class] = ACTIONS(2906),
    [anon_sym_async] = ACTIONS(2906),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2904),
    [anon_sym_void] = ACTIONS(2906),
    [anon_sym_delete] = ACTIONS(2906),
    [anon_sym_PLUS_PLUS] = ACTIONS(2904),
    [anon_sym_DASH_DASH] = ACTIONS(2904),
    [anon_sym_DQUOTE] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2904),
    [sym_number] = ACTIONS(2904),
    [sym_this] = ACTIONS(2906),
    [sym_super] = ACTIONS(2906),
    [sym_true] = ACTIONS(2906),
    [sym_false] = ACTIONS(2906),
    [sym_null] = ACTIONS(2906),
    [sym_undefined] = ACTIONS(2906),
    [anon_sym_AT] = ACTIONS(2904),
    [anon_sym_static] = ACTIONS(2906),
    [anon_sym_abstract] = ACTIONS(2906),
    [anon_sym_get] = ACTIONS(2906),
    [anon_sym_set] = ACTIONS(2906),
    [anon_sym_declare] = ACTIONS(2906),
    [anon_sym_public] = ACTIONS(2906),
    [anon_sym_private] = ACTIONS(2906),
    [anon_sym_protected] = ACTIONS(2906),
    [anon_sym_module] = ACTIONS(2906),
    [anon_sym_any] = ACTIONS(2906),
    [anon_sym_number] = ACTIONS(2906),
    [anon_sym_boolean] = ACTIONS(2906),
    [anon_sym_string] = ACTIONS(2906),
    [anon_sym_symbol] = ACTIONS(2906),
    [anon_sym_interface] = ACTIONS(2906),
    [anon_sym_enum] = ACTIONS(2906),
    [sym_readonly] = ACTIONS(2906),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2908),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_export] = ACTIONS(2910),
    [anon_sym_default] = ACTIONS(2910),
    [anon_sym_namespace] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_type] = ACTIONS(2910),
    [anon_sym_typeof] = ACTIONS(2910),
    [anon_sym_import] = ACTIONS(2910),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_const] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_else] = ACTIONS(2910),
    [anon_sym_switch] = ACTIONS(2910),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_await] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_with] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2910),
    [anon_sym_continue] = ACTIONS(2910),
    [anon_sym_debugger] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_throw] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_case] = ACTIONS(2910),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(2910),
    [anon_sym_class] = ACTIONS(2910),
    [anon_sym_async] = ACTIONS(2910),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_void] = ACTIONS(2910),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_DQUOTE] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2908),
    [sym_number] = ACTIONS(2908),
    [sym_this] = ACTIONS(2910),
    [sym_super] = ACTIONS(2910),
    [sym_true] = ACTIONS(2910),
    [sym_false] = ACTIONS(2910),
    [sym_null] = ACTIONS(2910),
    [sym_undefined] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(2908),
    [anon_sym_static] = ACTIONS(2910),
    [anon_sym_abstract] = ACTIONS(2910),
    [anon_sym_get] = ACTIONS(2910),
    [anon_sym_set] = ACTIONS(2910),
    [anon_sym_declare] = ACTIONS(2910),
    [anon_sym_public] = ACTIONS(2910),
    [anon_sym_private] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(2910),
    [anon_sym_module] = ACTIONS(2910),
    [anon_sym_any] = ACTIONS(2910),
    [anon_sym_number] = ACTIONS(2910),
    [anon_sym_boolean] = ACTIONS(2910),
    [anon_sym_string] = ACTIONS(2910),
    [anon_sym_symbol] = ACTIONS(2910),
    [anon_sym_interface] = ACTIONS(2910),
    [anon_sym_enum] = ACTIONS(2910),
    [sym_readonly] = ACTIONS(2910),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2912),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_export] = ACTIONS(2914),
    [anon_sym_default] = ACTIONS(2914),
    [anon_sym_namespace] = ACTIONS(2914),
    [anon_sym_LBRACE] = ACTIONS(2912),
    [anon_sym_RBRACE] = ACTIONS(2912),
    [anon_sym_type] = ACTIONS(2914),
    [anon_sym_typeof] = ACTIONS(2914),
    [anon_sym_import] = ACTIONS(2914),
    [anon_sym_var] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_const] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_else] = ACTIONS(2914),
    [anon_sym_switch] = ACTIONS(2914),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(2912),
    [anon_sym_await] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_with] = ACTIONS(2914),
    [anon_sym_break] = ACTIONS(2914),
    [anon_sym_continue] = ACTIONS(2914),
    [anon_sym_debugger] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_throw] = ACTIONS(2914),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_case] = ACTIONS(2914),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_SLASH] = ACTIONS(2914),
    [anon_sym_class] = ACTIONS(2914),
    [anon_sym_async] = ACTIONS(2914),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_BANG] = ACTIONS(2912),
    [anon_sym_TILDE] = ACTIONS(2912),
    [anon_sym_void] = ACTIONS(2914),
    [anon_sym_delete] = ACTIONS(2914),
    [anon_sym_PLUS_PLUS] = ACTIONS(2912),
    [anon_sym_DASH_DASH] = ACTIONS(2912),
    [anon_sym_DQUOTE] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2912),
    [sym_number] = ACTIONS(2912),
    [sym_this] = ACTIONS(2914),
    [sym_super] = ACTIONS(2914),
    [sym_true] = ACTIONS(2914),
    [sym_false] = ACTIONS(2914),
    [sym_null] = ACTIONS(2914),
    [sym_undefined] = ACTIONS(2914),
    [anon_sym_AT] = ACTIONS(2912),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_abstract] = ACTIONS(2914),
    [anon_sym_get] = ACTIONS(2914),
    [anon_sym_set] = ACTIONS(2914),
    [anon_sym_declare] = ACTIONS(2914),
    [anon_sym_public] = ACTIONS(2914),
    [anon_sym_private] = ACTIONS(2914),
    [anon_sym_protected] = ACTIONS(2914),
    [anon_sym_module] = ACTIONS(2914),
    [anon_sym_any] = ACTIONS(2914),
    [anon_sym_number] = ACTIONS(2914),
    [anon_sym_boolean] = ACTIONS(2914),
    [anon_sym_string] = ACTIONS(2914),
    [anon_sym_symbol] = ACTIONS(2914),
    [anon_sym_interface] = ACTIONS(2914),
    [anon_sym_enum] = ACTIONS(2914),
    [sym_readonly] = ACTIONS(2914),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2916),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_export] = ACTIONS(2918),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2916),
    [anon_sym_RBRACE] = ACTIONS(2916),
    [anon_sym_type] = ACTIONS(2918),
    [anon_sym_typeof] = ACTIONS(2918),
    [anon_sym_import] = ACTIONS(2918),
    [anon_sym_var] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(2918),
    [anon_sym_switch] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_LPAREN] = ACTIONS(2916),
    [anon_sym_await] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_with] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2918),
    [anon_sym_debugger] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_throw] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2916),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_SLASH] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_async] = ACTIONS(2918),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2916),
    [anon_sym_TILDE] = ACTIONS(2916),
    [anon_sym_void] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_PLUS_PLUS] = ACTIONS(2916),
    [anon_sym_DASH_DASH] = ACTIONS(2916),
    [anon_sym_DQUOTE] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2916),
    [sym_number] = ACTIONS(2916),
    [sym_this] = ACTIONS(2918),
    [sym_super] = ACTIONS(2918),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [sym_null] = ACTIONS(2918),
    [sym_undefined] = ACTIONS(2918),
    [anon_sym_AT] = ACTIONS(2916),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_abstract] = ACTIONS(2918),
    [anon_sym_get] = ACTIONS(2918),
    [anon_sym_set] = ACTIONS(2918),
    [anon_sym_declare] = ACTIONS(2918),
    [anon_sym_public] = ACTIONS(2918),
    [anon_sym_private] = ACTIONS(2918),
    [anon_sym_protected] = ACTIONS(2918),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_any] = ACTIONS(2918),
    [anon_sym_number] = ACTIONS(2918),
    [anon_sym_boolean] = ACTIONS(2918),
    [anon_sym_string] = ACTIONS(2918),
    [anon_sym_symbol] = ACTIONS(2918),
    [anon_sym_interface] = ACTIONS(2918),
    [anon_sym_enum] = ACTIONS(2918),
    [sym_readonly] = ACTIONS(2918),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2920),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_export] = ACTIONS(2922),
    [anon_sym_default] = ACTIONS(2922),
    [anon_sym_namespace] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_type] = ACTIONS(2922),
    [anon_sym_typeof] = ACTIONS(2922),
    [anon_sym_import] = ACTIONS(2922),
    [anon_sym_var] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_const] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2920),
    [anon_sym_await] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_break] = ACTIONS(2922),
    [anon_sym_continue] = ACTIONS(2922),
    [anon_sym_debugger] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_throw] = ACTIONS(2922),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2922),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_class] = ACTIONS(2922),
    [anon_sym_async] = ACTIONS(2922),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_void] = ACTIONS(2922),
    [anon_sym_delete] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2920),
    [sym_number] = ACTIONS(2920),
    [sym_this] = ACTIONS(2922),
    [sym_super] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_null] = ACTIONS(2922),
    [sym_undefined] = ACTIONS(2922),
    [anon_sym_AT] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2922),
    [anon_sym_abstract] = ACTIONS(2922),
    [anon_sym_get] = ACTIONS(2922),
    [anon_sym_set] = ACTIONS(2922),
    [anon_sym_declare] = ACTIONS(2922),
    [anon_sym_public] = ACTIONS(2922),
    [anon_sym_private] = ACTIONS(2922),
    [anon_sym_protected] = ACTIONS(2922),
    [anon_sym_module] = ACTIONS(2922),
    [anon_sym_any] = ACTIONS(2922),
    [anon_sym_number] = ACTIONS(2922),
    [anon_sym_boolean] = ACTIONS(2922),
    [anon_sym_string] = ACTIONS(2922),
    [anon_sym_symbol] = ACTIONS(2922),
    [anon_sym_interface] = ACTIONS(2922),
    [anon_sym_enum] = ACTIONS(2922),
    [sym_readonly] = ACTIONS(2922),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_export] = ACTIONS(2926),
    [anon_sym_default] = ACTIONS(2926),
    [anon_sym_namespace] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_type] = ACTIONS(2926),
    [anon_sym_typeof] = ACTIONS(2926),
    [anon_sym_import] = ACTIONS(2926),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_else] = ACTIONS(2926),
    [anon_sym_switch] = ACTIONS(2926),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2924),
    [anon_sym_await] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_break] = ACTIONS(2926),
    [anon_sym_continue] = ACTIONS(2926),
    [anon_sym_debugger] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_throw] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2926),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_SLASH] = ACTIONS(2926),
    [anon_sym_class] = ACTIONS(2926),
    [anon_sym_async] = ACTIONS(2926),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_void] = ACTIONS(2926),
    [anon_sym_delete] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_DQUOTE] = ACTIONS(2924),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2924),
    [sym_number] = ACTIONS(2924),
    [sym_this] = ACTIONS(2926),
    [sym_super] = ACTIONS(2926),
    [sym_true] = ACTIONS(2926),
    [sym_false] = ACTIONS(2926),
    [sym_null] = ACTIONS(2926),
    [sym_undefined] = ACTIONS(2926),
    [anon_sym_AT] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_abstract] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2926),
    [anon_sym_set] = ACTIONS(2926),
    [anon_sym_declare] = ACTIONS(2926),
    [anon_sym_public] = ACTIONS(2926),
    [anon_sym_private] = ACTIONS(2926),
    [anon_sym_protected] = ACTIONS(2926),
    [anon_sym_module] = ACTIONS(2926),
    [anon_sym_any] = ACTIONS(2926),
    [anon_sym_number] = ACTIONS(2926),
    [anon_sym_boolean] = ACTIONS(2926),
    [anon_sym_string] = ACTIONS(2926),
    [anon_sym_symbol] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2926),
    [anon_sym_enum] = ACTIONS(2926),
    [sym_readonly] = ACTIONS(2926),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2928),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_export] = ACTIONS(2930),
    [anon_sym_default] = ACTIONS(2930),
    [anon_sym_namespace] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_type] = ACTIONS(2930),
    [anon_sym_typeof] = ACTIONS(2930),
    [anon_sym_import] = ACTIONS(2930),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_else] = ACTIONS(2930),
    [anon_sym_switch] = ACTIONS(2930),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_LPAREN] = ACTIONS(2928),
    [anon_sym_await] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_break] = ACTIONS(2930),
    [anon_sym_continue] = ACTIONS(2930),
    [anon_sym_debugger] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_throw] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_class] = ACTIONS(2930),
    [anon_sym_async] = ACTIONS(2930),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_TILDE] = ACTIONS(2928),
    [anon_sym_void] = ACTIONS(2930),
    [anon_sym_delete] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [anon_sym_SQUOTE] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2928),
    [sym_number] = ACTIONS(2928),
    [sym_this] = ACTIONS(2930),
    [sym_super] = ACTIONS(2930),
    [sym_true] = ACTIONS(2930),
    [sym_false] = ACTIONS(2930),
    [sym_null] = ACTIONS(2930),
    [sym_undefined] = ACTIONS(2930),
    [anon_sym_AT] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_abstract] = ACTIONS(2930),
    [anon_sym_get] = ACTIONS(2930),
    [anon_sym_set] = ACTIONS(2930),
    [anon_sym_declare] = ACTIONS(2930),
    [anon_sym_public] = ACTIONS(2930),
    [anon_sym_private] = ACTIONS(2930),
    [anon_sym_protected] = ACTIONS(2930),
    [anon_sym_module] = ACTIONS(2930),
    [anon_sym_any] = ACTIONS(2930),
    [anon_sym_number] = ACTIONS(2930),
    [anon_sym_boolean] = ACTIONS(2930),
    [anon_sym_string] = ACTIONS(2930),
    [anon_sym_symbol] = ACTIONS(2930),
    [anon_sym_interface] = ACTIONS(2930),
    [anon_sym_enum] = ACTIONS(2930),
    [sym_readonly] = ACTIONS(2930),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_typeof] = ACTIONS(2934),
    [anon_sym_import] = ACTIONS(2934),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_else] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2932),
    [anon_sym_await] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_debugger] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2932),
    [sym_number] = ACTIONS(2932),
    [sym_this] = ACTIONS(2934),
    [sym_super] = ACTIONS(2934),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [sym_null] = ACTIONS(2934),
    [sym_undefined] = ACTIONS(2934),
    [anon_sym_AT] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_abstract] = ACTIONS(2934),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [sym_readonly] = ACTIONS(2934),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2936),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_export] = ACTIONS(2938),
    [anon_sym_default] = ACTIONS(2938),
    [anon_sym_namespace] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_type] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2938),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_else] = ACTIONS(2938),
    [anon_sym_switch] = ACTIONS(2938),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_await] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_break] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2938),
    [anon_sym_debugger] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_throw] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2938),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2938),
    [anon_sym_async] = ACTIONS(2938),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2936),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_void] = ACTIONS(2938),
    [anon_sym_delete] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [anon_sym_SQUOTE] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [sym_number] = ACTIONS(2936),
    [sym_this] = ACTIONS(2938),
    [sym_super] = ACTIONS(2938),
    [sym_true] = ACTIONS(2938),
    [sym_false] = ACTIONS(2938),
    [sym_null] = ACTIONS(2938),
    [sym_undefined] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_abstract] = ACTIONS(2938),
    [anon_sym_get] = ACTIONS(2938),
    [anon_sym_set] = ACTIONS(2938),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_public] = ACTIONS(2938),
    [anon_sym_private] = ACTIONS(2938),
    [anon_sym_protected] = ACTIONS(2938),
    [anon_sym_module] = ACTIONS(2938),
    [anon_sym_any] = ACTIONS(2938),
    [anon_sym_number] = ACTIONS(2938),
    [anon_sym_boolean] = ACTIONS(2938),
    [anon_sym_string] = ACTIONS(2938),
    [anon_sym_symbol] = ACTIONS(2938),
    [anon_sym_interface] = ACTIONS(2938),
    [anon_sym_enum] = ACTIONS(2938),
    [sym_readonly] = ACTIONS(2938),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2940),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_default] = ACTIONS(2942),
    [anon_sym_namespace] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_type] = ACTIONS(2942),
    [anon_sym_typeof] = ACTIONS(2942),
    [anon_sym_import] = ACTIONS(2942),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_else] = ACTIONS(2942),
    [anon_sym_switch] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2940),
    [anon_sym_await] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_debugger] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_throw] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_case] = ACTIONS(2942),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_SLASH] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2940),
    [anon_sym_void] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_DQUOTE] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2940),
    [sym_number] = ACTIONS(2940),
    [sym_this] = ACTIONS(2942),
    [sym_super] = ACTIONS(2942),
    [sym_true] = ACTIONS(2942),
    [sym_false] = ACTIONS(2942),
    [sym_null] = ACTIONS(2942),
    [sym_undefined] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2940),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_abstract] = ACTIONS(2942),
    [anon_sym_get] = ACTIONS(2942),
    [anon_sym_set] = ACTIONS(2942),
    [anon_sym_declare] = ACTIONS(2942),
    [anon_sym_public] = ACTIONS(2942),
    [anon_sym_private] = ACTIONS(2942),
    [anon_sym_protected] = ACTIONS(2942),
    [anon_sym_module] = ACTIONS(2942),
    [anon_sym_any] = ACTIONS(2942),
    [anon_sym_number] = ACTIONS(2942),
    [anon_sym_boolean] = ACTIONS(2942),
    [anon_sym_string] = ACTIONS(2942),
    [anon_sym_symbol] = ACTIONS(2942),
    [anon_sym_interface] = ACTIONS(2942),
    [anon_sym_enum] = ACTIONS(2942),
    [sym_readonly] = ACTIONS(2942),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2944),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_await] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2944),
    [anon_sym_TILDE] = ACTIONS(2944),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_SQUOTE] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [sym_number] = ACTIONS(2944),
    [sym_this] = ACTIONS(2946),
    [sym_super] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [sym_null] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2944),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [sym_readonly] = ACTIONS(2946),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_export] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_type] = ACTIONS(2950),
    [anon_sym_typeof] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(2950),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2948),
    [anon_sym_await] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_debugger] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_async] = ACTIONS(2950),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_void] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2948),
    [sym_number] = ACTIONS(2948),
    [sym_this] = ACTIONS(2950),
    [sym_super] = ACTIONS(2950),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [sym_null] = ACTIONS(2950),
    [sym_undefined] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2950),
    [anon_sym_get] = ACTIONS(2950),
    [anon_sym_set] = ACTIONS(2950),
    [anon_sym_declare] = ACTIONS(2950),
    [anon_sym_public] = ACTIONS(2950),
    [anon_sym_private] = ACTIONS(2950),
    [anon_sym_protected] = ACTIONS(2950),
    [anon_sym_module] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(2950),
    [anon_sym_number] = ACTIONS(2950),
    [anon_sym_boolean] = ACTIONS(2950),
    [anon_sym_string] = ACTIONS(2950),
    [anon_sym_symbol] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [sym_readonly] = ACTIONS(2950),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2952),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_export] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_type] = ACTIONS(2954),
    [anon_sym_typeof] = ACTIONS(2954),
    [anon_sym_import] = ACTIONS(2954),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_await] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_debugger] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_async] = ACTIONS(2954),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_void] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [sym_number] = ACTIONS(2952),
    [sym_this] = ACTIONS(2954),
    [sym_super] = ACTIONS(2954),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [sym_null] = ACTIONS(2954),
    [sym_undefined] = ACTIONS(2954),
    [anon_sym_AT] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_abstract] = ACTIONS(2954),
    [anon_sym_get] = ACTIONS(2954),
    [anon_sym_set] = ACTIONS(2954),
    [anon_sym_declare] = ACTIONS(2954),
    [anon_sym_public] = ACTIONS(2954),
    [anon_sym_private] = ACTIONS(2954),
    [anon_sym_protected] = ACTIONS(2954),
    [anon_sym_module] = ACTIONS(2954),
    [anon_sym_any] = ACTIONS(2954),
    [anon_sym_number] = ACTIONS(2954),
    [anon_sym_boolean] = ACTIONS(2954),
    [anon_sym_string] = ACTIONS(2954),
    [anon_sym_symbol] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [sym_readonly] = ACTIONS(2954),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2956),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_export] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_type] = ACTIONS(2958),
    [anon_sym_typeof] = ACTIONS(2958),
    [anon_sym_import] = ACTIONS(2958),
    [anon_sym_var] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2956),
    [anon_sym_await] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_debugger] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_SLASH] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_async] = ACTIONS(2958),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_void] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2956),
    [sym_number] = ACTIONS(2956),
    [sym_this] = ACTIONS(2958),
    [sym_super] = ACTIONS(2958),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [sym_null] = ACTIONS(2958),
    [sym_undefined] = ACTIONS(2958),
    [anon_sym_AT] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_abstract] = ACTIONS(2958),
    [anon_sym_get] = ACTIONS(2958),
    [anon_sym_set] = ACTIONS(2958),
    [anon_sym_declare] = ACTIONS(2958),
    [anon_sym_public] = ACTIONS(2958),
    [anon_sym_private] = ACTIONS(2958),
    [anon_sym_protected] = ACTIONS(2958),
    [anon_sym_module] = ACTIONS(2958),
    [anon_sym_any] = ACTIONS(2958),
    [anon_sym_number] = ACTIONS(2958),
    [anon_sym_boolean] = ACTIONS(2958),
    [anon_sym_string] = ACTIONS(2958),
    [anon_sym_symbol] = ACTIONS(2958),
    [anon_sym_interface] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [sym_readonly] = ACTIONS(2958),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2960),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_export] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_type] = ACTIONS(2962),
    [anon_sym_typeof] = ACTIONS(2962),
    [anon_sym_import] = ACTIONS(2962),
    [anon_sym_var] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_await] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_debugger] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_async] = ACTIONS(2962),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_void] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2960),
    [sym_number] = ACTIONS(2960),
    [sym_this] = ACTIONS(2962),
    [sym_super] = ACTIONS(2962),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [sym_null] = ACTIONS(2962),
    [sym_undefined] = ACTIONS(2962),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_abstract] = ACTIONS(2962),
    [anon_sym_get] = ACTIONS(2962),
    [anon_sym_set] = ACTIONS(2962),
    [anon_sym_declare] = ACTIONS(2962),
    [anon_sym_public] = ACTIONS(2962),
    [anon_sym_private] = ACTIONS(2962),
    [anon_sym_protected] = ACTIONS(2962),
    [anon_sym_module] = ACTIONS(2962),
    [anon_sym_any] = ACTIONS(2962),
    [anon_sym_number] = ACTIONS(2962),
    [anon_sym_boolean] = ACTIONS(2962),
    [anon_sym_string] = ACTIONS(2962),
    [anon_sym_symbol] = ACTIONS(2962),
    [anon_sym_interface] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [sym_readonly] = ACTIONS(2962),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2964),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_type] = ACTIONS(2966),
    [anon_sym_typeof] = ACTIONS(2966),
    [anon_sym_import] = ACTIONS(2966),
    [anon_sym_var] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2964),
    [anon_sym_await] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_debugger] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_async] = ACTIONS(2966),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_void] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2964),
    [sym_number] = ACTIONS(2964),
    [sym_this] = ACTIONS(2966),
    [sym_super] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [sym_null] = ACTIONS(2966),
    [sym_undefined] = ACTIONS(2966),
    [anon_sym_AT] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_abstract] = ACTIONS(2966),
    [anon_sym_get] = ACTIONS(2966),
    [anon_sym_set] = ACTIONS(2966),
    [anon_sym_declare] = ACTIONS(2966),
    [anon_sym_public] = ACTIONS(2966),
    [anon_sym_private] = ACTIONS(2966),
    [anon_sym_protected] = ACTIONS(2966),
    [anon_sym_module] = ACTIONS(2966),
    [anon_sym_any] = ACTIONS(2966),
    [anon_sym_number] = ACTIONS(2966),
    [anon_sym_boolean] = ACTIONS(2966),
    [anon_sym_string] = ACTIONS(2966),
    [anon_sym_symbol] = ACTIONS(2966),
    [anon_sym_interface] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [sym_readonly] = ACTIONS(2966),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2968),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_export] = ACTIONS(2970),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_namespace] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_type] = ACTIONS(2970),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_import] = ACTIONS(2970),
    [anon_sym_var] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_const] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_switch] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2968),
    [anon_sym_await] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_continue] = ACTIONS(2970),
    [anon_sym_debugger] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_throw] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_delete] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2968),
    [sym_number] = ACTIONS(2968),
    [sym_this] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_AT] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_declare] = ACTIONS(2970),
    [anon_sym_public] = ACTIONS(2970),
    [anon_sym_private] = ACTIONS(2970),
    [anon_sym_protected] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_interface] = ACTIONS(2970),
    [anon_sym_enum] = ACTIONS(2970),
    [sym_readonly] = ACTIONS(2970),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_typeof] = ACTIONS(2974),
    [anon_sym_import] = ACTIONS(2974),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_else] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_await] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_debugger] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_this] = ACTIONS(2974),
    [sym_super] = ACTIONS(2974),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_null] = ACTIONS(2974),
    [sym_undefined] = ACTIONS(2974),
    [anon_sym_AT] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_abstract] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [sym_readonly] = ACTIONS(2974),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2976),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_type] = ACTIONS(2978),
    [anon_sym_typeof] = ACTIONS(2978),
    [anon_sym_import] = ACTIONS(2978),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2976),
    [anon_sym_await] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_debugger] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_async] = ACTIONS(2978),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_void] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [sym_number] = ACTIONS(2976),
    [sym_this] = ACTIONS(2978),
    [sym_super] = ACTIONS(2978),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_null] = ACTIONS(2978),
    [sym_undefined] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_abstract] = ACTIONS(2978),
    [anon_sym_get] = ACTIONS(2978),
    [anon_sym_set] = ACTIONS(2978),
    [anon_sym_declare] = ACTIONS(2978),
    [anon_sym_public] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2978),
    [anon_sym_protected] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_any] = ACTIONS(2978),
    [anon_sym_number] = ACTIONS(2978),
    [anon_sym_boolean] = ACTIONS(2978),
    [anon_sym_string] = ACTIONS(2978),
    [anon_sym_symbol] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [sym_readonly] = ACTIONS(2978),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2980),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_export] = ACTIONS(2982),
    [anon_sym_default] = ACTIONS(2982),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_type] = ACTIONS(2982),
    [anon_sym_typeof] = ACTIONS(2982),
    [anon_sym_import] = ACTIONS(2982),
    [anon_sym_var] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2982),
    [anon_sym_const] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2980),
    [anon_sym_await] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_do] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2982),
    [anon_sym_with] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_continue] = ACTIONS(2982),
    [anon_sym_debugger] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_throw] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_function] = ACTIONS(2982),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_delete] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [sym_number] = ACTIONS(2980),
    [sym_this] = ACTIONS(2982),
    [sym_super] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_undefined] = ACTIONS(2982),
    [anon_sym_AT] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_abstract] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_declare] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2982),
    [anon_sym_enum] = ACTIONS(2982),
    [sym_readonly] = ACTIONS(2982),
  },
  [603] = {
    [sym__call_signature] = STATE(2886),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(761),
    [anon_sym_of] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [sym_readonly] = ACTIONS(2548),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [sym_readonly] = ACTIONS(2548),
  },
  [606] = {
    [sym__call_signature] = STATE(2886),
    [sym_formal_parameters] = STATE(2313),
    [sym_type_parameters] = STATE(2634),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2593),
    [anon_sym_in] = ACTIONS(597),
    [anon_sym_of] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(2986),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_typeof] = ACTIONS(2984),
    [anon_sym_import] = ACTIONS(2984),
    [anon_sym_var] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_const] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_switch] = ACTIONS(2984),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2986),
    [anon_sym_await] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_continue] = ACTIONS(2984),
    [anon_sym_debugger] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_throw] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_SLASH] = ACTIONS(2984),
    [anon_sym_class] = ACTIONS(2984),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [anon_sym_void] = ACTIONS(2984),
    [anon_sym_delete] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2986),
    [anon_sym_DASH_DASH] = ACTIONS(2986),
    [anon_sym_DQUOTE] = ACTIONS(2986),
    [anon_sym_SQUOTE] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2986),
    [sym_number] = ACTIONS(2986),
    [sym_this] = ACTIONS(2984),
    [sym_super] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [sym_false] = ACTIONS(2984),
    [sym_null] = ACTIONS(2984),
    [sym_undefined] = ACTIONS(2984),
    [anon_sym_AT] = ACTIONS(2986),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_abstract] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_interface] = ACTIONS(2984),
    [anon_sym_enum] = ACTIONS(2984),
    [sym_readonly] = ACTIONS(2984),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_export] = ACTIONS(2988),
    [anon_sym_namespace] = ACTIONS(2988),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_type] = ACTIONS(2988),
    [anon_sym_typeof] = ACTIONS(2988),
    [anon_sym_import] = ACTIONS(2988),
    [anon_sym_var] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_const] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_switch] = ACTIONS(2988),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_await] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_break] = ACTIONS(2988),
    [anon_sym_continue] = ACTIONS(2988),
    [anon_sym_debugger] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_throw] = ACTIONS(2988),
    [anon_sym_SEMI] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2988),
    [anon_sym_class] = ACTIONS(2988),
    [anon_sym_async] = ACTIONS(2988),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_TILDE] = ACTIONS(2990),
    [anon_sym_void] = ACTIONS(2988),
    [anon_sym_delete] = ACTIONS(2988),
    [anon_sym_PLUS_PLUS] = ACTIONS(2990),
    [anon_sym_DASH_DASH] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2990),
    [sym_number] = ACTIONS(2990),
    [sym_this] = ACTIONS(2988),
    [sym_super] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_null] = ACTIONS(2988),
    [sym_undefined] = ACTIONS(2988),
    [anon_sym_AT] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_abstract] = ACTIONS(2988),
    [anon_sym_get] = ACTIONS(2988),
    [anon_sym_set] = ACTIONS(2988),
    [anon_sym_declare] = ACTIONS(2988),
    [anon_sym_public] = ACTIONS(2988),
    [anon_sym_private] = ACTIONS(2988),
    [anon_sym_protected] = ACTIONS(2988),
    [anon_sym_module] = ACTIONS(2988),
    [anon_sym_any] = ACTIONS(2988),
    [anon_sym_number] = ACTIONS(2988),
    [anon_sym_boolean] = ACTIONS(2988),
    [anon_sym_string] = ACTIONS(2988),
    [anon_sym_symbol] = ACTIONS(2988),
    [anon_sym_interface] = ACTIONS(2988),
    [anon_sym_enum] = ACTIONS(2988),
    [sym_readonly] = ACTIONS(2988),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_export] = ACTIONS(2992),
    [anon_sym_namespace] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_type] = ACTIONS(2992),
    [anon_sym_typeof] = ACTIONS(2992),
    [anon_sym_import] = ACTIONS(2992),
    [anon_sym_var] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_const] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_switch] = ACTIONS(2992),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2994),
    [anon_sym_await] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_break] = ACTIONS(2992),
    [anon_sym_continue] = ACTIONS(2992),
    [anon_sym_debugger] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_throw] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_SLASH] = ACTIONS(2992),
    [anon_sym_class] = ACTIONS(2992),
    [anon_sym_async] = ACTIONS(2992),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [anon_sym_void] = ACTIONS(2992),
    [anon_sym_delete] = ACTIONS(2992),
    [anon_sym_PLUS_PLUS] = ACTIONS(2994),
    [anon_sym_DASH_DASH] = ACTIONS(2994),
    [anon_sym_DQUOTE] = ACTIONS(2994),
    [anon_sym_SQUOTE] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2994),
    [sym_number] = ACTIONS(2994),
    [sym_this] = ACTIONS(2992),
    [sym_super] = ACTIONS(2992),
    [sym_true] = ACTIONS(2992),
    [sym_false] = ACTIONS(2992),
    [sym_null] = ACTIONS(2992),
    [sym_undefined] = ACTIONS(2992),
    [anon_sym_AT] = ACTIONS(2994),
    [anon_sym_static] = ACTIONS(2992),
    [anon_sym_abstract] = ACTIONS(2992),
    [anon_sym_get] = ACTIONS(2992),
    [anon_sym_set] = ACTIONS(2992),
    [anon_sym_declare] = ACTIONS(2992),
    [anon_sym_public] = ACTIONS(2992),
    [anon_sym_private] = ACTIONS(2992),
    [anon_sym_protected] = ACTIONS(2992),
    [anon_sym_module] = ACTIONS(2992),
    [anon_sym_any] = ACTIONS(2992),
    [anon_sym_number] = ACTIONS(2992),
    [anon_sym_boolean] = ACTIONS(2992),
    [anon_sym_string] = ACTIONS(2992),
    [anon_sym_symbol] = ACTIONS(2992),
    [anon_sym_interface] = ACTIONS(2992),
    [anon_sym_enum] = ACTIONS(2992),
    [sym_readonly] = ACTIONS(2992),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_export] = ACTIONS(2996),
    [anon_sym_namespace] = ACTIONS(2996),
    [anon_sym_LBRACE] = ACTIONS(2998),
    [anon_sym_type] = ACTIONS(2996),
    [anon_sym_typeof] = ACTIONS(2996),
    [anon_sym_import] = ACTIONS(2996),
    [anon_sym_var] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_const] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_switch] = ACTIONS(2996),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2998),
    [anon_sym_await] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_break] = ACTIONS(2996),
    [anon_sym_continue] = ACTIONS(2996),
    [anon_sym_debugger] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_throw] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_SLASH] = ACTIONS(2996),
    [anon_sym_class] = ACTIONS(2996),
    [anon_sym_async] = ACTIONS(2996),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_BANG] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(2998),
    [anon_sym_void] = ACTIONS(2996),
    [anon_sym_delete] = ACTIONS(2996),
    [anon_sym_PLUS_PLUS] = ACTIONS(2998),
    [anon_sym_DASH_DASH] = ACTIONS(2998),
    [anon_sym_DQUOTE] = ACTIONS(2998),
    [anon_sym_SQUOTE] = ACTIONS(2998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2998),
    [sym_number] = ACTIONS(2998),
    [sym_this] = ACTIONS(2996),
    [sym_super] = ACTIONS(2996),
    [sym_true] = ACTIONS(2996),
    [sym_false] = ACTIONS(2996),
    [sym_null] = ACTIONS(2996),
    [sym_undefined] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_abstract] = ACTIONS(2996),
    [anon_sym_get] = ACTIONS(2996),
    [anon_sym_set] = ACTIONS(2996),
    [anon_sym_declare] = ACTIONS(2996),
    [anon_sym_public] = ACTIONS(2996),
    [anon_sym_private] = ACTIONS(2996),
    [anon_sym_protected] = ACTIONS(2996),
    [anon_sym_module] = ACTIONS(2996),
    [anon_sym_any] = ACTIONS(2996),
    [anon_sym_number] = ACTIONS(2996),
    [anon_sym_boolean] = ACTIONS(2996),
    [anon_sym_string] = ACTIONS(2996),
    [anon_sym_symbol] = ACTIONS(2996),
    [anon_sym_interface] = ACTIONS(2996),
    [anon_sym_enum] = ACTIONS(2996),
    [sym_readonly] = ACTIONS(2996),
  },
  [611] = {
    [sym_identifier] = ACTIONS(3000),
    [anon_sym_export] = ACTIONS(3000),
    [anon_sym_namespace] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_type] = ACTIONS(3000),
    [anon_sym_typeof] = ACTIONS(3000),
    [anon_sym_import] = ACTIONS(3000),
    [anon_sym_var] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(3000),
    [anon_sym_const] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(3000),
    [anon_sym_switch] = ACTIONS(3000),
    [anon_sym_for] = ACTIONS(3000),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_await] = ACTIONS(3000),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_do] = ACTIONS(3000),
    [anon_sym_try] = ACTIONS(3000),
    [anon_sym_with] = ACTIONS(3000),
    [anon_sym_break] = ACTIONS(3000),
    [anon_sym_continue] = ACTIONS(3000),
    [anon_sym_debugger] = ACTIONS(3000),
    [anon_sym_return] = ACTIONS(3000),
    [anon_sym_throw] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_yield] = ACTIONS(3000),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3000),
    [anon_sym_class] = ACTIONS(3000),
    [anon_sym_async] = ACTIONS(3000),
    [anon_sym_function] = ACTIONS(3000),
    [anon_sym_new] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_BANG] = ACTIONS(3002),
    [anon_sym_TILDE] = ACTIONS(3002),
    [anon_sym_void] = ACTIONS(3000),
    [anon_sym_delete] = ACTIONS(3000),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_DQUOTE] = ACTIONS(3002),
    [anon_sym_SQUOTE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [sym_number] = ACTIONS(3002),
    [sym_this] = ACTIONS(3000),
    [sym_super] = ACTIONS(3000),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [sym_null] = ACTIONS(3000),
    [sym_undefined] = ACTIONS(3000),
    [anon_sym_AT] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3000),
    [anon_sym_abstract] = ACTIONS(3000),
    [anon_sym_get] = ACTIONS(3000),
    [anon_sym_set] = ACTIONS(3000),
    [anon_sym_declare] = ACTIONS(3000),
    [anon_sym_public] = ACTIONS(3000),
    [anon_sym_private] = ACTIONS(3000),
    [anon_sym_protected] = ACTIONS(3000),
    [anon_sym_module] = ACTIONS(3000),
    [anon_sym_any] = ACTIONS(3000),
    [anon_sym_number] = ACTIONS(3000),
    [anon_sym_boolean] = ACTIONS(3000),
    [anon_sym_string] = ACTIONS(3000),
    [anon_sym_symbol] = ACTIONS(3000),
    [anon_sym_interface] = ACTIONS(3000),
    [anon_sym_enum] = ACTIONS(3000),
    [sym_readonly] = ACTIONS(3000),
  },
  [612] = {
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3004),
    [anon_sym_LBRACE] = ACTIONS(3006),
    [anon_sym_type] = ACTIONS(3004),
    [anon_sym_typeof] = ACTIONS(3004),
    [anon_sym_import] = ACTIONS(3004),
    [anon_sym_var] = ACTIONS(3004),
    [anon_sym_let] = ACTIONS(3004),
    [anon_sym_const] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3004),
    [anon_sym_switch] = ACTIONS(3004),
    [anon_sym_for] = ACTIONS(3004),
    [anon_sym_LPAREN] = ACTIONS(3006),
    [anon_sym_await] = ACTIONS(3004),
    [anon_sym_while] = ACTIONS(3004),
    [anon_sym_do] = ACTIONS(3004),
    [anon_sym_try] = ACTIONS(3004),
    [anon_sym_with] = ACTIONS(3004),
    [anon_sym_break] = ACTIONS(3004),
    [anon_sym_continue] = ACTIONS(3004),
    [anon_sym_debugger] = ACTIONS(3004),
    [anon_sym_return] = ACTIONS(3004),
    [anon_sym_throw] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_yield] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_class] = ACTIONS(3004),
    [anon_sym_async] = ACTIONS(3004),
    [anon_sym_function] = ACTIONS(3004),
    [anon_sym_new] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3006),
    [anon_sym_TILDE] = ACTIONS(3006),
    [anon_sym_void] = ACTIONS(3004),
    [anon_sym_delete] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3006),
    [anon_sym_DASH_DASH] = ACTIONS(3006),
    [anon_sym_DQUOTE] = ACTIONS(3006),
    [anon_sym_SQUOTE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3006),
    [sym_number] = ACTIONS(3006),
    [sym_this] = ACTIONS(3004),
    [sym_super] = ACTIONS(3004),
    [sym_true] = ACTIONS(3004),
    [sym_false] = ACTIONS(3004),
    [sym_null] = ACTIONS(3004),
    [sym_undefined] = ACTIONS(3004),
    [anon_sym_AT] = ACTIONS(3006),
    [anon_sym_static] = ACTIONS(3004),
    [anon_sym_abstract] = ACTIONS(3004),
    [anon_sym_get] = ACTIONS(3004),
    [anon_sym_set] = ACTIONS(3004),
    [anon_sym_declare] = ACTIONS(3004),
    [anon_sym_public] = ACTIONS(3004),
    [anon_sym_private] = ACTIONS(3004),
    [anon_sym_protected] = ACTIONS(3004),
    [anon_sym_module] = ACTIONS(3004),
    [anon_sym_any] = ACTIONS(3004),
    [anon_sym_number] = ACTIONS(3004),
    [anon_sym_boolean] = ACTIONS(3004),
    [anon_sym_string] = ACTIONS(3004),
    [anon_sym_symbol] = ACTIONS(3004),
    [anon_sym_interface] = ACTIONS(3004),
    [anon_sym_enum] = ACTIONS(3004),
    [sym_readonly] = ACTIONS(3004),
  },
  [613] = {
    [sym_identifier] = ACTIONS(3008),
    [anon_sym_export] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_type] = ACTIONS(3008),
    [anon_sym_typeof] = ACTIONS(3008),
    [anon_sym_import] = ACTIONS(3008),
    [anon_sym_var] = ACTIONS(3008),
    [anon_sym_let] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_await] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_with] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_debugger] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_async] = ACTIONS(3008),
    [anon_sym_function] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_void] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(3008),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_abstract] = ACTIONS(3008),
    [anon_sym_get] = ACTIONS(3008),
    [anon_sym_set] = ACTIONS(3008),
    [anon_sym_declare] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_module] = ACTIONS(3008),
    [anon_sym_any] = ACTIONS(3008),
    [anon_sym_number] = ACTIONS(3008),
    [anon_sym_boolean] = ACTIONS(3008),
    [anon_sym_string] = ACTIONS(3008),
    [anon_sym_symbol] = ACTIONS(3008),
    [anon_sym_interface] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [sym_readonly] = ACTIONS(3008),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3012),
    [anon_sym_export] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_import] = ACTIONS(3012),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_await] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_debugger] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_this] = ACTIONS(3012),
    [sym_super] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
    [anon_sym_declare] = ACTIONS(3012),
    [anon_sym_public] = ACTIONS(3012),
    [anon_sym_private] = ACTIONS(3012),
    [anon_sym_protected] = ACTIONS(3012),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_any] = ACTIONS(3012),
    [anon_sym_number] = ACTIONS(3012),
    [anon_sym_boolean] = ACTIONS(3012),
    [anon_sym_string] = ACTIONS(3012),
    [anon_sym_symbol] = ACTIONS(3012),
    [anon_sym_interface] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [sym_readonly] = ACTIONS(3012),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [sym_number] = ACTIONS(3018),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_abstract] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_interface] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [sym_readonly] = ACTIONS(3016),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3020),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_typeof] = ACTIONS(3020),
    [anon_sym_import] = ACTIONS(3020),
    [anon_sym_var] = ACTIONS(3020),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_with] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_debugger] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_void] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [sym_number] = ACTIONS(3022),
    [sym_this] = ACTIONS(3020),
    [sym_super] = ACTIONS(3020),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_undefined] = ACTIONS(3020),
    [anon_sym_AT] = ACTIONS(3022),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_abstract] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_interface] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [sym_readonly] = ACTIONS(3020),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [98] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3026), 1,
      sym_identifier,
    ACTIONS(3028), 1,
      anon_sym_DQUOTE,
    ACTIONS(3030), 1,
      anon_sym_SQUOTE,
    STATE(103), 1,
      sym_nested_identifier,
    STATE(104), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [196] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3026), 1,
      sym_identifier,
    ACTIONS(3028), 1,
      anon_sym_DQUOTE,
    ACTIONS(3030), 1,
      anon_sym_SQUOTE,
    STATE(103), 1,
      sym_nested_identifier,
    STATE(104), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [294] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [392] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3026), 1,
      sym_identifier,
    ACTIONS(3028), 1,
      anon_sym_DQUOTE,
    ACTIONS(3030), 1,
      anon_sym_SQUOTE,
    STATE(103), 1,
      sym_nested_identifier,
    STATE(104), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [490] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1107), 1,
      sym_arguments,
    STATE(1123), 1,
      sym__module,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [680] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    STATE(1402), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [771] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [858] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(613), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1107), 1,
      sym_arguments,
    STATE(1123), 1,
      sym__module,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [948] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3026), 1,
      sym_identifier,
    ACTIONS(3028), 1,
      anon_sym_DQUOTE,
    ACTIONS(3030), 1,
      anon_sym_SQUOTE,
    STATE(103), 1,
      sym_nested_identifier,
    STATE(104), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1036] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(663), 1,
      anon_sym_EQ_GT,
    ACTIONS(2637), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 13,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(493), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1126] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1214] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(597), 1,
      anon_sym_in,
    ACTIONS(600), 1,
      anon_sym_of,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      sym_identifier,
    STATE(963), 1,
      sym_string,
    STATE(964), 1,
      sym_nested_identifier,
    STATE(1223), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1304] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      sym_identifier,
    STATE(963), 1,
      sym_string,
    STATE(964), 1,
      sym_nested_identifier,
    STATE(1223), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1390] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      sym_identifier,
    STATE(963), 1,
      sym_string,
    STATE(964), 1,
      sym_nested_identifier,
    STATE(1223), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1478] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(3024), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1566] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1653] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(631), 1,
      anon_sym_EQ_GT,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    STATE(1402), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1742] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_export,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3050), 1,
      anon_sym_RBRACE,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3068), 1,
      anon_sym_static,
    ACTIONS(3074), 1,
      sym_readonly,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2440), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3070), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3072), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2578), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3042), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1871] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_export,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3068), 1,
      anon_sym_static,
    ACTIONS(3074), 1,
      sym_readonly,
    ACTIONS(3078), 1,
      anon_sym_COMMA,
    ACTIONS(3080), 1,
      anon_sym_RBRACE,
    ACTIONS(3082), 1,
      anon_sym_SEMI,
    ACTIONS(3084), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2440), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3070), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3072), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2578), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2045), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3042), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2000] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_export,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3068), 1,
      anon_sym_static,
    ACTIONS(3074), 1,
      sym_readonly,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3086), 1,
      anon_sym_RBRACE,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2440), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3070), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3072), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2578), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3042), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2129] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(613), 1,
      anon_sym_EQ_GT,
    ACTIONS(729), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(745), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [2214] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3090), 1,
      anon_sym_export,
    ACTIONS(3092), 1,
      anon_sym_RBRACE,
    ACTIONS(3094), 1,
      anon_sym_async,
    ACTIONS(3096), 1,
      anon_sym_static,
    ACTIONS(3102), 1,
      sym_readonly,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2441), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3098), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3100), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2438), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3088), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2343] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 1,
      anon_sym_EQ_GT,
    ACTIONS(673), 1,
      anon_sym_EQ,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2637), 1,
      anon_sym_DOT,
    ACTIONS(3104), 1,
      sym_identifier,
    STATE(1434), 1,
      sym_nested_identifier,
    STATE(1447), 1,
      sym_string,
    STATE(1593), 1,
      sym__module,
    ACTIONS(701), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2428] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3108), 1,
      anon_sym_export,
    ACTIONS(3110), 1,
      anon_sym_RBRACE,
    ACTIONS(3112), 1,
      anon_sym_async,
    ACTIONS(3114), 1,
      anon_sym_static,
    ACTIONS(3120), 1,
      sym_readonly,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2557), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3116), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3118), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2555), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3106), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2557] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(602), 1,
      anon_sym_EQ,
    ACTIONS(608), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(605), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2646] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1107), 1,
      sym_arguments,
    STATE(1123), 1,
      sym__module,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 13,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(602), 1,
      anon_sym_EQ,
    ACTIONS(608), 1,
      anon_sym_QMARK,
    ACTIONS(611), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(605), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2826] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3124), 1,
      anon_sym_export,
    ACTIONS(3126), 1,
      anon_sym_RBRACE,
    ACTIONS(3128), 1,
      anon_sym_async,
    ACTIONS(3130), 1,
      anon_sym_static,
    ACTIONS(3136), 1,
      sym_readonly,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2495), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3132), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3134), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2493), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3122), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2955] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_export,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3048), 1,
      anon_sym_COMMA,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3054), 1,
      anon_sym_SEMI,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3068), 1,
      anon_sym_static,
    ACTIONS(3074), 1,
      sym_readonly,
    ACTIONS(3076), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3138), 1,
      anon_sym_RBRACE,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2440), 1,
      aux_sym_object_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3070), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3072), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2578), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3042), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3084] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(631), 1,
      anon_sym_EQ_GT,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      sym_identifier,
    STATE(963), 1,
      sym_string,
    STATE(964), 1,
      sym_nested_identifier,
    STATE(1223), 1,
      sym__module,
    ACTIONS(635), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3168] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3254] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3401] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(761), 1,
      anon_sym_in,
    ACTIONS(764), 1,
      anon_sym_of,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3488] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3150), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3685] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      sym_identifier,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3768] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 1,
      anon_sym_EQ,
    ACTIONS(3158), 1,
      anon_sym_in,
    ACTIONS(3161), 1,
      anon_sym_of,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    STATE(2103), 1,
      sym_type_annotation,
    STATE(2556), 1,
      sym__initializer,
    ACTIONS(3156), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [3851] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3174), 1,
      anon_sym_LT,
    ACTIONS(3177), 1,
      anon_sym_DOT,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3186), 1,
      anon_sym_is,
    STATE(1905), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2521), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3171), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [3934] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      sym_identifier,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3194), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4143] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      sym_identifier,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4226] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(597), 1,
      anon_sym_in,
    ACTIONS(600), 1,
      anon_sym_of,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(971), 1,
      sym_string,
    STATE(1123), 1,
      sym__module,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4313] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3199), 1,
      anon_sym_DOT,
    ACTIONS(3201), 1,
      anon_sym_is,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [4394] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4474] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3205), 1,
      anon_sym_export,
    ACTIONS(3209), 1,
      anon_sym_async,
    ACTIONS(3211), 1,
      anon_sym_static,
    ACTIONS(3217), 1,
      sym_readonly,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3207), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3213), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3215), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2058), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3203), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4592] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      anon_sym_DOT,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [4672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      anon_sym_EQ,
    ACTIONS(3229), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(3232), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4752] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(1614), 1,
      sym_template_string,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1576), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3273), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3278), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5000] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5080] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5154] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5234] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(1460), 1,
      sym_template_string,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1461), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5350] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_STAR,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3056), 1,
      anon_sym_LBRACK,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3066), 1,
      sym_number,
    ACTIONS(3205), 1,
      anon_sym_export,
    ACTIONS(3209), 1,
      anon_sym_async,
    ACTIONS(3211), 1,
      anon_sym_static,
    ACTIONS(3217), 1,
      sym_readonly,
    STATE(1785), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3207), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3213), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3215), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1825), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2036), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3203), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5468] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      anon_sym_EQ,
    ACTIONS(3229), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(3232), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3318), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5616] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(1083), 1,
      sym_template_string,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1082), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5732] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5806] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      anon_sym_EQ,
    ACTIONS(3229), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(3232), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5886] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3361), 1,
      anon_sym_GT,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5999] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3199), 1,
      anon_sym_DOT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(453), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6216] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3373), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6329] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3375), 1,
      anon_sym_RBRACK,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2454), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(562), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(549), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(589), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6517] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3377), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6630] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3379), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6743] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3381), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6856] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3383), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7048] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7121] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3393), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7234] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3395), 1,
      anon_sym_RBRACK,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2504), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(453), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7420] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3397), 1,
      anon_sym_RBRACK,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2542), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7533] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3399), 1,
      anon_sym_RBRACK,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2566), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7646] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_LBRACK,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3401), 1,
      anon_sym_EQ,
    ACTIONS(3407), 1,
      anon_sym_RPAREN,
    ACTIONS(3411), 1,
      anon_sym_DOT,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3404), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      sym_identifier,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [7804] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 1,
      anon_sym_LBRACK,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3416), 1,
      anon_sym_EQ,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    ACTIONS(3420), 1,
      anon_sym_EQ_GT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3422), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7885] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3424), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7998] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3426), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8111] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    ACTIONS(3428), 1,
      anon_sym_LBRACE,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3432), 1,
      anon_sym_LT,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(3437), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2326), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2524), 1,
      sym_type_arguments,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8192] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3439), 1,
      sym_identifier,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2472), 1,
      sym_type_parameter,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2136), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8305] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3441), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8418] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3443), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8531] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3445), 1,
      anon_sym_DOT,
    ACTIONS(2417), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2415), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(1402), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3447), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8750] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3171), 1,
      anon_sym_LBRACK,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3449), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3183), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3152), 1,
      sym_identifier,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [8904] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    ACTIONS(3453), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_type_arguments,
    STATE(2346), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3437), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8983] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3455), 1,
      anon_sym_GT,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9096] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3457), 1,
      anon_sym_RBRACK,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2446), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9209] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(428), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9319] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2112), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9429] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1451), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9599] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1848), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9709] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(428), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9819] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(436), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9929] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(484), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10039] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(483), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10149] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(491), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10259] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    ACTIONS(3432), 1,
      anon_sym_LT,
    ACTIONS(3435), 1,
      anon_sym_DOT,
    ACTIONS(3469), 1,
      anon_sym_LBRACE,
    STATE(2524), 1,
      sym_type_arguments,
    ACTIONS(3471), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [10335] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1544), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10445] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1541), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10555] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2136), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10665] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2436), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10775] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2253), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10885] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1894), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10995] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1896), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11105] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(663), 1,
      anon_sym_EQ_GT,
    ACTIONS(2637), 1,
      anon_sym_DOT,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(493), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11237] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(2307), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11347] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1468), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11457] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2348), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11705] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    STATE(1521), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3140), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11777] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1007), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11951] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2418), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12061] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1986), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12171] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1495), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12281] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2192), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12391] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1014), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12501] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2415), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12611] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2422), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12721] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2131), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12831] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(2358), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12941] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3497), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [13011] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2018), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13121] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(433), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13231] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1852), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13341] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(429), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13451] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1020), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3194), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13621] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 1,
      anon_sym_COLON,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [13763] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2332), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13873] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2177), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13983] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2098), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14093] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2178), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14203] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1882), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14313] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1883), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14423] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(485), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14533] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1864), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14643] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(486), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14753] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1388), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14863] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1850), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14973] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3461), 1,
      anon_sym_new,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2650), 1,
      sym_type_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    STATE(2969), 1,
      sym_formal_parameters,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(487), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15083] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1886), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15193] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1389), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15303] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1485), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15413] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1031), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15523] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1032), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(613), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(493), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15705] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1484), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15815] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1035), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15925] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1482), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16035] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1840), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16215] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1036), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16325] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_new,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_AMP,
    ACTIONS(3299), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3307), 1,
      sym_this,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2678), 1,
      sym_type_parameters,
    STATE(2783), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    STATE(1481), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1459), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16435] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16503] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(3499), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3171), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16581] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16651] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1909), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(2393), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3315), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3318), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16889] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(436), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16999] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2185), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17179] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2120), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17289] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1509), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17399] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2236), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17509] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(2354), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17619] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1549), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17729] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1631), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17839] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(429), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17949] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1630), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18059] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2227), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18169] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2523), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18279] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 1,
      anon_sym_LT,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    ACTIONS(3453), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(3471), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18353] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1084), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18463] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3329), 1,
      anon_sym_LPAREN,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_new,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3337), 1,
      anon_sym_AMP,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3347), 1,
      sym_this,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2660), 1,
      sym_type_parameters,
    STATE(2850), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    STATE(1085), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1101), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1162), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3275), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3188), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18639] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2575), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18749] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18821] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(1833), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18931] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(2101), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19041] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1903), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19151] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3503), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19223] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1900), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19333] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(792), 1,
      anon_sym_AMP,
    ACTIONS(794), 1,
      anon_sym_PIPE,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3365), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2761), 1,
      sym_type_parameters,
    STATE(2791), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    STATE(433), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(431), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [19511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3223), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3505), 1,
      anon_sym_in,
    ACTIONS(3508), 1,
      anon_sym_of,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [19583] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1966), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19693] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(597), 1,
      anon_sym_in,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_of,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [19765] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1534), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19875] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1531), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19985] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    STATE(2656), 1,
      sym_type_annotation,
    ACTIONS(3512), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3150), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20119] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(2334), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20229] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3245), 1,
      anon_sym_LPAREN,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 1,
      anon_sym_new,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3253), 1,
      anon_sym_AMP,
    ACTIONS(3255), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3263), 1,
      sym_this,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2637), 1,
      sym_type_parameters,
    STATE(2906), 1,
      sym_nested_identifier,
    STATE(2959), 1,
      sym_formal_parameters,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    STATE(1530), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1598), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20339] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(984), 1,
      anon_sym_AMP,
    ACTIONS(986), 1,
      anon_sym_PIPE,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3479), 1,
      anon_sym_LPAREN,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3483), 1,
      anon_sym_new,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3491), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2778), 1,
      sym_type_parameters,
    STATE(2823), 1,
      sym_nested_identifier,
    STATE(2826), 1,
      sym_formal_parameters,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    STATE(1897), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1881), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    ACTIONS(3517), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_EQ_GT,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1098), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20658] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(589), 1,
      anon_sym_COMMA,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(631), 1,
      anon_sym_EQ_GT,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(635), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    ACTIONS(3447), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3420), 1,
      anon_sym_EQ_GT,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3140), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3416), 1,
      anon_sym_EQ,
    ACTIONS(3420), 1,
      anon_sym_EQ_GT,
    ACTIONS(3519), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3422), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20944] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3401), 1,
      anon_sym_EQ,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    ACTIONS(3521), 1,
      anon_sym_COLON,
    ACTIONS(3404), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    STATE(1521), 1,
      sym_arguments,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3144), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3140), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21084] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2417), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21155] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3525), 1,
      anon_sym_DOT,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2417), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21226] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 1,
      anon_sym_EQ_GT,
    ACTIONS(673), 1,
      anon_sym_EQ,
    ACTIONS(2637), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(701), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21297] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(602), 1,
      anon_sym_EQ,
    ACTIONS(608), 1,
      anon_sym_QMARK,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(605), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_EQ_GT,
    ACTIONS(729), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(745), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(602), 1,
      anon_sym_EQ,
    ACTIONS(608), 1,
      anon_sym_QMARK,
    ACTIONS(611), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(605), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3505), 1,
      anon_sym_in,
    ACTIONS(3508), 1,
      anon_sym_of,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3278), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3318), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21703] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(602), 1,
      anon_sym_EQ,
    ACTIONS(608), 1,
      anon_sym_QMARK,
    ACTIONS(665), 1,
      anon_sym_RPAREN,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(562), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(605), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21780] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3273), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21914] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(631), 1,
      anon_sym_EQ_GT,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(1402), 1,
      sym_arguments,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(501), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(493), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22054] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3527), 1,
      anon_sym_in,
    ACTIONS(3529), 1,
      anon_sym_COLON,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22125] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(589), 1,
      anon_sym_COMMA,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22198] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 1,
      anon_sym_EQ_GT,
    ACTIONS(673), 1,
      anon_sym_EQ,
    ACTIONS(2637), 1,
      anon_sym_DOT,
    ACTIONS(701), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22265] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(613), 1,
      anon_sym_EQ_GT,
    ACTIONS(729), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(562), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(745), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_EQ,
    ACTIONS(3225), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3401), 1,
      anon_sym_EQ,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    ACTIONS(3404), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3369), 1,
      anon_sym_EQ_GT,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3391), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1098), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22599] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 1,
      anon_sym_LBRACK,
    ACTIONS(3318), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22665] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3318), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_EQ,
    ACTIONS(3371), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3150), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [22915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3278), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [22977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3416), 1,
      anon_sym_EQ,
    ACTIONS(3420), 1,
      anon_sym_EQ_GT,
    ACTIONS(3422), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [23101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(659), 1,
      anon_sym_COLON,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(562), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(549), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(571), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3318), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3188), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3318), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [23367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3278), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 1,
      anon_sym_LBRACK,
    ACTIONS(3318), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3194), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [23621] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3278), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3318), 1,
      anon_sym_LT,
    ACTIONS(3315), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3188), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [23807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_EQ,
    ACTIONS(631), 1,
      anon_sym_EQ_GT,
    ACTIONS(1369), 1,
      anon_sym_DOT,
    ACTIONS(635), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3275), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3188), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23935] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3527), 1,
      anon_sym_in,
    ACTIONS(3529), 1,
      anon_sym_COLON,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_EQ,
    ACTIONS(3010), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3273), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3271), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24067] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_EQ,
    ACTIONS(3179), 1,
      anon_sym_EQ_GT,
    ACTIONS(3531), 1,
      anon_sym_DOT,
    ACTIONS(2417), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2415), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3181), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24195] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(597), 1,
      anon_sym_in,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_of,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24264] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3158), 1,
      anon_sym_in,
    ACTIONS(3161), 1,
      anon_sym_of,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3275), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
    ACTIONS(3188), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3416), 1,
      anon_sym_EQ,
    ACTIONS(3422), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24516] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(651), 1,
      anon_sym_EQ_GT,
    ACTIONS(761), 1,
      anon_sym_in,
    ACTIONS(2542), 1,
      anon_sym_DOT,
    ACTIONS(3533), 1,
      anon_sym_of,
    ACTIONS(523), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DOT,
    ACTIONS(3315), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3318), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3188), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3190), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_EQ_GT,
    ACTIONS(3505), 1,
      anon_sym_in,
    ACTIONS(3508), 1,
      anon_sym_of,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24717] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3054), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3076), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2068), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3158), 1,
      anon_sym_in,
    ACTIONS(3161), 1,
      anon_sym_of,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24885] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3082), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3084), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2045), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24989] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3555), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3557), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2083), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25093] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3563), 1,
      anon_sym_EQ,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [25197] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3597), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3599), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2051), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25301] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3563), 1,
      anon_sym_EQ,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [25405] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3563), 1,
      anon_sym_EQ,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [25509] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3563), 1,
      anon_sym_EQ,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [25613] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3601), 1,
      sym_identifier,
    ACTIONS(3603), 1,
      anon_sym_STAR,
    ACTIONS(3607), 1,
      anon_sym_LBRACE,
    STATE(2689), 1,
      sym_import_clause,
    ACTIONS(3611), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(2693), 2,
      sym_string,
      sym_import_require_clause,
    STATE(2855), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(3605), 15,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(3609), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25687] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3613), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3615), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2078), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_EQ,
    ACTIONS(3505), 1,
      anon_sym_in,
    ACTIONS(3508), 1,
      anon_sym_of,
    ACTIONS(3146), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1100), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1098), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25855] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    ACTIONS(3617), 1,
      anon_sym_EQ,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [25956] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1354), 1,
      anon_sym_LBRACE,
    ACTIONS(3559), 1,
      anon_sym_STAR,
    ACTIONS(3561), 1,
      anon_sym_default,
    ACTIONS(3563), 1,
      anon_sym_EQ,
    ACTIONS(3565), 1,
      anon_sym_as,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2368), 1,
      sym_export_clause,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2254), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26059] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3622), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26159] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3624), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3626), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26359] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3628), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3630), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26559] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26659] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3634), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26759] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3636), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26859] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3638), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26959] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3640), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27059] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3642), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27159] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3644), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3646), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27359] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3648), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3650), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27559] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2036), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27655] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2147), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27751] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2026), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3652), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [27909] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2092), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1096), 1,
      sym_template_string,
    STATE(1102), 1,
      sym_arguments,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3654), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3656), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28119] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_LT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [28185] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2071), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28281] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3060), 1,
      anon_sym_new,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_export,
    ACTIONS(3539), 1,
      anon_sym_STAR,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(3543), 1,
      anon_sym_async,
    ACTIONS(3545), 1,
      sym_number,
    ACTIONS(3547), 1,
      anon_sym_static,
    ACTIONS(3553), 1,
      sym_readonly,
    STATE(1783), 1,
      sym_accessibility_modifier,
    STATE(1810), 1,
      sym_decorator,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2394), 1,
      aux_sym_export_statement_repeat1,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(3549), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2058), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3535), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28377] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3660), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3664), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3668), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3672), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1224), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [28643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28700] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28757] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3678), 1,
      anon_sym_LT,
    ACTIONS(3681), 1,
      anon_sym_DOT,
    ACTIONS(3683), 1,
      anon_sym_is,
    STATE(1076), 1,
      sym_type_arguments,
    ACTIONS(2523), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_EQ,
    ACTIONS(3685), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3689), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3693), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1080), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [29024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3697), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [29075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3701), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [29126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3705), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [29177] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3709), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [29269] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3739), 1,
      anon_sym_COMMA,
    ACTIONS(3741), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2512), 1,
      aux_sym_array_repeat1,
    STATE(2955), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [29369] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3743), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29461] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3745), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29553] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3747), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29645] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3749), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29737] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3755), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [29809] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [29903] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3762), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [29995] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30073] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3764), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30165] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3766), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30257] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3768), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30349] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3739), 1,
      anon_sym_COMMA,
    ACTIONS(3770), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2544), 1,
      aux_sym_array_repeat1,
    STATE(2955), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2511), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1074), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    ACTIONS(3774), 1,
      anon_sym_DOT,
    STATE(1187), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30613] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3739), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2467), 1,
      aux_sym_array_repeat1,
    STATE(2955), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30713] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3778), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30805] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(3780), 1,
      anon_sym_EQ,
    ACTIONS(3784), 1,
      anon_sym_in,
    ACTIONS(3787), 1,
      anon_sym_of,
    STATE(2107), 1,
      sym_type_annotation,
    STATE(2545), 1,
      sym__initializer,
    ACTIONS(3782), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30921] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3795), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    ACTIONS(3799), 1,
      anon_sym_DOT,
    STATE(1093), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1093), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31123] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3751), 1,
      anon_sym_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [31213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_LT,
    STATE(1067), 1,
      sym_type_arguments,
    ACTIONS(2586), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31319] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3804), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31411] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3810), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31481] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3755), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31551] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3810), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31619] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(3813), 1,
      anon_sym_EQ,
    ACTIONS(3817), 1,
      anon_sym_in,
    ACTIONS(3820), 1,
      anon_sym_of,
    STATE(2105), 1,
      sym_type_annotation,
    STATE(2549), 1,
      sym__initializer,
    ACTIONS(3815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      sym__automatic_semicolon,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3755), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [31811] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3751), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [31897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3824), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32043] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3826), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32135] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3828), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32227] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3830), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32319] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3810), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32389] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [32471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    STATE(2339), 1,
      sym_type_arguments,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3660), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3664), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1232), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1234), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3838), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32726] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_DQUOTE,
    ACTIONS(715), 1,
      anon_sym_SQUOTE,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_STAR,
    ACTIONS(3241), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      anon_sym_typeof,
    ACTIONS(3247), 1,
      anon_sym_LBRACK,
    ACTIONS(3251), 1,
      anon_sym_QMARK,
    ACTIONS(3261), 1,
      sym_number,
    ACTIONS(3267), 1,
      anon_sym_keyof,
    ACTIONS(3269), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3840), 1,
      anon_sym_LPAREN,
    ACTIONS(3842), 1,
      sym_this,
    STATE(1449), 1,
      sym_nested_type_identifier,
    STATE(2906), 1,
      sym_nested_identifier,
    ACTIONS(3257), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3265), 2,
      sym_true,
      sym_false,
    STATE(1574), 2,
      sym_string,
      sym__number,
    ACTIONS(3259), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1540), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3846), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1090), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2477), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1210), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1186), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1130), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1196), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1220), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1244), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3850), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3854), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_AMP,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(2627), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2625), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2469), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2485), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2345), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3862), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3273), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33698] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3830), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33789] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_AMP,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(2623), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2621), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1096), 1,
      sym_template_string,
    STATE(1416), 1,
      sym_arguments,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1144), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2447), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2405), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2403), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3824), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_AMP,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(2619), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2617), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1176), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3804), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3928), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34293] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3930), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [34360] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2841), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2437), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2455), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34604] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(3935), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2955), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2339), 1,
      sym_type_arguments,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3654), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3656), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2429), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3766), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2425), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_AMP,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(2615), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2613), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_AMP,
    ACTIONS(3858), 1,
      anon_sym_PIPE,
    ACTIONS(2607), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3941), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_DOT,
    ACTIONS(2395), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2393), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35156] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_STAR,
    ACTIONS(982), 1,
      anon_sym_QMARK,
    ACTIONS(1002), 1,
      anon_sym_keyof,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3473), 1,
      sym_identifier,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(3477), 1,
      anon_sym_typeof,
    ACTIONS(3481), 1,
      anon_sym_LBRACK,
    ACTIONS(3489), 1,
      sym_number,
    ACTIONS(3946), 1,
      anon_sym_LPAREN,
    ACTIONS(3948), 1,
      sym_this,
    STATE(1835), 1,
      sym_nested_type_identifier,
    STATE(2823), 1,
      sym_nested_identifier,
    ACTIONS(3485), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3493), 2,
      sym_true,
      sym_false,
    STATE(1879), 2,
      sym_string,
      sym__number,
    ACTIONS(3487), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1893), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1168), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1166), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3950), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3952), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35339] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3768), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35430] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3826), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35521] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3749), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35612] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3745), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35703] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3747), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35843] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_LT,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    STATE(2339), 1,
      sym_type_arguments,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [35906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2459), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35955] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3764), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1120), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36095] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3709), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3693), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2481), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3609), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36431] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3652), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [36490] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_STAR,
    ACTIONS(3285), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_typeof,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3295), 1,
      anon_sym_QMARK,
    ACTIONS(3305), 1,
      sym_number,
    ACTIONS(3311), 1,
      anon_sym_keyof,
    ACTIONS(3313), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3954), 1,
      anon_sym_LPAREN,
    ACTIONS(3956), 1,
      sym_this,
    STATE(1301), 1,
      sym_nested_type_identifier,
    STATE(2869), 1,
      sym_nested_identifier,
    ACTIONS(3301), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3309), 2,
      sym_true,
      sym_false,
    STATE(1458), 2,
      sym_string,
      sym__number,
    ACTIONS(3303), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1387), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3762), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36624] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(3960), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [36695] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3459), 1,
      sym_identifier,
    ACTIONS(3463), 1,
      anon_sym_QMARK,
    ACTIONS(3963), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      sym_this,
    STATE(467), 1,
      sym_nested_type_identifier,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [36780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1080), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2411), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36878] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [36955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3967), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3969), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2407), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37102] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(3971), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2919), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      anon_sym_DOT,
    ACTIONS(2399), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2397), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3982), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37356] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [37437] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3828), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37528] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3751), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [37613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2421), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37662] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(3960), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37737] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(3960), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37806] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3985), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3705), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2451), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2433), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3993), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_LBRACK,
    ACTIONS(2475), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2473), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_DOT,
    ACTIONS(2417), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2415), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3745), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4001), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1224), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4005), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3672), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3697), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38832] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3751), 1,
      anon_sym_QMARK,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4009), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_LBRACK,
    ACTIONS(2443), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2441), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4017), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39119] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3795), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4021), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4025), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4029), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3778), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(589), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4033), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4037), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39693] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3862), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2327), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39790] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4075), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2867), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1108), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39936] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_SQUOTE,
    ACTIONS(3321), 1,
      sym_identifier,
    ACTIONS(3323), 1,
      anon_sym_STAR,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_typeof,
    ACTIONS(3331), 1,
      anon_sym_LBRACK,
    ACTIONS(3335), 1,
      anon_sym_QMARK,
    ACTIONS(3345), 1,
      sym_number,
    ACTIONS(3351), 1,
      anon_sym_keyof,
    ACTIONS(3353), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4077), 1,
      anon_sym_LPAREN,
    ACTIONS(4079), 1,
      sym_this,
    STATE(973), 1,
      sym_nested_type_identifier,
    STATE(2892), 1,
      sym_nested_identifier,
    ACTIONS(3341), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3349), 2,
      sym_true,
      sym_false,
    STATE(991), 2,
      sym_string,
      sym__number,
    ACTIONS(3343), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1087), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [40021] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    ACTIONS(4084), 1,
      anon_sym_RBRACE,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3768), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40116] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3743), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40207] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3762), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40347] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3766), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1200), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40487] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3804), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40578] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3824), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40669] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(3930), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4086), 1,
      anon_sym_COMMA,
    ACTIONS(4089), 1,
      anon_sym_RBRACE,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3743), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3668), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4091), 1,
      anon_sym_COMMA,
    ACTIONS(4094), 1,
      anon_sym_RBRACE,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3689), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4098), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41173] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_STAR,
    ACTIONS(790), 1,
      anon_sym_QMARK,
    ACTIONS(814), 1,
      anon_sym_keyof,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2558), 1,
      anon_sym_typeof,
    ACTIONS(2572), 1,
      sym_number,
    ACTIONS(3355), 1,
      sym_identifier,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(3359), 1,
      anon_sym_LBRACK,
    ACTIONS(3963), 1,
      anon_sym_LPAREN,
    ACTIONS(3965), 1,
      sym_this,
    STATE(1816), 1,
      sym_nested_type_identifier,
    STATE(2792), 1,
      sym_nested_identifier,
    ACTIONS(2568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2576), 2,
      sym_true,
      sym_false,
    STATE(444), 2,
      sym_string,
      sym__number,
    ACTIONS(3363), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41258] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4104), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2870), 1,
      sym_type_annotation,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3701), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4106), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41453] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(3930), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41522] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4084), 1,
      anon_sym_RBRACE,
    ACTIONS(4108), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3749), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41617] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4113), 1,
      anon_sym_RBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4117), 1,
      anon_sym_async,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4121), 1,
      anon_sym_static,
    ACTIONS(4127), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2441), 1,
      aux_sym_object_repeat1,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(4123), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4125), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2438), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4111), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41751] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4131), 1,
      anon_sym_RBRACE,
    ACTIONS(4133), 1,
      anon_sym_async,
    ACTIONS(4135), 1,
      anon_sym_static,
    ACTIONS(4141), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2495), 1,
      aux_sym_object_repeat1,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(4137), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4139), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2493), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4129), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 1,
      sym__automatic_semicolon,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41887] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3766), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41977] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 6,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [42057] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 5,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42141] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4145), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [42209] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4148), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [42283] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4151), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2519), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42377] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4148), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [42445] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3751), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3753), 3,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42533] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4153), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4155), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3743), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42717] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [42793] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3958), 1,
      anon_sym_LBRACE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42885] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3826), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42975] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3743), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43065] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3795), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43155] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4148), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 14,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [43225] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4157), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3747), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43317] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3751), 1,
      anon_sym_QMARK,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3753), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43405] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4159), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [43473] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3937), 1,
      anon_sym_LBRACE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3766), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43565] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4162), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2544), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43659] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3924), 1,
      anon_sym_LBRACE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3804), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43751] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3922), 1,
      anon_sym_LBRACE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3824), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43893] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4166), 1,
      anon_sym_RBRACE,
    ACTIONS(4168), 1,
      anon_sym_async,
    ACTIONS(4170), 1,
      anon_sym_static,
    ACTIONS(4176), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2557), 1,
      aux_sym_object_repeat1,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(4172), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4174), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2555), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4164), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [43979] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3997), 1,
      anon_sym_LBRACE,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3745), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44071] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [44145] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4178), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2579), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44239] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4180), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3826), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44331] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3751), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [44415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 1,
      anon_sym_LT,
    ACTIONS(4185), 1,
      anon_sym_DOT,
    ACTIONS(4187), 1,
      anon_sym_is,
    STATE(1392), 1,
      sym_type_arguments,
    ACTIONS(2523), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44471] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4189), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3768), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44563] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4193), 1,
      anon_sym_RBRACE,
    ACTIONS(4195), 1,
      anon_sym_async,
    ACTIONS(4197), 1,
      anon_sym_static,
    ACTIONS(4203), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2528), 1,
      aux_sym_object_repeat1,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(4199), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4201), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2530), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4191), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [44649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      sym_regex_flags,
    ACTIONS(4205), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4207), 23,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44699] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4211), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2473), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2509), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1074), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4213), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44895] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4215), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44985] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [45061] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [45131] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3747), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45221] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4217), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4219), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1168), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1166), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3768), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45499] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4221), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3709), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45591] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4106), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45683] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4223), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45773] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3749), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45865] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4223), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2393), 1,
      sym_type_arguments,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3654), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3656), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [46007] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4223), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46097] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3778), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3709), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46277] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3749), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(4145), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [46433] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4227), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2473), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46527] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3828), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3830), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46707] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4145), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [46775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4229), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2428), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46869] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4217), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3760), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46961] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4231), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2519), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47055] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4223), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47145] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2450), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47239] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2512), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    STATE(2393), 1,
      sym_type_arguments,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3660), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3664), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [47391] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4237), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2519), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47485] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4239), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [47553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47601] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4223), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47691] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4239), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [47757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1096), 1,
      sym_template_string,
    STATE(1516), 1,
      sym_arguments,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3140), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [47811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4242), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2467), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47905] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4244), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3828), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4246), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(2411), 1,
      aux_sym_array_repeat1,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48091] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4248), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48183] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4239), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [48251] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4217), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4250), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1200), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48391] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3896), 1,
      anon_sym_LT,
    ACTIONS(3898), 1,
      anon_sym_QMARK,
    ACTIONS(3900), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3906), 1,
      anon_sym_AMP,
    ACTIONS(3908), 1,
      anon_sym_PIPE,
    ACTIONS(3912), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3916), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4217), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3902), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3910), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4252), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3892), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3904), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3894), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3652), 1,
      anon_sym_LT,
    STATE(2393), 1,
      sym_type_arguments,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [48541] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_LT,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    STATE(2393), 1,
      sym_type_arguments,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [48603] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3764), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4254), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4256), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48793] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4258), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(3778), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48885] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3745), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48975] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4260), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49173] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4264), 1,
      anon_sym_RBRACE,
    ACTIONS(4266), 1,
      anon_sym_async,
    ACTIONS(4268), 1,
      anon_sym_static,
    ACTIONS(4274), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2440), 1,
      aux_sym_object_repeat1,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(4270), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4272), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2578), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4262), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49259] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [49339] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3824), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49429] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3804), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49519] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(4041), 1,
      anon_sym_as,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_LT,
    ACTIONS(4051), 1,
      anon_sym_QMARK,
    ACTIONS(4053), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4059), 1,
      anon_sym_AMP,
    ACTIONS(4061), 1,
      anon_sym_PIPE,
    ACTIONS(4065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4069), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4071), 1,
      anon_sym_BANG,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym_type_arguments,
    ACTIONS(4055), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4063), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4073), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1617), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4057), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4045), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4067), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1108), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1078), 1,
      sym__automatic_semicolon,
    ACTIONS(1070), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1074), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49711] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3866), 1,
      anon_sym_LT,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3876), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_PIPE,
    ACTIONS(3882), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3886), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3872), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3880), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3762), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3874), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3864), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 1,
      sym__automatic_semicolon,
    ACTIONS(1238), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1242), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1244), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49852] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [49919] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3768), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50008] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4094), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50097] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4089), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50186] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4320), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50275] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3778), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50364] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3709), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50453] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3749), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50631] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4084), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50720] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4344), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(1408), 1,
      sym_arguments,
    ACTIONS(3140), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50838] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4347), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50905] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3830), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50994] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3826), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51083] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4350), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51174] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4352), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51265] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3828), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51354] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4354), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51445] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51536] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4358), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4360), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51716] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4362), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 14,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(4347), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 15,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51850] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51925] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4365), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52016] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4347), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    STATE(1521), 1,
      sym_arguments,
    ACTIONS(3140), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [52136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    STATE(1521), 1,
      sym_arguments,
    ACTIONS(3140), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [52189] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4369), 1,
      anon_sym_RBRACE,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1321), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52270] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 6,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [52349] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3828), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52438] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3751), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 5,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52521] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3824), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52610] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52699] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4362), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2467), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52823] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52914] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4362), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 15,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52981] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3766), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53070] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3751), 1,
      anon_sym_QMARK,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3753), 3,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53206] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3795), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53295] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3743), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_EQ,
    ACTIONS(4213), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53435] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4385), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53516] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [53583] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4387), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53672] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3826), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      sym__automatic_semicolon,
    ACTIONS(1148), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1178), 1,
      sym__automatic_semicolon,
    ACTIONS(1170), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1174), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1176), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 1,
      anon_sym_LT,
    ACTIONS(4392), 1,
      anon_sym_DOT,
    ACTIONS(4394), 1,
      anon_sym_is,
    STATE(1577), 1,
      sym_type_arguments,
    ACTIONS(2523), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2521), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [53918] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4396), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1289), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53999] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1236), 1,
      sym__automatic_semicolon,
    ACTIONS(1228), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1232), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1234), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1092), 1,
      sym__automatic_semicolon,
    ACTIONS(1084), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1088), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1090), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54170] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2584), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_LT,
    STATE(1396), 1,
      sym_type_arguments,
    ACTIONS(2586), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54274] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(4407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 1,
      sym__automatic_semicolon,
    ACTIONS(1204), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1208), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1210), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1188), 1,
      sym__automatic_semicolon,
    ACTIONS(1180), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1184), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1186), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      sym__automatic_semicolon,
    ACTIONS(1138), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1142), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1144), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_EQ,
    ACTIONS(4409), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [54543] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54610] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3747), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54699] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54768] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(4407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54833] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4411), 1,
      anon_sym_RBRACE,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54924] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4416), 1,
      anon_sym_STAR,
    ACTIONS(4419), 1,
      anon_sym_RBRACE,
    ACTIONS(4421), 1,
      anon_sym_LBRACK,
    ACTIONS(4424), 1,
      anon_sym_async,
    ACTIONS(4427), 1,
      anon_sym_DQUOTE,
    ACTIONS(4430), 1,
      anon_sym_SQUOTE,
    ACTIONS(4433), 1,
      sym_number,
    ACTIONS(4436), 1,
      anon_sym_AT,
    ACTIONS(4439), 1,
      anon_sym_static,
    ACTIONS(4442), 1,
      anon_sym_abstract,
    ACTIONS(4451), 1,
      sym_readonly,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4445), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4448), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4413), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2493), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3979), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 1,
      sym__automatic_semicolon,
    ACTIONS(1124), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1128), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1130), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55109] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4454), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 1,
      sym__automatic_semicolon,
    ACTIONS(1190), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1194), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1196), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_LPAREN,
    ACTIONS(4459), 1,
      anon_sym_COLON,
    ACTIONS(4461), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3695), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3697), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55302] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4464), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55383] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4466), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1318), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1222), 1,
      sym__automatic_semicolon,
    ACTIONS(1214), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1218), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1220), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55515] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4468), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55596] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(4407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [55661] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55730] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [55797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2511), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1074), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55848] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4470), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55929] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4344), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_EQ,
    ACTIONS(4474), 1,
      anon_sym_in,
    ACTIONS(4477), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    ACTIONS(4481), 1,
      anon_sym_in,
    ACTIONS(4484), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56102] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4486), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1326), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56183] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3824), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56272] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3804), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56361] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3766), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56450] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3762), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56539] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3762), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56628] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4488), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1375), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56709] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3808), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [56774] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3743), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56863] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3745), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56952] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4215), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57041] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57130] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3764), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57219] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3751), 1,
      anon_sym_QMARK,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3753), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57306] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4490), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57446] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4115), 1,
      anon_sym_LBRACK,
    ACTIONS(4119), 1,
      sym_number,
    ACTIONS(4495), 1,
      anon_sym_async,
    ACTIONS(4497), 1,
      anon_sym_static,
    ACTIONS(4503), 1,
      sym_readonly,
    STATE(1784), 1,
      sym_accessibility_modifier,
    STATE(2896), 1,
      sym_object,
    STATE(2897), 1,
      sym_array,
    ACTIONS(3207), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4499), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4501), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4493), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57527] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4505), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57618] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3751), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57701] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3753), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [57780] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57871] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57960] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4511), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58051] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4513), 1,
      anon_sym_RPAREN,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58142] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3751), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3749), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58306] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4490), 1,
      anon_sym_LT,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3751), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3753), 14,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58375] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58464] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3709), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58553] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4515), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58644] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4517), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58735] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3778), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58873] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4519), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3789), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      sym__automatic_semicolon,
    ACTIONS(1114), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1118), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1120), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 1,
      sym_regex_flags,
    ACTIONS(4205), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4207), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59103] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(4407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59168] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3747), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59306] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3745), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59395] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59464] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3832), 1,
      anon_sym_as,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(3918), 1,
      anon_sym_BANG,
    ACTIONS(4322), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    ACTIONS(4326), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4332), 1,
      anon_sym_AMP,
    ACTIONS(4334), 1,
      anon_sym_PIPE,
    ACTIONS(4338), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4342), 1,
      anon_sym_QMARK_QMARK,
    STATE(2339), 1,
      sym_type_arguments,
    ACTIONS(3768), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3920), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4328), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4336), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1381), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4316), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4330), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4318), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4340), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59553] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3713), 1,
      anon_sym_LT,
    ACTIONS(3715), 1,
      anon_sym_QMARK,
    ACTIONS(3717), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3723), 1,
      anon_sym_AMP,
    ACTIONS(3725), 1,
      anon_sym_PIPE,
    ACTIONS(3729), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3733), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3758), 1,
      anon_sym_COMMA,
    ACTIONS(4523), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3719), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3707), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3721), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3711), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3731), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59644] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4525), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1363), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59725] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3541), 1,
      anon_sym_LBRACK,
    ACTIONS(4367), 1,
      anon_sym_STAR,
    ACTIONS(4371), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      sym_number,
    ACTIONS(4375), 1,
      anon_sym_static,
    ACTIONS(4377), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    ACTIONS(4527), 1,
      anon_sym_RBRACE,
    STATE(1746), 1,
      sym_method_definition,
    STATE(1776), 1,
      sym_accessibility_modifier,
    ACTIONS(4379), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1312), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3551), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1820), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2532), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3535), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 1,
      sym__automatic_semicolon,
    ACTIONS(1104), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2511), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1074), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      sym_regex_flags,
    ACTIONS(4205), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
    ACTIONS(4207), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1244), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4005), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 1,
      anon_sym_DOT,
    ACTIONS(2417), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2415), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1220), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1196), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4001), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 1,
      anon_sym_LBRACK,
    ACTIONS(2475), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2473), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2433), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2451), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1130), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2421), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_DOT,
    ACTIONS(2399), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2397), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3273), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2407), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2411), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60832] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4098), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4029), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3701), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4025), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3993), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4021), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3668), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3950), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3952), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [61400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4535), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [61448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4033), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3689), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4537), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3967), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3969), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    STATE(1521), 1,
      sym_arguments,
    ACTIONS(3140), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3144), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2511), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1074), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3697), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61866] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    ACTIONS(3521), 1,
      anon_sym_COLON,
    ACTIONS(4539), 1,
      anon_sym_EQ,
    ACTIONS(3404), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61966] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4541), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(4549), 1,
      anon_sym_COLON,
    ACTIONS(4551), 1,
      anon_sym_QMARK,
    ACTIONS(4546), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62108] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    ACTIONS(4560), 1,
      anon_sym_COLON,
    ACTIONS(4562), 1,
      anon_sym_QMARK,
    ACTIONS(4557), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62162] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62226] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3745), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62436] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3850), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3672), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3854), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62640] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4569), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_LBRACE,
    ACTIONS(4573), 1,
      anon_sym_DOT,
    STATE(1589), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_LPAREN,
    ACTIONS(4578), 1,
      anon_sym_COLON,
    ACTIONS(4580), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1232), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1234), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2477), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1090), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1210), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1186), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3693), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3609), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1144), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4037), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_LBRACE,
    STATE(1589), 1,
      sym_statement_block,
    ACTIONS(1064), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1062), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 1,
      sym_regex_flags,
    ACTIONS(4205), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4207), 20,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 1,
      anon_sym_LT,
    STATE(1573), 1,
      sym_type_arguments,
    ACTIONS(2586), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2584), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    ACTIONS(2627), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2625), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2485), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2469), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63742] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4596), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3824), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(589), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 1,
      anon_sym_LBRACK,
    ACTIONS(2443), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2441), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64108] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4598), 1,
      anon_sym_STAR,
    ACTIONS(4600), 1,
      anon_sym_async,
    ACTIONS(4602), 1,
      sym_number,
    ACTIONS(4604), 1,
      anon_sym_abstract,
    ACTIONS(4606), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1824), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3705), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4608), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3982), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    ACTIONS(4539), 1,
      anon_sym_EQ,
    ACTIONS(3404), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    ACTIONS(2623), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2621), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64508] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4610), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3762), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64642] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4612), 1,
      anon_sym_STAR,
    ACTIONS(4614), 1,
      anon_sym_async,
    ACTIONS(4616), 1,
      sym_number,
    ACTIONS(4618), 1,
      anon_sym_abstract,
    ACTIONS(4620), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1817), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1176), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2447), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2481), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3804), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2459), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4017), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_DOT,
    ACTIONS(2395), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2393), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    ACTIONS(2607), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    ACTIONS(2615), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2613), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2425), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2429), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2455), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65494] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3928), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2405), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2403), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4106), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(4551), 1,
      anon_sym_QMARK,
    ACTIONS(4546), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65790] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      anon_sym_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    ACTIONS(2619), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2617), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4009), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2437), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3838), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3846), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    ACTIONS(4562), 1,
      anon_sym_QMARK,
    ACTIONS(4557), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66182] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4624), 1,
      anon_sym_RBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1120), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66316] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_QMARK,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(4539), 1,
      anon_sym_EQ,
    ACTIONS(4626), 1,
      anon_sym_RPAREN,
    ACTIONS(3404), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 1,
      sym__automatic_semicolon,
    ACTIONS(1072), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1070), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3941), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_EQ_GT,
    ACTIONS(3789), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3766), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_PIPE,
    ACTIONS(2607), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66611] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4598), 1,
      anon_sym_STAR,
    ACTIONS(4600), 1,
      anon_sym_async,
    ACTIONS(4602), 1,
      sym_number,
    ACTIONS(4634), 1,
      sym_readonly,
    ACTIONS(4606), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1824), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3766), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3928), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3838), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3745), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1160), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1158), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66944] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3941), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67074] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4636), 1,
      anon_sym_STAR,
    ACTIONS(4638), 1,
      sym_number,
    ACTIONS(4640), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67133] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4642), 1,
      anon_sym_STAR,
    ACTIONS(4644), 1,
      anon_sym_async,
    ACTIONS(4646), 1,
      sym_number,
    ACTIONS(4648), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1819), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4013), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4021), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3950), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3952), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2509), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1074), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1076), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3804), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67472] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_DOT,
    ACTIONS(3658), 1,
      anon_sym_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4025), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1102), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_PIPE,
    ACTIONS(2627), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2625), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_PIPE,
    ACTIONS(2623), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2621), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2405), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2403), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67790] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      anon_sym_STAR,
    ACTIONS(4652), 1,
      sym_number,
    ACTIONS(4654), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_PIPE,
    ACTIONS(2619), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2617), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2469), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67947] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4658), 1,
      sym_number,
    ACTIONS(4660), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4029), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3824), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68096] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      sym_number,
    ACTIONS(4666), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4668), 1,
      anon_sym_LBRACK,
    ACTIONS(2475), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2473), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2433), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4033), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4037), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2451), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2467), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1168), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1166), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2425), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_PIPE,
    ACTIONS(2615), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2613), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68615] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_LT,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [68674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_DOT,
    ACTIONS(2399), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2397), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2501), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3890), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_DOT,
    ACTIONS(2395), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2393), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_DOT,
    ACTIONS(2417), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2415), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68950] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4598), 1,
      anon_sym_STAR,
    ACTIONS(4600), 1,
      anon_sym_async,
    ACTIONS(4602), 1,
      sym_number,
    ACTIONS(4606), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1824), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1162), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2497), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3982), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69150] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(589), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 1,
      anon_sym_COMMA,
    ACTIONS(3979), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69297] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3495), 1,
      anon_sym_DOT,
    ACTIONS(3652), 1,
      anon_sym_LT,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    STATE(2389), 1,
      sym_type_arguments,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [69356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3982), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4642), 1,
      anon_sym_STAR,
    ACTIONS(4670), 1,
      sym_number,
    ACTIONS(4672), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1080), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3846), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1154), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69599] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4674), 1,
      anon_sym_STAR,
    ACTIONS(4676), 1,
      sym_number,
    ACTIONS(4678), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1108), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2411), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2407), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2493), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1176), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2421), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69973] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4674), 1,
      anon_sym_STAR,
    ACTIONS(4680), 1,
      anon_sym_async,
    ACTIONS(4682), 1,
      sym_number,
    ACTIONS(4684), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1831), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70034] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4598), 1,
      anon_sym_STAR,
    ACTIONS(4686), 1,
      sym_number,
    ACTIONS(4688), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1232), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1234), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4690), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3993), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70230] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_DOT,
    ACTIONS(3662), 1,
      anon_sym_as,
    ACTIONS(3735), 1,
      anon_sym_BANG,
    ACTIONS(3834), 1,
      anon_sym_LBRACK,
    ACTIONS(4294), 1,
      anon_sym_LT,
    ACTIONS(4296), 1,
      anon_sym_QMARK,
    ACTIONS(4298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4304), 1,
      anon_sym_AMP,
    ACTIONS(4306), 1,
      anon_sym_PIPE,
    ACTIONS(4310), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4314), 1,
      anon_sym_QMARK_QMARK,
    STATE(2389), 1,
      sym_type_arguments,
    ACTIONS(3737), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4300), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4308), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1096), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4302), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4292), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4312), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70315] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4694), 1,
      sym_number,
    ACTIONS(4696), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4106), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3764), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1090), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1120), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1134), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1224), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 1,
      anon_sym_COMMA,
    ACTIONS(3979), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2509), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1200), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70787] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4636), 1,
      anon_sym_STAR,
    ACTIONS(4700), 1,
      anon_sym_async,
    ACTIONS(4702), 1,
      sym_number,
    ACTIONS(4706), 1,
      sym_readonly,
    ACTIONS(4704), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1827), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1210), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4100), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4102), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3854), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4668), 1,
      anon_sym_LBRACK,
    ACTIONS(2443), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2441), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4098), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3850), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2477), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4708), 1,
      anon_sym_STAR,
    ACTIONS(4710), 1,
      sym_number,
    ACTIONS(4712), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1244), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3762), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71363] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4612), 1,
      anon_sym_STAR,
    ACTIONS(4614), 1,
      anon_sym_async,
    ACTIONS(4616), 1,
      sym_number,
    ACTIONS(4714), 1,
      sym_readonly,
    ACTIONS(4620), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1817), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4009), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71471] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4716), 1,
      anon_sym_async,
    ACTIONS(4718), 1,
      sym_number,
    ACTIONS(4722), 1,
      sym_readonly,
    ACTIONS(4720), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3273), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2469), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71628] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4716), 1,
      anon_sym_async,
    ACTIONS(4718), 1,
      sym_number,
    ACTIONS(4720), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4636), 1,
      anon_sym_STAR,
    ACTIONS(4700), 1,
      anon_sym_async,
    ACTIONS(4702), 1,
      sym_number,
    ACTIONS(4704), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1827), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3989), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    ACTIONS(1098), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 22,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1186), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4005), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71991] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4724), 1,
      anon_sym_STAR,
    ACTIONS(4726), 1,
      anon_sym_async,
    ACTIONS(4728), 1,
      sym_number,
    ACTIONS(4730), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1829), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4001), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2485), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2447), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1220), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1144), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3609), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72373] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4724), 1,
      anon_sym_STAR,
    ACTIONS(4732), 1,
      sym_number,
    ACTIONS(4734), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2437), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2505), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2455), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2429), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2463), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2489), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3967), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3969), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2459), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72792] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4612), 1,
      anon_sym_STAR,
    ACTIONS(4736), 1,
      sym_number,
    ACTIONS(4738), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4017), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1196), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1130), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2481), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73031] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4740), 1,
      anon_sym_STAR,
    ACTIONS(4742), 1,
      sym_number,
    ACTIONS(4744), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73090] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4650), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      sym_number,
    ACTIONS(4746), 1,
      sym_readonly,
    ACTIONS(4666), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1832), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3535), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73153] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 1,
      sym_number,
    STATE(2056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2467), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      sym_number,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3979), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4750), 1,
      sym_number,
    STATE(2044), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73411] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3973), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1098), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73525] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73595] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 1,
      sym_number,
    STATE(2052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73649] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4686), 1,
      sym_number,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73753] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4652), 1,
      sym_number,
    STATE(2047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73875] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    ACTIONS(4481), 1,
      anon_sym_in,
    ACTIONS(4484), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73993] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_EQ,
    ACTIONS(3784), 1,
      anon_sym_in,
    ACTIONS(3787), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4670), 1,
      sym_number,
    STATE(2041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      sym_number,
    STATE(1921), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    ACTIONS(3817), 1,
      anon_sym_in,
    ACTIONS(3820), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74201] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74317] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74387] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74453] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74523] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4760), 1,
      sym_number,
    STATE(1917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3535), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74693] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 1,
      sym_number,
    STATE(2015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74815] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74883] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74953] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      sym_number,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75007] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75077] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75193] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_EQ,
    ACTIONS(4474), 1,
      anon_sym_in,
    ACTIONS(4477), 1,
      anon_sym_of,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1100), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75243] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75311] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      sym_number,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 1,
      sym_number,
    STATE(2022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75419] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4676), 1,
      sym_number,
    STATE(2053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4694), 1,
      sym_number,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75588] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4766), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2478), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75659] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75769] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4768), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75840] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75903] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75964] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76025] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76086] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76147] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4772), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_LPAREN,
    ACTIONS(4780), 1,
      anon_sym_DOT,
    STATE(1725), 1,
      sym_arguments,
    ACTIONS(4776), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4774), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76267] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4782), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76338] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(780), 1,
      anon_sym_RPAREN,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(1709), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2458), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_LPAREN,
    ACTIONS(4788), 1,
      anon_sym_DOT,
    STATE(1724), 1,
      sym_arguments,
    ACTIONS(4786), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4784), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76458] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76523] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4790), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76594] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_RPAREN,
    STATE(1703), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2514), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76665] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4794), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76736] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4796), 1,
      anon_sym_RPAREN,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76807] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2431), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4800), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4798), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76973] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(1708), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2662), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4802), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77083] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2757), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77151] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2580), 1,
      sym_readonly,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    STATE(1811), 1,
      sym_accessibility_modifier,
    STATE(2003), 1,
      sym__parameter_name,
    STATE(2137), 1,
      sym_object,
    STATE(2138), 1,
      sym_array,
    ACTIONS(4762), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2578), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2478), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2554), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77270] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3591), 1,
      anon_sym_module,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    ACTIONS(4806), 1,
      anon_sym_default,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2133), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77345] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1352), 1,
      anon_sym_namespace,
    ACTIONS(1356), 1,
      anon_sym_type,
    ACTIONS(1358), 1,
      anon_sym_import,
    ACTIONS(1360), 1,
      anon_sym_var,
    ACTIONS(1362), 1,
      anon_sym_let,
    ACTIONS(1364), 1,
      anon_sym_const,
    ACTIONS(1371), 1,
      anon_sym_class,
    ACTIONS(1373), 1,
      anon_sym_async,
    ACTIONS(1375), 1,
      anon_sym_function,
    ACTIONS(1377), 1,
      anon_sym_abstract,
    ACTIONS(1379), 1,
      anon_sym_declare,
    ACTIONS(1383), 1,
      anon_sym_interface,
    ACTIONS(1385), 1,
      anon_sym_enum,
    ACTIONS(1441), 1,
      anon_sym_module,
    ACTIONS(1443), 1,
      anon_sym_global,
    STATE(1810), 1,
      sym_decorator,
    STATE(2319), 1,
      aux_sym_export_statement_repeat1,
    STATE(536), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77420] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1352), 1,
      anon_sym_namespace,
    ACTIONS(1356), 1,
      anon_sym_type,
    ACTIONS(1358), 1,
      anon_sym_import,
    ACTIONS(1360), 1,
      anon_sym_var,
    ACTIONS(1362), 1,
      anon_sym_let,
    ACTIONS(1364), 1,
      anon_sym_const,
    ACTIONS(1371), 1,
      anon_sym_class,
    ACTIONS(1373), 1,
      anon_sym_async,
    ACTIONS(1375), 1,
      anon_sym_function,
    ACTIONS(1377), 1,
      anon_sym_abstract,
    ACTIONS(1383), 1,
      anon_sym_interface,
    ACTIONS(1385), 1,
      anon_sym_enum,
    ACTIONS(1443), 1,
      anon_sym_global,
    ACTIONS(1447), 1,
      anon_sym_declare,
    ACTIONS(2123), 1,
      anon_sym_module,
    STATE(1810), 1,
      sym_decorator,
    STATE(2319), 1,
      aux_sym_export_statement_repeat1,
    STATE(536), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77495] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1352), 1,
      anon_sym_namespace,
    ACTIONS(1356), 1,
      anon_sym_type,
    ACTIONS(1358), 1,
      anon_sym_import,
    ACTIONS(1360), 1,
      anon_sym_var,
    ACTIONS(1362), 1,
      anon_sym_let,
    ACTIONS(1364), 1,
      anon_sym_const,
    ACTIONS(1371), 1,
      anon_sym_class,
    ACTIONS(1373), 1,
      anon_sym_async,
    ACTIONS(1375), 1,
      anon_sym_function,
    ACTIONS(1377), 1,
      anon_sym_abstract,
    ACTIONS(1381), 1,
      anon_sym_module,
    ACTIONS(1383), 1,
      anon_sym_interface,
    ACTIONS(1385), 1,
      anon_sym_enum,
    ACTIONS(1447), 1,
      anon_sym_declare,
    ACTIONS(4808), 1,
      anon_sym_default,
    STATE(1810), 1,
      sym_decorator,
    STATE(2319), 1,
      aux_sym_export_statement_repeat1,
    STATE(601), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77672] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3567), 1,
      anon_sym_namespace,
    ACTIONS(3571), 1,
      anon_sym_type,
    ACTIONS(3573), 1,
      anon_sym_import,
    ACTIONS(3575), 1,
      anon_sym_var,
    ACTIONS(3577), 1,
      anon_sym_let,
    ACTIONS(3579), 1,
      anon_sym_const,
    ACTIONS(3581), 1,
      anon_sym_class,
    ACTIONS(3583), 1,
      anon_sym_async,
    ACTIONS(3585), 1,
      anon_sym_function,
    ACTIONS(3587), 1,
      anon_sym_abstract,
    ACTIONS(3589), 1,
      anon_sym_declare,
    ACTIONS(3593), 1,
      anon_sym_interface,
    ACTIONS(3595), 1,
      anon_sym_enum,
    ACTIONS(4810), 1,
      anon_sym_module,
    ACTIONS(4812), 1,
      anon_sym_global,
    STATE(1810), 1,
      sym_decorator,
    STATE(2311), 1,
      aux_sym_export_statement_repeat1,
    STATE(2229), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77747] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77798] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1352), 1,
      anon_sym_namespace,
    ACTIONS(1356), 1,
      anon_sym_type,
    ACTIONS(1358), 1,
      anon_sym_import,
    ACTIONS(1360), 1,
      anon_sym_var,
    ACTIONS(1362), 1,
      anon_sym_let,
    ACTIONS(1364), 1,
      anon_sym_const,
    ACTIONS(1371), 1,
      anon_sym_class,
    ACTIONS(1373), 1,
      anon_sym_async,
    ACTIONS(1375), 1,
      anon_sym_function,
    ACTIONS(1377), 1,
      anon_sym_abstract,
    ACTIONS(1379), 1,
      anon_sym_declare,
    ACTIONS(1381), 1,
      anon_sym_module,
    ACTIONS(1383), 1,
      anon_sym_interface,
    ACTIONS(1385), 1,
      anon_sym_enum,
    ACTIONS(4808), 1,
      anon_sym_default,
    STATE(1810), 1,
      sym_decorator,
    STATE(2319), 1,
      aux_sym_export_statement_repeat1,
    STATE(601), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [77873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3836), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2548), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3789), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4814), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4818), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3273), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3271), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4776), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4774), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78210] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4822), 1,
      anon_sym_STAR,
    ACTIONS(4824), 1,
      sym_number,
    ACTIONS(4826), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78263] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4828), 1,
      anon_sym_STAR,
    ACTIONS(4830), 1,
      sym_number,
    ACTIONS(4832), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78316] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4834), 1,
      anon_sym_STAR,
    ACTIONS(4836), 1,
      sym_number,
    ACTIONS(4838), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78369] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4834), 1,
      anon_sym_STAR,
    ACTIONS(4836), 1,
      sym_number,
    ACTIONS(4840), 1,
      anon_sym_async,
    ACTIONS(4838), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78424] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4828), 1,
      anon_sym_STAR,
    ACTIONS(4830), 1,
      sym_number,
    ACTIONS(4842), 1,
      anon_sym_async,
    ACTIONS(4844), 1,
      sym_readonly,
    ACTIONS(4832), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4828), 1,
      anon_sym_STAR,
    ACTIONS(4830), 1,
      sym_number,
    ACTIONS(4842), 1,
      anon_sym_async,
    ACTIONS(4832), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78536] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4830), 1,
      sym_number,
    ACTIONS(4846), 1,
      anon_sym_EQ_GT,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78587] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(2118), 1,
      sym_object,
    STATE(2123), 1,
      sym_array,
    ACTIONS(2653), 2,
      sym_identifier,
      sym_this,
    ACTIONS(611), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2655), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4848), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78673] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78721] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4852), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2019), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4686), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4854), 1,
      sym__automatic_semicolon,
    ACTIONS(1102), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1104), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78857] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4676), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4858), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78991] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79039] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4830), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4866), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4864), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4862), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4868), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2030), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79223] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4652), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4836), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79319] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79367] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4694), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4870), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4874), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4878), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4882), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2064), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4884), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4888), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79653] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4824), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4892), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4896), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4902), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4900), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1104), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 1,
      sym__automatic_semicolon,
    ACTIONS(1070), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1072), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4906), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4910), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4670), 1,
      sym_number,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    STATE(2146), 1,
      sym_object,
    STATE(2291), 1,
      sym_array,
    ACTIONS(4914), 2,
      sym_identifier,
      sym_this,
    ACTIONS(4918), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4916), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1160), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80103] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 1,
      anon_sym_RBRACE,
    ACTIONS(4922), 1,
      sym_number,
    STATE(2622), 1,
      sym_enum_assignment,
    STATE(2310), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80152] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      sym_number,
    ACTIONS(4924), 1,
      anon_sym_RBRACE,
    STATE(2622), 1,
      sym_enum_assignment,
    STATE(2310), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80201] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4926), 1,
      anon_sym_RBRACE,
    ACTIONS(4928), 1,
      sym_number,
    STATE(2486), 1,
      sym_enum_assignment,
    STATE(2219), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80250] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      sym_number,
    ACTIONS(4930), 1,
      anon_sym_RBRACE,
    STATE(2622), 1,
      sym_enum_assignment,
    STATE(2310), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80299] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4932), 1,
      anon_sym_RBRACE,
    ACTIONS(4934), 1,
      sym_number,
    STATE(2455), 1,
      sym_enum_assignment,
    STATE(2267), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80348] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      sym_number,
    ACTIONS(4936), 1,
      anon_sym_RBRACE,
    STATE(2622), 1,
      sym_enum_assignment,
    STATE(2310), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80397] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4612), 1,
      anon_sym_STAR,
    ACTIONS(4614), 1,
      anon_sym_async,
    ACTIONS(4616), 1,
      sym_number,
    ACTIONS(4938), 1,
      anon_sym_static,
    ACTIONS(4940), 1,
      anon_sym_abstract,
    ACTIONS(4942), 1,
      sym_readonly,
    ACTIONS(4620), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1817), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(611), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2548), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4948), 1,
      anon_sym_AT,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
    ACTIONS(4946), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4944), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80534] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 1,
      anon_sym_STAR,
    ACTIONS(4953), 1,
      sym_number,
    ACTIONS(4957), 1,
      sym_readonly,
    ACTIONS(4955), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1818), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80584] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      sym_number,
    STATE(2622), 1,
      sym_enum_assignment,
    STATE(2310), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80630] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      sym_number,
    ACTIONS(4965), 1,
      sym_readonly,
    ACTIONS(4963), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1822), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4967), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80716] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4636), 1,
      anon_sym_STAR,
    ACTIONS(4700), 1,
      anon_sym_async,
    ACTIONS(4702), 1,
      sym_number,
    ACTIONS(4706), 1,
      sym_readonly,
    ACTIONS(4969), 1,
      anon_sym_static,
    ACTIONS(4704), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1827), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80770] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(2515), 1,
      anon_sym_async,
    ACTIONS(2519), 1,
      sym_readonly,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4752), 1,
      anon_sym_STAR,
    ACTIONS(4971), 1,
      anon_sym_static,
    ACTIONS(2517), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80824] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_STAR,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4284), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      sym_number,
    ACTIONS(4398), 1,
      sym_readonly,
    ACTIONS(4973), 1,
      anon_sym_static,
    ACTIONS(4288), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1826), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4836), 1,
      sym_number,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80921] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4742), 1,
      sym_number,
    STATE(2056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      sym_number,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      sym_number,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81050] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      sym_number,
    STATE(1921), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4710), 1,
      sym_number,
    STATE(2022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81136] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4670), 1,
      sym_number,
    STATE(2041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4882), 1,
      sym_number,
    STATE(2064), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4856), 1,
      sym_number,
    STATE(2016), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81265] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4824), 1,
      sym_number,
    STATE(2093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4868), 1,
      sym_number,
    STATE(2030), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4736), 1,
      sym_number,
    STATE(2015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81394] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(2389), 1,
      sym_number,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    STATE(2039), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4638), 1,
      sym_number,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4686), 1,
      sym_number,
    STATE(2024), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4652), 1,
      sym_number,
    STATE(2047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(4282), 1,
      anon_sym_LBRACK,
    ACTIONS(4760), 1,
      sym_number,
    STATE(1917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3535), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81609] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4694), 1,
      sym_number,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4830), 1,
      sym_number,
    STATE(2063), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4852), 1,
      sym_number,
    STATE(2019), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81738] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4676), 1,
      sym_number,
    STATE(2053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81781] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4405), 1,
      sym_number,
    STATE(2040), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81824] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4750), 1,
      sym_number,
    STATE(2044), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(4403), 1,
      anon_sym_LBRACK,
    ACTIONS(4732), 1,
      sym_number,
    STATE(2052), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2513), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(4975), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(4979), 1,
      sym_readonly,
    STATE(2118), 1,
      sym_object,
    STATE(2123), 1,
      sym_array,
    ACTIONS(2653), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2655), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4981), 1,
      sym_identifier,
    STATE(1694), 1,
      sym_decorator_member_expression,
    STATE(1727), 1,
      sym_decorator_call_expression,
    ACTIONS(4983), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82021] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 1,
      anon_sym_EQ,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(4985), 1,
      anon_sym_LT,
    ACTIONS(4987), 1,
      anon_sym_DOT,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(2521), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [82053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 1,
      anon_sym_PIPE,
    ACTIONS(1224), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [82076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 1,
      anon_sym_PIPE,
    ACTIONS(1080), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [82099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_EQ,
    ACTIONS(4985), 1,
      anon_sym_LT,
    STATE(422), 1,
      sym_type_arguments,
    ACTIONS(2584), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [82125] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(4993), 1,
      anon_sym_QMARK,
    ACTIONS(4995), 1,
      anon_sym_BANG,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2193), 1,
      sym_type_annotation,
    STATE(2245), 1,
      sym__call_signature,
    STATE(2464), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(4991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82167] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(4995), 1,
      anon_sym_BANG,
    ACTIONS(4997), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2193), 1,
      sym_type_annotation,
    STATE(2461), 1,
      sym__call_signature,
    STATE(2464), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(4991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82209] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(5001), 1,
      anon_sym_QMARK,
    ACTIONS(5003), 1,
      anon_sym_BANG,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2194), 1,
      sym_type_annotation,
    STATE(2244), 1,
      sym__call_signature,
    STATE(2550), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(4999), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82251] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(5007), 1,
      anon_sym_QMARK,
    ACTIONS(5009), 1,
      anon_sym_BANG,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2293), 1,
      sym__call_signature,
    STATE(2295), 1,
      sym_type_annotation,
    STATE(2499), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5005), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 1,
      anon_sym_PIPE,
    ACTIONS(3186), 1,
      anon_sym_is,
    ACTIONS(5011), 1,
      anon_sym_LT,
    ACTIONS(5013), 1,
      anon_sym_DOT,
    STATE(1905), 1,
      sym_type_arguments,
    ACTIONS(2521), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [82323] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(5017), 1,
      anon_sym_QMARK,
    ACTIONS(5019), 1,
      anon_sym_BANG,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2196), 1,
      sym_type_annotation,
    STATE(2424), 1,
      sym__call_signature,
    STATE(2434), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5015), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82365] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(4985), 1,
      anon_sym_LT,
    ACTIONS(4987), 1,
      anon_sym_DOT,
    ACTIONS(5021), 1,
      anon_sym_EQ,
    STATE(426), 1,
      sym_type_arguments,
    STATE(2376), 1,
      sym_constraint,
    STATE(2670), 1,
      sym_default_type,
    ACTIONS(5023), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5026), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(2521), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [82403] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    ACTIONS(5019), 1,
      anon_sym_BANG,
    ACTIONS(5028), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2187), 1,
      sym__call_signature,
    STATE(2196), 1,
      sym_type_annotation,
    STATE(2434), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5015), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82445] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5032), 1,
      anon_sym_COLON,
    ACTIONS(5034), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1969), 1,
      sym__call_signature,
    STATE(2232), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5030), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82480] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5038), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1983), 1,
      sym__call_signature,
    STATE(2097), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5036), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82515] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5040), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2097), 1,
      sym_type_annotation,
    STATE(2122), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5036), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82550] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5042), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2230), 1,
      sym__call_signature,
    STATE(2232), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5030), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82585] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5046), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2238), 1,
      sym__call_signature,
    STATE(2241), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5044), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82620] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5050), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1987), 1,
      sym__call_signature,
    STATE(2174), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5048), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82655] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5052), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1994), 1,
      sym__call_signature,
    STATE(2241), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5044), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82690] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(5054), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2168), 1,
      sym__call_signature,
    STATE(2174), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5048), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2613), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [82749] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1984), 1,
      sym__call_signature,
    STATE(2158), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5060), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_PIPE,
    ACTIONS(5011), 1,
      anon_sym_LT,
    STATE(1885), 1,
      sym_type_arguments,
    ACTIONS(2584), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [82805] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2096), 1,
      sym__call_signature,
    STATE(2200), 1,
      sym_type_annotation,
    STATE(2432), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5062), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2156), 1,
      sym__call_signature,
    STATE(2176), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5064), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2281), 1,
      sym_type_annotation,
    STATE(2289), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82905] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2242), 1,
      sym__call_signature,
    STATE(2247), 1,
      sym_type_annotation,
    STATE(2417), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [82941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2625), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [82965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1990), 1,
      sym__call_signature,
    STATE(2252), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5070), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [82997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1985), 1,
      sym__call_signature,
    STATE(2176), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5064), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PIPE,
    ACTIONS(2393), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83051] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2247), 1,
      sym_type_annotation,
    STATE(2409), 1,
      sym__call_signature,
    STATE(2417), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3201), 1,
      anon_sym_is,
    ACTIONS(4985), 1,
      anon_sym_LT,
    ACTIONS(4987), 1,
      anon_sym_DOT,
    ACTIONS(5072), 1,
      anon_sym_RPAREN,
    STATE(426), 1,
      sym_type_arguments,
    ACTIONS(2521), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3521), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [83117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2233), 1,
      sym__call_signature,
    STATE(2252), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5070), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83149] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2102), 1,
      sym_type_annotation,
    STATE(2182), 1,
      sym__call_signature,
    STATE(2460), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5075), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2605), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [83209] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2200), 1,
      sym_type_annotation,
    STATE(2423), 1,
      sym__call_signature,
    STATE(2432), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5062), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2621), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [83269] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2269), 1,
      sym_type_annotation,
    STATE(2277), 1,
      sym__call_signature,
    STATE(2398), 1,
      sym__initializer,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5077), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2617), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [83329] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1998), 1,
      sym__call_signature,
    STATE(2281), 1,
      sym_type_annotation,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83361] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2158), 1,
      sym_type_annotation,
    STATE(2171), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
    ACTIONS(5060), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [83393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2399), 1,
      anon_sym_PIPE,
    ACTIONS(5013), 1,
      anon_sym_DOT,
    ACTIONS(2397), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [83473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT,
    ACTIONS(2415), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1164), 1,
      anon_sym_PIPE,
    ACTIONS(1162), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [83572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_PIPE,
    ACTIONS(2463), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83590] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(3607), 1,
      anon_sym_LBRACE,
    ACTIONS(5081), 1,
      sym_identifier,
    ACTIONS(5083), 1,
      anon_sym_STAR,
    STATE(2600), 1,
      sym_import_clause,
    STATE(2603), 2,
      sym_string,
      sym_import_require_clause,
    STATE(2855), 2,
      sym_namespace_import,
      sym_named_imports,
  [83620] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    STATE(1543), 1,
      sym_class_body,
    STATE(1946), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2630), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5093), 1,
      sym_identifier,
    STATE(1633), 1,
      sym_class_body,
    STATE(1938), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2767), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      anon_sym_EQ,
    ACTIONS(4459), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_PIPE,
    ACTIONS(2481), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_PIPE,
    ACTIONS(2459), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2491), 1,
      anon_sym_PIPE,
    ACTIONS(2489), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5095), 1,
      sym_identifier,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1446), 1,
      sym_class_body,
    STATE(1996), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2654), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83794] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5099), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_class_body,
    STATE(1996), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2654), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(3619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3569), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [83848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_PIPE,
    ACTIONS(2497), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83866] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5101), 1,
      sym_identifier,
    STATE(1414), 1,
      sym_class_body,
    STATE(1977), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2758), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83900] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5103), 1,
      sym_identifier,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1066), 1,
      sym_class_body,
    STATE(1974), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2731), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [83934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_PIPE,
    ACTIONS(589), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 1,
      anon_sym_PIPE,
    ACTIONS(2493), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [83970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5107), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_class_body,
    STATE(1996), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2654), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_PIPE,
    ACTIONS(5109), 1,
      anon_sym_LBRACK,
    ACTIONS(2441), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2605), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [84044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2613), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [84064] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5115), 1,
      sym_identifier,
    STATE(1113), 1,
      sym_class_body,
    STATE(1956), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2611), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 1,
      anon_sym_PIPE,
    ACTIONS(2407), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 1,
      anon_sym_PIPE,
    ACTIONS(2429), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84134] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5117), 1,
      sym_identifier,
    STATE(1414), 1,
      sym_class_body,
    STATE(1977), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2758), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_PIPE,
    ACTIONS(2425), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_PIPE,
    ACTIONS(2455), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 1,
      anon_sym_PIPE,
    ACTIONS(2411), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84222] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5089), 1,
      anon_sym_implements,
    ACTIONS(5091), 1,
      anon_sym_extends,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      sym_identifier,
    STATE(1414), 1,
      sym_class_body,
    STATE(1977), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2758), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_PIPE,
    ACTIONS(2509), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_PIPE,
    ACTIONS(5109), 1,
      anon_sym_LBRACK,
    ACTIONS(2473), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 1,
      anon_sym_PIPE,
    ACTIONS(2433), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_PIPE,
    ACTIONS(2477), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 1,
      anon_sym_PIPE,
    ACTIONS(2451), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2625), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [84368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 1,
      anon_sym_PIPE,
    ACTIONS(2485), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      anon_sym_PIPE,
    ACTIONS(2467), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2621), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [84424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_PIPE,
    ACTIONS(2447), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_PIPE,
    ACTIONS(2403), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2617), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [84480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 1,
      anon_sym_PIPE,
    ACTIONS(2437), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 1,
      anon_sym_PIPE,
    ACTIONS(2421), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_PIPE,
    ACTIONS(2505), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_PIPE,
    ACTIONS(2501), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84552] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(113), 1,
      sym_class_body,
    STATE(1967), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2688), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(5127), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84602] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(1978), 1,
      sym_type_parameters,
    STATE(2173), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2697), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84633] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5131), 1,
      anon_sym_LBRACE,
    STATE(589), 1,
      sym_class_body,
    STATE(1957), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2729), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84664] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1001), 1,
      sym_class_body,
    STATE(1979), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2651), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84695] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1391), 1,
      sym_class_body,
    STATE(1972), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2751), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84726] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1314), 1,
      sym_class_body,
    STATE(1975), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2684), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84757] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1503), 1,
      sym_class_body,
    STATE(2006), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2606), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84788] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(1958), 1,
      sym_type_parameters,
    STATE(2129), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2645), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2196), 1,
      sym_type_annotation,
    STATE(2434), 1,
      sym__initializer,
    ACTIONS(5019), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5015), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84844] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(497), 1,
      sym_class_body,
    STATE(1947), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2741), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(1973), 1,
      sym_type_parameters,
    STATE(2157), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2774), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84906] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1051), 1,
      sym_class_body,
    STATE(1960), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2657), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84937] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2194), 1,
      sym_type_annotation,
    STATE(2550), 1,
      sym__initializer,
    ACTIONS(5003), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(4999), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84962] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(504), 1,
      sym_class_body,
    STATE(1997), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2592), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [84993] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(114), 1,
      sym_class_body,
    STATE(1951), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2728), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85024] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1588), 1,
      sym_class_body,
    STATE(1948), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2632), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85055] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1638), 1,
      sym_class_body,
    STATE(1954), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2580), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85086] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1365), 1,
      sym_class_body,
    STATE(1941), 1,
      sym_type_parameters,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2595), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 1,
      anon_sym_RPAREN,
    ACTIONS(589), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(611), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [85135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2509), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [85151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2515), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4758), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85195] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4754), 1,
      anon_sym_RBRACE,
    STATE(2516), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 1,
      anon_sym_DOT,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2202), 1,
      sym_statement_block,
    ACTIONS(1062), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym_RPAREN,
    ACTIONS(2584), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3521), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [85255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(539), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2405), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2033), 1,
      sym_type_annotation,
    ACTIONS(5141), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2082), 1,
      sym_type_annotation,
    ACTIONS(5143), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2576), 1,
      aux_sym_object_repeat1,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1542), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2626), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85360] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ,
    STATE(2376), 1,
      sym_constraint,
    STATE(2670), 1,
      sym_default_type,
    ACTIONS(5026), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5145), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [85381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5147), 1,
      sym_identifier,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5153), 1,
      anon_sym_enum,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2325), 1,
      sym_variable_declarator,
  [85406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1320), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2739), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5155), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [85444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2170), 1,
      sym_type_annotation,
    ACTIONS(5157), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2247), 1,
      sym_type_annotation,
    STATE(2417), 1,
      sym__initializer,
    ACTIONS(5068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3569), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [85499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1600), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2706), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85524] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2691), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85549] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1623), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2707), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5159), 1,
      sym_identifier,
    ACTIONS(5161), 1,
      anon_sym_STAR,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2695), 1,
      sym__call_signature,
  [85599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(5165), 1,
      sym_identifier,
    ACTIONS(5167), 1,
      anon_sym_DOT,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
  [85624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(128), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2704), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85649] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5169), 1,
      sym_identifier,
    ACTIONS(5171), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2752), 1,
      sym__call_signature,
  [85674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2202), 1,
      sym_statement_block,
    ACTIONS(1062), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1580), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2775), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2109), 1,
      sym_type_annotation,
    ACTIONS(5173), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85733] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1005), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2644), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85758] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5131), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2681), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85783] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2172), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2661), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5175), 1,
      sym_identifier,
    ACTIONS(5177), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2752), 1,
      sym__call_signature,
  [85833] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1003), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2777), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [85858] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5179), 1,
      sym_identifier,
    ACTIONS(5181), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2755), 1,
      sym__call_signature,
  [85883] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_extends,
    STATE(2150), 1,
      sym_object_type,
    STATE(2204), 1,
      sym_type_parameters,
    STATE(2560), 1,
      sym_extends_clause,
  [85908] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(5187), 1,
      sym_identifier,
    ACTIONS(5189), 1,
      anon_sym_DOT,
    STATE(1932), 1,
      sym_nested_identifier,
    STATE(1953), 1,
      sym_string,
    STATE(2228), 1,
      sym__module,
  [85933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5191), 1,
      anon_sym_COLON,
    ACTIONS(5193), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2640), 1,
      sym__call_signature,
  [85958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(5165), 1,
      sym_identifier,
    ACTIONS(5195), 1,
      anon_sym_DOT,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
  [85983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5113), 1,
      anon_sym_PIPE,
    ACTIONS(2641), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(126), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2710), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2269), 1,
      sym_type_annotation,
    STATE(2398), 1,
      sym__initializer,
    ACTIONS(5077), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2601), 1,
      sym_statement_block,
    ACTIONS(5197), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86063] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5199), 1,
      sym_identifier,
    ACTIONS(5201), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2752), 1,
      sym__call_signature,
  [86088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [86101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1438), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2676), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86126] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2215), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2618), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86151] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1112), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2588), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1298), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2639), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5203), 1,
      sym_identifier,
    ACTIONS(5205), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2695), 1,
      sym__call_signature,
  [86226] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1411), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2750), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2237), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2667), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86276] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(993), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2672), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2103), 1,
      sym_type_annotation,
    STATE(2556), 1,
      sym__initializer,
    ACTIONS(3156), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2105), 1,
      sym_type_annotation,
    STATE(2549), 1,
      sym__initializer,
    ACTIONS(3815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2107), 1,
      sym_type_annotation,
    STATE(2545), 1,
      sym__initializer,
    ACTIONS(3782), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2743), 1,
      sym_statement_block,
    ACTIONS(5207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2745), 1,
      sym_statement_block,
    ACTIONS(5209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2721), 1,
      sym_statement_block,
    ACTIONS(5211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5213), 1,
      anon_sym_EQ,
    ACTIONS(5127), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [86434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2683), 1,
      sym_statement_block,
    ACTIONS(5215), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2912), 1,
      sym_predefined_type,
    ACTIONS(5217), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [86479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2609), 1,
      sym_statement_block,
    ACTIONS(5221), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86496] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5147), 1,
      sym_identifier,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5223), 1,
      anon_sym_enum,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2378), 1,
      sym_variable_declarator,
  [86521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2102), 1,
      sym_type_annotation,
    STATE(2460), 1,
      sym__initializer,
    ACTIONS(5075), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2916), 1,
      sym_predefined_type,
    ACTIONS(5217), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2619), 1,
      sym_statement_block,
    ACTIONS(5225), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5227), 1,
      sym_identifier,
    ACTIONS(5229), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2695), 1,
      sym__call_signature,
  [86599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1430), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2733), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2737), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2581), 1,
      sym_statement_block,
    ACTIONS(5231), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2583), 1,
      sym_statement_block,
    ACTIONS(5233), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2599), 1,
      sym_statement_block,
    ACTIONS(5235), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      sym_identifier,
    ACTIONS(5239), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2627), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [86725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(5183), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_extends,
    STATE(569), 1,
      sym_object_type,
    STATE(2135), 1,
      sym_type_parameters,
    STATE(2466), 1,
      sym_extends_clause,
  [86750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(2383), 1,
      sym_type_annotation,
    STATE(2727), 1,
      sym__initializer,
    ACTIONS(5243), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [86773] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5247), 1,
      sym_identifier,
    ACTIONS(5249), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2587), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [86798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5251), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [86811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5125), 1,
      anon_sym_extends,
    STATE(1384), 1,
      sym_class_body,
    STATE(2477), 1,
      sym_extends_clause,
    STATE(2747), 1,
      sym_class_heritage,
    STATE(2829), 1,
      sym_implements_clause,
  [86836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2604), 1,
      sym_statement_block,
    ACTIONS(5253), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2200), 1,
      sym_type_annotation,
    STATE(2432), 1,
      sym__initializer,
    ACTIONS(5062), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [86874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5255), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [86887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2608), 1,
      sym_statement_block,
    ACTIONS(5257), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [86904] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5259), 1,
      sym_identifier,
    ACTIONS(5261), 1,
      anon_sym_STAR,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2768), 1,
      sym__call_signature,
  [86929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_BQUOTE,
    ACTIONS(5268), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5263), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2012), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [86947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_default,
    ACTIONS(5274), 1,
      anon_sym_RBRACE,
    ACTIONS(5276), 1,
      anon_sym_case,
    STATE(2013), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [86965] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5279), 1,
      sym_identifier,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2325), 1,
      sym_variable_declarator,
  [86987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5281), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2245), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5283), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2261), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5287), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
  [87063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5289), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2258), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5291), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2746), 1,
      sym__call_signature,
  [87107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    ACTIONS(4985), 1,
      anon_sym_LT,
    STATE(422), 1,
      sym_type_arguments,
    STATE(2345), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3862), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [87127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2275), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5295), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2285), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87171] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5297), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2187), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3630), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5299), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2017), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3630), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5299), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5303), 1,
      anon_sym_BQUOTE,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5301), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2042), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [87243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3640), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5307), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5309), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2754), 1,
      sym__call_signature,
  [87281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2584), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [87303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5315), 1,
      anon_sym_BQUOTE,
    ACTIONS(5313), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2077), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [87321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5317), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2746), 1,
      sym__call_signature,
  [87343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [87355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [87367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5321), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2435), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2084), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3640), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5307), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87405] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5323), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2665), 1,
      sym__call_signature,
  [87427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5325), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2122), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87449] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5327), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2597), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [87471] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1983), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87493] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2244), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5335), 1,
      anon_sym_BQUOTE,
    ACTIONS(5333), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2012), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [87533] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5337), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2746), 1,
      sym__call_signature,
  [87555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5339), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2424), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2060), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5343), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5341), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87593] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5345), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1987), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2168), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3624), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5349), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5351), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2766), 1,
      sym__call_signature,
  [87675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3862), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    ACTIONS(5353), 1,
      anon_sym_LT,
    STATE(2327), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2525), 1,
      sym_type_arguments,
  [87697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2025), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5357), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5355), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87713] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5359), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2238), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5361), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1994), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [87769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5363), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2665), 1,
      sym__call_signature,
  [87791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5365), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1999), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5370), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5367), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2069), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3628), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5372), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87845] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5374), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2682), 1,
      sym__call_signature,
  [87867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3628), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5372), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(5165), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(532), 1,
      sym__module,
  [87905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5378), 1,
      anon_sym_COMMA,
    ACTIONS(5380), 1,
      anon_sym_RBRACE,
    STATE(2511), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [87925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5384), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2744), 1,
      sym__call_signature,
  [87947] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    ACTIONS(5386), 1,
      anon_sym_QMARK,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2007), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [87969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3646), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5388), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    ACTIONS(5165), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_identifier,
    STATE(508), 1,
      sym_string,
    STATE(539), 1,
      sym__module,
  [88007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5390), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2628), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [88029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2028), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5394), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3634), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5396), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5279), 1,
      sym_identifier,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2375), 1,
      sym_variable_declarator,
  [88083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2048), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3646), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5388), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5279), 1,
      sym_identifier,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2341), 1,
      sym_variable_declarator,
  [88121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5400), 1,
      anon_sym_BQUOTE,
    ACTIONS(5398), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2075), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [88139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5279), 1,
      sym_identifier,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2378), 1,
      sym_variable_declarator,
  [88161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5402), 1,
      anon_sym_BQUOTE,
    ACTIONS(5333), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2012), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [88179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(5187), 1,
      sym_identifier,
    STATE(1932), 1,
      sym_nested_identifier,
    STATE(1953), 1,
      sym_string,
    STATE(2216), 1,
      sym__module,
  [88201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5404), 1,
      anon_sym_BQUOTE,
    ACTIONS(5333), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2012), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [88219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2065), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5408), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5406), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2696), 1,
      sym__call_signature,
  [88257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    ACTIONS(5187), 1,
      sym_identifier,
    STATE(1932), 1,
      sym_nested_identifier,
    STATE(1953), 1,
      sym_string,
    STATE(2228), 1,
      sym__module,
  [88279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 1,
      anon_sym_default,
    ACTIONS(5414), 1,
      anon_sym_RBRACE,
    ACTIONS(5416), 1,
      anon_sym_case,
    STATE(2090), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [88297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2091), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5422), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5420), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3642), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5424), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_LBRACE,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5279), 1,
      sym_identifier,
    STATE(1981), 1,
      sym_object,
    STATE(1982), 1,
      sym_array,
    STATE(2395), 1,
      sym_variable_declarator,
  [88363] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    STATE(2353), 1,
      sym_type_annotation,
    STATE(2671), 1,
      sym__initializer,
    ACTIONS(5426), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [88383] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5428), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2665), 1,
      sym__call_signature,
  [88405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5430), 1,
      anon_sym_COMMA,
    ACTIONS(5432), 1,
      anon_sym_RBRACE,
    STATE(2574), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [88425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3626), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5434), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 1,
      anon_sym_default,
    ACTIONS(5416), 1,
      anon_sym_case,
    ACTIONS(5436), 1,
      anon_sym_RBRACE,
    STATE(2013), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [88459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2057), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3636), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5438), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2089), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3636), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5438), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    ACTIONS(5440), 1,
      anon_sym_QMARK,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2616), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [88513] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5442), 1,
      anon_sym_export,
    ACTIONS(5444), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [88532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1766), 1,
      sym_statement_block,
    ACTIONS(5211), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5452), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      aux_sym_implements_clause_repeat1,
  [88588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2340), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [88607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2711), 1,
      sym__call_signature,
  [88626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5454), 1,
      anon_sym_COMMA,
    ACTIONS(5456), 1,
      anon_sym_GT,
    STATE(2571), 1,
      aux_sym_implements_clause_repeat1,
  [88645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2420), 1,
      sym__initializer,
    ACTIONS(5458), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2543), 1,
      sym__initializer,
    ACTIONS(5460), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2666), 1,
      sym__call_signature,
  [88694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2537), 1,
      sym__initializer,
    ACTIONS(5462), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5464), 1,
      anon_sym_RBRACE,
    STATE(2736), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [88726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2533), 1,
      sym__initializer,
    ACTIONS(5466), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2720), 1,
      sym__call_signature,
  [88760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [88782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1990), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [88801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5468), 1,
      anon_sym_RBRACK,
    STATE(2539), 1,
      aux_sym_implements_clause_repeat1,
  [88820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2762), 1,
      sym__call_signature,
  [88839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2776), 1,
      sym__call_signature,
  [88869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5474), 1,
      anon_sym_COMMA,
    ACTIONS(5476), 1,
      anon_sym_GT,
    STATE(2529), 1,
      aux_sym_implements_clause_repeat1,
  [88932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5478), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_LBRACE,
    ACTIONS(2393), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [88980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [88991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      anon_sym_EQ,
    ACTIONS(4459), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [89004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [89015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1114), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5480), 1,
      anon_sym_COMMA,
    ACTIONS(5482), 1,
      anon_sym_GT,
    STATE(2413), 1,
      aux_sym_implements_clause_repeat1,
  [89067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2156), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_extends,
    STATE(595), 1,
      sym_object_type,
    STATE(2488), 1,
      sym_extends_clause,
  [89127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5484), 1,
      anon_sym_COMMA,
    ACTIONS(5486), 1,
      anon_sym_GT,
    STATE(2553), 1,
      aux_sym_implements_clause_repeat1,
  [89146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4560), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2620), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [89187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2317), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2677), 1,
      sym__call_signature,
  [89225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2674), 1,
      sym__call_signature,
  [89255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2607), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [89285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [89296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89318] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2010), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2742), 1,
      sym__call_signature,
  [89378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 1,
      anon_sym_LT,
    STATE(422), 1,
      sym_type_arguments,
    ACTIONS(4260), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [89393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5494), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2000), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2687), 1,
      sym__call_signature,
  [89497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1998), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89560] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2233), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5215), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5506), 1,
      anon_sym_RBRACK,
    STATE(2492), 1,
      aux_sym_implements_clause_repeat1,
  [89697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5508), 1,
      anon_sym_RBRACK,
    STATE(2443), 1,
      aux_sym_implements_clause_repeat1,
  [89716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2242), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [89757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1743), 1,
      sym_statement_block,
    ACTIONS(5209), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2692), 1,
      sym__call_signature,
  [89791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(1985), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [89810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5510), 1,
      anon_sym_RBRACK,
    STATE(2513), 1,
      aux_sym_implements_clause_repeat1,
  [89829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5512), 1,
      anon_sym_RBRACE,
    STATE(2736), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [89846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_statement_block,
    ACTIONS(5215), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2668), 1,
      sym__call_signature,
  [89891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2617), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [89910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(5353), 1,
      anon_sym_LT,
    STATE(2525), 1,
      sym_type_arguments,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [89927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5514), 1,
      anon_sym_COMMA,
    ACTIONS(5516), 1,
      anon_sym_GT,
    STATE(2421), 1,
      aux_sym_implements_clause_repeat1,
  [89946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2425), 1,
      sym__initializer,
    ACTIONS(5518), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2400), 1,
      sym__initializer,
    ACTIONS(5520), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2416), 1,
      sym__initializer,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [90024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2740), 1,
      sym__call_signature,
  [90043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2410), 1,
      sym__initializer,
    ACTIONS(5526), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [90069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_LBRACE,
    ACTIONS(4764), 1,
      anon_sym_LBRACK,
    ACTIONS(5528), 1,
      sym_identifier,
    STATE(2790), 1,
      sym_object,
    STATE(2794), 1,
      sym_array,
  [90099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_extends,
    STATE(2162), 1,
      sym_object_type,
    STATE(2494), 1,
      sym_extends_clause,
  [90118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5530), 1,
      anon_sym_export,
    ACTIONS(5532), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [90137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [90148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2409), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90167] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2385), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [90197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2748), 1,
      sym__call_signature,
  [90238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2749), 1,
      sym__call_signature,
  [90257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    ACTIONS(5536), 1,
      anon_sym_RBRACE,
    STATE(2396), 1,
      aux_sym_enum_body_repeat1,
    STATE(2716), 1,
      sym__initializer,
  [90331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2735), 1,
      sym__call_signature,
  [90350] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2633), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [90369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2582), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [90388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2624), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [90418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1138), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1084), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5538), 1,
      anon_sym_COMMA,
    ACTIONS(5540), 1,
      anon_sym_GT,
    STATE(2558), 1,
      aux_sym_implements_clause_repeat1,
  [90459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5197), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5542), 1,
      anon_sym_RBRACE,
    STATE(2753), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [90509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5221), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2323), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2289), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(2498), 1,
      aux_sym_implements_clause_repeat1,
  [90588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1228), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(5548), 1,
      anon_sym_RBRACE,
    STATE(2753), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [90638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1762), 1,
      sym_statement_block,
    ACTIONS(5221), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2277), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1761), 1,
      sym_statement_block,
    ACTIONS(5225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1753), 1,
      sym_statement_block,
    ACTIONS(5207), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2738), 1,
      sym__call_signature,
  [90732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2397), 1,
      sym__initializer,
    ACTIONS(5552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [90758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2096), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2763), 1,
      sym__call_signature,
  [90796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [90807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5556), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [90833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2718), 1,
      sym__call_signature,
  [90863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1754), 1,
      sym_statement_block,
    ACTIONS(5257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5257), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_statement_block,
    ACTIONS(5253), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2256), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1736), 1,
      sym_statement_block,
    ACTIONS(5235), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5253), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2257), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2365), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [90998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91009] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2343), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    ACTIONS(5558), 1,
      anon_sym_COMMA,
    ACTIONS(5560), 1,
      anon_sym_RBRACE,
    STATE(2427), 1,
      aux_sym_enum_body_repeat1,
    STATE(2716), 1,
      sym__initializer,
  [91047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2335), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2404), 1,
      sym__initializer,
    ACTIONS(5562), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      sym__automatic_semicolon,
    ACTIONS(1190), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1757), 1,
      sym_statement_block,
    ACTIONS(5233), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2260), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1758), 1,
      sym_statement_block,
    ACTIONS(5231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5566), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5287), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
  [91224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5571), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [91246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      sym__automatic_semicolon,
    ACTIONS(1180), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__automatic_semicolon,
    ACTIONS(1204), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2263), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [91313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 1,
      sym__automatic_semicolon,
    ACTIONS(1170), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5446), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_statement_block,
    ACTIONS(5197), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_EQ,
    STATE(2459), 1,
      sym__initializer,
    ACTIONS(5583), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5587), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91463] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2602), 1,
      sym__call_signature,
    STATE(2634), 1,
      sym_type_parameters,
  [91482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2313), 1,
      sym_formal_parameters,
    STATE(2634), 1,
      sym_type_parameters,
    STATE(2723), 1,
      sym__call_signature,
  [91501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91523] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1935), 1,
      sym_formal_parameters,
    STATE(2401), 1,
      sym__call_signature,
    STATE(2589), 1,
      sym_type_parameters,
  [91542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2359), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91556] = 5,
    ACTIONS(5593), 1,
      anon_sym_DQUOTE,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [91572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5603), 1,
      anon_sym_PIPE,
    ACTIONS(5601), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91586] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5605), 1,
      anon_sym_DQUOTE,
    ACTIONS(5607), 1,
      aux_sym_string_token1,
    ACTIONS(5609), 1,
      sym_escape_sequence,
    STATE(2336), 1,
      aux_sym_string_repeat1,
  [91602] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5605), 1,
      anon_sym_SQUOTE,
    ACTIONS(5611), 1,
      aux_sym_string_token2,
    ACTIONS(5613), 1,
      sym_escape_sequence,
    STATE(2337), 1,
      aux_sym_string_repeat2,
  [91618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    STATE(2716), 1,
      sym__initializer,
    ACTIONS(5615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5617), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [91648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3862), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    STATE(2327), 1,
      aux_sym_extends_clause_repeat1,
  [91664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    STATE(2717), 1,
      sym_type_annotation,
    ACTIONS(5141), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [91678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2636), 1,
      sym_type_parameters,
    STATE(2949), 1,
      sym_formal_parameters,
  [91694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym_type_parameters,
    STATE(2980), 1,
      sym_formal_parameters,
  [91710] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2658), 1,
      sym_type_parameters,
    STATE(2881), 1,
      sym_formal_parameters,
  [91726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_statement_block,
    ACTIONS(5619), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2701), 1,
      sym__from_clause,
    ACTIONS(5623), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5625), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [91770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [91780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    STATE(2753), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [91794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5627), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [91810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2283), 1,
      sym_statement_block,
    ACTIONS(5629), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
    STATE(2736), 1,
      sym__import_export_specifier,
    ACTIONS(5382), 2,
      anon_sym_type,
      anon_sym_typeof,
  [91838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2374), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5631), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(5633), 1,
      anon_sym_LBRACE,
    ACTIONS(5635), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2331), 1,
      aux_sym_extends_clause_repeat1,
  [91868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(5637), 1,
      anon_sym_LBRACE,
    ACTIONS(5639), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2331), 1,
      aux_sym_extends_clause_repeat1,
  [91884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    STATE(2328), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4260), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [91898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2719), 1,
      sym_type_parameters,
    STATE(2953), 1,
      sym_formal_parameters,
  [91914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5644), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [91930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(5646), 1,
      anon_sym_COMMA,
    STATE(2331), 1,
      aux_sym_extends_clause_repeat1,
  [91946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(2641), 2,
      anon_sym_else,
      anon_sym_while,
  [91960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2594), 1,
      sym_type_parameters,
    STATE(2965), 1,
      sym_formal_parameters,
  [91976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5603), 1,
      anon_sym_PIPE,
    ACTIONS(5649), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [91990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1304), 1,
      sym_statement_block,
    ACTIONS(5651), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92004] = 5,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5653), 1,
      anon_sym_DQUOTE,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92020] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5653), 1,
      anon_sym_SQUOTE,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92036] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5659), 1,
      anon_sym_DQUOTE,
    ACTIONS(5661), 1,
      aux_sym_string_token1,
    ACTIONS(5664), 1,
      sym_escape_sequence,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    STATE(1404), 2,
      sym_template_string,
      sym_arguments,
  [92066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_statement_block,
    ACTIONS(5651), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2305), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5667), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [92104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_LBRACE,
    STATE(122), 1,
      sym_statement_block,
    ACTIONS(5651), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92118] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5671), 1,
      anon_sym_SQUOTE,
    ACTIONS(5673), 1,
      aux_sym_string_token2,
    ACTIONS(5676), 1,
      sym_escape_sequence,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    STATE(2328), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5639), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [92148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    STATE(2328), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5635), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [92162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    STATE(2664), 1,
      sym_type_annotation,
    ACTIONS(5143), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [92176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5679), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [92190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2714), 1,
      sym_type_parameters,
    STATE(2940), 1,
      sym_formal_parameters,
  [92206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    STATE(2345), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3862), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [92220] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5681), 1,
      anon_sym_DQUOTE,
    ACTIONS(5683), 1,
      aux_sym_string_token1,
    ACTIONS(5685), 1,
      sym_escape_sequence,
    STATE(2306), 1,
      aux_sym_string_repeat1,
  [92236] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5681), 1,
      anon_sym_SQUOTE,
    ACTIONS(5687), 1,
      aux_sym_string_token2,
    ACTIONS(5689), 1,
      sym_escape_sequence,
    STATE(2392), 1,
      aux_sym_string_repeat2,
  [92252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    STATE(2760), 1,
      sym__initializer,
    ACTIONS(5691), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [92266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5603), 1,
      anon_sym_PIPE,
    ACTIONS(5693), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5695), 1,
      anon_sym_class,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [92296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_EQ_GT,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [92308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5697), 1,
      anon_sym_EQ_GT,
    ACTIONS(3569), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [92320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_AMP,
    ACTIONS(5603), 1,
      anon_sym_PIPE,
    ACTIONS(5699), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5701), 1,
      anon_sym_COMMA,
    STATE(2359), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5704), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2272), 1,
      sym_statement_block,
    ACTIONS(5706), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92362] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    ACTIONS(5708), 1,
      anon_sym_SQUOTE,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92378] = 5,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5708), 1,
      anon_sym_DQUOTE,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92394] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_SQUOTE,
    ACTIONS(5712), 1,
      aux_sym_string_token2,
    ACTIONS(5714), 1,
      sym_escape_sequence,
    STATE(2361), 1,
      aux_sym_string_repeat2,
  [92410] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_DQUOTE,
    ACTIONS(5716), 1,
      aux_sym_string_token1,
    ACTIONS(5718), 1,
      sym_escape_sequence,
    STATE(2362), 1,
      aux_sym_string_repeat1,
  [92426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_statement_block,
    ACTIONS(5619), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92440] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_DQUOTE,
    ACTIONS(5722), 1,
      aux_sym_string_token1,
    ACTIONS(5724), 1,
      sym_escape_sequence,
    STATE(2386), 1,
      aux_sym_string_repeat1,
  [92456] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_SQUOTE,
    ACTIONS(5726), 1,
      aux_sym_string_token2,
    ACTIONS(5728), 1,
      sym_escape_sequence,
    STATE(2387), 1,
      aux_sym_string_repeat2,
  [92472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2780), 1,
      sym__from_clause,
    ACTIONS(5730), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92486] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    ACTIONS(5732), 1,
      anon_sym_SQUOTE,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92502] = 5,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DQUOTE,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_LBRACE,
    ACTIONS(5083), 1,
      anon_sym_STAR,
    STATE(2909), 2,
      sym_namespace_import,
      sym_named_imports,
  [92532] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_SQUOTE,
    ACTIONS(5736), 1,
      aux_sym_string_token2,
    ACTIONS(5738), 1,
      sym_escape_sequence,
    STATE(2369), 1,
      aux_sym_string_repeat2,
  [92548] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_DQUOTE,
    ACTIONS(5740), 1,
      aux_sym_string_token1,
    ACTIONS(5742), 1,
      sym_escape_sequence,
    STATE(2370), 1,
      aux_sym_string_repeat1,
  [92564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2359), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5744), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2390), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5746), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ,
    STATE(2615), 1,
      sym_default_type,
    ACTIONS(5748), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [92606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    STATE(2656), 1,
      sym_type_annotation,
    ACTIONS(5750), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [92620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2391), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5752), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92634] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    ACTIONS(5754), 1,
      anon_sym_SQUOTE,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92650] = 5,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5754), 1,
      anon_sym_DQUOTE,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92666] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_SQUOTE,
    ACTIONS(5758), 1,
      aux_sym_string_token2,
    ACTIONS(5760), 1,
      sym_escape_sequence,
    STATE(2379), 1,
      aux_sym_string_repeat2,
  [92682] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_DQUOTE,
    ACTIONS(5762), 1,
      aux_sym_string_token1,
    ACTIONS(5764), 1,
      sym_escape_sequence,
    STATE(2380), 1,
      aux_sym_string_repeat1,
  [92698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_EQ,
    STATE(2673), 1,
      sym__initializer,
    ACTIONS(5766), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [92712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5768), 1,
      anon_sym_COMMA,
    STATE(2384), 1,
      aux_sym_array_repeat1,
    ACTIONS(4215), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [92726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1316), 1,
      sym_statement_block,
    ACTIONS(5619), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92740] = 5,
    ACTIONS(5595), 1,
      aux_sym_string_token1,
    ACTIONS(5597), 1,
      sym_escape_sequence,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5771), 1,
      anon_sym_DQUOTE,
    STATE(2338), 1,
      aux_sym_string_repeat1,
  [92756] = 5,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    ACTIONS(5771), 1,
      anon_sym_SQUOTE,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1955), 1,
      sym_formal_parameters,
    STATE(2685), 1,
      sym_type_parameters,
  [92788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_BQUOTE,
    ACTIONS(3034), 1,
      anon_sym_LPAREN,
    STATE(1086), 2,
      sym_template_string,
      sym_arguments,
  [92802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2359), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5773), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2359), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5775), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92830] = 5,
    ACTIONS(5593), 1,
      anon_sym_SQUOTE,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(5655), 1,
      aux_sym_string_token2,
    ACTIONS(5657), 1,
      sym_escape_sequence,
    STATE(2344), 1,
      aux_sym_string_repeat2,
  [92846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_BQUOTE,
    ACTIONS(3038), 1,
      anon_sym_LPAREN,
    STATE(1582), 2,
      sym_template_string,
      sym_arguments,
  [92860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5777), 1,
      anon_sym_export,
    STATE(1778), 1,
      aux_sym_export_statement_repeat1,
    STATE(1810), 1,
      sym_decorator,
  [92876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_RBRACE,
    ACTIONS(5779), 1,
      anon_sym_COMMA,
    STATE(2419), 1,
      aux_sym_enum_body_repeat1,
  [92898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5781), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      anon_sym_LPAREN,
    ACTIONS(5787), 1,
      anon_sym_await,
    STATE(36), 1,
      sym__for_header,
  [92929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5793), 1,
      sym_identifier,
    ACTIONS(5795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5797), 1,
      sym_identifier,
    ACTIONS(5799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [92969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5803), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [92991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5805), 1,
      anon_sym_COMMA,
    ACTIONS(5807), 1,
      anon_sym_GT,
    STATE(2490), 1,
      aux_sym_type_parameters_repeat1,
  [93004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5809), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [93017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5807), 1,
      anon_sym_GT,
    ACTIONS(5811), 1,
      sym_identifier,
    STATE(2705), 1,
      sym_type_parameter,
  [93030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5817), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    STATE(2512), 1,
      aux_sym_array_repeat1,
  [93074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3373), 1,
      anon_sym_GT,
    ACTIONS(5819), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [93087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5821), 1,
      anon_sym_RPAREN,
  [93113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5825), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5827), 1,
      anon_sym_RPAREN,
  [93144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_RBRACE,
    ACTIONS(5829), 1,
      anon_sym_COMMA,
    STATE(2419), 1,
      aux_sym_enum_body_repeat1,
  [93157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_GT,
    ACTIONS(5834), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [93179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5836), 1,
      anon_sym_RPAREN,
  [93192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5840), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5842), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5844), 1,
      anon_sym_EQ,
    STATE(2938), 1,
      sym_type_parameters,
  [93232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 1,
      anon_sym_RBRACE,
    ACTIONS(5846), 1,
      anon_sym_COMMA,
    STATE(2419), 1,
      aux_sym_enum_body_repeat1,
  [93245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5848), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    STATE(2450), 1,
      aux_sym_array_repeat1,
  [93271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4782), 1,
      anon_sym_RPAREN,
    ACTIONS(5850), 1,
      anon_sym_COMMA,
    STATE(2572), 1,
      aux_sym_formal_parameters_repeat1,
  [93297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5852), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4782), 1,
      anon_sym_RPAREN,
    ACTIONS(5850), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_formal_parameters_repeat1,
  [93319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5854), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5856), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5858), 1,
      anon_sym_RBRACK,
  [93350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5251), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [93359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5860), 1,
      anon_sym_RBRACE,
    STATE(2538), 1,
      aux_sym_object_repeat1,
  [93372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5862), 1,
      anon_sym_EQ_GT,
    STATE(2717), 1,
      sym_type_annotation,
  [93385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5865), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [93398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5860), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [93411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5867), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [93424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5869), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [93437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_LT,
    ACTIONS(5871), 1,
      anon_sym_EQ,
    STATE(2937), 1,
      sym_type_parameters,
  [93450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [93461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5875), 1,
      anon_sym_RBRACK,
  [93474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 1,
      anon_sym_EQ,
    ACTIONS(5879), 1,
      anon_sym_COMMA,
    ACTIONS(5881), 1,
      anon_sym_from,
  [93487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [93496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5885), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [93509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5887), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [93531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5889), 1,
      anon_sym_LBRACE,
    ACTIONS(5577), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [93542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5891), 1,
      anon_sym_EQ_GT,
    STATE(2664), 1,
      sym_type_annotation,
  [93555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5894), 1,
      anon_sym_RBRACK,
  [93568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_COMMA,
    ACTIONS(5560), 1,
      anon_sym_RBRACE,
    STATE(2427), 1,
      aux_sym_enum_body_repeat1,
  [93581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5896), 1,
      anon_sym_EQ_GT,
    STATE(2717), 1,
      sym_type_annotation,
  [93594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5899), 1,
      anon_sym_EQ_GT,
    STATE(2664), 1,
      sym_type_annotation,
  [93607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 1,
      anon_sym_COMMA,
    ACTIONS(5904), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_formal_parameters_repeat1,
  [93620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5906), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 1,
      anon_sym_LBRACE,
    ACTIONS(5571), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [93658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [93669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5916), 1,
      anon_sym_EQ_GT,
    STATE(2664), 1,
      sym_type_annotation,
  [93691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    STATE(594), 1,
      sym_object_type,
  [93704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5919), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4211), 1,
      anon_sym_RBRACK,
    STATE(2473), 1,
      aux_sym_array_repeat1,
  [93730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [93739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4211), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      sym_identifier,
    STATE(446), 1,
      sym_nested_type_identifier,
    STATE(2792), 1,
      sym_nested_identifier,
  [93765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 1,
      anon_sym_COMMA,
    ACTIONS(5925), 1,
      anon_sym_GT,
    STATE(2569), 1,
      aux_sym_type_parameters_repeat1,
  [93778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5927), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [93791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4215), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [93800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5255), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [93809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    ACTIONS(5929), 1,
      anon_sym_LPAREN,
    STATE(521), 1,
      sym_statement_block,
  [93822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      anon_sym_implements,
    ACTIONS(5931), 1,
      anon_sym_LBRACE,
    STATE(2804), 1,
      sym_implements_clause,
  [93835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      anon_sym_RPAREN,
    ACTIONS(5933), 1,
      anon_sym_COMMA,
    STATE(2520), 1,
      aux_sym_formal_parameters_repeat1,
  [93848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      anon_sym_DQUOTE,
    ACTIONS(2387), 1,
      anon_sym_SQUOTE,
    STATE(2873), 1,
      sym_string,
  [93861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5935), 1,
      anon_sym_COMMA,
    ACTIONS(5938), 1,
      anon_sym_RBRACE,
    STATE(2480), 1,
      aux_sym_named_imports_repeat1,
  [93874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5940), 1,
      anon_sym_COMMA,
    ACTIONS(5943), 1,
      anon_sym_RBRACE,
    STATE(2481), 1,
      aux_sym_export_clause_repeat1,
  [93887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [93896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5947), 1,
      anon_sym_EQ_GT,
    STATE(2664), 1,
      sym_type_annotation,
  [93909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5950), 1,
      anon_sym_EQ_GT,
    STATE(2717), 1,
      sym_type_annotation,
  [93922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(5955), 1,
      anon_sym_GT,
    STATE(2406), 1,
      aux_sym_type_parameters_repeat1,
  [93935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_COMMA,
    ACTIONS(5536), 1,
      anon_sym_RBRACE,
    STATE(2396), 1,
      aux_sym_enum_body_repeat1,
  [93948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5957), 1,
      sym_identifier,
    STATE(1394), 1,
      sym_nested_type_identifier,
    STATE(2869), 1,
      sym_nested_identifier,
  [93961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3357), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_object_type,
  [93974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    ACTIONS(5959), 1,
      anon_sym_GT,
    STATE(2705), 1,
      sym_type_parameter,
  [93987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5961), 1,
      anon_sym_COMMA,
    ACTIONS(5964), 1,
      anon_sym_GT,
    STATE(2490), 1,
      aux_sym_type_parameters_repeat1,
  [94000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      sym_identifier,
    STATE(1907), 1,
      sym_nested_type_identifier,
    STATE(2823), 1,
      sym_nested_identifier,
  [94013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5968), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5970), 1,
      anon_sym_RBRACE,
    STATE(2517), 1,
      aux_sym_object_repeat1,
  [94039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    STATE(2217), 1,
      sym_object_type,
  [94052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5970), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      anon_sym_RPAREN,
    ACTIONS(5933), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_formal_parameters_repeat1,
  [94078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5155), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [94087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5972), 1,
      anon_sym_LBRACE,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    ACTIONS(5976), 1,
      anon_sym_GT,
    STATE(2705), 1,
      sym_type_parameter,
  [94122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4151), 1,
      anon_sym_RBRACK,
    STATE(2519), 1,
      aux_sym_array_repeat1,
  [94135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4151), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4229), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(5978), 1,
      anon_sym_RBRACK,
  [94174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_DQUOTE,
    ACTIONS(3064), 1,
      anon_sym_SQUOTE,
    STATE(2648), 1,
      sym_string,
  [94187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_identifier,
    STATE(1068), 1,
      sym_nested_type_identifier,
    STATE(2892), 1,
      sym_nested_identifier,
  [94200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [94209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4229), 1,
      anon_sym_RBRACK,
    STATE(2428), 1,
      aux_sym_array_repeat1,
  [94222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5984), 1,
      anon_sym_as,
    ACTIONS(5986), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [94233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COLON,
    ACTIONS(5988), 1,
      anon_sym_EQ_GT,
    STATE(2717), 1,
      sym_type_annotation,
  [94246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 1,
      anon_sym_COMMA,
    ACTIONS(5993), 1,
      anon_sym_RBRACE,
    STATE(2561), 1,
      aux_sym_export_clause_repeat1,
  [94259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(5995), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(5997), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 1,
      anon_sym_COMMA,
    ACTIONS(6001), 1,
      anon_sym_RPAREN,
    STATE(2433), 1,
      aux_sym_formal_parameters_repeat1,
  [94298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6003), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6005), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6007), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 1,
      anon_sym_DOT,
    ACTIONS(6009), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [94348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(6011), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      anon_sym_RPAREN,
    ACTIONS(6013), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_formal_parameters_repeat1,
  [94374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4246), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4246), 1,
      anon_sym_RBRACK,
    STATE(2411), 1,
      aux_sym_array_repeat1,
  [94400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(6015), 1,
      anon_sym_RPAREN,
  [94413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 1,
      anon_sym_LBRACE,
    ACTIONS(2421), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [94424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 1,
      anon_sym_LBRACE,
    ACTIONS(2407), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [94435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 1,
      anon_sym_LBRACE,
    ACTIONS(2411), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [94446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    ACTIONS(6020), 1,
      anon_sym_RPAREN,
    STATE(2527), 1,
      aux_sym_formal_parameters_repeat1,
  [94459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6022), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_GT,
    ACTIONS(6024), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6022), 1,
      anon_sym_RBRACE,
    STATE(2442), 1,
      aux_sym_object_repeat1,
  [94498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [94507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6026), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4162), 1,
      anon_sym_RPAREN,
    STATE(2544), 1,
      aux_sym_array_repeat1,
  [94538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4162), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_LBRACE,
    ACTIONS(2425), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [94562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6030), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(6032), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6034), 1,
      anon_sym_LPAREN,
    ACTIONS(6036), 1,
      anon_sym_await,
    STATE(44), 1,
      sym__for_header,
  [94610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6038), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [94619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(6040), 1,
      anon_sym_RBRACK,
  [94632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(6044), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6048), 1,
      anon_sym_as,
    ACTIONS(6050), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [94674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_LBRACE,
    ACTIONS(2403), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [94685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_COMMA,
    ACTIONS(6055), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [94725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 1,
      anon_sym_DOT,
    ACTIONS(6063), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [94736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_GT,
    ACTIONS(6065), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4242), 1,
      anon_sym_RPAREN,
    STATE(2467), 1,
      aux_sym_array_repeat1,
  [94762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6067), 1,
      anon_sym_RBRACE,
    STATE(2577), 1,
      aux_sym_object_repeat1,
  [94775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6069), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6067), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [94797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_GT,
    ACTIONS(6071), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6073), 1,
      sym_identifier,
    ACTIONS(6075), 1,
      anon_sym_require,
    STATE(2552), 1,
      sym_nested_identifier,
  [94823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3475), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_object_type,
  [94836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_RBRACE,
    ACTIONS(6077), 1,
      anon_sym_COMMA,
    STATE(2481), 1,
      aux_sym_export_clause_repeat1,
  [94849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 1,
      anon_sym_RBRACE,
    ACTIONS(6079), 1,
      anon_sym_COMMA,
    STATE(2480), 1,
      aux_sym_named_imports_repeat1,
  [94862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4178), 1,
      anon_sym_RBRACK,
    STATE(2579), 1,
      aux_sym_array_repeat1,
  [94875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4178), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_COMMA,
    ACTIONS(5881), 1,
      anon_sym_from,
    ACTIONS(6081), 1,
      anon_sym_EQ,
  [94901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(6083), 1,
      anon_sym_RBRACK,
  [94914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      anon_sym_COMMA,
    ACTIONS(6085), 1,
      anon_sym_RBRACK,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 1,
      sym_identifier,
    STATE(1552), 1,
      sym_nested_type_identifier,
    STATE(2906), 1,
      sym_nested_identifier,
  [94940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6089), 1,
      anon_sym_COMMA,
    ACTIONS(6091), 1,
      anon_sym_GT,
    STATE(2490), 1,
      aux_sym_type_parameters_repeat1,
  [94953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(4242), 1,
      anon_sym_RPAREN,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [94966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_GT,
    ACTIONS(6093), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_implements_clause_repeat1,
  [94979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4772), 1,
      anon_sym_RPAREN,
    ACTIONS(6095), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_formal_parameters_repeat1,
  [94992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    ACTIONS(6091), 1,
      anon_sym_GT,
    STATE(2705), 1,
      sym_type_parameter,
  [95005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6097), 1,
      anon_sym_COMMA,
    ACTIONS(6099), 1,
      anon_sym_RBRACE,
    STATE(2562), 1,
      aux_sym_named_imports_repeat1,
  [95018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_AMP,
    ACTIONS(5058), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_RPAREN,
  [95031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6103), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [95044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6105), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      aux_sym_object_repeat1,
  [95057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(5865), 1,
      anon_sym_RBRACE,
    STATE(2407), 1,
      aux_sym_object_repeat1,
  [95070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_COMMA,
    ACTIONS(6107), 1,
      anon_sym_RBRACK,
    STATE(2384), 1,
      aux_sym_array_repeat1,
  [95083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1587), 1,
      sym_class_body,
  [95093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2599), 1,
      sym_statement_block,
  [95111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2604), 1,
      sym_statement_block,
  [95129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [95139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(2698), 1,
      sym_parenthesized_expression,
  [95149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1537), 1,
      sym_statement_block,
  [95159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1037), 1,
      sym_class_body,
  [95169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1936), 1,
      sym_formal_parameters,
  [95179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parenthesized_expression,
  [95189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(459), 1,
      sym_statement_block,
  [95199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_class_body,
  [95209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [95219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2861), 1,
      sym_formal_parameters,
  [95229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1243), 1,
      sym_class_body,
  [95239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6113), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2743), 1,
      sym_statement_block,
  [95257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6115), 1,
      sym_identifier,
    STATE(1556), 1,
      sym_nested_identifier,
  [95267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2621), 1,
      sym__from_clause,
  [95285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2608), 1,
      sym_statement_block,
  [95303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6117), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2457), 1,
      sym_formal_parameters,
  [95329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1380), 1,
      sym_class_body,
  [95339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1385), 1,
      sym_statement_block,
  [95349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4902), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2298), 1,
      sym_type_annotation,
  [95375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1006), 1,
      sym_class_body,
  [95385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6119), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2299), 1,
      sym_type_annotation,
  [95403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [95419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2583), 1,
      sym_statement_block,
  [95429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1294), 1,
      sym_statement_block,
  [95439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2273), 1,
      sym_class_body,
  [95449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2581), 1,
      sym_statement_block,
  [95467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6127), 1,
      sym_identifier,
    STATE(2552), 1,
      sym_nested_identifier,
  [95493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1000), 1,
      sym_statement_block,
  [95503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_STAR,
  [95513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1518), 1,
      sym_class_body,
  [95523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1512), 1,
      sym_statement_block,
  [95533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1553), 1,
      sym_statement_block,
  [95543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 1,
      sym_identifier,
    ACTIONS(6135), 1,
      anon_sym_STAR,
  [95553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_class_body,
  [95563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1604), 1,
      sym_class_body,
  [95581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(999), 1,
      sym_statement_block,
  [95591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym_formal_parameters,
  [95601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(502), 1,
      sym_statement_block,
  [95611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2944), 1,
      sym_formal_parameters,
  [95621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2945), 1,
      sym_formal_parameters,
  [95631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [95641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1293), 1,
      sym_class_body,
  [95651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2601), 1,
      sym_statement_block,
  [95661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
  [95671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [95681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2964), 1,
      sym_formal_parameters,
  [95691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_class_body,
  [95701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2169), 1,
      sym_class_body,
  [95711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2701), 1,
      sym__from_clause,
  [95729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_LBRACE,
    STATE(564), 1,
      sym_enum_body,
  [95747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2971), 1,
      sym_formal_parameters,
  [95757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(997), 1,
      sym_class_body,
  [95767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_statement_block,
  [95777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2780), 1,
      sym__from_clause,
  [95787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1432), 1,
      sym_class_body,
  [95797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_statement_block,
  [95807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1004), 1,
      sym_class_body,
  [95825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2907), 1,
      sym_formal_parameters,
  [95835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6055), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [95843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2893), 1,
      sym_formal_parameters,
  [95853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2225), 1,
      sym_class_body,
  [95863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 1,
      sym_identifier,
    ACTIONS(6149), 1,
      anon_sym_STAR,
  [95881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [95889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1378), 1,
      sym_statement_block,
  [95899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1002), 1,
      sym_statement_block,
  [95909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2292), 1,
      sym_class_body,
  [95919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1021), 1,
      sym_statement_block,
  [95929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6151), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym__for_header,
  [95939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5748), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [95947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6153), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(990), 1,
      sym_class_body,
  [95965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1637), 1,
      sym_statement_block,
  [95983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    STATE(2485), 1,
      sym_type_parameter,
  [95993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1473), 1,
      sym_class_body,
  [96003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1472), 1,
      sym_statement_block,
  [96013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2956), 1,
      sym_formal_parameters,
  [96023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6157), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    STATE(2116), 1,
      sym_enum_body,
  [96041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_class_body,
  [96051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2619), 1,
      sym_statement_block,
  [96061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1299), 1,
      sym_class_body,
  [96079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym_LPAREN,
    STATE(1943), 1,
      sym_formal_parameters,
  [96089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2483), 1,
      sym_formal_parameters,
  [96099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2609), 1,
      sym_statement_block,
  [96109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_class_body,
  [96119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_from,
    STATE(2603), 1,
      sym__from_clause,
  [96129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6161), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_STAR,
  [96139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(516), 1,
      sym_class_body,
  [96149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_statement_block,
  [96159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      sym_identifier,
    STATE(1859), 1,
      sym_nested_identifier,
  [96177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1489), 1,
      sym_statement_block,
  [96187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1568), 1,
      sym_statement_block,
  [96197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_class_body,
  [96207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_LBRACE,
    STATE(570), 1,
      sym_switch_body,
  [96217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6151), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym__for_header,
  [96227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym_identifier,
    STATE(1089), 1,
      sym_nested_identifier,
  [96261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    STATE(117), 1,
      sym_class_body,
  [96271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5964), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [96279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1636), 1,
      sym_class_body,
  [96289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1624), 1,
      sym_class_body,
  [96299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    STATE(116), 1,
      sym_class_body,
  [96325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1616), 1,
      sym_statement_block,
  [96335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_while,
    ACTIONS(6175), 1,
      anon_sym_else,
  [96345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2465), 1,
      sym_formal_parameters,
  [96355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2831), 1,
      sym_formal_parameters,
  [96365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      sym_identifier,
    STATE(1383), 1,
      sym_nested_identifier,
  [96375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [96391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_statement_block,
  [96401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2865), 1,
      sym_formal_parameters,
  [96411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1595), 1,
      sym_statement_block,
  [96421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 1,
      anon_sym_LBRACE,
    STATE(572), 1,
      sym_enum_body,
  [96439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_statement_block,
  [96449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_statement_block,
  [96459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      sym_identifier,
    STATE(2518), 1,
      sym_nested_identifier,
  [96469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2151), 1,
      sym_statement_block,
  [96479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 1,
      anon_sym_LBRACE,
    STATE(107), 1,
      sym_class_body,
  [96497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 1,
      anon_sym_LBRACE,
    STATE(525), 1,
      sym_class_body,
  [96507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2453), 1,
      sym_formal_parameters,
  [96517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_class_body,
  [96527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    STATE(2166), 1,
      sym_type_annotation,
  [96537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1479), 1,
      sym_class_body,
  [96547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2284), 1,
      sym_statement_block,
  [96565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6187), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_class_body,
  [96583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(2290), 1,
      sym_statement_block,
  [96593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1305), 1,
      sym_class_body,
  [96603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_statement_block,
  [96613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_class_body,
  [96623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2721), 1,
      sym_statement_block,
  [96633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2683), 1,
      sym_statement_block,
  [96651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1500), 1,
      sym_statement_block,
  [96669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1445), 1,
      sym_class_body,
  [96679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1442), 1,
      sym_statement_block,
  [96689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1441), 1,
      sym_statement_block,
  [96699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1506), 1,
      sym_class_body,
  [96709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1440), 1,
      sym_class_body,
  [96719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_statement_block,
  [96729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6189), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(996), 1,
      sym_statement_block,
  [96747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_statement_block,
  [96757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6191), 1,
      anon_sym_LPAREN,
    STATE(2679), 1,
      sym_parenthesized_expression,
  [96767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6193), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 1,
      anon_sym_LBRACE,
    STATE(1446), 1,
      sym_class_body,
  [96785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(598), 1,
      sym_statement_block,
  [96795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6195), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2946), 1,
      sym_formal_parameters,
  [96813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_LBRACE,
    STATE(2745), 1,
      sym_statement_block,
  [96823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(1303), 1,
      sym_statement_block,
  [96833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    STATE(2472), 1,
      sym_type_parameter,
  [96843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6197), 1,
      sym_identifier,
    STATE(425), 1,
      sym_nested_identifier,
  [96853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1012), 1,
      sym_statement_block,
  [96863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1543), 1,
      sym_class_body,
  [96873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1023), 1,
      sym_statement_block,
  [96883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4219), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      sym_identifier,
    STATE(2705), 1,
      sym_type_parameter,
  [96901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6201), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_class_body,
  [96935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 1,
      anon_sym_LBRACE,
    STATE(1569), 1,
      sym_class_body,
  [96945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 1,
      anon_sym_LBRACE,
    STATE(1575), 1,
      sym_statement_block,
  [96955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACE,
    STATE(1016), 1,
      sym_class_body,
  [96965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_LPAREN,
    STATE(2935), 1,
      sym_formal_parameters,
  [96975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    STATE(2148), 1,
      sym_enum_body,
  [96985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      sym_identifier,
  [97000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6205), 1,
      anon_sym_function,
  [97007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6207), 1,
      anon_sym_EQ_GT,
  [97014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6209), 1,
      sym_identifier,
  [97021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6211), 1,
      anon_sym_SLASH2,
  [97028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6213), 1,
      anon_sym_SLASH2,
  [97035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6215), 1,
      anon_sym_SLASH2,
  [97042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_COLON,
  [97049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_RPAREN,
  [97056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_RPAREN,
  [97063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6223), 1,
      anon_sym_EQ_GT,
  [97070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_DOT,
  [97077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6225), 1,
      sym_identifier,
  [97084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6227), 1,
      anon_sym_RPAREN,
  [97091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6229), 1,
      sym_number,
  [97098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6231), 1,
      anon_sym_EQ_GT,
  [97105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6233), 1,
      anon_sym_from,
  [97112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      anon_sym_target,
  [97119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 1,
      sym_identifier,
  [97126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
  [97133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6239), 1,
      anon_sym_EQ_GT,
  [97140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_EQ_GT,
  [97147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 1,
      sym_identifier,
  [97154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_LBRACE,
  [97161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6247), 1,
      sym_identifier,
  [97168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym_EQ_GT,
  [97175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_COLON,
  [97182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6251), 1,
      anon_sym_EQ_GT,
  [97189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5697), 1,
      anon_sym_EQ_GT,
  [97196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_EQ_GT,
  [97203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 1,
      anon_sym_EQ_GT,
  [97210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6257), 1,
      anon_sym_EQ_GT,
  [97217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 1,
      anon_sym_EQ_GT,
  [97224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_while,
  [97231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4352), 1,
      anon_sym_RPAREN,
  [97238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_target,
  [97245] = 2,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_regex_pattern,
  [97252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4354), 1,
      anon_sym_RPAREN,
  [97259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6267), 1,
      anon_sym_COLON,
  [97266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
  [97273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6269), 1,
      sym_identifier,
  [97280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 1,
      anon_sym_RPAREN,
  [97287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_DOT,
  [97294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_EQ_GT,
  [97301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_RPAREN,
  [97308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_EQ_GT,
  [97315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
  [97322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      sym_identifier,
  [97329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 1,
      anon_sym_LBRACE,
  [97336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4104), 1,
      anon_sym_RPAREN,
  [97343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      anon_sym_EQ_GT,
  [97350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      sym_identifier,
  [97357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6279), 1,
      sym_identifier,
  [97364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym_number,
  [97371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 1,
      sym_number,
  [97378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 1,
      anon_sym_RBRACE,
  [97385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 1,
      sym_identifier,
  [97392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6287), 1,
      anon_sym_EQ_GT,
  [97399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 1,
      sym_identifier,
  [97406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 1,
      sym_identifier,
  [97413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 1,
      anon_sym_RPAREN,
  [97420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 1,
      sym_identifier,
  [97427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6297), 1,
      sym_identifier,
  [97434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 1,
      sym_identifier,
  [97441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_COLON,
  [97448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6303), 1,
      sym_number,
  [97455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      sym_identifier,
  [97462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6307), 1,
      sym_identifier,
  [97469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_RBRACE,
  [97476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6311), 1,
      anon_sym_EQ_GT,
  [97483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      sym_identifier,
  [97490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6315), 1,
      anon_sym_SLASH2,
  [97497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_EQ,
  [97504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6319), 1,
      sym_identifier,
  [97511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 1,
      anon_sym_from,
  [97518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6321), 1,
      anon_sym_from,
  [97525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      sym_identifier,
  [97532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      sym_identifier,
  [97539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym_identifier,
  [97546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_as,
  [97553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6331), 1,
      anon_sym_EQ_GT,
  [97560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6333), 1,
      anon_sym_RBRACK,
  [97567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      sym_identifier,
  [97574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
  [97581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_EQ_GT,
  [97588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 1,
      anon_sym_EQ_GT,
  [97595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 1,
      anon_sym_RPAREN,
  [97602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      sym_identifier,
  [97609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_DOT,
  [97616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_RPAREN,
  [97623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_from,
  [97630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3971), 1,
      anon_sym_RPAREN,
  [97637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_RPAREN,
  [97644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      anon_sym_EQ_GT,
  [97651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      sym_identifier,
  [97658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6357), 1,
      sym_identifier,
  [97665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4505), 1,
      anon_sym_RPAREN,
  [97672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_RPAREN,
  [97679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_RPAREN,
  [97686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_RPAREN,
  [97693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      anon_sym_EQ_GT,
  [97700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      sym_identifier,
  [97707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 1,
      anon_sym_EQ_GT,
  [97714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 1,
      anon_sym_EQ_GT,
  [97721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6367), 1,
      anon_sym_EQ_GT,
  [97728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6369), 1,
      anon_sym_EQ_GT,
  [97735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      sym_identifier,
  [97742] = 2,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(6373), 1,
      sym_regex_pattern,
  [97749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_identifier,
  [97756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6377), 1,
      sym_identifier,
  [97763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6379), 1,
      sym_identifier,
  [97770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      anon_sym_DOT,
  [97777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6381), 1,
      anon_sym_EQ_GT,
  [97784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6383), 1,
      sym_identifier,
  [97791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6385), 1,
      sym_identifier,
  [97798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 1,
      anon_sym_EQ,
  [97805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6389), 1,
      anon_sym_EQ,
  [97812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      sym_identifier,
  [97819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6393), 1,
      sym_identifier,
  [97826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 1,
      anon_sym_DOT,
  [97833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6397), 1,
      sym_identifier,
  [97840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6399), 1,
      anon_sym_namespace,
  [97847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6401), 1,
      anon_sym_COLON,
  [97854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_RPAREN,
  [97861] = 2,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(6403), 1,
      sym_regex_pattern,
  [97868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_DOT,
  [97875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6405), 1,
      anon_sym_EQ_GT,
  [97882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 1,
      sym_identifier,
  [97889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6409), 1,
      anon_sym_from,
  [97896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6411), 1,
      sym_identifier,
  [97903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6413), 1,
      anon_sym_LPAREN,
  [97910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_RBRACK,
  [97917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6417), 1,
      sym_identifier,
  [97924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 1,
      sym_identifier,
  [97931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6421), 1,
      anon_sym_EQ_GT,
  [97938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_RBRACK,
  [97945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6425), 1,
      anon_sym_class,
  [97952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 1,
      sym_identifier,
  [97959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6429), 1,
      anon_sym_RPAREN,
  [97966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 1,
      sym_identifier,
  [97973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6433), 1,
      anon_sym_EQ_GT,
  [97980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 1,
      ts_builtin_sym_end,
  [97987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4515), 1,
      anon_sym_RBRACK,
  [97994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6437), 1,
      anon_sym_namespace,
  [98001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6439), 1,
      sym_identifier,
  [98008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6441), 1,
      sym_identifier,
  [98015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 1,
      sym_identifier,
  [98022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6445), 1,
      sym_identifier,
  [98029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 1,
      anon_sym_EQ_GT,
  [98036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 1,
      sym_identifier,
  [98043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 1,
      anon_sym_EQ_GT,
  [98050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 1,
      anon_sym_EQ_GT,
  [98057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_RBRACK,
  [98064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 1,
      sym_identifier,
  [98071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_EQ_GT,
  [98078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym_EQ,
  [98085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 1,
      anon_sym_EQ,
  [98092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_EQ,
  [98099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 1,
      anon_sym_class,
  [98106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6467), 1,
      anon_sym_EQ_GT,
  [98113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 1,
      sym_identifier,
  [98120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      sym_identifier,
  [98127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      sym_identifier,
  [98134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym_EQ_GT,
  [98141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_EQ_GT,
  [98148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 1,
      anon_sym_EQ_GT,
  [98155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      anon_sym_require,
  [98162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      sym_identifier,
  [98169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 1,
      anon_sym_EQ_GT,
  [98176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 1,
      sym_identifier,
  [98183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 1,
      anon_sym_from,
  [98190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym_from,
  [98197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_EQ_GT,
  [98204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      sym_identifier,
  [98211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_RPAREN,
  [98218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 1,
      anon_sym_EQ_GT,
  [98225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym_from,
  [98232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6503), 1,
      sym_identifier,
  [98239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_EQ_GT,
  [98246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_RPAREN,
  [98253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6507), 1,
      sym_identifier,
  [98260] = 2,
    ACTIONS(5599), 1,
      sym_comment,
    ACTIONS(6509), 1,
      sym_regex_pattern,
  [98267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 1,
      sym_identifier,
  [98274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym_EQ_GT,
  [98281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 1,
      anon_sym_EQ_GT,
  [98288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      sym_number,
  [98295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6519), 1,
      sym_identifier,
  [98302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 1,
      anon_sym_RBRACK,
  [98309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 1,
      anon_sym_EQ_GT,
  [98316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 1,
      anon_sym_EQ_GT,
  [98323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
  [98330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 1,
      anon_sym_target,
  [98337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      sym_identifier,
  [98344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 1,
      sym_identifier,
  [98351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      sym_identifier,
  [98358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 1,
      sym_identifier,
  [98365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 1,
      sym_identifier,
  [98372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 1,
      anon_sym_function,
  [98379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym_RBRACE,
  [98386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym_EQ_GT,
  [98393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6545), 1,
      sym_identifier,
  [98400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 1,
      sym_identifier,
  [98407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      sym_identifier,
  [98414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 1,
      sym_identifier,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(617)] = 0,
  [SMALL_STATE(618)] = 98,
  [SMALL_STATE(619)] = 196,
  [SMALL_STATE(620)] = 294,
  [SMALL_STATE(621)] = 392,
  [SMALL_STATE(622)] = 490,
  [SMALL_STATE(623)] = 582,
  [SMALL_STATE(624)] = 680,
  [SMALL_STATE(625)] = 771,
  [SMALL_STATE(626)] = 858,
  [SMALL_STATE(627)] = 948,
  [SMALL_STATE(628)] = 1036,
  [SMALL_STATE(629)] = 1126,
  [SMALL_STATE(630)] = 1214,
  [SMALL_STATE(631)] = 1304,
  [SMALL_STATE(632)] = 1390,
  [SMALL_STATE(633)] = 1478,
  [SMALL_STATE(634)] = 1566,
  [SMALL_STATE(635)] = 1653,
  [SMALL_STATE(636)] = 1742,
  [SMALL_STATE(637)] = 1871,
  [SMALL_STATE(638)] = 2000,
  [SMALL_STATE(639)] = 2129,
  [SMALL_STATE(640)] = 2214,
  [SMALL_STATE(641)] = 2343,
  [SMALL_STATE(642)] = 2428,
  [SMALL_STATE(643)] = 2557,
  [SMALL_STATE(644)] = 2646,
  [SMALL_STATE(645)] = 2735,
  [SMALL_STATE(646)] = 2826,
  [SMALL_STATE(647)] = 2955,
  [SMALL_STATE(648)] = 3084,
  [SMALL_STATE(649)] = 3168,
  [SMALL_STATE(650)] = 3254,
  [SMALL_STATE(651)] = 3338,
  [SMALL_STATE(652)] = 3401,
  [SMALL_STATE(653)] = 3488,
  [SMALL_STATE(654)] = 3559,
  [SMALL_STATE(655)] = 3622,
  [SMALL_STATE(656)] = 3685,
  [SMALL_STATE(657)] = 3768,
  [SMALL_STATE(658)] = 3851,
  [SMALL_STATE(659)] = 3934,
  [SMALL_STATE(660)] = 4017,
  [SMALL_STATE(661)] = 4080,
  [SMALL_STATE(662)] = 4143,
  [SMALL_STATE(663)] = 4226,
  [SMALL_STATE(664)] = 4313,
  [SMALL_STATE(665)] = 4394,
  [SMALL_STATE(666)] = 4474,
  [SMALL_STATE(667)] = 4592,
  [SMALL_STATE(668)] = 4672,
  [SMALL_STATE(669)] = 4752,
  [SMALL_STATE(670)] = 4868,
  [SMALL_STATE(671)] = 4934,
  [SMALL_STATE(672)] = 5000,
  [SMALL_STATE(673)] = 5080,
  [SMALL_STATE(674)] = 5154,
  [SMALL_STATE(675)] = 5234,
  [SMALL_STATE(676)] = 5350,
  [SMALL_STATE(677)] = 5468,
  [SMALL_STATE(678)] = 5548,
  [SMALL_STATE(679)] = 5616,
  [SMALL_STATE(680)] = 5732,
  [SMALL_STATE(681)] = 5806,
  [SMALL_STATE(682)] = 5886,
  [SMALL_STATE(683)] = 5999,
  [SMALL_STATE(684)] = 6078,
  [SMALL_STATE(685)] = 6147,
  [SMALL_STATE(686)] = 6216,
  [SMALL_STATE(687)] = 6329,
  [SMALL_STATE(688)] = 6442,
  [SMALL_STATE(689)] = 6517,
  [SMALL_STATE(690)] = 6630,
  [SMALL_STATE(691)] = 6743,
  [SMALL_STATE(692)] = 6856,
  [SMALL_STATE(693)] = 6969,
  [SMALL_STATE(694)] = 7048,
  [SMALL_STATE(695)] = 7121,
  [SMALL_STATE(696)] = 7234,
  [SMALL_STATE(697)] = 7347,
  [SMALL_STATE(698)] = 7420,
  [SMALL_STATE(699)] = 7533,
  [SMALL_STATE(700)] = 7646,
  [SMALL_STATE(701)] = 7731,
  [SMALL_STATE(702)] = 7804,
  [SMALL_STATE(703)] = 7885,
  [SMALL_STATE(704)] = 7998,
  [SMALL_STATE(705)] = 8111,
  [SMALL_STATE(706)] = 8192,
  [SMALL_STATE(707)] = 8305,
  [SMALL_STATE(708)] = 8418,
  [SMALL_STATE(709)] = 8531,
  [SMALL_STATE(710)] = 8604,
  [SMALL_STATE(711)] = 8677,
  [SMALL_STATE(712)] = 8750,
  [SMALL_STATE(713)] = 8831,
  [SMALL_STATE(714)] = 8904,
  [SMALL_STATE(715)] = 8983,
  [SMALL_STATE(716)] = 9096,
  [SMALL_STATE(717)] = 9209,
  [SMALL_STATE(718)] = 9319,
  [SMALL_STATE(719)] = 9429,
  [SMALL_STATE(720)] = 9539,
  [SMALL_STATE(721)] = 9599,
  [SMALL_STATE(722)] = 9709,
  [SMALL_STATE(723)] = 9819,
  [SMALL_STATE(724)] = 9929,
  [SMALL_STATE(725)] = 10039,
  [SMALL_STATE(726)] = 10149,
  [SMALL_STATE(727)] = 10259,
  [SMALL_STATE(728)] = 10335,
  [SMALL_STATE(729)] = 10445,
  [SMALL_STATE(730)] = 10555,
  [SMALL_STATE(731)] = 10665,
  [SMALL_STATE(732)] = 10775,
  [SMALL_STATE(733)] = 10885,
  [SMALL_STATE(734)] = 10995,
  [SMALL_STATE(735)] = 11105,
  [SMALL_STATE(736)] = 11177,
  [SMALL_STATE(737)] = 11237,
  [SMALL_STATE(738)] = 11347,
  [SMALL_STATE(739)] = 11457,
  [SMALL_STATE(740)] = 11567,
  [SMALL_STATE(741)] = 11635,
  [SMALL_STATE(742)] = 11705,
  [SMALL_STATE(743)] = 11777,
  [SMALL_STATE(744)] = 11887,
  [SMALL_STATE(745)] = 11951,
  [SMALL_STATE(746)] = 12061,
  [SMALL_STATE(747)] = 12171,
  [SMALL_STATE(748)] = 12281,
  [SMALL_STATE(749)] = 12391,
  [SMALL_STATE(750)] = 12501,
  [SMALL_STATE(751)] = 12611,
  [SMALL_STATE(752)] = 12721,
  [SMALL_STATE(753)] = 12831,
  [SMALL_STATE(754)] = 12941,
  [SMALL_STATE(755)] = 13011,
  [SMALL_STATE(756)] = 13121,
  [SMALL_STATE(757)] = 13231,
  [SMALL_STATE(758)] = 13341,
  [SMALL_STATE(759)] = 13451,
  [SMALL_STATE(760)] = 13561,
  [SMALL_STATE(761)] = 13621,
  [SMALL_STATE(762)] = 13693,
  [SMALL_STATE(763)] = 13763,
  [SMALL_STATE(764)] = 13873,
  [SMALL_STATE(765)] = 13983,
  [SMALL_STATE(766)] = 14093,
  [SMALL_STATE(767)] = 14203,
  [SMALL_STATE(768)] = 14313,
  [SMALL_STATE(769)] = 14423,
  [SMALL_STATE(770)] = 14533,
  [SMALL_STATE(771)] = 14643,
  [SMALL_STATE(772)] = 14753,
  [SMALL_STATE(773)] = 14863,
  [SMALL_STATE(774)] = 14973,
  [SMALL_STATE(775)] = 15083,
  [SMALL_STATE(776)] = 15193,
  [SMALL_STATE(777)] = 15303,
  [SMALL_STATE(778)] = 15413,
  [SMALL_STATE(779)] = 15523,
  [SMALL_STATE(780)] = 15633,
  [SMALL_STATE(781)] = 15705,
  [SMALL_STATE(782)] = 15815,
  [SMALL_STATE(783)] = 15925,
  [SMALL_STATE(784)] = 16035,
  [SMALL_STATE(785)] = 16145,
  [SMALL_STATE(786)] = 16215,
  [SMALL_STATE(787)] = 16325,
  [SMALL_STATE(788)] = 16435,
  [SMALL_STATE(789)] = 16503,
  [SMALL_STATE(790)] = 16581,
  [SMALL_STATE(791)] = 16651,
  [SMALL_STATE(792)] = 16761,
  [SMALL_STATE(793)] = 16821,
  [SMALL_STATE(794)] = 16889,
  [SMALL_STATE(795)] = 16999,
  [SMALL_STATE(796)] = 17109,
  [SMALL_STATE(797)] = 17179,
  [SMALL_STATE(798)] = 17289,
  [SMALL_STATE(799)] = 17399,
  [SMALL_STATE(800)] = 17509,
  [SMALL_STATE(801)] = 17619,
  [SMALL_STATE(802)] = 17729,
  [SMALL_STATE(803)] = 17839,
  [SMALL_STATE(804)] = 17949,
  [SMALL_STATE(805)] = 18059,
  [SMALL_STATE(806)] = 18169,
  [SMALL_STATE(807)] = 18279,
  [SMALL_STATE(808)] = 18353,
  [SMALL_STATE(809)] = 18463,
  [SMALL_STATE(810)] = 18573,
  [SMALL_STATE(811)] = 18639,
  [SMALL_STATE(812)] = 18749,
  [SMALL_STATE(813)] = 18821,
  [SMALL_STATE(814)] = 18931,
  [SMALL_STATE(815)] = 19041,
  [SMALL_STATE(816)] = 19151,
  [SMALL_STATE(817)] = 19223,
  [SMALL_STATE(818)] = 19333,
  [SMALL_STATE(819)] = 19443,
  [SMALL_STATE(820)] = 19511,
  [SMALL_STATE(821)] = 19583,
  [SMALL_STATE(822)] = 19693,
  [SMALL_STATE(823)] = 19765,
  [SMALL_STATE(824)] = 19875,
  [SMALL_STATE(825)] = 19985,
  [SMALL_STATE(826)] = 20059,
  [SMALL_STATE(827)] = 20119,
  [SMALL_STATE(828)] = 20229,
  [SMALL_STATE(829)] = 20339,
  [SMALL_STATE(830)] = 20449,
  [SMALL_STATE(831)] = 20520,
  [SMALL_STATE(832)] = 20591,
  [SMALL_STATE(833)] = 20658,
  [SMALL_STATE(834)] = 20731,
  [SMALL_STATE(835)] = 20802,
  [SMALL_STATE(836)] = 20873,
  [SMALL_STATE(837)] = 20944,
  [SMALL_STATE(838)] = 21017,
  [SMALL_STATE(839)] = 21084,
  [SMALL_STATE(840)] = 21155,
  [SMALL_STATE(841)] = 21226,
  [SMALL_STATE(842)] = 21297,
  [SMALL_STATE(843)] = 21368,
  [SMALL_STATE(844)] = 21435,
  [SMALL_STATE(845)] = 21508,
  [SMALL_STATE(846)] = 21575,
  [SMALL_STATE(847)] = 21638,
  [SMALL_STATE(848)] = 21703,
  [SMALL_STATE(849)] = 21780,
  [SMALL_STATE(850)] = 21851,
  [SMALL_STATE(851)] = 21914,
  [SMALL_STATE(852)] = 21985,
  [SMALL_STATE(853)] = 22054,
  [SMALL_STATE(854)] = 22125,
  [SMALL_STATE(855)] = 22198,
  [SMALL_STATE(856)] = 22265,
  [SMALL_STATE(857)] = 22336,
  [SMALL_STATE(858)] = 22399,
  [SMALL_STATE(859)] = 22470,
  [SMALL_STATE(860)] = 22537,
  [SMALL_STATE(861)] = 22599,
  [SMALL_STATE(862)] = 22665,
  [SMALL_STATE(863)] = 22731,
  [SMALL_STATE(864)] = 22795,
  [SMALL_STATE(865)] = 22857,
  [SMALL_STATE(866)] = 22915,
  [SMALL_STATE(867)] = 22977,
  [SMALL_STATE(868)] = 23043,
  [SMALL_STATE(869)] = 23101,
  [SMALL_STATE(870)] = 23169,
  [SMALL_STATE(871)] = 23239,
  [SMALL_STATE(872)] = 23303,
  [SMALL_STATE(873)] = 23367,
  [SMALL_STATE(874)] = 23433,
  [SMALL_STATE(875)] = 23497,
  [SMALL_STATE(876)] = 23563,
  [SMALL_STATE(877)] = 23621,
  [SMALL_STATE(878)] = 23685,
  [SMALL_STATE(879)] = 23749,
  [SMALL_STATE(880)] = 23807,
  [SMALL_STATE(881)] = 23873,
  [SMALL_STATE(882)] = 23935,
  [SMALL_STATE(883)] = 24005,
  [SMALL_STATE(884)] = 24067,
  [SMALL_STATE(885)] = 24137,
  [SMALL_STATE(886)] = 24195,
  [SMALL_STATE(887)] = 24264,
  [SMALL_STATE(888)] = 24333,
  [SMALL_STATE(889)] = 24394,
  [SMALL_STATE(890)] = 24455,
  [SMALL_STATE(891)] = 24516,
  [SMALL_STATE(892)] = 24585,
  [SMALL_STATE(893)] = 24648,
  [SMALL_STATE(894)] = 24717,
  [SMALL_STATE(895)] = 24821,
  [SMALL_STATE(896)] = 24885,
  [SMALL_STATE(897)] = 24989,
  [SMALL_STATE(898)] = 25093,
  [SMALL_STATE(899)] = 25197,
  [SMALL_STATE(900)] = 25301,
  [SMALL_STATE(901)] = 25405,
  [SMALL_STATE(902)] = 25509,
  [SMALL_STATE(903)] = 25613,
  [SMALL_STATE(904)] = 25687,
  [SMALL_STATE(905)] = 25791,
  [SMALL_STATE(906)] = 25855,
  [SMALL_STATE(907)] = 25956,
  [SMALL_STATE(908)] = 26059,
  [SMALL_STATE(909)] = 26159,
  [SMALL_STATE(910)] = 26259,
  [SMALL_STATE(911)] = 26359,
  [SMALL_STATE(912)] = 26459,
  [SMALL_STATE(913)] = 26559,
  [SMALL_STATE(914)] = 26659,
  [SMALL_STATE(915)] = 26759,
  [SMALL_STATE(916)] = 26859,
  [SMALL_STATE(917)] = 26959,
  [SMALL_STATE(918)] = 27059,
  [SMALL_STATE(919)] = 27159,
  [SMALL_STATE(920)] = 27259,
  [SMALL_STATE(921)] = 27359,
  [SMALL_STATE(922)] = 27459,
  [SMALL_STATE(923)] = 27559,
  [SMALL_STATE(924)] = 27655,
  [SMALL_STATE(925)] = 27751,
  [SMALL_STATE(926)] = 27847,
  [SMALL_STATE(927)] = 27909,
  [SMALL_STATE(928)] = 28005,
  [SMALL_STATE(929)] = 28063,
  [SMALL_STATE(930)] = 28119,
  [SMALL_STATE(931)] = 28185,
  [SMALL_STATE(932)] = 28281,
  [SMALL_STATE(933)] = 28377,
  [SMALL_STATE(934)] = 28439,
  [SMALL_STATE(935)] = 28490,
  [SMALL_STATE(936)] = 28541,
  [SMALL_STATE(937)] = 28592,
  [SMALL_STATE(938)] = 28643,
  [SMALL_STATE(939)] = 28700,
  [SMALL_STATE(940)] = 28757,
  [SMALL_STATE(941)] = 28816,
  [SMALL_STATE(942)] = 28871,
  [SMALL_STATE(943)] = 28922,
  [SMALL_STATE(944)] = 28973,
  [SMALL_STATE(945)] = 29024,
  [SMALL_STATE(946)] = 29075,
  [SMALL_STATE(947)] = 29126,
  [SMALL_STATE(948)] = 29177,
  [SMALL_STATE(949)] = 29269,
  [SMALL_STATE(950)] = 29369,
  [SMALL_STATE(951)] = 29461,
  [SMALL_STATE(952)] = 29553,
  [SMALL_STATE(953)] = 29645,
  [SMALL_STATE(954)] = 29737,
  [SMALL_STATE(955)] = 29809,
  [SMALL_STATE(956)] = 29903,
  [SMALL_STATE(957)] = 29995,
  [SMALL_STATE(958)] = 30073,
  [SMALL_STATE(959)] = 30165,
  [SMALL_STATE(960)] = 30257,
  [SMALL_STATE(961)] = 30349,
  [SMALL_STATE(962)] = 30449,
  [SMALL_STATE(963)] = 30503,
  [SMALL_STATE(964)] = 30557,
  [SMALL_STATE(965)] = 30613,
  [SMALL_STATE(966)] = 30713,
  [SMALL_STATE(967)] = 30805,
  [SMALL_STATE(968)] = 30869,
  [SMALL_STATE(969)] = 30921,
  [SMALL_STATE(970)] = 31013,
  [SMALL_STATE(971)] = 31069,
  [SMALL_STATE(972)] = 31123,
  [SMALL_STATE(973)] = 31213,
  [SMALL_STATE(974)] = 31267,
  [SMALL_STATE(975)] = 31319,
  [SMALL_STATE(976)] = 31411,
  [SMALL_STATE(977)] = 31481,
  [SMALL_STATE(978)] = 31551,
  [SMALL_STATE(979)] = 31619,
  [SMALL_STATE(980)] = 31683,
  [SMALL_STATE(981)] = 31735,
  [SMALL_STATE(982)] = 31811,
  [SMALL_STATE(983)] = 31897,
  [SMALL_STATE(984)] = 31989,
  [SMALL_STATE(985)] = 32043,
  [SMALL_STATE(986)] = 32135,
  [SMALL_STATE(987)] = 32227,
  [SMALL_STATE(988)] = 32319,
  [SMALL_STATE(989)] = 32389,
  [SMALL_STATE(990)] = 32471,
  [SMALL_STATE(991)] = 32520,
  [SMALL_STATE(992)] = 32569,
  [SMALL_STATE(993)] = 32628,
  [SMALL_STATE(994)] = 32677,
  [SMALL_STATE(995)] = 32726,
  [SMALL_STATE(996)] = 32811,
  [SMALL_STATE(997)] = 32860,
  [SMALL_STATE(998)] = 32909,
  [SMALL_STATE(999)] = 32958,
  [SMALL_STATE(1000)] = 33007,
  [SMALL_STATE(1001)] = 33056,
  [SMALL_STATE(1002)] = 33105,
  [SMALL_STATE(1003)] = 33154,
  [SMALL_STATE(1004)] = 33203,
  [SMALL_STATE(1005)] = 33252,
  [SMALL_STATE(1006)] = 33301,
  [SMALL_STATE(1007)] = 33350,
  [SMALL_STATE(1008)] = 33403,
  [SMALL_STATE(1009)] = 33456,
  [SMALL_STATE(1010)] = 33505,
  [SMALL_STATE(1011)] = 33600,
  [SMALL_STATE(1012)] = 33649,
  [SMALL_STATE(1013)] = 33698,
  [SMALL_STATE(1014)] = 33789,
  [SMALL_STATE(1015)] = 33842,
  [SMALL_STATE(1016)] = 33897,
  [SMALL_STATE(1017)] = 33946,
  [SMALL_STATE(1018)] = 33995,
  [SMALL_STATE(1019)] = 34044,
  [SMALL_STATE(1020)] = 34093,
  [SMALL_STATE(1021)] = 34146,
  [SMALL_STATE(1022)] = 34195,
  [SMALL_STATE(1023)] = 34244,
  [SMALL_STATE(1024)] = 34293,
  [SMALL_STATE(1025)] = 34360,
  [SMALL_STATE(1026)] = 34457,
  [SMALL_STATE(1027)] = 34506,
  [SMALL_STATE(1028)] = 34555,
  [SMALL_STATE(1029)] = 34604,
  [SMALL_STATE(1030)] = 34701,
  [SMALL_STATE(1031)] = 34754,
  [SMALL_STATE(1032)] = 34803,
  [SMALL_STATE(1033)] = 34852,
  [SMALL_STATE(1034)] = 34901,
  [SMALL_STATE(1035)] = 34950,
  [SMALL_STATE(1036)] = 35003,
  [SMALL_STATE(1037)] = 35056,
  [SMALL_STATE(1038)] = 35105,
  [SMALL_STATE(1039)] = 35156,
  [SMALL_STATE(1040)] = 35241,
  [SMALL_STATE(1041)] = 35290,
  [SMALL_STATE(1042)] = 35339,
  [SMALL_STATE(1043)] = 35430,
  [SMALL_STATE(1044)] = 35521,
  [SMALL_STATE(1045)] = 35612,
  [SMALL_STATE(1046)] = 35703,
  [SMALL_STATE(1047)] = 35794,
  [SMALL_STATE(1048)] = 35843,
  [SMALL_STATE(1049)] = 35906,
  [SMALL_STATE(1050)] = 35955,
  [SMALL_STATE(1051)] = 36046,
  [SMALL_STATE(1052)] = 36095,
  [SMALL_STATE(1053)] = 36186,
  [SMALL_STATE(1054)] = 36235,
  [SMALL_STATE(1055)] = 36284,
  [SMALL_STATE(1056)] = 36333,
  [SMALL_STATE(1057)] = 36382,
  [SMALL_STATE(1058)] = 36431,
  [SMALL_STATE(1059)] = 36490,
  [SMALL_STATE(1060)] = 36575,
  [SMALL_STATE(1061)] = 36624,
  [SMALL_STATE(1062)] = 36695,
  [SMALL_STATE(1063)] = 36780,
  [SMALL_STATE(1064)] = 36829,
  [SMALL_STATE(1065)] = 36878,
  [SMALL_STATE(1066)] = 36955,
  [SMALL_STATE(1067)] = 37004,
  [SMALL_STATE(1068)] = 37053,
  [SMALL_STATE(1069)] = 37102,
  [SMALL_STATE(1070)] = 37199,
  [SMALL_STATE(1071)] = 37252,
  [SMALL_STATE(1072)] = 37303,
  [SMALL_STATE(1073)] = 37356,
  [SMALL_STATE(1074)] = 37437,
  [SMALL_STATE(1075)] = 37528,
  [SMALL_STATE(1076)] = 37613,
  [SMALL_STATE(1077)] = 37662,
  [SMALL_STATE(1078)] = 37737,
  [SMALL_STATE(1079)] = 37806,
  [SMALL_STATE(1080)] = 37897,
  [SMALL_STATE(1081)] = 37946,
  [SMALL_STATE(1082)] = 37995,
  [SMALL_STATE(1083)] = 38044,
  [SMALL_STATE(1084)] = 38093,
  [SMALL_STATE(1085)] = 38142,
  [SMALL_STATE(1086)] = 38191,
  [SMALL_STATE(1087)] = 38240,
  [SMALL_STATE(1088)] = 38291,
  [SMALL_STATE(1089)] = 38340,
  [SMALL_STATE(1090)] = 38391,
  [SMALL_STATE(1091)] = 38440,
  [SMALL_STATE(1092)] = 38489,
  [SMALL_STATE(1093)] = 38538,
  [SMALL_STATE(1094)] = 38587,
  [SMALL_STATE(1095)] = 38636,
  [SMALL_STATE(1096)] = 38685,
  [SMALL_STATE(1097)] = 38734,
  [SMALL_STATE(1098)] = 38783,
  [SMALL_STATE(1099)] = 38832,
  [SMALL_STATE(1100)] = 38921,
  [SMALL_STATE(1101)] = 38970,
  [SMALL_STATE(1102)] = 39021,
  [SMALL_STATE(1103)] = 39070,
  [SMALL_STATE(1104)] = 39119,
  [SMALL_STATE(1105)] = 39210,
  [SMALL_STATE(1106)] = 39259,
  [SMALL_STATE(1107)] = 39308,
  [SMALL_STATE(1108)] = 39357,
  [SMALL_STATE(1109)] = 39406,
  [SMALL_STATE(1110)] = 39497,
  [SMALL_STATE(1111)] = 39546,
  [SMALL_STATE(1112)] = 39595,
  [SMALL_STATE(1113)] = 39644,
  [SMALL_STATE(1114)] = 39693,
  [SMALL_STATE(1115)] = 39790,
  [SMALL_STATE(1116)] = 39887,
  [SMALL_STATE(1117)] = 39936,
  [SMALL_STATE(1118)] = 40021,
  [SMALL_STATE(1119)] = 40116,
  [SMALL_STATE(1120)] = 40207,
  [SMALL_STATE(1121)] = 40298,
  [SMALL_STATE(1122)] = 40347,
  [SMALL_STATE(1123)] = 40438,
  [SMALL_STATE(1124)] = 40487,
  [SMALL_STATE(1125)] = 40578,
  [SMALL_STATE(1126)] = 40669,
  [SMALL_STATE(1127)] = 40738,
  [SMALL_STATE(1128)] = 40833,
  [SMALL_STATE(1129)] = 40882,
  [SMALL_STATE(1130)] = 40977,
  [SMALL_STATE(1131)] = 41026,
  [SMALL_STATE(1132)] = 41075,
  [SMALL_STATE(1133)] = 41124,
  [SMALL_STATE(1134)] = 41173,
  [SMALL_STATE(1135)] = 41258,
  [SMALL_STATE(1136)] = 41355,
  [SMALL_STATE(1137)] = 41404,
  [SMALL_STATE(1138)] = 41453,
  [SMALL_STATE(1139)] = 41522,
  [SMALL_STATE(1140)] = 41617,
  [SMALL_STATE(1141)] = 41703,
  [SMALL_STATE(1142)] = 41751,
  [SMALL_STATE(1143)] = 41837,
  [SMALL_STATE(1144)] = 41887,
  [SMALL_STATE(1145)] = 41977,
  [SMALL_STATE(1146)] = 42057,
  [SMALL_STATE(1147)] = 42141,
  [SMALL_STATE(1148)] = 42209,
  [SMALL_STATE(1149)] = 42283,
  [SMALL_STATE(1150)] = 42377,
  [SMALL_STATE(1151)] = 42445,
  [SMALL_STATE(1152)] = 42533,
  [SMALL_STATE(1153)] = 42625,
  [SMALL_STATE(1154)] = 42717,
  [SMALL_STATE(1155)] = 42793,
  [SMALL_STATE(1156)] = 42885,
  [SMALL_STATE(1157)] = 42975,
  [SMALL_STATE(1158)] = 43065,
  [SMALL_STATE(1159)] = 43155,
  [SMALL_STATE(1160)] = 43225,
  [SMALL_STATE(1161)] = 43317,
  [SMALL_STATE(1162)] = 43405,
  [SMALL_STATE(1163)] = 43473,
  [SMALL_STATE(1164)] = 43565,
  [SMALL_STATE(1165)] = 43659,
  [SMALL_STATE(1166)] = 43751,
  [SMALL_STATE(1167)] = 43843,
  [SMALL_STATE(1168)] = 43893,
  [SMALL_STATE(1169)] = 43979,
  [SMALL_STATE(1170)] = 44071,
  [SMALL_STATE(1171)] = 44145,
  [SMALL_STATE(1172)] = 44239,
  [SMALL_STATE(1173)] = 44331,
  [SMALL_STATE(1174)] = 44415,
  [SMALL_STATE(1175)] = 44471,
  [SMALL_STATE(1176)] = 44563,
  [SMALL_STATE(1177)] = 44649,
  [SMALL_STATE(1178)] = 44699,
  [SMALL_STATE(1179)] = 44793,
  [SMALL_STATE(1180)] = 44845,
  [SMALL_STATE(1181)] = 44895,
  [SMALL_STATE(1182)] = 44985,
  [SMALL_STATE(1183)] = 45061,
  [SMALL_STATE(1184)] = 45131,
  [SMALL_STATE(1185)] = 45221,
  [SMALL_STATE(1186)] = 45313,
  [SMALL_STATE(1187)] = 45361,
  [SMALL_STATE(1188)] = 45409,
  [SMALL_STATE(1189)] = 45499,
  [SMALL_STATE(1190)] = 45591,
  [SMALL_STATE(1191)] = 45683,
  [SMALL_STATE(1192)] = 45773,
  [SMALL_STATE(1193)] = 45865,
  [SMALL_STATE(1194)] = 45955,
  [SMALL_STATE(1195)] = 46007,
  [SMALL_STATE(1196)] = 46097,
  [SMALL_STATE(1197)] = 46187,
  [SMALL_STATE(1198)] = 46277,
  [SMALL_STATE(1199)] = 46367,
  [SMALL_STATE(1200)] = 46433,
  [SMALL_STATE(1201)] = 46527,
  [SMALL_STATE(1202)] = 46617,
  [SMALL_STATE(1203)] = 46707,
  [SMALL_STATE(1204)] = 46775,
  [SMALL_STATE(1205)] = 46869,
  [SMALL_STATE(1206)] = 46961,
  [SMALL_STATE(1207)] = 47055,
  [SMALL_STATE(1208)] = 47145,
  [SMALL_STATE(1209)] = 47239,
  [SMALL_STATE(1210)] = 47333,
  [SMALL_STATE(1211)] = 47391,
  [SMALL_STATE(1212)] = 47485,
  [SMALL_STATE(1213)] = 47553,
  [SMALL_STATE(1214)] = 47601,
  [SMALL_STATE(1215)] = 47691,
  [SMALL_STATE(1216)] = 47757,
  [SMALL_STATE(1217)] = 47811,
  [SMALL_STATE(1218)] = 47905,
  [SMALL_STATE(1219)] = 47997,
  [SMALL_STATE(1220)] = 48091,
  [SMALL_STATE(1221)] = 48183,
  [SMALL_STATE(1222)] = 48251,
  [SMALL_STATE(1223)] = 48343,
  [SMALL_STATE(1224)] = 48391,
  [SMALL_STATE(1225)] = 48483,
  [SMALL_STATE(1226)] = 48541,
  [SMALL_STATE(1227)] = 48603,
  [SMALL_STATE(1228)] = 48693,
  [SMALL_STATE(1229)] = 48743,
  [SMALL_STATE(1230)] = 48793,
  [SMALL_STATE(1231)] = 48885,
  [SMALL_STATE(1232)] = 48975,
  [SMALL_STATE(1233)] = 49065,
  [SMALL_STATE(1234)] = 49119,
  [SMALL_STATE(1235)] = 49173,
  [SMALL_STATE(1236)] = 49259,
  [SMALL_STATE(1237)] = 49339,
  [SMALL_STATE(1238)] = 49429,
  [SMALL_STATE(1239)] = 49519,
  [SMALL_STATE(1240)] = 49611,
  [SMALL_STATE(1241)] = 49659,
  [SMALL_STATE(1242)] = 49711,
  [SMALL_STATE(1243)] = 49801,
  [SMALL_STATE(1244)] = 49852,
  [SMALL_STATE(1245)] = 49919,
  [SMALL_STATE(1246)] = 50008,
  [SMALL_STATE(1247)] = 50097,
  [SMALL_STATE(1248)] = 50186,
  [SMALL_STATE(1249)] = 50275,
  [SMALL_STATE(1250)] = 50364,
  [SMALL_STATE(1251)] = 50453,
  [SMALL_STATE(1252)] = 50542,
  [SMALL_STATE(1253)] = 50631,
  [SMALL_STATE(1254)] = 50720,
  [SMALL_STATE(1255)] = 50787,
  [SMALL_STATE(1256)] = 50838,
  [SMALL_STATE(1257)] = 50905,
  [SMALL_STATE(1258)] = 50994,
  [SMALL_STATE(1259)] = 51083,
  [SMALL_STATE(1260)] = 51174,
  [SMALL_STATE(1261)] = 51265,
  [SMALL_STATE(1262)] = 51354,
  [SMALL_STATE(1263)] = 51445,
  [SMALL_STATE(1264)] = 51536,
  [SMALL_STATE(1265)] = 51625,
  [SMALL_STATE(1266)] = 51716,
  [SMALL_STATE(1267)] = 51785,
  [SMALL_STATE(1268)] = 51850,
  [SMALL_STATE(1269)] = 51925,
  [SMALL_STATE(1270)] = 52016,
  [SMALL_STATE(1271)] = 52083,
  [SMALL_STATE(1272)] = 52136,
  [SMALL_STATE(1273)] = 52189,
  [SMALL_STATE(1274)] = 52270,
  [SMALL_STATE(1275)] = 52349,
  [SMALL_STATE(1276)] = 52438,
  [SMALL_STATE(1277)] = 52521,
  [SMALL_STATE(1278)] = 52610,
  [SMALL_STATE(1279)] = 52699,
  [SMALL_STATE(1280)] = 52772,
  [SMALL_STATE(1281)] = 52823,
  [SMALL_STATE(1282)] = 52914,
  [SMALL_STATE(1283)] = 52981,
  [SMALL_STATE(1284)] = 53070,
  [SMALL_STATE(1285)] = 53157,
  [SMALL_STATE(1286)] = 53206,
  [SMALL_STATE(1287)] = 53295,
  [SMALL_STATE(1288)] = 53384,
  [SMALL_STATE(1289)] = 53435,
  [SMALL_STATE(1290)] = 53516,
  [SMALL_STATE(1291)] = 53583,
  [SMALL_STATE(1292)] = 53672,
  [SMALL_STATE(1293)] = 53761,
  [SMALL_STATE(1294)] = 53812,
  [SMALL_STATE(1295)] = 53863,
  [SMALL_STATE(1296)] = 53918,
  [SMALL_STATE(1297)] = 53999,
  [SMALL_STATE(1298)] = 54068,
  [SMALL_STATE(1299)] = 54119,
  [SMALL_STATE(1300)] = 54170,
  [SMALL_STATE(1301)] = 54223,
  [SMALL_STATE(1302)] = 54274,
  [SMALL_STATE(1303)] = 54339,
  [SMALL_STATE(1304)] = 54390,
  [SMALL_STATE(1305)] = 54441,
  [SMALL_STATE(1306)] = 54492,
  [SMALL_STATE(1307)] = 54543,
  [SMALL_STATE(1308)] = 54610,
  [SMALL_STATE(1309)] = 54699,
  [SMALL_STATE(1310)] = 54768,
  [SMALL_STATE(1311)] = 54833,
  [SMALL_STATE(1312)] = 54924,
  [SMALL_STATE(1313)] = 55005,
  [SMALL_STATE(1314)] = 55058,
  [SMALL_STATE(1315)] = 55109,
  [SMALL_STATE(1316)] = 55198,
  [SMALL_STATE(1317)] = 55249,
  [SMALL_STATE(1318)] = 55302,
  [SMALL_STATE(1319)] = 55383,
  [SMALL_STATE(1320)] = 55464,
  [SMALL_STATE(1321)] = 55515,
  [SMALL_STATE(1322)] = 55596,
  [SMALL_STATE(1323)] = 55661,
  [SMALL_STATE(1324)] = 55730,
  [SMALL_STATE(1325)] = 55797,
  [SMALL_STATE(1326)] = 55848,
  [SMALL_STATE(1327)] = 55929,
  [SMALL_STATE(1328)] = 55996,
  [SMALL_STATE(1329)] = 56049,
  [SMALL_STATE(1330)] = 56102,
  [SMALL_STATE(1331)] = 56183,
  [SMALL_STATE(1332)] = 56272,
  [SMALL_STATE(1333)] = 56361,
  [SMALL_STATE(1334)] = 56450,
  [SMALL_STATE(1335)] = 56539,
  [SMALL_STATE(1336)] = 56628,
  [SMALL_STATE(1337)] = 56709,
  [SMALL_STATE(1338)] = 56774,
  [SMALL_STATE(1339)] = 56863,
  [SMALL_STATE(1340)] = 56952,
  [SMALL_STATE(1341)] = 57041,
  [SMALL_STATE(1342)] = 57130,
  [SMALL_STATE(1343)] = 57219,
  [SMALL_STATE(1344)] = 57306,
  [SMALL_STATE(1345)] = 57373,
  [SMALL_STATE(1346)] = 57446,
  [SMALL_STATE(1347)] = 57527,
  [SMALL_STATE(1348)] = 57618,
  [SMALL_STATE(1349)] = 57701,
  [SMALL_STATE(1350)] = 57780,
  [SMALL_STATE(1351)] = 57871,
  [SMALL_STATE(1352)] = 57960,
  [SMALL_STATE(1353)] = 58051,
  [SMALL_STATE(1354)] = 58142,
  [SMALL_STATE(1355)] = 58217,
  [SMALL_STATE(1356)] = 58306,
  [SMALL_STATE(1357)] = 58375,
  [SMALL_STATE(1358)] = 58464,
  [SMALL_STATE(1359)] = 58553,
  [SMALL_STATE(1360)] = 58644,
  [SMALL_STATE(1361)] = 58735,
  [SMALL_STATE(1362)] = 58824,
  [SMALL_STATE(1363)] = 58873,
  [SMALL_STATE(1364)] = 58954,
  [SMALL_STATE(1365)] = 59003,
  [SMALL_STATE(1366)] = 59054,
  [SMALL_STATE(1367)] = 59103,
  [SMALL_STATE(1368)] = 59168,
  [SMALL_STATE(1369)] = 59257,
  [SMALL_STATE(1370)] = 59306,
  [SMALL_STATE(1371)] = 59395,
  [SMALL_STATE(1372)] = 59464,
  [SMALL_STATE(1373)] = 59553,
  [SMALL_STATE(1374)] = 59644,
  [SMALL_STATE(1375)] = 59725,
  [SMALL_STATE(1376)] = 59806,
  [SMALL_STATE(1377)] = 59854,
  [SMALL_STATE(1378)] = 59904,
  [SMALL_STATE(1379)] = 59950,
  [SMALL_STATE(1380)] = 59998,
  [SMALL_STATE(1381)] = 60044,
  [SMALL_STATE(1382)] = 60090,
  [SMALL_STATE(1383)] = 60136,
  [SMALL_STATE(1384)] = 60184,
  [SMALL_STATE(1385)] = 60230,
  [SMALL_STATE(1386)] = 60276,
  [SMALL_STATE(1387)] = 60322,
  [SMALL_STATE(1388)] = 60370,
  [SMALL_STATE(1389)] = 60416,
  [SMALL_STATE(1390)] = 60462,
  [SMALL_STATE(1391)] = 60508,
  [SMALL_STATE(1392)] = 60554,
  [SMALL_STATE(1393)] = 60600,
  [SMALL_STATE(1394)] = 60648,
  [SMALL_STATE(1395)] = 60694,
  [SMALL_STATE(1396)] = 60740,
  [SMALL_STATE(1397)] = 60786,
  [SMALL_STATE(1398)] = 60832,
  [SMALL_STATE(1399)] = 60892,
  [SMALL_STATE(1400)] = 60938,
  [SMALL_STATE(1401)] = 60984,
  [SMALL_STATE(1402)] = 61030,
  [SMALL_STATE(1403)] = 61076,
  [SMALL_STATE(1404)] = 61122,
  [SMALL_STATE(1405)] = 61168,
  [SMALL_STATE(1406)] = 61214,
  [SMALL_STATE(1407)] = 61260,
  [SMALL_STATE(1408)] = 61306,
  [SMALL_STATE(1409)] = 61352,
  [SMALL_STATE(1410)] = 61400,
  [SMALL_STATE(1411)] = 61448,
  [SMALL_STATE(1412)] = 61494,
  [SMALL_STATE(1413)] = 61540,
  [SMALL_STATE(1414)] = 61628,
  [SMALL_STATE(1415)] = 61674,
  [SMALL_STATE(1416)] = 61724,
  [SMALL_STATE(1417)] = 61770,
  [SMALL_STATE(1418)] = 61820,
  [SMALL_STATE(1419)] = 61866,
  [SMALL_STATE(1420)] = 61920,
  [SMALL_STATE(1421)] = 61966,
  [SMALL_STATE(1422)] = 62054,
  [SMALL_STATE(1423)] = 62108,
  [SMALL_STATE(1424)] = 62162,
  [SMALL_STATE(1425)] = 62226,
  [SMALL_STATE(1426)] = 62294,
  [SMALL_STATE(1427)] = 62342,
  [SMALL_STATE(1428)] = 62388,
  [SMALL_STATE(1429)] = 62436,
  [SMALL_STATE(1430)] = 62502,
  [SMALL_STATE(1431)] = 62548,
  [SMALL_STATE(1432)] = 62594,
  [SMALL_STATE(1433)] = 62640,
  [SMALL_STATE(1434)] = 62728,
  [SMALL_STATE(1435)] = 62780,
  [SMALL_STATE(1436)] = 62832,
  [SMALL_STATE(1437)] = 62880,
  [SMALL_STATE(1438)] = 62928,
  [SMALL_STATE(1439)] = 62974,
  [SMALL_STATE(1440)] = 63020,
  [SMALL_STATE(1441)] = 63066,
  [SMALL_STATE(1442)] = 63112,
  [SMALL_STATE(1443)] = 63158,
  [SMALL_STATE(1444)] = 63204,
  [SMALL_STATE(1445)] = 63250,
  [SMALL_STATE(1446)] = 63296,
  [SMALL_STATE(1447)] = 63342,
  [SMALL_STATE(1448)] = 63392,
  [SMALL_STATE(1449)] = 63440,
  [SMALL_STATE(1450)] = 63490,
  [SMALL_STATE(1451)] = 63536,
  [SMALL_STATE(1452)] = 63586,
  [SMALL_STATE(1453)] = 63632,
  [SMALL_STATE(1454)] = 63692,
  [SMALL_STATE(1455)] = 63742,
  [SMALL_STATE(1456)] = 63830,
  [SMALL_STATE(1457)] = 63876,
  [SMALL_STATE(1458)] = 63922,
  [SMALL_STATE(1459)] = 63968,
  [SMALL_STATE(1460)] = 64016,
  [SMALL_STATE(1461)] = 64062,
  [SMALL_STATE(1462)] = 64108,
  [SMALL_STATE(1463)] = 64172,
  [SMALL_STATE(1464)] = 64218,
  [SMALL_STATE(1465)] = 64306,
  [SMALL_STATE(1466)] = 64356,
  [SMALL_STATE(1467)] = 64406,
  [SMALL_STATE(1468)] = 64458,
  [SMALL_STATE(1469)] = 64508,
  [SMALL_STATE(1470)] = 64596,
  [SMALL_STATE(1471)] = 64642,
  [SMALL_STATE(1472)] = 64706,
  [SMALL_STATE(1473)] = 64752,
  [SMALL_STATE(1474)] = 64798,
  [SMALL_STATE(1475)] = 64844,
  [SMALL_STATE(1476)] = 64890,
  [SMALL_STATE(1477)] = 64936,
  [SMALL_STATE(1478)] = 64982,
  [SMALL_STATE(1479)] = 65028,
  [SMALL_STATE(1480)] = 65074,
  [SMALL_STATE(1481)] = 65122,
  [SMALL_STATE(1482)] = 65172,
  [SMALL_STATE(1483)] = 65222,
  [SMALL_STATE(1484)] = 65268,
  [SMALL_STATE(1485)] = 65314,
  [SMALL_STATE(1486)] = 65360,
  [SMALL_STATE(1487)] = 65406,
  [SMALL_STATE(1488)] = 65494,
  [SMALL_STATE(1489)] = 65554,
  [SMALL_STATE(1490)] = 65600,
  [SMALL_STATE(1491)] = 65646,
  [SMALL_STATE(1492)] = 65692,
  [SMALL_STATE(1493)] = 65744,
  [SMALL_STATE(1494)] = 65790,
  [SMALL_STATE(1495)] = 65850,
  [SMALL_STATE(1496)] = 65900,
  [SMALL_STATE(1497)] = 65946,
  [SMALL_STATE(1498)] = 65992,
  [SMALL_STATE(1499)] = 66038,
  [SMALL_STATE(1500)] = 66084,
  [SMALL_STATE(1501)] = 66130,
  [SMALL_STATE(1502)] = 66182,
  [SMALL_STATE(1503)] = 66270,
  [SMALL_STATE(1504)] = 66316,
  [SMALL_STATE(1505)] = 66374,
  [SMALL_STATE(1506)] = 66422,
  [SMALL_STATE(1507)] = 66468,
  [SMALL_STATE(1508)] = 66516,
  [SMALL_STATE(1509)] = 66562,
  [SMALL_STATE(1510)] = 66611,
  [SMALL_STATE(1511)] = 66674,
  [SMALL_STATE(1512)] = 66719,
  [SMALL_STATE(1513)] = 66764,
  [SMALL_STATE(1514)] = 66809,
  [SMALL_STATE(1515)] = 66854,
  [SMALL_STATE(1516)] = 66899,
  [SMALL_STATE(1517)] = 66944,
  [SMALL_STATE(1518)] = 67029,
  [SMALL_STATE(1519)] = 67074,
  [SMALL_STATE(1520)] = 67133,
  [SMALL_STATE(1521)] = 67194,
  [SMALL_STATE(1522)] = 67239,
  [SMALL_STATE(1523)] = 67288,
  [SMALL_STATE(1524)] = 67333,
  [SMALL_STATE(1525)] = 67378,
  [SMALL_STATE(1526)] = 67427,
  [SMALL_STATE(1527)] = 67472,
  [SMALL_STATE(1528)] = 67557,
  [SMALL_STATE(1529)] = 67602,
  [SMALL_STATE(1530)] = 67647,
  [SMALL_STATE(1531)] = 67696,
  [SMALL_STATE(1532)] = 67745,
  [SMALL_STATE(1533)] = 67790,
  [SMALL_STATE(1534)] = 67849,
  [SMALL_STATE(1535)] = 67898,
  [SMALL_STATE(1536)] = 67947,
  [SMALL_STATE(1537)] = 68006,
  [SMALL_STATE(1538)] = 68051,
  [SMALL_STATE(1539)] = 68096,
  [SMALL_STATE(1540)] = 68157,
  [SMALL_STATE(1541)] = 68204,
  [SMALL_STATE(1542)] = 68249,
  [SMALL_STATE(1543)] = 68294,
  [SMALL_STATE(1544)] = 68339,
  [SMALL_STATE(1545)] = 68384,
  [SMALL_STATE(1546)] = 68429,
  [SMALL_STATE(1547)] = 68476,
  [SMALL_STATE(1548)] = 68521,
  [SMALL_STATE(1549)] = 68566,
  [SMALL_STATE(1550)] = 68615,
  [SMALL_STATE(1551)] = 68674,
  [SMALL_STATE(1552)] = 68721,
  [SMALL_STATE(1553)] = 68766,
  [SMALL_STATE(1554)] = 68811,
  [SMALL_STATE(1555)] = 68858,
  [SMALL_STATE(1556)] = 68903,
  [SMALL_STATE(1557)] = 68950,
  [SMALL_STATE(1558)] = 69011,
  [SMALL_STATE(1559)] = 69056,
  [SMALL_STATE(1560)] = 69101,
  [SMALL_STATE(1561)] = 69150,
  [SMALL_STATE(1562)] = 69201,
  [SMALL_STATE(1563)] = 69246,
  [SMALL_STATE(1564)] = 69297,
  [SMALL_STATE(1565)] = 69356,
  [SMALL_STATE(1566)] = 69405,
  [SMALL_STATE(1567)] = 69464,
  [SMALL_STATE(1568)] = 69509,
  [SMALL_STATE(1569)] = 69554,
  [SMALL_STATE(1570)] = 69599,
  [SMALL_STATE(1571)] = 69658,
  [SMALL_STATE(1572)] = 69703,
  [SMALL_STATE(1573)] = 69748,
  [SMALL_STATE(1574)] = 69793,
  [SMALL_STATE(1575)] = 69838,
  [SMALL_STATE(1576)] = 69883,
  [SMALL_STATE(1577)] = 69928,
  [SMALL_STATE(1578)] = 69973,
  [SMALL_STATE(1579)] = 70034,
  [SMALL_STATE(1580)] = 70093,
  [SMALL_STATE(1581)] = 70138,
  [SMALL_STATE(1582)] = 70185,
  [SMALL_STATE(1583)] = 70230,
  [SMALL_STATE(1584)] = 70315,
  [SMALL_STATE(1585)] = 70374,
  [SMALL_STATE(1586)] = 70419,
  [SMALL_STATE(1587)] = 70466,
  [SMALL_STATE(1588)] = 70511,
  [SMALL_STATE(1589)] = 70556,
  [SMALL_STATE(1590)] = 70601,
  [SMALL_STATE(1591)] = 70646,
  [SMALL_STATE(1592)] = 70697,
  [SMALL_STATE(1593)] = 70742,
  [SMALL_STATE(1594)] = 70787,
  [SMALL_STATE(1595)] = 70850,
  [SMALL_STATE(1596)] = 70895,
  [SMALL_STATE(1597)] = 70940,
  [SMALL_STATE(1598)] = 70985,
  [SMALL_STATE(1599)] = 71032,
  [SMALL_STATE(1600)] = 71077,
  [SMALL_STATE(1601)] = 71122,
  [SMALL_STATE(1602)] = 71169,
  [SMALL_STATE(1603)] = 71214,
  [SMALL_STATE(1604)] = 71273,
  [SMALL_STATE(1605)] = 71318,
  [SMALL_STATE(1606)] = 71363,
  [SMALL_STATE(1607)] = 71426,
  [SMALL_STATE(1608)] = 71471,
  [SMALL_STATE(1609)] = 71534,
  [SMALL_STATE(1610)] = 71579,
  [SMALL_STATE(1611)] = 71628,
  [SMALL_STATE(1612)] = 71689,
  [SMALL_STATE(1613)] = 71750,
  [SMALL_STATE(1614)] = 71809,
  [SMALL_STATE(1615)] = 71854,
  [SMALL_STATE(1616)] = 71901,
  [SMALL_STATE(1617)] = 71946,
  [SMALL_STATE(1618)] = 71991,
  [SMALL_STATE(1619)] = 72052,
  [SMALL_STATE(1620)] = 72103,
  [SMALL_STATE(1621)] = 72148,
  [SMALL_STATE(1622)] = 72193,
  [SMALL_STATE(1623)] = 72238,
  [SMALL_STATE(1624)] = 72283,
  [SMALL_STATE(1625)] = 72328,
  [SMALL_STATE(1626)] = 72373,
  [SMALL_STATE(1627)] = 72432,
  [SMALL_STATE(1628)] = 72477,
  [SMALL_STATE(1629)] = 72522,
  [SMALL_STATE(1630)] = 72567,
  [SMALL_STATE(1631)] = 72612,
  [SMALL_STATE(1632)] = 72657,
  [SMALL_STATE(1633)] = 72702,
  [SMALL_STATE(1634)] = 72747,
  [SMALL_STATE(1635)] = 72792,
  [SMALL_STATE(1636)] = 72851,
  [SMALL_STATE(1637)] = 72896,
  [SMALL_STATE(1638)] = 72941,
  [SMALL_STATE(1639)] = 72986,
  [SMALL_STATE(1640)] = 73031,
  [SMALL_STATE(1641)] = 73090,
  [SMALL_STATE(1642)] = 73153,
  [SMALL_STATE(1643)] = 73207,
  [SMALL_STATE(1644)] = 73255,
  [SMALL_STATE(1645)] = 73309,
  [SMALL_STATE(1646)] = 73357,
  [SMALL_STATE(1647)] = 73411,
  [SMALL_STATE(1648)] = 73477,
  [SMALL_STATE(1649)] = 73525,
  [SMALL_STATE(1650)] = 73595,
  [SMALL_STATE(1651)] = 73649,
  [SMALL_STATE(1652)] = 73703,
  [SMALL_STATE(1653)] = 73753,
  [SMALL_STATE(1654)] = 73821,
  [SMALL_STATE(1655)] = 73875,
  [SMALL_STATE(1656)] = 73943,
  [SMALL_STATE(1657)] = 73993,
  [SMALL_STATE(1658)] = 74043,
  [SMALL_STATE(1659)] = 74097,
  [SMALL_STATE(1660)] = 74151,
  [SMALL_STATE(1661)] = 74201,
  [SMALL_STATE(1662)] = 74267,
  [SMALL_STATE(1663)] = 74317,
  [SMALL_STATE(1664)] = 74387,
  [SMALL_STATE(1665)] = 74453,
  [SMALL_STATE(1666)] = 74523,
  [SMALL_STATE(1667)] = 74589,
  [SMALL_STATE(1668)] = 74643,
  [SMALL_STATE(1669)] = 74693,
  [SMALL_STATE(1670)] = 74761,
  [SMALL_STATE(1671)] = 74815,
  [SMALL_STATE(1672)] = 74883,
  [SMALL_STATE(1673)] = 74953,
  [SMALL_STATE(1674)] = 75007,
  [SMALL_STATE(1675)] = 75077,
  [SMALL_STATE(1676)] = 75143,
  [SMALL_STATE(1677)] = 75193,
  [SMALL_STATE(1678)] = 75243,
  [SMALL_STATE(1679)] = 75311,
  [SMALL_STATE(1680)] = 75365,
  [SMALL_STATE(1681)] = 75419,
  [SMALL_STATE(1682)] = 75473,
  [SMALL_STATE(1683)] = 75527,
  [SMALL_STATE(1684)] = 75588,
  [SMALL_STATE(1685)] = 75659,
  [SMALL_STATE(1686)] = 75720,
  [SMALL_STATE(1687)] = 75769,
  [SMALL_STATE(1688)] = 75840,
  [SMALL_STATE(1689)] = 75903,
  [SMALL_STATE(1690)] = 75964,
  [SMALL_STATE(1691)] = 76025,
  [SMALL_STATE(1692)] = 76086,
  [SMALL_STATE(1693)] = 76147,
  [SMALL_STATE(1694)] = 76218,
  [SMALL_STATE(1695)] = 76267,
  [SMALL_STATE(1696)] = 76338,
  [SMALL_STATE(1697)] = 76409,
  [SMALL_STATE(1698)] = 76458,
  [SMALL_STATE(1699)] = 76523,
  [SMALL_STATE(1700)] = 76594,
  [SMALL_STATE(1701)] = 76665,
  [SMALL_STATE(1702)] = 76736,
  [SMALL_STATE(1703)] = 76807,
  [SMALL_STATE(1704)] = 76875,
  [SMALL_STATE(1705)] = 76931,
  [SMALL_STATE(1706)] = 76973,
  [SMALL_STATE(1707)] = 77041,
  [SMALL_STATE(1708)] = 77083,
  [SMALL_STATE(1709)] = 77151,
  [SMALL_STATE(1710)] = 77219,
  [SMALL_STATE(1711)] = 77270,
  [SMALL_STATE(1712)] = 77345,
  [SMALL_STATE(1713)] = 77420,
  [SMALL_STATE(1714)] = 77495,
  [SMALL_STATE(1715)] = 77570,
  [SMALL_STATE(1716)] = 77621,
  [SMALL_STATE(1717)] = 77672,
  [SMALL_STATE(1718)] = 77747,
  [SMALL_STATE(1719)] = 77798,
  [SMALL_STATE(1720)] = 77873,
  [SMALL_STATE(1721)] = 77924,
  [SMALL_STATE(1722)] = 77964,
  [SMALL_STATE(1723)] = 78010,
  [SMALL_STATE(1724)] = 78050,
  [SMALL_STATE(1725)] = 78090,
  [SMALL_STATE(1726)] = 78130,
  [SMALL_STATE(1727)] = 78170,
  [SMALL_STATE(1728)] = 78210,
  [SMALL_STATE(1729)] = 78263,
  [SMALL_STATE(1730)] = 78316,
  [SMALL_STATE(1731)] = 78369,
  [SMALL_STATE(1732)] = 78424,
  [SMALL_STATE(1733)] = 78481,
  [SMALL_STATE(1734)] = 78536,
  [SMALL_STATE(1735)] = 78587,
  [SMALL_STATE(1736)] = 78635,
  [SMALL_STATE(1737)] = 78673,
  [SMALL_STATE(1738)] = 78721,
  [SMALL_STATE(1739)] = 78769,
  [SMALL_STATE(1740)] = 78817,
  [SMALL_STATE(1741)] = 78857,
  [SMALL_STATE(1742)] = 78905,
  [SMALL_STATE(1743)] = 78953,
  [SMALL_STATE(1744)] = 78991,
  [SMALL_STATE(1745)] = 79039,
  [SMALL_STATE(1746)] = 79087,
  [SMALL_STATE(1747)] = 79127,
  [SMALL_STATE(1748)] = 79175,
  [SMALL_STATE(1749)] = 79223,
  [SMALL_STATE(1750)] = 79271,
  [SMALL_STATE(1751)] = 79319,
  [SMALL_STATE(1752)] = 79367,
  [SMALL_STATE(1753)] = 79415,
  [SMALL_STATE(1754)] = 79453,
  [SMALL_STATE(1755)] = 79491,
  [SMALL_STATE(1756)] = 79529,
  [SMALL_STATE(1757)] = 79577,
  [SMALL_STATE(1758)] = 79615,
  [SMALL_STATE(1759)] = 79653,
  [SMALL_STATE(1760)] = 79701,
  [SMALL_STATE(1761)] = 79739,
  [SMALL_STATE(1762)] = 79777,
  [SMALL_STATE(1763)] = 79815,
  [SMALL_STATE(1764)] = 79853,
  [SMALL_STATE(1765)] = 79893,
  [SMALL_STATE(1766)] = 79931,
  [SMALL_STATE(1767)] = 79969,
  [SMALL_STATE(1768)] = 80017,
  [SMALL_STATE(1769)] = 80065,
  [SMALL_STATE(1770)] = 80103,
  [SMALL_STATE(1771)] = 80152,
  [SMALL_STATE(1772)] = 80201,
  [SMALL_STATE(1773)] = 80250,
  [SMALL_STATE(1774)] = 80299,
  [SMALL_STATE(1775)] = 80348,
  [SMALL_STATE(1776)] = 80397,
  [SMALL_STATE(1777)] = 80454,
  [SMALL_STATE(1778)] = 80492,
  [SMALL_STATE(1779)] = 80534,
  [SMALL_STATE(1780)] = 80584,
  [SMALL_STATE(1781)] = 80630,
  [SMALL_STATE(1782)] = 80680,
  [SMALL_STATE(1783)] = 80716,
  [SMALL_STATE(1784)] = 80770,
  [SMALL_STATE(1785)] = 80824,
  [SMALL_STATE(1786)] = 80878,
  [SMALL_STATE(1787)] = 80921,
  [SMALL_STATE(1788)] = 80964,
  [SMALL_STATE(1789)] = 81007,
  [SMALL_STATE(1790)] = 81050,
  [SMALL_STATE(1791)] = 81093,
  [SMALL_STATE(1792)] = 81136,
  [SMALL_STATE(1793)] = 81179,
  [SMALL_STATE(1794)] = 81222,
  [SMALL_STATE(1795)] = 81265,
  [SMALL_STATE(1796)] = 81308,
  [SMALL_STATE(1797)] = 81351,
  [SMALL_STATE(1798)] = 81394,
  [SMALL_STATE(1799)] = 81437,
  [SMALL_STATE(1800)] = 81480,
  [SMALL_STATE(1801)] = 81523,
  [SMALL_STATE(1802)] = 81566,
  [SMALL_STATE(1803)] = 81609,
  [SMALL_STATE(1804)] = 81652,
  [SMALL_STATE(1805)] = 81695,
  [SMALL_STATE(1806)] = 81738,
  [SMALL_STATE(1807)] = 81781,
  [SMALL_STATE(1808)] = 81824,
  [SMALL_STATE(1809)] = 81867,
  [SMALL_STATE(1810)] = 81910,
  [SMALL_STATE(1811)] = 81944,
  [SMALL_STATE(1812)] = 81987,
  [SMALL_STATE(1813)] = 82021,
  [SMALL_STATE(1814)] = 82053,
  [SMALL_STATE(1815)] = 82076,
  [SMALL_STATE(1816)] = 82099,
  [SMALL_STATE(1817)] = 82125,
  [SMALL_STATE(1818)] = 82167,
  [SMALL_STATE(1819)] = 82209,
  [SMALL_STATE(1820)] = 82251,
  [SMALL_STATE(1821)] = 82293,
  [SMALL_STATE(1822)] = 82323,
  [SMALL_STATE(1823)] = 82365,
  [SMALL_STATE(1824)] = 82403,
  [SMALL_STATE(1825)] = 82445,
  [SMALL_STATE(1826)] = 82480,
  [SMALL_STATE(1827)] = 82515,
  [SMALL_STATE(1828)] = 82550,
  [SMALL_STATE(1829)] = 82585,
  [SMALL_STATE(1830)] = 82620,
  [SMALL_STATE(1831)] = 82655,
  [SMALL_STATE(1832)] = 82690,
  [SMALL_STATE(1833)] = 82725,
  [SMALL_STATE(1834)] = 82749,
  [SMALL_STATE(1835)] = 82781,
  [SMALL_STATE(1836)] = 82805,
  [SMALL_STATE(1837)] = 82841,
  [SMALL_STATE(1838)] = 82873,
  [SMALL_STATE(1839)] = 82905,
  [SMALL_STATE(1840)] = 82941,
  [SMALL_STATE(1841)] = 82965,
  [SMALL_STATE(1842)] = 82997,
  [SMALL_STATE(1843)] = 83029,
  [SMALL_STATE(1844)] = 83051,
  [SMALL_STATE(1845)] = 83087,
  [SMALL_STATE(1846)] = 83117,
  [SMALL_STATE(1847)] = 83149,
  [SMALL_STATE(1848)] = 83185,
  [SMALL_STATE(1849)] = 83209,
  [SMALL_STATE(1850)] = 83245,
  [SMALL_STATE(1851)] = 83269,
  [SMALL_STATE(1852)] = 83305,
  [SMALL_STATE(1853)] = 83329,
  [SMALL_STATE(1854)] = 83361,
  [SMALL_STATE(1855)] = 83393,
  [SMALL_STATE(1856)] = 83414,
  [SMALL_STATE(1857)] = 83435,
  [SMALL_STATE(1858)] = 83456,
  [SMALL_STATE(1859)] = 83473,
  [SMALL_STATE(1860)] = 83494,
  [SMALL_STATE(1861)] = 83513,
  [SMALL_STATE(1862)] = 83534,
  [SMALL_STATE(1863)] = 83555,
  [SMALL_STATE(1864)] = 83572,
  [SMALL_STATE(1865)] = 83590,
  [SMALL_STATE(1866)] = 83620,
  [SMALL_STATE(1867)] = 83654,
  [SMALL_STATE(1868)] = 83688,
  [SMALL_STATE(1869)] = 83706,
  [SMALL_STATE(1870)] = 83724,
  [SMALL_STATE(1871)] = 83742,
  [SMALL_STATE(1872)] = 83760,
  [SMALL_STATE(1873)] = 83794,
  [SMALL_STATE(1874)] = 83828,
  [SMALL_STATE(1875)] = 83848,
  [SMALL_STATE(1876)] = 83866,
  [SMALL_STATE(1877)] = 83900,
  [SMALL_STATE(1878)] = 83934,
  [SMALL_STATE(1879)] = 83952,
  [SMALL_STATE(1880)] = 83970,
  [SMALL_STATE(1881)] = 84004,
  [SMALL_STATE(1882)] = 84024,
  [SMALL_STATE(1883)] = 84044,
  [SMALL_STATE(1884)] = 84064,
  [SMALL_STATE(1885)] = 84098,
  [SMALL_STATE(1886)] = 84116,
  [SMALL_STATE(1887)] = 84134,
  [SMALL_STATE(1888)] = 84168,
  [SMALL_STATE(1889)] = 84186,
  [SMALL_STATE(1890)] = 84204,
  [SMALL_STATE(1891)] = 84222,
  [SMALL_STATE(1892)] = 84256,
  [SMALL_STATE(1893)] = 84274,
  [SMALL_STATE(1894)] = 84294,
  [SMALL_STATE(1895)] = 84312,
  [SMALL_STATE(1896)] = 84330,
  [SMALL_STATE(1897)] = 84348,
  [SMALL_STATE(1898)] = 84368,
  [SMALL_STATE(1899)] = 84386,
  [SMALL_STATE(1900)] = 84404,
  [SMALL_STATE(1901)] = 84424,
  [SMALL_STATE(1902)] = 84442,
  [SMALL_STATE(1903)] = 84460,
  [SMALL_STATE(1904)] = 84480,
  [SMALL_STATE(1905)] = 84498,
  [SMALL_STATE(1906)] = 84516,
  [SMALL_STATE(1907)] = 84534,
  [SMALL_STATE(1908)] = 84552,
  [SMALL_STATE(1909)] = 84583,
  [SMALL_STATE(1910)] = 84602,
  [SMALL_STATE(1911)] = 84633,
  [SMALL_STATE(1912)] = 84664,
  [SMALL_STATE(1913)] = 84695,
  [SMALL_STATE(1914)] = 84726,
  [SMALL_STATE(1915)] = 84757,
  [SMALL_STATE(1916)] = 84788,
  [SMALL_STATE(1917)] = 84819,
  [SMALL_STATE(1918)] = 84844,
  [SMALL_STATE(1919)] = 84875,
  [SMALL_STATE(1920)] = 84906,
  [SMALL_STATE(1921)] = 84937,
  [SMALL_STATE(1922)] = 84962,
  [SMALL_STATE(1923)] = 84993,
  [SMALL_STATE(1924)] = 85024,
  [SMALL_STATE(1925)] = 85055,
  [SMALL_STATE(1926)] = 85086,
  [SMALL_STATE(1927)] = 85117,
  [SMALL_STATE(1928)] = 85135,
  [SMALL_STATE(1929)] = 85151,
  [SMALL_STATE(1930)] = 85173,
  [SMALL_STATE(1931)] = 85195,
  [SMALL_STATE(1932)] = 85217,
  [SMALL_STATE(1933)] = 85237,
  [SMALL_STATE(1934)] = 85255,
  [SMALL_STATE(1935)] = 85277,
  [SMALL_STATE(1936)] = 85295,
  [SMALL_STATE(1937)] = 85313,
  [SMALL_STATE(1938)] = 85335,
  [SMALL_STATE(1939)] = 85360,
  [SMALL_STATE(1940)] = 85381,
  [SMALL_STATE(1941)] = 85406,
  [SMALL_STATE(1942)] = 85431,
  [SMALL_STATE(1943)] = 85444,
  [SMALL_STATE(1944)] = 85461,
  [SMALL_STATE(1945)] = 85482,
  [SMALL_STATE(1946)] = 85499,
  [SMALL_STATE(1947)] = 85524,
  [SMALL_STATE(1948)] = 85549,
  [SMALL_STATE(1949)] = 85574,
  [SMALL_STATE(1950)] = 85599,
  [SMALL_STATE(1951)] = 85624,
  [SMALL_STATE(1952)] = 85649,
  [SMALL_STATE(1953)] = 85674,
  [SMALL_STATE(1954)] = 85691,
  [SMALL_STATE(1955)] = 85716,
  [SMALL_STATE(1956)] = 85733,
  [SMALL_STATE(1957)] = 85758,
  [SMALL_STATE(1958)] = 85783,
  [SMALL_STATE(1959)] = 85808,
  [SMALL_STATE(1960)] = 85833,
  [SMALL_STATE(1961)] = 85858,
  [SMALL_STATE(1962)] = 85883,
  [SMALL_STATE(1963)] = 85908,
  [SMALL_STATE(1964)] = 85933,
  [SMALL_STATE(1965)] = 85958,
  [SMALL_STATE(1966)] = 85983,
  [SMALL_STATE(1967)] = 86000,
  [SMALL_STATE(1968)] = 86025,
  [SMALL_STATE(1969)] = 86046,
  [SMALL_STATE(1970)] = 86063,
  [SMALL_STATE(1971)] = 86088,
  [SMALL_STATE(1972)] = 86101,
  [SMALL_STATE(1973)] = 86126,
  [SMALL_STATE(1974)] = 86151,
  [SMALL_STATE(1975)] = 86176,
  [SMALL_STATE(1976)] = 86201,
  [SMALL_STATE(1977)] = 86226,
  [SMALL_STATE(1978)] = 86251,
  [SMALL_STATE(1979)] = 86276,
  [SMALL_STATE(1980)] = 86301,
  [SMALL_STATE(1981)] = 86322,
  [SMALL_STATE(1982)] = 86343,
  [SMALL_STATE(1983)] = 86364,
  [SMALL_STATE(1984)] = 86381,
  [SMALL_STATE(1985)] = 86398,
  [SMALL_STATE(1986)] = 86415,
  [SMALL_STATE(1987)] = 86434,
  [SMALL_STATE(1988)] = 86451,
  [SMALL_STATE(1989)] = 86466,
  [SMALL_STATE(1990)] = 86479,
  [SMALL_STATE(1991)] = 86496,
  [SMALL_STATE(1992)] = 86521,
  [SMALL_STATE(1993)] = 86542,
  [SMALL_STATE(1994)] = 86557,
  [SMALL_STATE(1995)] = 86574,
  [SMALL_STATE(1996)] = 86599,
  [SMALL_STATE(1997)] = 86624,
  [SMALL_STATE(1998)] = 86649,
  [SMALL_STATE(1999)] = 86666,
  [SMALL_STATE(2000)] = 86683,
  [SMALL_STATE(2001)] = 86700,
  [SMALL_STATE(2002)] = 86725,
  [SMALL_STATE(2003)] = 86750,
  [SMALL_STATE(2004)] = 86773,
  [SMALL_STATE(2005)] = 86798,
  [SMALL_STATE(2006)] = 86811,
  [SMALL_STATE(2007)] = 86836,
  [SMALL_STATE(2008)] = 86853,
  [SMALL_STATE(2009)] = 86874,
  [SMALL_STATE(2010)] = 86887,
  [SMALL_STATE(2011)] = 86904,
  [SMALL_STATE(2012)] = 86929,
  [SMALL_STATE(2013)] = 86947,
  [SMALL_STATE(2014)] = 86965,
  [SMALL_STATE(2015)] = 86987,
  [SMALL_STATE(2016)] = 87009,
  [SMALL_STATE(2017)] = 87031,
  [SMALL_STATE(2018)] = 87047,
  [SMALL_STATE(2019)] = 87063,
  [SMALL_STATE(2020)] = 87085,
  [SMALL_STATE(2021)] = 87107,
  [SMALL_STATE(2022)] = 87127,
  [SMALL_STATE(2023)] = 87149,
  [SMALL_STATE(2024)] = 87171,
  [SMALL_STATE(2025)] = 87193,
  [SMALL_STATE(2026)] = 87209,
  [SMALL_STATE(2027)] = 87225,
  [SMALL_STATE(2028)] = 87243,
  [SMALL_STATE(2029)] = 87259,
  [SMALL_STATE(2030)] = 87281,
  [SMALL_STATE(2031)] = 87303,
  [SMALL_STATE(2032)] = 87321,
  [SMALL_STATE(2033)] = 87343,
  [SMALL_STATE(2034)] = 87355,
  [SMALL_STATE(2035)] = 87367,
  [SMALL_STATE(2036)] = 87389,
  [SMALL_STATE(2037)] = 87405,
  [SMALL_STATE(2038)] = 87427,
  [SMALL_STATE(2039)] = 87449,
  [SMALL_STATE(2040)] = 87471,
  [SMALL_STATE(2041)] = 87493,
  [SMALL_STATE(2042)] = 87515,
  [SMALL_STATE(2043)] = 87533,
  [SMALL_STATE(2044)] = 87555,
  [SMALL_STATE(2045)] = 87577,
  [SMALL_STATE(2046)] = 87593,
  [SMALL_STATE(2047)] = 87615,
  [SMALL_STATE(2048)] = 87637,
  [SMALL_STATE(2049)] = 87653,
  [SMALL_STATE(2050)] = 87675,
  [SMALL_STATE(2051)] = 87697,
  [SMALL_STATE(2052)] = 87713,
  [SMALL_STATE(2053)] = 87735,
  [SMALL_STATE(2054)] = 87757,
  [SMALL_STATE(2055)] = 87769,
  [SMALL_STATE(2056)] = 87791,
  [SMALL_STATE(2057)] = 87813,
  [SMALL_STATE(2058)] = 87829,
  [SMALL_STATE(2059)] = 87845,
  [SMALL_STATE(2060)] = 87867,
  [SMALL_STATE(2061)] = 87883,
  [SMALL_STATE(2062)] = 87905,
  [SMALL_STATE(2063)] = 87925,
  [SMALL_STATE(2064)] = 87947,
  [SMALL_STATE(2065)] = 87969,
  [SMALL_STATE(2066)] = 87985,
  [SMALL_STATE(2067)] = 88007,
  [SMALL_STATE(2068)] = 88029,
  [SMALL_STATE(2069)] = 88045,
  [SMALL_STATE(2070)] = 88061,
  [SMALL_STATE(2071)] = 88083,
  [SMALL_STATE(2072)] = 88099,
  [SMALL_STATE(2073)] = 88121,
  [SMALL_STATE(2074)] = 88139,
  [SMALL_STATE(2075)] = 88161,
  [SMALL_STATE(2076)] = 88179,
  [SMALL_STATE(2077)] = 88201,
  [SMALL_STATE(2078)] = 88219,
  [SMALL_STATE(2079)] = 88235,
  [SMALL_STATE(2080)] = 88257,
  [SMALL_STATE(2081)] = 88279,
  [SMALL_STATE(2082)] = 88297,
  [SMALL_STATE(2083)] = 88309,
  [SMALL_STATE(2084)] = 88325,
  [SMALL_STATE(2085)] = 88341,
  [SMALL_STATE(2086)] = 88363,
  [SMALL_STATE(2087)] = 88383,
  [SMALL_STATE(2088)] = 88405,
  [SMALL_STATE(2089)] = 88425,
  [SMALL_STATE(2090)] = 88441,
  [SMALL_STATE(2091)] = 88459,
  [SMALL_STATE(2092)] = 88475,
  [SMALL_STATE(2093)] = 88491,
  [SMALL_STATE(2094)] = 88513,
  [SMALL_STATE(2095)] = 88532,
  [SMALL_STATE(2096)] = 88543,
  [SMALL_STATE(2097)] = 88558,
  [SMALL_STATE(2098)] = 88569,
  [SMALL_STATE(2099)] = 88588,
  [SMALL_STATE(2100)] = 88607,
  [SMALL_STATE(2101)] = 88626,
  [SMALL_STATE(2102)] = 88645,
  [SMALL_STATE(2103)] = 88660,
  [SMALL_STATE(2104)] = 88675,
  [SMALL_STATE(2105)] = 88694,
  [SMALL_STATE(2106)] = 88709,
  [SMALL_STATE(2107)] = 88726,
  [SMALL_STATE(2108)] = 88741,
  [SMALL_STATE(2109)] = 88760,
  [SMALL_STATE(2110)] = 88771,
  [SMALL_STATE(2111)] = 88782,
  [SMALL_STATE(2112)] = 88801,
  [SMALL_STATE(2113)] = 88820,
  [SMALL_STATE(2114)] = 88839,
  [SMALL_STATE(2115)] = 88850,
  [SMALL_STATE(2116)] = 88869,
  [SMALL_STATE(2117)] = 88880,
  [SMALL_STATE(2118)] = 88891,
  [SMALL_STATE(2119)] = 88902,
  [SMALL_STATE(2120)] = 88913,
  [SMALL_STATE(2121)] = 88932,
  [SMALL_STATE(2122)] = 88943,
  [SMALL_STATE(2123)] = 88954,
  [SMALL_STATE(2124)] = 88965,
  [SMALL_STATE(2125)] = 88980,
  [SMALL_STATE(2126)] = 88991,
  [SMALL_STATE(2127)] = 89004,
  [SMALL_STATE(2128)] = 89015,
  [SMALL_STATE(2129)] = 89026,
  [SMALL_STATE(2130)] = 89037,
  [SMALL_STATE(2131)] = 89048,
  [SMALL_STATE(2132)] = 89067,
  [SMALL_STATE(2133)] = 89078,
  [SMALL_STATE(2134)] = 89089,
  [SMALL_STATE(2135)] = 89108,
  [SMALL_STATE(2136)] = 89127,
  [SMALL_STATE(2137)] = 89146,
  [SMALL_STATE(2138)] = 89157,
  [SMALL_STATE(2139)] = 89168,
  [SMALL_STATE(2140)] = 89187,
  [SMALL_STATE(2141)] = 89206,
  [SMALL_STATE(2142)] = 89225,
  [SMALL_STATE(2143)] = 89236,
  [SMALL_STATE(2144)] = 89255,
  [SMALL_STATE(2145)] = 89266,
  [SMALL_STATE(2146)] = 89285,
  [SMALL_STATE(2147)] = 89296,
  [SMALL_STATE(2148)] = 89307,
  [SMALL_STATE(2149)] = 89318,
  [SMALL_STATE(2150)] = 89337,
  [SMALL_STATE(2151)] = 89348,
  [SMALL_STATE(2152)] = 89359,
  [SMALL_STATE(2153)] = 89378,
  [SMALL_STATE(2154)] = 89393,
  [SMALL_STATE(2155)] = 89404,
  [SMALL_STATE(2156)] = 89415,
  [SMALL_STATE(2157)] = 89426,
  [SMALL_STATE(2158)] = 89437,
  [SMALL_STATE(2159)] = 89448,
  [SMALL_STATE(2160)] = 89459,
  [SMALL_STATE(2161)] = 89478,
  [SMALL_STATE(2162)] = 89497,
  [SMALL_STATE(2163)] = 89508,
  [SMALL_STATE(2164)] = 89519,
  [SMALL_STATE(2165)] = 89538,
  [SMALL_STATE(2166)] = 89549,
  [SMALL_STATE(2167)] = 89560,
  [SMALL_STATE(2168)] = 89579,
  [SMALL_STATE(2169)] = 89590,
  [SMALL_STATE(2170)] = 89601,
  [SMALL_STATE(2171)] = 89612,
  [SMALL_STATE(2172)] = 89623,
  [SMALL_STATE(2173)] = 89634,
  [SMALL_STATE(2174)] = 89645,
  [SMALL_STATE(2175)] = 89656,
  [SMALL_STATE(2176)] = 89667,
  [SMALL_STATE(2177)] = 89678,
  [SMALL_STATE(2178)] = 89697,
  [SMALL_STATE(2179)] = 89716,
  [SMALL_STATE(2180)] = 89727,
  [SMALL_STATE(2181)] = 89746,
  [SMALL_STATE(2182)] = 89757,
  [SMALL_STATE(2183)] = 89772,
  [SMALL_STATE(2184)] = 89791,
  [SMALL_STATE(2185)] = 89810,
  [SMALL_STATE(2186)] = 89829,
  [SMALL_STATE(2187)] = 89846,
  [SMALL_STATE(2188)] = 89861,
  [SMALL_STATE(2189)] = 89872,
  [SMALL_STATE(2190)] = 89891,
  [SMALL_STATE(2191)] = 89910,
  [SMALL_STATE(2192)] = 89927,
  [SMALL_STATE(2193)] = 89946,
  [SMALL_STATE(2194)] = 89961,
  [SMALL_STATE(2195)] = 89976,
  [SMALL_STATE(2196)] = 89987,
  [SMALL_STATE(2197)] = 90002,
  [SMALL_STATE(2198)] = 90013,
  [SMALL_STATE(2199)] = 90024,
  [SMALL_STATE(2200)] = 90043,
  [SMALL_STATE(2201)] = 90058,
  [SMALL_STATE(2202)] = 90069,
  [SMALL_STATE(2203)] = 90080,
  [SMALL_STATE(2204)] = 90099,
  [SMALL_STATE(2205)] = 90118,
  [SMALL_STATE(2206)] = 90137,
  [SMALL_STATE(2207)] = 90148,
  [SMALL_STATE(2208)] = 90167,
  [SMALL_STATE(2209)] = 90186,
  [SMALL_STATE(2210)] = 90197,
  [SMALL_STATE(2211)] = 90208,
  [SMALL_STATE(2212)] = 90219,
  [SMALL_STATE(2213)] = 90238,
  [SMALL_STATE(2214)] = 90257,
  [SMALL_STATE(2215)] = 90268,
  [SMALL_STATE(2216)] = 90279,
  [SMALL_STATE(2217)] = 90290,
  [SMALL_STATE(2218)] = 90301,
  [SMALL_STATE(2219)] = 90312,
  [SMALL_STATE(2220)] = 90331,
  [SMALL_STATE(2221)] = 90350,
  [SMALL_STATE(2222)] = 90369,
  [SMALL_STATE(2223)] = 90388,
  [SMALL_STATE(2224)] = 90399,
  [SMALL_STATE(2225)] = 90418,
  [SMALL_STATE(2226)] = 90429,
  [SMALL_STATE(2227)] = 90440,
  [SMALL_STATE(2228)] = 90459,
  [SMALL_STATE(2229)] = 90470,
  [SMALL_STATE(2230)] = 90481,
  [SMALL_STATE(2231)] = 90492,
  [SMALL_STATE(2232)] = 90509,
  [SMALL_STATE(2233)] = 90520,
  [SMALL_STATE(2234)] = 90531,
  [SMALL_STATE(2235)] = 90550,
  [SMALL_STATE(2236)] = 90569,
  [SMALL_STATE(2237)] = 90588,
  [SMALL_STATE(2238)] = 90599,
  [SMALL_STATE(2239)] = 90610,
  [SMALL_STATE(2240)] = 90621,
  [SMALL_STATE(2241)] = 90638,
  [SMALL_STATE(2242)] = 90649,
  [SMALL_STATE(2243)] = 90664,
  [SMALL_STATE(2244)] = 90683,
  [SMALL_STATE(2245)] = 90698,
  [SMALL_STATE(2246)] = 90713,
  [SMALL_STATE(2247)] = 90732,
  [SMALL_STATE(2248)] = 90747,
  [SMALL_STATE(2249)] = 90758,
  [SMALL_STATE(2250)] = 90777,
  [SMALL_STATE(2251)] = 90796,
  [SMALL_STATE(2252)] = 90807,
  [SMALL_STATE(2253)] = 90818,
  [SMALL_STATE(2254)] = 90833,
  [SMALL_STATE(2255)] = 90844,
  [SMALL_STATE(2256)] = 90863,
  [SMALL_STATE(2257)] = 90878,
  [SMALL_STATE(2258)] = 90889,
  [SMALL_STATE(2259)] = 90904,
  [SMALL_STATE(2260)] = 90923,
  [SMALL_STATE(2261)] = 90938,
  [SMALL_STATE(2262)] = 90949,
  [SMALL_STATE(2263)] = 90968,
  [SMALL_STATE(2264)] = 90979,
  [SMALL_STATE(2265)] = 90998,
  [SMALL_STATE(2266)] = 91009,
  [SMALL_STATE(2267)] = 91028,
  [SMALL_STATE(2268)] = 91047,
  [SMALL_STATE(2269)] = 91066,
  [SMALL_STATE(2270)] = 91081,
  [SMALL_STATE(2271)] = 91092,
  [SMALL_STATE(2272)] = 91103,
  [SMALL_STATE(2273)] = 91116,
  [SMALL_STATE(2274)] = 91127,
  [SMALL_STATE(2275)] = 91138,
  [SMALL_STATE(2276)] = 91153,
  [SMALL_STATE(2277)] = 91172,
  [SMALL_STATE(2278)] = 91187,
  [SMALL_STATE(2279)] = 91198,
  [SMALL_STATE(2280)] = 91209,
  [SMALL_STATE(2281)] = 91224,
  [SMALL_STATE(2282)] = 91235,
  [SMALL_STATE(2283)] = 91246,
  [SMALL_STATE(2284)] = 91259,
  [SMALL_STATE(2285)] = 91272,
  [SMALL_STATE(2286)] = 91283,
  [SMALL_STATE(2287)] = 91302,
  [SMALL_STATE(2288)] = 91313,
  [SMALL_STATE(2289)] = 91332,
  [SMALL_STATE(2290)] = 91343,
  [SMALL_STATE(2291)] = 91356,
  [SMALL_STATE(2292)] = 91367,
  [SMALL_STATE(2293)] = 91378,
  [SMALL_STATE(2294)] = 91393,
  [SMALL_STATE(2295)] = 91404,
  [SMALL_STATE(2296)] = 91419,
  [SMALL_STATE(2297)] = 91430,
  [SMALL_STATE(2298)] = 91441,
  [SMALL_STATE(2299)] = 91452,
  [SMALL_STATE(2300)] = 91463,
  [SMALL_STATE(2301)] = 91482,
  [SMALL_STATE(2302)] = 91501,
  [SMALL_STATE(2303)] = 91512,
  [SMALL_STATE(2304)] = 91523,
  [SMALL_STATE(2305)] = 91542,
  [SMALL_STATE(2306)] = 91556,
  [SMALL_STATE(2307)] = 91572,
  [SMALL_STATE(2308)] = 91586,
  [SMALL_STATE(2309)] = 91602,
  [SMALL_STATE(2310)] = 91618,
  [SMALL_STATE(2311)] = 91632,
  [SMALL_STATE(2312)] = 91648,
  [SMALL_STATE(2313)] = 91664,
  [SMALL_STATE(2314)] = 91678,
  [SMALL_STATE(2315)] = 91694,
  [SMALL_STATE(2316)] = 91710,
  [SMALL_STATE(2317)] = 91726,
  [SMALL_STATE(2318)] = 91740,
  [SMALL_STATE(2319)] = 91754,
  [SMALL_STATE(2320)] = 91770,
  [SMALL_STATE(2321)] = 91780,
  [SMALL_STATE(2322)] = 91794,
  [SMALL_STATE(2323)] = 91810,
  [SMALL_STATE(2324)] = 91824,
  [SMALL_STATE(2325)] = 91838,
  [SMALL_STATE(2326)] = 91852,
  [SMALL_STATE(2327)] = 91868,
  [SMALL_STATE(2328)] = 91884,
  [SMALL_STATE(2329)] = 91898,
  [SMALL_STATE(2330)] = 91914,
  [SMALL_STATE(2331)] = 91930,
  [SMALL_STATE(2332)] = 91946,
  [SMALL_STATE(2333)] = 91960,
  [SMALL_STATE(2334)] = 91976,
  [SMALL_STATE(2335)] = 91990,
  [SMALL_STATE(2336)] = 92004,
  [SMALL_STATE(2337)] = 92020,
  [SMALL_STATE(2338)] = 92036,
  [SMALL_STATE(2339)] = 92052,
  [SMALL_STATE(2340)] = 92066,
  [SMALL_STATE(2341)] = 92080,
  [SMALL_STATE(2342)] = 92094,
  [SMALL_STATE(2343)] = 92104,
  [SMALL_STATE(2344)] = 92118,
  [SMALL_STATE(2345)] = 92134,
  [SMALL_STATE(2346)] = 92148,
  [SMALL_STATE(2347)] = 92162,
  [SMALL_STATE(2348)] = 92176,
  [SMALL_STATE(2349)] = 92190,
  [SMALL_STATE(2350)] = 92206,
  [SMALL_STATE(2351)] = 92220,
  [SMALL_STATE(2352)] = 92236,
  [SMALL_STATE(2353)] = 92252,
  [SMALL_STATE(2354)] = 92266,
  [SMALL_STATE(2355)] = 92280,
  [SMALL_STATE(2356)] = 92296,
  [SMALL_STATE(2357)] = 92308,
  [SMALL_STATE(2358)] = 92320,
  [SMALL_STATE(2359)] = 92334,
  [SMALL_STATE(2360)] = 92348,
  [SMALL_STATE(2361)] = 92362,
  [SMALL_STATE(2362)] = 92378,
  [SMALL_STATE(2363)] = 92394,
  [SMALL_STATE(2364)] = 92410,
  [SMALL_STATE(2365)] = 92426,
  [SMALL_STATE(2366)] = 92440,
  [SMALL_STATE(2367)] = 92456,
  [SMALL_STATE(2368)] = 92472,
  [SMALL_STATE(2369)] = 92486,
  [SMALL_STATE(2370)] = 92502,
  [SMALL_STATE(2371)] = 92518,
  [SMALL_STATE(2372)] = 92532,
  [SMALL_STATE(2373)] = 92548,
  [SMALL_STATE(2374)] = 92564,
  [SMALL_STATE(2375)] = 92578,
  [SMALL_STATE(2376)] = 92592,
  [SMALL_STATE(2377)] = 92606,
  [SMALL_STATE(2378)] = 92620,
  [SMALL_STATE(2379)] = 92634,
  [SMALL_STATE(2380)] = 92650,
  [SMALL_STATE(2381)] = 92666,
  [SMALL_STATE(2382)] = 92682,
  [SMALL_STATE(2383)] = 92698,
  [SMALL_STATE(2384)] = 92712,
  [SMALL_STATE(2385)] = 92726,
  [SMALL_STATE(2386)] = 92740,
  [SMALL_STATE(2387)] = 92756,
  [SMALL_STATE(2388)] = 92772,
  [SMALL_STATE(2389)] = 92788,
  [SMALL_STATE(2390)] = 92802,
  [SMALL_STATE(2391)] = 92816,
  [SMALL_STATE(2392)] = 92830,
  [SMALL_STATE(2393)] = 92846,
  [SMALL_STATE(2394)] = 92860,
  [SMALL_STATE(2395)] = 92876,
  [SMALL_STATE(2396)] = 92885,
  [SMALL_STATE(2397)] = 92898,
  [SMALL_STATE(2398)] = 92907,
  [SMALL_STATE(2399)] = 92916,
  [SMALL_STATE(2400)] = 92929,
  [SMALL_STATE(2401)] = 92938,
  [SMALL_STATE(2402)] = 92947,
  [SMALL_STATE(2403)] = 92958,
  [SMALL_STATE(2404)] = 92969,
  [SMALL_STATE(2405)] = 92978,
  [SMALL_STATE(2406)] = 92991,
  [SMALL_STATE(2407)] = 93004,
  [SMALL_STATE(2408)] = 93017,
  [SMALL_STATE(2409)] = 93030,
  [SMALL_STATE(2410)] = 93039,
  [SMALL_STATE(2411)] = 93048,
  [SMALL_STATE(2412)] = 93061,
  [SMALL_STATE(2413)] = 93074,
  [SMALL_STATE(2414)] = 93087,
  [SMALL_STATE(2415)] = 93100,
  [SMALL_STATE(2416)] = 93113,
  [SMALL_STATE(2417)] = 93122,
  [SMALL_STATE(2418)] = 93131,
  [SMALL_STATE(2419)] = 93144,
  [SMALL_STATE(2420)] = 93157,
  [SMALL_STATE(2421)] = 93166,
  [SMALL_STATE(2422)] = 93179,
  [SMALL_STATE(2423)] = 93192,
  [SMALL_STATE(2424)] = 93201,
  [SMALL_STATE(2425)] = 93210,
  [SMALL_STATE(2426)] = 93219,
  [SMALL_STATE(2427)] = 93232,
  [SMALL_STATE(2428)] = 93245,
  [SMALL_STATE(2429)] = 93258,
  [SMALL_STATE(2430)] = 93271,
  [SMALL_STATE(2431)] = 93284,
  [SMALL_STATE(2432)] = 93297,
  [SMALL_STATE(2433)] = 93306,
  [SMALL_STATE(2434)] = 93319,
  [SMALL_STATE(2435)] = 93328,
  [SMALL_STATE(2436)] = 93337,
  [SMALL_STATE(2437)] = 93350,
  [SMALL_STATE(2438)] = 93359,
  [SMALL_STATE(2439)] = 93372,
  [SMALL_STATE(2440)] = 93385,
  [SMALL_STATE(2441)] = 93398,
  [SMALL_STATE(2442)] = 93411,
  [SMALL_STATE(2443)] = 93424,
  [SMALL_STATE(2444)] = 93437,
  [SMALL_STATE(2445)] = 93450,
  [SMALL_STATE(2446)] = 93461,
  [SMALL_STATE(2447)] = 93474,
  [SMALL_STATE(2448)] = 93487,
  [SMALL_STATE(2449)] = 93496,
  [SMALL_STATE(2450)] = 93509,
  [SMALL_STATE(2451)] = 93522,
  [SMALL_STATE(2452)] = 93531,
  [SMALL_STATE(2453)] = 93542,
  [SMALL_STATE(2454)] = 93555,
  [SMALL_STATE(2455)] = 93568,
  [SMALL_STATE(2456)] = 93581,
  [SMALL_STATE(2457)] = 93594,
  [SMALL_STATE(2458)] = 93607,
  [SMALL_STATE(2459)] = 93620,
  [SMALL_STATE(2460)] = 93629,
  [SMALL_STATE(2461)] = 93638,
  [SMALL_STATE(2462)] = 93647,
  [SMALL_STATE(2463)] = 93658,
  [SMALL_STATE(2464)] = 93669,
  [SMALL_STATE(2465)] = 93678,
  [SMALL_STATE(2466)] = 93691,
  [SMALL_STATE(2467)] = 93704,
  [SMALL_STATE(2468)] = 93717,
  [SMALL_STATE(2469)] = 93730,
  [SMALL_STATE(2470)] = 93739,
  [SMALL_STATE(2471)] = 93752,
  [SMALL_STATE(2472)] = 93765,
  [SMALL_STATE(2473)] = 93778,
  [SMALL_STATE(2474)] = 93791,
  [SMALL_STATE(2475)] = 93800,
  [SMALL_STATE(2476)] = 93809,
  [SMALL_STATE(2477)] = 93822,
  [SMALL_STATE(2478)] = 93835,
  [SMALL_STATE(2479)] = 93848,
  [SMALL_STATE(2480)] = 93861,
  [SMALL_STATE(2481)] = 93874,
  [SMALL_STATE(2482)] = 93887,
  [SMALL_STATE(2483)] = 93896,
  [SMALL_STATE(2484)] = 93909,
  [SMALL_STATE(2485)] = 93922,
  [SMALL_STATE(2486)] = 93935,
  [SMALL_STATE(2487)] = 93948,
  [SMALL_STATE(2488)] = 93961,
  [SMALL_STATE(2489)] = 93974,
  [SMALL_STATE(2490)] = 93987,
  [SMALL_STATE(2491)] = 94000,
  [SMALL_STATE(2492)] = 94013,
  [SMALL_STATE(2493)] = 94026,
  [SMALL_STATE(2494)] = 94039,
  [SMALL_STATE(2495)] = 94052,
  [SMALL_STATE(2496)] = 94065,
  [SMALL_STATE(2497)] = 94078,
  [SMALL_STATE(2498)] = 94087,
  [SMALL_STATE(2499)] = 94100,
  [SMALL_STATE(2500)] = 94109,
  [SMALL_STATE(2501)] = 94122,
  [SMALL_STATE(2502)] = 94135,
  [SMALL_STATE(2503)] = 94148,
  [SMALL_STATE(2504)] = 94161,
  [SMALL_STATE(2505)] = 94174,
  [SMALL_STATE(2506)] = 94187,
  [SMALL_STATE(2507)] = 94200,
  [SMALL_STATE(2508)] = 94209,
  [SMALL_STATE(2509)] = 94222,
  [SMALL_STATE(2510)] = 94233,
  [SMALL_STATE(2511)] = 94246,
  [SMALL_STATE(2512)] = 94259,
  [SMALL_STATE(2513)] = 94272,
  [SMALL_STATE(2514)] = 94285,
  [SMALL_STATE(2515)] = 94298,
  [SMALL_STATE(2516)] = 94311,
  [SMALL_STATE(2517)] = 94324,
  [SMALL_STATE(2518)] = 94337,
  [SMALL_STATE(2519)] = 94348,
  [SMALL_STATE(2520)] = 94361,
  [SMALL_STATE(2521)] = 94374,
  [SMALL_STATE(2522)] = 94387,
  [SMALL_STATE(2523)] = 94400,
  [SMALL_STATE(2524)] = 94413,
  [SMALL_STATE(2525)] = 94424,
  [SMALL_STATE(2526)] = 94435,
  [SMALL_STATE(2527)] = 94446,
  [SMALL_STATE(2528)] = 94459,
  [SMALL_STATE(2529)] = 94472,
  [SMALL_STATE(2530)] = 94485,
  [SMALL_STATE(2531)] = 94498,
  [SMALL_STATE(2532)] = 94507,
  [SMALL_STATE(2533)] = 94516,
  [SMALL_STATE(2534)] = 94525,
  [SMALL_STATE(2535)] = 94538,
  [SMALL_STATE(2536)] = 94551,
  [SMALL_STATE(2537)] = 94562,
  [SMALL_STATE(2538)] = 94571,
  [SMALL_STATE(2539)] = 94584,
  [SMALL_STATE(2540)] = 94597,
  [SMALL_STATE(2541)] = 94610,
  [SMALL_STATE(2542)] = 94619,
  [SMALL_STATE(2543)] = 94632,
  [SMALL_STATE(2544)] = 94641,
  [SMALL_STATE(2545)] = 94654,
  [SMALL_STATE(2546)] = 94663,
  [SMALL_STATE(2547)] = 94674,
  [SMALL_STATE(2548)] = 94685,
  [SMALL_STATE(2549)] = 94698,
  [SMALL_STATE(2550)] = 94707,
  [SMALL_STATE(2551)] = 94716,
  [SMALL_STATE(2552)] = 94725,
  [SMALL_STATE(2553)] = 94736,
  [SMALL_STATE(2554)] = 94749,
  [SMALL_STATE(2555)] = 94762,
  [SMALL_STATE(2556)] = 94775,
  [SMALL_STATE(2557)] = 94784,
  [SMALL_STATE(2558)] = 94797,
  [SMALL_STATE(2559)] = 94810,
  [SMALL_STATE(2560)] = 94823,
  [SMALL_STATE(2561)] = 94836,
  [SMALL_STATE(2562)] = 94849,
  [SMALL_STATE(2563)] = 94862,
  [SMALL_STATE(2564)] = 94875,
  [SMALL_STATE(2565)] = 94888,
  [SMALL_STATE(2566)] = 94901,
  [SMALL_STATE(2567)] = 94914,
  [SMALL_STATE(2568)] = 94927,
  [SMALL_STATE(2569)] = 94940,
  [SMALL_STATE(2570)] = 94953,
  [SMALL_STATE(2571)] = 94966,
  [SMALL_STATE(2572)] = 94979,
  [SMALL_STATE(2573)] = 94992,
  [SMALL_STATE(2574)] = 95005,
  [SMALL_STATE(2575)] = 95018,
  [SMALL_STATE(2576)] = 95031,
  [SMALL_STATE(2577)] = 95044,
  [SMALL_STATE(2578)] = 95057,
  [SMALL_STATE(2579)] = 95070,
  [SMALL_STATE(2580)] = 95083,
  [SMALL_STATE(2581)] = 95093,
  [SMALL_STATE(2582)] = 95101,
  [SMALL_STATE(2583)] = 95111,
  [SMALL_STATE(2584)] = 95119,
  [SMALL_STATE(2585)] = 95129,
  [SMALL_STATE(2586)] = 95139,
  [SMALL_STATE(2587)] = 95149,
  [SMALL_STATE(2588)] = 95159,
  [SMALL_STATE(2589)] = 95169,
  [SMALL_STATE(2590)] = 95179,
  [SMALL_STATE(2591)] = 95189,
  [SMALL_STATE(2592)] = 95199,
  [SMALL_STATE(2593)] = 95209,
  [SMALL_STATE(2594)] = 95219,
  [SMALL_STATE(2595)] = 95229,
  [SMALL_STATE(2596)] = 95239,
  [SMALL_STATE(2597)] = 95247,
  [SMALL_STATE(2598)] = 95257,
  [SMALL_STATE(2599)] = 95267,
  [SMALL_STATE(2600)] = 95275,
  [SMALL_STATE(2601)] = 95285,
  [SMALL_STATE(2602)] = 95293,
  [SMALL_STATE(2603)] = 95303,
  [SMALL_STATE(2604)] = 95311,
  [SMALL_STATE(2605)] = 95319,
  [SMALL_STATE(2606)] = 95329,
  [SMALL_STATE(2607)] = 95339,
  [SMALL_STATE(2608)] = 95349,
  [SMALL_STATE(2609)] = 95357,
  [SMALL_STATE(2610)] = 95365,
  [SMALL_STATE(2611)] = 95375,
  [SMALL_STATE(2612)] = 95385,
  [SMALL_STATE(2613)] = 95393,
  [SMALL_STATE(2614)] = 95403,
  [SMALL_STATE(2615)] = 95411,
  [SMALL_STATE(2616)] = 95419,
  [SMALL_STATE(2617)] = 95429,
  [SMALL_STATE(2618)] = 95439,
  [SMALL_STATE(2619)] = 95449,
  [SMALL_STATE(2620)] = 95457,
  [SMALL_STATE(2621)] = 95467,
  [SMALL_STATE(2622)] = 95475,
  [SMALL_STATE(2623)] = 95483,
  [SMALL_STATE(2624)] = 95493,
  [SMALL_STATE(2625)] = 95503,
  [SMALL_STATE(2626)] = 95513,
  [SMALL_STATE(2627)] = 95523,
  [SMALL_STATE(2628)] = 95533,
  [SMALL_STATE(2629)] = 95543,
  [SMALL_STATE(2630)] = 95553,
  [SMALL_STATE(2631)] = 95563,
  [SMALL_STATE(2632)] = 95571,
  [SMALL_STATE(2633)] = 95581,
  [SMALL_STATE(2634)] = 95591,
  [SMALL_STATE(2635)] = 95601,
  [SMALL_STATE(2636)] = 95611,
  [SMALL_STATE(2637)] = 95621,
  [SMALL_STATE(2638)] = 95631,
  [SMALL_STATE(2639)] = 95641,
  [SMALL_STATE(2640)] = 95651,
  [SMALL_STATE(2641)] = 95661,
  [SMALL_STATE(2642)] = 95671,
  [SMALL_STATE(2643)] = 95681,
  [SMALL_STATE(2644)] = 95691,
  [SMALL_STATE(2645)] = 95701,
  [SMALL_STATE(2646)] = 95711,
  [SMALL_STATE(2647)] = 95719,
  [SMALL_STATE(2648)] = 95729,
  [SMALL_STATE(2649)] = 95737,
  [SMALL_STATE(2650)] = 95747,
  [SMALL_STATE(2651)] = 95757,
  [SMALL_STATE(2652)] = 95767,
  [SMALL_STATE(2653)] = 95777,
  [SMALL_STATE(2654)] = 95787,
  [SMALL_STATE(2655)] = 95797,
  [SMALL_STATE(2656)] = 95807,
  [SMALL_STATE(2657)] = 95815,
  [SMALL_STATE(2658)] = 95825,
  [SMALL_STATE(2659)] = 95835,
  [SMALL_STATE(2660)] = 95843,
  [SMALL_STATE(2661)] = 95853,
  [SMALL_STATE(2662)] = 95863,
  [SMALL_STATE(2663)] = 95871,
  [SMALL_STATE(2664)] = 95881,
  [SMALL_STATE(2665)] = 95889,
  [SMALL_STATE(2666)] = 95899,
  [SMALL_STATE(2667)] = 95909,
  [SMALL_STATE(2668)] = 95919,
  [SMALL_STATE(2669)] = 95929,
  [SMALL_STATE(2670)] = 95939,
  [SMALL_STATE(2671)] = 95947,
  [SMALL_STATE(2672)] = 95955,
  [SMALL_STATE(2673)] = 95965,
  [SMALL_STATE(2674)] = 95973,
  [SMALL_STATE(2675)] = 95983,
  [SMALL_STATE(2676)] = 95993,
  [SMALL_STATE(2677)] = 96003,
  [SMALL_STATE(2678)] = 96013,
  [SMALL_STATE(2679)] = 96023,
  [SMALL_STATE(2680)] = 96031,
  [SMALL_STATE(2681)] = 96041,
  [SMALL_STATE(2682)] = 96051,
  [SMALL_STATE(2683)] = 96061,
  [SMALL_STATE(2684)] = 96069,
  [SMALL_STATE(2685)] = 96079,
  [SMALL_STATE(2686)] = 96089,
  [SMALL_STATE(2687)] = 96099,
  [SMALL_STATE(2688)] = 96109,
  [SMALL_STATE(2689)] = 96119,
  [SMALL_STATE(2690)] = 96129,
  [SMALL_STATE(2691)] = 96139,
  [SMALL_STATE(2692)] = 96149,
  [SMALL_STATE(2693)] = 96159,
  [SMALL_STATE(2694)] = 96167,
  [SMALL_STATE(2695)] = 96177,
  [SMALL_STATE(2696)] = 96187,
  [SMALL_STATE(2697)] = 96197,
  [SMALL_STATE(2698)] = 96207,
  [SMALL_STATE(2699)] = 96217,
  [SMALL_STATE(2700)] = 96227,
  [SMALL_STATE(2701)] = 96235,
  [SMALL_STATE(2702)] = 96243,
  [SMALL_STATE(2703)] = 96251,
  [SMALL_STATE(2704)] = 96261,
  [SMALL_STATE(2705)] = 96271,
  [SMALL_STATE(2706)] = 96279,
  [SMALL_STATE(2707)] = 96289,
  [SMALL_STATE(2708)] = 96299,
  [SMALL_STATE(2709)] = 96307,
  [SMALL_STATE(2710)] = 96315,
  [SMALL_STATE(2711)] = 96325,
  [SMALL_STATE(2712)] = 96335,
  [SMALL_STATE(2713)] = 96345,
  [SMALL_STATE(2714)] = 96355,
  [SMALL_STATE(2715)] = 96365,
  [SMALL_STATE(2716)] = 96375,
  [SMALL_STATE(2717)] = 96383,
  [SMALL_STATE(2718)] = 96391,
  [SMALL_STATE(2719)] = 96401,
  [SMALL_STATE(2720)] = 96411,
  [SMALL_STATE(2721)] = 96421,
  [SMALL_STATE(2722)] = 96429,
  [SMALL_STATE(2723)] = 96439,
  [SMALL_STATE(2724)] = 96449,
  [SMALL_STATE(2725)] = 96459,
  [SMALL_STATE(2726)] = 96469,
  [SMALL_STATE(2727)] = 96479,
  [SMALL_STATE(2728)] = 96487,
  [SMALL_STATE(2729)] = 96497,
  [SMALL_STATE(2730)] = 96507,
  [SMALL_STATE(2731)] = 96517,
  [SMALL_STATE(2732)] = 96527,
  [SMALL_STATE(2733)] = 96537,
  [SMALL_STATE(2734)] = 96547,
  [SMALL_STATE(2735)] = 96555,
  [SMALL_STATE(2736)] = 96565,
  [SMALL_STATE(2737)] = 96573,
  [SMALL_STATE(2738)] = 96583,
  [SMALL_STATE(2739)] = 96593,
  [SMALL_STATE(2740)] = 96603,
  [SMALL_STATE(2741)] = 96613,
  [SMALL_STATE(2742)] = 96623,
  [SMALL_STATE(2743)] = 96633,
  [SMALL_STATE(2744)] = 96641,
  [SMALL_STATE(2745)] = 96651,
  [SMALL_STATE(2746)] = 96659,
  [SMALL_STATE(2747)] = 96669,
  [SMALL_STATE(2748)] = 96679,
  [SMALL_STATE(2749)] = 96689,
  [SMALL_STATE(2750)] = 96699,
  [SMALL_STATE(2751)] = 96709,
  [SMALL_STATE(2752)] = 96719,
  [SMALL_STATE(2753)] = 96729,
  [SMALL_STATE(2754)] = 96737,
  [SMALL_STATE(2755)] = 96747,
  [SMALL_STATE(2756)] = 96757,
  [SMALL_STATE(2757)] = 96767,
  [SMALL_STATE(2758)] = 96775,
  [SMALL_STATE(2759)] = 96785,
  [SMALL_STATE(2760)] = 96795,
  [SMALL_STATE(2761)] = 96803,
  [SMALL_STATE(2762)] = 96813,
  [SMALL_STATE(2763)] = 96823,
  [SMALL_STATE(2764)] = 96833,
  [SMALL_STATE(2765)] = 96843,
  [SMALL_STATE(2766)] = 96853,
  [SMALL_STATE(2767)] = 96863,
  [SMALL_STATE(2768)] = 96873,
  [SMALL_STATE(2769)] = 96883,
  [SMALL_STATE(2770)] = 96891,
  [SMALL_STATE(2771)] = 96901,
  [SMALL_STATE(2772)] = 96909,
  [SMALL_STATE(2773)] = 96917,
  [SMALL_STATE(2774)] = 96925,
  [SMALL_STATE(2775)] = 96935,
  [SMALL_STATE(2776)] = 96945,
  [SMALL_STATE(2777)] = 96955,
  [SMALL_STATE(2778)] = 96965,
  [SMALL_STATE(2779)] = 96975,
  [SMALL_STATE(2780)] = 96985,
  [SMALL_STATE(2781)] = 96993,
  [SMALL_STATE(2782)] = 97000,
  [SMALL_STATE(2783)] = 97007,
  [SMALL_STATE(2784)] = 97014,
  [SMALL_STATE(2785)] = 97021,
  [SMALL_STATE(2786)] = 97028,
  [SMALL_STATE(2787)] = 97035,
  [SMALL_STATE(2788)] = 97042,
  [SMALL_STATE(2789)] = 97049,
  [SMALL_STATE(2790)] = 97056,
  [SMALL_STATE(2791)] = 97063,
  [SMALL_STATE(2792)] = 97070,
  [SMALL_STATE(2793)] = 97077,
  [SMALL_STATE(2794)] = 97084,
  [SMALL_STATE(2795)] = 97091,
  [SMALL_STATE(2796)] = 97098,
  [SMALL_STATE(2797)] = 97105,
  [SMALL_STATE(2798)] = 97112,
  [SMALL_STATE(2799)] = 97119,
  [SMALL_STATE(2800)] = 97126,
  [SMALL_STATE(2801)] = 97133,
  [SMALL_STATE(2802)] = 97140,
  [SMALL_STATE(2803)] = 97147,
  [SMALL_STATE(2804)] = 97154,
  [SMALL_STATE(2805)] = 97161,
  [SMALL_STATE(2806)] = 97168,
  [SMALL_STATE(2807)] = 97175,
  [SMALL_STATE(2808)] = 97182,
  [SMALL_STATE(2809)] = 97189,
  [SMALL_STATE(2810)] = 97196,
  [SMALL_STATE(2811)] = 97203,
  [SMALL_STATE(2812)] = 97210,
  [SMALL_STATE(2813)] = 97217,
  [SMALL_STATE(2814)] = 97224,
  [SMALL_STATE(2815)] = 97231,
  [SMALL_STATE(2816)] = 97238,
  [SMALL_STATE(2817)] = 97245,
  [SMALL_STATE(2818)] = 97252,
  [SMALL_STATE(2819)] = 97259,
  [SMALL_STATE(2820)] = 97266,
  [SMALL_STATE(2821)] = 97273,
  [SMALL_STATE(2822)] = 97280,
  [SMALL_STATE(2823)] = 97287,
  [SMALL_STATE(2824)] = 97294,
  [SMALL_STATE(2825)] = 97301,
  [SMALL_STATE(2826)] = 97308,
  [SMALL_STATE(2827)] = 97315,
  [SMALL_STATE(2828)] = 97322,
  [SMALL_STATE(2829)] = 97329,
  [SMALL_STATE(2830)] = 97336,
  [SMALL_STATE(2831)] = 97343,
  [SMALL_STATE(2832)] = 97350,
  [SMALL_STATE(2833)] = 97357,
  [SMALL_STATE(2834)] = 97364,
  [SMALL_STATE(2835)] = 97371,
  [SMALL_STATE(2836)] = 97378,
  [SMALL_STATE(2837)] = 97385,
  [SMALL_STATE(2838)] = 97392,
  [SMALL_STATE(2839)] = 97399,
  [SMALL_STATE(2840)] = 97406,
  [SMALL_STATE(2841)] = 97413,
  [SMALL_STATE(2842)] = 97420,
  [SMALL_STATE(2843)] = 97427,
  [SMALL_STATE(2844)] = 97434,
  [SMALL_STATE(2845)] = 97441,
  [SMALL_STATE(2846)] = 97448,
  [SMALL_STATE(2847)] = 97455,
  [SMALL_STATE(2848)] = 97462,
  [SMALL_STATE(2849)] = 97469,
  [SMALL_STATE(2850)] = 97476,
  [SMALL_STATE(2851)] = 97483,
  [SMALL_STATE(2852)] = 97490,
  [SMALL_STATE(2853)] = 97497,
  [SMALL_STATE(2854)] = 97504,
  [SMALL_STATE(2855)] = 97511,
  [SMALL_STATE(2856)] = 97518,
  [SMALL_STATE(2857)] = 97525,
  [SMALL_STATE(2858)] = 97532,
  [SMALL_STATE(2859)] = 97539,
  [SMALL_STATE(2860)] = 97546,
  [SMALL_STATE(2861)] = 97553,
  [SMALL_STATE(2862)] = 97560,
  [SMALL_STATE(2863)] = 97567,
  [SMALL_STATE(2864)] = 97574,
  [SMALL_STATE(2865)] = 97581,
  [SMALL_STATE(2866)] = 97588,
  [SMALL_STATE(2867)] = 97595,
  [SMALL_STATE(2868)] = 97602,
  [SMALL_STATE(2869)] = 97609,
  [SMALL_STATE(2870)] = 97616,
  [SMALL_STATE(2871)] = 97623,
  [SMALL_STATE(2872)] = 97630,
  [SMALL_STATE(2873)] = 97637,
  [SMALL_STATE(2874)] = 97644,
  [SMALL_STATE(2875)] = 97651,
  [SMALL_STATE(2876)] = 97658,
  [SMALL_STATE(2877)] = 97665,
  [SMALL_STATE(2878)] = 97672,
  [SMALL_STATE(2879)] = 97679,
  [SMALL_STATE(2880)] = 97686,
  [SMALL_STATE(2881)] = 97693,
  [SMALL_STATE(2882)] = 97700,
  [SMALL_STATE(2883)] = 97707,
  [SMALL_STATE(2884)] = 97714,
  [SMALL_STATE(2885)] = 97721,
  [SMALL_STATE(2886)] = 97728,
  [SMALL_STATE(2887)] = 97735,
  [SMALL_STATE(2888)] = 97742,
  [SMALL_STATE(2889)] = 97749,
  [SMALL_STATE(2890)] = 97756,
  [SMALL_STATE(2891)] = 97763,
  [SMALL_STATE(2892)] = 97770,
  [SMALL_STATE(2893)] = 97777,
  [SMALL_STATE(2894)] = 97784,
  [SMALL_STATE(2895)] = 97791,
  [SMALL_STATE(2896)] = 97798,
  [SMALL_STATE(2897)] = 97805,
  [SMALL_STATE(2898)] = 97812,
  [SMALL_STATE(2899)] = 97819,
  [SMALL_STATE(2900)] = 97826,
  [SMALL_STATE(2901)] = 97833,
  [SMALL_STATE(2902)] = 97840,
  [SMALL_STATE(2903)] = 97847,
  [SMALL_STATE(2904)] = 97854,
  [SMALL_STATE(2905)] = 97861,
  [SMALL_STATE(2906)] = 97868,
  [SMALL_STATE(2907)] = 97875,
  [SMALL_STATE(2908)] = 97882,
  [SMALL_STATE(2909)] = 97889,
  [SMALL_STATE(2910)] = 97896,
  [SMALL_STATE(2911)] = 97903,
  [SMALL_STATE(2912)] = 97910,
  [SMALL_STATE(2913)] = 97917,
  [SMALL_STATE(2914)] = 97924,
  [SMALL_STATE(2915)] = 97931,
  [SMALL_STATE(2916)] = 97938,
  [SMALL_STATE(2917)] = 97945,
  [SMALL_STATE(2918)] = 97952,
  [SMALL_STATE(2919)] = 97959,
  [SMALL_STATE(2920)] = 97966,
  [SMALL_STATE(2921)] = 97973,
  [SMALL_STATE(2922)] = 97980,
  [SMALL_STATE(2923)] = 97987,
  [SMALL_STATE(2924)] = 97994,
  [SMALL_STATE(2925)] = 98001,
  [SMALL_STATE(2926)] = 98008,
  [SMALL_STATE(2927)] = 98015,
  [SMALL_STATE(2928)] = 98022,
  [SMALL_STATE(2929)] = 98029,
  [SMALL_STATE(2930)] = 98036,
  [SMALL_STATE(2931)] = 98043,
  [SMALL_STATE(2932)] = 98050,
  [SMALL_STATE(2933)] = 98057,
  [SMALL_STATE(2934)] = 98064,
  [SMALL_STATE(2935)] = 98071,
  [SMALL_STATE(2936)] = 98078,
  [SMALL_STATE(2937)] = 98085,
  [SMALL_STATE(2938)] = 98092,
  [SMALL_STATE(2939)] = 98099,
  [SMALL_STATE(2940)] = 98106,
  [SMALL_STATE(2941)] = 98113,
  [SMALL_STATE(2942)] = 98120,
  [SMALL_STATE(2943)] = 98127,
  [SMALL_STATE(2944)] = 98134,
  [SMALL_STATE(2945)] = 98141,
  [SMALL_STATE(2946)] = 98148,
  [SMALL_STATE(2947)] = 98155,
  [SMALL_STATE(2948)] = 98162,
  [SMALL_STATE(2949)] = 98169,
  [SMALL_STATE(2950)] = 98176,
  [SMALL_STATE(2951)] = 98183,
  [SMALL_STATE(2952)] = 98190,
  [SMALL_STATE(2953)] = 98197,
  [SMALL_STATE(2954)] = 98204,
  [SMALL_STATE(2955)] = 98211,
  [SMALL_STATE(2956)] = 98218,
  [SMALL_STATE(2957)] = 98225,
  [SMALL_STATE(2958)] = 98232,
  [SMALL_STATE(2959)] = 98239,
  [SMALL_STATE(2960)] = 98246,
  [SMALL_STATE(2961)] = 98253,
  [SMALL_STATE(2962)] = 98260,
  [SMALL_STATE(2963)] = 98267,
  [SMALL_STATE(2964)] = 98274,
  [SMALL_STATE(2965)] = 98281,
  [SMALL_STATE(2966)] = 98288,
  [SMALL_STATE(2967)] = 98295,
  [SMALL_STATE(2968)] = 98302,
  [SMALL_STATE(2969)] = 98309,
  [SMALL_STATE(2970)] = 98316,
  [SMALL_STATE(2971)] = 98323,
  [SMALL_STATE(2972)] = 98330,
  [SMALL_STATE(2973)] = 98337,
  [SMALL_STATE(2974)] = 98344,
  [SMALL_STATE(2975)] = 98351,
  [SMALL_STATE(2976)] = 98358,
  [SMALL_STATE(2977)] = 98365,
  [SMALL_STATE(2978)] = 98372,
  [SMALL_STATE(2979)] = 98379,
  [SMALL_STATE(2980)] = 98386,
  [SMALL_STATE(2981)] = 98393,
  [SMALL_STATE(2982)] = 98400,
  [SMALL_STATE(2983)] = 98407,
  [SMALL_STATE(2984)] = 98414,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(762),
  [9] = {.count = 1, .reusable = true}, SHIFT(16),
  [11] = {.count = 1, .reusable = false}, SHIFT(166),
  [13] = {.count = 1, .reusable = false}, SHIFT(627),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = false}, SHIFT(701),
  [19] = {.count = 1, .reusable = false}, SHIFT(272),
  [21] = {.count = 1, .reusable = false}, SHIFT(903),
  [23] = {.count = 1, .reusable = false}, SHIFT(2072),
  [25] = {.count = 1, .reusable = false}, SHIFT(2014),
  [27] = {.count = 1, .reusable = false}, SHIFT(1940),
  [29] = {.count = 1, .reusable = false}, SHIFT(2585),
  [31] = {.count = 1, .reusable = false}, SHIFT(2586),
  [33] = {.count = 1, .reusable = false}, SHIFT(2399),
  [35] = {.count = 1, .reusable = true}, SHIFT(134),
  [37] = {.count = 1, .reusable = false}, SHIFT(372),
  [39] = {.count = 1, .reusable = false}, SHIFT(2590),
  [41] = {.count = 1, .reusable = false}, SHIFT(31),
  [43] = {.count = 1, .reusable = false}, SHIFT(2591),
  [45] = {.count = 1, .reusable = false}, SHIFT(2593),
  [47] = {.count = 1, .reusable = false}, SHIFT(2402),
  [49] = {.count = 1, .reusable = false}, SHIFT(2403),
  [51] = {.count = 1, .reusable = false}, SHIFT(2596),
  [53] = {.count = 1, .reusable = false}, SHIFT(156),
  [55] = {.count = 1, .reusable = false}, SHIFT(226),
  [57] = {.count = 1, .reusable = true}, SHIFT(517),
  [59] = {.count = 1, .reusable = false}, SHIFT(95),
  [61] = {.count = 1, .reusable = true}, SHIFT(141),
  [63] = {.count = 1, .reusable = true}, SHIFT(706),
  [65] = {.count = 1, .reusable = false}, SHIFT(2962),
  [67] = {.count = 1, .reusable = false}, SHIFT(1887),
  [69] = {.count = 1, .reusable = false}, SHIFT(492),
  [71] = {.count = 1, .reusable = false}, SHIFT(1959),
  [73] = {.count = 1, .reusable = false}, SHIFT(221),
  [75] = {.count = 1, .reusable = false}, SHIFT(266),
  [77] = {.count = 1, .reusable = true}, SHIFT(265),
  [79] = {.count = 1, .reusable = false}, SHIFT(59),
  [81] = {.count = 1, .reusable = true}, SHIFT(260),
  [83] = {.count = 1, .reusable = true}, SHIFT(2308),
  [85] = {.count = 1, .reusable = true}, SHIFT(2309),
  [87] = {.count = 1, .reusable = true}, SHIFT(2031),
  [89] = {.count = 1, .reusable = true}, SHIFT(1224),
  [91] = {.count = 1, .reusable = false}, SHIFT(1224),
  [93] = {.count = 1, .reusable = false}, SHIFT(1048),
  [95] = {.count = 1, .reusable = true}, SHIFT(1812),
  [97] = {.count = 1, .reusable = false}, SHIFT(741),
  [99] = {.count = 1, .reusable = false}, SHIFT(2939),
  [101] = {.count = 1, .reusable = false}, SHIFT(257),
  [103] = {.count = 1, .reusable = false}, SHIFT(633),
  [105] = {.count = 1, .reusable = false}, SHIFT(2934),
  [107] = {.count = 1, .reusable = false}, SHIFT(2928),
  [109] = {.count = 1, .reusable = false}, SHIFT(677),
  [111] = {.count = 1, .reusable = false}, SHIFT(149),
  [113] = {.count = 1, .reusable = true}, SHIFT(1798),
  [115] = {.count = 1, .reusable = false}, SHIFT(618),
  [117] = {.count = 1, .reusable = true}, SHIFT(1346),
  [119] = {.count = 1, .reusable = true}, SHIFT(941),
  [121] = {.count = 1, .reusable = false}, SHIFT(662),
  [123] = {.count = 1, .reusable = true}, SHIFT(136),
  [125] = {.count = 1, .reusable = false}, SHIFT(418),
  [127] = {.count = 1, .reusable = true}, SHIFT(309),
  [129] = {.count = 1, .reusable = false}, SHIFT(51),
  [131] = {.count = 1, .reusable = true}, SHIFT(1435),
  [133] = {.count = 1, .reusable = false}, SHIFT(456),
  [135] = {.count = 1, .reusable = false}, SHIFT(457),
  [137] = {.count = 1, .reusable = false}, SHIFT(161),
  [139] = {.count = 1, .reusable = false}, SHIFT(471),
  [141] = {.count = 1, .reusable = false}, SHIFT(623),
  [143] = {.count = 1, .reusable = false}, SHIFT(674),
  [145] = {.count = 1, .reusable = false}, SHIFT(453),
  [147] = {.count = 1, .reusable = false}, SHIFT(668),
  [149] = {.count = 1, .reusable = false}, SHIFT(153),
  [151] = {.count = 1, .reusable = false}, SHIFT(619),
  [153] = {.count = 1, .reusable = true}, SHIFT(1306),
  [155] = {.count = 1, .reusable = false}, SHIFT(659),
  [157] = {.count = 1, .reusable = false}, SHIFT(417),
  [159] = {.count = 1, .reusable = false}, SHIFT(48),
  [161] = {.count = 1, .reusable = false}, SHIFT(454),
  [163] = {.count = 1, .reusable = false}, SHIFT(450),
  [165] = {.count = 1, .reusable = false}, SHIFT(163),
  [167] = {.count = 1, .reusable = false}, SHIFT(472),
  [169] = {.count = 1, .reusable = false}, SHIFT(617),
  [171] = {.count = 1, .reusable = false}, SHIFT(672),
  [173] = {.count = 1, .reusable = false}, SHIFT(451),
  [175] = {.count = 1, .reusable = false}, SHIFT(681),
  [177] = {.count = 1, .reusable = false}, SHIFT(150),
  [179] = {.count = 1, .reusable = false}, SHIFT(621),
  [181] = {.count = 1, .reusable = true}, SHIFT(105),
  [183] = {.count = 1, .reusable = false}, SHIFT(656),
  [185] = {.count = 1, .reusable = false}, SHIFT(414),
  [187] = {.count = 1, .reusable = false}, SHIFT(49),
  [189] = {.count = 1, .reusable = false}, SHIFT(449),
  [191] = {.count = 1, .reusable = false}, SHIFT(452),
  [193] = {.count = 1, .reusable = false}, SHIFT(164),
  [195] = {.count = 1, .reusable = false}, SHIFT(463),
  [197] = {.count = 1, .reusable = false}, SHIFT(620),
  [199] = {.count = 1, .reusable = false}, SHIFT(665),
  [201] = {.count = 1, .reusable = false}, SHIFT(455),
  [203] = {.count = 1, .reusable = true}, SHIFT(1241),
  [205] = {.count = 1, .reusable = true}, SHIFT(1288),
  [207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(762),
  [212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(166),
  [215] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(627),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(701),
  [226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(272),
  [229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(903),
  [232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2072),
  [235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2014),
  [238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1940),
  [241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2585),
  [244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2586),
  [247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2399),
  [250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(134),
  [253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(372),
  [256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2590),
  [259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2591),
  [265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2593),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2402),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2403),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2596),
  [277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(156),
  [280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(226),
  [283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(517),
  [286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(95),
  [289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(141),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(706),
  [295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2962),
  [298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1887),
  [301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(492),
  [304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1959),
  [307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(221),
  [310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(266),
  [313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(265),
  [316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(260),
  [322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2308),
  [325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2309),
  [328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2031),
  [331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1224),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1224),
  [337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1048),
  [340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1812),
  [343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(741),
  [346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2939),
  [349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(257),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(633),
  [355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2934),
  [358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2928),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [373] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [377] = {.count = 1, .reusable = true}, SHIFT(462),
  [379] = {.count = 1, .reusable = true}, SHIFT(1180),
  [381] = {.count = 1, .reusable = true}, SHIFT(980),
  [383] = {.count = 1, .reusable = true}, SHIFT(974),
  [385] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [387] = {.count = 1, .reusable = true}, SHIFT(473),
  [389] = {.count = 1, .reusable = true}, SHIFT(1764),
  [391] = {.count = 1, .reusable = true}, SHIFT(109),
  [393] = {.count = 1, .reusable = true}, SHIFT(1505),
  [395] = {.count = 1, .reusable = true}, SHIFT(460),
  [397] = {.count = 1, .reusable = true}, SHIFT(465),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [401] = {.count = 1, .reusable = true}, SHIFT(1143),
  [403] = {.count = 1, .reusable = true}, SHIFT(1740),
  [405] = {.count = 1, .reusable = true}, SHIFT(112),
  [407] = {.count = 1, .reusable = true}, SHIFT(1376),
  [409] = {.count = 1, .reusable = false}, SHIFT(796),
  [411] = {.count = 1, .reusable = false}, SHIFT(162),
  [413] = {.count = 1, .reusable = false}, SHIFT(632),
  [415] = {.count = 1, .reusable = true}, SHIFT(5),
  [417] = {.count = 1, .reusable = false}, SHIFT(713),
  [419] = {.count = 1, .reusable = false}, SHIFT(2638),
  [421] = {.count = 1, .reusable = false}, SHIFT(2540),
  [423] = {.count = 1, .reusable = false}, SHIFT(2641),
  [425] = {.count = 1, .reusable = false}, SHIFT(2642),
  [427] = {.count = 1, .reusable = false}, SHIFT(1876),
  [429] = {.count = 1, .reusable = false}, SHIFT(495),
  [431] = {.count = 1, .reusable = false}, SHIFT(1952),
  [433] = {.count = 1, .reusable = false}, SHIFT(58),
  [435] = {.count = 1, .reusable = false}, SHIFT(785),
  [437] = {.count = 1, .reusable = false}, SHIFT(340),
  [439] = {.count = 1, .reusable = false}, SHIFT(629),
  [441] = {.count = 1, .reusable = false}, SHIFT(788),
  [443] = {.count = 1, .reusable = false}, SHIFT(819),
  [445] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [447] = {.count = 1, .reusable = false}, SHIFT(325),
  [449] = {.count = 1, .reusable = false}, SHIFT(631),
  [451] = {.count = 1, .reusable = true}, SHIFT(1140),
  [453] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [455] = {.count = 1, .reusable = true}, SHIFT(1443),
  [457] = {.count = 1, .reusable = false}, SHIFT(1444),
  [459] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(40),
  [462] = {.count = 1, .reusable = false}, SHIFT(706),
  [464] = {.count = 1, .reusable = false}, SHIFT(2890),
  [466] = {.count = 1, .reusable = false}, SHIFT(1891),
  [468] = {.count = 1, .reusable = false}, SHIFT(482),
  [470] = {.count = 1, .reusable = false}, SHIFT(1970),
  [472] = {.count = 1, .reusable = true}, SHIFT(190),
  [474] = {.count = 1, .reusable = true}, SHIFT(324),
  [476] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [479] = {.count = 1, .reusable = false}, SHIFT(265),
  [481] = {.count = 1, .reusable = false}, SHIFT(57),
  [483] = {.count = 1, .reusable = true}, SHIFT(1138),
  [485] = {.count = 1, .reusable = false}, SHIFT(1138),
  [487] = {.count = 1, .reusable = true}, SHIFT(1053),
  [489] = {.count = 1, .reusable = false}, SHIFT(873),
  [491] = {.count = 1, .reusable = false}, SHIFT(862),
  [493] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [495] = {.count = 1, .reusable = false}, SHIFT(285),
  [497] = {.count = 1, .reusable = false}, SHIFT(650),
  [499] = {.count = 1, .reusable = true}, SHIFT(1235),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [503] = {.count = 1, .reusable = false}, SHIFT(269),
  [505] = {.count = 1, .reusable = false}, SHIFT(1055),
  [507] = {.count = 1, .reusable = false}, SHIFT(287),
  [509] = {.count = 1, .reusable = false}, SHIFT(99),
  [511] = {.count = 1, .reusable = false}, SHIFT(2981),
  [513] = {.count = 1, .reusable = false}, SHIFT(1877),
  [515] = {.count = 1, .reusable = false}, SHIFT(577),
  [517] = {.count = 1, .reusable = false}, SHIFT(1961),
  [519] = {.count = 1, .reusable = true}, SHIFT(244),
  [521] = {.count = 1, .reusable = false}, SHIFT(175),
  [523] = {.count = 1, .reusable = true}, SHIFT(274),
  [525] = {.count = 1, .reusable = true}, SHIFT(352),
  [527] = {.count = 1, .reusable = false}, SHIFT(78),
  [529] = {.count = 1, .reusable = true}, SHIFT(2382),
  [531] = {.count = 1, .reusable = true}, SHIFT(2381),
  [533] = {.count = 1, .reusable = true}, SHIFT(1256),
  [535] = {.count = 1, .reusable = false}, SHIFT(1256),
  [537] = {.count = 1, .reusable = false}, SHIFT(930),
  [539] = {.count = 1, .reusable = true}, SHIFT(943),
  [541] = {.count = 1, .reusable = false}, SHIFT(685),
  [543] = {.count = 1, .reusable = false}, SHIFT(684),
  [545] = {.count = 1, .reusable = false}, SHIFT(259),
  [547] = {.count = 1, .reusable = false}, SHIFT(625),
  [549] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [552] = {.count = 1, .reusable = false}, SHIFT(335),
  [554] = {.count = 1, .reusable = true}, SHIFT(132),
  [556] = {.count = 1, .reusable = false}, SHIFT(336),
  [558] = {.count = 1, .reusable = false}, SHIFT(90),
  [560] = {.count = 1, .reusable = true}, SHIFT(148),
  [562] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [565] = {.count = 1, .reusable = false}, SHIFT(2905),
  [567] = {.count = 1, .reusable = false}, SHIFT(476),
  [569] = {.count = 1, .reusable = false}, SHIFT(173),
  [571] = {.count = 1, .reusable = true}, SHIFT(262),
  [573] = {.count = 1, .reusable = false}, SHIFT(288),
  [575] = {.count = 1, .reusable = false}, SHIFT(286),
  [577] = {.count = 1, .reusable = true}, SHIFT(286),
  [579] = {.count = 1, .reusable = false}, SHIFT(55),
  [581] = {.count = 1, .reusable = true}, SHIFT(281),
  [583] = {.count = 1, .reusable = true}, SHIFT(2073),
  [585] = {.count = 1, .reusable = true}, SHIFT(988),
  [587] = {.count = 1, .reusable = false}, SHIFT(988),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [591] = {.count = 1, .reusable = false}, SHIFT(313),
  [593] = {.count = 1, .reusable = true}, SHIFT(34),
  [595] = {.count = 1, .reusable = true}, SHIFT(40),
  [597] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(176),
  [600] = {.count = 1, .reusable = false}, SHIFT(176),
  [602] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(259),
  [605] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [608] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [611] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [613] = {.count = 1, .reusable = true}, SHIFT(245),
  [615] = {.count = 1, .reusable = false}, SHIFT(867),
  [617] = {.count = 1, .reusable = false}, SHIFT(880),
  [619] = {.count = 1, .reusable = false}, SHIFT(333),
  [621] = {.count = 1, .reusable = false}, SHIFT(648),
  [623] = {.count = 1, .reusable = false}, SHIFT(391),
  [625] = {.count = 1, .reusable = false}, SHIFT(396),
  [627] = {.count = 1, .reusable = false}, SHIFT(102),
  [629] = {.count = 1, .reusable = false}, SHIFT(553),
  [631] = {.count = 1, .reusable = true}, SHIFT(218),
  [633] = {.count = 1, .reusable = false}, SHIFT(211),
  [635] = {.count = 1, .reusable = true}, SHIFT(334),
  [637] = {.count = 1, .reusable = false}, SHIFT(400),
  [639] = {.count = 1, .reusable = false}, SHIFT(410),
  [641] = {.count = 1, .reusable = true}, SHIFT(410),
  [643] = {.count = 1, .reusable = false}, SHIFT(77),
  [645] = {.count = 1, .reusable = true}, SHIFT(409),
  [647] = {.count = 1, .reusable = true}, SHIFT(1254),
  [649] = {.count = 1, .reusable = false}, SHIFT(1254),
  [651] = {.count = 1, .reusable = true}, SHIFT(197),
  [653] = {.count = 1, .reusable = false}, SHIFT(331),
  [655] = {.count = 1, .reusable = false}, SHIFT(352),
  [657] = {.count = 1, .reusable = true}, SHIFT(412),
  [659] = {.count = 1, .reusable = true}, SHIFT(1988),
  [661] = {.count = 1, .reusable = false}, SHIFT(2875),
  [663] = {.count = 1, .reusable = true}, SHIFT(213),
  [665] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [669] = {.count = 1, .reusable = false}, SHIFT(832),
  [671] = {.count = 1, .reusable = false}, SHIFT(855),
  [673] = {.count = 1, .reusable = false}, SHIFT(401),
  [675] = {.count = 1, .reusable = false}, SHIFT(641),
  [677] = {.count = 1, .reusable = false}, SHIFT(1168),
  [679] = {.count = 1, .reusable = false}, SHIFT(293),
  [681] = {.count = 1, .reusable = false}, SHIFT(1625),
  [683] = {.count = 1, .reusable = true}, SHIFT(133),
  [685] = {.count = 1, .reusable = false}, SHIFT(290),
  [687] = {.count = 1, .reusable = false}, SHIFT(101),
  [689] = {.count = 1, .reusable = true}, SHIFT(146),
  [691] = {.count = 1, .reusable = false}, SHIFT(2888),
  [693] = {.count = 1, .reusable = false}, SHIFT(1867),
  [695] = {.count = 1, .reusable = false}, SHIFT(518),
  [697] = {.count = 1, .reusable = false}, SHIFT(2004),
  [699] = {.count = 1, .reusable = false}, SHIFT(189),
  [701] = {.count = 1, .reusable = true}, SHIFT(399),
  [703] = {.count = 1, .reusable = false}, SHIFT(345),
  [705] = {.count = 1, .reusable = false}, SHIFT(354),
  [707] = {.count = 1, .reusable = true}, SHIFT(354),
  [709] = {.count = 1, .reusable = false}, SHIFT(75),
  [711] = {.count = 1, .reusable = true}, SHIFT(355),
  [713] = {.count = 1, .reusable = true}, SHIFT(2364),
  [715] = {.count = 1, .reusable = true}, SHIFT(2363),
  [717] = {.count = 1, .reusable = true}, SHIFT(2027),
  [719] = {.count = 1, .reusable = true}, SHIFT(1221),
  [721] = {.count = 1, .reusable = false}, SHIFT(1221),
  [723] = {.count = 1, .reusable = false}, SHIFT(1226),
  [725] = {.count = 1, .reusable = false}, SHIFT(859),
  [727] = {.count = 1, .reusable = false}, SHIFT(843),
  [729] = {.count = 1, .reusable = false}, SHIFT(397),
  [731] = {.count = 1, .reusable = false}, SHIFT(639),
  [733] = {.count = 1, .reusable = false}, SHIFT(348),
  [735] = {.count = 1, .reusable = false}, SHIFT(360),
  [737] = {.count = 1, .reusable = false}, SHIFT(100),
  [739] = {.count = 1, .reusable = false}, SHIFT(2817),
  [741] = {.count = 1, .reusable = false}, SHIFT(520),
  [743] = {.count = 1, .reusable = false}, SHIFT(178),
  [745] = {.count = 1, .reusable = true}, SHIFT(411),
  [747] = {.count = 1, .reusable = false}, SHIFT(255),
  [749] = {.count = 1, .reusable = false}, SHIFT(253),
  [751] = {.count = 1, .reusable = true}, SHIFT(253),
  [753] = {.count = 1, .reusable = false}, SHIFT(73),
  [755] = {.count = 1, .reusable = true}, SHIFT(252),
  [757] = {.count = 1, .reusable = true}, SHIFT(1203),
  [759] = {.count = 1, .reusable = false}, SHIFT(1203),
  [761] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(207),
  [764] = {.count = 1, .reusable = false}, SHIFT(207),
  [766] = {.count = 1, .reusable = false}, SHIFT(700),
  [768] = {.count = 1, .reusable = false}, SHIFT(842),
  [770] = {.count = 1, .reusable = true}, SHIFT(445),
  [772] = {.count = 1, .reusable = false}, SHIFT(643),
  [774] = {.count = 1, .reusable = false}, SHIFT(638),
  [776] = {.count = 1, .reusable = false}, SHIFT(186),
  [778] = {.count = 1, .reusable = true}, SHIFT(82),
  [780] = {.count = 1, .reusable = true}, SHIFT(2451),
  [782] = {.count = 1, .reusable = true}, SHIFT(88),
  [784] = {.count = 1, .reusable = false}, SHIFT(513),
  [786] = {.count = 1, .reusable = false}, SHIFT(217),
  [788] = {.count = 1, .reusable = true}, SHIFT(2844),
  [790] = {.count = 1, .reusable = true}, SHIFT(1134),
  [792] = {.count = 1, .reusable = true}, SHIFT(803),
  [794] = {.count = 1, .reusable = true}, SHIFT(818),
  [796] = {.count = 1, .reusable = false}, SHIFT(307),
  [798] = {.count = 1, .reusable = false}, SHIFT(69),
  [800] = {.count = 1, .reusable = true}, SHIFT(1560),
  [802] = {.count = 1, .reusable = false}, SHIFT(1504),
  [804] = {.count = 1, .reusable = false}, SHIFT(1560),
  [806] = {.count = 1, .reusable = false}, SHIFT(1025),
  [808] = {.count = 1, .reusable = false}, SHIFT(605),
  [810] = {.count = 1, .reusable = false}, SHIFT(848),
  [812] = {.count = 1, .reusable = false}, SHIFT(523),
  [814] = {.count = 1, .reusable = false}, SHIFT(2471),
  [816] = {.count = 1, .reusable = true}, SHIFT(894),
  [818] = {.count = 1, .reusable = false}, SHIFT(1029),
  [820] = {.count = 1, .reusable = false}, SHIFT(1115),
  [822] = {.count = 1, .reusable = false}, SHIFT(789),
  [824] = {.count = 1, .reusable = false}, SHIFT(647),
  [826] = {.count = 1, .reusable = true}, SHIFT(139),
  [828] = {.count = 1, .reusable = false}, SHIFT(214),
  [830] = {.count = 1, .reusable = true}, SHIFT(1463),
  [832] = {.count = 1, .reusable = false}, SHIFT(308),
  [834] = {.count = 1, .reusable = false}, SHIFT(76),
  [836] = {.count = 1, .reusable = true}, SHIFT(1645),
  [838] = {.count = 1, .reusable = false}, SHIFT(1648),
  [840] = {.count = 1, .reusable = false}, SHIFT(1645),
  [842] = {.count = 1, .reusable = false}, SHIFT(1171),
  [844] = {.count = 1, .reusable = false}, SHIFT(870),
  [846] = {.count = 1, .reusable = true}, SHIFT(2251),
  [848] = {.count = 1, .reusable = false}, SHIFT(1149),
  [850] = {.count = 1, .reusable = true}, SHIFT(947),
  [852] = {.count = 1, .reusable = false}, SHIFT(1219),
  [854] = {.count = 1, .reusable = true}, SHIFT(1081),
  [856] = {.count = 1, .reusable = false}, SHIFT(1178),
  [858] = {.count = 1, .reusable = false}, SHIFT(321),
  [860] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [862] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [864] = {.count = 1, .reusable = true}, SHIFT(986),
  [866] = {.count = 1, .reusable = false}, SHIFT(986),
  [868] = {.count = 1, .reusable = false}, SHIFT(702),
  [870] = {.count = 1, .reusable = false}, SHIFT(640),
  [872] = {.count = 1, .reusable = false}, SHIFT(238),
  [874] = {.count = 1, .reusable = true}, SHIFT(81),
  [876] = {.count = 1, .reusable = true}, SHIFT(89),
  [878] = {.count = 1, .reusable = false}, SHIFT(239),
  [880] = {.count = 1, .reusable = false}, SHIFT(264),
  [882] = {.count = 1, .reusable = false}, SHIFT(64),
  [884] = {.count = 1, .reusable = true}, SHIFT(1563),
  [886] = {.count = 1, .reusable = false}, SHIFT(1561),
  [888] = {.count = 1, .reusable = false}, SHIFT(1563),
  [890] = {.count = 1, .reusable = false}, SHIFT(1354),
  [892] = {.count = 1, .reusable = false}, SHIFT(833),
  [894] = {.count = 1, .reusable = false}, SHIFT(683),
  [896] = {.count = 1, .reusable = false}, SHIFT(636),
  [898] = {.count = 1, .reusable = false}, SHIFT(188),
  [900] = {.count = 1, .reusable = false}, SHIFT(191),
  [902] = {.count = 1, .reusable = false}, SHIFT(317),
  [904] = {.count = 1, .reusable = false}, SHIFT(74),
  [906] = {.count = 1, .reusable = true}, SHIFT(1072),
  [908] = {.count = 1, .reusable = false}, SHIFT(1070),
  [910] = {.count = 1, .reusable = false}, SHIFT(1072),
  [912] = {.count = 1, .reusable = false}, SHIFT(1182),
  [914] = {.count = 1, .reusable = false}, SHIFT(856),
  [916] = {.count = 1, .reusable = false}, SHIFT(712),
  [918] = {.count = 1, .reusable = false}, SHIFT(199),
  [920] = {.count = 1, .reusable = false}, SHIFT(195),
  [922] = {.count = 1, .reusable = false}, SHIFT(408),
  [924] = {.count = 1, .reusable = false}, SHIFT(65),
  [926] = {.count = 1, .reusable = true}, SHIFT(1591),
  [928] = {.count = 1, .reusable = false}, SHIFT(1619),
  [930] = {.count = 1, .reusable = false}, SHIFT(1591),
  [932] = {.count = 1, .reusable = false}, SHIFT(1268),
  [934] = {.count = 1, .reusable = false}, SHIFT(854),
  [936] = {.count = 1, .reusable = false}, SHIFT(693),
  [938] = {.count = 1, .reusable = false}, SHIFT(642),
  [940] = {.count = 1, .reusable = false}, SHIFT(192),
  [942] = {.count = 1, .reusable = true}, SHIFT(83),
  [944] = {.count = 1, .reusable = true}, SHIFT(85),
  [946] = {.count = 1, .reusable = false}, SHIFT(182),
  [948] = {.count = 1, .reusable = false}, SHIFT(332),
  [950] = {.count = 1, .reusable = false}, SHIFT(71),
  [952] = {.count = 1, .reusable = true}, SHIFT(1565),
  [954] = {.count = 1, .reusable = false}, SHIFT(1522),
  [956] = {.count = 1, .reusable = false}, SHIFT(1565),
  [958] = {.count = 1, .reusable = false}, SHIFT(1154),
  [960] = {.count = 1, .reusable = false}, SHIFT(841),
  [962] = {.count = 1, .reusable = false}, SHIFT(249),
  [964] = {.count = 1, .reusable = true}, SHIFT(1074),
  [966] = {.count = 1, .reusable = false}, SHIFT(1074),
  [968] = {.count = 1, .reusable = false}, SHIFT(658),
  [970] = {.count = 1, .reusable = true}, SHIFT(1875),
  [972] = {.count = 1, .reusable = false}, SHIFT(637),
  [974] = {.count = 1, .reusable = false}, SHIFT(168),
  [976] = {.count = 1, .reusable = true}, SHIFT(84),
  [978] = {.count = 1, .reusable = true}, SHIFT(87),
  [980] = {.count = 1, .reusable = false}, SHIFT(170),
  [982] = {.count = 1, .reusable = true}, SHIFT(1039),
  [984] = {.count = 1, .reusable = true}, SHIFT(733),
  [986] = {.count = 1, .reusable = true}, SHIFT(734),
  [988] = {.count = 1, .reusable = false}, SHIFT(384),
  [990] = {.count = 1, .reusable = false}, SHIFT(54),
  [992] = {.count = 1, .reusable = true}, SHIFT(1313),
  [994] = {.count = 1, .reusable = false}, SHIFT(1300),
  [996] = {.count = 1, .reusable = false}, SHIFT(1313),
  [998] = {.count = 1, .reusable = false}, SHIFT(1315),
  [1000] = {.count = 1, .reusable = false}, SHIFT(688),
  [1002] = {.count = 1, .reusable = false}, SHIFT(2491),
  [1004] = {.count = 1, .reusable = true}, SHIFT(896),
  [1006] = {.count = 1, .reusable = false}, SHIFT(667),
  [1008] = {.count = 1, .reusable = false}, SHIFT(198),
  [1010] = {.count = 1, .reusable = false}, SHIFT(240),
  [1012] = {.count = 1, .reusable = false}, SHIFT(369),
  [1014] = {.count = 1, .reusable = false}, SHIFT(56),
  [1016] = {.count = 1, .reusable = true}, SHIFT(1465),
  [1018] = {.count = 1, .reusable = false}, SHIFT(1466),
  [1020] = {.count = 1, .reusable = false}, SHIFT(1465),
  [1022] = {.count = 1, .reusable = false}, SHIFT(1065),
  [1024] = {.count = 1, .reusable = false}, SHIFT(761),
  [1026] = {.count = 1, .reusable = false}, SHIFT(664),
  [1028] = {.count = 1, .reusable = false}, SHIFT(220),
  [1030] = {.count = 1, .reusable = false}, SHIFT(250),
  [1032] = {.count = 1, .reusable = false}, SHIFT(52),
  [1034] = {.count = 1, .reusable = false}, SHIFT(957),
  [1036] = {.count = 1, .reusable = false}, SHIFT(697),
  [1038] = {.count = 1, .reusable = false}, SHIFT(318),
  [1040] = {.count = 1, .reusable = true}, SHIFT(1261),
  [1042] = {.count = 1, .reusable = false}, SHIFT(1261),
  [1044] = {.count = 1, .reusable = false}, SHIFT(368),
  [1046] = {.count = 1, .reusable = true}, SHIFT(1201),
  [1048] = {.count = 1, .reusable = false}, SHIFT(1201),
  [1050] = {.count = 1, .reusable = false}, SHIFT(413),
  [1052] = {.count = 1, .reusable = true}, SHIFT(1218),
  [1054] = {.count = 1, .reusable = false}, SHIFT(1218),
  [1056] = {.count = 1, .reusable = false}, SHIFT(326),
  [1058] = {.count = 1, .reusable = true}, SHIFT(1275),
  [1060] = {.count = 1, .reusable = false}, SHIFT(1275),
  [1062] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1064] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1066] = {.count = 1, .reusable = true}, SHIFT(26),
  [1068] = {.count = 1, .reusable = false}, SHIFT(2864),
  [1070] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1072] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1074] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1076] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1078] = {.count = 1, .reusable = true}, SHIFT(474),
  [1080] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1082] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1084] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1086] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1088] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 127),
  [1090] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 127),
  [1092] = {.count = 1, .reusable = true}, SHIFT(563),
  [1094] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1096] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1098] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1100] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1102] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1104] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1106] = {.count = 1, .reusable = true}, SHIFT(118),
  [1108] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1110] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1112] = {.count = 1, .reusable = true}, SHIFT(111),
  [1114] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1116] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1118] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 49),
  [1120] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 49),
  [1122] = {.count = 1, .reusable = true}, SHIFT(586),
  [1124] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1126] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1128] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 101),
  [1130] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 101),
  [1132] = {.count = 1, .reusable = true}, SHIFT(533),
  [1134] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 27),
  [1136] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 27),
  [1138] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1140] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1142] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 119),
  [1144] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 119),
  [1146] = {.count = 1, .reusable = true}, SHIFT(550),
  [1148] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1150] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1152] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 150),
  [1154] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 150),
  [1156] = {.count = 1, .reusable = true}, SHIFT(556),
  [1158] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1160] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1162] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1164] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1166] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1168] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1170] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1172] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1174] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1176] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1178] = {.count = 1, .reusable = true}, SHIFT(561),
  [1180] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1182] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1184] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 122),
  [1186] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 122),
  [1188] = {.count = 1, .reusable = true}, SHIFT(551),
  [1190] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1192] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1194] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 98),
  [1196] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 98),
  [1198] = {.count = 1, .reusable = true}, SHIFT(583),
  [1200] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1202] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1204] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1206] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1208] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1210] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1212] = {.count = 1, .reusable = true}, SHIFT(552),
  [1214] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1216] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1218] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 91),
  [1220] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 91),
  [1222] = {.count = 1, .reusable = true}, SHIFT(549),
  [1224] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1226] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1228] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1230] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1232] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 128),
  [1234] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 128),
  [1236] = {.count = 1, .reusable = true}, SHIFT(566),
  [1238] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1240] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1242] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 90),
  [1244] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 90),
  [1246] = {.count = 1, .reusable = true}, SHIFT(571),
  [1248] = {.count = 1, .reusable = false}, SHIFT(820),
  [1250] = {.count = 1, .reusable = false}, SHIFT(822),
  [1252] = {.count = 1, .reusable = false}, SHIFT(630),
  [1254] = {.count = 1, .reusable = false}, SHIFT(201),
  [1256] = {.count = 1, .reusable = false}, SHIFT(200),
  [1258] = {.count = 1, .reusable = false}, SHIFT(490),
  [1260] = {.count = 1, .reusable = false}, SHIFT(60),
  [1262] = {.count = 1, .reusable = false}, SHIFT(858),
  [1264] = {.count = 1, .reusable = false}, SHIFT(61),
  [1266] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1268] = {.count = 1, .reusable = false}, SHIFT(1467),
  [1270] = {.count = 1, .reusable = true}, SHIFT(1115),
  [1272] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1274] = {.count = 1, .reusable = false}, SHIFT(853),
  [1276] = {.count = 1, .reusable = false}, SHIFT(852),
  [1278] = {.count = 1, .reusable = false}, SHIFT(634),
  [1280] = {.count = 1, .reusable = false}, SHIFT(522),
  [1282] = {.count = 1, .reusable = false}, SHIFT(66),
  [1284] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1286] = {.count = 1, .reusable = false}, SHIFT(1211),
  [1288] = {.count = 1, .reusable = true}, SHIFT(1200),
  [1290] = {.count = 1, .reusable = false}, SHIFT(1200),
  [1292] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1294] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1296] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1298] = {.count = 1, .reusable = true}, SHIFT(1206),
  [1300] = {.count = 1, .reusable = false}, SHIFT(1206),
  [1302] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1304] = {.count = 1, .reusable = false}, SHIFT(1181),
  [1306] = {.count = 1, .reusable = true}, SHIFT(1088),
  [1308] = {.count = 1, .reusable = true}, SHIFT(1217),
  [1310] = {.count = 1, .reusable = false}, SHIFT(1217),
  [1312] = {.count = 1, .reusable = true}, SHIFT(1178),
  [1314] = {.count = 1, .reusable = true}, SHIFT(2248),
  [1316] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1318] = {.count = 1, .reusable = false}, SHIFT(1204),
  [1320] = {.count = 1, .reusable = true}, SHIFT(1723),
  [1322] = {.count = 1, .reusable = true}, SHIFT(1208),
  [1324] = {.count = 1, .reusable = false}, SHIFT(1208),
  [1326] = {.count = 1, .reusable = true}, SHIFT(1403),
  [1328] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1330] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1332] = {.count = 1, .reusable = true}, SHIFT(1149),
  [1334] = {.count = 1, .reusable = true}, SHIFT(1171),
  [1336] = {.count = 1, .reusable = true}, SHIFT(1555),
  [1338] = {.count = 1, .reusable = true}, SHIFT(1164),
  [1340] = {.count = 1, .reusable = false}, SHIFT(1164),
  [1342] = {.count = 1, .reusable = true}, SHIFT(1219),
  [1344] = {.count = 1, .reusable = false}, SHIFT(2647),
  [1346] = {.count = 1, .reusable = true}, SHIFT(365),
  [1348] = {.count = 1, .reusable = false}, SHIFT(319),
  [1350] = {.count = 1, .reusable = false}, SHIFT(2902),
  [1352] = {.count = 1, .reusable = true}, SHIFT(2061),
  [1354] = {.count = 1, .reusable = true}, SHIFT(2062),
  [1356] = {.count = 1, .reusable = true}, SHIFT(2895),
  [1358] = {.count = 1, .reusable = true}, SHIFT(2894),
  [1360] = {.count = 1, .reusable = true}, SHIFT(2072),
  [1362] = {.count = 1, .reusable = true}, SHIFT(2014),
  [1364] = {.count = 1, .reusable = true}, SHIFT(1940),
  [1366] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1369] = {.count = 1, .reusable = true}, SHIFT(2890),
  [1371] = {.count = 1, .reusable = true}, SHIFT(2889),
  [1373] = {.count = 1, .reusable = true}, SHIFT(2782),
  [1375] = {.count = 1, .reusable = true}, SHIFT(2663),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2939),
  [1379] = {.count = 1, .reusable = true}, SHIFT(1712),
  [1381] = {.count = 1, .reusable = true}, SHIFT(2066),
  [1383] = {.count = 1, .reusable = true}, SHIFT(2934),
  [1385] = {.count = 1, .reusable = true}, SHIFT(2928),
  [1387] = {.count = 1, .reusable = false}, SHIFT(727),
  [1389] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1391] = {.count = 1, .reusable = true}, SHIFT(1239),
  [1393] = {.count = 1, .reusable = false}, SHIFT(1239),
  [1395] = {.count = 1, .reusable = false}, SHIFT(705),
  [1397] = {.count = 1, .reusable = true}, SHIFT(1114),
  [1399] = {.count = 1, .reusable = false}, SHIFT(1114),
  [1401] = {.count = 1, .reusable = true}, SHIFT(548),
  [1403] = {.count = 1, .reusable = true}, SHIFT(1222),
  [1405] = {.count = 1, .reusable = false}, SHIFT(1222),
  [1407] = {.count = 1, .reusable = false}, SHIFT(714),
  [1409] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1411] = {.count = 1, .reusable = false}, SHIFT(1010),
  [1413] = {.count = 1, .reusable = false}, SHIFT(893),
  [1415] = {.count = 1, .reusable = false}, SHIFT(886),
  [1417] = {.count = 1, .reusable = false}, SHIFT(663),
  [1419] = {.count = 1, .reusable = false}, SHIFT(267),
  [1421] = {.count = 1, .reusable = false}, SHIFT(606),
  [1423] = {.count = 1, .reusable = false}, SHIFT(79),
  [1425] = {.count = 1, .reusable = true}, SHIFT(1527),
  [1427] = {.count = 1, .reusable = false}, SHIFT(1527),
  [1429] = {.count = 1, .reusable = false}, SHIFT(807),
  [1431] = {.count = 1, .reusable = true}, SHIFT(1232),
  [1433] = {.count = 1, .reusable = false}, SHIFT(1232),
  [1435] = {.count = 1, .reusable = true}, SHIFT(33),
  [1437] = {.count = 1, .reusable = true}, SHIFT(1281),
  [1439] = {.count = 1, .reusable = false}, SHIFT(1281),
  [1441] = {.count = 1, .reusable = true}, SHIFT(1965),
  [1443] = {.count = 1, .reusable = true}, SHIFT(2724),
  [1445] = {.count = 1, .reusable = false}, SHIFT(364),
  [1447] = {.count = 1, .reusable = true}, SHIFT(1713),
  [1449] = {.count = 1, .reusable = true}, SHIFT(45),
  [1451] = {.count = 1, .reusable = true}, SHIFT(1263),
  [1453] = {.count = 1, .reusable = false}, SHIFT(1263),
  [1455] = {.count = 1, .reusable = true}, SHIFT(3),
  [1457] = {.count = 1, .reusable = true}, SHIFT(1155),
  [1459] = {.count = 1, .reusable = false}, SHIFT(1155),
  [1461] = {.count = 1, .reusable = false}, SHIFT(709),
  [1463] = {.count = 1, .reusable = true}, SHIFT(1359),
  [1465] = {.count = 1, .reusable = false}, SHIFT(1359),
  [1467] = {.count = 1, .reusable = false}, SHIFT(680),
  [1469] = {.count = 1, .reusable = false}, SHIFT(673),
  [1471] = {.count = 1, .reusable = false}, SHIFT(622),
  [1473] = {.count = 1, .reusable = false}, SHIFT(2816),
  [1475] = {.count = 1, .reusable = false}, SHIFT(461),
  [1477] = {.count = 1, .reusable = false}, SHIFT(50),
  [1479] = {.count = 1, .reusable = true}, SHIFT(984),
  [1481] = {.count = 1, .reusable = false}, SHIFT(984),
  [1483] = {.count = 1, .reusable = true}, SHIFT(2),
  [1485] = {.count = 1, .reusable = true}, SHIFT(1339),
  [1487] = {.count = 1, .reusable = false}, SHIFT(1339),
  [1489] = {.count = 1, .reusable = true}, SHIFT(1373),
  [1491] = {.count = 1, .reusable = false}, SHIFT(1373),
  [1493] = {.count = 1, .reusable = true}, SHIFT(1259),
  [1495] = {.count = 1, .reusable = false}, SHIFT(1259),
  [1497] = {.count = 1, .reusable = false}, SHIFT(830),
  [1499] = {.count = 1, .reusable = false}, SHIFT(849),
  [1501] = {.count = 1, .reusable = false}, SHIFT(644),
  [1503] = {.count = 1, .reusable = false}, SHIFT(511),
  [1505] = {.count = 1, .reusable = false}, SHIFT(68),
  [1507] = {.count = 1, .reusable = true}, SHIFT(1260),
  [1509] = {.count = 1, .reusable = false}, SHIFT(1260),
  [1511] = {.count = 1, .reusable = true}, SHIFT(1262),
  [1513] = {.count = 1, .reusable = false}, SHIFT(1262),
  [1515] = {.count = 1, .reusable = false}, SHIFT(812),
  [1517] = {.count = 1, .reusable = false}, SHIFT(780),
  [1519] = {.count = 1, .reusable = false}, SHIFT(626),
  [1521] = {.count = 1, .reusable = false}, SHIFT(493),
  [1523] = {.count = 1, .reusable = false}, SHIFT(63),
  [1525] = {.count = 1, .reusable = true}, SHIFT(1265),
  [1527] = {.count = 1, .reusable = false}, SHIFT(1265),
  [1529] = {.count = 1, .reusable = true}, SHIFT(1269),
  [1531] = {.count = 1, .reusable = false}, SHIFT(1269),
  [1533] = {.count = 1, .reusable = true}, SHIFT(1335),
  [1535] = {.count = 1, .reusable = false}, SHIFT(1335),
  [1537] = {.count = 1, .reusable = false}, SHIFT(742),
  [1539] = {.count = 1, .reusable = false}, SHIFT(735),
  [1541] = {.count = 1, .reusable = false}, SHIFT(628),
  [1543] = {.count = 1, .reusable = false}, SHIFT(2972),
  [1545] = {.count = 1, .reusable = false}, SHIFT(489),
  [1547] = {.count = 1, .reusable = false}, SHIFT(67),
  [1549] = {.count = 1, .reusable = true}, SHIFT(1415),
  [1551] = {.count = 1, .reusable = false}, SHIFT(1415),
  [1553] = {.count = 1, .reusable = false}, SHIFT(1564),
  [1555] = {.count = 1, .reusable = true}, SHIFT(1333),
  [1557] = {.count = 1, .reusable = false}, SHIFT(1333),
  [1559] = {.count = 1, .reusable = true}, SHIFT(1332),
  [1561] = {.count = 1, .reusable = false}, SHIFT(1332),
  [1563] = {.count = 1, .reusable = false}, SHIFT(882),
  [1565] = {.count = 1, .reusable = false}, SHIFT(869),
  [1567] = {.count = 1, .reusable = false}, SHIFT(649),
  [1569] = {.count = 1, .reusable = false}, SHIFT(534),
  [1571] = {.count = 1, .reusable = false}, SHIFT(72),
  [1573] = {.count = 1, .reusable = true}, SHIFT(1487),
  [1575] = {.count = 1, .reusable = false}, SHIFT(1487),
  [1577] = {.count = 1, .reusable = false}, SHIFT(839),
  [1579] = {.count = 1, .reusable = true}, SHIFT(1331),
  [1581] = {.count = 1, .reusable = false}, SHIFT(1331),
  [1583] = {.count = 1, .reusable = false}, SHIFT(834),
  [1585] = {.count = 1, .reusable = true}, SHIFT(6),
  [1587] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1589] = {.count = 1, .reusable = false}, SHIFT(1050),
  [1591] = {.count = 1, .reusable = false}, SHIFT(831),
  [1593] = {.count = 1, .reusable = true}, SHIFT(1166),
  [1595] = {.count = 1, .reusable = false}, SHIFT(1166),
  [1597] = {.count = 1, .reusable = true}, SHIFT(1165),
  [1599] = {.count = 1, .reusable = false}, SHIFT(1165),
  [1601] = {.count = 1, .reusable = true}, SHIFT(1163),
  [1603] = {.count = 1, .reusable = false}, SHIFT(1163),
  [1605] = {.count = 1, .reusable = true}, SHIFT(1342),
  [1607] = {.count = 1, .reusable = false}, SHIFT(1342),
  [1609] = {.count = 1, .reusable = false}, SHIFT(816),
  [1611] = {.count = 1, .reusable = false}, SHIFT(840),
  [1613] = {.count = 1, .reusable = false}, SHIFT(657),
  [1615] = {.count = 1, .reusable = false}, SHIFT(891),
  [1617] = {.count = 1, .reusable = false}, SHIFT(652),
  [1619] = {.count = 1, .reusable = false}, SHIFT(603),
  [1621] = {.count = 1, .reusable = false}, SHIFT(80),
  [1623] = {.count = 1, .reusable = true}, SHIFT(1237),
  [1625] = {.count = 1, .reusable = false}, SHIFT(1237),
  [1627] = {.count = 1, .reusable = true}, SHIFT(1238),
  [1629] = {.count = 1, .reusable = false}, SHIFT(1238),
  [1631] = {.count = 1, .reusable = true}, SHIFT(1144),
  [1633] = {.count = 1, .reusable = false}, SHIFT(1144),
  [1635] = {.count = 1, .reusable = true}, SHIFT(1242),
  [1637] = {.count = 1, .reusable = false}, SHIFT(1242),
  [1639] = {.count = 1, .reusable = true}, SHIFT(1122),
  [1641] = {.count = 1, .reusable = false}, SHIFT(1122),
  [1643] = {.count = 1, .reusable = true}, SHIFT(1347),
  [1645] = {.count = 1, .reusable = false}, SHIFT(1347),
  [1647] = {.count = 1, .reusable = true}, SHIFT(1350),
  [1649] = {.count = 1, .reusable = false}, SHIFT(1350),
  [1651] = {.count = 1, .reusable = true}, SHIFT(1352),
  [1653] = {.count = 1, .reusable = false}, SHIFT(1352),
  [1655] = {.count = 1, .reusable = true}, SHIFT(1353),
  [1657] = {.count = 1, .reusable = false}, SHIFT(1353),
  [1659] = {.count = 1, .reusable = false}, SHIFT(835),
  [1661] = {.count = 1, .reusable = false}, SHIFT(851),
  [1663] = {.count = 1, .reusable = false}, SHIFT(635),
  [1665] = {.count = 1, .reusable = false}, SHIFT(2798),
  [1667] = {.count = 1, .reusable = false}, SHIFT(515),
  [1669] = {.count = 1, .reusable = false}, SHIFT(70),
  [1671] = {.count = 1, .reusable = true}, SHIFT(1255),
  [1673] = {.count = 1, .reusable = false}, SHIFT(1255),
  [1675] = {.count = 1, .reusable = false}, SHIFT(1550),
  [1677] = {.count = 1, .reusable = true}, SHIFT(1169),
  [1679] = {.count = 1, .reusable = false}, SHIFT(1169),
  [1681] = {.count = 1, .reusable = true}, SHIFT(1190),
  [1683] = {.count = 1, .reusable = false}, SHIFT(1190),
  [1685] = {.count = 1, .reusable = false}, SHIFT(884),
  [1687] = {.count = 1, .reusable = true}, SHIFT(1124),
  [1689] = {.count = 1, .reusable = false}, SHIFT(1124),
  [1691] = {.count = 1, .reusable = true}, SHIFT(1125),
  [1693] = {.count = 1, .reusable = false}, SHIFT(1125),
  [1695] = {.count = 1, .reusable = true}, SHIFT(1357),
  [1697] = {.count = 1, .reusable = false}, SHIFT(1357),
  [1699] = {.count = 1, .reusable = true}, SHIFT(1231),
  [1701] = {.count = 1, .reusable = false}, SHIFT(1231),
  [1703] = {.count = 1, .reusable = false}, SHIFT(711),
  [1705] = {.count = 1, .reusable = false}, SHIFT(694),
  [1707] = {.count = 1, .reusable = false}, SHIFT(710),
  [1709] = {.count = 1, .reusable = false}, SHIFT(624),
  [1711] = {.count = 1, .reusable = false}, SHIFT(481),
  [1713] = {.count = 1, .reusable = false}, SHIFT(53),
  [1715] = {.count = 1, .reusable = true}, SHIFT(983),
  [1717] = {.count = 1, .reusable = false}, SHIFT(983),
  [1719] = {.count = 1, .reusable = true}, SHIFT(1135),
  [1721] = {.count = 1, .reusable = false}, SHIFT(1135),
  [1723] = {.count = 1, .reusable = true}, SHIFT(975),
  [1725] = {.count = 1, .reusable = false}, SHIFT(975),
  [1727] = {.count = 1, .reusable = true}, SHIFT(959),
  [1729] = {.count = 1, .reusable = false}, SHIFT(959),
  [1731] = {.count = 1, .reusable = true}, SHIFT(1185),
  [1733] = {.count = 1, .reusable = false}, SHIFT(1185),
  [1735] = {.count = 1, .reusable = true}, SHIFT(1370),
  [1737] = {.count = 1, .reusable = false}, SHIFT(1370),
  [1739] = {.count = 1, .reusable = true}, SHIFT(1360),
  [1741] = {.count = 1, .reusable = false}, SHIFT(1360),
  [1743] = {.count = 1, .reusable = true}, SHIFT(1334),
  [1745] = {.count = 1, .reusable = false}, SHIFT(1334),
  [1747] = {.count = 1, .reusable = true}, SHIFT(1069),
  [1749] = {.count = 1, .reusable = false}, SHIFT(1069),
  [1751] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1753] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1755] = {.count = 1, .reusable = true}, SHIFT(1120),
  [1757] = {.count = 1, .reusable = false}, SHIFT(1120),
  [1759] = {.count = 1, .reusable = true}, SHIFT(956),
  [1761] = {.count = 1, .reusable = false}, SHIFT(956),
  [1763] = {.count = 1, .reusable = true}, SHIFT(1278),
  [1765] = {.count = 1, .reusable = false}, SHIFT(1278),
  [1767] = {.count = 1, .reusable = true}, SHIFT(1277),
  [1769] = {.count = 1, .reusable = false}, SHIFT(1277),
  [1771] = {.count = 1, .reusable = true}, SHIFT(955),
  [1773] = {.count = 1, .reusable = false}, SHIFT(955),
  [1775] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1777] = {.count = 1, .reusable = false}, SHIFT(1205),
  [1779] = {.count = 1, .reusable = false}, SHIFT(836),
  [1781] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1783] = {.count = 1, .reusable = false}, SHIFT(1045),
  [1785] = {.count = 1, .reusable = true}, SHIFT(1311),
  [1787] = {.count = 1, .reusable = false}, SHIFT(1311),
  [1789] = {.count = 1, .reusable = true}, SHIFT(951),
  [1791] = {.count = 1, .reusable = false}, SHIFT(951),
  [1793] = {.count = 1, .reusable = true}, SHIFT(958),
  [1795] = {.count = 1, .reusable = false}, SHIFT(958),
  [1797] = {.count = 1, .reusable = true}, SHIFT(1227),
  [1799] = {.count = 1, .reusable = false}, SHIFT(1227),
  [1801] = {.count = 1, .reusable = true}, SHIFT(1368),
  [1803] = {.count = 1, .reusable = false}, SHIFT(1368),
  [1805] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1807] = {.count = 1, .reusable = false}, SHIFT(1175),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1811] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1109),
  [1815] = {.count = 1, .reusable = false}, SHIFT(1109),
  [1817] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1819] = {.count = 1, .reusable = false}, SHIFT(978),
  [1821] = {.count = 1, .reusable = true}, SHIFT(929),
  [1823] = {.count = 1, .reusable = false}, SHIFT(929),
  [1825] = {.count = 1, .reusable = true}, SHIFT(933),
  [1827] = {.count = 1, .reusable = false}, SHIFT(933),
  [1829] = {.count = 1, .reusable = true}, SHIFT(1147),
  [1831] = {.count = 1, .reusable = false}, SHIFT(1147),
  [1833] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1835] = {.count = 1, .reusable = false}, SHIFT(1042),
  [1837] = {.count = 1, .reusable = true}, SHIFT(1199),
  [1839] = {.count = 1, .reusable = false}, SHIFT(1199),
  [1841] = {.count = 1, .reusable = true}, SHIFT(1046),
  [1843] = {.count = 1, .reusable = false}, SHIFT(1046),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1258),
  [1847] = {.count = 1, .reusable = false}, SHIFT(1258),
  [1849] = {.count = 1, .reusable = true}, SHIFT(953),
  [1851] = {.count = 1, .reusable = false}, SHIFT(953),
  [1853] = {.count = 1, .reusable = true}, SHIFT(992),
  [1855] = {.count = 1, .reusable = false}, SHIFT(992),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1308),
  [1859] = {.count = 1, .reusable = false}, SHIFT(1308),
  [1861] = {.count = 1, .reusable = true}, SHIFT(948),
  [1863] = {.count = 1, .reusable = false}, SHIFT(948),
  [1865] = {.count = 1, .reusable = true}, SHIFT(1264),
  [1867] = {.count = 1, .reusable = false}, SHIFT(1264),
  [1869] = {.count = 1, .reusable = true}, SHIFT(1454),
  [1871] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1873] = {.count = 1, .reusable = true}, SHIFT(1126),
  [1875] = {.count = 1, .reusable = false}, SHIFT(1126),
  [1877] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1879] = {.count = 1, .reusable = false}, SHIFT(1024),
  [1881] = {.count = 1, .reusable = false}, SHIFT(887),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1061),
  [1885] = {.count = 1, .reusable = false}, SHIFT(1061),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1157),
  [1889] = {.count = 1, .reusable = false}, SHIFT(1157),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1065),
  [1893] = {.count = 1, .reusable = true}, SHIFT(1250),
  [1895] = {.count = 1, .reusable = false}, SHIFT(1250),
  [1897] = {.count = 1, .reusable = true}, SHIFT(1469),
  [1899] = {.count = 1, .reusable = false}, SHIFT(1469),
  [1901] = {.count = 1, .reusable = true}, SHIFT(1073),
  [1903] = {.count = 1, .reusable = false}, SHIFT(1073),
  [1905] = {.count = 1, .reusable = true}, SHIFT(1075),
  [1907] = {.count = 1, .reusable = false}, SHIFT(1075),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1077),
  [1911] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1078),
  [1915] = {.count = 1, .reusable = false}, SHIFT(1078),
  [1917] = {.count = 1, .reusable = true}, SHIFT(1099),
  [1919] = {.count = 1, .reusable = false}, SHIFT(1099),
  [1921] = {.count = 1, .reusable = true}, SHIFT(1158),
  [1923] = {.count = 1, .reusable = false}, SHIFT(1158),
  [1925] = {.count = 1, .reusable = true}, SHIFT(1104),
  [1927] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1931] = {.count = 1, .reusable = false}, SHIFT(1119),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1252),
  [1935] = {.count = 1, .reusable = false}, SHIFT(1252),
  [1937] = {.count = 1, .reusable = true}, SHIFT(976),
  [1939] = {.count = 1, .reusable = false}, SHIFT(976),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1257),
  [1943] = {.count = 1, .reusable = false}, SHIFT(1257),
  [1945] = {.count = 1, .reusable = true}, SHIFT(978),
  [1947] = {.count = 1, .reusable = true}, SHIFT(1161),
  [1949] = {.count = 1, .reusable = false}, SHIFT(1161),
  [1951] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1953] = {.count = 1, .reusable = false}, SHIFT(1220),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1162),
  [1957] = {.count = 1, .reusable = false}, SHIFT(1162),
  [1959] = {.count = 1, .reusable = true}, SHIFT(1338),
  [1961] = {.count = 1, .reusable = false}, SHIFT(1338),
  [1963] = {.count = 1, .reusable = true}, SHIFT(1341),
  [1965] = {.count = 1, .reusable = false}, SHIFT(1341),
  [1967] = {.count = 1, .reusable = true}, SHIFT(1343),
  [1969] = {.count = 1, .reusable = false}, SHIFT(1343),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1170),
  [1973] = {.count = 1, .reusable = false}, SHIFT(1170),
  [1975] = {.count = 1, .reusable = true}, SHIFT(985),
  [1977] = {.count = 1, .reusable = false}, SHIFT(985),
  [1979] = {.count = 1, .reusable = true}, SHIFT(1344),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1344),
  [1983] = {.count = 1, .reusable = true}, SHIFT(1345),
  [1985] = {.count = 1, .reusable = false}, SHIFT(1345),
  [1987] = {.count = 1, .reusable = true}, SHIFT(1348),
  [1989] = {.count = 1, .reusable = false}, SHIFT(1348),
  [1991] = {.count = 1, .reusable = true}, SHIFT(1349),
  [1993] = {.count = 1, .reusable = false}, SHIFT(1349),
  [1995] = {.count = 1, .reusable = true}, SHIFT(1433),
  [1997] = {.count = 1, .reusable = false}, SHIFT(1433),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2001] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2003] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2007] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2009] = {.count = 1, .reusable = true}, SHIFT(1610),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1643),
  [2013] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2015] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2017] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2019] = {.count = 1, .reusable = false}, SHIFT(1464),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2023] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2027] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2031] = {.count = 1, .reusable = false}, SHIFT(1044),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2035] = {.count = 1, .reusable = false}, SHIFT(1455),
  [2037] = {.count = 1, .reusable = false}, SHIFT(825),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2041] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2045] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2047] = {.count = 1, .reusable = false}, SHIFT(754),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2051] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2055] = {.count = 1, .reusable = false}, SHIFT(1030),
  [2057] = {.count = 1, .reusable = true}, SHIFT(966),
  [2059] = {.count = 1, .reusable = false}, SHIFT(966),
  [2061] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2063] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1502),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1502),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2075] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2079] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2083] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2085] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2087] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2093] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2095] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1535),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2101] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2109] = {.count = 1, .reusable = true}, SHIFT(987),
  [2111] = {.count = 1, .reusable = false}, SHIFT(987),
  [2113] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2115] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2123] = {.count = 1, .reusable = true}, SHIFT(1950),
  [2125] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2127] = {.count = 1, .reusable = false}, SHIFT(1183),
  [2129] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2131] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2133] = {.count = 1, .reusable = true}, SHIFT(960),
  [2135] = {.count = 1, .reusable = false}, SHIFT(960),
  [2137] = {.count = 1, .reusable = true}, SHIFT(952),
  [2139] = {.count = 1, .reusable = false}, SHIFT(952),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2147] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2151] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2153] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2155] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2157] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2159] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2163] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2169] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2171] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2173] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2175] = {.count = 1, .reusable = false}, SHIFT(790),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2179] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2187] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2191] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1421),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1421),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2199] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2203] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2207] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2211] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2215] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2219] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2221] = {.count = 1, .reusable = true}, SHIFT(954),
  [2223] = {.count = 1, .reusable = false}, SHIFT(954),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1013),
  [2233] = {.count = 1, .reusable = true}, SHIFT(957),
  [2235] = {.count = 1, .reusable = true}, SHIFT(989),
  [2237] = {.count = 1, .reusable = false}, SHIFT(989),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2241] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2243] = {.count = 1, .reusable = true}, SHIFT(982),
  [2245] = {.count = 1, .reusable = false}, SHIFT(982),
  [2247] = {.count = 1, .reusable = true}, SHIFT(981),
  [2249] = {.count = 1, .reusable = false}, SHIFT(981),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2253] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2257] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2261] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2263] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2265] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2273] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2279] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2281] = {.count = 1, .reusable = true}, SHIFT(977),
  [2283] = {.count = 1, .reusable = false}, SHIFT(977),
  [2285] = {.count = 1, .reusable = true}, SHIFT(972),
  [2287] = {.count = 1, .reusable = false}, SHIFT(972),
  [2289] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1413),
  [2293] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2297] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2299] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2301] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2307] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2309] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2311] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2319] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1287),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2337] = {.count = 1, .reusable = true}, SHIFT(969),
  [2339] = {.count = 1, .reusable = false}, SHIFT(969),
  [2341] = {.count = 1, .reusable = true}, SHIFT(950),
  [2343] = {.count = 1, .reusable = false}, SHIFT(950),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2347] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2359] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2365] = {.count = 1, .reusable = false}, SHIFT(2357),
  [2367] = {.count = 1, .reusable = false}, SHIFT(2356),
  [2369] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1804),
  [2372] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1696),
  [2376] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(323),
  [2379] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2764),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1976),
  [2385] = {.count = 1, .reusable = true}, SHIFT(2373),
  [2387] = {.count = 1, .reusable = true}, SHIFT(2372),
  [2389] = {.count = 1, .reusable = true}, SHIFT(2039),
  [2391] = {.count = 1, .reusable = false}, SHIFT(1734),
  [2393] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2395] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2397] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2399] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2401] = {.count = 1, .reusable = false}, SHIFT(2854),
  [2403] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2405] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2407] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2409] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2411] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2413] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2415] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2417] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2419] = {.count = 1, .reusable = false}, SHIFT(2828),
  [2421] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2423] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2425] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2427] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2429] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2431] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2433] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2435] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2437] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2439] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2441] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2443] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2445] = {.count = 1, .reusable = true}, SHIFT(696),
  [2447] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2449] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2451] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2453] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2455] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2457] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2459] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2461] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2463] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2465] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2467] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2, .production_id = 8),
  [2469] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2, .production_id = 8),
  [2471] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2473] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2475] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2477] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2479] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2481] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2483] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2485] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2487] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2489] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2491] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2493] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2495] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2497] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2499] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2501] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2503] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2505] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2507] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2509] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2511] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2513] = {.count = 1, .reusable = false}, SHIFT(2034),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1729),
  [2517] = {.count = 1, .reusable = false}, SHIFT(1745),
  [2519] = {.count = 1, .reusable = false}, SHIFT(1733),
  [2521] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2523] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2525] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(730),
  [2528] = {.count = 1, .reusable = false}, SHIFT(725),
  [2530] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2532] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2534] = {.count = 1, .reusable = false}, SHIFT(2476),
  [2536] = {.count = 1, .reusable = false}, SHIFT(2759),
  [2538] = {.count = 1, .reusable = false}, SHIFT(2801),
  [2540] = {.count = 1, .reusable = false}, SHIFT(2796),
  [2542] = {.count = 1, .reusable = true}, SHIFT(2981),
  [2544] = {.count = 1, .reusable = false}, SHIFT(2011),
  [2546] = {.count = 1, .reusable = true}, SHIFT(478),
  [2548] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2550] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2552] = {.count = 1, .reusable = false}, SHIFT(1845),
  [2554] = {.count = 1, .reusable = false}, SHIFT(2128),
  [2556] = {.count = 1, .reusable = false}, SHIFT(646),
  [2558] = {.count = 1, .reusable = false}, SHIFT(2765),
  [2560] = {.count = 1, .reusable = true}, SHIFT(466),
  [2562] = {.count = 1, .reusable = true}, SHIFT(86),
  [2564] = {.count = 1, .reusable = true}, SHIFT(2764),
  [2566] = {.count = 1, .reusable = false}, SHIFT(2333),
  [2568] = {.count = 1, .reusable = true}, SHIFT(2795),
  [2570] = {.count = 1, .reusable = false}, SHIFT(1927),
  [2572] = {.count = 1, .reusable = true}, SHIFT(444),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1933),
  [2576] = {.count = 1, .reusable = false}, SHIFT(444),
  [2578] = {.count = 1, .reusable = false}, SHIFT(1777),
  [2580] = {.count = 1, .reusable = false}, SHIFT(1735),
  [2582] = {.count = 1, .reusable = true}, SHIFT(479),
  [2584] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2586] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2588] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(730),
  [2591] = {.count = 1, .reusable = true}, SHIFT(468),
  [2593] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1696),
  [2596] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2764),
  [2599] = {.count = 1, .reusable = false}, SHIFT(2809),
  [2601] = {.count = 1, .reusable = false}, SHIFT(2824),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1995),
  [2605] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2607] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2609] = {.count = 1, .reusable = true}, SHIFT(723),
  [2611] = {.count = 1, .reusable = true}, SHIFT(722),
  [2613] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2615] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2617] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2619] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2621] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2623] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2625] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2627] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2629] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2631] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2633] = {.count = 1, .reusable = false}, SHIFT(2866),
  [2635] = {.count = 1, .reusable = false}, SHIFT(2806),
  [2637] = {.count = 1, .reusable = true}, SHIFT(2875),
  [2639] = {.count = 1, .reusable = false}, SHIFT(2001),
  [2641] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2643] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2645] = {.count = 1, .reusable = false}, SHIFT(2812),
  [2647] = {.count = 1, .reusable = false}, SHIFT(2811),
  [2649] = {.count = 1, .reusable = true}, SHIFT(21),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1949),
  [2653] = {.count = 1, .reusable = false}, SHIFT(2117),
  [2655] = {.count = 1, .reusable = false}, SHIFT(2114),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2659] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(145),
  [2662] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2664] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2666] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2668] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2670] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2672] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2674] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2676] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2678] = {.count = 1, .reusable = false}, SHIFT(2885),
  [2680] = {.count = 1, .reusable = false}, SHIFT(2884),
  [2682] = {.count = 1, .reusable = false}, SHIFT(2931),
  [2684] = {.count = 1, .reusable = false}, SHIFT(2929),
  [2686] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2688] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2690] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2692] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2694] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2696] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2698] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2700] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2702] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2704] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2706] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2708] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2712] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2716] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2718] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2720] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2730] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2732] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2806] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [2808] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [2810] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2812] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2818] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2820] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2838] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2852] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2854] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2868] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2872] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2874] = {.count = 1, .reusable = false}, SHIFT(42),
  [2876] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2878] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2880] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2882] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2884] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2886] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2888] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2890] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2892] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2894] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2896] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2898] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2900] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2902] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2904] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2906] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2908] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2910] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2912] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2914] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2916] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2918] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2920] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2922] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2924] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2926] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2928] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2930] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2932] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2934] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2936] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2938] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2940] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2942] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2944] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2946] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2948] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2950] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2952] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2954] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2956] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2958] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2960] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2962] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2964] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2966] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2968] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2970] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2972] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2974] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2976] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2978] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2980] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2982] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2984] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2986] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2988] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2990] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2992] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2994] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2996] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 134),
  [2998] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 134),
  [3000] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 133),
  [3002] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 133),
  [3004] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 152),
  [3006] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 152),
  [3008] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3010] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3012] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3016] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 136),
  [3018] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 136),
  [3020] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3022] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3024] = {.count = 1, .reusable = false}, SHIFT(494),
  [3026] = {.count = 1, .reusable = false}, SHIFT(103),
  [3028] = {.count = 1, .reusable = true}, SHIFT(2366),
  [3030] = {.count = 1, .reusable = true}, SHIFT(2367),
  [3032] = {.count = 1, .reusable = false}, SHIFT(970),
  [3034] = {.count = 1, .reusable = true}, SHIFT(140),
  [3036] = {.count = 1, .reusable = true}, SHIFT(144),
  [3038] = {.count = 1, .reusable = true}, SHIFT(147),
  [3040] = {.count = 1, .reusable = false}, SHIFT(964),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1861),
  [3044] = {.count = 1, .reusable = false}, SHIFT(902),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3048] = {.count = 1, .reusable = true}, SHIFT(676),
  [3050] = {.count = 1, .reusable = true}, SHIFT(962),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3054] = {.count = 1, .reusable = true}, SHIFT(923),
  [3056] = {.count = 1, .reusable = true}, SHIFT(135),
  [3058] = {.count = 1, .reusable = false}, SHIFT(1302),
  [3060] = {.count = 1, .reusable = false}, SHIFT(2388),
  [3062] = {.count = 1, .reusable = true}, SHIFT(2351),
  [3064] = {.count = 1, .reusable = true}, SHIFT(2352),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3068] = {.count = 1, .reusable = false}, SHIFT(1297),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3072] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3074] = {.count = 1, .reusable = false}, SHIFT(1290),
  [3076] = {.count = 1, .reusable = true}, SHIFT(448),
  [3078] = {.count = 1, .reusable = true}, SHIFT(666),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1179),
  [3082] = {.count = 1, .reusable = true}, SHIFT(932),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1892),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3088] = {.count = 1, .reusable = false}, SHIFT(1857),
  [3090] = {.count = 1, .reusable = false}, SHIFT(901),
  [3092] = {.count = 1, .reusable = true}, SHIFT(1325),
  [3094] = {.count = 1, .reusable = false}, SHIFT(1310),
  [3096] = {.count = 1, .reusable = false}, SHIFT(1309),
  [3098] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3100] = {.count = 1, .reusable = false}, SHIFT(1662),
  [3102] = {.count = 1, .reusable = false}, SHIFT(1307),
  [3104] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3106] = {.count = 1, .reusable = false}, SHIFT(1856),
  [3108] = {.count = 1, .reusable = false}, SHIFT(900),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3112] = {.count = 1, .reusable = false}, SHIFT(1322),
  [3114] = {.count = 1, .reusable = false}, SHIFT(1323),
  [3116] = {.count = 1, .reusable = false}, SHIFT(1488),
  [3118] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3120] = {.count = 1, .reusable = false}, SHIFT(1324),
  [3122] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3124] = {.count = 1, .reusable = false}, SHIFT(898),
  [3126] = {.count = 1, .reusable = true}, SHIFT(1928),
  [3128] = {.count = 1, .reusable = false}, SHIFT(1367),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1371),
  [3132] = {.count = 1, .reusable = false}, SHIFT(1398),
  [3134] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3136] = {.count = 1, .reusable = false}, SHIFT(1244),
  [3138] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3140] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3142] = {.count = 1, .reusable = false}, SHIFT(337),
  [3144] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3146] = {.count = 1, .reusable = true}, SHIFT(261),
  [3148] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3150] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3152] = {.count = 1, .reusable = false}, SHIFT(2444),
  [3154] = {.count = 1, .reusable = false}, SHIFT(389),
  [3156] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3158] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(208),
  [3161] = {.count = 1, .reusable = true}, SHIFT(208),
  [3163] = {.count = 1, .reusable = true}, SHIFT(791),
  [3165] = {.count = 1, .reusable = true}, SHIFT(2803),
  [3167] = {.count = 1, .reusable = true}, SHIFT(171),
  [3169] = {.count = 1, .reusable = false}, SHIFT(343),
  [3171] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3174] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(748),
  [3177] = {.count = 1, .reusable = true}, SHIFT(2920),
  [3179] = {.count = 1, .reusable = true}, SHIFT(243),
  [3181] = {.count = 1, .reusable = true}, SHIFT(344),
  [3183] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3186] = {.count = 1, .reusable = true}, SHIFT(767),
  [3188] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3190] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3192] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3194] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3196] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(730),
  [3199] = {.count = 1, .reusable = true}, SHIFT(2857),
  [3201] = {.count = 1, .reusable = true}, SHIFT(721),
  [3203] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3205] = {.count = 1, .reusable = false}, SHIFT(907),
  [3207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3209] = {.count = 1, .reusable = false}, SHIFT(1424),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1425),
  [3213] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3217] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3219] = {.count = 1, .reusable = false}, SHIFT(254),
  [3221] = {.count = 1, .reusable = true}, SHIFT(2793),
  [3223] = {.count = 1, .reusable = true}, SHIFT(241),
  [3225] = {.count = 1, .reusable = true}, SHIFT(256),
  [3227] = {.count = 1, .reusable = false}, SHIFT(342),
  [3229] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3232] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3235] = {.count = 1, .reusable = true}, SHIFT(2882),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1295),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3241] = {.count = 1, .reusable = false}, SHIFT(904),
  [3243] = {.count = 1, .reusable = false}, SHIFT(2598),
  [3245] = {.count = 1, .reusable = true}, SHIFT(470),
  [3247] = {.count = 1, .reusable = true}, SHIFT(765),
  [3249] = {.count = 1, .reusable = false}, SHIFT(2314),
  [3251] = {.count = 1, .reusable = true}, SHIFT(995),
  [3253] = {.count = 1, .reusable = true}, SHIFT(729),
  [3255] = {.count = 1, .reusable = true}, SHIFT(728),
  [3257] = {.count = 1, .reusable = true}, SHIFT(2966),
  [3259] = {.count = 1, .reusable = false}, SHIFT(1562),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3265] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3267] = {.count = 1, .reusable = false}, SHIFT(2568),
  [3269] = {.count = 1, .reusable = true}, SHIFT(904),
  [3271] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3273] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3275] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3278] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3281] = {.count = 1, .reusable = false}, SHIFT(1174),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3285] = {.count = 1, .reusable = false}, SHIFT(899),
  [3287] = {.count = 1, .reusable = false}, SHIFT(2715),
  [3289] = {.count = 1, .reusable = true}, SHIFT(475),
  [3291] = {.count = 1, .reusable = true}, SHIFT(764),
  [3293] = {.count = 1, .reusable = false}, SHIFT(2349),
  [3295] = {.count = 1, .reusable = true}, SHIFT(1059),
  [3297] = {.count = 1, .reusable = true}, SHIFT(772),
  [3299] = {.count = 1, .reusable = true}, SHIFT(776),
  [3301] = {.count = 1, .reusable = true}, SHIFT(2834),
  [3303] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3307] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3309] = {.count = 1, .reusable = false}, SHIFT(1458),
  [3311] = {.count = 1, .reusable = false}, SHIFT(2487),
  [3313] = {.count = 1, .reusable = true}, SHIFT(899),
  [3315] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3318] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3321] = {.count = 1, .reusable = false}, SHIFT(940),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1121),
  [3325] = {.count = 1, .reusable = false}, SHIFT(897),
  [3327] = {.count = 1, .reusable = false}, SHIFT(2703),
  [3329] = {.count = 1, .reusable = true}, SHIFT(464),
  [3331] = {.count = 1, .reusable = true}, SHIFT(718),
  [3333] = {.count = 1, .reusable = false}, SHIFT(2316),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1117),
  [3337] = {.count = 1, .reusable = true}, SHIFT(809),
  [3339] = {.count = 1, .reusable = true}, SHIFT(808),
  [3341] = {.count = 1, .reusable = true}, SHIFT(2846),
  [3343] = {.count = 1, .reusable = false}, SHIFT(1111),
  [3345] = {.count = 1, .reusable = true}, SHIFT(991),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1101),
  [3349] = {.count = 1, .reusable = false}, SHIFT(991),
  [3351] = {.count = 1, .reusable = false}, SHIFT(2506),
  [3353] = {.count = 1, .reusable = true}, SHIFT(897),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1813),
  [3357] = {.count = 1, .reusable = false}, SHIFT(894),
  [3359] = {.count = 1, .reusable = true}, SHIFT(795),
  [3361] = {.count = 1, .reusable = true}, SHIFT(427),
  [3363] = {.count = 1, .reusable = false}, SHIFT(438),
  [3365] = {.count = 1, .reusable = false}, SHIFT(431),
  [3367] = {.count = 1, .reusable = false}, SHIFT(357),
  [3369] = {.count = 1, .reusable = true}, SHIFT(219),
  [3371] = {.count = 1, .reusable = true}, SHIFT(347),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1902),
  [3379] = {.count = 1, .reusable = true}, SHIFT(2547),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3383] = {.count = 1, .reusable = true}, SHIFT(2536),
  [3385] = {.count = 1, .reusable = false}, SHIFT(247),
  [3387] = {.count = 1, .reusable = true}, SHIFT(2914),
  [3389] = {.count = 1, .reusable = true}, SHIFT(212),
  [3391] = {.count = 1, .reusable = true}, SHIFT(407),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1034),
  [3395] = {.count = 1, .reusable = true}, SHIFT(434),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1028),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3401] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(343),
  [3404] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3407] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3411] = {.count = 1, .reusable = true}, SHIFT(2930),
  [3413] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3416] = {.count = 1, .reusable = false}, SHIFT(311),
  [3418] = {.count = 1, .reusable = true}, SHIFT(2926),
  [3420] = {.count = 1, .reusable = true}, SHIFT(227),
  [3422] = {.count = 1, .reusable = true}, SHIFT(246),
  [3424] = {.count = 1, .reusable = true}, SHIFT(421),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3428] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3430] = {.count = 1, .reusable = true}, SHIFT(154),
  [3432] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(814),
  [3435] = {.count = 1, .reusable = true}, SHIFT(2942),
  [3437] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3439] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1018),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3445] = {.count = 1, .reusable = true}, SHIFT(2927),
  [3447] = {.count = 1, .reusable = true}, SHIFT(2918),
  [3449] = {.count = 1, .reusable = true}, SHIFT(2963),
  [3451] = {.count = 1, .reusable = true}, SHIFT(159),
  [3453] = {.count = 1, .reusable = true}, SHIFT(2837),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1888),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1889),
  [3459] = {.count = 1, .reusable = false}, SHIFT(458),
  [3461] = {.count = 1, .reusable = false}, SHIFT(2315),
  [3463] = {.count = 1, .reusable = true}, SHIFT(1062),
  [3465] = {.count = 1, .reusable = true}, SHIFT(758),
  [3467] = {.count = 1, .reusable = true}, SHIFT(756),
  [3469] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3471] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3473] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3475] = {.count = 1, .reusable = false}, SHIFT(896),
  [3477] = {.count = 1, .reusable = false}, SHIFT(2694),
  [3479] = {.count = 1, .reusable = true}, SHIFT(469),
  [3481] = {.count = 1, .reusable = true}, SHIFT(766),
  [3483] = {.count = 1, .reusable = false}, SHIFT(2329),
  [3485] = {.count = 1, .reusable = true}, SHIFT(2835),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1879),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1881),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1879),
  [3495] = {.count = 1, .reusable = true}, SHIFT(2967),
  [3497] = {.count = 1, .reusable = true}, SHIFT(581),
  [3499] = {.count = 1, .reusable = true}, SHIFT(2908),
  [3501] = {.count = 1, .reusable = true}, SHIFT(2132),
  [3503] = {.count = 1, .reusable = true}, SHIFT(2839),
  [3505] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(177),
  [3508] = {.count = 1, .reusable = true}, SHIFT(177),
  [3510] = {.count = 1, .reusable = true}, SHIFT(176),
  [3512] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3515] = {.count = 1, .reusable = true}, SHIFT(746),
  [3517] = {.count = 1, .reusable = true}, SHIFT(2925),
  [3519] = {.count = 1, .reusable = true}, SHIFT(2941),
  [3521] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3523] = {.count = 1, .reusable = true}, SHIFT(2961),
  [3525] = {.count = 1, .reusable = true}, SHIFT(2910),
  [3527] = {.count = 1, .reusable = false}, SHIFT(731),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1993),
  [3531] = {.count = 1, .reusable = true}, SHIFT(2821),
  [3533] = {.count = 1, .reusable = true}, SHIFT(207),
  [3535] = {.count = 1, .reusable = false}, SHIFT(1863),
  [3537] = {.count = 1, .reusable = false}, SHIFT(906),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3541] = {.count = 1, .reusable = true}, SHIFT(185),
  [3543] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1828),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3549] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3551] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3553] = {.count = 1, .reusable = false}, SHIFT(1612),
  [3555] = {.count = 1, .reusable = true}, SHIFT(927),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1090),
  [3559] = {.count = 1, .reusable = true}, SHIFT(2653),
  [3561] = {.count = 1, .reusable = true}, SHIFT(338),
  [3563] = {.count = 1, .reusable = true}, SHIFT(356),
  [3565] = {.count = 1, .reusable = false}, SHIFT(2924),
  [3567] = {.count = 1, .reusable = true}, SHIFT(2076),
  [3569] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3571] = {.count = 1, .reusable = true}, SHIFT(2976),
  [3573] = {.count = 1, .reusable = true}, SHIFT(2977),
  [3575] = {.count = 1, .reusable = true}, SHIFT(2070),
  [3577] = {.count = 1, .reusable = true}, SHIFT(2074),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1991),
  [3581] = {.count = 1, .reusable = true}, SHIFT(2898),
  [3583] = {.count = 1, .reusable = true}, SHIFT(2978),
  [3585] = {.count = 1, .reusable = true}, SHIFT(2629),
  [3587] = {.count = 1, .reusable = true}, SHIFT(2917),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3591] = {.count = 1, .reusable = true}, SHIFT(2080),
  [3593] = {.count = 1, .reusable = true}, SHIFT(2901),
  [3595] = {.count = 1, .reusable = true}, SHIFT(2899),
  [3597] = {.count = 1, .reusable = true}, SHIFT(925),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3601] = {.count = 1, .reusable = false}, SHIFT(2447),
  [3603] = {.count = 1, .reusable = false}, SHIFT(2860),
  [3605] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3607] = {.count = 1, .reusable = true}, SHIFT(2088),
  [3609] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3611] = {.count = 1, .reusable = false}, SHIFT(1865),
  [3613] = {.count = 1, .reusable = true}, SHIFT(931),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3617] = {.count = 1, .reusable = true}, SHIFT(2868),
  [3619] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [3622] = {.count = 1, .reusable = true}, SHIFT(1895),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3626] = {.count = 1, .reusable = true}, SHIFT(1009),
  [3628] = {.count = 1, .reusable = true}, SHIFT(1906),
  [3630] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3632] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1898),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1027),
  [3638] = {.count = 1, .reusable = true}, SHIFT(998),
  [3640] = {.count = 1, .reusable = true}, SHIFT(447),
  [3642] = {.count = 1, .reusable = true}, SHIFT(442),
  [3644] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3646] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3648] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3650] = {.count = 1, .reusable = true}, SHIFT(440),
  [3652] = {.count = 1, .reusable = false}, SHIFT(730),
  [3654] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [3656] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [3658] = {.count = 1, .reusable = true}, SHIFT(228),
  [3660] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3662] = {.count = 1, .reusable = true}, SHIFT(679),
  [3664] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3666] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3668] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3670] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3672] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3674] = {.count = 1, .reusable = false}, SHIFT(385),
  [3676] = {.count = 1, .reusable = false}, SHIFT(398),
  [3678] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(797),
  [3681] = {.count = 1, .reusable = true}, SHIFT(2891),
  [3683] = {.count = 1, .reusable = true}, SHIFT(786),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1091),
  [3687] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3689] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3691] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 28),
  [3693] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 28),
  [3695] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3697] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3699] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 28),
  [3701] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 28),
  [3703] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3705] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3707] = {.count = 1, .reusable = false}, SHIFT(370),
  [3709] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [3711] = {.count = 1, .reusable = false}, SHIFT(373),
  [3713] = {.count = 1, .reusable = false}, SHIFT(98),
  [3715] = {.count = 1, .reusable = false}, SHIFT(303),
  [3717] = {.count = 1, .reusable = true}, SHIFT(374),
  [3719] = {.count = 1, .reusable = true}, SHIFT(376),
  [3721] = {.count = 1, .reusable = true}, SHIFT(370),
  [3723] = {.count = 1, .reusable = false}, SHIFT(374),
  [3725] = {.count = 1, .reusable = false}, SHIFT(376),
  [3727] = {.count = 1, .reusable = false}, SHIFT(377),
  [3729] = {.count = 1, .reusable = true}, SHIFT(386),
  [3731] = {.count = 1, .reusable = true}, SHIFT(373),
  [3733] = {.count = 1, .reusable = true}, SHIFT(387),
  [3735] = {.count = 1, .reusable = false}, SHIFT(1131),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1132),
  [3739] = {.count = 1, .reusable = true}, SHIFT(137),
  [3741] = {.count = 1, .reusable = true}, SHIFT(850),
  [3743] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3745] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [3747] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [3749] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3751] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3753] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3755] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(98),
  [3758] = {.count = 1, .reusable = true}, SHIFT(236),
  [3760] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 55),
  [3762] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3764] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3766] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [3768] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [3770] = {.count = 1, .reusable = true}, SHIFT(883),
  [3772] = {.count = 1, .reusable = true}, SHIFT(13),
  [3774] = {.count = 1, .reusable = true}, SHIFT(2958),
  [3776] = {.count = 1, .reusable = true}, SHIFT(670),
  [3778] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3780] = {.count = 1, .reusable = false}, SHIFT(392),
  [3782] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3784] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(210),
  [3787] = {.count = 1, .reusable = true}, SHIFT(210),
  [3789] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3791] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3793] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3795] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3797] = {.count = 1, .reusable = true}, SHIFT(15),
  [3799] = {.count = 1, .reusable = true}, SHIFT(2781),
  [3801] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(797),
  [3804] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [3806] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3808] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3810] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(98),
  [3813] = {.count = 1, .reusable = false}, SHIFT(390),
  [3815] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3817] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(209),
  [3820] = {.count = 1, .reusable = true}, SHIFT(209),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1056),
  [3824] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [3826] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [3828] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3830] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3832] = {.count = 1, .reusable = true}, SHIFT(675),
  [3834] = {.count = 1, .reusable = true}, SHIFT(172),
  [3836] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3838] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3840] = {.count = 1, .reusable = true}, SHIFT(811),
  [3842] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3844] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [3846] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [3848] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 103),
  [3850] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 103),
  [3852] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 102),
  [3854] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 102),
  [3856] = {.count = 1, .reusable = false}, SHIFT(779),
  [3858] = {.count = 1, .reusable = false}, SHIFT(778),
  [3860] = {.count = 1, .reusable = false}, SHIFT(341),
  [3862] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [3864] = {.count = 1, .reusable = false}, SHIFT(339),
  [3866] = {.count = 1, .reusable = false}, SHIFT(92),
  [3868] = {.count = 1, .reusable = false}, SHIFT(361),
  [3870] = {.count = 1, .reusable = true}, SHIFT(312),
  [3872] = {.count = 1, .reusable = true}, SHIFT(306),
  [3874] = {.count = 1, .reusable = true}, SHIFT(341),
  [3876] = {.count = 1, .reusable = false}, SHIFT(312),
  [3878] = {.count = 1, .reusable = false}, SHIFT(306),
  [3880] = {.count = 1, .reusable = false}, SHIFT(297),
  [3882] = {.count = 1, .reusable = true}, SHIFT(291),
  [3884] = {.count = 1, .reusable = true}, SHIFT(339),
  [3886] = {.count = 1, .reusable = true}, SHIFT(289),
  [3888] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [3890] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [3892] = {.count = 1, .reusable = false}, SHIFT(270),
  [3894] = {.count = 1, .reusable = false}, SHIFT(273),
  [3896] = {.count = 1, .reusable = false}, SHIFT(97),
  [3898] = {.count = 1, .reusable = false}, SHIFT(275),
  [3900] = {.count = 1, .reusable = true}, SHIFT(276),
  [3902] = {.count = 1, .reusable = true}, SHIFT(277),
  [3904] = {.count = 1, .reusable = true}, SHIFT(270),
  [3906] = {.count = 1, .reusable = false}, SHIFT(276),
  [3908] = {.count = 1, .reusable = false}, SHIFT(277),
  [3910] = {.count = 1, .reusable = false}, SHIFT(278),
  [3912] = {.count = 1, .reusable = true}, SHIFT(279),
  [3914] = {.count = 1, .reusable = true}, SHIFT(273),
  [3916] = {.count = 1, .reusable = true}, SHIFT(280),
  [3918] = {.count = 1, .reusable = false}, SHIFT(1399),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3922] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [3924] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [3926] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 94),
  [3928] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 94),
  [3930] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(97),
  [3933] = {.count = 1, .reusable = true}, SHIFT(792),
  [3935] = {.count = 1, .reusable = true}, SHIFT(654),
  [3937] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [3939] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 92),
  [3941] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 92),
  [3943] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3946] = {.count = 1, .reusable = true}, SHIFT(750),
  [3948] = {.count = 1, .reusable = false}, SHIFT(1893),
  [3950] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 89),
  [3952] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 89),
  [3954] = {.count = 1, .reusable = true}, SHIFT(751),
  [3956] = {.count = 1, .reusable = false}, SHIFT(1387),
  [3958] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3960] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(97),
  [3963] = {.count = 1, .reusable = true}, SHIFT(745),
  [3965] = {.count = 1, .reusable = false}, SHIFT(439),
  [3967] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [3971] = {.count = 1, .reusable = true}, SHIFT(613),
  [3973] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3976] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3979] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3982] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3985] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [3987] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [3989] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [3991] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [3993] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [3995] = {.count = 1, .reusable = true}, SHIFT(698),
  [3997] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [3999] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [4001] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [4003] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4005] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4007] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [4009] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [4011] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4013] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4015] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 129),
  [4017] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 129),
  [4019] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [4021] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [4023] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4025] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4027] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 52),
  [4029] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 52),
  [4031] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 51),
  [4033] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 51),
  [4035] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [4037] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [4039] = {.count = 1, .reusable = false}, SHIFT(406),
  [4041] = {.count = 1, .reusable = true}, SHIFT(669),
  [4043] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [4045] = {.count = 1, .reusable = false}, SHIFT(403),
  [4047] = {.count = 1, .reusable = true}, SHIFT(169),
  [4049] = {.count = 1, .reusable = false}, SHIFT(94),
  [4051] = {.count = 1, .reusable = false}, SHIFT(388),
  [4053] = {.count = 1, .reusable = true}, SHIFT(395),
  [4055] = {.count = 1, .reusable = true}, SHIFT(394),
  [4057] = {.count = 1, .reusable = true}, SHIFT(406),
  [4059] = {.count = 1, .reusable = false}, SHIFT(395),
  [4061] = {.count = 1, .reusable = false}, SHIFT(394),
  [4063] = {.count = 1, .reusable = false}, SHIFT(383),
  [4065] = {.count = 1, .reusable = true}, SHIFT(379),
  [4067] = {.count = 1, .reusable = true}, SHIFT(403),
  [4069] = {.count = 1, .reusable = true}, SHIFT(371),
  [4071] = {.count = 1, .reusable = false}, SHIFT(1599),
  [4073] = {.count = 1, .reusable = true}, SHIFT(1596),
  [4075] = {.count = 1, .reusable = true}, SHIFT(868),
  [4077] = {.count = 1, .reusable = true}, SHIFT(806),
  [4079] = {.count = 1, .reusable = false}, SHIFT(1087),
  [4081] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [4084] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72),
  [4086] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63), REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [4089] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63),
  [4091] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4094] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62),
  [4096] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [4098] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [4100] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4102] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4104] = {.count = 1, .reusable = true}, SHIFT(2709),
  [4106] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [4108] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4111] = {.count = 1, .reusable = false}, SHIFT(1929),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1110),
  [4115] = {.count = 1, .reusable = true}, SHIFT(138),
  [4117] = {.count = 1, .reusable = false}, SHIFT(1661),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1663),
  [4123] = {.count = 1, .reusable = false}, SHIFT(1683),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4127] = {.count = 1, .reusable = false}, SHIFT(1669),
  [4129] = {.count = 1, .reusable = false}, SHIFT(1931),
  [4131] = {.count = 1, .reusable = true}, SHIFT(2296),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1666),
  [4135] = {.count = 1, .reusable = false}, SHIFT(1674),
  [4137] = {.count = 1, .reusable = false}, SHIFT(1685),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4141] = {.count = 1, .reusable = false}, SHIFT(1653),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1213),
  [4145] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(92),
  [4148] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(94),
  [4151] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4153] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4155] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [4157] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [4159] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(92),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1609),
  [4164] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1420),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4170] = {.count = 1, .reusable = false}, SHIFT(1649),
  [4172] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4174] = {.count = 1, .reusable = false}, SHIFT(1720),
  [4176] = {.count = 1, .reusable = false}, SHIFT(1655),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1418),
  [4180] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [4182] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(752),
  [4185] = {.count = 1, .reusable = true}, SHIFT(2954),
  [4187] = {.count = 1, .reusable = true}, SHIFT(787),
  [4189] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [4191] = {.count = 1, .reusable = false}, SHIFT(1930),
  [4193] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4195] = {.count = 1, .reusable = false}, SHIFT(1664),
  [4197] = {.count = 1, .reusable = false}, SHIFT(1665),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1691),
  [4201] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4203] = {.count = 1, .reusable = false}, SHIFT(1678),
  [4205] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 48),
  [4207] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 48),
  [4209] = {.count = 1, .reusable = false}, SHIFT(1041),
  [4211] = {.count = 1, .reusable = true}, SHIFT(1098),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1141),
  [4215] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4217] = {.count = 1, .reusable = true}, SHIFT(237),
  [4219] = {.count = 1, .reusable = true}, SHIFT(585),
  [4221] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [4223] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 76),
  [4225] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4227] = {.count = 1, .reusable = true}, SHIFT(1317),
  [4229] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4231] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1726),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1395),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4239] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(94),
  [4242] = {.count = 1, .reusable = true}, SHIFT(1011),
  [4244] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4246] = {.count = 1, .reusable = true}, SHIFT(945),
  [4248] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4250] = {.count = 1, .reusable = true}, SHIFT(600),
  [4252] = {.count = 1, .reusable = true}, SHIFT(510),
  [4254] = {.count = 1, .reusable = false}, SHIFT(404),
  [4256] = {.count = 1, .reusable = false}, SHIFT(405),
  [4258] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4260] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4262] = {.count = 1, .reusable = false}, SHIFT(1934),
  [4264] = {.count = 1, .reusable = true}, SHIFT(935),
  [4266] = {.count = 1, .reusable = false}, SHIFT(1675),
  [4268] = {.count = 1, .reusable = false}, SHIFT(1672),
  [4270] = {.count = 1, .reusable = false}, SHIFT(1692),
  [4272] = {.count = 1, .reusable = false}, SHIFT(1715),
  [4274] = {.count = 1, .reusable = false}, SHIFT(1671),
  [4276] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4280] = {.count = 1, .reusable = true}, SHIFT(329),
  [4282] = {.count = 1, .reusable = true}, SHIFT(292),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1536),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4288] = {.count = 1, .reusable = false}, SHIFT(1679),
  [4290] = {.count = 1, .reusable = false}, SHIFT(351),
  [4292] = {.count = 1, .reusable = false}, SHIFT(353),
  [4294] = {.count = 1, .reusable = false}, SHIFT(93),
  [4296] = {.count = 1, .reusable = false}, SHIFT(310),
  [4298] = {.count = 1, .reusable = true}, SHIFT(362),
  [4300] = {.count = 1, .reusable = true}, SHIFT(363),
  [4302] = {.count = 1, .reusable = true}, SHIFT(351),
  [4304] = {.count = 1, .reusable = false}, SHIFT(362),
  [4306] = {.count = 1, .reusable = false}, SHIFT(363),
  [4308] = {.count = 1, .reusable = false}, SHIFT(375),
  [4310] = {.count = 1, .reusable = true}, SHIFT(378),
  [4312] = {.count = 1, .reusable = true}, SHIFT(353),
  [4314] = {.count = 1, .reusable = true}, SHIFT(381),
  [4316] = {.count = 1, .reusable = false}, SHIFT(305),
  [4318] = {.count = 1, .reusable = false}, SHIFT(304),
  [4320] = {.count = 1, .reusable = true}, SHIFT(580),
  [4322] = {.count = 1, .reusable = false}, SHIFT(91),
  [4324] = {.count = 1, .reusable = false}, SHIFT(314),
  [4326] = {.count = 1, .reusable = true}, SHIFT(302),
  [4328] = {.count = 1, .reusable = true}, SHIFT(301),
  [4330] = {.count = 1, .reusable = true}, SHIFT(305),
  [4332] = {.count = 1, .reusable = false}, SHIFT(302),
  [4334] = {.count = 1, .reusable = false}, SHIFT(301),
  [4336] = {.count = 1, .reusable = false}, SHIFT(300),
  [4338] = {.count = 1, .reusable = true}, SHIFT(299),
  [4340] = {.count = 1, .reusable = true}, SHIFT(304),
  [4342] = {.count = 1, .reusable = true}, SHIFT(296),
  [4344] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(91),
  [4347] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(93),
  [4350] = {.count = 1, .reusable = true}, SHIFT(9),
  [4352] = {.count = 1, .reusable = true}, SHIFT(611),
  [4354] = {.count = 1, .reusable = true}, SHIFT(610),
  [4356] = {.count = 1, .reusable = true}, SHIFT(46),
  [4358] = {.count = 1, .reusable = true}, SHIFT(2223),
  [4360] = {.count = 1, .reusable = true}, SHIFT(615),
  [4362] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(93),
  [4365] = {.count = 1, .reusable = true}, SHIFT(616),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1240),
  [4371] = {.count = 1, .reusable = false}, SHIFT(1635),
  [4373] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4375] = {.count = 1, .reusable = false}, SHIFT(1606),
  [4377] = {.count = 1, .reusable = false}, SHIFT(1779),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1670),
  [4381] = {.count = 1, .reusable = false}, SHIFT(1471),
  [4383] = {.count = 1, .reusable = true}, SHIFT(32),
  [4385] = {.count = 1, .reusable = true}, SHIFT(1547),
  [4387] = {.count = 1, .reusable = true}, SHIFT(535),
  [4389] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(805),
  [4392] = {.count = 1, .reusable = true}, SHIFT(2948),
  [4394] = {.count = 1, .reusable = true}, SHIFT(798),
  [4396] = {.count = 1, .reusable = true}, SHIFT(1571),
  [4398] = {.count = 1, .reusable = false}, SHIFT(1611),
  [4400] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(752),
  [4403] = {.count = 1, .reusable = true}, SHIFT(323),
  [4405] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4407] = {.count = 1, .reusable = false}, SHIFT(1744),
  [4409] = {.count = 1, .reusable = true}, SHIFT(1529),
  [4411] = {.count = 1, .reusable = true}, SHIFT(2342),
  [4413] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1863),
  [4416] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1797),
  [4419] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4421] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(185),
  [4424] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1635),
  [4427] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2351),
  [4430] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2352),
  [4433] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1820),
  [4436] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1812),
  [4439] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1606),
  [4442] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1779),
  [4445] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1670),
  [4448] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1601),
  [4451] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1471),
  [4454] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 73),
  [4456] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4459] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4461] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4464] = {.count = 1, .reusable = true}, SHIFT(576),
  [4466] = {.count = 1, .reusable = true}, SHIFT(537),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1186),
  [4470] = {.count = 1, .reusable = true}, SHIFT(477),
  [4472] = {.count = 1, .reusable = false}, SHIFT(283),
  [4474] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(179),
  [4477] = {.count = 1, .reusable = true}, SHIFT(179),
  [4479] = {.count = 1, .reusable = false}, SHIFT(284),
  [4481] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(180),
  [4484] = {.count = 1, .reusable = true}, SHIFT(180),
  [4486] = {.count = 1, .reusable = true}, SHIFT(480),
  [4488] = {.count = 1, .reusable = true}, SHIFT(1116),
  [4490] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(91),
  [4493] = {.count = 1, .reusable = false}, SHIFT(1945),
  [4495] = {.count = 1, .reusable = false}, SHIFT(1690),
  [4497] = {.count = 1, .reusable = false}, SHIFT(1698),
  [4499] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4501] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4503] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4505] = {.count = 1, .reusable = true}, SHIFT(612),
  [4507] = {.count = 1, .reusable = true}, SHIFT(609),
  [4509] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4511] = {.count = 1, .reusable = true}, SHIFT(608),
  [4513] = {.count = 1, .reusable = true}, SHIFT(607),
  [4515] = {.count = 1, .reusable = true}, SHIFT(865),
  [4517] = {.count = 1, .reusable = true}, SHIFT(655),
  [4519] = {.count = 1, .reusable = true}, SHIFT(120),
  [4521] = {.count = 1, .reusable = false}, SHIFT(1407),
  [4523] = {.count = 1, .reusable = true}, SHIFT(826),
  [4525] = {.count = 1, .reusable = true}, SHIFT(110),
  [4527] = {.count = 1, .reusable = true}, SHIFT(1040),
  [4529] = {.count = 1, .reusable = true}, SHIFT(1515),
  [4531] = {.count = 1, .reusable = true}, SHIFT(687),
  [4533] = {.count = 1, .reusable = false}, SHIFT(271),
  [4535] = {.count = 1, .reusable = false}, SHIFT(282),
  [4537] = {.count = 1, .reusable = true}, SHIFT(316),
  [4539] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4541] = {.count = 1, .reusable = true}, SHIFT(330),
  [4543] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(404),
  [4546] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4549] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4551] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4554] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(405),
  [4557] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4560] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4562] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4565] = {.count = 1, .reusable = false}, SHIFT(366),
  [4567] = {.count = 1, .reusable = false}, SHIFT(367),
  [4569] = {.count = 1, .reusable = true}, SHIFT(298),
  [4571] = {.count = 1, .reusable = false}, SHIFT(20),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2950),
  [4575] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4578] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4580] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4583] = {.count = 1, .reusable = false}, SHIFT(346),
  [4585] = {.count = 1, .reusable = false}, SHIFT(349),
  [4587] = {.count = 1, .reusable = false}, SHIFT(1524),
  [4589] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(805),
  [4592] = {.count = 1, .reusable = false}, SHIFT(781),
  [4594] = {.count = 1, .reusable = false}, SHIFT(777),
  [4596] = {.count = 1, .reusable = true}, SHIFT(258),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4600] = {.count = 1, .reusable = false}, SHIFT(1566),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4604] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4606] = {.count = 1, .reusable = false}, SHIFT(1658),
  [4608] = {.count = 1, .reusable = true}, SHIFT(248),
  [4610] = {.count = 1, .reusable = true}, SHIFT(322),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4614] = {.count = 1, .reusable = false}, SHIFT(1579),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4618] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4620] = {.count = 1, .reusable = false}, SHIFT(1651),
  [4622] = {.count = 1, .reusable = true}, SHIFT(1858),
  [4624] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4626] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4630] = {.count = 1, .reusable = false}, SHIFT(802),
  [4632] = {.count = 1, .reusable = false}, SHIFT(804),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1520),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4640] = {.count = 1, .reusable = false}, SHIFT(1749),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4644] = {.count = 1, .reusable = false}, SHIFT(1603),
  [4646] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4648] = {.count = 1, .reusable = false}, SHIFT(1680),
  [4650] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4654] = {.count = 1, .reusable = false}, SHIFT(1748),
  [4656] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4660] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4662] = {.count = 1, .reusable = false}, SHIFT(1626),
  [4664] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4666] = {.count = 1, .reusable = false}, SHIFT(1650),
  [4668] = {.count = 1, .reusable = true}, SHIFT(699),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4672] = {.count = 1, .reusable = false}, SHIFT(1751),
  [4674] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4678] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4680] = {.count = 1, .reusable = false}, SHIFT(1640),
  [4682] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4684] = {.count = 1, .reusable = false}, SHIFT(1642),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4688] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4690] = {.count = 1, .reusable = false}, SHIFT(295),
  [4692] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4696] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4698] = {.count = 1, .reusable = false}, SHIFT(294),
  [4700] = {.count = 1, .reusable = false}, SHIFT(1533),
  [4702] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4704] = {.count = 1, .reusable = false}, SHIFT(1654),
  [4706] = {.count = 1, .reusable = false}, SHIFT(1539),
  [4708] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4710] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4712] = {.count = 1, .reusable = false}, SHIFT(1738),
  [4714] = {.count = 1, .reusable = false}, SHIFT(1557),
  [4716] = {.count = 1, .reusable = false}, SHIFT(1570),
  [4718] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4720] = {.count = 1, .reusable = false}, SHIFT(1681),
  [4722] = {.count = 1, .reusable = false}, SHIFT(1578),
  [4724] = {.count = 1, .reusable = true}, SHIFT(1803),
  [4726] = {.count = 1, .reusable = false}, SHIFT(1584),
  [4728] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4730] = {.count = 1, .reusable = false}, SHIFT(1682),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4734] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4738] = {.count = 1, .reusable = false}, SHIFT(1739),
  [4740] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4744] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4746] = {.count = 1, .reusable = false}, SHIFT(1618),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4750] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4752] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2302),
  [4756] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4758] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4760] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4762] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4764] = {.count = 1, .reusable = true}, SHIFT(145),
  [4766] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2437),
  [4770] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4772] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4774] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4776] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4778] = {.count = 1, .reusable = true}, SHIFT(143),
  [4780] = {.count = 1, .reusable = false}, SHIFT(2858),
  [4782] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4784] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4786] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4788] = {.count = 1, .reusable = false}, SHIFT(2887),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2531),
  [4792] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4794] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4796] = {.count = 1, .reusable = true}, SHIFT(2475),
  [4798] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4800] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4802] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4804] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4806] = {.count = 1, .reusable = true}, SHIFT(263),
  [4808] = {.count = 1, .reusable = true}, SHIFT(359),
  [4810] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2726),
  [4814] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4816] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4818] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4820] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4822] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4826] = {.count = 1, .reusable = false}, SHIFT(1747),
  [4828] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4830] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4832] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4834] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4838] = {.count = 1, .reusable = false}, SHIFT(1759),
  [4840] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4842] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4844] = {.count = 1, .reusable = false}, SHIFT(1731),
  [4846] = {.count = 1, .reusable = true}, SHIFT(206),
  [4848] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4850] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4854] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4858] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4860] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4862] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4864] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4866] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4870] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4872] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4874] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4876] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4878] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4880] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4884] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4886] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4888] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4890] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4892] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4894] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4896] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4898] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4900] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4902] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4904] = {.count = 1, .reusable = true}, SHIFT(1763),
  [4906] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4908] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4910] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4912] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4914] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4916] = {.count = 1, .reusable = false}, SHIFT(2142),
  [4918] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2278),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2310),
  [4924] = {.count = 1, .reusable = true}, SHIFT(562),
  [4926] = {.count = 1, .reusable = true}, SHIFT(599),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2219),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2267),
  [4936] = {.count = 1, .reusable = true}, SHIFT(557),
  [4938] = {.count = 1, .reusable = false}, SHIFT(1510),
  [4940] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4942] = {.count = 1, .reusable = false}, SHIFT(1462),
  [4944] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4946] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4948] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1812),
  [4951] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4953] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4955] = {.count = 1, .reusable = false}, SHIFT(1646),
  [4957] = {.count = 1, .reusable = false}, SHIFT(1667),
  [4959] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4961] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4963] = {.count = 1, .reusable = false}, SHIFT(1644),
  [4965] = {.count = 1, .reusable = false}, SHIFT(1659),
  [4967] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4969] = {.count = 1, .reusable = false}, SHIFT(1641),
  [4971] = {.count = 1, .reusable = false}, SHIFT(1732),
  [4973] = {.count = 1, .reusable = false}, SHIFT(1608),
  [4975] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4979] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4981] = {.count = 1, .reusable = false}, SHIFT(1694),
  [4983] = {.count = 1, .reusable = false}, SHIFT(1697),
  [4985] = {.count = 1, .reusable = true}, SHIFT(730),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2854),
  [4989] = {.count = 1, .reusable = true}, SHIFT(380),
  [4991] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 70),
  [4993] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4997] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4999] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 142),
  [5001] = {.count = 1, .reusable = true}, SHIFT(1851),
  [5003] = {.count = 1, .reusable = true}, SHIFT(1968),
  [5005] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5007] = {.count = 1, .reusable = true}, SHIFT(1847),
  [5009] = {.count = 1, .reusable = true}, SHIFT(1992),
  [5011] = {.count = 1, .reusable = true}, SHIFT(748),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2943),
  [5015] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 113),
  [5017] = {.count = 1, .reusable = true}, SHIFT(1844),
  [5019] = {.count = 1, .reusable = true}, SHIFT(1944),
  [5021] = {.count = 1, .reusable = true}, SHIFT(739),
  [5023] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5026] = {.count = 1, .reusable = true}, SHIFT(732),
  [5028] = {.count = 1, .reusable = true}, SHIFT(1839),
  [5030] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5032] = {.count = 1, .reusable = true}, SHIFT(96),
  [5034] = {.count = 1, .reusable = true}, SHIFT(1834),
  [5036] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 70),
  [5038] = {.count = 1, .reusable = true}, SHIFT(1842),
  [5040] = {.count = 1, .reusable = true}, SHIFT(1837),
  [5042] = {.count = 1, .reusable = true}, SHIFT(1854),
  [5044] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 142),
  [5046] = {.count = 1, .reusable = true}, SHIFT(1838),
  [5048] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 113),
  [5050] = {.count = 1, .reusable = true}, SHIFT(1841),
  [5052] = {.count = 1, .reusable = true}, SHIFT(1853),
  [5054] = {.count = 1, .reusable = true}, SHIFT(1846),
  [5056] = {.count = 1, .reusable = true}, SHIFT(794),
  [5058] = {.count = 1, .reusable = true}, SHIFT(717),
  [5060] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5062] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 70),
  [5064] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 70),
  [5066] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 142),
  [5068] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 113),
  [5070] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 113),
  [5072] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5075] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5077] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 142),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2982),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5083] = {.count = 1, .reusable = true}, SHIFT(2860),
  [5085] = {.count = 1, .reusable = false}, SHIFT(1925),
  [5087] = {.count = 1, .reusable = true}, SHIFT(1296),
  [5089] = {.count = 1, .reusable = false}, SHIFT(799),
  [5091] = {.count = 1, .reusable = false}, SHIFT(157),
  [5093] = {.count = 1, .reusable = false}, SHIFT(1924),
  [5095] = {.count = 1, .reusable = false}, SHIFT(1923),
  [5097] = {.count = 1, .reusable = true}, SHIFT(1273),
  [5099] = {.count = 1, .reusable = false}, SHIFT(1913),
  [5101] = {.count = 1, .reusable = false}, SHIFT(1926),
  [5103] = {.count = 1, .reusable = false}, SHIFT(1920),
  [5105] = {.count = 1, .reusable = true}, SHIFT(1336),
  [5107] = {.count = 1, .reusable = false}, SHIFT(1914),
  [5109] = {.count = 1, .reusable = true}, SHIFT(716),
  [5111] = {.count = 1, .reusable = true}, SHIFT(770),
  [5113] = {.count = 1, .reusable = false}, SHIFT(775),
  [5115] = {.count = 1, .reusable = false}, SHIFT(1912),
  [5117] = {.count = 1, .reusable = false}, SHIFT(1908),
  [5119] = {.count = 1, .reusable = false}, SHIFT(1915),
  [5121] = {.count = 1, .reusable = true}, SHIFT(1374),
  [5123] = {.count = 1, .reusable = true}, SHIFT(799),
  [5125] = {.count = 1, .reusable = true}, SHIFT(157),
  [5127] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5129] = {.count = 1, .reusable = true}, SHIFT(1330),
  [5131] = {.count = 1, .reusable = true}, SHIFT(1319),
  [5133] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5136] = {.count = 1, .reusable = true}, SHIFT(17),
  [5138] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5141] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5143] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5145] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5147] = {.count = 1, .reusable = false}, SHIFT(1980),
  [5149] = {.count = 1, .reusable = true}, SHIFT(1176),
  [5151] = {.count = 1, .reusable = true}, SHIFT(142),
  [5153] = {.count = 1, .reusable = false}, SHIFT(2848),
  [5155] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5157] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5159] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5163] = {.count = 1, .reusable = true}, SHIFT(1696),
  [5165] = {.count = 1, .reusable = true}, SHIFT(494),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2832),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2037),
  [5173] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5175] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5177] = {.count = 1, .reusable = true}, SHIFT(2087),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2104),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2049),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2675),
  [5185] = {.count = 1, .reusable = true}, SHIFT(155),
  [5187] = {.count = 1, .reusable = true}, SHIFT(1932),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2833),
  [5191] = {.count = 1, .reusable = true}, SHIFT(350),
  [5193] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5195] = {.count = 1, .reusable = true}, SHIFT(2805),
  [5197] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 87),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2055),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2020),
  [5207] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 97),
  [5209] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 115),
  [5211] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 139),
  [5213] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5215] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 121),
  [5217] = {.count = 1, .reusable = true}, SHIFT(438),
  [5219] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5221] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 160),
  [5223] = {.count = 1, .reusable = false}, SHIFT(2876),
  [5225] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 161),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5229] = {.count = 1, .reusable = true}, SHIFT(2043),
  [5231] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 170),
  [5233] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 171),
  [5235] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 178),
  [5237] = {.count = 1, .reusable = true}, SHIFT(2100),
  [5239] = {.count = 1, .reusable = true}, SHIFT(2079),
  [5241] = {.count = 1, .reusable = true}, SHIFT(358),
  [5243] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5245] = {.count = 1, .reusable = true}, SHIFT(2086),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2067),
  [5251] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 138),
  [5253] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 179),
  [5255] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 110),
  [5257] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 182),
  [5259] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5261] = {.count = 1, .reusable = true}, SHIFT(2029),
  [5263] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2012),
  [5266] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(242),
  [5271] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(2903),
  [5274] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5276] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(174),
  [5279] = {.count = 1, .reusable = true}, SHIFT(1980),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5285] = {.count = 1, .reusable = true}, SHIFT(921),
  [5287] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5293] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5297] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5299] = {.count = 1, .reusable = true}, SHIFT(913),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2042),
  [5303] = {.count = 1, .reusable = true}, SHIFT(1620),
  [5305] = {.count = 1, .reusable = true}, SHIFT(242),
  [5307] = {.count = 1, .reusable = true}, SHIFT(918),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5313] = {.count = 1, .reusable = true}, SHIFT(2077),
  [5315] = {.count = 1, .reusable = true}, SHIFT(1386),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5319] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5321] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5329] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2012),
  [5335] = {.count = 1, .reusable = true}, SHIFT(1607),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2141),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5341] = {.count = 1, .reusable = true}, SHIFT(911),
  [5343] = {.count = 1, .reusable = true}, SHIFT(1869),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2111),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5349] = {.count = 1, .reusable = true}, SHIFT(919),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5353] = {.count = 1, .reusable = true}, SHIFT(814),
  [5355] = {.count = 1, .reusable = true}, SHIFT(912),
  [5357] = {.count = 1, .reusable = true}, SHIFT(1475),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5363] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(924),
  [5370] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5372] = {.count = 1, .reusable = true}, SHIFT(914),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5376] = {.count = 1, .reusable = false}, SHIFT(2509),
  [5378] = {.count = 1, .reusable = true}, SHIFT(2849),
  [5380] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5382] = {.count = 1, .reusable = false}, SHIFT(2851),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5386] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5388] = {.count = 1, .reusable = true}, SHIFT(909),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2108),
  [5392] = {.count = 1, .reusable = true}, SHIFT(917),
  [5394] = {.count = 1, .reusable = true}, SHIFT(441),
  [5396] = {.count = 1, .reusable = true}, SHIFT(908),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2075),
  [5400] = {.count = 1, .reusable = true}, SHIFT(1094),
  [5402] = {.count = 1, .reusable = true}, SHIFT(1100),
  [5404] = {.count = 1, .reusable = true}, SHIFT(1496),
  [5406] = {.count = 1, .reusable = true}, SHIFT(920),
  [5408] = {.count = 1, .reusable = true}, SHIFT(1639),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2903),
  [5414] = {.count = 1, .reusable = true}, SHIFT(559),
  [5416] = {.count = 1, .reusable = true}, SHIFT(174),
  [5418] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 65),
  [5420] = {.count = 1, .reusable = true}, SHIFT(915),
  [5422] = {.count = 1, .reusable = true}, SHIFT(1054),
  [5424] = {.count = 1, .reusable = true}, SHIFT(922),
  [5426] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2979),
  [5432] = {.count = 1, .reusable = true}, SHIFT(2856),
  [5434] = {.count = 1, .reusable = true}, SHIFT(916),
  [5436] = {.count = 1, .reusable = true}, SHIFT(584),
  [5438] = {.count = 1, .reusable = true}, SHIFT(910),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5442] = {.count = 1, .reusable = true}, SHIFT(1719),
  [5444] = {.count = 1, .reusable = true}, SHIFT(1872),
  [5446] = {.count = 1, .reusable = true}, SHIFT(18),
  [5448] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 114),
  [5450] = {.count = 1, .reusable = true}, SHIFT(755),
  [5452] = {.count = 1, .reusable = true}, SHIFT(1632),
  [5454] = {.count = 1, .reusable = true}, SHIFT(692),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5458] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 116),
  [5460] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [5462] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5464] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5466] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5468] = {.count = 1, .reusable = true}, SHIFT(1047),
  [5470] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5472] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [5474] = {.count = 1, .reusable = true}, SHIFT(695),
  [5476] = {.count = 1, .reusable = true}, SHIFT(1064),
  [5478] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5480] = {.count = 1, .reusable = true}, SHIFT(686),
  [5482] = {.count = 1, .reusable = true}, SHIFT(1397),
  [5484] = {.count = 1, .reusable = true}, SHIFT(682),
  [5486] = {.count = 1, .reusable = true}, SHIFT(423),
  [5488] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 82),
  [5490] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5492] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 83),
  [5494] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [5496] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 116),
  [5498] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5500] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5502] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 140),
  [5504] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 141),
  [5506] = {.count = 1, .reusable = true}, SHIFT(1478),
  [5508] = {.count = 1, .reusable = true}, SHIFT(1871),
  [5510] = {.count = 1, .reusable = true}, SHIFT(443),
  [5512] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5514] = {.count = 1, .reusable = true}, SHIFT(715),
  [5516] = {.count = 1, .reusable = true}, SHIFT(1890),
  [5518] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 114),
  [5520] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 163),
  [5522] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 140),
  [5524] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5526] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 141),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2789),
  [5530] = {.count = 1, .reusable = true}, SHIFT(1714),
  [5532] = {.count = 1, .reusable = true}, SHIFT(1880),
  [5534] = {.count = 1, .reusable = true}, SHIFT(1771),
  [5536] = {.count = 1, .reusable = true}, SHIFT(545),
  [5538] = {.count = 1, .reusable = true}, SHIFT(704),
  [5540] = {.count = 1, .reusable = true}, SHIFT(1572),
  [5542] = {.count = 1, .reusable = true}, SHIFT(2797),
  [5544] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [5546] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2871),
  [5550] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 163),
  [5552] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 162),
  [5554] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 162),
  [5556] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5558] = {.count = 1, .reusable = true}, SHIFT(1770),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5562] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 172),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5566] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(755),
  [5569] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 172),
  [5571] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5575] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5577] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5581] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5583] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5585] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5587] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2085),
  [5591] = {.count = 1, .reusable = true}, SHIFT(574),
  [5593] = {.count = 1, .reusable = false}, SHIFT(1815),
  [5595] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5597] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5599] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5603] = {.count = 1, .reusable = true}, SHIFT(775),
  [5605] = {.count = 1, .reusable = false}, SHIFT(937),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5609] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5613] = {.count = 1, .reusable = false}, SHIFT(2337),
  [5615] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2842),
  [5619] = {.count = 1, .reusable = true}, SHIFT(524),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5623] = {.count = 1, .reusable = true}, SHIFT(587),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2863),
  [5627] = {.count = 1, .reusable = true}, SHIFT(1873),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5631] = {.count = 1, .reusable = true}, SHIFT(575),
  [5633] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5635] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5637] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5639] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [5641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(159),
  [5644] = {.count = 1, .reusable = true}, SHIFT(1866),
  [5646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(154),
  [5649] = {.count = 1, .reusable = true}, SHIFT(541),
  [5651] = {.count = 1, .reusable = true}, SHIFT(588),
  [5653] = {.count = 1, .reusable = false}, SHIFT(944),
  [5655] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5657] = {.count = 1, .reusable = false}, SHIFT(2344),
  [5659] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [5661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2338),
  [5664] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2338),
  [5667] = {.count = 1, .reusable = true}, SHIFT(578),
  [5669] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [5671] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [5673] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2344),
  [5676] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2344),
  [5679] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5681] = {.count = 1, .reusable = false}, SHIFT(1814),
  [5683] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5685] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5689] = {.count = 1, .reusable = false}, SHIFT(2392),
  [5691] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [5693] = {.count = 1, .reusable = true}, SHIFT(596),
  [5695] = {.count = 1, .reusable = true}, SHIFT(1884),
  [5697] = {.count = 1, .reusable = true}, SHIFT(215),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5701] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2085),
  [5704] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5708] = {.count = 1, .reusable = false}, SHIFT(1567),
  [5710] = {.count = 1, .reusable = false}, SHIFT(1590),
  [5712] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5714] = {.count = 1, .reusable = false}, SHIFT(2361),
  [5716] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5718] = {.count = 1, .reusable = false}, SHIFT(2362),
  [5720] = {.count = 1, .reusable = false}, SHIFT(127),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5724] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5728] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5732] = {.count = 1, .reusable = false}, SHIFT(416),
  [5734] = {.count = 1, .reusable = false}, SHIFT(415),
  [5736] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5742] = {.count = 1, .reusable = false}, SHIFT(2370),
  [5744] = {.count = 1, .reusable = true}, SHIFT(565),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2095),
  [5748] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5750] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5754] = {.count = 1, .reusable = false}, SHIFT(1063),
  [5756] = {.count = 1, .reusable = false}, SHIFT(1095),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5760] = {.count = 1, .reusable = false}, SHIFT(2379),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5764] = {.count = 1, .reusable = false}, SHIFT(2380),
  [5766] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [5768] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(139),
  [5771] = {.count = 1, .reusable = false}, SHIFT(106),
  [5773] = {.count = 1, .reusable = true}, SHIFT(2121),
  [5775] = {.count = 1, .reusable = true}, SHIFT(2119),
  [5777] = {.count = 1, .reusable = true}, SHIFT(1711),
  [5779] = {.count = 1, .reusable = true}, SHIFT(1775),
  [5781] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 173),
  [5783] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 174),
  [5785] = {.count = 1, .reusable = true}, SHIFT(130),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5789] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 175),
  [5791] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 170),
  [5793] = {.count = 1, .reusable = true}, SHIFT(2773),
  [5795] = {.count = 1, .reusable = true}, SHIFT(528),
  [5797] = {.count = 1, .reusable = true}, SHIFT(2772),
  [5799] = {.count = 1, .reusable = true}, SHIFT(526),
  [5801] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 180),
  [5803] = {.count = 1, .reusable = true}, SHIFT(946),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5807] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5809] = {.count = 1, .reusable = true}, SHIFT(934),
  [5811] = {.count = 1, .reusable = true}, SHIFT(1939),
  [5813] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 160),
  [5815] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 166),
  [5817] = {.count = 1, .reusable = true}, SHIFT(942),
  [5819] = {.count = 1, .reusable = true}, SHIFT(691),
  [5821] = {.count = 1, .reusable = true}, SHIFT(1870),
  [5823] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 165),
  [5825] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 164),
  [5827] = {.count = 1, .reusable = true}, SHIFT(435),
  [5829] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1780),
  [5832] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 146),
  [5834] = {.count = 1, .reusable = true}, SHIFT(689),
  [5836] = {.count = 1, .reusable = true}, SHIFT(1477),
  [5838] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 139),
  [5840] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 121),
  [5842] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 145),
  [5844] = {.count = 1, .reusable = true}, SHIFT(753),
  [5846] = {.count = 1, .reusable = true}, SHIFT(1773),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2110),
  [5850] = {.count = 1, .reusable = true}, SHIFT(1693),
  [5852] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 144),
  [5854] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 143),
  [5856] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 161),
  [5858] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [5860] = {.count = 1, .reusable = true}, SHIFT(1097),
  [5862] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(768),
  [5865] = {.count = 1, .reusable = true}, SHIFT(936),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2125),
  [5869] = {.count = 1, .reusable = true}, SHIFT(1904),
  [5871] = {.count = 1, .reusable = true}, SHIFT(800),
  [5873] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [5875] = {.count = 1, .reusable = true}, SHIFT(1901),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5881] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [5883] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 71),
  [5885] = {.count = 1, .reusable = true}, SHIFT(2127),
  [5887] = {.count = 1, .reusable = true}, SHIFT(1721),
  [5889] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [5891] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(784),
  [5894] = {.count = 1, .reusable = true}, SHIFT(1474),
  [5896] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(815),
  [5899] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(817),
  [5902] = {.count = 1, .reusable = true}, SHIFT(1699),
  [5904] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5906] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 77),
  [5908] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 118),
  [5910] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 97),
  [5912] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [5914] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 117),
  [5916] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(829),
  [5919] = {.count = 1, .reusable = true}, SHIFT(994),
  [5921] = {.count = 1, .reusable = true}, SHIFT(420),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5927] = {.count = 1, .reusable = true}, SHIFT(1130),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5931] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [5933] = {.count = 1, .reusable = true}, SHIFT(1702),
  [5935] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2321),
  [5938] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5940] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2324),
  [5943] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5945] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 71),
  [5947] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(773),
  [5950] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(757),
  [5953] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5957] = {.count = 1, .reusable = true}, SHIFT(1393),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5961] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2770),
  [5964] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5966] = {.count = 1, .reusable = true}, SHIFT(1855),
  [5968] = {.count = 1, .reusable = true}, SHIFT(1497),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5972] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5978] = {.count = 1, .reusable = true}, SHIFT(432),
  [5980] = {.count = 1, .reusable = true}, SHIFT(1071),
  [5982] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2913),
  [5986] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5988] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(813),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2106),
  [5993] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5995] = {.count = 1, .reusable = true}, SHIFT(1499),
  [5997] = {.count = 1, .reusable = true}, SHIFT(430),
  [5999] = {.count = 1, .reusable = true}, SHIFT(1695),
  [6001] = {.count = 1, .reusable = true}, SHIFT(1942),
  [6003] = {.count = 1, .reusable = true}, SHIFT(1136),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2279),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2274),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2188),
  [6011] = {.count = 1, .reusable = true}, SHIFT(2271),
  [6013] = {.count = 1, .reusable = true}, SHIFT(1687),
  [6015] = {.count = 1, .reusable = true}, SHIFT(1049),
  [6017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1706),
  [6020] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [6022] = {.count = 1, .reusable = true}, SHIFT(2206),
  [6024] = {.count = 1, .reusable = true}, SHIFT(707),
  [6026] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [6028] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 78),
  [6030] = {.count = 1, .reusable = true}, SHIFT(1128),
  [6032] = {.count = 1, .reusable = true}, SHIFT(1026),
  [6034] = {.count = 1, .reusable = true}, SHIFT(131),
  [6036] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6038] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [6040] = {.count = 1, .reusable = true}, SHIFT(1017),
  [6042] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 77),
  [6044] = {.count = 1, .reusable = true}, SHIFT(1513),
  [6046] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [6048] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6050] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 70),
  [6052] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1346),
  [6055] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [6057] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [6059] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 167),
  [6061] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 71),
  [6063] = {.count = 1, .reusable = true}, SHIFT(592),
  [6065] = {.count = 1, .reusable = true}, SHIFT(703),
  [6067] = {.count = 1, .reusable = true}, SHIFT(1431),
  [6069] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [6071] = {.count = 1, .reusable = true}, SHIFT(708),
  [6073] = {.count = 1, .reusable = false}, SHIFT(2552),
  [6075] = {.count = 1, .reusable = false}, SHIFT(2911),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2186),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2240),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6083] = {.count = 1, .reusable = true}, SHIFT(1622),
  [6085] = {.count = 1, .reusable = true}, SHIFT(1627),
  [6087] = {.count = 1, .reusable = true}, SHIFT(1551),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2500),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2287),
  [6093] = {.count = 1, .reusable = true}, SHIFT(690),
  [6095] = {.count = 1, .reusable = true}, SHIFT(1701),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2231),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6101] = {.count = 1, .reusable = true}, SHIFT(1634),
  [6103] = {.count = 1, .reusable = true}, SHIFT(1401),
  [6105] = {.count = 1, .reusable = true}, SHIFT(1406),
  [6107] = {.count = 1, .reusable = true}, SHIFT(1412),
  [6109] = {.count = 1, .reusable = true}, SHIFT(230),
  [6111] = {.count = 1, .reusable = true}, SHIFT(20),
  [6113] = {.count = 1, .reusable = true}, SHIFT(544),
  [6115] = {.count = 1, .reusable = true}, SHIFT(1556),
  [6117] = {.count = 1, .reusable = true}, SHIFT(582),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2165),
  [6121] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6123] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6125] = {.count = 1, .reusable = true}, SHIFT(593),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2552),
  [6129] = {.count = 1, .reusable = true}, SHIFT(2234),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2984),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2288),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6137] = {.count = 1, .reusable = true}, SHIFT(579),
  [6139] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 67),
  [6141] = {.count = 1, .reusable = true}, SHIFT(1772),
  [6143] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6145] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2264),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6151] = {.count = 1, .reusable = true}, SHIFT(158),
  [6153] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 85),
  [6155] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 85),
  [6157] = {.count = 1, .reusable = true}, SHIFT(554),
  [6159] = {.count = 1, .reusable = true}, SHIFT(1774),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2099),
  [6163] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6165] = {.count = 1, .reusable = true}, SHIFT(540),
  [6167] = {.count = 1, .reusable = true}, SHIFT(1859),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2081),
  [6171] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 130),
  [6173] = {.count = 1, .reusable = true}, SHIFT(1089),
  [6175] = {.count = 1, .reusable = true}, SHIFT(35),
  [6177] = {.count = 1, .reusable = true}, SHIFT(1383),
  [6179] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 40),
  [6181] = {.count = 1, .reusable = true}, SHIFT(2518),
  [6183] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 40),
  [6185] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 104),
  [6187] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 71),
  [6189] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 75),
  [6191] = {.count = 1, .reusable = true}, SHIFT(223),
  [6193] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 109),
  [6195] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 111),
  [6197] = {.count = 1, .reusable = true}, SHIFT(425),
  [6199] = {.count = 1, .reusable = true}, SHIFT(527),
  [6201] = {.count = 1, .reusable = true}, SHIFT(529),
  [6203] = {.count = 1, .reusable = true}, SHIFT(1057),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2690),
  [6207] = {.count = 1, .reusable = true}, SHIFT(783),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2702),
  [6211] = {.count = 1, .reusable = false}, SHIFT(1177),
  [6213] = {.count = 1, .reusable = false}, SHIFT(1366),
  [6215] = {.count = 1, .reusable = false}, SHIFT(1379),
  [6217] = {.count = 1, .reusable = true}, SHIFT(726),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2652),
  [6223] = {.count = 1, .reusable = true}, SHIFT(813),
  [6225] = {.count = 1, .reusable = true}, SHIFT(847),
  [6227] = {.count = 1, .reusable = true}, SHIFT(2635),
  [6229] = {.count = 1, .reusable = true}, SHIFT(437),
  [6231] = {.count = 1, .reusable = true}, SHIFT(225),
  [6233] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 75),
  [6235] = {.count = 1, .reusable = true}, SHIFT(1405),
  [6237] = {.count = 1, .reusable = true}, SHIFT(1911),
  [6239] = {.count = 1, .reusable = true}, SHIFT(224),
  [6241] = {.count = 1, .reusable = true}, SHIFT(222),
  [6243] = {.count = 1, .reusable = true}, SHIFT(660),
  [6245] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6249] = {.count = 1, .reusable = true}, SHIFT(196),
  [6251] = {.count = 1, .reusable = true}, SHIFT(216),
  [6253] = {.count = 1, .reusable = true}, SHIFT(205),
  [6255] = {.count = 1, .reusable = true}, SHIFT(204),
  [6257] = {.count = 1, .reusable = true}, SHIFT(203),
  [6259] = {.count = 1, .reusable = true}, SHIFT(202),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6263] = {.count = 1, .reusable = true}, SHIFT(1106),
  [6265] = {.count = 1, .reusable = false}, SHIFT(2787),
  [6267] = {.count = 1, .reusable = true}, SHIFT(763),
  [6269] = {.count = 1, .reusable = true}, SHIFT(888),
  [6271] = {.count = 1, .reusable = true}, SHIFT(768),
  [6273] = {.count = 1, .reusable = true}, SHIFT(424),
  [6275] = {.count = 1, .reusable = true}, SHIFT(719),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6279] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6281] = {.count = 1, .reusable = true}, SHIFT(1390),
  [6283] = {.count = 1, .reusable = true}, SHIFT(1899),
  [6285] = {.count = 1, .reusable = true}, SHIFT(878),
  [6287] = {.count = 1, .reusable = true}, SHIFT(193),
  [6289] = {.count = 1, .reusable = true}, SHIFT(846),
  [6291] = {.count = 1, .reusable = true}, SHIFT(1919),
  [6293] = {.count = 1, .reusable = true}, SHIFT(720),
  [6295] = {.count = 1, .reusable = true}, SHIFT(1910),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2377),
  [6301] = {.count = 1, .reusable = true}, SHIFT(821),
  [6303] = {.count = 1, .reusable = true}, SHIFT(1080),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2646),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2649),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2541),
  [6311] = {.count = 1, .reusable = true}, SHIFT(782),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2546),
  [6315] = {.count = 1, .reusable = false}, SHIFT(1448),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2623),
  [6319] = {.count = 1, .reusable = true}, SHIFT(419),
  [6321] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6323] = {.count = 1, .reusable = true}, SHIFT(678),
  [6325] = {.count = 1, .reusable = true}, SHIFT(1705),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2199),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6331] = {.count = 1, .reusable = true}, SHIFT(784),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6335] = {.count = 1, .reusable = true}, SHIFT(1918),
  [6337] = {.count = 1, .reusable = true}, SHIFT(119),
  [6339] = {.count = 1, .reusable = true}, SHIFT(829),
  [6341] = {.count = 1, .reusable = true}, SHIFT(194),
  [6343] = {.count = 1, .reusable = true}, SHIFT(885),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2700),
  [6349] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 75),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6353] = {.count = 1, .reusable = true}, SHIFT(167),
  [6355] = {.count = 1, .reusable = true}, SHIFT(876),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2680),
  [6359] = {.count = 1, .reusable = true}, SHIFT(759),
  [6361] = {.count = 1, .reusable = true}, SHIFT(736),
  [6363] = {.count = 1, .reusable = true}, SHIFT(181),
  [6365] = {.count = 1, .reusable = true}, SHIFT(183),
  [6367] = {.count = 1, .reusable = true}, SHIFT(184),
  [6369] = {.count = 1, .reusable = true}, SHIFT(187),
  [6371] = {.count = 1, .reusable = true}, SHIFT(1707),
  [6373] = {.count = 1, .reusable = false}, SHIFT(2852),
  [6375] = {.count = 1, .reusable = true}, SHIFT(1922),
  [6377] = {.count = 1, .reusable = true}, SHIFT(760),
  [6379] = {.count = 1, .reusable = true}, SHIFT(1038),
  [6381] = {.count = 1, .reusable = true}, SHIFT(749),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2444),
  [6387] = {.count = 1, .reusable = true}, SHIFT(328),
  [6389] = {.count = 1, .reusable = true}, SHIFT(327),
  [6391] = {.count = 1, .reusable = true}, SHIFT(1916),
  [6393] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6395] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6397] = {.count = 1, .reusable = true}, SHIFT(1962),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6401] = {.count = 1, .reusable = true}, SHIFT(10),
  [6403] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6405] = {.count = 1, .reusable = true}, SHIFT(743),
  [6407] = {.count = 1, .reusable = true}, SHIFT(892),
  [6409] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6411] = {.count = 1, .reusable = true}, SHIFT(877),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2479),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2613),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2734),
  [6419] = {.count = 1, .reusable = true}, SHIFT(872),
  [6421] = {.count = 1, .reusable = true}, SHIFT(232),
  [6423] = {.count = 1, .reusable = true}, SHIFT(2610),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6427] = {.count = 1, .reusable = true}, SHIFT(671),
  [6429] = {.count = 1, .reusable = true}, SHIFT(614),
  [6431] = {.count = 1, .reusable = true}, SHIFT(793),
  [6433] = {.count = 1, .reusable = true}, SHIFT(229),
  [6435] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6439] = {.count = 1, .reusable = true}, SHIFT(866),
  [6441] = {.count = 1, .reusable = true}, SHIFT(875),
  [6443] = {.count = 1, .reusable = true}, SHIFT(810),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6447] = {.count = 1, .reusable = true}, SHIFT(231),
  [6449] = {.count = 1, .reusable = true}, SHIFT(863),
  [6451] = {.count = 1, .reusable = true}, SHIFT(234),
  [6453] = {.count = 1, .reusable = true}, SHIFT(235),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2002),
  [6457] = {.count = 1, .reusable = true}, SHIFT(817),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6461] = {.count = 1, .reusable = true}, SHIFT(827),
  [6463] = {.count = 1, .reusable = true}, SHIFT(737),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6467] = {.count = 1, .reusable = true}, SHIFT(747),
  [6469] = {.count = 1, .reusable = true}, SHIFT(874),
  [6471] = {.count = 1, .reusable = true}, SHIFT(871),
  [6473] = {.count = 1, .reusable = true}, SHIFT(1843),
  [6475] = {.count = 1, .reusable = true}, SHIFT(828),
  [6477] = {.count = 1, .reusable = true}, SHIFT(824),
  [6479] = {.count = 1, .reusable = true}, SHIFT(773),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6483] = {.count = 1, .reusable = true}, SHIFT(1554),
  [6485] = {.count = 1, .reusable = true}, SHIFT(823),
  [6487] = {.count = 1, .reusable = true}, SHIFT(1558),
  [6489] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 75),
  [6491] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6493] = {.count = 1, .reusable = true}, SHIFT(815),
  [6495] = {.count = 1, .reusable = true}, SHIFT(1480),
  [6497] = {.count = 1, .reusable = true}, SHIFT(651),
  [6499] = {.count = 1, .reusable = true}, SHIFT(738),
  [6501] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6503] = {.count = 1, .reusable = true}, SHIFT(1133),
  [6505] = {.count = 1, .reusable = true}, SHIFT(801),
  [6507] = {.count = 1, .reusable = true}, SHIFT(881),
  [6509] = {.count = 1, .reusable = false}, SHIFT(2786),
  [6511] = {.count = 1, .reusable = true}, SHIFT(861),
  [6513] = {.count = 1, .reusable = true}, SHIFT(774),
  [6515] = {.count = 1, .reusable = true}, SHIFT(757),
  [6517] = {.count = 1, .reusable = true}, SHIFT(1545),
  [6519] = {.count = 1, .reusable = true}, SHIFT(879),
  [6521] = {.count = 1, .reusable = true}, SHIFT(724),
  [6523] = {.count = 1, .reusable = true}, SHIFT(233),
  [6525] = {.count = 1, .reusable = true}, SHIFT(771),
  [6527] = {.count = 1, .reusable = true}, SHIFT(1523),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2183),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6533] = {.count = 1, .reusable = true}, SHIFT(2124),
  [6535] = {.count = 1, .reusable = true}, SHIFT(2426),
  [6537] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6539] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6543] = {.count = 1, .reusable = true}, SHIFT(769),
  [6545] = {.count = 1, .reusable = true}, SHIFT(661),
  [6547] = {.count = 1, .reusable = true}, SHIFT(1860),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2220),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2246),
};

void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
